﻿// Generated by Construct 2, the HTML5 game and app creator :: http://www.scirra.com
//////////////////////////////////////
// COCOONJS.JS                      //
//////////////////////////////////////

(function()
{
	// There should not be a CocoonJS object when this code is executed.
	// if (typeof window.CocoonJS !== 'undefined') throw("This is strange, a CocoonJS object already exists when trying to create it.");

    /**
    * The basic object for all the CocoonJS related specific APIs === extensions.
    * @namespace
    */
    CocoonJS = window.CocoonJS ? window.CocoonJS : {};

	CocoonJS.nativeExtensionObjectAvailable = typeof window.ext !== 'undefined';

	/**
	* This type represents a 2D size structure with horizontal and vertical values.
	* @namespace
	*/
	CocoonJS.Size = {
		/**
		* The horizontal size value.
		*/
		width : 0,

		/**
		* The vertical size value.
		*/
		height : 0
	};

	/**
	* This utility function allows to create an object oriented like hierarchy between two functions using their prototypes.
	* This function adds a "superclass" and a "__super" attributes to the subclass and it's functions to reference the super class.
	* @param {function} subc The subclass function.
	* @param {function} superc The superclass function.
	*/
	CocoonJS.extend = function(subc, superc) {
	    var subcp = subc.prototype;

	    // Class pattern.
	    var CocoonJSExtendHierarchyChainClass = function() {};
	    CocoonJSExtendHierarchyChainClass.prototype = superc.prototype;

	    subc.prototype = new CocoonJSExtendHierarchyChainClass();       // chain prototypes.
	    subc.superclass = superc.prototype;
	    subc.prototype.constructor = subc;

	    // Reset constructor. See Object Oriented Javascript for an in-depth explanation of this.
	    if (superc.prototype.constructor === Object.prototype.constructor) {
	        superc.prototype.constructor = superc;
	    }

	    // Check all the elements in the subclass prototype and add them to the chain object's prototype.
	    for (var method in subcp) {
	        if (subcp.hasOwnProperty(method)) {
	            subc.prototype[method] = subcp[method];

	            // // tenemos en super un metodo con igual nombre.
	            // if ( superc.prototype[method]) 
	            // {
	            //     subc.prototype[method]= (function(fn, fnsuper) 
	            //     {
	            //         return function() 
	            //         {
	            //             var prevMethod= this.__super;

	            //             this.__super= fnsuper;

	            //             var retValue= fn.apply(
	            //                     this,
	            //                     Array.prototype.slice.call(arguments) );

	            //             this.__super= prevMethod;

	            //             return retValue;
	            //         };
	            //     })(subc.prototype[method], superc.prototype[method]);
	            // }
	        }
	    }
	}

	/**
	* IMPORTANT: This function should only be used by Ludei.
	* This function allows a call to the native extension object function reusing the same arguments object.
	* Why is interesting to use this function instead of calling the native object's function directly?
	* As the CocoonJS object functions expicitly receive parameters, if they are not present and the native call is direcly mapped,
	* undefined arguments are passed to the native side. Some native functions do not check the parameters validation
	* correctly (just check the number of parameters passed).
	* Another solution instead of using this function call is to correctly check if the parameters are valid (not undefined) to make the
	* call, but it takes more work than using this approach.
	* @static
	* @param {string} nativeExtensionObjectName The name of the native extension object name. The object that is a member of the 'ext' object.
	* @param {string} nativeFunctionName The name of the function to be called inside the native extension object.
	* @param {object} arguments The arguments object of the CocoonJS extension object function. It contains all the arguments passed to the CocoonJS extension object function and these are the ones that will be passed to the native call too.
	* @param {boolean} [async] A flag to indicate if the makeCall (false or undefined) or the makeCallAsync function should be used to perform the native call.
	* @returns Whatever the native function call returns.
	*/
	CocoonJS.makeNativeExtensionObjectFunctionCall = function(nativeExtensionObjectName, nativeFunctionName, args, async) {
		if (CocoonJS.nativeExtensionObjectAvailable) {
			var argumentsArray = Array.prototype.slice.call(args);
			argumentsArray.unshift(nativeFunctionName);
			var nativeExtensionObject = ext[nativeExtensionObjectName];
			var makeCallFunction = async ? nativeExtensionObject.makeCallAsync : nativeExtensionObject.makeCall;
			var ret = makeCallFunction.apply(nativeExtensionObject, argumentsArray);
			var finalRet = ret;
			if (typeof ret === "string") {
				try	{
					finalRet = JSON.parse(ret);
				}
				catch(error) {
				}
			}
			return finalRet;
		}
	};

	/**
	* Returns an object retrieved from a path specified by a dot specified text path starting from a given base object.
	* It could be useful to find the reference of an object from a defined base object. For example the base object could be window and the
	* path could be "CocoonJS.App" or "document.body".
	* @param {Object} baseObject The object to start from to find the object using the given text path.
	* @param {string} objectPath The path in the form of a text using the dot notation. i.e. "document.body"
	* For example:
	* var body = getObjectFromPath(window, "document.body");
	*/
	CocoonJS.getObjectFromPath = function(baseObject, objectPath) {
    	var parts = objectPath.split('.');
    	var obj = baseObject;
        for (var i = 0, len = parts.length; i < len; ++i) 
        {
            obj[parts[i]] = obj[parts[i]] || undefined;
    		obj = obj[parts[i]];
    	}
    	return obj;
 	};

 	/**
 	* Returns the key for a value in a dictionary. It looks for an specific value inside a dictionary and returns the corresponding key.
 	* @param {Object} dictionary The dictionary to look for the value in and get the corresponding key.
 	* @param {Object} value The value to look for inside the dictionary and return it's corresponding key.
 	* @return The key that corresponds to the given value it is has been found or null.
 	*/
 	CocoonJS.getKeyForValueInDictionary = function(dictionary, value) {
        var finalKey = null;
        for (var key in dictionary) {
            if (dictionary[key] === value)            {
                finalKey = key;
                break;
            }
        }
        return finalKey;
 	}

 	/**
 	* Finds a string inside a given array of strings by looking for a given substring. It can also
 	* specify if the search must be performed taking care or not of the case sensitivity.
 	* @param {Array} stringArray The array of strings in which to to look for the string.
 	* @param {string} subString The substring to look for inside all the strings of the array.
 	* @param {boolean} caseSensitive A flag to indicate if the search must be performed taking case of the 
 	* case sensitiveness (true) or not (false).
 	* @return {string} The string that has been found or null if the substring is not inside any of the string of the array.
 	*/
 	CocoonJS.findStringInStringArrayThatIsIndexOf = function(stringArray, subString, caseSensitive) {
 		var foundString = null;
 		subString = caseSensitive ? subString : subString.toUpperCase();
 		for (var i = 0; foundString == null && i < stringArray.length; i++)	{
 			foundString = caseSensitive ? stringArray[i] : stringArray[i].toUpperCase();
 			foundString = foundString.indexOf(subString) >= 0 ? stringArray[i] : null; 
 		}
 		return foundString;
 	};

	/**
	* A class that represents objects to handle events. Event handlers have always the same structure:
	* Mainly they provide the addEventListener and removeEventListener functions.
	* Both functions receive a callback function that will be added or removed. All the added callback
	* functions will be called when the event takes place.
	* Additionally they also allow the addEventListenerOnce and notifyEventListeners functions.
	* @constructor
	* @param {string} nativeExtensionObjectName The name of the native extension object (inside the ext object) to be used.
	* @param {string} cocoonJSExtensionObjectName The name of the sugarized extension object.
	* @param {string} nativeEventName The name of the native event inside the ext object.
	* @param {number} [chainFunction] An optional function used to preprocess the listener callbacks. This function, if provided,
	* will be called before any of the other listeners.
	*/
	CocoonJS.EventHandler = function(nativeExtensionObjectName, cocoonJSExtensionObjectName, nativeEventName, chainFunction) {
		this.listeners = [];
		this.listenersOnce = [];
		this.chainFunction = chainFunction;

		/**
		* Adds a callback function so it can be called when the event takes place.
		* @param {function} listener The callback function to be added to the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
		*/
		this.addEventListener = function(listener) {
			if (chainFunction) {
				var f = function() {
					chainFunction.call(this, arguments.callee.sourceListener, Array.prototype.slice.call(arguments)); 
				};
				listener.CocoonJSEventHandlerChainFunction = f;
				f.sourceListener = listener;
				listener = f;
			}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListener(nativeEventName, listener);
            }
            else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener < 0) {
                	this.listeners.push(listener);
                }
            }
		};

        this.addEventListenerOnce = function(listener)
		{
			if (chainFunction) {
				var f = function() { chainFunction(arguments.callee.sourceListener,Array.prototype.slice.call(arguments)); };
				f.sourceListener = listener;
				listener = f;
			}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListenerOnce(nativeEventName, listener);
            }
            else
            {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener < 0)
                {
                	this.listenersOnce.push(listener);
                }
            }
		};

        /**
         * Removes a callback function that was added to the event handler so it won't be called when the event takes place.
         * @param {function} listener The callback function to be removed from the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
         */
        this.removeEventListener = function (listener) {

        	if (chainFunction) {
        		listener = listener.CocoonJSEventHandlerChainFunction;
        		delete listener.CocoonJSEventHandlerChainFunction;
        	}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].removeEventListener(nativeEventName, listener);
            }
            else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener >= 0) {
                    this.listeners.splice(indexOfListener, 1);
                }
            }
        };

		this.notifyEventListeners = function() {
			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].notifyEventListeners(nativeEventName);
            } else {

                var argumentsArray= Array.prototype.slice.call(arguments);
                var listeners =     Array.prototype.slice.call(this.listeners);
                var listenersOnce = Array.prototype.slice.call(this.listenersOnce);
                var _this = this;
                // Notify listeners after a while ;) === do not block this thread.
                setTimeout(function() {
                    for (var i = 0; i < listeners.length; i++) {
                        listeners[i].apply(_this, argumentsArray);
                    }
                    for (var i = 0; i < listenersOnce.length; i++) {
                        listenersOnce[i].apply(_this, argumentsArray);
                    }
                }, 0);

                _this.listenersOnce= [];
            }
		};
		return this;
	};

	/**
	* A simple timer class. Update it every loop iteration and get values from accumulated time to elapsed time in seconds or milliseconds.
	*/
	CocoonJS.Timer = function() {
		this.reset();
		return this;
	};

	CocoonJS.Timer.prototype = {
		currentTimeInMillis : 0,
		lastTimeInMillis : 0,
		elapsedTimeInMillis : 0,
		elapsedTimeInSeconds : 0,
		accumTimeInMillis : 0,

		/**
		Resets the timer to 0.
		*/
		reset : function() {
			this.currentTimeInMillis = this.lastTimeInMillis = new Date().getTime();
			this.accumTimeInMillis = this.elapsedTimeInMillis = this.elapsedTimeInSeconds = 0;
		},

		/**
		Updates the timer calculating the elapsed time between update calls.
		*/
		update : function() {
			this.currentTimeInMillis = new Date().getTime();
			this.elapsedTimeInMillis = this.currentTimeInMillis - this.lastTimeInMillis;
			this.elapsedTimeInSeconds = this.elapsedTimeInMillis / 1000.0;
			this.lastTimeInMillis = this.currentTimeInMillis;
			this.accumTimeInMillis += this.elapsedTimeInMillis;
		}
	};

	// CocoonJS.FindAllNativeBindingsInCocoonJSExtensionObject = function(cocoonJSExtensionObject, nativeFunctionBindingCallback, nativeEventBindingCallback)
	// {
	// 	for (var cocoonJSExtensionObjectAttributeName in cocoonJSExtensionObject)
	// 	{
	// 		var cocoonJSExtensionObjectAttribute = cocoonJSExtensionObject[cocoonJSExtensionObjectAttributeName];

	// 		// Function
	// 		if (typeof cocoonJSExtensionObjectAttribute === 'function' && typeof cocoonJSExtensionObjectAttribute.nativeFunctionName !== 'undefined')
	// 		{
	// 			var nativeFunctionName = cocoonJSExtensionObjectAttribute.nativeFunctionName;
	// 			nativeFunctionBindingCallback(cocoonJSExtensionObjectAttributeName, nativeFunctionName);
	// 		}
	// 		// Event object
	// 		else if (typeof cocoonJSExtensionObjectAttribute === 'object' && cocoonJSExtensionObjectAttribute !== null && typeof cocoonJSExtensionObjectAttribute.nativeEventName !== 'undefined')
	// 		{
	// 			var nativeEventName = cocoonJSExtensionObjectAttribute.nativeEventName;
	// 			nativeEventBindingCallback(cocoonJSExtensionObjectAttributeName, nativeEventName);
	// 		}
	// 	}
	// }

	/**
	This function looks for a CocoonJS extension object that is bound to the given native ext object name.
	@returns The CocoonJS extension object that corresponds to the give native extension object name or null if it cannot be found.
	*/
	// CocoonJS.GetCocoonJSExtensionObjectForNativeExtensionObjectName = function(nativeExtensionObjectName)
	// {
	// 	var cocoonJSExtensionObject = null;
	// 	// Look in the CocoonJS object and for every object that is a CocoonJS.Extension check if it's nativeExtensionObjectName matches to the one passed as argument. If so, create an object that will represent it's documentation for the native ext object.
	// 	for (var cocoonJSAttributeName in CocoonJS)
	// 	{
	// 		var cocoonJSAttribute = CocoonJS[cocoonJSAttributeName];
	// 		if (typeof cocoonJSAttribute === 'object' && cocoonJSAttribute instanceof CocoonJS.Extension && cocoonJSAttribute.nativeExtensionObjectName === nativeExtensionObjectName)
	// 		{
	// 			// We have found the CocoonJS object that represents the native ext extension object name. 
	// 			cocoonJSExtensionObject = cocoonJSAttribute;
	// 			break;
	// 		}
	// 	}
	// 	return cocoonJSExtensionObject;
	// };

	/**
	This function adds functions to a CocoonJS extension object in order to bind them to the native makeCall function calls of the ext object.

	@param extensionObject The reference to the CocoonJS extension object where to add the new functions bound to the ext object makeCall functions calls.

	@param nativeFunctionsConfiguration An array of objects with the following structure:

		{ nativeFunctionName : "" [, functionName : "", isAsync : true/false] }

		- nativeFunctionName: Specifies the name of the function inside the ext object makeCall function call that will be bound.
		- functionName: An optional attribute that allows to specify the name of the function to be added to the CocoonJS extension object. If is not present, the name of the function will be the same
		as the nativeFunctionName.
		- isAsync: An optional attribute that allows to specify if the call should be performed using makeCall (false or missing) or makeCallAsync (true).
		- alternativeFunction: An optional attribute that allows to specify an alternative function that will be called internally when this function is called. This attribute
		allows for adding new functionalities like for example adding methods 

	@returns The CocoonJS extension object.
	*/
	// CocoonJS.AddNativeFunctionBindingsToExtensionObject = function(extensionObject, nativeFunctionsConfiguration)
	// {
	// 	if (typeof extensionObject === 'undefined' || extensionObject === null) throw("The passed extension object be a valid object.");
	// 	if (typeof nativeFunctionsConfiguration === 'undefined' || nativeFunctionsConfiguration === null) throw("The passed native functions configuration array must be a valid object.");

	// 	for (var i = 0; i < nativeFunctionsConfiguration.length; i++)
	// 	{
	// 		if (typeof nativeFunctionsConfiguration[i].nativeFunctionName === 'undefined') throw("The 'nativeFunctionName' attribute in the native function configuration object at index '" + i + "' in the native function configuration array cannot be undefined.");
	// 		var nativeFunctionName = nativeFunctionsConfiguration[i].nativeFunctionName;
	// 		var functionName = typeof nativeFunctionsConfiguration[i].functionName !== 'undefined' ? nativeFunctionsConfiguration[i].functionName : nativeFunctionName;
	// 		var makeCallFunction = null;
	// 		makeCallFunction = typeof nativeFunctionsConfiguration[i].isAsync !== 'undefined' && nativeFunctionsConfiguration[i].isAsync ? extensionObject.nativeExtensionObject.makeCallAsync : extensionObject.nativeExtensionObject.makeCall;
	// 		// Add the new function to the CocoonJS extension object
	// 		extensionObject[functionName] = function()
	// 		{
	// 			// Convert the arguments object to an array
	// 			var arguments = Array.prototype.slice.call(arguments);
	// 			// Add the native function name as the first parameter
	// 			arguments.unshift(nativeFunctionName);
	// 			// Make the native ext object call
	// 			var result = makeCallFunction.apply(extensionObject.nativeExtensionObject, arguments);
	// 			return result;
	// 		}
	// 		// Add a property to the newly added function to store the name of the original function.
	// 		extensionObject[functionName].nativeFunctionName = nativeFunctionName;
	// 	}
	// 	return extensionObject;
	// };

	/**
	This function adds objects to a CocoonJS extension object to allow event listener handling (add and remove) bound to the native ext object event listener handling.

	@param extensionObject The reference to the CocoonJS extension object where to add the new objects bound to the ext object event listener handling.

	@param nativeEventsConfiguration An array of objects with the following structure:

		{ nativeEventName : "" [, eventObjectName : ""] }

		- nativeEventName: Specifies the event in the native ext object to be bound.
		- eventObjectName: An optional attribute that allows to specify the name of the object to be added to the CocoonJS extension object. If is not present, the name of the function will be the same
		as the nativeEventName.
		- alternativeAddEventListenerFunction:
		- alternativeRemoveEventListenerFunction:

	@returns The CocoonJS extension object.
	*/
	// CocoonJS.AddNativeEventBindingsToExtensionObject = function(extensionObject, nativeEventsConfiguration)
	// {
	// 	if (typeof extensionObject === 'undefined' || extensionObject === null) throw("The passed extension object be a valid object.");
	// 	if (typeof nativeEventsConfiguration === 'undefined' || nativeEventsConfiguration === null) throw("The passed native events configuration array must be a valid object.");

	// 	for (var i = 0; i < nativeEventsConfiguration.length; i++)
	// 	{
	// 		if (typeof nativeEventsConfiguration[i].nativeEventName === 'undefined') throw("The 'nativeEventName' attribute in the native event configuration object at index '" + i + "' in the native event configuration array cannot be undefined.");
	// 		var nativeEventName = nativeEventsConfiguration[i].nativeEventName;
	// 		var eventObjectName = typeof nativeEventsConfiguration[i].eventObjectName !== 'undefined' ? nativeEventsConfiguration[i].eventObjectName : nativeEventName;
	// 		// Anonymous function call so each variable in the loop is used in the event listener handling function bindings.
	// 		(function(nativeEventName, eventObjectName)
	// 		{
	//     		extensionObject[eventObjectName] =
	//     		{
	//     			// Store the native event name
	//     			nativeEventName : nativeEventName,
	//     			// Create the event listener management functions bound to the native counterparts
	//     			addEventListener : function(callback)
	// 	    		{
	// 	    			extensionObject.nativeExtensionObject.addEventListener(nativeEventName, callback);
	//     			},
	//     			removeEventListener : function(callback)
	//     			{
	// 	    			extensionObject.nativeExtensionObject.removeEventListener(nativeEventName, callback);
	//     			}
	//     			// ,
	//     			// removeAllEventListeners : function()
	//     			// {

	//     			// }
	//     		};
	// 		})(nativeEventName, eventObjectName);
	// 	}
	// 	return extensionObject;
	// };

	/**
	The function object constructor function all the CocoonJS extensions can use to instantiate the CocoonJS extension object and add all the functionality needed bound to the native ext object.

	@param nativeExtensionObject The reference to the ext object extension object.

	@param nativeFunctionsConfiguration See CocoonJS.AddNativeFunctionBindingsToExtensionObject function's documentation for more details.

	@param nativeEventsConfiguration See CocoonJS.AddNativeEventBindingsToExtensionObject function's documentation for more details.

	@returns The new CocoonJS extension object.
	*/
	// CocoonJS.Extension = function(nativeExtensionObjectName, nativeFunctionsConfiguration, nativeEventsConfiguration)
	// {
	// 	if (typeof nativeExtensionObjectName === 'undefined' || nativeExtensionObjectName === null) throw("The native extension object name cannot be null");

	// 	if (window.ext[nativeExtensionObjectName] === 'undefined') throw("The given native extension object name '" + nativeExtensionObjectName + "' is incorrect or the native extension object is undefined.");

	// 	var nativeExtensionObject = window.ext[nativeExtensionObjectName];

	// 	// Store a reference to the native extension object and to it's name
	// 	this.nativeExtensionObject = nativeExtensionObject;
	// 	this.nativeExtensionObjectName = nativeExtensionObjectName;

	// 	// If native function configuration is passed, use it to add some functions to the new extension object.
	// 	if (typeof nativeFunctionsConfiguration !== 'undefined')
	// 	{
	// 		CocoonJS.AddNativeFunctionBindingsToExtensionObject(this, nativeFunctionsConfiguration);
	// 	}

	// 	// If native event configuration is passed, use it to add some event objects to the new extension object.
	// 	if (typeof nativeEventsConfiguration !== 'undefined')
	// 	{
	// 		CocoonJS.AddNativeEventBindingsToExtensionObject(this, nativeEventsConfiguration);
	// 	}

	// 	return this;
	// };   

})();

//////////////////////////////////////
// COCOONJS_APP.JS                  //
//////////////////////////////////////

(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents all the basic functionalities available in the CocoonJS extension API.
     * @namespace
     */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    CocoonJS.App.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_APP !== 'undefined';

    /**
     * The predefined possible layouts for the FPS overlay.
     * @namespace
     */
    CocoonJS.App.FPSLayout = {
        TOP_LEFT:'top-left',
        TOP_RIGHT:'top-right',
        BOTTOM_LEFT:'bottom-left',
        BOTTOM_RIGHT:'bottom-right'
    };

    /**
     * Contains all the possible values to specify the input keyboard type to be used when introducing text.
     * @namespace
     */
    CocoonJS.App.KeyboardType = {
        /**
         * Represents a generic text input keyboard.
         */
        TEXT:"text",

        /**
         * Represents a number like input keyboard.
         */
        NUMBER:"num",

        /**
         * Represents a phone like input keyboard.
         */
        PHONE:"phone",

        /**
         * Represents an email like input keyboard.
         */
        EMAIL:"email",

        /**
         * Represents an URL like input keyboard.
         */
        URL:"url"
    };

    /**
     * The storage types to be used with file system related operations.
     * @namespace
     */
    CocoonJS.App.StorageType = {
        /**
         * Represents the application storage. The application storage is the place where all the resources that come with the application are stored.
         */
        APP_STORAGE:"APP_STORAGE",

        /**
         * Represents the internal storage. The internal storage is a different storage space that the application storage and only the data that the application has stored
         * in it will be in this storage. It is internal to the platform/device.
         */
        INTERNAL_STORAGE:"INTERNAL_STORAGE",

        /**
         * Represents an external storage. The external storage is similar to the internal storage in the sense that it only contains information that the application has written
         * in it but it represents an external storage device like a SD-CARD. If there is no exrernal storage, it will represent the same as the internal storage.
         */
        EXTERNAL_STORAGE:"EXTERNAL_STORAGE",

        /**
         * Represents the temporal storage. Same as the internal and external storage spaces in the sense that it only contains information that the application has written
         * in it but the main difference is that the information in this storage may dissapear without notice.
         */
        TEMPORARY_STORAGE:"TEMPORARY_STORAGE"
    };

    /**
     * The capture types to capture screenshots using CocoonJS native capabilities.
     * @namespace
     */
    CocoonJS.App.CaptureType = {
        /**
         Captures everything, both the CocoonJS GL hardware accelerated surface and the system views (like the WebView).
         */
        EVERYTHING:0,

        /**
         * Captures just the CocoonJS GL hardware accelerated surface.
         */
        JUST_COCOONJS_GL_SURFACE:1,

        /**
         * Captures just the sustem views (like the webview)
         */
        JUST_SYSTEM_VIEWS:2
    };

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It waits until the code is executed and the result of it is returned === synchronous.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @return {string} The result of the execution of the passed JavaScript code in the different JavaScript environment.
     */
    CocoonJS.App.forward = function (javaScriptCode) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forward", arguments);
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                //return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
                return window.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
            }
        }
    };

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It is asyncrhonous so it does not wait until the code is executed and the result of it is returned. Instead, it calls a callback function when the execution has finished to pass the result.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @param {function} [returnCallback] A function callback that will be called when the passed JavaScript code is executed in a different thread to pass the result of the execution in the different JavaScript environment.
     */
    CocoonJS.App.forwardAsync = function (javaScriptCode, returnCallback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            if (typeof returnCallback !== 'undefined') {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode, returnCallback);
            }
            else {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode);
            }
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
                // window.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
            }
        }
    };

    /**
     * Pops up a text dialog so the user can introduce some text and the application can get it back. It is the first approach CocoonJS has taken to be able to introduce
     * text input in a easy way. The dialog execution events are passed to the application through the {@link CocoonJS.App.onTextDialogFinished} and the {@link CocoonJS.App.onTextDialogCancelled} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [text] Default value is "". The initial text to be introduced in the text input field.
     * @param {CocoonJS.App.KeyboardType} [keyboardType] Default value is {@link CocoonJS.App.KeyboardType.TEXT}. The keyboard type to be used when the text has to be introduced.
     * @param {string} [cancelButtonText] Default value is "". The text to be displayed in the cancel button of the dialog.
     * @param {string} [okButtonText] Default value is "". The text to be displayed in the ok button of the dialog.
     * @see CocoonJS.App.onTextDialogFinished
     * @see CocoonJS.App.onTextDialogCancelled
     */
    CocoonJS.App.showTextDialog = function (title, message, text, keyboardType, cancelButtonText, okButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showTextDialog", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            if (!text) {
                text = "";
            }
            var result = prompt(message, text);
            var eventObject = result ? CocoonJS.App.onTextDialogFinished : CocoonJS.App.onTextDialogCancelled;
            eventObject.notifyEventListeners(result);
        }
    };

    /**
     * Pops up a message dialog so the user can decide between a yes or no like confirmation. The message box execution events are passed to the application through the {@link CocoonJS.App.onMessageBoxConfirmed} and the {@link CocoonJS.App.onMessageBoxDenied} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [confirmButtonText] Default value is "Yes". The text to be displayed for the confirm button.
     * @param {string} [denyButtonText] Default value is "No". The text to be displayed for the deny button.
     * @see CocoonJS.App.onMessageBoxConfirmed
     * @see CocoonJS.App.onMessageBoxDenied
     */
    CocoonJS.App.showMessageBox = function (title, message, confirmButtonText, denyButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showMessageBox", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            var result = confirm(message);
            var eventObject = result ? CocoonJS.App.onMessageBoxConfirmed : CocoonJS.App.onMessageBoxDenied;
            eventObject.notifyEventListeners();
        }
    };

    /**
     * It allows to load a new JavaScript/HTML5 resource that can be loaded either locally (inside the platform/device storage) or using a remote URL.
     * @function
     * @param {string} path A path to a resource stored in the platform or in a URL to a remote resource.
     * @param {CocoonJS.App.StorageType} [storageType] If the path argument represents a locally stored resource, the developer can specify the storage where it is stored. If no value is passes, the {@link CocoonJS.App.StorageType.APP_STORAGE} value is used by default.
     */
    CocoonJS.App.load = function (path, storageType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "loadPath", arguments);
        }
        else if (!navigator.isCocoonJS) {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function (event) {
                if (xhr.readyState === 4) {
                    if (xhr.status === 200) {
                        // TODO: As window load event is not being called (WHY???), I have decided to call the listeners directly
                        // var callback= function(event){
                        //     window.removeEventListener("load", callback);
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInCocoonJSSucceed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                        // };
                        // window.addEventListener("load", callback);
                        window.location.href = path;
                    }
                    else if (xhr.status === 404) {
                        this.onreadystatechange = null;
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInCocoonJSFailed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the current context.
     * @function
     */
    CocoonJS.App.reload = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "reload", arguments);
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.location.reload();
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.location.reload();
            }
        }
    };

    /**
     * Opens a given URL using a system service that is able to open it. For example, open a HTTP URL using the system WebBrowser.+
     * @function
     * @param {string} url The URL to be opened by a system service.
     */
    CocoonJS.App.openURL = function (url) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "openURL", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            window.open(url, '_blank');
        }
    }

    /**
     * Forces the app to be finished.
     * @function
     */
    CocoonJS.App.forceToFinish = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forceToFinish", arguments);
        }
        else if (!navigator.isCocoonJS) {
            window.close();
        }
    }

    /**
     * Enables or disables the auto lock to control if the screen keeps on after an inactivity period.
     * When the auto lock is enabled and the application has no user input for a short period, the system puts the device into a "sleepâ€ state where the screen dims or turns off.
     * When the auto lock is disabled the screen keeps on even when there is no user input for long times.
     * @param enabled A boolean value that controls whether to enable or disable the auto lock.
     */
    CocoonJS.App.setAutoLockEnabled = function (enabled) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setAutoLockEnabled", arguments);
        }
    }

    /**
     * Creates a canvas element that is automatically resized to the screen size. When the app is being executed
     * inside CocoonJS. This canvas is optimized for rendering so it is higly recommended to use it if it fits
     * your app needs. If your app uses one canvas as the main canvas where all other canvases and images are displayed, Ludei recommends to
     * call this function in order to create this main canvas. A usual 2x performance gain is achieved by doing so
     * depending on the device and the graphics card driver.
     * @function
     * @return {object} The canvas object that should be used as the main canvas and that is resized to the screen resolution.
     */
    CocoonJS.App.createScreenCanvas = function () {
        var screenCanvas;
        if (navigator.isCocoonJS) {
            screenCanvas = document.createElement("screencanvas");
        }
        else if (!navigator.isCocoonJS) {
            screenCanvas = document.createElement("canvas");
            screenCanvas.width = window.innerWidth;
            screenCanvas.height = window.innerHeight;
        }
        return screenCanvas;
    };

    /**
     * Disables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.disableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "CocoonJSView");
        }
    };

    /**
     * Enables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.enableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "CocoonJSView");
        }
    };

    /**
     * Disables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.disableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "WebView");
        }
    };

    /**
     * Enables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.enableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "WebView");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the accelerometer updates.
     * It defines the rate at which the devicemotion events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setAccelerometerUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setAccelerometerUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for accelerometer related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for accelerometer related events.
     */
    CocoonJS.App.getAccelerometerUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getAccelerometerUpdateIntervalInSeconds");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the gyroscope updates.
     * It defines the rate at which the devicemotion and deviceorientation events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setGyroscopeUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setGyroscopeUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for gyroscope related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for gyroscope related events.
     */
    CocoonJS.App.getGyroscopeUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("getGyroscopeUpdateIntervalInSeconds");
        }
    };


    /**
     * Setups a origin proxy for a given typeName. What this means is that after calling this function the environment that makes this call will suddenly
     * have a way of creating instances of the given typeName and those instances will act as a transparent proxy to counterpart instances in the destination environment.
     * Manipulating attributes, calling funcitions or handling events will all be performed in the destination environment but the developer will think they will be
     * happening in the origin environment.
     * IMPORTANT NOTE: These proxies only work with types that use attributes and function parameters and return types that are primitive like numbers, strings or arrays.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} [attributeNames] A list of the names of the attributes to be proxified.
     * @param {array} [functionNames] A list of the names of the functions to be proxified.
     * @param {array} [eventHandlerNames] A list of the names of the event handlers to be proxified (onXXXX like attributes that represent callbacks).
     * A valid typeName and at least one valid array for attribute, function or event handler names is mandatory.
     */
    CocoonJS.App.setupOriginProxyType = function (typeName, attributeNames, functionNames, eventHandlerNames) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            // Control the parameters.
            if (!typeName) throw "The given typeName must be valid.";
            if (!attributeNames && !functionNames && !eventHandlerNames) throw "There is no point on setting up a proxy for no attributes, functions nor eventHandlers.";
            attributeNames = attributeNames ? attributeNames : [];
            functionNames = functionNames ? functionNames : [];
            eventHandlerNames = eventHandlerNames ? eventHandlerNames : [];

            // The parent object will be the window. It could be another object but careful, the destination side should know about this.
            // TODO: Specify the parentObject as a parameter, obtain it's path from the window object and pass it to the destination environment so it knows about it.
            var parentObject = window;

            // Setup the destination side too.
            var jsCode = "CocoonJS.App.setupDestinationProxyType(" + JSON.stringify(typeName) + ", " + JSON.stringify(eventHandlerNames) + ");";
            CocoonJS.App.forward(jsCode);

            var originalType = parentObject[typeName];

            // Constructor. This will be the new proxified type in the origin environment. Instances of this type will be created by the developer without knowing that they are
            // internally calling to their counterparts in the destination environment.
            parentObject[typeName] = function () {
                var _this = this;

                // Each proxy object will have a origin object inside with all the necessary information to be a proxy to the destination.
                this._cocoonjs_proxy_object_data = {};
                // The id is obtained calling to the destination side to create an instance of the type.
                var jsCode = "CocoonJS.App.newDestinationProxyObject(" + JSON.stringify(typeName) + ");";
                this._cocoonjs_proxy_object_data.id = CocoonJS.App.forward(jsCode);
                // The eventHandlers dictionary contains objects of the type { eventHandlerName : string, eventHandler : function } to be able to make the callbacks when the 
                // webview makes the corresponding calls.
                this._cocoonjs_proxy_object_data.eventHandlers = {};
                // Also store the typename inside each instance.
                this._cocoonjs_proxy_object_data.typeName = typeName;
                // A dictionary to store the event handlers
                this._cocoonjs_proxy_object_data.eventListeners = {};

                // TODO: eventHandlers and eventListeners should be in the same list ;)

                // Store all the proxy instances in a list that belongs to the type itself.
                parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[this._cocoonjs_proxy_object_data.id] = this;

                // Create a setter and a getter for all the attribute names that have been specified. When the attributes are accessed (set or get) a call to the destination counterpart will be performed.
                for (var i = 0; i < attributeNames.length; i++) {
                    (function (attributeName) {
                        _this.__defineSetter__(attributeName, function (value) {
                            var jsCode = "CocoonJS.App.setDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ", " + JSON.stringify(value) + ");";
                            return CocoonJS.App.forwardAsync(jsCode);
                        });
                        _this.__defineGetter__(attributeName, function () {
                            var jsCode = "CocoonJS.App.getDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ");";
                            return CocoonJS.App.forwardAsync(jsCode);
                        });
                    })(attributeNames[i]);
                }

                // Create a function that performs a call to the destination environment counterpart for all the function names that have been specified.
                for (var i = 0; i < functionNames.length; i++) {
                    (function (functionName) {
                        _this[functionName] = function () {
                            // Get the arguments as an array and add the typeName, the proxy id and the functionName before all the other arguments before making the call to the destination counterpart.
                            var argumentsArray = Array.prototype.slice.call(arguments);
                            argumentsArray.unshift(functionName);
                            argumentsArray.unshift(this._cocoonjs_proxy_object_data.id);
                            argumentsArray.unshift(typeName);
                            // Use the array to create the correct function call.
                            var jsCode = "CocoonJS.App.callDestinationProxyObjectFunction(";
                            for (var i = 0; i < argumentsArray.length; i++) {
                                // The second argument (the id) should not be stringified
                                jsCode += (i !== 1 ? JSON.stringify(argumentsArray[i]) : argumentsArray[i]) + (i < argumentsArray.length - 1 ? ", " : "");
                            }
                            jsCode += ");";
                            // TODO: This next call should be synchronous but it seems that some customers are experiencing some crash issues. Making it async solves these crashes.
                            // Another possible solution could be to be able to specify which calls could be async and which sync in the proxification array.
                            var ret = CocoonJS.App.forwardAsync(jsCode);
                            return ret;
                        };
                    })(functionNames[i]);
                }

                // Create a setter and getter for all the event handler names that have been specified. When the event handlers are accessed, store them inside the corresponding position on the eventHandlers
                // array so they can be called when the destination environment makes the corresponding callback call.
                for (var i = 0; i < eventHandlerNames.length; i++) {
                    (function (eventHandlerName) {
                        _this.__defineSetter__(eventHandlerName, function (value) {
                            _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName] = value;
                        });
                        _this.__defineGetter__(eventHandlerName, function () {
                            return _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
                        });
                    })(eventHandlerNames[i]);
                }

                // Setup the add and remove event listeners in the proxy object
                _this.addEventListener = function (eventTypeName, eventCallback) {
                    var addEventCallback = true;
                    // Check for the eventListeners
                    var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                    if (eventListeners) {
                        // As the eventListeners were already added, check that the same callback has not been added.
                        addEventCallback = eventListeners.indexOf(eventCallback) < 0;
                    }
                    else {
                        // There are no event listeners, so add the one and add the listeners array for the specific event type name
                        eventListeners = [];
                        _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = eventListeners;

                        // Forward the call so the other end registers a event listener (only one is needed).
                        var jsCode = "CocoonJS.App.addDestinationProxyObjectEventListener(" + JSON.stringify(_this._cocoonjs_proxy_object_data.typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
                        CocoonJS.App.forwardAsync(jsCode);
                    }
                    // Only if the alforithm above specify so, add the eventcallback and notify the destination environment to do the same
                    if (addEventCallback) {
                        eventListeners.push(eventCallback);
                    }
                };

                _this.removeEventListener = function (eventTypeName, eventCallback) {
                    // Check for the eventListeners
                    var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                    if (eventListeners) {
                        var eventCallbackIndex = eventListeners.indexOf(eventCallback);
                        if (eventCallbackIndex >= 0) {
                            eventListeners.splice(eventCallbackIndex, 1);
                        }
                    }
                };

                // Return the proxy instance.
                return this;
            };

            // The type will contain a proxy data structure to store all the instances that are created so they are available when the destination environment calls back. 
            parentObject[typeName]._cocoonjs_proxy_type_data =
            {
                originalType:originalType,
                proxyObjects:[]
            };

            /**
             * Deletes a proxy instance from both the CocoonJS environment structures and also deleting it's webview environment counterpart.
             * This function should be manually called whenever a proxy instance won't be accessed anymore.
             * @param {object} object The proxy object to be deleted.
             */
            parentObject[typeName]._cocoonjs_proxy_type_data.deleteProxyObject = function (object) {
                var proxyObjectKey = CocoonJS.getKeyForValueInDictionary(this.proxyObjects, object);
                if (proxyObjectKey) {
                    var jsCode = "CocoonJS.App.deleteDestinationProxyObject(" + JSON.stringify(typeName) + ", " + object._cocoonjs_proxy_object_data.id + ");";
                    CocoonJS.App.forwardAsync(jsCode);
                    object._cocoonjs_proxy_object_data = null;
                    delete this.proxyObjects[proxyObjectKey];
                }
            };

            /**
             * Calls a event handler for the given proxy object id and eventHandlerName.
             * @param {number} id The id to be used to look for the proxy object for which to make the call to it's event handler.
             * @param {string} eventHandlerName The name of the handler to be called.
             * NOTE: Events are a complex thing in the HTML specification. This function just performs a call but at least provides a
             * structure to the event passing the target (the proxy object).
             * TODO: The destination should serialize the event object as far as it can so many parameters can be passed to the origin
             * side. Using JSON.stringify in the destination side and parse in origin side maybe? Still must add the target to the event structure though.
             */
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler = function (id, eventHandlerName) {
                var object = this.proxyObjects[id];
                var eventHandler = object._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
                if (eventHandler) {
                    eventHandler({ target:object });
                }
            };

            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners = function (id, eventTypeName) {
                var object = this.proxyObjects[id];
                var eventListeners = object._cocoonjs_proxy_object_data.eventListeners[eventTypeName].slice();
                for (var i = 0; i < eventListeners.length; i++) {
                    eventListeners[i]({ target:object });
                }
            };
        }
    };

    /**
     * Takes down the proxification of a type and restores it to it's original type. Do not worry if you pass a type name that is not proxified yet. The
     * function will handle it correctly for compativility reasons.
     * @param {string} typeName The name of the type to be deproxified (take down the proxification and restore the type to it's original state)
     */
    CocoonJS.App.takedownOriginProxyType = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (parentObject[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
                parentObject[typeName] = parentObject[typeName]._cocoonjs_proxy_type_data.originalType;
            }
        }
    };

    /**
     * Deletes everything related to a proxy object in both environments. Do not worry of you do not pass a proxified object to the
     * function. For compatibility reasons, you can still have calls to this function even when no poxification of a type has been done.
     * @param {object} object The proxified object to be deleted.
     */
    CocoonJS.App.deleteOriginProxyObject = function (object) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (object && object._cocoonjs_proxy_object_data) {
                parentObject[object._cocoonjs_proxy_object_data.typeName]._cocoonjs_proxy_type_data.deleteProxyObject(object);
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when an event handler need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventHandlerName The name of the event handler to be called.
     */
    CocoonJS.App.callOriginProxyObjectEventHandler = function (typeName, id, eventHandlerName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler(id, eventHandlerName);
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when all the event listeners related to a specific event need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventTypeName The name of the event type to call the listeners related to it.
     */
    CocoonJS.App.callOriginProxyObjectEventListeners = function (typeName, id, eventTypeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners(id, eventTypeName);
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Setups all the structures that are needed to proxify a destination type to an origin type.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} eventHandlerNames An array with al the event handlers to be proxified. Needed in order to be able to create callbacks for all the event handlers
     * and call to the CocoonJS counterparts accordingly.
     */
    CocoonJS.App.setupDestinationProxyType = function (typeName, eventHandlerNames) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;

            // Add a cocoonjs structure to the destination proxified type to store some useful information like all the proxy instances that are created, plus the id counter 
            // and the names of all the event handlers and some utility functions.
            parentObject[typeName]._cocoonjs_proxy_type_data =
            {
                nextId:0,
                proxyObjects:{},
                eventHandlerNames:eventHandlerNames
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Takes down the proxy type at the destination environment. Just removes the data structure related to proxies that was added to the type when proxification tool place.
     * @param {string} typeName The name of the type to take the proxification down.
     */
    CocoonJS.App.takedownDestinationProxyType = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (parent[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
                delete parentObject[typeName]._cocoonjs_proxy_type_data;
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Creates a new destination object instance and generates a id to reference it from the original environment.
     * @param {string} typeName The name of the type to be proxified and to generate an instance.
     * @return The id to be used from the original environment to identify the corresponding destination object instance.
     */
    CocoonJS.App.newDestinationProxyObject = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;

            var proxyObject = new parentObject[typeName]();
            // Also store some additional information in the proxy object
            proxyObject._cocoonjs_proxy_object_data = {};
            // Like the type name, that could be useful late ;)
            proxyObject._cocoonjs_proxy_object_data.typeName = typeName;
            // Caculate the id for the object. It will be returned to the origin environment so this object can be referenced later
            var proxyObjectId = parentObject[typeName]._cocoonjs_proxy_type_data.nextId;
            // Store the created object in the structure defined in the setup of proxification with an id associated to it
            parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[proxyObjectId] = proxyObject;
            // Also store the id inside the proxy object itself
            proxyObject._cocoonjs_proxy_object_data.id = proxyObjectId;
            // Calculate a new id for the next object.
            parentObject[typeName]._cocoonjs_proxy_type_data.nextId++;

            // Setup all the event handlers.
            for (var i = 0; i < parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames.length; i++) {
                (function (eventHandlerName) {
                    proxyObject[eventHandlerName] = function (event) {
                        var proxyObject = this; // event.target;
                        // var eventHandlerName = CocoonJS.getKeyForValueInDictionary(proxyObject, this); // Avoid closures ;)
                        var jsCode = "CocoonJS.App.callOriginProxyObjectEventHandler(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventHandlerName) + ");";
                        CocoonJS.App.forwardAsync(jsCode);
                    };
                })(parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames[i]);
            }

            // Add the dictionary where the event listeners (callbacks) will be added.
            proxyObject._cocoonjs_proxy_object_data.eventListeners = {};

            return proxyObjectId;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environement whenever it is needed to work with proxy objects.
     * Calls a function of a destination object idetified by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} functionName The name of the function to be called.
     * @return Whatever the function call returns.
     */
    CocoonJS.App.callDestinationProxyObjectFunction = function (typeName, id, functionName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var argumentsArray = Array.prototype.slice.call(arguments);
            argumentsArray.splice(0, 3);
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            var result = proxyObject[functionName].apply(proxyObject, argumentsArray);
            return result;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Sets a value to the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be set.
     * @param {unknown} attributeValue The value to be set to the attribute.
     */
    CocoonJS.App.setDestinationProxyObjectAttribute = function (typeName, id, attributeName, attributeValue) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            proxyObject[attributeName] = attributeValue;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Retrieves the value of the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be retrieved.
     */
    CocoonJS.App.getDestinationProxyObjectAttribute = function (typeName, id, attributeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            return proxyObject[attributeName];
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Deletes a proxy object identifying it using it's typeName and id. Deleting a proxy object mainly means to remove the instance from the global structure
     * that hold all the instances.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     */
    CocoonJS.App.deleteDestinationProxyObject = function (typeName, id) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            delete parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     */
    CocoonJS.App.addDestinationProxyObjectEventListener = function (typeName, id, eventTypeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            // Look for the proxy object
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];

            var callback = function (event) {
                var proxyObject = this; // event.target;
                // var eventTypeName = CocoonJS.getKeyForValueInDictionary(proxyObject._cocoonjs_proxy_object_data.eventListeners, this); // Avoid closures ;)
                // TODO: Is there a way to retrieve the callbackId without a closure?
                var jsCode = "CocoonJS.App.callOriginProxyObjectEventListeners(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
                CocoonJS.App.forwardAsync(jsCode);
            };

            proxyObject._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = callback;

            // Finally add the event listener callback to the proxy object
            proxyObject.addEventListener(eventTypeName, callback);
        }
    };

    // TODO: We could add a removeDestinationProxyObjectEventListener although it seems that is not completely necessary.

    /**
     * Proxifies the XMLHttpRequest type for the environment where this call is made. After calling this function, all the new objects
     * of XMLHttpRequest that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyXHR = function () {
        var ATTRIBUTE_NAMES =
            [
                "timeout",
                "withCredentials",
                "upload",
                "status",
                "statusText",
                "responseType",
                "response",
                "responseText",
                "responseXML",
                "readyState"
            ];
        var FUNCTION_NAMES =
            [
                "open",
                "setRequestHeader",
                "send",
                "abort",
                "getResponseHeader",
                "getAllResponseHeaders",
                "overrideMimeType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onloadstart",
                "onprogress",
                "onabort",
                "onerror",
                "onload",
                "ontimeout",
                "onloadend",
                "onreadystatechange"
            ];
        CocoonJS.App.setupOriginProxyType("XMLHttpRequest", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Proxifies the Audio type for the environment where this call is made. After calling this function, all the new objects
     * of Audio that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyAudio = function () {
        var ATTRIBUTE_NAMES =
            [
                "src",
                "loop",
                "volume",
                "preload"
            ];
        var FUNCTION_NAMES =
            [
                "play",
                "pause",
                "load",
                "canPlayType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onended",
                "oncanplay",
                "oncanplaythrough",
                "onerror"
            ];
        CocoonJS.App.setupOriginProxyType("Audio", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Captures a image of the screen synchronously and saves it to a file. Sync mode allows to capture the screen in the middle of a frame rendering.
     * @param {string} fileName Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} storageType The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @return The URL of the saved file.
     * @throws exception if the image fails to be stored or there is another error.
     * @see CocoonJS.App.onCaptureScreenSucceeded
     * @see CocoonJS.App.onCaptureScreenFailed
     */
    CocoonJS.App.captureScreen = function (fileName, storageType, captureType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("captureScreen", fileName, storageType, captureType);
        }
    };

    /**
     * Captures a image of the screen asynchronously and saves it to a file.
     * Async mode captures a final frame as soon as possible.
     * @param {string} Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} [storageType] The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface, 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @param {function} callback. Response callback, check the error property to monitor errors. Check the 'url' property to get the URL of the saved Image
     */
    CocoonJS.App.captureScreenAsync = function (fileName, storageType, captureType, callback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCallAsync("captureScreen", fileName, storageType, captureType, callback);
        }
    };

    /**
     * Returns the device UUID
     * @return {string} The device UUID
     */
    CocoonJS.App.getDeviceId = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceId");
        }
    };

    /**
     * Structure that defines the getDeviceInfo returned information
     */
    CocoonJS.App.DeviceInfo = {

        /**
        * The operating system name (ios, android,...)
        * @type string
        */
        os: null,

        /**
        * The operating system version (4.2.2, 5.0,...)
        * @type string
        */
        version: null,

        /**
        * The operating system screen density in dpi
        * @type string
        */
        dpi: null,

        /**
        * The device manufacturer (apple, samsung, lg,...)
        * @type string
        */
        brand: null,

        /**
        * The device model (iPhone 4S, SAMSUNG-SGH-I997, SAMSUNG-SGH-I997R, etc)
        * @type string
        */
        model: null,

        /**
        * The phone IMEI
        * Android: The phone IMEI is returned or null if the device has not telepohny
        * iOS: null is returned as we cannot get the IMEI in iOS, no public API available for that yet.
        * @type string
        */
        imei: null,

        /**
        * The platform Id
        * Android: The ANDROID_ID is used.
        * iOS: The OpenUDID is used as there is no Android ANDROID_ID equivalent in iOS
        * @type string
        */
        platformId: null,

        /**
        * The Odin generated id https://code.google.com/p/odinmobile/
        * @type string
        */
        odin: null,

        /**
        * The OpenUDID generated Id https://github.com/ylechelle/OpenUDID
        * @type string
        */
        openudid: null
    };

    /**
     * Returns the device Info
     * @return {CocoonJS.App.DeviceInfo} The device Info
     */
    CocoonJS.App.getDeviceInfo = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceInfo");
        }
    };    

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onTextDialogFinished} event calls.
     * @name OnTextDialogFinishedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} text The text that was introduced in the text dialog when it was finished.
     */
    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function's documentation is represented by {@link CocoonJS.App.OnTextDialogFinishedListener}
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogFinished = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogfinish");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogCancelled = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogcancel");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxConfirmed = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxconfirmed");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxDenied = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxdenied");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is suspended.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onSuspended = new CocoonJS.EventHandler("IDTK_APP", "App", "onsuspended");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is activated.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onActivated = new CocoonJS.EventHandler("IDTK_APP", "App", "onactivated");

})();

//////////////////////////////////////
// COCOONJS_APP_FORCOCOONJS.JS		//
//////////////////////////////////////

(function()
{
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before adding more functionalities to an extension.");
    if (typeof window.CocoonJS.App === 'undefined' || window.CocoonJS.App === null) throw("The CocoonJS.App object must exist and be valid before adding more functionalities to it.");

    /**
    * This namespace represents all the basic functionalities available in the CocoonJS extension API.
    * @namespace
    */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    if (!CocoonJS.App.nativeExtensionObjectAvailable)
    {
        (function createWebView() { 
            CocoonJS.App.EmulatedWebView = document.createElement('div'); 
            CocoonJS.App.EmulatedWebView.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewDiv'); 
            CocoonJS.App.EmulatedWebView.style.width = 0; 
            CocoonJS.App.EmulatedWebView.style.height = 0; 
            CocoonJS.App.EmulatedWebView.style.position = "absolute"; 
            CocoonJS.App.EmulatedWebView.style.left = 0; 
            CocoonJS.App.EmulatedWebView.style.top = 0;
            CocoonJS.App.EmulatedWebView.style.backgroundColor = 'transparent';
            CocoonJS.App.EmulatedWebView.style.border = "0px solid #000"; 
            CocoonJS.App.EmulatedWebViewIFrame = document.createElement("IFRAME"); 
            CocoonJS.App.EmulatedWebViewIFrame.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
            CocoonJS.App.EmulatedWebViewIFrame.setAttribute('name', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
            CocoonJS.App.EmulatedWebViewIFrame.style.width = 0; 
            CocoonJS.App.EmulatedWebViewIFrame.style.height = 0; 
            CocoonJS.App.EmulatedWebViewIFrame.frameBorder = 0;
            CocoonJS.App.EmulatedWebViewIFrame.allowtransparency = true;
            CocoonJS.App.EmulatedWebView.appendChild(CocoonJS.App.EmulatedWebViewIFrame);
            if(!document.body)
            document.body = document.createElement("body");
            document.body.appendChild(CocoonJS.App.EmulatedWebView);
        })(); 
    }

    /**
    * Pauses the CocoonJS JavaScript execution loop.
    * @function
    * @augments CocoonJS.App
    */
    CocoonJS.App.pause = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "pause", arguments);
        }
    };

    /**
    * Resumes the CocoonJS JavaScript execution loop.
    * @static
    * @function
    */
    CocoonJS.App.resume = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "resume", arguments);
        }
    };

    /**
    * Loads a resource in the WebView environment from the CocoonJS environment.
    * @function
    * @param {string} path The path to the resource. It can be a remote URL or a path to a local file.
    * @param {CocoonJS.App.StorageType} [storageType] An optional parameter to specify at which storage in the device the file path is stored. By default, APP_STORAGE is used.
    * @see CocoonJS.App.load
    * @see CocoonJS.App.onLoadInTheWebViewSucceed
    * @see CocoonJS.App.onLoadInTheWebViewFailed
    */
    CocoonJS.App.loadInTheWebView = function(path, storageType)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            // TODO: All this code should be changed to a simple call makeNativeExtensionObjectFunctionCall when the native argument control is improved.
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('loadPath'";
            if (typeof path !== 'undefined')
            {
                javaScriptCodeToForward += ", '" + path + "'";
                if (typeof storageType !== 'undefined')
                {
                    javaScriptCodeToForward += ", '" + storageType + "'";
                }
            }
            javaScriptCodeToForward += ");";

            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function(event) {
                if (xhr.readyState === 4)
                {
                    if (xhr.status === 200)
                    {
                        var callback= function(event){
                            CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners(path);
                            CocoonJS.App.EmulatedWebViewIFrame.removeEventListener("load", callback);
                        };

                        CocoonJS.App.EmulatedWebViewIFrame.addEventListener(
                            "load", 
                            callback
                        );
                        CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.href= path;
                    }
                    else if (xhr.status === 404)
                    {
                        this.onreadystatechange = null;
                        CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners(path);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the WebView context.
     * @function
     */
    CocoonJS.App.reloadWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.App.forwardAsync("ext.IDTK_APP.makeCall('reload');");
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.reload();
        }
    };

    /**
    * Shows the webview.
    * @function
    * @param {int} x The top lef x coordinate of the rectangle where the webview will be shown.
    * @param {int} y The top lef y coordinate of the rectangle where the webview will be shown.
    * @param {width} y The width of the rectangle where the webview will be shown.
    * @param {height} y The height of the rectangle where the webview will be shown.
    */
    CocoonJS.App.showTheWebView = function(x, y, width, height)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('show'";
            if (typeof x !== 'undefined' && typeof y !== 'undefined' && typeof width !== 'undefined' && typeof height !== 'undefined')
            {
                javaScriptCodeToForward += ", " + x + ", " + y + ", " + width + ", " + height;
            }
            javaScriptCodeToForward += ");";

            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebViewIFrame.style.width = (width ? width : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebViewIFrame.style.height = (height ? height : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.left = (x ? x : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.top = (y ? y : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.width = (width ? width : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebView.style.height = (height ? height : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.display = "block";
        }
    };

    /**
    * Hides the webview.
    * @function
    */
    CocoonJS.App.hideTheWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('hide');";
            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebView.style.display = "none";
        }
    };

    /**
    * Marks a audio file to be used as music by the system. CocoonJS, internally, differentiates among music files and sound files.
    * Music files are usually bigger in size and longer in duration that sound files. There can only be just one music file 
    * playing at a specific given time. The developer can mark as many files as he/she wants to be treated as music. When the corresponding
    * HTML5 audio object is used, the system will automatically know how to treat the audio resource as music or as sound.
    * Note that it is not mandatory to use this function. The system automatically tries to identify if a file is suitable to be treated as music
    * or as sound by checking file size and duration thresholds. It is recommended, though, that the developer specifies him/herself what he/she considers
    * to be music.
    * @function
    * @param {string} audioFilePath The same audio file path that will be used to create HTML5 audio objects.
    */
    CocoonJS.App.markAsMusic = function(audioFilePath)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "addForceMusic", arguments);
        }
    };

    /**
    * Activates or deactivates the antialas functionality from the CocoonJS rendering.
    * @function
    * @param {boolean} enable A flag that indicates if the antialas should be activated (true) or deactivated (false).
    */
    CocoonJS.App.setAntialias = function(enable)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultAntialias", arguments);
        }
    };

    /**
    * Sets a callback function that will be called whenever the system tries to finish the app.
    * The developer can specify how the system will react to the finish of the app by returning a
    * boolean value in the callback function: true means, close the app, false means that the developer
    * will handle the app close.
    * A common example of this is the back button in Android devices. When the back button is pressed, this
    * callback will be called and the system will react depending on the developers choice finishing, or not,
    * the application.
    * @function
    * @param {function} appShouldFinishCallback A function object that will be called when the system
    * determines that the app should be finished. This function must return a true or a false value
    * depending on what the developer wants: true === finish the app, false === do not close the app.
    */
    CocoonJS.App.setAppShouldFinishCallback = function(appShouldFinishCallback)
    {
        if (navigator.isCocoonJS)
        {
            window.onidtkappfinish = appShouldFinishCallback;
        }
    }

    /**
    * Sets the texture reduction options. The texture reduction is a process that allows big images to be reduced/scaled down when they are loaded.
    * Although the quality of the images may decrease, it can be very useful in low end devices or those with limited amount of memory.
    * The function sets the threshold on image size (width or height) that will be used in order to know if an image should be reduced or not.
    * It also allows to specify a list of strings to identify in which images file paths should be applied (when they meet the size threshold requirement) 
    * The developer will still think that the image is of the original size. CocoonJS handles all of the internals to be able to show the image correctly.
    * IMPORTANT NOTE: This function should be called when the application is initialized before any image is set to be loaded for obvious reasons ;).
    * and in which sould be forbid (even if they meet the threshold requirement).
    * @function
    * @param {number} sizeThreshold This parameter specifies the minimun size (either width or height) that an image should have in order to be reduced.
    * @param {string or array} [applyTo] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it will be reduced. This parameter can also be null.
    * @param {string or array} [forbidFor] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it won't be reduced. This parameter should be used in order to mantain the 
    * quality of some images even they meet the size threshold requirement.
    */
    CocoonJS.App.setTextureReduction = function(sizeThreshold, applyTo, forbidFor)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultTextureReducerThreshold", arguments);
        }
    };


    /**
    * Prints to the console the memory usage of the currently alive textures
    * @function
    */
    CocoonJS.App.logMemoryInfo = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "logMemoryInfo", arguments);
        }
    };

    /**
    * Enable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.enableFPSInTheWebView = function(fpsLayout, textColor)
    {
        if (!CocoonJS.App.fpsInTheWebViewEnabled)
        {
            fpsLayout = fpsLayout ? fpsLayout : CocoonJS.App.FPSLayout.TOP_RIGHT;
            textColor = textColor ? textColor : "white";
            var jsCode = "" +
                "(function()" +
                "{" +
                    "var COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES = ['js/CocoonJSExtensions/CocoonJS.js', 'js/CocoonJSExtensions/CocoonJS_App.js', 'js/CocoonJSExtensions/CocoonJS_App_ForWebView.js'];" +
                    "var loadedScriptCounter = 0;" + 
                    "var loadedScriptFunction = function() " +
                    "{ " +
                        "loadedScriptCounter++;"+
                        "if (loadedScriptCounter >= COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length)"+
                        "{"+
                            "CocoonJS.App.enableFPS(" + JSON.stringify(fpsLayout) + ", " + JSON.stringify(textColor) + ");"+
                        "}"+
                    "};"+
                    "for (var i = 0; i < COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length; i++)"+
                    "{"+
                        "var s = document.createElement('script');"+
                        "s.onload = loadedScriptFunction;"+
                        "s.src = COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES[i];"+
                        "document.body.appendChild(s);"+
                    "}" +
                "})();";
            setTimeout(function()
            {
                CocoonJS.App.forward(jsCode);
            }, 3000);
            CocoonJS.App.fpsInTheWebViewEnabled = true;
        }
    };

    /**
    * Disable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.disableFPSInTheWebView = function()
    {
        // TODO: Implement this function.
    };

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewSucceed} event calls.
     * @name OnLoadInTheWebViewSucceedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load has completed successfully.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewSucceedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    * @param {string} pageURL A string that represents the page URL loaded.
    */
    CocoonJS.App.onLoadInTheWebViewSucceed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpageload");

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewFailed} event calls.
     * @name OnLoadInTheWebViewFailedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load fails.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewFailedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    */
    CocoonJS.App.onLoadInTheWebViewFailed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpagefail");
    
})();

//////////////////////////////////////
// COCOONJS_AD.JS                   //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS Advertisement extension API.
    * @namespace
    */
    CocoonJS.Ad = {};

    CocoonJS.Ad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_AD !== 'undefined';

    /**
    * The predefined possible layouts for a banner ad.
    * @namespace 
    */
	CocoonJS.Ad.BannerLayout = 
	{
		/**
		* Specifies that the banner must be shown in the top of the screen and vertically centered.
		*/
	    TOP_CENTER      : "TOP_CENTER",

		/**
		* Specifies that the banner must be shown in the bottom of the screen and vertically centered.
		*/
	    BOTTOM_CENTER   : "BOTTOM_CENTER"
	};

	/**
    * A rectangle object that contains the banner dimensions
    * @namespace 
    * @constructor
    * @param {int} x The top lef x coordinate of the rectangle.
    * @param {int} y The top lef y coordinate of the rectangle.
    * @param {width} y The rectangle width.
    * @param {height} y The rectangle height.
    */
	CocoonJS.Ad.Rectangle = function(x, y, width, height) 
	{
		/**
		* The top lef x coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.x = x;

		/**
		* The top lef y coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.y = y;

	    /**
		* The rectangle width
		* @field 
		* @type {int}
		*/
	    this.width = width;

	    /**
		* The rectangle height
		* @field 
		* @type {int}
		*/
	    this.height = height;
	};

	CocoonJS.Ad.Banner = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
    	* The callback function does not receive any parameter.
    	* @param {number} width The banner width
    	* @param {number} height The banner height
    	* @static
    	* @event
    	*/
		this.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener(args[1], args[2]);
    		}
    	});
	};

	CocoonJS.Ad.Banner.prototype = {

		/**
		* Shows a banner ad if available.
		* @function
		*/
		showBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", [this.id], true);
			}
		},

		/**
		* Hides the banner ad if it was being shown.
		* @function
		*/
		hideBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", [this.id], true);
			}
		},

		/**
		* Refreshes the banner.
		* @function
		*/
		refreshBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", [this.id], true);
			}
		},

		/**
		* Gets the rectangle representing the banner screen position.
		* @function
		* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
		*/
		getRectangle : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", [this.id]);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* @function
		* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
		*/
		setRectangle : function(rect)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", [this.id, rect],true);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* You can use this method if you want to have better control of the banner screen positioning.
		* @function
		* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
		*/
		setBannerLayout : function(bannerLayout)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", [this.id, bannerLayout],true);
			}
		}
	};

	CocoonJS.Ad.Fullscreen = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
		this.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

    	/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});
	};

	CocoonJS.Ad.Fullscreen.prototype = {

		/**
		* Shows a full screen ad if available.
		* @function
		* @see CocoonJS.Ad.onFullScreenShown
		* @see CocoonJS.Ad.onFullScreenHidden
		*/
		showFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", [this.id], true);
			}
		},

		/**
		* Refreshes the fullscreen.
		* @function
		*/
		refreshFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", [this.id], true);
			}
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Ad.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "requestInitialization", arguments, true);
		}
	};

	/**
	* Creates a new banner ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createBanner = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createBanner", [parameters]);
			var banner = new CocoonJS.Ad.Banner(adId);

			return banner;
		}
	};

	/**
	* Releases a banner.
	* @function
	* @param {object} The banner ad object to be released.
	*/
	CocoonJS.Ad.releaseBanner = function(banner)
	{
		if (typeof banner === "undefined") {
            throw "The banner ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseBanner", [banner.id]);
		}
	};

	/**
	* Creates a new fullscreen ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createFullscreen = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createFullscreen", [parameters]);
			var fullscreen = new CocoonJS.Ad.Fullscreen(adId);

			return fullscreen;
		}
	};

	/**
	* Releases a fullscreen ad.
	* @function
	* @param {object} The fullscreen ad object to be released.
	*/
	CocoonJS.Ad.releaseFullscreen = function(fullscreen)
	{
		if (typeof fullscreen === "undefined") {
            throw "The fullscreen ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseFullscreen", [fullscreen.id]);
		}
	};

	/**
	* Shows a banner ad if available.
	* @function
	* @see CocoonJS.Ad.setBannerLayout
	* @see CocoonJS.Ad.onBannerShown
	*/
	CocoonJS.Ad.showBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", arguments, true);
		}
	};

	/**
	* Hides the banner ad if it was being shown.
	* @function
	*/
	CocoonJS.Ad.hideBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", arguments, true);
		}
	};

	/**
	* Refreshes the banner.
	* @function
	*/
	CocoonJS.Ad.refreshBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", arguments, true);
		}
	};

	/**
	* Shows a full screen ad if available.
	* @function
	* @see CocoonJS.Ad.onFullScreenShown
	* @see CocoonJS.Ad.onFullScreenHidden
	*/
	CocoonJS.Ad.showFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", arguments, true);
		}
	};

	/**
	* Refreshes the fullscreen.
	* @function
	*/
	CocoonJS.Ad.refreshFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", arguments, true);
		}
	};

	/**
	* Makes a request to preload a banner ad.
	* @function
	*/
	CocoonJS.Ad.preloadBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadBanner", arguments, true);
		}
	};

	/**
	* Makes a request to preload a full screen ad.
	* @function
	*/
	CocoonJS.Ad.preloadFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadFullScreen", arguments, true);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* @function
	* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.setRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", arguments, true);
		}
	};

	/**
	* Gets the rectangle representing the banner screen position.
	* @function
	* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.getRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", arguments);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* You can use this method if you want to have better control of the banner screen positioning.
	* @function
	* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
	*/
	CocoonJS.Ad.setBannerLayout = function(bannerLayout)
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", arguments, true);
		}
	};

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide"); 

	/**
	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
	* The callback function does not receive any parameter.
	* @param {number} width The banner width
	* @param {number} height The banner height
	* @static
	* @event
	*/
	CocoonJS.Ad.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready"); 

})();

//////////////////////////////////////
// COCOONJS_STORE.JS                //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS In-App Purchase extension.
    * @namespace
    */
    CocoonJS.Store = {};

    CocoonJS.Store.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_STORE !== 'undefined';

	/**
	* The data structure that represents the information of a product in the store.
	* @namespace
	* @constructor
	* @param {string} The id of the product.
	* @param {string} The alias of the product.
	* @param {CocoonJS.Store.ProductType} The product type @see CocoonJS.Store.ProductType.
	* @param {string} The title of the product.
	* @param {string} The description of the product.
	* @param {string} The localized price of the product.
	* @param {string} The URL of the asset to be downloaded for this purchase.
	*/
	CocoonJS.Store.ProductInfo = function(productAlias, productId, productType, title, description, price, localizedPrice, downloadURL)
	{
		/**
		* The id of the product.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The alias of the product.
		* @field
		* @type string
		*/
		this.productAlias = productAlias;

		/**
		* The product type @see CocoonJS.Store.ProductType
		* @field
		* @type CocoonJS.Store.ProductType
		*/
		this.productType = productType;

		/**
		* The title of the product.
		* @field
		* @type string
		*/
		this.title = title;

		/**
		* The description of the product.
		* @field
		* @type string
		*/
		this.description = description;

		/**
		* The price of the product.
		* @field
		* @type string
		*/
		this.price = price;

		/**
		* The localized price of the product.
		* @field
		* @type string
		*/
		this.localizedPrice = localizedPrice;

		/**
		* The URL of the asset to be downloaded for this purchase.
		* @field
		* @type string
		*/
		this.downloadURL = downloadURL;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.ProductType = 
	{
		/**
		* A consumable product. See platform documentation for further information.
		*/
	    CONSUMABLE : 0,

		/**
		* A non-cunsumable product. . See platform documentation for further information.
		*/
	    NON_CONSUMABLE : 1,

	    /**
		* An auto-renewable subscription. See platform documentation for further information.
		*/
	    AUTO_RENEWABLE_SUBSCRIPTION : 2,

	    /**
		* A free subscription. See platform documentation for further information.
		*/
	    FREE_SUBSCRIPTION : 3,

	    /**
		* A non-renewable subscription. See platform documentation for further information.
		*/
	    NON_RENEWABLE_SUBSCRIPTION : 4
	};

	/**
    * The predefined possible store types.
    * @namespace 
    */
	CocoonJS.Store.StoreType = 
	{
		/**
		* Apple AppStore
		*/
	    APP_STORE : 0,

	    /**
	    * Android Play Store
	    */
	    PLAY_STORE : 1,

		/**
		* Mock Store
		*/
		MOCK_STORE : 2,

		/**
	    * Amazon AppStore
	    */
	    CHROME_STORE : 3,

	    /**
	    * Amazon AppStore
	    */
	    AMAZON_STORE : 4,

	    /**
	    * Nook Store
	    */
	    NOOK_STORE : 5
	};

	/**
	* The data structure that represents the information of a purchase.
	* @namespace
	* @constructor
	* @param {string} The transaction id of a purchase.
	* @param {string} The time when the purchase was done in seconds since 1970.
	* @param {CocoonJS.Store.PurchaseState} The state of the purchase. @see CocoonJS.Store.PurchaseState
	* @param {string} The product id related to this purchase.
	* @param {number} The number of products of the productId kind purchased in this transaction.
	*/
	CocoonJS.Store.PurchaseInfo = function(transactionId, purchaseTime, purchaseState, productId, quantity)
	{
		/**
		* The transaction id of a purchase.
		* @field
		* @type string
		*/
		this.transactionId = transactionId;

		/**
		* The time when the purchase was done in seconds since 1970.
		* @field
		* @type string
		*/
		this.purchaseTime = purchaseTime;

		/**
		* The state of the purchase. @see CocoonJS.Store.PurchaseState
		* @field
		* @type CocoonJS.Store.PurchaseState
		*/
		this.purchaseState = purchaseState;

		/**
		* The product id related to this purchase.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The number of products of the productId kind purchased in this transaction.
		* @field
		* @type number
		*/
		this.quantity = quantity;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.PurchaseState = 
	{
		/**
		* The product has been successfully purchased. The transaction has ended successfully.
		*/
	    PURCHASED : 0,

		/**
		* The purchase has been canceled.
		*/
	    CANCELED : 1,

	    /**
		* The purchase has been refunded.
		*/
	    REFUNDED : 2,

	    /**
		* The purchase (subscriptions only) has expired and is no longer valid.
		*/
	    EXPIRED : 3
	};

	/**
	* Gets the name of the native store implementation. 
	* @return {CocoonJS.Store.StoreType} The store type
	* @function
	*/ 
	CocoonJS.Store.getStoreType = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getStoreType", arguments);
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Store.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") 
        {
            parameters = {};
        }
        else
        {
        	if (parameters['managed'] !== undefined) parameters['remote'] = parameters['managed'];
        	if (parameters['sandbox'] !== undefined) parameters['debug'] = parameters['sandbox'];
        }

		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "requestInitialization", arguments, true);
		}
	};

	/**
	* Starts the Store Service. 
	* This will make the system to initialize the Store Service and probably Store callbacks will start to be received after calling this method so you should have set your event handler before calling this method so don't lose any callback.
	* @function
	*/ 
	CocoonJS.Store.start = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "start", arguments);
		}
	};

	/**
	* This method allows you to check is the  Store service is available in this platform. 
	* Not all iOS and Android devices will have the Store service available so you should check if it is before calling any other method.
	* @function
	* @return {boolean} True if the service is available and false otherwise.
	*/ 
	CocoonJS.Store.canPurchase = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "canPurchase", arguments);
		}
	};

	/**
	* Fetches the products from the CocoonJS Cloud Compiling service store configuration. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @deprecated You should now use fetchProductsFromStore. We don't support cloud products now.
	* @function
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromServer = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromServer", arguments, true);
		}
	};

	/**
	* Fetches the products information from the Store. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @function
	* @param {array} productIds An array with the ids of the products to retrieve information from.
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromStore = function(productIds)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromStore", arguments, true);
		}
	};

	/**
	* Finish a purchase transaction and removes the transaction from the transaction queue. 
	* This method must be called after a purchase finishes successfully and the  {@link CocoonJS.Store.onProductPurchaseCompleted} callback has been received. 
	* If the purchase includes some asset to download from an external server this method must be called after the asset has been successfully downloaded. 
	* If you do not finish the transaction because the asset has not been correctly downloaded the {@link CocoonJS.Store.onProductPurchaseStarted} method will be called again later on.
	* @function
	* @param {string} transactionId The transactionId of the purchase to finish.
	*/ 
	CocoonJS.Store.finishPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "finishPurchase", arguments, true);
		}
	};

	/**
	* Consumes a purchase. This makes that product to be purchasable again. 
	* @function
	* @param {string} transactionId The transaction Id of the purchase to consume.
	* @param {string} productId The product Id of the product to be consumed.
	*/ 
	CocoonJS.Store.consumePurchase = function(transactionId, productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "consumePurchase", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeature", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id showing a modal progress dialog. 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.puchaseProductModal = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModal", arguments, true);
		}
	};

	/**
	* Request the purchase of a product given it's product id showing a dialog with a preview of the product (title and description). 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProductModalWithPreview = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModalWithPreview", arguments, true);
		}
	};

	/**
	* Returns if a product has been already purchased or not. 
	* @function
	* @param {string} productId The product id or alias of the product to be checked.
	* @returns {boolean} A flag that indicates whether the product has been already purchased (true) or not (false).
	*/
	CocoonJS.Store.isProductPurchased = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "isFeaturePurchased", arguments);
		}
	};

	/**
	* Restores all the purchases from the platform's market. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchases", arguments, true);
		}
	};

	/**
	* Restores all the purchases from the platform's market showing a modal progress dialog. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchasesModal = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchasesModal", arguments, true);
		}
	};

	/**
	* Returns all the products available to be purchased.
	* @function
	* @returns {array} An array with  all the {@link CocoonJS.Store.ProductInfo} objects available for purchase.
	*/
	CocoonJS.Store.getProducts = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getProducts", arguments);
		}
	};

	/**
	* Adds a product to the products local DB. 
	* @function
	* @param {CocoonJS.Store.ProductInfo} product The product to be added to the local products DB.
	*/
	CocoonJS.Store.addProduct = function(product)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addProduct", arguments);
		}
	};

	/**
	* Removes a product from the products local DB given its productId. 
	* @function
	* @param {string} productId The product or alias of the product to be removed from the local products DB.
	*/
	CocoonJS.Store.removeProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removeProduct", arguments);
		}
	};

	/**
	* Returns all the locally stored purchases.
	* @function
	* @returns {array} An array with all the {@link CocoonJS.Store.PurchaseInfo} completed purchases.
	*/
	CocoonJS.Store.getPurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getPurchases", arguments);
		}
	};

	/**
	* Adds a purchase to the local purchases DB. 
	* @function
	* @param {CocoonJS.Store.StorePurchase} purchase The purchase to be added.
	*/ 
	CocoonJS.Store.addPurchase = function(purchase)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addPurchase", arguments);
		}
	};

	/**
	* Removes a purchase from the local purchases DB given it's transaction id. 
	* @function
	* @param {string} transactionId The id of the transaction to be removed.
	*/ 
	CocoonJS.Store.removePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removePurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase cancel. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be canceled.
	*/
	CocoonJS.Store.cancelPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "cancelPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase refundment. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be refunded.
	*/
	CocoonJS.Store.refundPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "refundPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase expiration. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be expired.
	*/
	CocoonJS.Store.expirePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "expirePurchase", arguments);
		}
	};

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onProductsFetchStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchStarted");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has completed.
    * The callback function receives a parameter with an the valid products array.
    * @static
    * @event
    * @param {array} validProducts An array of {@link CocoonJS.Store.ProductInfo} objects representing all the valid fetched products.
    */
	CocoonJS.Store.onProductsFetchCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onProductsFetchFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product starts.
    * The callback function receives a parameters with the information of the purchased product @see CocoonJS.Store.ProductInfo.
    * @static
	* @event
    * @param {string} productId The product id of the product being purchased.
    */
	CocoonJS.Store.onProductPurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseStarted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a request for purchase verification has been received from the Store.
    * The callback function receives two parameters, one with the productId of the purchased product and another one with a JSON object containing the data to be verified.
    * In Andorid this JSON object will containt two keys: signedData and signature. You will need that information to verify the purchase against the backend server.
    * @static
    * @event
    * @param {string} productId The product id of the product to be verified.
    * @param {string} data The string with the data to be verified.
    */
	CocoonJS.Store.onProductPurchaseVerificationRequestReceived = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseVerificationRequestReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product succeeds.
    * The callback function receives as parameter the information of the purchase {@see CocoonJS.Store.PurchaseInfo}.
    * @static
    * @event
    * @param {CocoonJS.Store.PurchaseInfo} purchaseInfo The purchase info.
    */
	CocoonJS.Store.onProductPurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product fails.
    * The callback function receives a parameters with the product id and an error message.
    * @static
    * @event
    * @param {string} productId The product id.
    * @param {string} msg The error message.
    */
	CocoonJS.Store.onProductPurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has completed.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onRestorePurchasesFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesFailed");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has started.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase being consumed.
    */
	CocoonJS.Store.onConsumePurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has completed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the consumed purchase.
    */
	CocoonJS.Store.onConsumePurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has failed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase that couldn't be consumed.
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onConsumePurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseFailed");

})();

//////////////////////////////////////
// COCOONJS_SOCIAL.JS               //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

	/**
	* This type represents the access to a native Social extension API. As there can be more than
	* one service of this type, more than one instance can be created.
	* @namespace
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	*/
	CocoonJS.Social = function(nativeExtensionName, extensionName)
	{
		if (typeof nativeExtensionName !== 'string') throw "The given native extension name '" + nativeExtensionName + "' is not a string.";
		if (typeof extensionName !== 'string') throw "The given extension name '" + extensionName + "' is not a string.";

		this.nativeExtensionName = nativeExtensionName;
		this.extensionName = extensionName;
	    this.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[nativeExtensionName] !== 'undefined';

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestInitializationSucceed} event calls.
	     * @name OnRequestInitializationSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {object} initializationData The data structure passed when requestInitialization was called.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestInitializationSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
	    this.onRequestInitializationSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestInitializationSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestInitializationFailed} event calls.
	     * @name OnRequestInitializationFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {object} initializationData The data structure passed when the requestInitialization function was called.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestInitializationFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
	    this.onRequestInitializationFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestInitializationFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestLoginSucceed} event calls.
	     * @name OnRequestLoginSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.UserInfo} userInfo The structure that describes the information of the user that logged in.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user login request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestLoginSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestLoginSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestLoginSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestLoginFailed} event calls.
	     * @name OnRequestLoginFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user login request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestLoginFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestLoginFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestLoginFailed");

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user logs out.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onLogout = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLogout");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserInfoSucceed} event calls.
	     * @name OnRequestUserInfoSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.UserInfo} userInfo The structure that describes the information of the request user id.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnUserInfoRequestSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserInfoSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserInfoSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserInfoFailed} event calls.
	     * @name OnRequestUserInfoFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id used in the request.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnUserInfoRequestFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserInfoFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserInfoFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserImageURLSucceed} event calls.
	     * @name OnRequestUserImageURLSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id used in the request.
	     * @param {string} imageURL The URL of the image of the requested user. 
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user image URL request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserImageURLSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserImageURLSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserImageURLSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserImageURLFailed} event calls.
	     * @name OnRequestUserImageURLFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id of the user the request was placed for.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user image URL request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserImageURLFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserImageURLFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserImageURLFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserFriendsUserInfosSucceed} event calls.
	     * @name OnRequestUserFriendsUserInfosSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id of the user for whom the friend user infos where requested.
	     * @param {array} friendsInfo An array of {@link CocoonJS.Social.UserInfo} objects representing the information of the friends of the user.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's friends info is successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserFriendsUserInfosSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserFriendsUserInfosSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserFriendsUserInfosSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserFriendsUserInfosFailed} event calls.
	     * @name OnRequestUserFriendsUserInfosFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param 
	     * @param {string} userID The id of the user fro whom the friends infos were requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's friends info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserFriendsUserInfosFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserFriendsUserInfosFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserFriendsUserInfosFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestMessagePublicationSucceed} event calls.
	     * @name OnRequestMessagePublicationSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
 	     * @param {CocoonJS.Social.Message} message The message that has been published.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user message publication request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestMessagePublicationSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    * @param {CocoonJS.Social.Message} message The message that has been published.
	    */
		this.onRequestMessagePublicationSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestMessagePublicationSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestMessagePublicationFailed} event calls.
	     * @name OnRequestMessagePublicationFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.Message} message The message that was supposed to be published.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user message publication request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestMessagePublicationFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestMessagePublicationFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestMessagePublicationFailed");

		/**
        * @ignore
        */
        this.on= function(event, callback) {
            event= "on"+event[0].toUpperCase()+event.substr(1);
            var signal= this[event];
            if (signal) {
                signal.addEventListener(callback);
            } else {
                console.error("SocialGaming service: '"+this.extensionName+"' does not understand '"+event+' signal.');
            }

            return this;
        };

	    return this;
	};

	CocoonJS.Social.prototype = {
        userInfo : null,
        userInfoCocoonJS : null,

        /**
        * @ignore
        */
        getUserInfo : function() {
            return this.userInfo;
        },

        /**
        * Returns the information of the currently logged in user.
        * @return {@link CocoonJS.Social.UserInfo}
        */
        getLoggedInUserInfo : function() {
            if (this.nativeExtensionObjectAvailable) {
                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getLoggedInUserInfo", arguments);
            }
            else {
                return this.userInfoCocoonJS;
            }
        },

        /**
        * @ignore
        */
        setUserInfo : function( userInfo) {
            this.userInfo= userInfo;
        },

        /**
        * @ignore
        */
        setUserInfoCocoonJS : function( userInfoCocoonJS ) {
            this.userInfoCocoonJS = userInfoCocoonJS;
        },

		/**
        * Request initialization of the underlying social service.
        * @param {object} paramsObject A data structure to initialize the service. It will be dependable of the underlying service.
        * @see CocoonJS.Social.onRequestInitializationSucceed
        * @see CocoonJS.Social.onRequestInitializationFailed
        */
		requestInitialization : function(paramsObject) 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestInitialization", arguments, true);
			}
		},

		/**
        * Returns a flag to indicate if the underlying service has been initialized or not.
        * @return {boolean} If the underlying service had been initialized using the requestInitialization function call.
        */
		isInitialized : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "isInitialized", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Request to log in the social gaming application.
		* @see CocoonJS.Social.onRequestLoginSucceed
		* @see CocoonJS.Socual.onRequestLoginFailed
		*/
		requestLogin : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestLogin", arguments, true);
			}
		},

		/**
		* Request to log out of the social gaming application.
		* @see CocoonJS.Social.onRequestLoginSucceed
		* @see CocoonJS.Social.onRequestLoginFailed
		* @see CocoonJS.Social.onLogout
		*/
		requestLogout : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestLogout", arguments, true);
			}
		},

		/**
		* Check if the user is logged in.
		* @return {boolean} true if the user is still logged in, false otherwise.
		*/
		isLoggedIn : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "isLoggedIn", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Returns all the granted permissions for the current session.
		* @return {Array} An array containin the user granted permissions.
		*/
		getPermissions : function() 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getPermissions", arguments);
			}
			else
			{
				return new Array();
			}
		},

		/**
		* Check if the user has granted the publish permission for the current session.
		* @return {boolean} true if the user has granted the publish permission for the current session, false otherwise.
		*/
		hasPublishPermission : function() 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "hasPublishPermission", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Request to retrieve the current or a specific user's id. The request can be monitored using the {@link CocoonJS.Social.onUserInfoRequestSucceed} and {@link CocoonJS.Social.onUserInfoRequestFailed} event handlers.
		* @param {string} [userId] The id of the user to retireve the information from. If no userID is specified, the currently logged in user is assumed.
		* @see CocoonJS.Social.onRequestUserInfoSucceed
		* @see CocoonJS.Social.onRequestUserInfoFailed
		*/
		requestUserInfo : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserInfo", arguments, true);
			}
		},

		/**
		* Request to retrieve the Image of a user
		* @param {string} [userID] The id of the user to get the image for. If no userID is specified, the currently logged user is used.
		* @param {CocoonJS.Social.ImageSizeType} [imageSizeType] The size of the image. One of the possible values among the ones in the {@link CocoonJS.Social.ImageSizeType}. If no value is specified, SMALL is used.
		* @see CocoonJS.Social.onRequestUserImageURLSucceed;
		* @see CocoonJS.Social.onRequestUserImageURLFailed;
		*/
		requestUserImageURL : function( imageSizeType, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserImageURL", arguments, true);
			}
		},

		/**
		* Request for the information of all the friends of the currently logged user.
		* @param {string} [userID] The id of the user to get the friends infos for. If no userID is specified, the currently logged user is used.
		* @see CocoonJS.Social.onRequestUserFriendsUserInfosSucceed;
		* @see CocoonJS.Social.onRequestUserFriendsUserInfosFailed;
		*/
		requestUserFriendsUserInfos : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserFriendsUserInfos", arguments, true);
			}
		},

		/**
		* Request the publication of a message using a dialog.
		* @param {CocoonJS.Social.Message} message A object representing the information to be published.
		* @see CocoonJS.Social.onRequestMessagePublicationSucceed
		* @see CocoonJS.Social.onRequestMessagePublicationFailed
		*/
		requestMessagePublicationWithDialog : function(message)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestMessagePublicationWithDialog", arguments, true);
			}
		}
	};

	/**
	* This structure represents the possible images to be obtained for a user in the social gaming extension.
	* @namespace
	*/
	CocoonJS.Social.ImageSizeType = 
	{
		/**
		* Represent a thumbnail like image size.
		*/
	    THUMB : "thumb",

		/**
		* Represents the small image size.
		*/
	    SMALL : "small",

		/**
		* Represents the medium image size.
		*/
	    MEDIUM : "medium",

		/**
		* Represents the large image size.
		*/
	    LARGE : "large"
	};

	/**
	* The data structure that represents the information of a user inside the social gaming extension.
	* @namespace
	* @constructor
	* @param {string} userID The id of the user.
	* @param {string} userName The user name of the user.
	*/
	CocoonJS.Social.UserInfo = function(userID, userName)
	{
		/**
		* The id of the user.
		* @field
		* @type string
		*/
		this.userID = userID;

		/**
		* The user name of the user.
		* @field
		* @type string
		*/
		this.userName = userName;
	};

	/**
	* This type represents a message to be published.
	* @namespace
	* @constructor
	* @param {string} message The message to be published.
	* @param {string} mediaURL An URL to a media (image, video, ...)
	* @param {string} linkURL An URL to add to the message so the user can click on that link to get more information.
	* @param {string} linkText The text that will appear in the message link.
	* @param {string} linkCaption The text caption that will appear in the message link.
	*/
	CocoonJS.Social.Message = function(message, mediaURL, linkURL, linkText, linkCaption)
	{
		/**
		* The message to be published.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* An URL to a media (image, video, ...)
		* @field
		* @type string
		*/
		this.mediaURL = mediaURL;

		/**
		* An URL to add to the message so the user can click on that link to get more information.
		* @field
		* @type string
		*/
		this.linkURL = linkURL;

		/**
		* The text that will appear in the message link.
		* @field
		* @type string
		*/
		this.linkText = linkText;

		/**
		* The text caption that will appear in the message link.
		* @field
		* @type string
		*/
		this.linkCaption = linkCaption;

		return this;
	};

})();

//////////////////////////////////////
// COCOONJS_SOCIALGAMING.JS         //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    if (!CocoonJS.Social)
		throw("The CocoonJS.Social object must exist and be valid before creating any extension object.");

	/**
	* This type represents the access to a native Social Gamming extension API. As there can be more than
	* one service of this type, more than one instance can be created.
	* @namespace
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	*/
	CocoonJS.SocialGaming = function(nativeExtensionName, extensionName)
	{
		CocoonJS.SocialGaming.superclass.constructor.call(this, nativeExtensionName, extensionName);

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAndFriendsScoresSucceed} event calls.
	     * @name OnRequestUserAndFriendsScoresSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {array} userAndFriendsScoreInfos An array of {@link CocoonJS.SocialGaming.UserScoreInfo} objects representing the information of the user's and friends' scores.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user and friends scores request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAndFriendsScoresSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAndFriendsScoresSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAndFriendsScoresSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAndFriendsScoresFailed} event calls.
	     * @name OnRequestUserAndFriendsScoresFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score and friends scores were requested.
	     * @param {string} leadeboardID The id of the leaderboard for whom the score and friends scores were requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user and his/her friends scores request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAndFriendsScoresFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAndFriendsScoresFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAndFriendsScoresFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserScoreSucceed} event calls.
	     * @name OnRequestUserScoreSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {CocoonJS.SocialGaming.UserScoreInfo} userScoreInfo The info of the user's score.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserScoreSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserScoreSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserScoreSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserScoreFailed} event calls.
	     * @name OnRequestUserScoreFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score was requested.
	     * @param {string} leaderboardID The id of the leaderboard for whom the score was requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserScoreFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserScoreFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserScoreFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserScoreSucceed} event calls.
	     * @name OnSubmitUserScoreSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score has been submitted.
	     * @param {string} leaderboardID The id of the leaderboard for which the score has been submitted.
	     * @param {number} score The score that has been submitted.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score submit suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserScoreSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserScoreSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserScoreSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserScoreFailed} event calls.
	     * @name OnSubmitUserScoreFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score submition was requested.
	     * @param {string} leaderboadID The id of the leaderboard for which the score submition was requested.
	     * @param {number} score The score that was submitted and failed.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score submit fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserScoreFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserScoreFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserScoreFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAchievementsSucceed} event calls.
	     * @name OnRequestUserAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements where requested.
	     * @param {array} achievementsInfos An array of {@link CocoonJS.SocialGaming.AchievementInfo} objects representing the information of the user's achievements.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievements info are successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAchievementsFailed} event calls.
	     * @name OnRequestUserAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements were requested.
	   	 * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievmeents info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAchievementsFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAllAchievementsSucceed} event calls.
	     * @name OnRequestAllAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {array} achievementsInfos An array of {@link CocoonJS.SocialGaming.AchievementInfo} objects representing the information of all the achievements.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievements info are successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAllAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAllAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAllAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAllAchievementsFailed} event calls.
	     * @name OnRequestAllAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	   	 * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievmeents info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAllAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAllAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAllAchievementsFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAchievementInfoSucceed} event calls.
	     * @name OnRequestAchievementInfoSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {CocoonJS.SocialGaming.AchievementInfo} achievementInfo A {@link CocoonJS.SocialGaming.AchievementInfo} object representing the information of the achievement.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the request to retrieve the information of an achievement succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAchievementInfoSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAchievementInfoSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAchievementInfoSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAchievementInfoFailed} event calls.
	     * @name OnRequestAchievementInfoFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} achievementID The id of the achievement for which the information retrieval was requested.
	     * @param {string} errorMessage The error message.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the request to retrieve the information of an achievement fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAchievementInfoFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAchievementInfoFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAchievementInfoFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserAchievementSucceed} event calls.
	     * @name OnSubmitUserAchievementSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievement has been submitted.
	     * @param {string} achievementID The id of the achievement that has been submitted.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement submition succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserAchievementSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserAchievementSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserAchievementSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserAchievementFailed} event calls.
	     * @name OnSubmitUserAchievementFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievment was submitted.
	     * @param {string} achievementID The id of the achievement that was submitted.
	     * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement submition fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserAchievementFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserAchievementFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserAchievementFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onResetUserAchievementsSucceed} event calls.
	     * @name OnResetUserAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements were reset.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnResetUserAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onResetUserAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onResetUserAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onResetUserAchievementsFailed} event calls.
	     * @name OnResetUserAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements where tried to be reset.
	     * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnResetUserAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onResetUserAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onResetUserAchievementsFailed");

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the users closes the achievements view.
	    * The callback function does not receive any parameter.
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewClosed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewClosed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onAchievementsViewFailed} event calls.
	     * @name OnAchievementsViewFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} errorMessage The message that describes why the call failed.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the achievements view failed to show.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnAchievementsViewFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewFailed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewFailed");

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when achievements view shows successfully.
	    * The callback function does not receive any parameter.
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewClosed} event calls.
	     * @name OnLeaderboardViewClosedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewClosedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewClosed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewClosed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewFailed} event calls.
	     * @name OnLeaderboardViewFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewFailed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewSucceed} event calls.
	     * @name OnLeaderboardViewSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewSucceed");

		return this;
	};

	CocoonJS.SocialGaming.prototype = 
	{
        abstractToSocialGamingAchievementMap : null,
        abstractToSocialGamingAchievementMapInverse : null,

        /**
        * @ignore
        */
        setAbstractToSocialGamingAchievementMap : function( map ) {
            this.abstractToSocialGamingAchievementMap= map;

            // build a reciprocal map.
            this.abstractToSocialGamingAchievementMapInverse= {};
            for( var id in map ) {
                if ( map.hasOwnProperty(id) ) {
                    this.abstractToSocialGamingAchievementMapInverse[ map[id] ]= id;
                }
            }
            return this;
        },

        /**
        * @ignore
        */
        getAbstractToSocialGamingAchievementTranslation : function( achievementID ) {
            /**
             * If a translation map for abstract in-game achievements has been set, translate achievementID from
             * abstract to SocialGamingService.
             */
            if (this.abstractToSocialGamingAchievementMap) {
                var socialGamingAchievementID = this.abstractToSocialGamingAchievementMap[achievementID];
                if (socialGamingAchievementID) {
                    console.log("Abstract achieventID='" + achievementID + "' turned to '" + socialGamingAchievementID + "'");
                    achievementID = socialGamingAchievementID;
                } else {
                    console.log("Something may be wrong: abstract achievementID: '" + achievementID + "' w/o translation.")
                }
            }

            return achievementID;
        },

		/**
		* Request to retrieve the scores of all friends of a given user.
		* @param {string} [leaderboardID] The id of the leaderboard to request the scores for.
		* @param {string} [userID] The id of the user. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onRequestUserAndFriendsScoresSucceed
		* @see CocoonJS.SocialGaming.onRequestUserAndFriendsScoresFailed
		*/
		requestUserAndFriendsScores : function(leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserAndFriendsScores", arguments, true);
			}
		},

		/**
		* Request to retrieve the score of a user.
		* @param {string} [leaderboardID] The id of the scores leaderboard to retireve the score from. If null or underfined is passed, the "leadeboard" id will be used.
		* @param {string} [userID] The id of the user to retireve the score from. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onRequestUserScoreSucceed
		* @see CocoonJS.SocualGaming.onRequestUserScoreFailed
		*/
		requestUserScore : function(leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserScore", arguments, true);
			}
		},

		/**
		* Request to the server the score of a user.
		* @param {number} [score] the score to submit
		* @param {string} [leaderboardID] The id of the scores leaderboard to submit the score to. If null or underfined is passed, the "leadeboard" id will be used.
		* @param {string} [userID] The id of the user to submit the score for. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onSubmitUserScoreSucceed
		* @see CocoonJS.SocualGaming.onSubmitUserScoreFailed
		*/
		submitUserScore : function(score, leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitUserScore", arguments, true);
			}
		},
		/**
		* Shows the leaderboard using a platform dependant view.
		* @param {string} [leaderboardID] The id of the scores leaderboard to show the view for. If null or underfined is passed, the "leadeboard" id will be used.
		* @see CocoonJS.SocialGaming.onLeaderboardViewClosed
		*/
		showLeaderboardView : function(leaderboardID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showLeaderboardView", arguments, true);
			}
		},

		/**
		* Request to retrieve the user achievements. The request can be monitored using the {@link CocoonJS.SocialGaming.onRequestUserAchievementsSucceed} and {@link CocoonJS.Social.onRequestUserAchievementsFailed} event handlers.
		* @param {string} [userID] The id of the user to retireve the achievements from. if null/undefined/"" is specified, the currently logged in user is assumed.
		* @see CocoonJS.SocialGaming.onRequestUserAchievementsSucceed
		* @see CocoonJS.SocialGaming.onRequestUserAchievementsFailed
		*/
		requestUserAchievements : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserAchievements", arguments, true);
			}
		},

		/**
		* Request to retrieve all the achievements. The request can be monitored using the {@link CocoonJS.SocialGaming.onRequestAllAchievementsSucceed} and {@link CocoonJS.Social.onRequestAllAchievementsFailed} event handlers.
		* @see CocoonJS.SocialGaming.onRequestAllAchievementsSucceed
		* @see CocoonJS.SocialGaming.onRequestAllAchievementsFailed
		*/
		requestAllAchievements : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestAllAchievements", arguments, true);
			}
		},

		/**
		* Request to retrieve the information about an achievement. 
		* @param {string} achievementID The id of the achievement to get the information for.
		* @param {CocoonJS.Social.ImageSizeType} [imageSizeType] The size of the image. One of the possible values among the ones in the {@link CocoonJS.Social.ImageSizeType}
		*/
		requestAchievementInfo : function(achievementID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestAchievementInfo", arguments, true);
			}
		},

		/**
		* Submits an achievement to the server. If the process fails, the achievement is stored to submit it later.
		* @param {string} [achievementID] the achievement identifier
		* @param {number} [percentComplete] an optional number between 0 and 100 that indicates a completion percentage.
		* @see CocoonJS.SocialGaming.onSubmitAchievementSucceed
		* @see CocoonJS.SocualGaming.onSubmitAchievementFailed
		*/
        submitUserAchievement:function (achievementID, userID) {
            achievementID = this.getAbstractToSocialGamingAchievementTranslation(achievementID);

            if (this.nativeExtensionObjectAvailable) {
                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitUserAchievement", arguments, true);
            }
        },

		/**
		* Shows the achievements using a platform dependant view.
		* @see CocoonJS.SocialGaming.onAchievementsViewClosed
		*/
		showUserAchievementsView : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showUserAchievementsView", arguments, true);
			}
		},

		/**
		* Resets all the achievements of the current user
		* @param {string} [userID] The id of the user to reset the achievements for. If null/undefined/"", the logged in user is assumed.
		* @see CocoonJS.SocialGaming.onResetAchievementsSucceed
		* @see CocoonJS.SocualGaming.onResetAchievementsFailed
		*/
		resetUserAchievements : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "resetUserAchievements", arguments, true);
			}
		}
	};

	/**
    * @ignore
    */
	CocoonJS.extend(CocoonJS.SocialGaming, CocoonJS.Social);

	/**
	* The data structure that represents the information of the user score in the application.
	* @namespace
	* @constructor
	* @param {string} userID The user id.
	* @param {number} score The score of the user.
	* @param {string} userName The name of the user.
	* @param {string} imageURL The url of the user image.
	* @param {number} leaderboardID The id of the leaderboard the score belongs to.
	*/
	CocoonJS.SocialGaming.UserScoreInfo = function(userID, score, userName, imageURL, leaderboardID)
	{
		/**
		* The user id. 
		* @type string
		*/
		this.userID = userID;

		/**
		* The score of the user.
		* @type number
		*/
		this.score = score ? score : 0;

		/**
		* The name of the user.
		* @type string
		*/
        this.userName = userName;

		/**
		* The url of the user image.
		* @type string
		*/
        this.imageURL = imageURL;

        /**
		* The id of the leaderboard the score belongs to.
		* @type number
		*/
        this.leaderboardID = leaderboardID;
	};

	/**
	* The data structure that represents the information of an achievement in the application.
	* @namespace
	* @constructor
	* @param {string} achievementID The id of the achievement info.
	* @param {string} title The title of the achievement.
	* @param {string} description The description of the achievement.
	* @param {string} imageURL The url to the image representing the achievement.
	* @param {number} points The points value of the achievement
	*/
	CocoonJS.SocialGaming.AchievementInfo = function(achievementID, title, description, imageURL, points)
	{
		/**
		* The id of the achievement info.
		* @type string
		*/
		this.achievementID = achievementID;

		/**
		* The title of the achievement.
		* @type string
		*/
		this.title = title;

		/**
		* The description of the achievement.
		* @type string
		*/
		this.description = description;

		/**
		* The url to the image representing the achievement.
		* @type string
		*/
		this.imageURL = imageURL;

		/**
		* The points value of the achievement
		* @type number
		*/
		this.points = points ? points : 0;
	};

})();

/////////////////////////////////////////
// COCOONJS_SOCIALGAMING_GAMECENTER.JS //
/////////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (typeof window.CocoonJS.SocialGaming === 'undefined' || window.CocoonJS === null) throw("The CocoonJS.SocialGaming object must exist and be valid before creating a Game Center extension object.");

	/**
	* This instance represents the extension object to access GameCenter related native functionalities.
	* The data structure for initialization: None.
	* @see CocoonJS.Social
	*/
	CocoonJS.SocialGaming.GameCenter = new CocoonJS.SocialGaming("IDTK_SRV_SOCIAL_GAMECENTER", "SocialGaming.GameCenter");
})();

//////////////////////////////
// COCOONJS_GAMEPAD.JS 		//
//////////////////////////////

(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents the functionalities related to OUYA android gaming control.
     * @namespace
     */
    CocoonJS.Gamepad = {};

    CocoonJS.Gamepad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.Gamepad !== 'undefined';

    CocoonJS.Gamepad.Indices = {
        BUTTON_0                : 0, 
        BUTTON_1                : 1,
        BUTTON_2                : 2,
        BUTTON_3                : 3,
        BUTTON_LEFT_BUMPER      : 4,
        BUTTON_RIGHT_BUMPER     : 5,
        
        BUTTON_LEFT_TRIGGER     : 6,
        BUTTON_RIGHT_TRIGGER    : 7,
        
        BUTTON_LEFT_JOYSTICK    : 10,
        BUTTON_RIGHT_JOYSTICK   : 11,
        BUTTON_DPAD_UP          : 12,
        BUTTON_DPAD_DOWN        : 13,
        BUTTON_DPAD_LEFT        : 14,
        BUTTON_DPAD_RIGHT       : 15,
        
        AXE_LEFT_JOYSTICK_X     : 0,
        AXE_LEFT_JOYSTICK_Y     : 1,
        AXE_RIGHT_JOYSTICK_X    : 2,
        AXE_RIGHT_JOYSTICK_Y    : 3
    };

    // If the extension is present and the navigator does not provide the gamepad API:
    // 1.- Add the getGamepads function to the navigator object.
    // 2.- Replace the window add and remove event listener functions to call to the extension for the gamepad related events.
    var systemSupportsGamepads = navigator["getGamepads"] || navigator["webkitGetGamepads"];
    if (CocoonJS.Gamepad.nativeExtensionObjectAvailable && !systemSupportsGamepads)
    {
        navigator.getGamepads = function()
        {
            return window.ext.Gamepad.makeCall("getGamepads");
        };

        CocoonJS.Gamepad.originalWindowAddEventListener = window.addEventListener;
        CocoonJS.Gamepad.originalWindowRemoveEventListener = window.removeEventListener;

        window.addEventListener = function(eventName, callback)
        {
            console.log("The new window.addEventListener has been called.");
            if (eventName === "gamepadconnected" || eventName === "gamepaddisconnected")
            {
                window.ext.Gamepad.addEventListener(eventName, callback);
            }
            else
            {
                var argumentsArray = Array.prototype.slice.call(arguments);
                CocoonJS.Gamepad.originalWindowAddEventListener.apply(window, argumentsArray);
            }
        };
        window.removeEventListener = function(eventName, callback)
        {
            console.log("The new window.removeEventListener has been called.");
            if (eventName === "gamepadconnected" || eventName === "gamepaddisconnected")
            {
                window.ext.Gamepad.removeEventListener(eventName, callback);
            }
            else
            {
                var argumentsArray = Array.prototype.slice.call(arguments);
                CocoonJS.Gamepad.originalWindowRemoveEventListener.apply(window, argumentsArray);
            }
        };
    }
})();

//////////////////////////////
// COCOONJS_NOTIFICATION.JS //
//////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS Notification extension.
    * @namespace
    */
    CocoonJS.Notification = {};

    CocoonJS.Notification.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_NOTIFICATION !== 'undefined';

	/**
	* The data structure that represents the information of a local notification.
	* @namespace
	* @constructor
	* @param {string} message The notification message.
	* @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
	* @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
	* @param {object} userData The JSON data to attached to the notification.
	* @param {string} contentBody The body content to be showed in the expanded notification information.
	* @param {string} contentTitle The title to be showed in the expanded notification information.
	* @param {number} date Time in millisecs from 1970 when the notification will be fired.
	*/
	CocoonJS.Notification.LocalNotification = function(message, soundEnabled, badgeNumber, userData, contentBody, contentTitle, scheduleTime)
	{
		/**
		* The notification message.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* A flag that indicates if the sound should be enabled for the notification.
		* @field
		* @type boolean
		*/
		this.soundEnabled = soundEnabled;

		/**
		* (iOS only) The number that will appear in the badge of the application icon in the home screen.
		* @field
		* @type number
		*/
		this.badgeNumber = badgeNumber;

		/**
		* The JSON data to attached to the notification.
		* @field
		* @type object
		*/
		this.userData = userData;

		/**
		* (Android only) The body content to be showed in the expanded notification information.
		* @field
		* @type string
		*/
		if (contentBody !== undefined)
			this.contentBody = contentBody;
		else
			this.contentBody = "";

		/**
		* (Android only) The title to be showed in the expanded notification information.
		* @field
		* @type string
		*/
		if (contentTitle !== undefined)
			this.contentTitle = contentTitle;
		else
			this.contentTitle = "";

		/**
		* Time in millisecs from 1970 when the local notification will be fired
		* @field
		* @type number
		*/
		var currentTime = new Date().getTime();
		if (scheduleTime !== undefined){
			this.scheduleTime = scheduleTime;
		}else{
			this.scheduleTime = currentTime;
		}
	};

	/**
	* The data structure that represents the information of a push notification.
	* @namespace
	* @constructor
	* @param {string} message The notification message.
	* @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
	* @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
	* @param {object} userData The JSON data to attached to the notification.
	* @param {array} channels An array containing the channels names this notification will be delivered to.
	* @param {number} expirationTime A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
	* @param {number} expirationTimeInterval An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
	*/
	CocoonJS.Notification.PushNotification = function(message, soundEnabled, badgeNumber, userData, channels, expirationTime, expirationTimeInterval)
	{
		/**
		* The notification message.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* A flag that indicates if the sound should be enabled for the notification.
		* @field
		* @type boolean
		*/
		this.soundEnabled = soundEnabled;

		/**
		* The number that will appear in the badge of the application icon in the home screen.
		* @field
		* @type number
		*/
		this.badgeNumber = badgeNumber;

		/**
		* The JSON data to attached to the notification.
		* @field
		* @type object
		*/
		this.userData = userData

		/**
		* An array containing the channels names this notification will be delivered to.
		* @field
		* @type array
		*/
		this.channels = channels;

		/**
		* A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
		* @field
		* @type number
		*/
		if (expirationTime !== undefined)
			this.expirationTime = expirationTime;
		else
			this.expirationTime = 0;

		/**
		* An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
		* @field
		* @type number
		*/
		if (expirationTimeInterval !== undefined)
			this.expirationTimeInterval = expirationTimeInterval;
		else
			this.expirationTimeInterval = 0;
	};

	/**
	* Start processing received notifications. The user must call this method when the game is ready to process notifications. Notifications received before being prepared are stored and processed later.
	*/
	CocoonJS.Notification.start = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "start", arguments, true);
		}
	};


	/**
	* Register to be able to receive push notifications.
	* The registration process is controlled using the {@link CocoonJS.Notification.onRegisterForPushNotificationsSucceed} and {@link CocoonJS.Notification.onRegisterForPushNotificationsFailed} event handlers.
	* @function
	* @see {CocoonJS.Notification.onRegisterForPushNotificationsSucceed}
	* @see {CocoonJS.Notification.onRegisterForPushNotificationsFailed}
	*/
	CocoonJS.Notification.registerForPushNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "registerForPushNotifications", arguments, true);
		}
	};

	/**
	* Unregister from receiving push notifications.
	* The unregistration process is controlled using the {@link CocoonJS.Notification.onUnregisterForPushNotificationsSucceed} event handler.
	* @function
	* @see CocoonJS.Notification.onUnregisterForPushNotificationsSucceed
	*/
	CocoonJS.Notification.unregisterForPushNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unregisterForPushNotifications", arguments, true);
		}
	};

	/**
	* Cancel the last sent local notification.
	* The last sent local notification will be remove from the notifications bar.
	* @function
	*/
	CocoonJS.Notification.cancelLastSentLocalNotificiation = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelLocalNotification", arguments, true);
		}
	};

	/**
	* Cancel all sent local notifications.
	* All the notifications will ve removed from the notifications bar.
	* @function
	*/
	CocoonJS.Notification.cancelAllLocalNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelAllLocalNotifications", arguments, true);
		}
	};

	/**
	* Send a local notification.
	* @function
	* @param {CocoonJS.Notification.LocalNotification} localNotification The local notification to be sent.
	*/
	CocoonJS.Notification.sendLocalNotification = function(localNotification)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendLocalNotification", arguments, true);
		}
	};

	/**
	* Subscribe to a channel in order to receive notifications targeted to that channel.
	* @function
	* @param {string} channel The channel id to subscribe to.
	*/
	CocoonJS.Notification.subscribeToChannel = function(channel)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "subscribe", arguments, true);
		}
	};

	/**
	* Unsubscribe from a channel in order to stop receiving notifications targeted to it.
	* @function
	* @param {string} channel The channel id to unsubscribe from.
	*/
	CocoonJS.Notification.unsubscribeFromChannel = function(channel)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unsubscribe", arguments, true);
		}
	};

	/**
	* Send a push notification.
	* @function
	* @param {CocoonJS.Notification.PushNotification} pushNotification The push notification object to be sent.
	* @see CocoonJS.Notification.onPushNotificationDeliverySucceed
	* @see CocoonJS.Notification.onPushNotificationDeliveryFailed
	*/
	CocoonJS.Notification.sendPushNotification = function(pushNotification)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendPushNotification", arguments, true);
		}
	};

	/**
	* (iOS only) Set the badge number for this application.
	* This is useful if you want to modify the badge number set by a notification.
	* @function
	* @param {number} badgeNumber The number of the badge.
	*/
	CocoonJS.Notification.setBadgeNumber = function(badgeNumber)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "setBadgeNumber", arguments);
		}
	};

	/**
	* (iOS only) Returns the current badge number.
	* @function
	* @returns {number} The badge number.
	*/
	CocoonJS.Notification.getBadgeNumber = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getBadgeNumber", arguments);
		}
	};

	/**
	* Returns the last received user data from a Local notification.
	* @function
	* @returns {object} The last received user data from a Local notification.
	*/
	CocoonJS.Notification.getLastReceivedLocalNotificationData = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedLocalNotificationData", arguments);
		}
	};

	/**
	* Returns the last received user data from a Push notification.
	* @function
	* @returns {object} The last received user data from a Push notification.
	*/
	CocoonJS.Notification.getLastReceivedPushNotificationData = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedPushNotificationData", arguments);
		}
	};

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notification succeeds.
    * The callback function does not receive any parameter.
    * @static
    * @event
    * @param {string} token The token (apid or device token) received at registration time.
    * @memberOf CocoonJS.Notification
    */
	CocoonJS.Notification.onRegisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceRegistered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the unregistration for push notifications succeeds.
    * The callback function does not receive any parameter.
    * @static
    * @event
    * @memberOf CocoonJS.Notification
    */
	CocoonJS.Notification.onUnregisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceUnregistered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notifications fails.
    * The callback function receives a parameter with error information.
    * @static
    * @event
    * @param {string} msg The error message.
    */
	CocoonJS.Notification.onRegisterForPushNotificationsFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceFailedToRegister");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a push notification is received.
    * The callback function receives a parameter with the userData of the received notification.
    * @static
    * @event
    * @param {object} userData An object with the notification userData information.
    */
	CocoonJS.Notification.onPushNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a local notification is received.
    * The callback function receives a parameter with the userData of the received notification.
    * @static
    * @event
    * @param {object} userData An object with the notification userData information.
    */
	CocoonJS.Notification.onLocalNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "localNotificationReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a notification is successfully delivered.
    * The callback function receives a parameter with the notificationId of the delivered notification.
    * @static
    * @event
    * @param {string} userData A string with the notification userData information.
    */
	CocoonJS.Notification.onPushNotificationDeliverySucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationSuccessfullyDelivered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the delivery of push a notification fails.
    * The callback function receives a parameter with error information.
    * @static
    * @event
    * @param {string} msg The error message.
    */
	CocoonJS.Notification.onPushNotificationDeliveryFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationDeliveryError");

})();

/////////////////
// PATHFIND.JS //
/////////////////

// Pathfind.js
// Written by Ashley Gullen
// Copyright (c) 2013 Scirra Ltd.

// A* pathfinding javascript implementation

(function() {
	
	var PF_CLEAR = 0;
	var PF_OBSTACLE = 32767;
	
	function node()
	{
		this.parent = null;
		
		this.x = 0;
		this.y = 0;

		this.f = 0;
		this.g = 0;
		this.h = 0;
	};
	
	var nodeCache = [];			// for recycling nodes
	
	function allocNode()
	{
		var ret;
		
		if (nodeCache.length)
			ret = nodeCache.pop();
		else
			ret = new node();
			
		ret.parent = null;
		ret.x = 0;
		ret.y = 0;
		ret.f = 0;
		ret.g = 0;
		ret.h = 0;
		return ret;
	};
	
	function freeNode(n)
	{
		if (nodeCache.length < 64000)
			nodeCache.push(n);
	};
	
	function resultNode(x_, y_)
	{
		this.x = x_ || 0;
		this.y = y_ || 0;
	};
	
	var resultNodeCache = [];			// for recycling resultNodes
	
	function allocResultNode()
	{
		if (resultNodeCache.length)
			return resultNodeCache.pop();
		else
			return new resultNode(0, 0);
	};
	
	function freeResultNode(n)
	{
		if (resultNodeCache.length < 10000)
			resultNodeCache.push(n);
	};
	
	var workersSupported = (typeof Worker !== "undefined");
	var isInWebWorker = (typeof document === "undefined");		// no DOM in a worker
	var myInstance = null;										// single pathfinder instance for worker
	
	if (isInWebWorker)
	{
		self.addEventListener("message", function (e)
		{
			var d = e.data;
			
			if (!d)
				return;		// could be empty postMessage() to start worker
			
			if (d.cmd === "init")
			{
				if (!myInstance)
					myInstance = new pathfinder();
					
				myInstance.init(d.hcells, d.vcells, d.data, d.diagonals);
			}
			else if (d.cmd === "find")
			{
				// receive a pathfind job, process it them dispatch result
				myInstance.pathEnd.parent = null;
				myInstance.targetX = d.endX;
				myInstance.targetY = d.endY;
				
				if (myInstance.doLongFindPath(d.startX, d.startY))
				{
					self.postMessage({ cmd: "result", pathList: myInstance.pathList });
				}
				else
				{
					self.postMessage({ cmd: "result", pathList: null });
				}
			}
			else if (d.cmd === "setdiag")
			{
				// update diagonalsEnabled flag
				myInstance.diagonalsEnabled = d.diagonals;
			}
			
		}, false);
	}
	
	function pathfinder()
	{
		this.hcells = 0;
		this.vcells = 0;
		
		this.pathEnd = allocNode();
		
		this.cells = null;
		this.openList = [];
		this.closedList = [];
		this.closedCache = {};
		this.pathList = [];
		
		this.currentNode = null;
		this.targetX = 0;
		this.targetY = 0;
		this.diagonalsEnabled = true;
		
		this.worker = null;
		this.workerQueue = [];		// jobs awaiting completion from worker in order of requests made
		this.workerRecycle = [];
		
		var self = this;
		var i, len;
		
		if (workersSupported && !isInWebWorker)
		{
			// Create worker and receive results of pathfind jobs from it
			this.worker = new Worker("pathfind.js");
			
			this.worker.addEventListener("message", function (e) {
			
				if (!e || !e.data)
					return;
				
				if (e.data.cmd === "result")
				{
					if (e.data.pathList)
					{
						for (i = 0, len = self.pathList.length; i < len; i++)
							freeResultNode(self.pathList[i]);
						
						self.pathList = e.data.pathList;
						self.workerQueue[0].success();
					}
					else
						self.workerQueue[0].fail();
						
					self.workerRecycle.push(self.workerQueue.shift());
				}
			}, false);
			
			this.worker.addEventListener("error", function (e) {
				console.error(e);
			}, false);
			
			this.worker.postMessage(null);
		}
	};
	
	pathfinder.prototype.init = function (hcells_, vcells_, data_, diagonals_)
	{
		this.hcells = hcells_;
		this.vcells = vcells_;
		this.cells = data_;
		this.diagonalsEnabled = diagonals_;
		
		if (workersSupported && !isInWebWorker)
		{
			this.worker.postMessage({
				cmd: "init",
				hcells: hcells_,
				vcells: vcells_,
				diagonals: diagonals_,
				data: data_
			});
		}
	};
	
	pathfinder.prototype.isReady = function ()
	{
		return !!this.cells;
	};
	
	pathfinder.prototype.setDiagonals = function (d)
	{
		if (this.diagonalsEnabled === d)
			return;
		
		this.diagonalsEnabled = d;
		
		if (workersSupported && !isInWebWorker)
		{
			this.worker.postMessage({
				cmd: "setdiag",
				diagonals: d,
			});
		}
	};
	
	pathfinder.prototype.at = function (x_, y_)
	{
		if (x_ < 0 || y_ < 0 || x_ >= this.hcells || y_ >= this.vcells)
			return PF_OBSTACLE;
			
		return this.cells[x_][y_];
	};
	
	pathfinder.prototype.findPath = function (startX, startY, endX, endY, successCallback, failCallback)
	{
		if (!this.cells)
		{
			// not yet initialised
			failCallback();
			return;
		}
		
		startX = Math.floor(startX);
		startY = Math.floor(startY);
		endX = Math.floor(endX);
		endY = Math.floor(endY);
		
		this.targetX = endX;
		this.targetY = endY;
		this.pathEnd.parent = null;
		
		// Check the box made by the start and dest cells.
		// If the complete box is empty, allow a direct move to target.
		var minX = Math.min(startX, endX);
		var maxX = Math.max(startX, endX);
		var minY = Math.min(startY, endY);
		var maxY = Math.max(startY, endY);
		
		// Path goes out of bounds: no calculable path
		if (minX < 0 || minY < 0 || maxX >= this.hcells || maxY >= this.vcells)
		{
			failCallback();
			return;
		}
		
		var x, y, i, len, c, h, n;

		if (this.diagonalsEnabled)
		{
			var canMoveDirect = true;
			
			for (x = minX; x <= maxX; x++)
			{
				for (y = minY; y <= maxY; y++)
				{
					if (this.cells[x][y] !== 0)
					{
						canMoveDirect = false;
						
						// Break both loops
						x = maxX + 1;
						break;
					}
				}
			}

			// A "direct" path is available (box is empty)
			if (canMoveDirect)
			{
				for (i = 0, len = this.pathList.length; i < len; i++)
					freeResultNode(this.pathList[i]);
				this.pathList.length = 0;
			
				this.pathEnd.x = endX;
				this.pathEnd.y = endY;
				this.pathEnd.parent = null;
				n = allocResultNode();
				n.x = endX;
				n.y = endY;
				this.pathList.push(n);
				successCallback();
				return;
			}
		}
		
		if (workersSupported)
		{
			// recycle objects in the worker queue
			if (this.workerRecycle.length)
				h = this.workerRecycle.pop();
			else
				h = {};
			
			h.success = successCallback;
			h.fail = failCallback;
			
			// dispatch the heavy lifting to the worker thread
			this.workerQueue.push(h);

			this.worker.postMessage({
				cmd: "find",
				startX: startX,
				startY: startY,
				endX: endX,
				endY: endY
			});
		}
		else
		{
			// no web worker support, just run on main thread
			if (this.doLongFindPath(startX, startY))
				successCallback();
			else
				failCallback();
		}
	};
		
	pathfinder.prototype.doLongFindPath = function (startX, startY)
	{
		var i, len, c, n, p, lastDir = 8, curDir = -1, addNode;
		for (i = 0, len = this.openList.length; i < len; i++)
			freeNode(this.openList[i]);
		for (i = 0, len = this.closedList.length; i < len; i++)
			freeNode(this.closedList[i]);
		for (i = 0, len = this.pathList.length; i < len; i++)
			freeResultNode(this.pathList[i]);
		this.openList.length = 0;
		this.closedList.length = 0;
		this.closedCache = {};
		this.pathList.length = 0;

		// Add the start node to the open list
		var startNode = allocNode();
		startNode.x = startX;
		startNode.y = startY;

		this.openList.push(startNode);
		var obsLeft = false, obsTop = false, obsRight = false, obsBottom = false;
		var diagonals = this.diagonalsEnabled;
		
		// While there are nodes on the open list
		while (this.openList.length)
		{
			// Move the best F value to closed list
			c = this.openList.shift();
			this.closedList.unshift(c);
			this.closedCache[((c.x << 16) + c.y).toString()] = true;

			// Are we there yet?
			if (c.x === this.targetX && c.y === this.targetY)
			{
				this.pathEnd.parent = c.parent;
				this.pathEnd.x = c.x;
				this.pathEnd.y = c.y;
				
				// Link up the whole path to an indexable array
				p = this.pathEnd;
				
				while (p)
				{
					// filter redundant nodes in straight lines
					if (this.pathList.length === 0)
					{
						addNode = true;
						
						if (p.parent)
						{
							lastDir = this.nodeDirection(p, p.parent);
							curDir = lastDir;
						}
					}
					else if (!p.parent)
						addNode = false;
					else 
					{
						curDir = this.nodeDirection(p, p.parent);
						addNode = (curDir !== lastDir);
					}
					
					if (addNode)
					{
						n = allocResultNode();
						n.x = p.x;
						n.y = p.y;
						this.pathList.unshift(n);
						lastDir = curDir;
					}
					
					p = p.parent;
				}
				
				return true;
			}

			// Get current node
			this.currentNode = c;
			var x = c.x;
			var y = c.y;
			
			var obsLeft = (this.at(x - 1, y) === PF_OBSTACLE);
			var obsTop = (this.at(x, y - 1) === PF_OBSTACLE);
			var obsRight = (this.at(x + 1, y) === PF_OBSTACLE);
			var obsBottom = (this.at(x, y + 1) === PF_OBSTACLE);

			// Check adjacent 8 nodes.  No diagonals allowed if either cell being crossed is obstacle.
			if (!obsLeft)
				this.addCellToOpenList(x - 1, y, 10);

			if (diagonals && !obsLeft && !obsTop)
				this.addCellToOpenList(x - 1, y - 1, 14);

			if (!obsTop)
				this.addCellToOpenList(x, y - 1, 10);

			if (diagonals && !obsTop && !obsRight)
				this.addCellToOpenList(x + 1, y - 1, 14);

			if (!obsRight)
				this.addCellToOpenList(x + 1, y, 10);

			if (diagonals && !obsRight && !obsBottom)
				this.addCellToOpenList(x + 1, y + 1, 14);

			if (!obsBottom)
				this.addCellToOpenList(x, y + 1, 10);

			if (diagonals && !obsBottom && !obsLeft)
				this.addCellToOpenList(x - 1, y + 1, 14);
		}
		
		return false;
	};
	
	pathfinder.prototype.insertToOpenList = function (c)
	{
		var i, len;
		
		// Needs to go at end
		if (c.f >= this.openList[this.openList.length - 1].f)
		{
			this.openList.push(c);
		}
		else
		{
			for (i = 0, len = this.openList.length; i < len; i++)
			{
				if (c.f < this.openList[i].f)
				{
					this.openList.splice(i, 0, c);
					break;
				}
			}
		}
	};
	
	pathfinder.prototype.addCellToOpenList = function (x_, y_, g_)
	{
		// Ignore if cell on closed list
		if (this.closedCache.hasOwnProperty(((x_ << 16) + y_).toString()))
			return;
		
		var i, len, c;
		
		// Cell costs can be increased by changing the number in the map
		var curCellCost = this.at(x_, y_);

		// Is this cell already on the open list?
		for (i = 0, len = this.openList.length; i < len; i++)
		{
			c = this.openList[i];
			
			if (x_ === c.x && y_ === c.y)
			{
				// Is this a better path?
				if (this.currentNode.g + g_ + curCellCost < c.g)
				{
					// Update F, G and H and update parent
					c.parent = this.currentNode;
					c.g = this.currentNode.g + g_ + curCellCost;
					c.h = this.estimateH(c.x, c.y);
					c.f = c.g + c.h;

					// This node's F has changed:  Delete it then re-insert it in the right place

					if (this.openList.length === 1)
					{
						// no need to remove then re-insert same node, just leave it there
						return;
					}
					
					this.openList.splice(i, 1);
					this.insertToOpenList(c);
				}

				return;
			}
		}

		// Not on the open list; add it in the right place
		c = allocNode();
		c.x = x_;
		c.y = y_;
		c.h = this.estimateH(x_, y_);
		c.g = this.currentNode.g + g_ + curCellCost;
		c.f = c.h + c.g;
		c.parent = this.currentNode;

		// Insert this node sorted in the open list
		// The loop below won't add new largest F values
		if (!this.openList.length)
		{
			this.openList.push(c);
			return;
		}
		
		this.insertToOpenList(c);
	};
	
	function quickAbs(x)
	{
		return x < 0 ? -x : x;
	};
	
	pathfinder.prototype.estimateH = function (x_, y_)
	{
		var dx = quickAbs(x_ - this.targetX);
		var dy = quickAbs(y_ - this.targetY);

		return dx * 10 + dy * 10;
	};
	
	pathfinder.prototype.nodeDirection = function (a, b)
	{
		var ax = a.x;
		var ay = a.y;
		var bx = b.x;
		var by = b.y;

		if (ax === bx)
		{
			if (by > ay) return 6;
			if (by < ay) return 2;
			if (ay == by) return 8;
		}
		else if (ay === by)
		{
			if (bx > ax) return 4;
			if (by < ax) return 0;
		}
		else
		{
			if (bx < ax && by < ay) return 1;
			if (bx > ax && by < ay) return 3;
			if (bx < ax && by > ay) return 7;
			if (bx > ax && by > ay) return 5;
		}
		return 8;
	};
	
	if (!isInWebWorker)
	{
		window.PF_CLEAR = PF_CLEAR;
		window.PF_OBSTACLE = PF_OBSTACLE;
		window.Pathfinder = pathfinder;
		
		window.ResultNode = resultNode;
		window.allocResultNode = allocResultNode;
		window.freeResultNode = freeResultNode;
	}

})();
(function() {
'use strict';var cr={plugins_:{},behaviors:{}};"function"!==typeof Object.getPrototypeOf&&(Object.getPrototypeOf="object"===typeof"test".__proto__?function(a){return a.__proto__}:function(a){return a.constructor.prototype});
(function(){function a(a,b){this.x=a;this.y=b;cr.seal(this)}function b(a,b,c,d){this.set(a,b,c,d);cr.seal(this)}function c(){this.bly=this.blx=this.bry=this.brx=this.try_=this.trx=this.tly=this.tlx=0;cr.seal(this)}function d(){this.items={};this.item_count=0;this.values_cache=[];this.cache_valid=!0;cr.seal(this)}function e(){this.sum=this.t=this.y=this.c=0;cr.seal(this)}function f(a){this.pts_cache=[];this.set_pts(a);cr.seal(this)}cr.logexport=function(a){window.console&&window.console.log&&window.console.log(a)};
cr.seal=function(a){return a};cr.freeze=function(a){return a};cr.is_undefined=function(a){return"undefined"===typeof a};cr.is_number=function(a){return"number"===typeof a};cr.is_string=function(a){return"string"===typeof a};cr.isPOT=function(a){return 0<a&&0===(a-1&a)};cr.abs=function(a){return 0>a?-a:a};cr.max=function(a,b){return a>b?a:b};cr.min=function(a,b){return a<b?a:b};cr.PI=Math.PI;cr.round=function(a){return a+0.5|0};cr.floor=function(a){return a|0};a.prototype.offset=function(a,b){this.x+=
a;this.y+=b;return this};a.prototype.mul=function(a,b){this.x*=a;this.y*=b;return this};cr.vector2=a;cr.segments_intersect=function(a,b,c,d,e,h,g,f){if(cr.max(a,c)<cr.min(e,g)||cr.min(a,c)>cr.max(e,g)||cr.max(b,d)<cr.min(h,f)||cr.min(b,d)>cr.max(h,f))return!1;var t=e-a+g-c,v=h-b+f-d;a=c-a;b=d-b;e=g-e;h=f-h;f=cr.abs(b*e-h*a);a=a*v-b*t;return cr.abs(e*v-h*t)<=f&&cr.abs(a)<=f};b.prototype.set=function(a,b,c,d){this.left=a;this.top=b;this.right=c;this.bottom=d};b.prototype.width=function(){return this.right-
this.left};b.prototype.height=function(){return this.bottom-this.top};b.prototype.offset=function(a,b){this.left+=a;this.top+=b;this.right+=a;this.bottom+=b;return this};b.prototype.intersects_rect=function(a){return!(a.right<this.left||a.bottom<this.top||a.left>this.right||a.top>this.bottom)};b.prototype.contains_pt=function(a,b){return a>=this.left&&a<=this.right&&b>=this.top&&b<=this.bottom};cr.rect=b;c.prototype.set_from_rect=function(a){this.tlx=a.left;this.tly=a.top;this.trx=a.right;this.try_=
a.top;this.brx=a.right;this.bry=a.bottom;this.blx=a.left;this.bly=a.bottom};c.prototype.set_from_rotated_rect=function(a,b){if(0===b)this.set_from_rect(a);else{var c=Math.sin(b),d=Math.cos(b),e=a.left*c,h=a.top*c,g=a.right*c,c=a.bottom*c,f=a.left*d,t=a.top*d,v=a.right*d,d=a.bottom*d;this.tlx=f-h;this.tly=t+e;this.trx=v-h;this.try_=t+g;this.brx=v-c;this.bry=d+g;this.blx=f-c;this.bly=d+e}};c.prototype.offset=function(a,b){this.tlx+=a;this.tly+=b;this.trx+=a;this.try_+=b;this.brx+=a;this.bry+=b;this.blx+=
a;this.bly+=b;return this};c.prototype.bounding_box=function(a){a.left=cr.min(cr.min(this.tlx,this.trx),cr.min(this.brx,this.blx));a.top=cr.min(cr.min(this.tly,this.try_),cr.min(this.bry,this.bly));a.right=cr.max(cr.max(this.tlx,this.trx),cr.max(this.brx,this.blx));a.bottom=cr.max(cr.max(this.tly,this.try_),cr.max(this.bry,this.bly))};c.prototype.contains_pt=function(a,b){var c=this.trx-this.tlx,d=this.try_-this.tly,e=this.brx-this.tlx,h=this.bry-this.tly,g=a-this.tlx,f=b-this.tly,t=c*c+d*d,v=c*e+
d*h,d=c*g+d*f,y=e*e+h*h,z=e*g+h*f,C=1/(t*y-v*v),c=(y*d-v*z)*C,t=(t*z-v*d)*C;if(0<=c&&0<t&&1>c+t)return!0;c=this.blx-this.tlx;d=this.bly-this.tly;t=c*c+d*d;v=c*e+d*h;d=c*g+d*f;C=1/(t*y-v*v);c=(y*d-v*z)*C;t=(t*z-v*d)*C;return 0<=c&&0<t&&1>c+t};c.prototype.at=function(a,b){switch(a){case 0:return b?this.tlx:this.tly;case 1:return b?this.trx:this.try_;case 2:return b?this.brx:this.bry;case 3:return b?this.blx:this.bly;case 4:return b?this.tlx:this.tly;default:return b?this.tlx:this.tly}};c.prototype.midX=
function(){return(this.tlx+this.trx+this.brx+this.blx)/4};c.prototype.midY=function(){return(this.tly+this.try_+this.bry+this.bly)/4};c.prototype.intersects_segment=function(a,b,c,d){if(this.contains_pt(a,b)||this.contains_pt(c,d))return!0;var e,h,g,f,t;for(t=0;4>t;t++)if(e=this.at(t,!0),h=this.at(t,!1),g=this.at(t+1,!0),f=this.at(t+1,!1),cr.segments_intersect(a,b,c,d,e,h,g,f))return!0;return!1};c.prototype.intersects_quad=function(a){var b=a.midX(),c=a.midY();if(this.contains_pt(b,c))return!0;b=
this.midX();c=this.midY();if(a.contains_pt(b,c))return!0;var d,e,h,g,f,t,v,y;for(v=0;4>v;v++)for(y=0;4>y;y++)if(b=this.at(v,!0),c=this.at(v,!1),d=this.at(v+1,!0),e=this.at(v+1,!1),h=a.at(y,!0),g=a.at(y,!1),f=a.at(y+1,!0),t=a.at(y+1,!1),cr.segments_intersect(b,c,d,e,h,g,f,t))return!0;return!1};cr.quad=c;cr.RGB=function(a,b,c){return Math.max(Math.min(a,255),0)|Math.max(Math.min(b,255),0)<<8|Math.max(Math.min(c,255),0)<<16};cr.GetRValue=function(a){return a&255};cr.GetGValue=function(a){return(a&65280)>>
8};cr.GetBValue=function(a){return(a&16711680)>>16};cr.shallowCopy=function(a,b,c){for(var d in b)b.hasOwnProperty(d)&&(a[d]=b[d]);return a};cr.arrayRemove=function(a,b){var c,d;b=cr.floor(b);if(!(0>b||b>=a.length))if(0===b)a.shift();else if(b===a.length-1)a.pop();else{c=b;for(d=a.length-1;c<d;c++)a[c]=a[c+1];a.length=d}};cr.shallowAssignArray=function(a,b){a.length=b.length;var c,d;c=0;for(d=b.length;c<d;c++)a[c]=b[c]};cr.arrayFindRemove=function(a,b){var c=a.indexOf(b);-1!==c&&cr.arrayRemove(a,
c)};cr.clamp=function(a,b,c){return a<b?b:a>c?c:a};cr.to_radians=function(a){return a/(180/cr.PI)};cr.to_degrees=function(a){return a*(180/cr.PI)};cr.clamp_angle_degrees=function(a){a%=360;0>a&&(a+=360);return a};cr.clamp_angle=function(a){a%=2*cr.PI;0>a&&(a+=2*cr.PI);return a};cr.to_clamped_degrees=function(a){return cr.clamp_angle_degrees(cr.to_degrees(a))};cr.to_clamped_radians=function(a){return cr.clamp_angle(cr.to_radians(a))};cr.angleTo=function(a,b,c,d){return Math.atan2(d-b,c-a)};cr.angleDiff=
function(a,b){if(a===b)return 0;var c=Math.sin(a),d=Math.cos(a),e=Math.sin(b),h=Math.cos(b),c=c*e+d*h;return 1<=c?0:-1>=c?cr.PI:Math.acos(c)};cr.angleRotate=function(a,b,c){var d=Math.sin(a),e=Math.cos(a),h=Math.sin(b),g=Math.cos(b);return Math.acos(d*h+e*g)>c?0<e*h-d*g?cr.clamp_angle(a+c):cr.clamp_angle(a-c):cr.clamp_angle(b)};cr.angleClockwise=function(a,b){var c=Math.sin(a),d=Math.cos(a),e=Math.sin(b),h=Math.cos(b);return 0>=d*e-c*h};cr.rotatePtAround=function(a,b,c,d,e,h){if(0===c)return h?a:
b;var g=Math.sin(c);c=Math.cos(c);a-=d;b-=e;var f=a*g;a=a*c-b*g;b=b*c+f;return h?a+d:b+e};cr.distanceTo=function(a,b,c,d){a=c-a;b=d-b;return Math.sqrt(a*a+b*b)};cr.xor=function(a,b){return!a!==!b};cr.lerp=function(a,b,c){return a+(b-a)*c};cr.hasAnyOwnProperty=function(a){for(var b in a)if(a.hasOwnProperty(b))return!0;return!1};cr.wipe=function(a){for(var b in a)a.hasOwnProperty(b)&&delete a[b]};var g=+new Date;cr.performance_now=function(){if("undefined"!==typeof window.performance){var a=window.performance;
if("undefined"!==typeof a.now)return a.now();if("undefined"!==typeof a.webkitNow)return a.webkitNow();if("undefined"!==typeof a.msNow)return a.msNow()}return Date.now()-g};d.prototype.contains=function(a){return this.items.hasOwnProperty(a.toString())};d.prototype.add=function(a){var b=a.toString();this.items.hasOwnProperty(b)||(this.items[b]=a,this.item_count++,this.cache_valid=!1);return this};d.prototype.remove=function(a){a=a.toString();this.items.hasOwnProperty(a)&&(delete this.items[a],this.item_count--,
this.cache_valid=!1);return this};d.prototype.clear=function(){cr.wipe(this.items);this.item_count=0;this.values_cache.length=0;this.cache_valid=!0;return this};d.prototype.isEmpty=function(){return 0===this.item_count};d.prototype.count=function(){return this.item_count};d.prototype.update_cache=function(){if(!this.cache_valid){this.values_cache.length=this.item_count;var a,b=0;for(a in this.items)this.items.hasOwnProperty(a)&&(this.values_cache[b++]=this.items[a]);this.cache_valid=!0}};d.prototype.values=
function(){this.update_cache();return this.values_cache.slice(0)};d.prototype.valuesRef=function(){this.update_cache();return this.values_cache};cr.ObjectSet=d;e.prototype.add=function(a){this.y=a-this.c;this.t=this.sum+this.y;this.c=this.t-this.sum-this.y;this.sum=this.t};e.prototype.reset=function(){this.sum=this.t=this.y=this.c=0};cr.KahanAdder=e;cr.regexp_escape=function(a){return a.replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&")};f.prototype.set_pts=function(a){this.pts_array=a;this.pts_count=a.length/
2;this.pts_cache.length=a.length;this.cache_height=this.cache_width=-1;this.cache_angle=0};f.prototype.is_empty=function(){return!this.pts_array.length};f.prototype.set_from_quad=function(a,b,c,d,e){this.pts_cache.length=8;this.pts_count=4;var h=this.pts_cache;h[0]=a.tlx-b;h[1]=a.tly-c;h[2]=a.trx-b;h[3]=a.try_-c;h[4]=a.brx-b;h[5]=a.bry-c;h[6]=a.blx-b;h[7]=a.bly-c;this.cache_width=d;this.cache_height=e};f.prototype.set_from_poly=function(a){this.pts_count=a.pts_count;cr.shallowAssignArray(this.pts_cache,
a.pts_cache)};f.prototype.cache_poly=function(a,b,c){if(!(this.cache_width===a&&this.cache_height===b&&this.cache_angle===c)){this.cache_width=a;this.cache_height=b;this.cache_angle=c;var d,e,h,g=0,f=1,t=this.pts_array,v=this.pts_cache;0!==c&&(g=Math.sin(c),f=Math.cos(c));c=0;for(d=this.pts_count;c<d;c++)e=t[2*c]*a,h=t[2*c+1]*b,v[2*c]=e*f-h*g,v[2*c+1]=h*f+e*g}};f.prototype.contains_pt=function(a,b){var c=this.pts_cache;if(a===c[0]&&b===c[1])return!0;var d,e,h,g=this.pts_count,f=c[0],t=f,v=c[1],y=
v;for(d=1;d<g;d++)e=c[2*d],h=c[2*d+1],e<f&&(f=e),e>t&&(t=e),h<v&&(v=h),h>y&&(y=h);e=f-110;var v=v-101,t=t+131,y=y+120,z,C,A=0,x=0;for(d=0;d<g;d++)h=c[2*d],f=c[2*d+1],z=c[2*((d+1)%g)],C=c[2*((d+1)%g)+1],cr.segments_intersect(e,v,a,b,h,f,z,C)&&A++,cr.segments_intersect(t,y,a,b,h,f,z,C)&&x++;return 1===A%2||1===x%2};f.prototype.intersects_poly=function(a,b,c){var d=a.pts_cache,e=this.pts_cache;if(this.contains_pt(d[0]+b,d[1]+c)||a.contains_pt(e[0]-b,e[1]-c))return!0;var h,g,f,t,v,y,z,C,A,x,w,D;h=0;for(g=
this.pts_count;h<g;h++){v=e[2*h];y=e[2*h+1];z=e[2*((h+1)%g)];C=e[2*((h+1)%g)+1];f=0;for(t=a.pts_count;f<t;f++)if(A=d[2*f]+b,x=d[2*f+1]+c,w=d[2*((f+1)%t)]+b,D=d[2*((f+1)%t)+1]+c,cr.segments_intersect(v,y,z,C,A,x,w,D))return!0}return!1};f.prototype.intersects_segment=function(a,b,c,d,e,h){var g=this.pts_cache;if(this.contains_pt(c-a,d-b))return!0;var f,t,v,y,z,C;f=0;for(t=this.pts_count;f<t;f++)if(v=g[2*f]+a,y=g[2*f+1]+b,z=g[2*((f+1)%t)]+a,C=g[2*((f+1)%t)+1]+b,cr.segments_intersect(c,d,e,h,v,y,z,C))return!0;
return!1};cr.CollisionPoly=f;var h="lighter xor copy destination-over source-in destination-in source-out destination-out source-atop destination-atop".split(" ");cr.effectToCompositeOp=function(a){return 0>=a||11<=a?"source-over":h[a-1]};cr.setGLBlend=function(a,b,c){if(c)switch(a.srcBlend=c.ONE,a.destBlend=c.ONE_MINUS_SRC_ALPHA,b){case 1:a.srcBlend=c.ONE;a.destBlend=c.ONE;break;case 3:a.srcBlend=c.ONE;a.destBlend=c.ZERO;break;case 4:a.srcBlend=c.ONE_MINUS_DST_ALPHA;a.destBlend=c.ONE;break;case 5:a.srcBlend=
c.DST_ALPHA;a.destBlend=c.ZERO;break;case 6:a.srcBlend=c.ZERO;a.destBlend=c.SRC_ALPHA;break;case 7:a.srcBlend=c.ONE_MINUS_DST_ALPHA;a.destBlend=c.ZERO;break;case 8:a.srcBlend=c.ZERO;a.destBlend=c.ONE_MINUS_SRC_ALPHA;break;case 9:a.srcBlend=c.DST_ALPHA;a.destBlend=c.ONE_MINUS_SRC_ALPHA;break;case 10:a.srcBlend=c.ONE_MINUS_DST_ALPHA,a.destBlend=c.SRC_ALPHA}};cr.round6dp=function(a){return Math.round(1E6*a)/1E6};cr.equals_nocase=function(a,b){return"string"!==typeof a||"string"!==typeof b||a.length!==
b.length?!1:a===b?!0:a.toLowerCase()===b.toLowerCase()}})();var MatrixArray="undefined"!==typeof Float32Array?Float32Array:Array,glMatrixArrayType=MatrixArray,vec3={},mat3={},mat4={},quat4={};vec3.create=function(a){var b=new MatrixArray(3);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2]);return b};vec3.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];return b};vec3.add=function(a,b,c){if(!c||a===c)return a[0]+=b[0],a[1]+=b[1],a[2]+=b[2],a;c[0]=a[0]+b[0];c[1]=a[1]+b[1];c[2]=a[2]+b[2];return c};
vec3.subtract=function(a,b,c){if(!c||a===c)return a[0]-=b[0],a[1]-=b[1],a[2]-=b[2],a;c[0]=a[0]-b[0];c[1]=a[1]-b[1];c[2]=a[2]-b[2];return c};vec3.negate=function(a,b){b||(b=a);b[0]=-a[0];b[1]=-a[1];b[2]=-a[2];return b};vec3.scale=function(a,b,c){if(!c||a===c)return a[0]*=b,a[1]*=b,a[2]*=b,a;c[0]=a[0]*b;c[1]=a[1]*b;c[2]=a[2]*b;return c};
vec3.normalize=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],f=Math.sqrt(c*c+d*d+e*e);if(f){if(1===f)return b[0]=c,b[1]=d,b[2]=e,b}else return b[0]=0,b[1]=0,b[2]=0,b;f=1/f;b[0]=c*f;b[1]=d*f;b[2]=e*f;return b};vec3.cross=function(a,b,c){c||(c=a);var d=a[0],e=a[1];a=a[2];var f=b[0],g=b[1];b=b[2];c[0]=e*b-a*g;c[1]=a*f-d*b;c[2]=d*g-e*f;return c};vec3.length=function(a){var b=a[0],c=a[1];a=a[2];return Math.sqrt(b*b+c*c+a*a)};vec3.dot=function(a,b){return a[0]*b[0]+a[1]*b[1]+a[2]*b[2]};
vec3.direction=function(a,b,c){c||(c=a);var d=a[0]-b[0],e=a[1]-b[1];a=a[2]-b[2];b=Math.sqrt(d*d+e*e+a*a);if(!b)return c[0]=0,c[1]=0,c[2]=0,c;b=1/b;c[0]=d*b;c[1]=e*b;c[2]=a*b;return c};vec3.lerp=function(a,b,c,d){d||(d=a);d[0]=a[0]+c*(b[0]-a[0]);d[1]=a[1]+c*(b[1]-a[1]);d[2]=a[2]+c*(b[2]-a[2]);return d};vec3.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+"]"};
mat3.create=function(a){var b=new MatrixArray(9);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3],b[4]=a[4],b[5]=a[5],b[6]=a[6],b[7]=a[7],b[8]=a[8]);return b};mat3.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];return b};mat3.identity=function(a){a[0]=1;a[1]=0;a[2]=0;a[3]=0;a[4]=1;a[5]=0;a[6]=0;a[7]=0;a[8]=1;return a};
mat3.transpose=function(a,b){if(!b||a===b){var c=a[1],d=a[2],e=a[5];a[1]=a[3];a[2]=a[6];a[3]=c;a[5]=a[7];a[6]=d;a[7]=e;return a}b[0]=a[0];b[1]=a[3];b[2]=a[6];b[3]=a[1];b[4]=a[4];b[5]=a[7];b[6]=a[2];b[7]=a[5];b[8]=a[8];return b};mat3.toMat4=function(a,b){b||(b=mat4.create());b[15]=1;b[14]=0;b[13]=0;b[12]=0;b[11]=0;b[10]=a[8];b[9]=a[7];b[8]=a[6];b[7]=0;b[6]=a[5];b[5]=a[4];b[4]=a[3];b[3]=0;b[2]=a[2];b[1]=a[1];b[0]=a[0];return b};
mat3.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+", "+a[4]+", "+a[5]+", "+a[6]+", "+a[7]+", "+a[8]+"]"};mat4.create=function(a){var b=new MatrixArray(16);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3],b[4]=a[4],b[5]=a[5],b[6]=a[6],b[7]=a[7],b[8]=a[8],b[9]=a[9],b[10]=a[10],b[11]=a[11],b[12]=a[12],b[13]=a[13],b[14]=a[14],b[15]=a[15]);return b};
mat4.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];b[9]=a[9];b[10]=a[10];b[11]=a[11];b[12]=a[12];b[13]=a[13];b[14]=a[14];b[15]=a[15];return b};mat4.identity=function(a){a[0]=1;a[1]=0;a[2]=0;a[3]=0;a[4]=0;a[5]=1;a[6]=0;a[7]=0;a[8]=0;a[9]=0;a[10]=1;a[11]=0;a[12]=0;a[13]=0;a[14]=0;a[15]=1;return a};
mat4.transpose=function(a,b){if(!b||a===b){var c=a[1],d=a[2],e=a[3],f=a[6],g=a[7],h=a[11];a[1]=a[4];a[2]=a[8];a[3]=a[12];a[4]=c;a[6]=a[9];a[7]=a[13];a[8]=d;a[9]=f;a[11]=a[14];a[12]=e;a[13]=g;a[14]=h;return a}b[0]=a[0];b[1]=a[4];b[2]=a[8];b[3]=a[12];b[4]=a[1];b[5]=a[5];b[6]=a[9];b[7]=a[13];b[8]=a[2];b[9]=a[6];b[10]=a[10];b[11]=a[14];b[12]=a[3];b[13]=a[7];b[14]=a[11];b[15]=a[15];return b};
mat4.determinant=function(a){var b=a[0],c=a[1],d=a[2],e=a[3],f=a[4],g=a[5],h=a[6],l=a[7],k=a[8],m=a[9],n=a[10],q=a[11],p=a[12],r=a[13],s=a[14];a=a[15];return p*m*h*e-k*r*h*e-p*g*n*e+f*r*n*e+k*g*s*e-f*m*s*e-p*m*d*l+k*r*d*l+p*c*n*l-b*r*n*l-k*c*s*l+b*m*s*l+p*g*d*q-f*r*d*q-p*c*h*q+b*r*h*q+f*c*s*q-b*g*s*q-k*g*d*a+f*m*d*a+k*c*h*a-b*m*h*a-f*c*n*a+b*g*n*a};
mat4.inverse=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],f=a[3],g=a[4],h=a[5],l=a[6],k=a[7],m=a[8],n=a[9],q=a[10],p=a[11],r=a[12],s=a[13],t=a[14],v=a[15],y=c*h-d*g,z=c*l-e*g,C=c*k-f*g,A=d*l-e*h,x=d*k-f*h,w=e*k-f*l,D=m*s-n*r,E=m*t-q*r,H=m*v-p*r,u=n*t-q*s,B=n*v-p*s,K=q*v-p*t,F=1/(y*K-z*B+C*u+A*H-x*E+w*D);b[0]=(h*K-l*B+k*u)*F;b[1]=(-d*K+e*B-f*u)*F;b[2]=(s*w-t*x+v*A)*F;b[3]=(-n*w+q*x-p*A)*F;b[4]=(-g*K+l*H-k*E)*F;b[5]=(c*K-e*H+f*E)*F;b[6]=(-r*w+t*C-v*z)*F;b[7]=(m*w-q*C+p*z)*F;b[8]=(g*B-h*H+k*D)*F;
b[9]=(-c*B+d*H-f*D)*F;b[10]=(r*x-s*C+v*y)*F;b[11]=(-m*x+n*C-p*y)*F;b[12]=(-g*u+h*E-l*D)*F;b[13]=(c*u-d*E+e*D)*F;b[14]=(-r*A+s*z-t*y)*F;b[15]=(m*A-n*z+q*y)*F;return b};mat4.toRotationMat=function(a,b){b||(b=mat4.create());b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];b[9]=a[9];b[10]=a[10];b[11]=a[11];b[12]=0;b[13]=0;b[14]=0;b[15]=1;return b};
mat4.toMat3=function(a,b){b||(b=mat3.create());b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[4];b[4]=a[5];b[5]=a[6];b[6]=a[8];b[7]=a[9];b[8]=a[10];return b};mat4.toInverseMat3=function(a,b){var c=a[0],d=a[1],e=a[2],f=a[4],g=a[5],h=a[6],l=a[8],k=a[9],m=a[10],n=m*g-h*k,q=-m*f+h*l,p=k*f-g*l,r=c*n+d*q+e*p;if(!r)return null;r=1/r;b||(b=mat3.create());b[0]=n*r;b[1]=(-m*d+e*k)*r;b[2]=(h*d-e*g)*r;b[3]=q*r;b[4]=(m*c-e*l)*r;b[5]=(-h*c+e*f)*r;b[6]=p*r;b[7]=(-k*c+d*l)*r;b[8]=(g*c-d*f)*r;return b};
mat4.multiply=function(a,b,c){c||(c=a);var d=a[0],e=a[1],f=a[2],g=a[3],h=a[4],l=a[5],k=a[6],m=a[7],n=a[8],q=a[9],p=a[10],r=a[11],s=a[12],t=a[13],v=a[14];a=a[15];var y=b[0],z=b[1],C=b[2],A=b[3],x=b[4],w=b[5],D=b[6],E=b[7],H=b[8],u=b[9],B=b[10],K=b[11],F=b[12],M=b[13],Q=b[14];b=b[15];c[0]=y*d+z*h+C*n+A*s;c[1]=y*e+z*l+C*q+A*t;c[2]=y*f+z*k+C*p+A*v;c[3]=y*g+z*m+C*r+A*a;c[4]=x*d+w*h+D*n+E*s;c[5]=x*e+w*l+D*q+E*t;c[6]=x*f+w*k+D*p+E*v;c[7]=x*g+w*m+D*r+E*a;c[8]=H*d+u*h+B*n+K*s;c[9]=H*e+u*l+B*q+K*t;c[10]=H*
f+u*k+B*p+K*v;c[11]=H*g+u*m+B*r+K*a;c[12]=F*d+M*h+Q*n+b*s;c[13]=F*e+M*l+Q*q+b*t;c[14]=F*f+M*k+Q*p+b*v;c[15]=F*g+M*m+Q*r+b*a;return c};mat4.multiplyVec3=function(a,b,c){c||(c=b);var d=b[0],e=b[1];b=b[2];c[0]=a[0]*d+a[4]*e+a[8]*b+a[12];c[1]=a[1]*d+a[5]*e+a[9]*b+a[13];c[2]=a[2]*d+a[6]*e+a[10]*b+a[14];return c};
mat4.multiplyVec4=function(a,b,c){c||(c=b);var d=b[0],e=b[1],f=b[2];b=b[3];c[0]=a[0]*d+a[4]*e+a[8]*f+a[12]*b;c[1]=a[1]*d+a[5]*e+a[9]*f+a[13]*b;c[2]=a[2]*d+a[6]*e+a[10]*f+a[14]*b;c[3]=a[3]*d+a[7]*e+a[11]*f+a[15]*b;return c};
mat4.translate=function(a,b,c){var d=b[0],e=b[1];b=b[2];var f,g,h,l,k,m,n,q,p,r,s,t;if(!c||a===c)return a[12]=a[0]*d+a[4]*e+a[8]*b+a[12],a[13]=a[1]*d+a[5]*e+a[9]*b+a[13],a[14]=a[2]*d+a[6]*e+a[10]*b+a[14],a[15]=a[3]*d+a[7]*e+a[11]*b+a[15],a;f=a[0];g=a[1];h=a[2];l=a[3];k=a[4];m=a[5];n=a[6];q=a[7];p=a[8];r=a[9];s=a[10];t=a[11];c[0]=f;c[1]=g;c[2]=h;c[3]=l;c[4]=k;c[5]=m;c[6]=n;c[7]=q;c[8]=p;c[9]=r;c[10]=s;c[11]=t;c[12]=f*d+k*e+p*b+a[12];c[13]=g*d+m*e+r*b+a[13];c[14]=h*d+n*e+s*b+a[14];c[15]=l*d+q*e+t*b+
a[15];return c};mat4.scale=function(a,b,c){var d=b[0],e=b[1];b=b[2];if(!c||a===c)return a[0]*=d,a[1]*=d,a[2]*=d,a[3]*=d,a[4]*=e,a[5]*=e,a[6]*=e,a[7]*=e,a[8]*=b,a[9]*=b,a[10]*=b,a[11]*=b,a;c[0]=a[0]*d;c[1]=a[1]*d;c[2]=a[2]*d;c[3]=a[3]*d;c[4]=a[4]*e;c[5]=a[5]*e;c[6]=a[6]*e;c[7]=a[7]*e;c[8]=a[8]*b;c[9]=a[9]*b;c[10]=a[10]*b;c[11]=a[11]*b;c[12]=a[12];c[13]=a[13];c[14]=a[14];c[15]=a[15];return c};
mat4.rotate=function(a,b,c,d){var e=c[0],f=c[1];c=c[2];var g=Math.sqrt(e*e+f*f+c*c),h,l,k,m,n,q,p,r,s,t,v,y,z,C,A,x,w,D,E,H;if(!g)return null;1!==g&&(g=1/g,e*=g,f*=g,c*=g);h=Math.sin(b);l=Math.cos(b);k=1-l;b=a[0];g=a[1];m=a[2];n=a[3];q=a[4];p=a[5];r=a[6];s=a[7];t=a[8];v=a[9];y=a[10];z=a[11];C=e*e*k+l;A=f*e*k+c*h;x=c*e*k-f*h;w=e*f*k-c*h;D=f*f*k+l;E=c*f*k+e*h;H=e*c*k+f*h;e=f*c*k-e*h;f=c*c*k+l;d?a!==d&&(d[12]=a[12],d[13]=a[13],d[14]=a[14],d[15]=a[15]):d=a;d[0]=b*C+q*A+t*x;d[1]=g*C+p*A+v*x;d[2]=m*C+r*
A+y*x;d[3]=n*C+s*A+z*x;d[4]=b*w+q*D+t*E;d[5]=g*w+p*D+v*E;d[6]=m*w+r*D+y*E;d[7]=n*w+s*D+z*E;d[8]=b*H+q*e+t*f;d[9]=g*H+p*e+v*f;d[10]=m*H+r*e+y*f;d[11]=n*H+s*e+z*f;return d};
mat4.rotateX=function(a,b,c){var d=Math.sin(b);b=Math.cos(b);var e=a[4],f=a[5],g=a[6],h=a[7],l=a[8],k=a[9],m=a[10],n=a[11];c?a!==c&&(c[0]=a[0],c[1]=a[1],c[2]=a[2],c[3]=a[3],c[12]=a[12],c[13]=a[13],c[14]=a[14],c[15]=a[15]):c=a;c[4]=e*b+l*d;c[5]=f*b+k*d;c[6]=g*b+m*d;c[7]=h*b+n*d;c[8]=e*-d+l*b;c[9]=f*-d+k*b;c[10]=g*-d+m*b;c[11]=h*-d+n*b;return c};
mat4.rotateY=function(a,b,c){var d=Math.sin(b);b=Math.cos(b);var e=a[0],f=a[1],g=a[2],h=a[3],l=a[8],k=a[9],m=a[10],n=a[11];c?a!==c&&(c[4]=a[4],c[5]=a[5],c[6]=a[6],c[7]=a[7],c[12]=a[12],c[13]=a[13],c[14]=a[14],c[15]=a[15]):c=a;c[0]=e*b+l*-d;c[1]=f*b+k*-d;c[2]=g*b+m*-d;c[3]=h*b+n*-d;c[8]=e*d+l*b;c[9]=f*d+k*b;c[10]=g*d+m*b;c[11]=h*d+n*b;return c};
mat4.rotateZ=function(a,b,c){var d=Math.sin(b);b=Math.cos(b);var e=a[0],f=a[1],g=a[2],h=a[3],l=a[4],k=a[5],m=a[6],n=a[7];c?a!==c&&(c[8]=a[8],c[9]=a[9],c[10]=a[10],c[11]=a[11],c[12]=a[12],c[13]=a[13],c[14]=a[14],c[15]=a[15]):c=a;c[0]=e*b+l*d;c[1]=f*b+k*d;c[2]=g*b+m*d;c[3]=h*b+n*d;c[4]=e*-d+l*b;c[5]=f*-d+k*b;c[6]=g*-d+m*b;c[7]=h*-d+n*b;return c};
mat4.frustum=function(a,b,c,d,e,f,g){g||(g=mat4.create());var h=b-a,l=d-c,k=f-e;g[0]=2*e/h;g[1]=0;g[2]=0;g[3]=0;g[4]=0;g[5]=2*e/l;g[6]=0;g[7]=0;g[8]=(b+a)/h;g[9]=(d+c)/l;g[10]=-(f+e)/k;g[11]=-1;g[12]=0;g[13]=0;g[14]=-(2*f*e)/k;g[15]=0;return g};mat4.perspective=function(a,b,c,d,e){a=c*Math.tan(a*Math.PI/360);b*=a;return mat4.frustum(-b,b,-a,a,c,d,e)};
mat4.ortho=function(a,b,c,d,e,f,g){g||(g=mat4.create());var h=b-a,l=d-c,k=f-e;g[0]=2/h;g[1]=0;g[2]=0;g[3]=0;g[4]=0;g[5]=2/l;g[6]=0;g[7]=0;g[8]=0;g[9]=0;g[10]=-2/k;g[11]=0;g[12]=-(a+b)/h;g[13]=-(d+c)/l;g[14]=-(f+e)/k;g[15]=1;return g};
mat4.lookAt=function(a,b,c,d){d||(d=mat4.create());var e,f,g,h,l,k,m,n,q=a[0],p=a[1];a=a[2];f=c[0];g=c[1];e=c[2];c=b[1];k=b[2];if(q===b[0]&&p===c&&a===k)return mat4.identity(d);c=q-b[0];k=p-b[1];m=a-b[2];n=1/Math.sqrt(c*c+k*k+m*m);c*=n;k*=n;m*=n;b=g*m-e*k;e=e*c-f*m;f=f*k-g*c;(n=Math.sqrt(b*b+e*e+f*f))?(n=1/n,b*=n,e*=n,f*=n):f=e=b=0;g=k*f-m*e;h=m*b-c*f;l=c*e-k*b;(n=Math.sqrt(g*g+h*h+l*l))?(n=1/n,g*=n,h*=n,l*=n):l=h=g=0;d[0]=b;d[1]=g;d[2]=c;d[3]=0;d[4]=e;d[5]=h;d[6]=k;d[7]=0;d[8]=f;d[9]=l;d[10]=m;d[11]=
0;d[12]=-(b*q+e*p+f*a);d[13]=-(g*q+h*p+l*a);d[14]=-(c*q+k*p+m*a);d[15]=1;return d};mat4.fromRotationTranslation=function(a,b,c){c||(c=mat4.create());var d=a[0],e=a[1],f=a[2],g=a[3],h=d+d,l=e+e,k=f+f;a=d*h;var m=d*l,d=d*k,n=e*l,e=e*k,f=f*k,h=h*g,l=l*g,g=g*k;c[0]=1-(n+f);c[1]=m+g;c[2]=d-l;c[3]=0;c[4]=m-g;c[5]=1-(a+f);c[6]=e+h;c[7]=0;c[8]=d+l;c[9]=e-h;c[10]=1-(a+n);c[11]=0;c[12]=b[0];c[13]=b[1];c[14]=b[2];c[15]=1;return c};
mat4.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+", "+a[4]+", "+a[5]+", "+a[6]+", "+a[7]+", "+a[8]+", "+a[9]+", "+a[10]+", "+a[11]+", "+a[12]+", "+a[13]+", "+a[14]+", "+a[15]+"]"};quat4.create=function(a){var b=new MatrixArray(4);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3]);return b};quat4.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];return b};
quat4.calculateW=function(a,b){var c=a[0],d=a[1],e=a[2];if(!b||a===b)return a[3]=-Math.sqrt(Math.abs(1-c*c-d*d-e*e)),a;b[0]=c;b[1]=d;b[2]=e;b[3]=-Math.sqrt(Math.abs(1-c*c-d*d-e*e));return b};quat4.inverse=function(a,b){if(!b||a===b)return a[0]*=-1,a[1]*=-1,a[2]*=-1,a;b[0]=-a[0];b[1]=-a[1];b[2]=-a[2];b[3]=a[3];return b};quat4.length=function(a){var b=a[0],c=a[1],d=a[2];a=a[3];return Math.sqrt(b*b+c*c+d*d+a*a)};
quat4.normalize=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],f=a[3],g=Math.sqrt(c*c+d*d+e*e+f*f);if(0===g)return b[0]=0,b[1]=0,b[2]=0,b[3]=0,b;g=1/g;b[0]=c*g;b[1]=d*g;b[2]=e*g;b[3]=f*g;return b};quat4.multiply=function(a,b,c){c||(c=a);var d=a[0],e=a[1],f=a[2];a=a[3];var g=b[0],h=b[1],l=b[2];b=b[3];c[0]=d*b+a*g+e*l-f*h;c[1]=e*b+a*h+f*g-d*l;c[2]=f*b+a*l+d*h-e*g;c[3]=a*b-d*g-e*h-f*l;return c};
quat4.multiplyVec3=function(a,b,c){c||(c=b);var d=b[0],e=b[1],f=b[2];b=a[0];var g=a[1],h=a[2];a=a[3];var l=a*d+g*f-h*e,k=a*e+h*d-b*f,m=a*f+b*e-g*d,d=-b*d-g*e-h*f;c[0]=l*a+d*-b+k*-h-m*-g;c[1]=k*a+d*-g+m*-b-l*-h;c[2]=m*a+d*-h+l*-g-k*-b;return c};quat4.toMat3=function(a,b){b||(b=mat3.create());var c=a[0],d=a[1],e=a[2],f=a[3],g=c+c,h=d+d,l=e+e,k=c*g,m=c*h,c=c*l,n=d*h,d=d*l,e=e*l,g=g*f,h=h*f,f=f*l;b[0]=1-(n+e);b[1]=m+f;b[2]=c-h;b[3]=m-f;b[4]=1-(k+e);b[5]=d+g;b[6]=c+h;b[7]=d-g;b[8]=1-(k+n);return b};
quat4.toMat4=function(a,b){b||(b=mat4.create());var c=a[0],d=a[1],e=a[2],f=a[3],g=c+c,h=d+d,l=e+e,k=c*g,m=c*h,c=c*l,n=d*h,d=d*l,e=e*l,g=g*f,h=h*f,f=f*l;b[0]=1-(n+e);b[1]=m+f;b[2]=c-h;b[3]=0;b[4]=m-f;b[5]=1-(k+e);b[6]=d+g;b[7]=0;b[8]=c+h;b[9]=d-g;b[10]=1-(k+n);b[11]=0;b[12]=0;b[13]=0;b[14]=0;b[15]=1;return b};
quat4.slerp=function(a,b,c,d){d||(d=a);var e=a[0]*b[0]+a[1]*b[1]+a[2]*b[2]+a[3]*b[3],f,g;if(1<=Math.abs(e))return d!==a&&(d[0]=a[0],d[1]=a[1],d[2]=a[2],d[3]=a[3]),d;f=Math.acos(e);g=Math.sqrt(1-e*e);if(0.0010>Math.abs(g))return d[0]=0.5*a[0]+0.5*b[0],d[1]=0.5*a[1]+0.5*b[1],d[2]=0.5*a[2]+0.5*b[2],d[3]=0.5*a[3]+0.5*b[3],d;e=Math.sin((1-c)*f)/g;c=Math.sin(c*f)/g;d[0]=a[0]*e+b[0]*c;d[1]=a[1]*e+b[1]*c;d[2]=a[2]*e+b[2]*c;d[3]=a[3]*e+b[3]*c;return d};
quat4.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+"]"};
(function(){function a(a,b){this.height=this.width=0;this.cam=vec3.create([0,0,100]);this.look=vec3.create([0,0,0]);this.up=vec3.create([0,1,0]);this.worldScale=vec3.create([1,1,1]);this.matP=mat4.create();this.matMV=mat4.create();this.lastMV=mat4.create();this.currentMV=mat4.create();this.gl=a;this.initState()}function b(a,b,c){this.gl=a;this.shaderProgram=b;this.name=c;this.locAPos=a.getAttribLocation(b,"aPos");this.locATex=a.getAttribLocation(b,"aTex");this.locMatP=a.getUniformLocation(b,"matP");
this.locMatMV=a.getUniformLocation(b,"matMV");this.locOpacity=a.getUniformLocation(b,"opacity");this.locSamplerFront=a.getUniformLocation(b,"samplerFront");this.locSamplerBack=a.getUniformLocation(b,"samplerBack");this.locDestStart=a.getUniformLocation(b,"destStart");this.locDestEnd=a.getUniformLocation(b,"destEnd");this.locSeconds=a.getUniformLocation(b,"seconds");this.locPixelWidth=a.getUniformLocation(b,"pixelWidth");this.locPixelHeight=a.getUniformLocation(b,"pixelHeight");this.locLayerScale=
a.getUniformLocation(b,"layerScale");this.locOpacity&&a.uniform1f(this.locOpacity,1);this.locSamplerFront&&a.uniform1i(this.locSamplerFront,0);this.locSamplerBack&&a.uniform1i(this.locSamplerBack,1);this.locDestStart&&a.uniform2f(this.locDestStart,0,0);this.locDestEnd&&a.uniform2f(this.locDestEnd,1,1);this.hasCurrentMatMV=!1}function c(a,b){this.type=a;this.glwrap=b;this.gl=b.gl;this.indexCount=this.startIndex=this.opacityParam=0;this.mat4param=this.texParam=null;this.shaderParams=[];cr.seal(this)}
function d(a){--a;for(var b=1;32>b;b<<=1)a|=a>>b;return a+1}a.prototype.initState=function(){var a=this.gl,b;this.lastOpacity=1;this.lastTexture=null;this.currentOpacity=1;a.clearColor(0,0,0,0);a.clear(a.COLOR_BUFFER_BIT);a.enable(a.BLEND);a.blendFunc(a.ONE,a.ONE_MINUS_SRC_ALPHA);a.disable(a.CULL_FACE);a.disable(a.DEPTH_TEST);this.maxTextureSize=a.getParameter(a.MAX_TEXTURE_SIZE);this.lastSrcBlend=a.ONE;this.lastDestBlend=a.ONE_MINUS_SRC_ALPHA;this.pointBuffer=a.createBuffer();a.bindBuffer(a.ARRAY_BUFFER,
this.pointBuffer);this.vertexBuffers=Array(4);this.texcoordBuffers=Array(4);for(b=0;4>b;b++)this.vertexBuffers[b]=a.createBuffer(),a.bindBuffer(a.ARRAY_BUFFER,this.vertexBuffers[b]),this.texcoordBuffers[b]=a.createBuffer(),a.bindBuffer(a.ARRAY_BUFFER,this.texcoordBuffers[b]);this.curBuffer=0;this.indexBuffer=a.createBuffer();a.bindBuffer(a.ELEMENT_ARRAY_BUFFER,this.indexBuffer);this.vertexData=new Float32Array(16E3);this.texcoordData=new Float32Array(16E3);this.pointData=new Float32Array(32E3);for(var c=
new Uint16Array(12E3),d=b=0;12E3>b;)c[b++]=d,c[b++]=d+1,c[b++]=d+2,c[b++]=d,c[b++]=d+2,c[b++]=d+3,d+=4;a.bufferData(a.ELEMENT_ARRAY_BUFFER,c,a.STATIC_DRAW);this.pointPtr=this.vertexPtr=0;this.shaderPrograms=[];b=this.createShaderProgram({src:"varying mediump vec2 vTex;\nuniform lowp float opacity;\nuniform lowp sampler2D samplerFront;\nvoid main(void) {\n\tgl_FragColor = texture2D(samplerFront, vTex);\n\tgl_FragColor *= opacity;\n}"},"attribute highp vec2 aPos;\nattribute mediump vec2 aTex;\nvarying mediump vec2 vTex;\nuniform highp mat4 matP;\nuniform highp mat4 matMV;\nvoid main(void) {\n\tgl_Position = matP * matMV * vec4(aPos.x, aPos.y, 0.0, 1.0);\n\tvTex = aTex;\n}",
"<default>");this.shaderPrograms.push(b);b=this.createShaderProgram({src:"uniform mediump sampler2D samplerFront;\nvarying lowp float opacity;\nvoid main(void) {\n\tgl_FragColor = texture2D(samplerFront, gl_PointCoord);\n\tgl_FragColor *= opacity;\n}"},"attribute vec4 aPos;\nvarying float opacity;\nuniform mat4 matP;\nuniform mat4 matMV;\nvoid main(void) {\n\tgl_Position = matP * matMV * vec4(aPos.x, aPos.y, 0.0, 1.0);\n\tgl_PointSize = aPos.z;\n\topacity = aPos.w;\n}","<point>");this.shaderPrograms.push(b);
for(var e in cr.shaders)cr.shaders.hasOwnProperty(e)&&this.shaderPrograms.push(this.createShaderProgram(cr.shaders[e],"attribute highp vec2 aPos;\nattribute mediump vec2 aTex;\nvarying mediump vec2 vTex;\nuniform highp mat4 matP;\nuniform highp mat4 matMV;\nvoid main(void) {\n\tgl_Position = matP * matMV * vec4(aPos.x, aPos.y, 0.0, 1.0);\n\tvTex = aTex;\n}",e));a.activeTexture(a.TEXTURE0);a.bindTexture(a.TEXTURE_2D,null);this.batch=[];this.batchPtr=0;this.hasPointBatchTop=this.hasQuadBatchTop=!1;
this.currentProgram=this.lastProgram=-1;this.currentShader=null;this.fbo=a.createFramebuffer();this.renderToTex=null;this.tmpVec3=vec3.create([0,0,0]);a=a.getParameter(a.ALIASED_POINT_SIZE_RANGE);this.minPointSize=a[0];this.maxPointSize=a[1];this.switchProgram(0);cr.seal(this)};a.prototype.createShaderProgram=function(a,c,d){var e=this.gl,f=e.createShader(e.FRAGMENT_SHADER);e.shaderSource(f,a.src);e.compileShader(f);if(!e.getShaderParameter(f,e.COMPILE_STATUS))return e.deleteShader(f),null;var n=
e.createShader(e.VERTEX_SHADER);e.shaderSource(n,c);e.compileShader(n);if(!e.getShaderParameter(n,e.COMPILE_STATUS))return e.deleteShader(f),e.deleteShader(n),null;c=e.createProgram();e.attachShader(c,f);e.attachShader(c,n);e.linkProgram(c);if(!e.getProgramParameter(c,e.LINK_STATUS))return e.deleteShader(f),e.deleteShader(n),e.deleteProgram(c),null;e.useProgram(c);e.validateProgram(c);e.deleteShader(f);e.deleteShader(n);d=new b(e,c,d);d.extendBoxHorizontal=a.extendBoxHorizontal||0;d.extendBoxVertical=
a.extendBoxVertical||0;d.crossSampling=!!a.crossSampling;d.animated=!!a.animated;d.parameters=a.parameters||[];a=0;for(f=d.parameters.length;a<f;a++)d.parameters[a][1]=e.getUniformLocation(c,d.parameters[a][0]),e.uniform1f(d.parameters[a][1],0);cr.seal(d);return d};a.prototype.getShaderIndex=function(a){var b,c;b=0;for(c=this.shaderPrograms.length;b<c;b++)if(this.shaderPrograms[b].name===a)return b;return-1};a.prototype.project=function(a,b,c){var d=[0,0,this.width,this.height],e=this.matMV,f=this.matP,
q=[0,0,0,0,0,0,0,0];q[0]=e[0]*a+e[4]*b+e[12];q[1]=e[1]*a+e[5]*b+e[13];q[2]=e[2]*a+e[6]*b+e[14];q[3]=e[3]*a+e[7]*b+e[15];q[4]=f[0]*q[0]+f[4]*q[1]+f[8]*q[2]+f[12]*q[3];q[5]=f[1]*q[0]+f[5]*q[1]+f[9]*q[2]+f[13]*q[3];q[6]=f[2]*q[0]+f[6]*q[1]+f[10]*q[2]+f[14]*q[3];q[7]=-q[2];0!==q[7]&&(q[7]=1/q[7],q[4]*=q[7],q[5]*=q[7],q[6]*=q[7],c[0]=(0.5*q[4]+0.5)*d[2]+d[0],c[1]=(0.5*q[5]+0.5)*d[3]+d[1])};a.prototype.setSize=function(a,b,c){if(!(this.width===a&&this.height===b&&!c)){this.endBatch();this.width=a;this.height=
b;this.gl.viewport(0,0,a,b);mat4.perspective(45,a/b,1,1E3,this.matP);mat4.lookAt(this.cam,this.look,this.up,this.matMV);a=[0,0];b=[0,0];this.project(0,0,a);this.project(1,1,b);this.worldScale[0]=1/(b[0]-a[0]);this.worldScale[1]=-1/(b[1]-a[1]);a=0;for(b=this.shaderPrograms.length;a<b;a++)c=this.shaderPrograms[a],c.hasCurrentMatMV=!1,c.locMatP&&(this.gl.useProgram(c.shaderProgram),this.gl.uniformMatrix4fv(c.locMatP,!1,this.matP));this.gl.useProgram(this.shaderPrograms[this.lastProgram].shaderProgram);
this.gl.bindTexture(this.gl.TEXTURE_2D,null);this.lastTexture=null}};a.prototype.resetModelView=function(){mat4.lookAt(this.cam,this.look,this.up,this.matMV);mat4.scale(this.matMV,this.worldScale)};a.prototype.translate=function(a,b){0===a&&0===b||(this.tmpVec3[0]=a,this.tmpVec3[1]=b,this.tmpVec3[2]=0,mat4.translate(this.matMV,this.tmpVec3))};a.prototype.scale=function(a,b){1===a&&1===b||(this.tmpVec3[0]=a,this.tmpVec3[1]=b,this.tmpVec3[2]=1,mat4.scale(this.matMV,this.tmpVec3))};a.prototype.rotateZ=
function(a){0!==a&&mat4.rotateZ(this.matMV,a)};a.prototype.updateModelView=function(){for(var a=!1,b=0;16>b;b++)if(this.lastMV[b]!==this.matMV[b]){a=!0;break}a&&(a=this.pushBatch(),a.type=5,a.mat4param?mat4.set(this.matMV,a.mat4param):a.mat4param=mat4.create(this.matMV),mat4.set(this.matMV,this.lastMV),this.hasPointBatchTop=this.hasQuadBatchTop=!1)};c.prototype.doSetTexture=function(){this.gl.bindTexture(this.gl.TEXTURE_2D,this.texParam)};c.prototype.doSetOpacity=function(){var a=this.opacityParam,
b=this.glwrap;b.currentOpacity=a;b=b.currentShader;b.locOpacity&&this.gl.uniform1f(b.locOpacity,a)};c.prototype.doQuad=function(){this.gl.drawElements(this.gl.TRIANGLES,this.indexCount,this.gl.UNSIGNED_SHORT,2*this.startIndex)};c.prototype.doSetBlend=function(){this.gl.blendFunc(this.startIndex,this.indexCount)};c.prototype.doUpdateModelView=function(){var a,b,c,d=this.glwrap.shaderPrograms,e=this.glwrap.currentProgram;a=0;for(b=d.length;a<b;a++)c=d[a],a===e&&c.locMatMV?(this.gl.uniformMatrix4fv(c.locMatMV,
!1,this.mat4param),c.hasCurrentMatMV=!0):c.hasCurrentMatMV=!1;mat4.set(this.mat4param,this.glwrap.currentMV)};c.prototype.doRenderToTexture=function(){var a=this.gl,b=this.glwrap;this.texParam?(a.bindFramebuffer(a.FRAMEBUFFER,b.fbo),a.framebufferTexture2D(a.FRAMEBUFFER,a.COLOR_ATTACHMENT0,a.TEXTURE_2D,this.texParam,0)):(a.framebufferTexture2D(a.FRAMEBUFFER,a.COLOR_ATTACHMENT0,a.TEXTURE_2D,null,0),a.bindFramebuffer(a.FRAMEBUFFER,null))};c.prototype.doClear=function(){var a=this.gl;0===this.startIndex?
(a.clearColor(this.mat4param[0],this.mat4param[1],this.mat4param[2],this.mat4param[3]),a.clear(a.COLOR_BUFFER_BIT)):(a.enable(a.SCISSOR_TEST),a.scissor(this.mat4param[0],this.mat4param[1],this.mat4param[2],this.mat4param[3]),a.clearColor(0,0,0,0),a.clear(this.gl.COLOR_BUFFER_BIT),a.disable(a.SCISSOR_TEST))};c.prototype.doPoints=function(){var a=this.gl,b=this.glwrap,c=b.shaderPrograms[1];a.useProgram(c.shaderProgram);!c.hasCurrentMatMV&&c.locMatMV&&(a.uniformMatrix4fv(c.locMatMV,!1,b.currentMV),c.hasCurrentMatMV=
!0);a.enableVertexAttribArray(c.locAPos);a.bindBuffer(a.ARRAY_BUFFER,b.pointBuffer);a.vertexAttribPointer(c.locAPos,4,a.FLOAT,!1,0,0);a.drawArrays(a.POINTS,this.startIndex/4,this.indexCount);c=b.currentShader;a.useProgram(c.shaderProgram);0<=c.locAPos&&(a.enableVertexAttribArray(c.locAPos),a.bindBuffer(a.ARRAY_BUFFER,b.vertexBuffers[b.curBuffer]),a.vertexAttribPointer(c.locAPos,2,a.FLOAT,!1,0,0));0<=c.locATex&&(a.enableVertexAttribArray(c.locATex),a.bindBuffer(a.ARRAY_BUFFER,b.texcoordBuffers[b.curBuffer]),
a.vertexAttribPointer(c.locATex,2,a.FLOAT,!1,0,0))};c.prototype.doSetProgram=function(){var a=this.gl,b=this.glwrap,c=b.shaderPrograms[this.startIndex];b.currentProgram=this.startIndex;b.currentShader=c;a.useProgram(c.shaderProgram);!c.hasCurrentMatMV&&c.locMatMV&&(a.uniformMatrix4fv(c.locMatMV,!1,b.currentMV),c.hasCurrentMatMV=!0);c.locOpacity&&a.uniform1f(c.locOpacity,b.currentOpacity);0<=c.locAPos&&(a.enableVertexAttribArray(c.locAPos),a.bindBuffer(a.ARRAY_BUFFER,b.vertexBuffers[b.curBuffer]),
a.vertexAttribPointer(c.locAPos,2,a.FLOAT,!1,0,0));0<=c.locATex&&(a.enableVertexAttribArray(c.locATex),a.bindBuffer(a.ARRAY_BUFFER,b.texcoordBuffers[b.curBuffer]),a.vertexAttribPointer(c.locATex,2,a.FLOAT,!1,0,0))};c.prototype.doSetProgramParameters=function(){var a,b,c=this.glwrap.currentShader,d=this.gl;c.locSamplerBack&&(d.activeTexture(d.TEXTURE1),d.bindTexture(d.TEXTURE_2D,this.texParam),d.activeTexture(d.TEXTURE0));c.locPixelWidth&&d.uniform1f(c.locPixelWidth,this.mat4param[0]);c.locPixelHeight&&
d.uniform1f(c.locPixelHeight,this.mat4param[1]);c.locDestStart&&d.uniform2f(c.locDestStart,this.mat4param[2],this.mat4param[3]);c.locDestEnd&&d.uniform2f(c.locDestEnd,this.mat4param[4],this.mat4param[5]);c.locLayerScale&&d.uniform1f(c.locLayerScale,this.mat4param[6]);c.locSeconds&&d.uniform1f(c.locSeconds,cr.performance_now()/1E3);if(c.parameters.length){a=0;for(b=c.parameters.length;a<b;a++)d.uniform1f(c.parameters[a][1],this.shaderParams[a])}};a.prototype.pushBatch=function(){this.batchPtr===this.batch.length&&
this.batch.push(new c(0,this));return this.batch[this.batchPtr++]};a.prototype.endBatch=function(){if(0!==this.batchPtr&&!this.gl.isContextLost()){var a=this.gl;0<this.pointPtr&&(a.bindBuffer(a.ARRAY_BUFFER,this.pointBuffer),a.bufferData(a.ARRAY_BUFFER,this.pointData.subarray(0,this.pointPtr),a.STREAM_DRAW),b&&(0<=b.locAPos&&"<point>"===b.name)&&a.vertexAttribPointer(b.locAPos,4,a.FLOAT,!1,0,0));if(0<this.vertexPtr){var b=this.currentShader;a.bindBuffer(a.ARRAY_BUFFER,this.vertexBuffers[this.curBuffer]);
a.bufferData(a.ARRAY_BUFFER,this.vertexData.subarray(0,this.vertexPtr),a.STREAM_DRAW);b&&(0<=b.locAPos&&"<point>"!==b.name)&&a.vertexAttribPointer(b.locAPos,2,a.FLOAT,!1,0,0);a.bindBuffer(a.ARRAY_BUFFER,this.texcoordBuffers[this.curBuffer]);a.bufferData(a.ARRAY_BUFFER,this.texcoordData.subarray(0,this.vertexPtr),a.STREAM_DRAW);b&&(0<=b.locATex&&"<point>"!==b.name)&&a.vertexAttribPointer(b.locATex,2,a.FLOAT,!1,0,0)}for(var c,a=0,b=this.batchPtr;a<b;a++)switch(c=this.batch[a],c.type){case 1:c.doQuad();
break;case 2:c.doSetTexture();break;case 3:c.doSetOpacity();break;case 4:c.doSetBlend();break;case 5:c.doUpdateModelView();break;case 6:c.doRenderToTexture();break;case 7:c.doClear();break;case 8:c.doPoints();break;case 9:c.doSetProgram();break;case 10:c.doSetProgramParameters()}this.pointPtr=this.vertexPtr=this.batchPtr=0;this.hasPointBatchTop=this.hasQuadBatchTop=!1;this.curBuffer++;4<=this.curBuffer&&(this.curBuffer=0)}};a.prototype.setOpacity=function(a){if(a!==this.lastOpacity){var b=this.pushBatch();
b.type=3;this.lastOpacity=b.opacityParam=a;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.setTexture=function(a){if(a!==this.lastTexture){var b=this.pushBatch();b.type=2;this.lastTexture=b.texParam=a;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.setBlend=function(a,b){if(!(a===this.lastSrcBlend&&b===this.lastDestBlend)){var c=this.pushBatch();c.type=4;c.startIndex=a;c.indexCount=b;this.lastSrcBlend=a;this.lastDestBlend=b;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.setAlphaBlend=
function(){this.setBlend(this.gl.ONE,this.gl.ONE_MINUS_SRC_ALPHA)};a.prototype.quad=function(a,b,c,d,e,f,q,p){15992<=this.vertexPtr&&this.endBatch();var r=this.vertexPtr,s=this.vertexData,t=this.texcoordData;if(this.hasQuadBatchTop)this.batch[this.batchPtr-1].indexCount+=6;else{var v=this.pushBatch();v.type=1;v.startIndex=3*(r/4);v.indexCount=6;this.hasQuadBatchTop=!0;this.hasPointBatchTop=!1}s[r]=a;t[r++]=0;s[r]=b;t[r++]=0;s[r]=c;t[r++]=1;s[r]=d;t[r++]=0;s[r]=e;t[r++]=1;s[r]=f;t[r++]=1;s[r]=q;t[r++]=
0;s[r]=p;t[r++]=1;this.vertexPtr=r};a.prototype.quadTex=function(a,b,c,d,e,f,q,p,r){15992<=this.vertexPtr&&this.endBatch();var s=this.vertexPtr,t=this.vertexData,v=this.texcoordData;if(this.hasQuadBatchTop)this.batch[this.batchPtr-1].indexCount+=6;else{var y=this.pushBatch();y.type=1;y.startIndex=3*(s/4);y.indexCount=6;this.hasQuadBatchTop=!0;this.hasPointBatchTop=!1}t[s]=a;v[s++]=r.left;t[s]=b;v[s++]=r.top;t[s]=c;v[s++]=r.right;t[s]=d;v[s++]=r.top;t[s]=e;v[s++]=r.right;t[s]=f;v[s++]=r.bottom;t[s]=
q;v[s++]=r.left;t[s]=p;v[s++]=r.bottom;this.vertexPtr=s};a.prototype.point=function(a,b,c,d){7996<=this.pointPtr&&this.endBatch();var e=this.pointPtr,f=this.pointData;if(this.hasPointBatchTop)this.batch[this.batchPtr-1].indexCount++;else{var q=this.pushBatch();q.type=8;q.startIndex=e;q.indexCount=1;this.hasPointBatchTop=!0;this.hasQuadBatchTop=!1}f[e++]=a;f[e++]=b;f[e++]=c;f[e++]=d;this.pointPtr=e};a.prototype.switchProgram=function(a){if(this.lastProgram!==a){if(!this.shaderPrograms[a]){if(0===this.lastProgram)return;
a=0}var b=this.pushBatch();b.type=9;this.lastProgram=b.startIndex=a;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.programUsesDest=function(a){a=this.shaderPrograms[a];return!(!a.locDestStart&&!a.locDestEnd)};a.prototype.programUsesCrossSampling=function(a){return this.shaderPrograms[a].crossSampling};a.prototype.programExtendsBox=function(a){a=this.shaderPrograms[a];return 0!==a.extendBoxHorizontal||0!==a.extendBoxVertical};a.prototype.getProgramBoxExtendHorizontal=function(a){return this.shaderPrograms[a].extendBoxHorizontal};
a.prototype.getProgramBoxExtendVertical=function(a){return this.shaderPrograms[a].extendBoxVertical};a.prototype.getProgramParameterType=function(a,b){return this.shaderPrograms[a].parameters[b][2]};a.prototype.programIsAnimated=function(a){return this.shaderPrograms[a].animated};a.prototype.setProgramParameters=function(a,b,c,d,e,f,q,p,r){var s=this.shaderPrograms[this.lastProgram];if(s.locPixelWidth||s.locPixelHeight||s.locSeconds||s.locSamplerBack||s.locDestStart||s.locDestEnd||s.locLayerScale||
r.length){s=this.pushBatch();s.type=10;s.mat4param?mat4.set(this.matMV,s.mat4param):s.mat4param=mat4.create();s.mat4param[0]=b;s.mat4param[1]=c;s.mat4param[2]=d;s.mat4param[3]=e;s.mat4param[4]=f;s.mat4param[5]=q;s.mat4param[6]=p;s.texParam=a;if(r.length){s.shaderParams.length=r.length;a=0;for(b=r.length;a<b;a++)s.shaderParams[a]=r[a]}this.hasPointBatchTop=this.hasQuadBatchTop=!1}};a.prototype.clear=function(a,b,c,d){var e=this.pushBatch();e.type=7;e.startIndex=0;e.mat4param||(e.mat4param=mat4.create());
e.mat4param[0]=a;e.mat4param[1]=b;e.mat4param[2]=c;e.mat4param[3]=d;this.hasPointBatchTop=this.hasQuadBatchTop=!1};a.prototype.clearRect=function(a,b,c,d){var e=this.pushBatch();e.type=7;e.startIndex=1;e.mat4param||(e.mat4param=mat4.create());e.mat4param[0]=a;e.mat4param[1]=b;e.mat4param[2]=c;e.mat4param[3]=d;this.hasPointBatchTop=this.hasQuadBatchTop=!1};a.prototype.present=function(){this.endBatch();this.gl.flush()};var e=[],f={};a.prototype.loadTexture=function(a,b,c,k,m){b=!!b;c=!!c;var n=a.src+
","+b+","+c+(b?","+m:""),q=null;if("undefined"!==typeof a.src&&f.hasOwnProperty(n))return q=f[n],q.c2refcount++,q;this.endBatch();var p=this.gl,r=cr.isPOT(a.width)&&cr.isPOT(a.height),q=p.createTexture();p.bindTexture(p.TEXTURE_2D,q);p.pixelStorei(p.UNPACK_PREMULTIPLY_ALPHA_WEBGL,!0);var s=p.RGBA,t=p.RGBA,v=p.UNSIGNED_BYTE;if(k)switch(k){case 1:t=s=p.RGB;break;case 2:v=p.UNSIGNED_SHORT_4_4_4_4;break;case 3:v=p.UNSIGNED_SHORT_5_5_5_1;break;case 4:t=s=p.RGB,v=p.UNSIGNED_SHORT_5_6_5}!r&&b?(k=document.createElement("canvas"),
k.width=d(a.width),k.height=d(a.height),k.getContext("2d").drawImage(a,0,0,a.width,a.height,0,0,k.width,k.height),p.texImage2D(p.TEXTURE_2D,0,s,t,v,k)):p.texImage2D(p.TEXTURE_2D,0,s,t,v,a);b?"repeat-x"===m?(p.texParameteri(p.TEXTURE_2D,p.TEXTURE_WRAP_S,p.REPEAT),p.texParameteri(p.TEXTURE_2D,p.TEXTURE_WRAP_T,p.CLAMP_TO_EDGE)):("repeat-y"===m?p.texParameteri(p.TEXTURE_2D,p.TEXTURE_WRAP_S,p.CLAMP_TO_EDGE):p.texParameteri(p.TEXTURE_2D,p.TEXTURE_WRAP_S,p.REPEAT),p.texParameteri(p.TEXTURE_2D,p.TEXTURE_WRAP_T,
p.REPEAT)):(p.texParameteri(p.TEXTURE_2D,p.TEXTURE_WRAP_S,p.CLAMP_TO_EDGE),p.texParameteri(p.TEXTURE_2D,p.TEXTURE_WRAP_T,p.CLAMP_TO_EDGE));c?(p.texParameteri(p.TEXTURE_2D,p.TEXTURE_MAG_FILTER,p.LINEAR),r?(p.texParameteri(p.TEXTURE_2D,p.TEXTURE_MIN_FILTER,p.LINEAR_MIPMAP_LINEAR),p.generateMipmap(p.TEXTURE_2D)):p.texParameteri(p.TEXTURE_2D,p.TEXTURE_MIN_FILTER,p.LINEAR)):(p.texParameteri(p.TEXTURE_2D,p.TEXTURE_MAG_FILTER,p.NEAREST),p.texParameteri(p.TEXTURE_2D,p.TEXTURE_MIN_FILTER,p.NEAREST));p.bindTexture(p.TEXTURE_2D,
null);this.lastTexture=null;q.c2width=a.width;q.c2height=a.height;q.c2refcount=1;q.c2texkey=n;e.push(q);return f[n]=q};a.prototype.createEmptyTexture=function(a,b,c,d){this.endBatch();var f=this.gl,n=f.createTexture();f.bindTexture(f.TEXTURE_2D,n);f.texImage2D(f.TEXTURE_2D,0,f.RGBA,a,b,0,f.RGBA,d?f.UNSIGNED_SHORT_4_4_4_4:f.UNSIGNED_BYTE,null);f.texParameteri(f.TEXTURE_2D,f.TEXTURE_WRAP_S,f.CLAMP_TO_EDGE);f.texParameteri(f.TEXTURE_2D,f.TEXTURE_WRAP_T,f.CLAMP_TO_EDGE);f.texParameteri(f.TEXTURE_2D,f.TEXTURE_MAG_FILTER,
c?f.LINEAR:f.NEAREST);f.texParameteri(f.TEXTURE_2D,f.TEXTURE_MIN_FILTER,c?f.LINEAR:f.NEAREST);f.bindTexture(f.TEXTURE_2D,null);this.lastTexture=null;n.c2width=a;n.c2height=b;e.push(n);return n};a.prototype.videoToTexture=function(a,b,c){this.endBatch();var d=this.gl;d.bindTexture(d.TEXTURE_2D,b);d.texImage2D(d.TEXTURE_2D,0,d.RGBA,d.RGBA,c?d.UNSIGNED_SHORT_4_4_4_4:d.UNSIGNED_BYTE,a);d.bindTexture(d.TEXTURE_2D,null);this.lastTexture=null};a.prototype.deleteTexture=function(a){a&&("undefined"!==typeof a.c2refcount&&
1<a.c2refcount?a.c2refcount--:(this.endBatch(),this.gl.bindTexture(this.gl.TEXTURE_2D,null),this.lastTexture=null,cr.arrayFindRemove(e,a),"undefined"!==typeof a.c2texkey&&delete f[a.c2texkey],this.gl.deleteTexture(a)))};a.prototype.estimateVRAM=function(){var a=8*this.width*this.height,b,c,d;b=0;for(c=e.length;b<c;b++)d=e[b],a+=4*d.c2width*d.c2height;return a};a.prototype.textureCount=function(){return e.length};a.prototype.setRenderingToTexture=function(a){if(a!==this.renderToTex){var b=this.pushBatch();
b.type=6;this.renderToTex=b.texParam=a;this.hasPointBatchTop=this.hasQuadBatchTop=!1}};cr.GLWrap=a})();
(function(){function a(a){if(a&&(a.getContext||a.dc)&&!a.c2runtime){a.c2runtime=this;var b=this;this.isPhoneGap="undefined"!==typeof window.device&&("undefined"!==typeof window.device.cordova||"undefined"!==typeof window.device.phonegap);this.isDirectCanvas=!!a.dc;this.isAppMobi="undefined"!==typeof window.AppMobi||this.isDirectCanvas;if(this.isCocoonJs=!!window.c2cocoonjs)CocoonJS.App.onSuspended.addEventListener(function(){b.setSuspended(!0)}),CocoonJS.App.onActivated.addEventListener(function(){b.setSuspended(!1)});
this.isDomFree=this.isDirectCanvas||this.isCocoonJs;this.isTizen=/tizen/i.test(navigator.userAgent);this.isAndroid=/android/i.test(navigator.userAgent)&&!this.isTizen;this.isIE=/msie/i.test(navigator.userAgent);this.isiPhone=/iphone/i.test(navigator.userAgent)||/ipod/i.test(navigator.userAgent);this.isiPad=/ipad/i.test(navigator.userAgent);this.isiOS=this.isiPhone||this.isiPad;this.isChrome=/chrome/i.test(navigator.userAgent)||/chromium/i.test(navigator.userAgent);this.isSafari=!this.isChrome&&/safari/i.test(navigator.userAgent);
this.isWindows=/windows/i.test(navigator.userAgent);this.isNodeWebkit="undefined"!==typeof window.c2nodewebkit;this.isArcade="undefined"!==typeof window.is_scirra_arcade;this.isWindows8App=!!("undefined"!==typeof window.c2isWindows8&&window.c2isWindows8);this.isWindowsPhone8=!!("undefined"!==typeof window.c2isWindowsPhone8&&window.c2isWindowsPhone8);this.isBlackberry10=!!("undefined"!==typeof window.c2isBlackberry10&&window.c2isBlackberry10);this.devicePixelRatio=1;this.isMobile=this.isPhoneGap||
this.isAppMobi||this.isCocoonJs||this.isAndroid||this.isiOS||this.isWindowsPhone8||this.isBlackberry10||this.isTizen;this.isMobile||(this.isMobile=/(blackberry|bb10|playbook|palm|symbian|nokia|windows\s+ce|phone|mobile|tablet)/i.test(navigator.userAgent));if("undefined"!==typeof cr_is_preview&&!this.isNodeWebkit&&("?nw"===window.location.search||/nodewebkit/i.test(navigator.userAgent)))this.isNodeWebkit=!0;this.isDebug="undefined"!==typeof cr_is_preview&&-1<window.location.search.indexOf("debug");
this.canvas=a;this.canvasdiv=document.getElementById("c2canvasdiv");this.ctx=this.glwrap=this.gl=null;this.canvas.oncontextmenu=function(a){a.preventDefault&&a.preventDefault();return!1};this.canvas.onselectstart=function(a){a.preventDefault&&a.preventDefault();return!1};this.isDirectCanvas&&(window.c2runtime=this);this.isNodeWebkit&&(window.ondragover=function(a){a.preventDefault();return!1},window.ondrop=function(a){a.preventDefault();return!1});this.width=a.width;this.height=a.height;this.lastwidth=
this.width;this.lastheight=this.height;this.redraw=!0;this.isSuspended=!1;Date.now||(Date.now=function(){return+new Date});this.plugins=[];this.types={};this.types_by_index=[];this.behaviors=[];this.layouts={};this.layouts_by_index=[];this.eventsheets={};this.eventsheets_by_index=[];this.wait_for_textures=[];this.triggers_to_postinit=[];this.all_global_vars=[];this.all_local_vars=[];this.deathRow=new cr.ObjectSet;this.isInClearDeathRow=!1;this.isInOnDestroy=0;this.isRunningEvents=!1;this.createRow=
[];this.isLoadingState=!1;this.lastSaveJson=this.loadFromJson=this.loadFromSlot=this.saveToSlot="";this.suspendDrawing=this.signalledContinuousPreview=!1;this.zeroDtCount=this.cpuutilisation=this.logictime=this.dt1=this.dt=0;this.timescale=1;this.kahanTime=new cr.KahanAdder;this.last_tick_time=0;this.measuring_dt=!0;this.objectcount=this.framecount=this.execcount=this.tickcount=this.last_fps_time=this.fps=0;this.changelayout=null;this.destroycallbacks=[];this.event_stack=[];this.event_stack_index=
-1;this.localvar_stack=[[]];this.trigger_depth=this.localvar_stack_index=0;this.pushEventStack(null);this.loop_stack=[];this.loop_stack_index=-1;this.next_puid=this.next_uid=0;this.layout_first_tick=!0;this.family_count=0;this.suspend_events=[];this.timeout_id=this.raf_id=0;this.isloading=!0;this.loadingprogress=0;this.isNodeFullscreen=!1;this.stackLocalCount=0;this.had_a_click=!1;this.objects_to_tick=new cr.ObjectSet;this.objects_to_tick2=new cr.ObjectSet;this.registered_collisions=[];this.temp_poly=
new cr.CollisionPoly([]);this.temp_poly2=new cr.CollisionPoly([]);this.allGroups=[];this.activeGroups={};this.cndsBySid={};this.actsBySid={};this.varsBySid={};this.blocksBySid={};this.layout_tex=this.layer_tex=this.layer_ctx=this.layer_canvas=this.running_layout=null;this.uses_background_blending=this.is_WebGL_context_lost=!1;this.fx_tex=[null,null];this.fullscreen_scaling=0;this.files_subfolder="";this.objectsByUid={};this.snapshotCanvas=this.loaderlogo=null;this.snapshotData="";this.load();this.devicePixelRatio=
(this.isRetina=!this.isDomFree&&this.useiOSRetina&&(this.isiOS||this.isTizen))?window.devicePixelRatio||1:1;this.ClearDeathRow();var c;"undefined"!==typeof jQuery&&0<this.fullscreen_mode&&this.setSize(jQuery(window).width(),jQuery(window).height());try{if(this.enableWebGL&&(this.isCocoonJs||!this.isDomFree)){c={depth:!1,antialias:!this.isMobile};var d=!0;if(this.isChrome&&this.isWindows){var e=document.createElement("canvas");if("OES_texture_float,OES_standard_derivatives,WEBKIT_WEBGL_lose_context"===
(e.getContext("webgl",c)||e.getContext("experimental-webgl",c)).getSupportedExtensions().toString())d=!1}d&&(this.gl=a.getContext("webgl",c)||a.getContext("experimental-webgl",c))}}catch(f){}if(this.gl){this.isDomFree||(this.overlay_canvas=document.createElement("canvas"),jQuery(this.overlay_canvas).appendTo(this.canvas.parentNode),this.overlay_canvas.oncontextmenu=function(a){return!1},this.overlay_canvas.onselectstart=function(a){return!1},this.overlay_canvas.width=a.width,this.overlay_canvas.height=
a.height,this.positionOverlayCanvas(),this.overlay_ctx=this.overlay_canvas.getContext("2d"));this.glwrap=new cr.GLWrap(this.gl,this.isMobile);this.glwrap.setSize(a.width,a.height);this.ctx=null;this.canvas.addEventListener("webglcontextlost",function(a){a.preventDefault();b.onContextLost();window.cr_setSuspended(!0)},!1);this.canvas.addEventListener("webglcontextrestored",function(a){b.glwrap.initState();b.glwrap.setSize(b.glwrap.width,b.glwrap.height,!0);b.layer_tex=null;b.layout_tex=null;b.fx_tex[0]=
null;b.fx_tex[1]=null;b.onContextRestored();b.redraw=!0;window.cr_setSuspended(!1)},!1);var h,k,g,m,l;a=0;for(c=this.types_by_index.length;a<c;a++){h=this.types_by_index[a];d=0;for(e=h.effect_types.length;d<e;d++)g=h.effect_types[d],g.shaderindex=this.glwrap.getShaderIndex(g.id),this.uses_background_blending=this.uses_background_blending||this.glwrap.programUsesDest(g.shaderindex)}a=0;for(c=this.layouts_by_index.length;a<c;a++){m=this.layouts_by_index[a];d=0;for(e=m.effect_types.length;d<e;d++)g=
m.effect_types[d],g.shaderindex=this.glwrap.getShaderIndex(g.id);d=0;for(e=m.layers.length;d<e;d++){l=m.layers[d];h=0;for(k=l.effect_types.length;h<k;h++)g=l.effect_types[h],g.shaderindex=this.glwrap.getShaderIndex(g.id),this.uses_background_blending=this.uses_background_blending||this.glwrap.programUsesDest(g.shaderindex)}}}else{if(0<this.fullscreen_mode&&this.isDirectCanvas){this.canvas=null;document.oncontextmenu=function(a){return!1};document.onselectstart=function(a){return!1};this.ctx=AppMobi.canvas.getContext("2d");
try{this.ctx.samplingMode=this.linearSampling?"smooth":"sharp",this.ctx.globalScale=1,this.ctx.HTML5CompatibilityMode=!0}catch(p){}0!==this.width&&0!==this.height&&(this.ctx.width=this.width,this.ctx.height=this.height)}this.ctx||(this.isCocoonJs?(c={antialias:!!this.linearSampling},this.ctx=a.getContext("2d",c)):this.ctx=a.getContext("2d"),this.ctx.webkitImageSmoothingEnabled=this.linearSampling,this.ctx.mozImageSmoothingEnabled=this.linearSampling,this.ctx.msImageSmoothingEnabled=this.linearSampling,
this.ctx.imageSmoothingEnabled=this.linearSampling);this.overlay_ctx=this.overlay_canvas=null}this.tickFunc=function(){b.tick()};window!=window.top&&(!this.isDomFree&&!this.isWindows8App)&&(document.addEventListener("mousedown",function(){window.focus()},!0),document.addEventListener("touchstart",function(){window.focus()},!0));"undefined"!==typeof cr_is_preview&&(this.isCocoonJs&&console.log("[Construct 2] In preview-over-wifi via CocoonJS mode"),-1<window.location.search.indexOf("continuous")&&
(cr.logexport("Reloading for continuous preview"),this.loadFromSlot="__c2_continuouspreview",this.suspendDrawing=!0),this.pauseOnBlur&&!this.isMobile&&(jQuery(window).focus(function(){b.setSuspended(!1)}),jQuery(window).blur(function(){b.setSuspended(!0)})));this.go();this.extra={};cr.seal(this)}}function b(a){a.target.result.createObjectStore("saves",{keyPath:"slot"})}function c(a,c,d,e){var f=indexedDB.open("_C2SaveStates");f.onupgradeneeded=b;f.onerror=e;f.onsuccess=function(b){b=b.target.result;
b.onerror=e;b.transaction(["saves"],"readwrite").objectStore("saves").put({slot:a,data:c}).onsuccess=d}}function d(a,c,d){var e=indexedDB.open("_C2SaveStates");e.onupgradeneeded=b;e.onerror=d;e.onsuccess=function(b){b=b.target.result;b.onerror=d;var e=b.transaction(["saves"]).objectStore("saves").get(a);e.onsuccess=function(a){e.result?c(e.result.data):c(null)}}}function e(){cr.logexport("Reloading for continuous preview");window.c2cocoonjs?CocoonJS.App.reload():-1<window.location.search.indexOf("continuous")?
window.location.reload(!0):window.location+="?continuous"}function f(a){var b,c={};for(b in a)a.hasOwnProperty(b)&&!(a[b]instanceof cr.ObjectSet)&&"undefined"===typeof a[b].c2userdata&&(c[b]=a[b]);return c}a.prototype.setSize=function(a,b){var c=this.hideAddressBar&&this.isiPhone&&!navigator.standalone&&!this.isDomFree&&!this.isPhoneGap,d=0;c&&(this.isiPhone?d=60:this.isAndroid&&(d=56),b+=d);var e=0,f=0,h=0,k=0,g=0,g=this.fullscreen_mode,m=document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||
this.isNodeFullscreen;m&&0<this.fullscreen_scaling&&(g=this.fullscreen_scaling);4<=g?(h=this.original_width/this.original_height,a/b>h?(h*=b,5===g?(g=h/this.original_width,1<g?g=Math.floor(g):1>g&&(g=1/Math.ceil(1/g)),h=this.original_width*g,k=this.original_height*g,e=(a-h)/2,f=(b-k)/2,a=h,b=k):(e=(a-h)/2,a=h)):(k=a/h,5===g?(g=k/this.original_height,1<g?g=Math.floor(g):1>g&&(g=1/Math.ceil(1/g)),h=this.original_width*g,k=this.original_height*g,e=(a-h)/2,f=(b-k)/2,a=h):f=(b-k)/2,b=k),m&&!this.isNodeWebkit&&
(f=e=0),e=Math.floor(e),f=Math.floor(f),a=Math.floor(a),b=Math.floor(b)):this.isNodeWebkit&&(this.isNodeFullscreen&&0===this.fullscreen_mode_set)&&(e=Math.floor((a-this.original_width)/2),f=Math.floor((b-this.original_height)/2),a=this.original_width,b=this.original_height);this.isRetina&&(this.isiPad&&1<this.devicePixelRatio)&&(1024<=a&&(a=1023),1024<=b&&(b=1023));m=this.devicePixelRatio;this.width=a*m;this.height=b*m;this.redraw=!0;this.canvasdiv&&!this.isDomFree&&(jQuery(this.canvasdiv).css({width:a+
"px",height:b+"px","margin-left":e,"margin-top":f}),"undefined"!==typeof cr_is_preview&&jQuery("#borderwrap").css({width:a+"px",height:b+"px"}));this.canvas&&(this.canvas.width=a*m,this.canvas.height=b*m,this.isRetina&&jQuery(this.canvas).css({width:a+"px",height:b+"px"}));this.overlay_canvas&&(this.overlay_canvas.width=a,this.overlay_canvas.height=b);this.glwrap&&this.glwrap.setSize(a,b);this.isDirectCanvas&&this.ctx&&(this.ctx.width=a,this.ctx.height=b);this.ctx&&(this.ctx.webkitImageSmoothingEnabled=
this.linearSampling,this.ctx.mozImageSmoothingEnabled=this.linearSampling,this.ctx.msImageSmoothingEnabled=this.linearSampling,this.ctx.imageSmoothingEnabled=this.linearSampling);c&&0<d&&window.setTimeout(function(){window.scrollTo(0,1)},100)};a.prototype.onContextLost=function(){this.is_WebGL_context_lost=!0;var a,b,c;a=0;for(b=this.types_by_index.length;a<b;a++)if(c=this.types_by_index[a],c.onLostWebGLContext)c.onLostWebGLContext()};a.prototype.onContextRestored=function(){this.is_WebGL_context_lost=
!1;var a,b,c;a=0;for(b=this.types_by_index.length;a<b;a++)if(c=this.types_by_index[a],c.onRestoreWebGLContext)c.onRestoreWebGLContext()};a.prototype.positionOverlayCanvas=function(){if(!this.isDomFree){var a=document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||this.isNodeFullscreen?jQuery(this.canvas).offset():jQuery(this.canvas).position();a.position="absolute";jQuery(this.overlay_canvas).css(a)}};var g=window.cancelAnimationFrame||window.mozCancelAnimationFrame||window.webkitCancelAnimationFrame||
window.msCancelAnimationFrame||window.oCancelAnimationFrame;a.prototype.setSuspended=function(a){var b;if(a&&!this.isSuspended){cr.logexport("[Construct 2] Suspending");this.isSuspended=!0;0!==this.raf_id&&g&&g(this.raf_id);0!==this.timeout_id&&clearTimeout(this.timeout_id);a=0;for(b=this.suspend_events.length;a<b;a++)this.suspend_events[a](!0)}else if(!a&&this.isSuspended){cr.logexport("[Construct 2] Resuming");this.isSuspended=!1;this.last_tick_time=cr.performance_now();this.last_fps_time=cr.performance_now();
a=this.logictime=this.framecount=0;for(b=this.suspend_events.length;a<b;a++)this.suspend_events[a](!1);this.tick()}};a.prototype.addSuspendCallback=function(a){this.suspend_events.push(a)};a.prototype.load=function(){var a=cr.getProjectModel();this.name=a[0];this.first_layout=a[1];this.fullscreen_mode=a[11];this.fullscreen_mode_set=a[11];if(this.isDomFree&&(4<=a[11]||0===a[11]))cr.logexport("[Construct 2] Letterbox scale fullscreen modes are not supported on this platform - falling back to 'Scale outer'"),
this.fullscreen_mode_set=this.fullscreen_mode=3;this.uses_loader_layout=a[17];this.loaderstyle=a[18];0===this.loaderstyle&&(this.loaderlogo=new Image,this.loaderlogo.src="loading-logo.png");this.next_uid=a[20];this.system=new cr.system_object(this);var b,c,d,e,f,h,k,g,m;b=0;for(c=a[2].length;b<c;b++){k=a[2][b];cr.add_common_aces(k);m=new k[0](this);m.singleglobal=k[1];m.is_world=k[2];m.must_predraw=k[9];if(m.onCreate)m.onCreate();cr.seal(m);this.plugins.push(m)}a=cr.getProjectModel();b=0;for(c=a[3].length;b<
c;b++){k=a[3][b];f=k[1];m=null;d=0;for(e=this.plugins.length;d<e;d++)if(this.plugins[d]instanceof f){m=this.plugins[d];break}var l=new m.Type(m);l.name=k[0];l.is_family=k[2];l.instvar_sids=k[3].slice(0);l.vars_count=k[3].length;l.behs_count=k[4];l.fx_count=k[5];l.sid=k[11];l.is_family?(l.members=[],l.family_index=this.family_count++,l.families=null):(l.members=null,l.family_index=-1,l.families=[]);l.family_var_map=null;l.family_beh_map=null;l.family_fx_map=null;l.is_contained=!1;l.container=null;
k[6]?(l.texture_file=k[6][0],l.texture_filesize=k[6][1],l.texture_pixelformat=k[6][2]):(l.texture_file=null,l.texture_filesize=0,l.texture_pixelformat=0);l.animations=k[7]?k[7]:null;l.index=b;l.instances=[];l.deadCache=[];l.solstack=[new cr.selection(l)];l.cur_sol=0;l.default_instance=null;l.stale_iids=!0;l.updateIIDs=cr.type_updateIIDs;l.getFirstPicked=cr.type_getFirstPicked;l.getPairedInstance=cr.type_getPairedInstance;l.getCurrentSol=cr.type_getCurrentSol;l.pushCleanSol=cr.type_pushCleanSol;l.pushCopySol=
cr.type_pushCopySol;l.popSol=cr.type_popSol;l.getBehaviorByName=cr.type_getBehaviorByName;l.getBehaviorIndexByName=cr.type_getBehaviorIndexByName;l.getEffectIndexByName=cr.type_getEffectIndexByName;l.applySolToContainer=cr.type_applySolToContainer;l.extra={};l.toString=cr.type_toString;l.behaviors=[];d=0;for(e=k[8].length;d<e;d++){g=k[8][d];var p=g[1],n=null;f=0;for(h=this.behaviors.length;f<h;f++)if(this.behaviors[f]instanceof p){n=this.behaviors[f];break}if(!n){n=new p(this);n.my_instances=new cr.ObjectSet;
if(n.onCreate)n.onCreate();cr.seal(n);this.behaviors.push(n)}f=new n.Type(n,l);f.name=g[0];f.sid=g[2];f.onCreate();cr.seal(f);l.behaviors.push(f)}l.global=k[9];l.isOnLoaderLayout=k[10];l.effect_types=[];d=0;for(e=k[12].length;d<e;d++)l.effect_types.push({id:k[12][d][0],name:k[12][d][1],shaderindex:-1,active:!0,index:d});if(!this.uses_loader_layout||l.is_family||l.isOnLoaderLayout||!m.is_world)l.onCreate(),cr.seal(l);l.name&&(this.types[l.name]=l);this.types_by_index.push(l);m.singleglobal&&(d=new m.Instance(l),
d.uid=this.next_uid++,d.puid=this.next_puid++,d.iid=0,d.get_iid=cr.inst_get_iid,d.toString=cr.inst_toString,d.properties=k[13],d.onCreate(),cr.seal(d),l.instances.push(d),this.objectsByUid[d.uid.toString()]=d)}b=0;for(c=a[4].length;b<c;b++){f=a[4][b];h=this.types_by_index[f[0]];d=1;for(e=f.length;d<e;d++)k=this.types_by_index[f[d]],k.families.push(h),h.members.push(k)}b=0;for(c=a[22].length;b<c;b++){f=a[22][b];h=[];d=0;for(e=f.length;d<e;d++)h.push(this.types_by_index[f[d]]);d=0;for(e=h.length;d<
e;d++)h[d].is_contained=!0,h[d].container=h}if(0<this.family_count){b=0;for(c=this.types_by_index.length;b<c;b++)if(k=this.types_by_index[b],!k.is_family&&k.families.length){k.family_var_map=Array(this.family_count);k.family_beh_map=Array(this.family_count);k.family_fx_map=Array(this.family_count);l=[];d=n=p=g=0;for(e=k.families.length;d<e;d++){m=k.families[d];k.family_var_map[m.family_index]=g;g+=m.vars_count;k.family_beh_map[m.family_index]=p;p+=m.behs_count;k.family_fx_map[m.family_index]=n;n+=
m.fx_count;f=0;for(h=m.effect_types.length;f<h;f++)l.push(cr.shallowCopy({},m.effect_types[f]))}k.effect_types=l.concat(k.effect_types);d=0;for(e=k.effect_types.length;d<e;d++)k.effect_types[d].index=d}}b=0;for(c=a[5].length;b<c;b++)k=a[5][b],d=new cr.layout(this,k),cr.seal(d),this.layouts[d.name]=d,this.layouts_by_index.push(d);b=0;for(c=a[6].length;b<c;b++)k=a[6][b],d=new cr.eventsheet(this,k),cr.seal(d),this.eventsheets[d.name]=d,this.eventsheets_by_index.push(d);b=0;for(c=this.eventsheets_by_index.length;b<
c;b++)this.eventsheets_by_index[b].postInit();b=0;for(c=this.triggers_to_postinit.length;b<c;b++)this.triggers_to_postinit[b].postInit();this.triggers_to_postinit.length=0;this.files_subfolder=a[7];this.pixel_rounding=a[8];this.original_width=a[9];this.original_height=a[10];this.aspect_scale=1;this.enableWebGL=a[12];this.linearSampling=a[13];this.clearBackground=a[14];this.versionstr=a[15];b=a[16];2===b&&(b=this.isiPhone?1:0);this.useiOSRetina=0!==b;this.hideAddressBar=a[19];this.pauseOnBlur=a[21];
this.start_time=Date.now()};a.prototype.findWaitingTexture=function(a){var b,c;b=0;for(c=this.wait_for_textures.length;b<c;b++)if(this.wait_for_textures[b].cr_src===a)return this.wait_for_textures[b];return null};a.prototype.areAllTexturesLoaded=function(){var a=0,b=0,c=!0,d,e;d=0;for(e=this.wait_for_textures.length;d<e;d++){var f=this.wait_for_textures[d].cr_filesize;if(!f||0>=f)f=5E4;a+=f;this.wait_for_textures[d].complete||this.wait_for_textures[d].loaded?b+=f:c=!1}this.progress=0==a?0:b/a;return c};
a.prototype.go=function(){if(this.ctx||this.glwrap){var a=this.ctx||this.overlay_ctx;this.overlay_canvas&&this.positionOverlayCanvas();this.progress=0;this.last_progress=-1;if(this.areAllTexturesLoaded())this.go_textures_done();else{var b=Date.now()-this.start_time,c=1;this.isTizen&&(c=this.devicePixelRatio);if(a){if(3!==this.loaderstyle&&500<=b&&this.last_progress!=this.progress){a.clearRect(0,0,this.width,this.height);var b=this.width/(2*c),c=this.height/(2*c),d=0===this.loaderstyle&&this.loaderlogo.complete,
e=40,f=0,h=80;d&&(h=this.loaderlogo.width,e=h/2,f=this.loaderlogo.height/2,a.drawImage(this.loaderlogo,cr.floor(b-e),cr.floor(c-f)));1>=this.loaderstyle?(c+=f+(d?12:0),b=cr.floor(b-e)+0.5,c=cr.floor(c)+0.5,a.fillStyle="DodgerBlue",a.fillRect(b,c,Math.floor(h*this.progress),6),a.strokeStyle="black",a.strokeRect(b,c,h,6),a.strokeStyle="white",a.strokeRect(b-1,c-1,h+2,8)):2===this.loaderstyle&&(a.font="12pt Arial",a.fillStyle="#999",a.textBaseLine="middle",d=Math.round(100*this.progress)+"%",e=a.measureText?
a.measureText(d):null,a.fillText(d,b-(e?e.width:0)/2,c))}this.last_progress=this.progress}setTimeout(function(a){return function(){a.go()}}(this),100)}}};a.prototype.go_textures_done=function(){this.overlay_canvas&&(this.canvas.parentNode.removeChild(this.overlay_canvas),this.overlay_canvas=this.overlay_ctx=null);this.start_time=Date.now();this.last_fps_time=cr.performance_now();var a,b,c;if(this.uses_loader_layout){a=0;for(b=this.types_by_index.length;a<b;a++)c=this.types_by_index[a],!c.is_family&&
(!c.isOnLoaderLayout&&c.plugin.is_world)&&(c.onCreate(),cr.seal(c))}else this.isloading=!1;a=0;for(b=this.layouts_by_index.length;a<b;a++)this.layouts_by_index[a].createGlobalNonWorlds();2<=this.fullscreen_mode&&(a=this.original_width/this.original_height,b=this.width/this.height,this.aspect_scale=2!==this.fullscreen_mode&&b>a||2===this.fullscreen_mode&&b<a?this.height/this.original_height:this.width/this.original_width);this.first_layout?this.layouts[this.first_layout].startRunning():this.layouts_by_index[0].startRunning();
this.uses_loader_layout||(this.loadingprogress=1,this.trigger(cr.system_object.prototype.cnds.OnLoadFinished,null));this.tick();this.isDirectCanvas&&AppMobi.webview.execute("onGameReady();")};var h=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.msRequestAnimationFrame||window.oRequestAnimationFrame;a.prototype.tick=function(){if(this.running_layout){var a=cr.performance_now();if(this.isArcade){var b=jQuery(window).width(),c=jQuery(window).height();
if(this.lastwidth!==b||this.lastheight!==c)this.lastwidth=b,this.lastheight=c,this.setSize(b,c)}this.isloading&&(b=this.areAllTexturesLoaded(),this.loadingprogress=this.progress,b&&(this.isloading=!1,this.progress=1,this.trigger(cr.system_object.prototype.cnds.OnLoadFinished,null)));this.logic();if((this.redraw||this.isCocoonJs)&&!this.is_WebGL_context_lost&&!this.suspendDrawing)this.redraw=!1,this.glwrap?this.drawGL():this.draw(),this.snapshotCanvas&&(this.canvas&&this.canvas.toDataURL&&(this.snapshotData=
this.canvas.toDataURL(this.snapshotCanvas[0],this.snapshotCanvas[1]),this.trigger(cr.system_object.prototype.cnds.OnCanvasSnapshot,null)),this.snapshotCanvas=null);this.tickcount++;this.execcount++;this.framecount++;this.logictime+=cr.performance_now()-a;this.isSuspended||(h?this.raf_id=h(this.tickFunc,this.canvas):this.timeout_id=setTimeout(this.tickFunc,this.isMobile?1:16))}};a.prototype.logic=function(){var a,b,c,d,e,f,h,k,g;a=cr.performance_now();1E3<=a-this.last_fps_time&&(this.last_fps_time+=
1E3,this.fps=this.framecount,this.framecount=0,this.cpuutilisation=this.logictime,this.logictime=0);this.measuring_dt&&(0!==this.last_tick_time&&(b=a-this.last_tick_time,0===b&&!this.isDebug?(this.zeroDtCount++,10<=this.zeroDtCout&&(this.measuring_dt=!1),this.dt1=1/60):(this.dt1=b/1E3,0.5<this.dt1?this.dt1=0:0.1<this.dt1&&(this.dt1=0.1))),this.last_tick_time=a);this.dt=this.dt1*this.timescale;this.kahanTime.add(this.dt);a=document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||this.isNodeFullscreen;
2<=this.fullscreen_mode||a&&0<this.fullscreen_scaling?(b=this.original_width/this.original_height,c=this.width/this.height,d=this.fullscreen_mode,a&&0<this.fullscreen_scaling&&(d=this.fullscreen_scaling),this.aspect_scale=2!==d&&c>b||2===d&&c<b?this.height/this.original_height:this.width/this.original_width,this.running_layout&&(this.running_layout.scrollToX(this.running_layout.scrollX),this.running_layout.scrollToY(this.running_layout.scrollY))):this.aspect_scale=1;this.ClearDeathRow();this.isInOnDestroy++;
this.system.runWaits();this.isInOnDestroy--;this.ClearDeathRow();this.isInOnDestroy++;a=0;for(b=this.types_by_index.length;a<b;a++)if(h=this.types_by_index[a],!(h.is_family||!h.behaviors.length&&!h.families.length)){c=0;for(d=h.instances.length;c<d;c++){k=h.instances[c];e=0;for(f=k.behavior_insts.length;e<f;e++)k.behavior_insts[e].tick()}}a=0;for(b=this.types_by_index.length;a<b;a++)if(h=this.types_by_index[a],!(h.is_family||!h.behaviors.length&&!h.families.length)){c=0;for(d=h.instances.length;c<
d;c++){k=h.instances[c];e=0;for(f=k.behavior_insts.length;e<f;e++)g=k.behavior_insts[e],g.posttick&&g.posttick()}}c=this.objects_to_tick.valuesRef();a=0;for(b=c.length;a<b;a++)c[a].tick();this.isInOnDestroy--;this.handleSaveLoad();for(a=0;this.changelayout&&10>a++;)this.doChangeLayout(this.changelayout);a=0;for(b=this.eventsheets_by_index.length;a<b;a++)this.eventsheets_by_index[a].hasRun=!1;this.running_layout.event_sheet&&this.running_layout.event_sheet.run();this.registered_collisions.length=0;
this.layout_first_tick=!1;this.isInOnDestroy++;a=0;for(b=this.types_by_index.length;a<b;a++)if(h=this.types_by_index[a],!(h.is_family||!h.behaviors.length&&!h.families.length)){c=0;for(d=h.instances.length;c<d;c++){k=h.instances[c];e=0;for(f=k.behavior_insts.length;e<f;e++)g=k.behavior_insts[e],g.tick2&&g.tick2()}}c=this.objects_to_tick2.valuesRef();a=0;for(b=c.length;a<b;a++)c[a].tick2();this.isInOnDestroy--};a.prototype.doChangeLayout=function(a){var b=this.running_layout;this.running_layout.stopRunning();
var c,d,e,f,h,k,g;if(this.glwrap){c=0;for(d=this.types_by_index.length;c<d;c++)h=this.types_by_index[c],h.is_family||h.unloadTextures&&((!h.global||0===h.instances.length)&&-1===a.initial_types.indexOf(h))&&h.unloadTextures()}b==a&&(this.system.waits.length=0);a.startRunning();c=0;for(d=this.types_by_index.length;c<d;c++)if(h=this.types_by_index[c],h.global||h.plugin.singleglobal){a=0;for(b=h.instances.length;a<b;a++){k=h.instances[a];if(k.onLayoutChange)k.onLayoutChange();if(k.behavior_insts){e=
0;for(f=k.behavior_insts.length;e<f;e++)if(g=k.behavior_insts[e],g.onLayoutChange)g.onLayoutChange()}}}this.layout_first_tick=this.redraw=!0;this.ClearDeathRow()};a.prototype.tickMe=function(a){this.objects_to_tick.add(a)};a.prototype.untickMe=function(a){this.objects_to_tick.remove(a)};a.prototype.tick2Me=function(a){this.objects_to_tick2.add(a)};a.prototype.untick2Me=function(a){this.objects_to_tick2.remove(a)};a.prototype.getDt=function(a){return!a||-1===a.my_timescale?this.dt:this.dt1*a.my_timescale};
a.prototype.draw=function(){this.running_layout.draw(this.ctx);this.isDirectCanvas&&this.ctx.present()};a.prototype.drawGL=function(){this.running_layout.drawGL(this.glwrap);this.glwrap.present()};a.prototype.addDestroyCallback=function(a){a&&this.destroycallbacks.push(a)};a.prototype.removeDestroyCallback=function(a){cr.arrayFindRemove(this.destroycallbacks,a)};a.prototype.getObjectByUID=function(a){return this.objectsByUid[a.toString()]};a.prototype.DestroyInstance=function(a){var b,c;if(!this.deathRow.contains(a)){this.deathRow.add(a);
if(a.is_contained){b=0;for(c=a.siblings.length;b<c;b++)this.DestroyInstance(a.siblings[b])}this.isInClearDeathRow&&this.deathRow.values_cache.push(a);this.isInOnDestroy++;this.trigger(Object.getPrototypeOf(a.type.plugin).cnds.OnDestroyed,a);this.isInOnDestroy--}};a.prototype.ClearDeathRow=function(){var a,b,c,d,e,f,h,k,g,m;this.isInClearDeathRow=!0;d=0;for(f=this.createRow.length;d<f;d++){a=this.createRow[d];b=a.type;b.instances.push(a);e=0;for(h=b.families.length;e<h;e++)b.families[e].instances.push(a),
b.families[e].stale_iids=!0}this.createRow.length=0;f=this.deathRow.valuesRef();for(d=0;d<f.length;d++){a=f[d];b=a.type;c=b.instances;e=0;for(h=this.destroycallbacks.length;e<h;e++)this.destroycallbacks[e](a);cr.arrayFindRemove(c,a);a.layer&&(cr.arrayRemove(a.layer.instances,a.get_zindex()),a.layer.zindices_stale=!0);e=0;for(h=b.families.length;e<h;e++)cr.arrayFindRemove(b.families[e].instances,a),b.families[e].stale_iids=!0;if(a.behavior_insts){e=0;for(h=a.behavior_insts.length;e<h;e++){c=a.behavior_insts[e];
if(c.onDestroy)c.onDestroy();c.behavior.my_instances.remove(a)}}this.objects_to_tick.remove(a);this.objects_to_tick2.remove(a);e=0;for(h=this.system.waits.length;e<h;e++)if(g=this.system.waits[e],g.sols.hasOwnProperty(b.index)&&cr.arrayFindRemove(g.sols[b.index].insts,a),!b.is_family){c=0;for(k=b.families.length;c<k;c++)m=b.families[c],g.sols.hasOwnProperty(m.index)&&cr.arrayFindRemove(g.sols[m.index].insts,a)}if(a.onDestroy)a.onDestroy();this.objectsByUid.hasOwnProperty(a.uid.toString())&&delete this.objectsByUid[a.uid.toString()];
this.objectcount--;64>b.deadCache.length&&b.deadCache.push(a);b.stale_iids=!0}this.deathRow.isEmpty()||(this.redraw=!0);this.deathRow.clear();this.isInClearDeathRow=!1};a.prototype.createInstance=function(a,b,c,d){if(a.is_family){var e=cr.floor(Math.random()*a.members.length);return this.createInstance(a.members[e],b,c,d)}return!a.default_instance?null:this.createInstanceFromInit(a.default_instance,b,!1,c,d,!1)};var l=[];a.prototype.createInstanceFromInit=function(a,b,c,d,e,f){var h,k,g,m;if(!a)return null;
var p=this.types_by_index[a[1]],n=p.plugin.is_world;if(this.isloading&&n&&!p.isOnLoaderLayout||n&&!this.glwrap&&11===a[0][11])return null;var q=b;n||(b=null);var u;p.deadCache.length?(u=p.deadCache.pop(),u.recycled=!0,p.plugin.Instance.call(u,p)):(u=new p.plugin.Instance(p),u.recycled=!1);u.uid=c&&!f?a[2]:this.next_uid++;this.objectsByUid[u.uid.toString()]=u;u.puid=this.next_puid++;u.iid=p.instances.length;h=0;for(k=this.createRow.length;h<k;++h)this.createRow[h].type===p&&u.iid++;u.get_iid=cr.inst_get_iid;
g=a[3];if(u.recycled)cr.wipe(u.extra);else{u.extra={};if("undefined"!==typeof cr_is_preview){u.instance_var_names=[];u.instance_var_names.length=g.length;h=0;for(k=g.length;h<k;h++)u.instance_var_names[h]=g[h][1]}u.instance_vars=[];u.instance_vars.length=g.length}h=0;for(k=g.length;h<k;h++)u.instance_vars[h]=g[h][0];if(n){var B=a[0];u.x=cr.is_undefined(d)?B[0]:d;u.y=cr.is_undefined(e)?B[1]:e;u.z=B[2];u.width=B[3];u.height=B[4];u.depth=B[5];u.angle=B[6];u.opacity=B[7];u.hotspotX=B[8];u.hotspotY=B[9];
u.blend_mode=B[10];h=B[11];!this.glwrap&&p.effect_types.length&&(u.blend_mode=h);u.compositeOp=cr.effectToCompositeOp(u.blend_mode);this.gl&&cr.setGLBlend(u,u.blend_mode,this.gl);if(u.recycled){h=0;for(k=B[12].length;h<k;h++){g=0;for(m=B[12][h].length;g<m;g++)u.effect_params[h][g]=B[12][h][g]}u.bbox.set(0,0,0,0);u.bquad.set_from_rect(u.bbox);u.bbox_changed_callbacks.length=0}else{u.effect_params=B[12].slice(0);h=0;for(k=u.effect_params.length;h<k;h++)u.effect_params[h]=B[12][h].slice(0);u.active_effect_types=
[];u.active_effect_flags=[];u.active_effect_flags.length=p.effect_types.length;u.bbox=new cr.rect(0,0,0,0);u.bquad=new cr.quad;u.bbox_changed_callbacks=[];u.set_bbox_changed=cr.set_bbox_changed;u.add_bbox_changed_callback=cr.add_bbox_changed_callback;u.contains_pt=cr.inst_contains_pt;u.update_bbox=cr.update_bbox;u.get_zindex=cr.inst_get_zindex}h=0;for(k=p.effect_types.length;h<k;h++)u.active_effect_flags[h]=!0;u.updateActiveEffects=cr.inst_updateActiveEffects;u.updateActiveEffects();u.uses_shaders=
!!u.active_effect_types.length;u.bbox_changed=!0;u.visible=!0;u.my_timescale=-1;u.layer=b;u.zindex=b.instances.length;"undefined"===typeof u.collision_poly&&(u.collision_poly=null);this.redraw=u.collisionsEnabled=!0}u.toString=cr.inst_toString;var K;h=l.length=0;for(k=p.families.length;h<k;h++)l.push.apply(l,p.families[h].behaviors);l.push.apply(l,p.behaviors);if(u.recycled){h=0;for(k=l.length;h<k;h++){var F=l[h];K=u.behavior_insts[h];K.recycled=!0;F.behavior.Instance.call(K,F,u);B=a[4][h];g=0;for(m=
B.length;g<m;g++)K.properties[g]=B[g];K.onCreate();F.behavior.my_instances.add(u)}}else{u.behavior_insts=[];h=0;for(k=l.length;h<k;h++)F=l[h],K=new F.behavior.Instance(F,u),K.recycled=!1,K.properties=a[4][h].slice(0),K.onCreate(),cr.seal(K),u.behavior_insts.push(K),F.behavior.my_instances.add(u)}B=a[5];if(u.recycled){h=0;for(k=B.length;h<k;h++)u.properties[h]=B[h]}else u.properties=B.slice(0);this.createRow.push(u);b&&b.instances.push(u);this.objectcount++;if(p.is_contained){if(u.is_contained=!0,
u.recycled?u.siblings.length=0:u.siblings=[],!c&&!f){h=0;for(k=p.container.length;h<k;h++)if(p.container[h]!==p){if(!p.container[h].default_instance)return null;u.siblings.push(this.createInstanceFromInit(p.container[h].default_instance,q,!1,n?u.x:d,n?u.y:e,!0))}h=0;for(k=u.siblings.length;h<k;h++){u.siblings[h].siblings.push(u);for(g=0;g<k;g++)h!==g&&u.siblings[h].siblings.push(u.siblings[g])}}}else u.is_contained=!1,u.siblings=null;u.onCreate();u.recycled||cr.seal(u);h=0;for(k=u.behavior_insts.length;h<
k;h++)u.behavior_insts[h].postCreate&&u.behavior_insts[h].postCreate();return u};a.prototype.getLayerByName=function(a){var b,c;b=0;for(c=this.running_layout.layers.length;b<c;b++){var d=this.running_layout.layers[b];if(cr.equals_nocase(d.name,a))return d}return null};a.prototype.getLayerByNumber=function(a){a=cr.floor(a);0>a&&(a=0);a>=this.running_layout.layers.length&&(a=this.running_layout.layers.length-1);return this.running_layout.layers[a]};a.prototype.getLayer=function(a){return cr.is_number(a)?
this.getLayerByNumber(a):this.getLayerByName(a.toString())};a.prototype.clearSol=function(a){var b,c;b=0;for(c=a.length;b<c;b++)a[b].getCurrentSol().select_all=!0};a.prototype.pushCleanSol=function(a){var b,c;b=0;for(c=a.length;b<c;b++)a[b].pushCleanSol()};a.prototype.pushCopySol=function(a){var b,c;b=0;for(c=a.length;b<c;b++)a[b].pushCopySol()};a.prototype.popSol=function(a){var b,c;b=0;for(c=a.length;b<c;b++)a[b].popSol()};a.prototype.testAndSelectCanvasPointOverlap=function(a,b,c,d){var e=a.getCurrentSol(),
f,h,k,g,m,l;if(e.select_all){d||(e.select_all=!1,e.instances.length=0);f=0;for(g=a.instances.length;f<g;f++)if(k=a.instances[f],k.update_bbox(),m=k.layer.canvasToLayer(b,c,!0),l=k.layer.canvasToLayer(b,c,!1),k.contains_pt(m,l)){if(d)return!1;e.instances.push(k)}}else{f=h=0;for(g=e.instances.length;f<g;f++)if(k=e.instances[f],k.update_bbox(),m=k.layer.canvasToLayer(b,c,!0),l=k.layer.canvasToLayer(b,c,!1),k.contains_pt(m,l)){if(d)return!1;e.instances[h]=e.instances[f];h++}d||(e.instances.length=h)}a.applySolToContainer();
return d?!0:e.hasObjects()};a.prototype.testOverlap=function(a,b){if(!a||!b||a===b||!a.collisionsEnabled||!b.collisionsEnabled)return!1;a.update_bbox();b.update_bbox();var c=a.layer,d=b.layer,e,f,h,k,g,m;if(c!==d&&(c.parallaxX!==d.parallaxX||d.parallaxY!==d.parallaxY||c.scale!==d.scale||c.angle!==d.angle||c.zoomRate!==d.zoomRate)){g=a.collision_poly&&!a.collision_poly.is_empty();e=b.collision_poly&&!b.collision_poly.is_empty();g?(a.collision_poly.cache_poly(a.width,a.height,a.angle),this.temp_poly.set_from_poly(a.collision_poly)):
this.temp_poly.set_from_quad(a.bquad,a.x,a.y,a.width,a.height);g=this.temp_poly;e?(b.collision_poly.cache_poly(b.width,b.height,b.angle),this.temp_poly2.set_from_poly(b.collision_poly)):this.temp_poly2.set_from_quad(b.bquad,b.x,b.y,b.width,b.height);m=this.temp_poly2;e=0;for(f=g.pts_count;e<f;e++)h=g.pts_cache[2*e],k=g.pts_cache[2*e+1],g.pts_cache[2*e]=c.layerToCanvas(h+a.x,k+a.y,!0),g.pts_cache[2*e+1]=c.layerToCanvas(h+a.x,k+a.y,!1);e=0;for(f=m.pts_count;e<f;e++)h=m.pts_cache[2*e],k=m.pts_cache[2*
e+1],m.pts_cache[2*e]=d.layerToCanvas(h+b.x,k+b.y,!0),m.pts_cache[2*e+1]=d.layerToCanvas(h+b.x,k+b.y,!1);return g.intersects_poly(m,0,0)}if(!a.bbox.intersects_rect(b.bbox)||!a.bquad.intersects_quad(b.bquad))return!1;g=a.collision_poly&&!a.collision_poly.is_empty();e=b.collision_poly&&!b.collision_poly.is_empty();if(!g&&!e)return!0;g?(a.collision_poly.cache_poly(a.width,a.height,a.angle),g=a.collision_poly):(this.temp_poly.set_from_quad(a.bquad,a.x,a.y,a.width,a.height),g=this.temp_poly);e?(b.collision_poly.cache_poly(b.width,
b.height,b.angle),m=b.collision_poly):(this.temp_poly.set_from_quad(b.bquad,b.x,b.y,b.width,b.height),m=this.temp_poly);return g.intersects_poly(m,b.x-a.x,b.y-a.y)};var k=new cr.quad,m=new cr.rect(0,0,0,0);a.prototype.testRectOverlap=function(a,b){if(!b||!b.collisionsEnabled)return!1;b.update_bbox();if(!b.bbox.intersects_rect(a))return!1;k.set_from_rect(a);if(!b.bquad.intersects_quad(k))return!1;if(!b.collision_poly||b.collision_poly.is_empty())return!0;b.collision_poly.cache_poly(b.width,b.height,
b.angle);k.offset(-a.left,-a.top);this.temp_poly.set_from_quad(k,0,0,1,1);return b.collision_poly.intersects_poly(this.temp_poly,a.left-b.x,a.top-b.y)};a.prototype.testSegmentOverlap=function(a,b,c,d,e){if(!e||!e.collisionsEnabled)return!1;e.update_bbox();m.set(cr.min(a,c),cr.min(b,d),cr.max(a,c),cr.max(b,d));if(!e.bbox.intersects_rect(m)||!e.bquad.intersects_segment(a,b,c,d))return!1;if(!e.collision_poly||e.collision_poly.is_empty())return!0;e.collision_poly.cache_poly(e.width,e.height,e.angle);
return e.collision_poly.intersects_segment(e.x,e.y,a,b,c,d)};a.prototype.typeHasBehavior=function(a,b){if(!b)return!1;var c,d,e,f,h;c=0;for(d=a.behaviors.length;c<d;c++)if(a.behaviors[c].behavior instanceof b)return!0;if(!a.is_family){c=0;for(d=a.families.length;c<d;c++){h=a.families[c];e=0;for(f=h.behaviors.length;e<f;e++)if(h.behaviors[e].behavior instanceof b)return!0}}return!1};a.prototype.typeHasNoSaveBehavior=function(a){return this.typeHasBehavior(a,cr.behaviors.NoSave)};a.prototype.typeHasPersistBehavior=
function(a){return this.typeHasBehavior(a,cr.behaviors.Persist)};a.prototype.getSolidBehavior=function(){if(!cr.behaviors.solid)return null;var a,b;a=0;for(b=this.behaviors.length;a<b;a++)if(this.behaviors[a]instanceof cr.behaviors.solid)return this.behaviors[a];return null};a.prototype.testOverlapSolid=function(a){var b=this.getSolidBehavior();if(!b)return null;var c,d,e=b.my_instances.valuesRef(),b=0;for(c=e.length;b<c;++b)if(d=e[b],d.extra.solidEnabled&&this.testOverlap(a,d))return d;return null};
a.prototype.testRectOverlapSolid=function(a){var b=this.getSolidBehavior();if(!b)return null;var c,d,e=b.my_instances.valuesRef(),b=0;for(c=e.length;b<c;++b)if(d=e[b],d.extra.solidEnabled&&this.testRectOverlap(a,d))return d;return null};var n=[];a.prototype.testOverlapJumpThru=function(a,b){var c=null,d,e;if(!cr.behaviors.jumpthru)return null;d=0;for(e=this.behaviors.length;d<e;d++)if(this.behaviors[d]instanceof cr.behaviors.jumpthru){c=this.behaviors[d];break}if(!c)return null;var f=null;b&&(f=n,
f.length=0);var h=c.my_instances.valuesRef();d=0;for(e=h.length;d<e;++d)if(c=h[d],c.extra.jumpthruEnabled&&this.testOverlap(a,c))if(b)f.push(c);else return c;return f};a.prototype.pushOutSolid=function(a,b,c,d,e,f){d=d||50;var h=a.x,k=a.y,g,m=null,l=null;for(g=0;g<d;g++)if(a.x=h+b*g,a.y=k+c*g,a.set_bbox_changed(),!this.testOverlap(a,m)&&((m=this.testOverlapSolid(a))&&(l=m),!m&&(e&&(m=f?this.testOverlap(a,f)?f:null:this.testOverlapJumpThru(a))&&(l=m),!m)))return l&&this.pushInFractional(a,b,c,l,16),
!0;a.x=h;a.y=k;a.set_bbox_changed();return!1};a.prototype.pushOut=function(a,b,c,d,e){d=d||50;var f=a.x,h=a.y,k;for(k=0;k<d;k++)if(a.x=f+b*k,a.y=h+c*k,a.set_bbox_changed(),!this.testOverlap(a,e))return!0;a.x=f;a.y=h;a.set_bbox_changed();return!1};a.prototype.pushInFractional=function(a,b,c,d,e){var f=2,h,k=!1;h=!1;for(var g=a.x,m=a.y;f<=e;)h=1/f,f*=2,a.x+=b*h*(k?1:-1),a.y+=c*h*(k?1:-1),a.set_bbox_changed(),this.testOverlap(a,d)?h=k=!0:(h=k=!1,g=a.x,m=a.y);h&&(a.x=g,a.y=m,a.set_bbox_changed())};a.prototype.pushOutSolidNearest=
function(a,b){var c=cr.is_undefined(b)?100:b,d=0,e=a.x,f=a.y,h=0,k=0,g=0,m=this.testOverlapSolid(a);if(!m)return!0;for(;d<=c;){switch(h){case 0:k=0;g=-1;d++;break;case 1:k=1;g=-1;break;case 2:k=1;g=0;break;case 3:g=k=1;break;case 4:k=0;g=1;break;case 5:k=-1;g=1;break;case 6:k=-1;g=0;break;case 7:g=k=-1}h=(h+1)%8;a.x=cr.floor(e+k*d);a.y=cr.floor(f+g*d);a.set_bbox_changed();if(!this.testOverlap(a,m)&&(m=this.testOverlapSolid(a),!m))return!0}a.x=e;a.y=f;a.set_bbox_changed();return!1};a.prototype.registerCollision=
function(a,b){a.collisionsEnabled&&b.collisionsEnabled&&this.registered_collisions.push([a,b])};a.prototype.checkRegisteredCollision=function(a,b){var c,d,e;c=0;for(d=this.registered_collisions.length;c<d;c++)if(e=this.registered_collisions[c],e[0]==a&&e[1]==b||e[0]==b&&e[1]==a)return!0;return!1};a.prototype.calculateSolidBounceAngle=function(a,b,c,d){var e=a.x,f=a.y,h=cr.max(10,cr.distanceTo(b,c,e,f)),k=cr.angleTo(b,c,e,f),g=d||this.testOverlapSolid(a);if(!g)return cr.clamp_angle(k+cr.PI);var m=
g,l,p,n,q,B=cr.to_radians(5);for(l=1;36>l;l++)if(p=k-l*B,a.x=b+Math.cos(p)*h,a.y=c+Math.sin(p)*h,a.set_bbox_changed(),!this.testOverlap(a,m)&&(m=d?null:this.testOverlapSolid(a),!m)){n=p;break}36===l&&(n=cr.clamp_angle(k+cr.PI));m=g;for(l=1;36>l;l++)if(p=k+l*B,a.x=b+Math.cos(p)*h,a.y=c+Math.sin(p)*h,a.set_bbox_changed(),!this.testOverlap(a,m)&&(m=d?null:this.testOverlapSolid(a),!m)){q=p;break}36===l&&(q=cr.clamp_angle(k+cr.PI));a.x=e;a.y=f;a.set_bbox_changed();if(q===n)return q;a=cr.angleDiff(q,n)/
2;a=cr.angleClockwise(q,n)?cr.clamp_angle(n+a+cr.PI):cr.clamp_angle(q+a);n=Math.cos(k);k=Math.sin(k);q=Math.cos(a);a=Math.sin(a);b=n*q+k*a;return cr.angleTo(0,0,n-2*b*q,k-2*b*a)};var q=[],p=-1;a.prototype.trigger=function(a,b,c){if(!this.running_layout)return!1;var d=this.running_layout.event_sheet;if(!d)return!1;p++;p===q.length?q.push(new cr.ObjectSet):q[p].clear();a=this.triggerOnSheet(a,b,d,c);p--;return a};a.prototype.triggerOnSheet=function(a,b,c,d){var e=q[p];if(e.contains(c))return!1;e.add(c);
var e=c.includes.valuesRef(),f=!1,h,k,g;h=0;for(k=e.length;h<k;h++)e[h].isActive()&&(g=this.triggerOnSheet(a,b,e[h].include_sheet,d),f=f||g);if(b){g=this.triggerOnSheetForTypeName(a,b,b.type.name,c,d);f=f||g;h=0;for(k=b.type.families.length;h<k;h++)g=this.triggerOnSheetForTypeName(a,b,b.type.families[h].name,c,d),f=f||g}else g=this.triggerOnSheetForTypeName(a,b,"system",c,d),f=f||g;return f};a.prototype.triggerOnSheetForTypeName=function(a,b,c,d,e){var f,h=!1,k=!1,k="undefined"!==typeof e,g=(k?d.fasttriggers:
d.triggers)[c];if(!g)return h;var m=null;d=0;for(f=g.length;d<f;d++)if(g[d].method==a){m=g[d].evs;break}if(!m)return h;a=k?m[e]:m;if(!a)return null;d=0;for(f=a.length;d<f;d++)e=a[d][0],k=a[d][1],k=this.executeSingleTrigger(b,c,e,k),h=h||k;return h};a.prototype.executeSingleTrigger=function(a,b,c,d){var e,f,h=!1;this.trigger_depth++;var k=this.getCurrentEventStack().current_event;k&&this.pushCleanSol(k.solModifiersIncludingParents);var g=1<this.trigger_depth;this.pushCleanSol(c.solModifiersIncludingParents);
g&&this.pushLocalVarStack();var m=this.pushEventStack(c);m.current_event=c;a&&(e=this.types[b].getCurrentSol(),e.select_all=!1,e.instances.length=1,e.instances[0]=a,this.types[b].applySolToContainer());a=!0;if(c.parent){b=m.temp_parents_arr;for(e=c.parent;e;)b.push(e),e=e.parent;b.reverse();e=0;for(f=b.length;e<f;e++)if(!b[e].run_pretrigger()){a=!1;break}}a&&(this.execcount++,c.orblock?c.run_orblocktrigger(d):c.run(),h=h||m.last_event_true);this.popEventStack();g&&this.popLocalVarStack();this.popSol(c.solModifiersIncludingParents);
k&&this.popSol(k.solModifiersIncludingParents);0===this.isInOnDestroy&&(0===p&&!this.isRunningEvents&&(!this.deathRow.isEmpty()||this.createRow.length))&&this.ClearDeathRow();this.trigger_depth--;return h};a.prototype.getCurrentCondition=function(){var a=this.getCurrentEventStack();return a.current_event.conditions[a.cndindex]};a.prototype.getCurrentAction=function(){var a=this.getCurrentEventStack();return a.current_event.actions[a.actindex]};a.prototype.pushLocalVarStack=function(){this.localvar_stack_index++;
this.localvar_stack_index>=this.localvar_stack.length&&this.localvar_stack.push([])};a.prototype.popLocalVarStack=function(){this.localvar_stack_index--};a.prototype.getCurrentLocalVarStack=function(){return this.localvar_stack[this.localvar_stack_index]};a.prototype.pushEventStack=function(a){this.event_stack_index++;this.event_stack_index>=this.event_stack.length&&this.event_stack.push(new cr.eventStackFrame);var b=this.getCurrentEventStack();b.reset(a);return b};a.prototype.popEventStack=function(){this.event_stack_index--};
a.prototype.getCurrentEventStack=function(){return this.event_stack[this.event_stack_index]};a.prototype.pushLoopStack=function(a){this.loop_stack_index++;this.loop_stack_index>=this.loop_stack.length&&this.loop_stack.push(cr.seal({name:a,index:0,stopped:!1}));var b=this.getCurrentLoop();b.name=a;b.index=0;b.stopped=!1;return b};a.prototype.popLoopStack=function(){this.loop_stack_index--};a.prototype.getCurrentLoop=function(){return this.loop_stack[this.loop_stack_index]};a.prototype.getEventVariableByName=
function(a,b){for(var c,d,e,f,h,k;b;){c=0;for(d=b.subevents.length;c<d;c++)if(k=b.subevents[c],k instanceof cr.eventvariable&&cr.equals_nocase(a,k.name))return k;b=b.parent}c=0;for(d=this.eventsheets_by_index.length;c<d;c++){h=this.eventsheets_by_index[c];e=0;for(f=h.events.length;e<f;e++)if(k=h.events[e],k instanceof cr.eventvariable&&cr.equals_nocase(a,k.name))return k}return null};a.prototype.getLayoutBySid=function(a){var b,c;b=0;for(c=this.layouts_by_index.length;b<c;b++)if(this.layouts_by_index[b].sid===
a)return this.layouts_by_index[b];return null};a.prototype.getObjectTypeBySid=function(a){var b,c;b=0;for(c=this.types_by_index.length;b<c;b++)if(this.types_by_index[b].sid===a)return this.types_by_index[b];return null};a.prototype.getGroupBySid=function(a){var b,c;b=0;for(c=this.allGroups.length;b<c;b++)if(this.allGroups[b].sid===a)return this.allGroups[b];return null};a.prototype.signalContinuousPreview=function(){this.signalledContinuousPreview=!0};a.prototype.handleSaveLoad=function(){var a=this,
b=this.saveToSlot,f=this.lastSaveJson,h=this.loadFromSlot,k=!1;this.signalledContinuousPreview&&(k=!0,b="__c2_continuouspreview",this.signalledContinuousPreview=!1);if(b.length){this.ClearDeathRow();f=this.saveToJSONString();if(window.indexedDB&&!this.isCocoonJs)c(b,f,function(){cr.logexport("Saved state to IndexedDB storage ("+f.length+" bytes)");a.lastSaveJson=f;a.trigger(cr.system_object.prototype.cnds.OnSaveComplete,null);a.lastSaveJson="";k&&e()},function(c){try{localStorage.setItem("__c2save_"+
b,f),cr.logexport("Saved state to WebStorage ("+f.length+" bytes)"),a.lastSaveJson=f,a.trigger(cr.system_object.prototype.cnds.OnSaveComplete,null),a.lastSaveJson="",k&&e()}catch(d){cr.logexport("Failed to save game state: "+c+"; "+d)}});else try{localStorage.setItem("__c2save_"+b,f),cr.logexport("Saved state to WebStorage ("+f.length+" bytes)"),a.lastSaveJson=f,this.trigger(cr.system_object.prototype.cnds.OnSaveComplete,null),a.lastSaveJson="",k&&e()}catch(g){cr.logexport("Error saving to WebStorage: "+
g)}this.loadFromJson=this.loadFromSlot=this.saveToSlot=""}h.length&&(window.indexedDB&&!this.isCocoonJs?d(h,function(b){b?(a.loadFromJson=b,cr.logexport("Loaded state from IndexedDB storage ("+a.loadFromJson.length+" bytes)")):(a.loadFromJson=localStorage.getItem("__c2save_"+h)||"",cr.logexport("Loaded state from WebStorage ("+a.loadFromJson.length+" bytes)"));a.suspendDrawing=!1;a.loadFromJson.length||a.trigger(cr.system_object.prototype.cnds.OnLoadFailed,null)},function(b){a.loadFromJson=localStorage.getItem("__c2save_"+
h)||"";cr.logexport("Loaded state from WebStorage ("+a.loadFromJson.length+" bytes)");a.suspendDrawing=!1;a.loadFromJson.length||a.trigger(cr.system_object.prototype.cnds.OnLoadFailed,null)}):(this.loadFromJson=localStorage.getItem("__c2save_"+h)||"",cr.logexport("Loaded state from WebStorage ("+this.loadFromJson.length+" bytes)"),this.suspendDrawing=!1,a.loadFromJson.length||a.trigger(cr.system_object.prototype.cnds.OnLoadFailed,null)),this.saveToSlot=this.loadFromSlot="");this.loadFromJson.length&&
(this.ClearDeathRow(),this.loadFromJSONString(this.loadFromJson),this.lastSaveJson=this.loadFromJson,this.trigger(cr.system_object.prototype.cnds.OnLoadComplete,null),this.loadFromJson=this.lastSaveJson="")};a.prototype.saveToJSONString=function(){var a,b,c,d,e,h,k,g={c2save:!0,version:1,rt:{time:this.kahanTime.sum,timescale:this.timescale,tickcount:this.tickcount,execcount:this.execcount,next_uid:this.next_uid,running_layout:this.running_layout.sid,start_time_offset:Date.now()-this.start_time},types:{},
layouts:{},events:{groups:{},cnds:{},acts:{},vars:{}}};a=0;for(b=this.types_by_index.length;a<b;a++)if(e=this.types_by_index[a],!e.is_family&&!this.typeHasNoSaveBehavior(e)){h={instances:[]};cr.hasAnyOwnProperty(e.extra)&&(h.ex=f(e.extra));c=0;for(d=e.instances.length;c<d;c++)h.instances.push(this.saveInstanceToJSON(e.instances[c]));g.types[e.sid.toString()]=h}a=0;for(b=this.layouts_by_index.length;a<b;a++)c=this.layouts_by_index[a],g.layouts[c.sid.toString()]=c.saveToJSON();d=g.events.groups;a=0;
for(b=this.allGroups.length;a<b;a++)c=this.allGroups[a],d[c.sid.toString()]=!!this.activeGroups[c.group_name];b=g.events.cnds;for(k in this.cndsBySid)this.cndsBySid.hasOwnProperty(k)&&(a=this.cndsBySid[k],cr.hasAnyOwnProperty(a.extra)&&(b[k]={ex:f(a.extra)}));b=g.events.acts;for(k in this.actsBySid)this.actsBySid.hasOwnProperty(k)&&(a=this.actsBySid[k],cr.hasAnyOwnProperty(a.extra)&&(b[k]={ex:a.extra}));b=g.events.vars;for(k in this.varsBySid)if(this.varsBySid.hasOwnProperty(k)&&(a=this.varsBySid[k],
!a.is_constant&&(!a.parent||a.is_static)))b[k]=a.data;g.system=this.system.saveToJSON();return JSON.stringify(g)};a.prototype.refreshUidMap=function(){var a,b,c,d,e,f;this.objectsByUid={};a=0;for(b=this.types_by_index.length;a<b;a++)if(c=this.types_by_index[a],!c.is_family){d=0;for(e=c.instances.length;d<e;d++)f=c.instances[d],this.objectsByUid[f.uid.toString()]=f}};a.prototype.loadFromJSONString=function(a){a=JSON.parse(a);if(a.c2save&&!(1<a.version)){var b=a.rt;this.kahanTime.reset();this.kahanTime.sum=
b.time;this.timescale=b.timescale;this.tickcount=b.tickcount;this.execcount=b.execcount;this.start_time=Date.now()-b.start_time_offset;var c=b.running_layout;if(c!==this.running_layout.sid)if(c=this.getLayoutBySid(c))this.doChangeLayout(c);else return;this.isLoadingState=!0;var d,e,f,h,k,g,m;g=a.types;for(e in g)if(g.hasOwnProperty(e)&&(h=this.getObjectTypeBySid(parseInt(e,10)))&&!h.is_family&&!this.typeHasNoSaveBehavior(h)){g[e].ex?h.extra=g[e].ex:cr.wipe(h.extra);k=h.instances;f=g[e].instances;
c=0;for(d=cr.min(k.length,f.length);c<d;c++)this.loadInstanceFromJSON(k[c],f[c]);c=f.length;for(d=k.length;c<d;c++)this.DestroyInstance(k[c]);c=k.length;for(d=f.length;c<d;c++){k=null;if(h.plugin.is_world&&(k=this.running_layout.getLayerBySid(f[c].w.l),!k))continue;k=this.createInstanceFromInit(h.default_instance,k,!1,0,0,!0);this.loadInstanceFromJSON(k,f[c])}h.stale_iids=!0}this.ClearDeathRow();this.refreshUidMap();d=a.layouts;for(e in d)d.hasOwnProperty(e)&&(c=this.getLayoutBySid(parseInt(e,10)))&&
c.loadFromJSON(d[e]);d=a.events.groups;for(e in d)d.hasOwnProperty(e)&&(c=this.getGroupBySid(parseInt(e,10)))&&(this.activeGroups[c.group_name]=d[e]);c=a.events.cnds;for(e in c)c.hasOwnProperty(e)&&this.cndsBySid.hasOwnProperty(e)&&(this.cndsBySid[e].extra=c[e].ex);c=a.events.acts;for(e in c)c.hasOwnProperty(e)&&this.actsBySid.hasOwnProperty(e)&&(this.actsBySid[e].extra=c[e].ex);c=a.events.vars;for(e in c)c.hasOwnProperty(e)&&this.varsBySid.hasOwnProperty(e)&&(this.varsBySid[e].data=c[e]);this.next_uid=
b.next_uid;this.isLoadingState=!1;this.system.loadFromJSON(a.system);c=0;for(d=this.types_by_index.length;c<d;c++)if(h=this.types_by_index[c],!h.is_family){e=0;for(a=h.instances.length;e<a;e++){k=h.instances[e];if(h.is_contained){g=k.get_iid();b=k.siblings.length=0;for(f=h.container.length;b<f;b++)m=h.container[b],h!==m&&k.siblings.push(m.instances[g])}k.afterLoad&&k.afterLoad();if(k.behavior_insts){b=0;for(f=k.behavior_insts.length;b<f;b++)g=k.behavior_insts[b],g.afterLoad&&g.afterLoad()}}}this.redraw=
!0}};a.prototype.saveInstanceToJSON=function(a){var b,c,d,e,h;e=a.type;d=e.plugin;var k={uid:a.uid};cr.hasAnyOwnProperty(a.extra)&&(k.ex=f(a.extra));if(a.instance_vars&&a.instance_vars.length){k.ivs={};b=0;for(c=a.instance_vars.length;b<c;b++)k.ivs[a.type.instvar_sids[b].toString()]=a.instance_vars[b]}if(d.is_world){d={x:a.x,y:a.y,w:a.width,h:a.height,l:a.layer.sid,zi:a.get_zindex()};0!==a.angle&&(d.a=a.angle);1!==a.opacity&&(d.o=a.opacity);0.5!==a.hotspotX&&(d.hX=a.hotspotX);0.5!==a.hotspotY&&(d.hY=
a.hotspotY);0!==a.blend_mode&&(d.bm=a.blend_mode);a.visible||(d.v=a.visible);a.collisionsEnabled||(d.ce=a.collisionsEnabled);-1!==a.my_timescale&&(d.mts=a.my_timescale);if(e.effect_types.length){d.fx=[];b=0;for(c=e.effect_types.length;b<c;b++)h=e.effect_types[b],d.fx.push({name:h.name,active:a.active_effect_flags[h.index],params:a.effect_params[h.index]})}k.w=d}if(a.behavior_insts&&a.behavior_insts.length){k.behs={};b=0;for(c=a.behavior_insts.length;b<c;b++)e=a.behavior_insts[b],e.saveToJSON&&(k.behs[e.type.sid.toString()]=
e.saveToJSON())}a.saveToJSON&&(k.data=a.saveToJSON());return k};a.prototype.getInstanceVarIndexBySid=function(a,b){var c,d;c=0;for(d=a.instvar_sids.length;c<d;c++)if(a.instvar_sids[c]===b)return c;return-1};a.prototype.getBehaviorIndexBySid=function(a,b){var c,d;c=0;for(d=a.behavior_insts.length;c<d;c++)if(a.behavior_insts[c].type.sid===b)return c;return-1};a.prototype.loadInstanceFromJSON=function(a,b){var c,d,e,f,h,k;k=a.type;e=k.plugin;a.uid=b.uid;b.ex?a.extra=b.ex:cr.wipe(a.extra);if(d=b.ivs)for(c in d)d.hasOwnProperty(c)&&
(f=this.getInstanceVarIndexBySid(k,parseInt(c,10)),0>f||f>=a.instance_vars.length||(a.instance_vars[f]=d[c]));if(e.is_world){f=b.w;a.layer.sid!==f.l&&(d=a.layer,a.layer=this.running_layout.getLayerBySid(f.l),a.layer?(a.layer.instances.push(a),a.layer.zindices_stale=!0,cr.arrayFindRemove(d.instances,a),d.zindices_stale=!0):(a.layer=d,this.DestroyInstance(a)));a.x=f.x;a.y=f.y;a.width=f.w;a.height=f.h;a.zindex=f.zi;a.angle=f.hasOwnProperty("a")?f.a:0;a.opacity=f.hasOwnProperty("o")?f.o:1;a.hotspotX=
f.hasOwnProperty("hX")?f.hX:0.5;a.hotspotY=f.hasOwnProperty("hY")?f.hY:0.5;a.visible=f.hasOwnProperty("v")?f.v:!0;a.collisionsEnabled=f.hasOwnProperty("ce")?f.ce:!0;a.my_timescale=f.hasOwnProperty("mts")?f.mts:-1;a.blend_mode=f.hasOwnProperty("bm")?f.bm:0;a.compositeOp=cr.effectToCompositeOp(a.blend_mode);this.gl&&cr.setGLBlend(a,a.blend_mode,this.gl);a.set_bbox_changed();if(f.hasOwnProperty("fx")){d=0;for(e=f.fx.length;d<e;d++)h=k.getEffectIndexByName(f.fx[d].name),0>h||(a.active_effect_flags[h]=
f.fx[d].active,a.effect_params[h]=f.fx[d].params)}a.updateActiveEffects()}if(k=b.behs)for(c in k)k.hasOwnProperty(c)&&(f=this.getBehaviorIndexBySid(a,parseInt(c,10)),0>f||a.behavior_insts[f].loadFromJSON(k[c]));b.data&&a.loadFromJSON(b.data)};cr.runtime=a;cr.createRuntime=function(b){return new a(document.getElementById(b))};cr.createDCRuntime=function(b,c){return new a({dc:!0,width:b,height:c})};window.cr_createRuntime=cr.createRuntime;window.cr_createDCRuntime=cr.createDCRuntime;window.createCocoonJSRuntime=
function(){window.c2cocoonjs=!0;var b=document.createElement("screencanvas")||document.createElement("canvas");document.body.appendChild(b);b=new a(b);window.c2runtime=b;window.addEventListener("orientationchange",function(){window.c2runtime.setSize(window.innerWidth,window.innerHeight)});window.c2runtime.setSize(window.innerWidth,window.innerHeight);return b}})();window.cr_getC2Runtime=function(){var a=document.getElementById("c2canvas");return a?a.c2runtime:window.c2runtime?window.c2runtime:null};
window.cr_sizeCanvas=function(a,b){if(!(0===a||0===b)){var c=window.cr_getC2Runtime();c&&c.setSize(a,b)}};window.cr_setSuspended=function(a){var b=window.cr_getC2Runtime();b&&b.setSuspended(a)};
(function(){function a(a,b){this.runtime=a;this.event_sheet=null;this.scrollX=this.runtime.original_width/2;this.scrollY=this.runtime.original_height/2;this.scale=1;this.angle=0;this.first_visit=!0;this.name=b[0];this.width=b[1];this.height=b[2];this.unbounded_scrolling=b[3];this.sheetname=b[4];this.sid=b[5];var c=b[6],d,l;this.layers=[];this.initial_types=[];d=0;for(l=c.length;d<l;d++){var k=new cr.layer(this,c[d]);k.number=d;cr.seal(k);this.layers.push(k)}c=b[7];this.initial_nonworld=[];d=0;for(l=
c.length;d<l;d++){var k=c[d],m=this.runtime.types_by_index[k[1]];m.default_instance||(m.default_instance=k);this.initial_nonworld.push(k);-1===this.initial_types.indexOf(m)&&this.initial_types.push(m)}this.effect_types=[];this.active_effect_types=[];this.effect_params=[];d=0;for(l=b[8].length;d<l;d++)this.effect_types.push({id:b[8][d][0],name:b[8][d][1],shaderindex:-1,active:!0,index:d}),this.effect_params.push(b[8][d][2].slice(0));this.updateActiveEffects();this.rcTex=new cr.rect(0,0,1,1);this.rcTex2=
new cr.rect(0,0,1,1);this.persist_data={}}function b(a,b){this.layout=a;this.runtime=a.runtime;this.instances=[];this.scale=1;this.angle=0;this.disableAngle=!1;this.tmprect=new cr.rect(0,0,0,0);this.tmpquad=new cr.quad;this.viewBottom=this.viewTop=this.viewRight=this.viewLeft=0;this.zindices_stale=!1;this.name=b[0];this.index=b[1];this.sid=b[2];this.visible=b[3];this.background_color=b[4];this.transparent=b[5];this.parallaxX=b[6];this.parallaxY=b[7];this.opacity=b[8];this.forceOwnTexture=b[9];this.zoomRate=
b[10];this.blend_mode=b[11];this.effect_fallback=b[12];this.compositeOp="source-over";this.destBlend=this.srcBlend=0;this.render_offscreen=!1;var c=b[13],d,l;this.initial_instances=[];d=0;for(l=c.length;d<l;d++){var k=c[d],m=this.runtime.types_by_index[k[1]];m.default_instance||(m.default_instance=k);this.initial_instances.push(k);-1===this.layout.initial_types.indexOf(m)&&this.layout.initial_types.push(m)}this.effect_types=[];this.active_effect_types=[];this.effect_params=[];d=0;for(l=b[14].length;d<
l;d++)this.effect_types.push({id:b[14][d][0],name:b[14][d][1],shaderindex:-1,active:!0,index:d}),this.effect_params.push(b[14][d][2].slice(0));this.updateActiveEffects();this.rcTex=new cr.rect(0,0,1,1);this.rcTex2=new cr.rect(0,0,1,1)}function c(a,b){return a.zindex-b.zindex}a.prototype.saveObjectToPersist=function(a){var b=a.type.sid.toString();this.persist_data.hasOwnProperty(b)||(this.persist_data[b]=[]);this.persist_data[b].push(this.runtime.saveInstanceToJSON(a))};a.prototype.hasOpaqueBottomLayer=
function(){var a=this.layers[0];return!a.transparent&&1===a.opacity&&!a.forceOwnTexture&&a.visible};a.prototype.updateActiveEffects=function(){this.active_effect_types.length=0;var a,b,c;a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],c.active&&this.active_effect_types.push(c)};a.prototype.getEffectByName=function(a){var b,c,d;b=0;for(c=this.effect_types.length;b<c;b++)if(d=this.effect_types[b],d.name===a)return d;return null};var d=[];a.prototype.startRunning=function(){this.sheetname&&
(this.event_sheet=this.runtime.eventsheets[this.sheetname]);this.runtime.running_layout=this;this.scrollX=this.runtime.original_width/2;this.scrollY=this.runtime.original_height/2;var a,b,g,h,l,k,m;a=0;for(g=this.runtime.types_by_index.length;a<g;a++)if(b=this.runtime.types_by_index[a],!b.is_family){l=b.instances;b=0;for(h=l.length;b<h;b++)if(k=l[b],k.layer){var n=k.layer.number;n>=this.layers.length&&(n=this.layers.length-1);k.layer=this.layers[n];k.layer.instances.push(k);k.layer.zindices_stale=
!0}}d.length=0;this.boundScrolling();a=0;for(g=this.layers.length;a<g;a++)k=this.layers[a],k.createInitialInstances(),k.disableAngle=!0,b=k.canvasToLayer(0,0,!0),h=k.canvasToLayer(0,0,!1),k.disableAngle=!1,this.runtime.pixel_rounding&&(b=b+0.5|0,h=h+0.5|0),k.rotateViewport(b,h,null);l=!1;if(!this.first_visit){for(m in this.persist_data)if(this.persist_data.hasOwnProperty(m)&&(b=this.runtime.getObjectTypeBySid(parseInt(m,10)))&&!b.is_family&&this.runtime.typeHasPersistBehavior(b)){h=this.persist_data[m];
a=0;for(g=h.length;a<g;a++){k=null;if(b.plugin.is_world&&(k=this.getLayerBySid(h[a].w.l),!k))continue;k=this.runtime.createInstanceFromInit(b.default_instance,k,!1,0,0,!0);this.runtime.loadInstanceFromJSON(k,h[a]);l=!0;d.push(k)}h.length=0}a=0;for(g=this.layers.length;a<g;a++)this.layers[a].instances.sort(c),this.layers[a].zindices_stale=!0}l&&(this.runtime.ClearDeathRow(),this.runtime.refreshUidMap());for(a=0;a<d.length;a++)if(k=d[a],k.type.is_contained){g=k.get_iid();b=0;for(h=k.type.container.length;b<
h;b++)m=k.type.container[b],k.type!==m&&(m.instances.length>g?k.siblings.push(m.instances[g]):m.default_instance&&(l=this.runtime.createInstanceFromInit(m.default_instance,k.layer,!0,k.x,k.y,!0),this.runtime.ClearDeathRow(),m.updateIIDs(),k.siblings.push(l),d.push(l)))}a=0;for(g=this.initial_nonworld.length;a<g;a++)this.runtime.createInstanceFromInit(this.initial_nonworld[a],null,!0);this.runtime.changelayout=null;this.runtime.ClearDeathRow();if(this.runtime.ctx&&!this.runtime.isDomFree){a=0;for(g=
this.runtime.types_by_index.length;a<g;a++)m=this.runtime.types_by_index[a],!m.is_family&&(m.instances.length&&m.preloadCanvas2D)&&m.preloadCanvas2D(this.runtime.ctx)}a=0;for(g=d.length;a<g;a++)k=d[a],this.runtime.trigger(Object.getPrototypeOf(k.type.plugin).cnds.OnCreated,k);d.length=0;this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutStart,null);this.first_visit=!1};a.prototype.createGlobalNonWorlds=function(){var a,b,c,d,l;b=a=0;for(c=this.initial_nonworld.length;a<c;a++)d=this.initial_nonworld[a],
l=this.runtime.types_by_index[d[1]],l.global?this.runtime.createInstanceFromInit(d,null,!0):(this.initial_nonworld[b]=d,b++);this.initial_nonworld.length=b};a.prototype.stopRunning=function(){this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutEnd,null);this.runtime.system.waits.length=0;var a,b,c,d,l,k;a=0;for(b=this.layers.length;a<b;a++){l=this.layers[a].instances;c=0;for(d=l.length;c<d;c++)k=l[c],k.type.global||(this.runtime.typeHasPersistBehavior(k.type)&&this.saveObjectToPersist(k),
this.runtime.DestroyInstance(k));this.runtime.ClearDeathRow();l.length=0;this.layers[a].zindices_stale=!0}a=0;for(b=this.runtime.types_by_index.length;a<b;a++)if(l=this.runtime.types_by_index[a],!l.global&&!l.plugin.is_world&&!l.plugin.singleglobal&&!l.is_family){c=0;for(d=l.instances.length;c<d;c++)this.runtime.DestroyInstance(l.instances[c]);this.runtime.ClearDeathRow()}};a.prototype.draw=function(a){a.globalAlpha=1;a.globalCompositeOperation="source-over";this.runtime.clearBackground&&!this.hasOpaqueBottomLayer()&&
a.clearRect(0,0,this.runtime.width,this.runtime.height);var b,c,d;b=0;for(c=this.layers.length;b<c;b++)d=this.layers[b],d.visible&&(0<d.opacity&&11!==d.blend_mode)&&d.draw(a)};a.prototype.drawGL=function(a){var b=0<this.active_effect_types.length||this.runtime.uses_background_blending;if(b){this.runtime.layout_tex||(this.runtime.layout_tex=a.createEmptyTexture(this.runtime.width,this.runtime.height,this.runtime.linearSampling));if(this.runtime.layout_tex.c2width!==this.runtime.width||this.runtime.layout_tex.c2height!==
this.runtime.height)a.deleteTexture(this.runtime.layout_tex),this.runtime.layout_tex=a.createEmptyTexture(this.runtime.width,this.runtime.height,this.runtime.linearSampling);a.setRenderingToTexture(this.runtime.layout_tex)}this.runtime.clearBackground&&!this.hasOpaqueBottomLayer()&&a.clear(0,0,0,0);var c,d;c=0;for(d=this.layers.length;c<d;c++)this.layers[c].visible&&0<this.layers[c].opacity&&this.layers[c].drawGL(a);b&&(1>=this.active_effect_types.length?(1===this.active_effect_types.length?(b=this.active_effect_types[0].index,
a.switchProgram(this.active_effect_types[0].shaderindex),a.setProgramParameters(null,1/this.runtime.width,1/this.runtime.height,0,0,1,1,this.scale,this.effect_params[b]),a.programIsAnimated(this.active_effect_types[0].shaderindex)&&(this.runtime.redraw=!0)):a.switchProgram(0),a.setRenderingToTexture(null),a.setOpacity(1),a.setTexture(this.runtime.layout_tex),a.setAlphaBlend(),a.resetModelView(),a.updateModelView(),b=this.runtime.width/2,c=this.runtime.height/2,a.quad(-b,c,b,c,b,-c,-b,-c),a.setTexture(null)):
this.renderEffectChain(a,null,null,null))};a.prototype.getRenderTarget=function(){return 0<this.active_effect_types.length||this.runtime.uses_background_blending?this.runtime.layout_tex:null};a.prototype.getMinLayerScale=function(){var a=this.layers[0].getScale(),b,c,d;b=1;for(c=this.layers.length;b<c;b++)d=this.layers[b],0===d.parallaxX&&0===d.parallaxY||d.getScale()<a&&(a=d.getScale());return a};a.prototype.scrollToX=function(a){if(!this.unbounded_scrolling){var b=this.runtime.width*(1/this.getMinLayerScale())/
2;a>this.width-b&&(a=this.width-b);a<b&&(a=b)}this.scrollX!==a&&(this.scrollX=a,this.runtime.redraw=!0)};a.prototype.scrollToY=function(a){if(!this.unbounded_scrolling){var b=this.runtime.height*(1/this.getMinLayerScale())/2;a>this.height-b&&(a=this.height-b);a<b&&(a=b)}this.scrollY!==a&&(this.scrollY=a,this.runtime.redraw=!0)};a.prototype.boundScrolling=function(){this.scrollToX(this.scrollX);this.scrollToY(this.scrollY)};a.prototype.renderEffectChain=function(a,b,c,d){var l=c?c.active_effect_types:
b?b.active_effect_types:this.active_effect_types,k=c?c.layer.getScale():b?b.getScale():1,m=this.runtime.fx_tex,n,q,p,r,s=0,t=1,v,y=this.runtime.width,z=this.runtime.height,C=y/2,A=z/2,x=b?b.rcTex:this.rcTex,w=b?b.rcTex2:this.rcTex2,D=0,E=0,H=0,u=0,B=y,K=y,F=z,M=z,Q=p=0,V=c?c.layer.getAngle():0;if(c){n=0;for(q=l.length;n<q;n++)p+=a.getProgramBoxExtendHorizontal(l[n].shaderindex),Q+=a.getProgramBoxExtendVertical(l[n].shaderindex);r=c.bbox;D=b.layerToCanvas(r.left,r.top,!0);H=b.layerToCanvas(r.left,
r.top,!1);B=b.layerToCanvas(r.right,r.bottom,!0);F=b.layerToCanvas(r.right,r.bottom,!1);0!==V&&(n=b.layerToCanvas(r.right,r.top,!0),q=b.layerToCanvas(r.right,r.top,!1),E=b.layerToCanvas(r.left,r.bottom,!0),u=b.layerToCanvas(r.left,r.bottom,!1),r=Math.min(D,B,n,E),B=Math.max(D,B,n,E),D=r,r=Math.min(H,F,q,u),F=Math.max(H,F,q,u),H=r);D-=p;H-=Q;B+=p;F+=Q;w.left=D/y;w.top=1-H/z;w.right=B/y;w.bottom=1-F/z;E=D=Math.floor(D);u=H=Math.floor(H);K=B=Math.ceil(B);M=F=Math.ceil(F);E-=p;u-=Q;K+=p;M+=Q;0>D&&(D=
0);0>H&&(H=0);B>y&&(B=y);F>z&&(F=z);0>E&&(E=0);0>u&&(u=0);K>y&&(K=y);M>z&&(M=z);x.left=D/y;x.top=1-H/z;x.right=B/y;x.bottom=1-F/z}else x.left=w.left=0,x.top=w.top=0,x.right=w.right=1,x.bottom=w.bottom=1;Q=c&&((c.angle||V)&&a.programUsesDest(l[0].shaderindex)||0!==p||0!==Q||1!==c.opacity||c.type.plugin.must_predraw)||b&&!c&&1!==b.opacity;a.setAlphaBlend();if(Q){m[s]||(m[s]=a.createEmptyTexture(y,z,this.runtime.linearSampling));if(m[s].c2width!==y||m[s].c2height!==z)a.deleteTexture(m[s]),m[s]=a.createEmptyTexture(y,
z,this.runtime.linearSampling);a.switchProgram(0);a.setRenderingToTexture(m[s]);v=M-u;a.clearRect(E,z-u-v,K-E,v);c?c.drawGL(a):(a.setTexture(this.runtime.layer_tex),a.setOpacity(b.opacity),a.resetModelView(),a.translate(-C,-A),a.updateModelView(),a.quadTex(D,F,B,F,B,H,D,H,x));w.left=w.top=0;w.right=w.bottom=1;c&&(r=x.top,x.top=x.bottom,x.bottom=r);s=1;t=0}a.setOpacity(1);p=l.length-1;var V=a.programUsesCrossSampling(l[p].shaderindex),T=0;n=0;for(q=l.length;n<q;n++){m[s]||(m[s]=a.createEmptyTexture(y,
z,this.runtime.linearSampling));if(m[s].c2width!==y||m[s].c2height!==z)a.deleteTexture(m[s]),m[s]=a.createEmptyTexture(y,z,this.runtime.linearSampling);a.switchProgram(l[n].shaderindex);T=l[n].index;a.programIsAnimated(l[n].shaderindex)&&(this.runtime.redraw=!0);0==n&&!Q?(a.setRenderingToTexture(m[s]),v=M-u,r=z-u-v,a.clearRect(E,r,K-E,v),c?(a.setProgramParameters(d,1/c.width,1/c.height,w.left,w.top,w.right,w.bottom,k,c.effect_params[T]),c.drawGL(a)):(a.setProgramParameters(d,1/y,1/z,0,0,1,1,k,b?b.effect_params[T]:
this.effect_params[T]),a.setTexture(b?this.runtime.layer_tex:this.runtime.layout_tex),a.resetModelView(),a.translate(-C,-A),a.updateModelView(),a.quadTex(D,F,B,F,B,H,D,H,x)),w.left=w.top=0,w.right=w.bottom=1,c&&!V&&(r=F,F=H,H=r)):(a.setProgramParameters(d,1/y,1/z,w.left,w.top,w.right,w.bottom,k,c?c.effect_params[T]:b?b.effect_params[T]:this.effect_params[T]),n===p&&!V?(c?a.setBlend(c.srcBlend,c.destBlend):b&&a.setBlend(b.srcBlend,b.destBlend),a.setRenderingToTexture(d)):(a.setRenderingToTexture(m[s]),
v=M-u,r=z-u-v,a.clearRect(E,r,K-E,v)),a.setTexture(m[t]),a.resetModelView(),a.translate(-C,-A),a.updateModelView(),a.quadTex(D,F,B,F,B,H,D,H,x),n===p&&!V&&a.setTexture(null));s=0===s?1:0;t=0===s?1:0}V&&(a.switchProgram(0),c?a.setBlend(c.srcBlend,c.destBlend):b&&a.setBlend(b.srcBlend,b.destBlend),a.setRenderingToTexture(d),a.setTexture(m[t]),a.resetModelView(),a.translate(-C,-A),a.updateModelView(),c&&1===l.length&&!Q?a.quadTex(D,H,B,H,B,F,D,F,x):a.quadTex(D,F,B,F,B,H,D,H,x),a.setTexture(null))};a.prototype.getLayerBySid=
function(a){var b,c;b=0;for(c=this.layers.length;b<c;b++)if(this.layers[b].sid===a)return this.layers[b];return null};a.prototype.saveToJSON=function(){var a,b,c,d={sx:this.scrollX,sy:this.scrollY,s:this.scale,a:this.angle,w:this.width,h:this.height,fv:this.first_visit,persist:this.persist_data,fx:[],layers:{}};a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],d.fx.push({name:c.name,active:c.active,params:this.effect_params[c.index]});a=0;for(b=this.layers.length;a<b;a++)c=this.layers[a],
d.layers[c.sid.toString()]=c.saveToJSON();return d};a.prototype.loadFromJSON=function(a){var b,c,d,l;this.scrollX=a.sx;this.scrollY=a.sy;this.scale=a.s;this.angle=a.a;this.width=a.w;this.height=a.h;this.persist_data=a.persist;"undefined"!==typeof a.fv&&(this.first_visit=a.fv);var k=a.fx;b=0;for(c=k.length;b<c;b++)if(d=this.getEffectByName(k[b].name))d.active=k[b].active,this.effect_params[d.index]=k[b].params;this.updateActiveEffects();b=a.layers;for(l in b)b.hasOwnProperty(l)&&(a=this.getLayerBySid(parseInt(l,
10)))&&a.loadFromJSON(b[l])};cr.layout=a;b.prototype.updateActiveEffects=function(){this.active_effect_types.length=0;var a,b,c;a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],c.active&&this.active_effect_types.push(c)};b.prototype.getEffectByName=function(a){var b,c,d;b=0;for(c=this.effect_types.length;b<c;b++)if(d=this.effect_types[b],d.name===a)return d;return null};b.prototype.createInitialInstances=function(){var a,b,c,h,l,k;b=a=0;for(c=this.initial_instances.length;a<c;a++){h=
this.initial_instances[a];l=this.runtime.types_by_index[h[1]];k=this.runtime.typeHasPersistBehavior(l);l=!0;if(!k||this.layout.first_visit)h=this.runtime.createInstanceFromInit(h,this,!0),d.push(h),h.type.global&&(l=!1);l&&(this.initial_instances[b]=this.initial_instances[a],b++)}this.initial_instances.length=b;this.runtime.ClearDeathRow();!this.runtime.glwrap&&this.effect_types.length&&(this.blend_mode=this.effect_fallback);this.compositeOp=cr.effectToCompositeOp(this.blend_mode);this.runtime.gl&&
cr.setGLBlend(this,this.blend_mode,this.runtime.gl)};b.prototype.updateZIndices=function(){if(this.zindices_stale){var a,b;a=0;for(b=this.instances.length;a<b;a++)this.instances[a].zindex=a;this.zindices_stale=!1}};b.prototype.getScale=function(){return this.getNormalScale()*this.runtime.aspect_scale};b.prototype.getNormalScale=function(){return(this.scale*this.layout.scale-1)*this.zoomRate+1};b.prototype.getAngle=function(){return this.disableAngle?0:cr.clamp_angle(this.layout.angle+this.angle)};
b.prototype.draw=function(a){this.render_offscreen=this.forceOwnTexture||1!==this.opacity||0!==this.blend_mode;var b=this.runtime.canvas,c=a;a.globalAlpha=1;a.globalCompositeOperation="source-over";this.render_offscreen&&(this.runtime.layer_canvas||(this.runtime.layer_canvas=document.createElement("canvas"),b=this.runtime.layer_canvas,b.width=this.runtime.width,b.height=this.runtime.height,this.runtime.layer_ctx=b.getContext("2d")),b=this.runtime.layer_canvas,c=this.runtime.layer_ctx,b.width!==this.runtime.width&&
(b.width=this.runtime.width),b.height!==this.runtime.height&&(b.height=this.runtime.height),this.transparent&&c.clearRect(0,0,this.runtime.width,this.runtime.height));this.transparent||(c.fillStyle="rgb("+this.background_color[0]+","+this.background_color[1]+","+this.background_color[2]+")",c.fillRect(0,0,this.runtime.width,this.runtime.height));c.save();this.disableAngle=!0;var d=this.canvasToLayer(0,0,!0),l=this.canvasToLayer(0,0,!1);this.disableAngle=!1;this.runtime.pixel_rounding&&(d=d+0.5|0,
l=l+0.5|0);this.rotateViewport(d,l,c);var k=this.getScale();c.scale(k,k);c.translate(-d,-l);for(var m,d=0,l=this.instances.length;d<l;d++)if(k=this.instances[d],k.visible&&!(0===k.width||0===k.height))k.update_bbox(),m=k.bbox,m.right<this.viewLeft||(m.bottom<this.viewTop||m.left>this.viewRight||m.top>this.viewBottom)||(c.globalCompositeOperation=k.compositeOp,k.draw(c));c.restore();this.render_offscreen&&(a.globalCompositeOperation=this.compositeOp,a.globalAlpha=this.opacity,a.drawImage(b,0,0))};
b.prototype.rotateViewport=function(a,b,c){var d=this.getScale();this.viewLeft=a;this.viewTop=b;this.viewRight=a+this.runtime.width*(1/d);this.viewBottom=b+this.runtime.height*(1/d);a=this.getAngle();0!==a&&(c&&(c.translate(this.runtime.width/2,this.runtime.height/2),c.rotate(-a),c.translate(this.runtime.width/-2,this.runtime.height/-2)),this.tmprect.set(this.viewLeft,this.viewTop,this.viewRight,this.viewBottom),this.tmprect.offset((this.viewLeft+this.viewRight)/-2,(this.viewTop+this.viewBottom)/
-2),this.tmpquad.set_from_rotated_rect(this.tmprect,a),this.tmpquad.bounding_box(this.tmprect),this.tmprect.offset((this.viewLeft+this.viewRight)/2,(this.viewTop+this.viewBottom)/2),this.viewLeft=this.tmprect.left,this.viewTop=this.tmprect.top,this.viewRight=this.tmprect.right,this.viewBottom=this.tmprect.bottom)};b.prototype.drawGL=function(a){var b=this.runtime.width,c=this.runtime.height,d=0,l=0;if(this.render_offscreen=this.forceOwnTexture||1!==this.opacity||0<this.active_effect_types.length||
0!==this.blend_mode){this.runtime.layer_tex||(this.runtime.layer_tex=a.createEmptyTexture(this.runtime.width,this.runtime.height,this.runtime.linearSampling));if(this.runtime.layer_tex.c2width!==this.runtime.width||this.runtime.layer_tex.c2height!==this.runtime.height)a.deleteTexture(this.runtime.layer_tex),this.runtime.layer_tex=a.createEmptyTexture(this.runtime.width,this.runtime.height,this.runtime.linearSampling);a.setRenderingToTexture(this.runtime.layer_tex);this.transparent&&a.clear(0,0,0,
0)}this.transparent||a.clear(this.background_color[0]/255,this.background_color[1]/255,this.background_color[2]/255,1);this.disableAngle=!0;var l=this.canvasToLayer(0,0,!0),k=this.canvasToLayer(0,0,!1);this.disableAngle=!1;this.runtime.pixel_rounding&&(l=l+0.5|0,k=k+0.5|0);this.rotateViewport(l,k,null);k=this.getScale();a.resetModelView();a.scale(k,k);a.rotateZ(-this.getAngle());a.translate((this.viewLeft+this.viewRight)/-2,(this.viewTop+this.viewBottom)/-2);a.updateModelView();var m,n,q;m=0;for(n=
this.instances.length;m<n;m++)if(q=this.instances[m],q.visible&&!(0===q.width||0===q.height))if(q.update_bbox(),d=q.bbox,!(d.right<this.viewLeft||d.bottom<this.viewTop||d.left>this.viewRight||d.top>this.viewBottom))if(q.uses_shaders)if(d=q.active_effect_types[0].shaderindex,l=q.active_effect_types[0].index,1===q.active_effect_types.length&&!a.programUsesCrossSampling(d)&&!a.programExtendsBox(d)&&(!q.angle&&!q.layer.getAngle()||!a.programUsesDest(d))&&1===q.opacity&&!q.type.plugin.must_predraw){a.switchProgram(d);
a.setBlend(q.srcBlend,q.destBlend);a.programIsAnimated(d)&&(this.runtime.redraw=!0);var p=0,r=0,s=0,t=0;a.programUsesDest(d)&&(d=q.bbox,p=this.layerToCanvas(d.left,d.top,!0),r=this.layerToCanvas(d.left,d.top,!1),s=this.layerToCanvas(d.right,d.bottom,!0),d=this.layerToCanvas(d.right,d.bottom,!1),p/=b,r=1-r/c,s/=b,t=1-d/c);a.setProgramParameters(this.render_offscreen?this.runtime.layer_tex:this.layout.getRenderTarget(),1/q.width,1/q.height,p,r,s,t,this.getScale(),q.effect_params[l]);q.drawGL(a)}else this.layout.renderEffectChain(a,
this,q,this.render_offscreen?this.runtime.layer_tex:this.layout.getRenderTarget()),a.resetModelView(),a.scale(k,k),a.rotateZ(-this.getAngle()),a.translate((this.viewLeft+this.viewRight)/-2,(this.viewTop+this.viewBottom)/-2),a.updateModelView();else a.switchProgram(0),a.setBlend(q.srcBlend,q.destBlend),q.drawGL(a);this.render_offscreen&&(d=this.active_effect_types.length?this.active_effect_types[0].shaderindex:0,l=this.active_effect_types.length?this.active_effect_types[0].index:0,0===this.active_effect_types.length||
1===this.active_effect_types.length&&!a.programUsesCrossSampling(d)&&1===this.opacity?(1===this.active_effect_types.length?(a.switchProgram(d),a.setProgramParameters(this.layout.getRenderTarget(),1/this.runtime.width,1/this.runtime.height,0,0,1,1,this.getScale(),this.effect_params[l]),a.programIsAnimated(d)&&(this.runtime.redraw=!0)):a.switchProgram(0),a.setRenderingToTexture(this.layout.getRenderTarget()),a.setOpacity(this.opacity),a.setTexture(this.runtime.layer_tex),a.setBlend(this.srcBlend,this.destBlend),
a.resetModelView(),a.updateModelView(),b=this.runtime.width/2,c=this.runtime.height/2,a.quad(-b,c,b,c,b,-c,-b,-c),a.setTexture(null)):this.layout.renderEffectChain(a,this,null,this.layout.getRenderTarget()))};b.prototype.canvasToLayer=function(a,b,c){var d=this.runtime.devicePixelRatio;this.runtime.isRetina&&0<this.runtime.fullscreen_mode&&(a*=d,b*=d);var d=this.runtime.original_width/2,l=this.runtime.original_height/2,d=(this.layout.scrollX-d)*this.parallaxX+d,l=(this.layout.scrollY-l)*this.parallaxY+
l,k=1/this.getScale(),d=d-this.runtime.width*k/2,l=l-this.runtime.height*k/2,d=d+a*k,l=l+b*k;b=this.getAngle();0!==b&&(d-=this.layout.scrollX,l-=this.layout.scrollY,a=Math.cos(b),b=Math.sin(b),k=d*a-l*b,l=l*a+d*b,d=k+this.layout.scrollX,l+=this.layout.scrollY);return c?d:l};b.prototype.layerToCanvas=function(a,b,c){var d=this.getAngle();if(0!==d){a-=this.layout.scrollX;b-=this.layout.scrollY;var l=Math.cos(-d),d=Math.sin(-d),k=a*l-b*d;b=b*l+a*d;a=k+this.layout.scrollX;b+=this.layout.scrollY}l=this.runtime.original_width/
2;d=this.runtime.original_height/2;l=(this.layout.scrollX-l)*this.parallaxX+l;d=(this.layout.scrollY-d)*this.parallaxY+d;k=1/this.getScale();l-=this.runtime.width*k/2;d-=this.runtime.height*k/2;l=(a-l)/k;d=(b-d)/k;a=this.runtime.devicePixelRatio;this.runtime.isRetina&&0<this.runtime.fullscreen_mode&&(l/=a,d/=a);return c?l:d};b.prototype.rotatePt=function(a,b,c){if(0===this.getAngle())return c?a:b;var d=this.layerToCanvas(a,b,!0);b=this.layerToCanvas(a,b,!1);this.disableAngle=!0;a=this.canvasToLayer(d,
b,!0);d=this.canvasToLayer(d,b,!0);this.disableAngle=!1;return c?a:d};b.prototype.saveToJSON=function(){var a,b,c,d={s:this.scale,a:this.angle,vl:this.viewLeft,vt:this.viewTop,vr:this.viewRight,vb:this.viewBottom,v:this.visible,bc:this.background_color,t:this.transparent,px:this.parallaxX,py:this.parallaxY,o:this.opacity,zr:this.zoomRate,fx:[],instances:[]};a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],d.fx.push({name:c.name,active:c.active,params:this.effect_params[c.index]});
return d};b.prototype.loadFromJSON=function(a){var b,d;this.scale=a.s;this.angle=a.a;this.viewLeft=a.vl;this.viewTop=a.vt;this.viewRight=a.vr;this.viewBottom=a.vb;this.visible=a.v;this.background_color=a.bc;this.transparent=a.t;this.parallaxX=a.px;this.parallaxY=a.py;this.opacity=a.o;this.zoomRate=a.zr;var h=a.fx;a=0;for(b=h.length;a<b;a++)if(d=this.getEffectByName(h[a].name))d.active=h[a].active,this.effect_params[d.index]=h[a].params;this.updateActiveEffects();this.instances.sort(c);this.zindices_stale=
!0};cr.layer=b})();
(function(){function a(a,b){var c,d=a.length;switch(d){case 0:return!0;case 1:return a[0]===b[0];case 2:return a[0]===b[0]&&a[1]===b[1];default:for(c=0;c<d;c++)if(a[c]!==b[c])return!1;return!0}}function b(a,b){return a.index-b.index}function c(c){var d,e,k,h;2===c.length?c[0].index>c[1].index&&(d=c[0],c[0]=c[1],c[1]=d):2<c.length&&c.sort(b);c.length>=p.length&&(p.length=c.length+1);p[c.length]||(p[c.length]=[]);h=p[c.length];d=0;for(e=h.length;d<e;d++)if(k=h[d],a(c,k))return k;h.push(c);return c}
function d(a,b){this.runtime=a;this.triggers={};this.fasttriggers={};this.hasRun=!1;this.includes=new cr.ObjectSet;this.name=b[0];var c=b[1];this.events=[];var d,e;d=0;for(e=c.length;d<e;d++)this.init_event(c[d],null,this.events)}function e(a){this.type=a;this.instances=[];this.else_instances=[];this.select_all=!0}function f(a,b,c){this.sheet=a;this.parent=b;this.runtime=a.runtime;this.solModifiers=[];this.solModifiersIncludingParents=[];this.has_else_block=this.toplevelgroup=this.toplevelevent=this.initially_activated=
this.group=this.solWriterAfterCnds=!1;this.conditions=[];this.actions=[];this.subevents=[];c[1]?(this.group_name=c[1][1].toLowerCase(),this.group=!0,this.initially_activated=!!c[1][0],this.runtime.allGroups.push(this),this.runtime.activeGroups[this.group_name.toLowerCase()]=this.initially_activated):(this.group_name="",this.initially_activated=this.group=!1);this.orblock=c[2];this.sid=c[3];this.group||(this.runtime.blocksBySid[this.sid.toString()]=this);var d=c[4];a=0;for(b=d.length;a<b;a++){var e=
new cr.condition(this,d[a]);cr.seal(e);this.conditions.push(e);this.addSolModifier(e.type)}d=c[5];a=0;for(b=d.length;a<b;a++)e=new cr.action(this,d[a]),cr.seal(e),this.actions.push(e);if(7===c.length){c=c[6];a=0;for(b=c.length;a<b;a++)this.sheet.init_event(c[a],this,this.subevents)}this.is_else_block=!1;this.conditions.length&&(this.is_else_block=null==this.conditions[0].type&&this.conditions[0].func==cr.system_object.prototype.cnds.Else)}function g(a,b){var c,d,e;if(a&&(-1===b.indexOf(a)&&b.push(a),
a.is_contained)){c=0;for(d=a.container.length;c<d;c++)e=a.container[c],a!==e&&-1===b.indexOf(e)&&b.push(e)}}function h(a,b){this.block=a;this.sheet=a.sheet;this.runtime=a.runtime;this.parameters=[];this.results=[];this.extra={};this.func=b[1];this.trigger=0<b[3];this.fasttrigger=2===b[3];this.looping=b[4];this.inverted=b[5];this.isstatic=b[6];this.sid=b[7];this.runtime.cndsBySid[this.sid.toString()]=this;-1===b[0]?(this.type=null,this.run=this.run_system,this.behaviortype=null,this.beh_index=-1):
(this.type=this.runtime.types_by_index[b[0]],this.run=this.isstatic?this.run_static:this.run_object,b[2]?(this.behaviortype=this.type.getBehaviorByName(b[2]),this.beh_index=this.type.getBehaviorIndexByName(b[2])):(this.behaviortype=null,this.beh_index=-1),this.block.parent&&this.block.parent.setSolWriterAfterCnds());this.fasttrigger&&(this.run=this.run_true);if(9===b.length){var c,d,e=b[8];c=0;for(d=e.length;c<d;c++){var k=new cr.parameter(this,e[c]);cr.seal(k);this.parameters.push(k)}this.results.length=
e.length}}function l(a,b){this.block=a;this.sheet=a.sheet;this.runtime=a.runtime;this.parameters=[];this.results=[];this.extra={};this.func=b[1];-1===b[0]?(this.type=null,this.run=this.run_system,this.behaviortype=null,this.beh_index=-1):(this.type=this.runtime.types_by_index[b[0]],this.run=this.run_object,b[2]?(this.behaviortype=this.type.getBehaviorByName(b[2]),this.beh_index=this.type.getBehaviorIndexByName(b[2])):(this.behaviortype=null,this.beh_index=-1));this.sid=b[3];this.runtime.actsBySid[this.sid.toString()]=
this;if(5===b.length){var c,d,e=b[4];c=0;for(d=e.length;c<d;c++){var k=new cr.parameter(this,e[c]);cr.seal(k);this.parameters.push(k)}this.results.length=e.length}}function k(a,b){this.owner=a;this.block=a.block;this.sheet=a.sheet;this.runtime=a.runtime;this.type=b[0];this.expression=null;this.combosel=this.solindex=0;this.layout=null;this.key=0;this.object=null;this.index=0;this.variadicret=this.subparams=this.fileinfo=this.eventvar=this.varname=null;var c,d,e;switch(b[0]){case 0:case 7:this.expression=
new cr.expNode(this,b[1]);this.solindex=0;this.get=this.get_exp;break;case 1:this.expression=new cr.expNode(this,b[1]);this.solindex=0;this.get=this.get_exp_str;break;case 5:this.expression=new cr.expNode(this,b[1]);this.solindex=0;this.get=this.get_layer;break;case 3:case 8:this.combosel=b[1];this.get=this.get_combosel;break;case 6:this.layout=this.runtime.layouts[b[1]];this.get=this.get_layout;break;case 9:this.key=b[1];this.get=this.get_key;break;case 4:this.object=this.runtime.types_by_index[b[1]];
this.get=this.get_object;this.block.addSolModifier(this.object);this.owner instanceof cr.action?this.block.setSolWriterAfterCnds():this.block.parent&&this.block.parent.setSolWriterAfterCnds();break;case 10:this.index=b[1];this.get=a.type.is_family?this.get_familyvar:this.get_instvar;break;case 11:this.varname=b[1];this.eventvar=null;this.get=this.get_eventvar;break;case 2:case 12:this.fileinfo=b[1];this.get=this.get_audiofile;break;case 13:this.get=this.get_variadic;this.subparams=[];this.variadicret=
[];c=1;for(d=b.length;c<d;c++)e=new cr.parameter(this.owner,b[c]),cr.seal(e),this.subparams.push(e),this.variadicret.push(0)}}function m(a,b,c){this.sheet=a;this.parent=b;this.runtime=a.runtime;this.solModifiers=[];this.name=c[1];this.vartype=c[2];this.initial=c[3];this.is_static=!!c[4];this.is_constant=!!c[5];this.sid=c[6];this.runtime.varsBySid[this.sid.toString()]=this;this.data=this.initial;this.parent?(this.localIndex=this.is_static||this.is_constant?-1:this.runtime.stackLocalCount++,this.runtime.all_local_vars.push(this)):
(this.localIndex=-1,this.runtime.all_global_vars.push(this))}function n(a,b,c){this.sheet=a;this.parent=b;this.runtime=a.runtime;this.solModifiers=[];this.include_sheet=null;this.include_sheet_name=c[1]}function q(){this.temp_parents_arr=[];this.reset(null);cr.seal(this)}var p=[];d.prototype.toString=function(){return this.name};d.prototype.init_event=function(a,b,c){switch(a[0]){case 0:a=new cr.eventblock(this,b,a);cr.seal(a);if(a.orblock){c.push(a);c=0;for(b=a.conditions.length;c<b;c++)a.conditions[c].trigger&&
this.init_trigger(a,c)}else a.is_trigger()?this.init_trigger(a,0):c.push(a);break;case 1:a=new cr.eventvariable(this,b,a);cr.seal(a);c.push(a);break;case 2:a=new cr.eventinclude(this,b,a),cr.seal(a),c.push(a)}};d.prototype.postInit=function(){var a,b;a=0;for(b=this.events.length;a<b;a++)this.events[a].postInit(a<b-1&&this.events[a+1].is_else_block)};d.prototype.run=function(){this.hasRun=!0;this.runtime.isRunningEvents=!0;var a,b;a=0;for(b=this.events.length;a<b;a++){var c=this.events[a];c.run();
this.runtime.clearSol(c.solModifiers);(!this.runtime.deathRow.isEmpty()||this.runtime.createRow.length)&&this.runtime.ClearDeathRow()}this.runtime.isRunningEvents=!1};d.prototype.init_trigger=function(a,b){a.orblock||this.runtime.triggers_to_postinit.push(a);var c,d,e=a.conditions[b],k;k=e.type?e.type.name:"system";var h=(c=e.fasttrigger)?this.fasttriggers:this.triggers;h[k]||(h[k]=[]);k=h[k];h=e.func;if(c){if(e.parameters.length&&(e=e.parameters[0],!(1!==e.type||2!==e.expression.type))){e=e.expression.value.toLowerCase();
c=0;for(d=k.length;c<d;c++)if(k[c].method==h){c=k[c].evs;c[e]?c[e].push([a,b]):c[e]=[[a,b]];return}c={};c[e]=[[a,b]];k.push({method:h,evs:c})}}else{c=0;for(d=k.length;c<d;c++)if(k[c].method==h){k[c].evs.push([a,b]);return}k.push({method:h,evs:[[a,b]]})}};cr.eventsheet=d;e.prototype.hasObjects=function(){return this.select_all?this.type.instances.length:this.instances.length};e.prototype.getObjects=function(){return this.select_all?this.type.instances:this.instances};e.prototype.pick_one=function(a){a&&
(a.runtime.getCurrentEventStack().current_event.orblock?(this.select_all&&(this.instances.length=0,cr.shallowAssignArray(this.else_instances,a.type.instances),this.select_all=!1),a=this.else_instances.indexOf(a),-1!==a&&(this.instances.push(this.else_instances[a]),this.else_instances.splice(a,1))):(this.select_all=!1,this.instances.length=1,this.instances[0]=a))};cr.selection=e;f.prototype.postInit=function(a){var b,d=this.parent;if(this.group)for(this.toplevelgroup=!0;d;){if(!d.group){this.toplevelgroup=
!1;break}d=d.parent}this.toplevelevent=!this.is_trigger()&&(!this.parent||this.parent.group&&this.parent.toplevelgroup);this.has_else_block=!!a;this.solModifiersIncludingParents=this.solModifiers.slice(0);for(d=this.parent;d;){a=0;for(b=d.solModifiers.length;a<b;a++)this.addParentSolModifier(d.solModifiers[a]);d=d.parent}this.solModifiers=c(this.solModifiers);this.solModifiersIncludingParents=c(this.solModifiersIncludingParents);a=0;for(b=this.conditions.length;a<b;a++)this.conditions[a].postInit();
a=0;for(b=this.actions.length;a<b;a++)this.actions[a].postInit();a=0;for(b=this.subevents.length;a<b;a++)this.subevents[a].postInit(a<b-1&&this.subevents[a+1].is_else_block)};f.prototype.addSolModifier=function(a){g(a,this.solModifiers)};f.prototype.addParentSolModifier=function(a){g(a,this.solModifiersIncludingParents)};f.prototype.setSolWriterAfterCnds=function(){this.solWriterAfterCnds=!0;this.parent&&this.parent.setSolWriterAfterCnds()};f.prototype.is_trigger=function(){return this.conditions.length?
this.conditions[0].trigger:!1};f.prototype.run=function(){var a,b=!1,c=this.runtime.getCurrentEventStack();c.current_event=this;this.is_else_block||(c.else_branch_ran=!1);if(this.orblock){0===this.conditions.length&&(b=!0);c.cndindex=0;for(a=this.conditions.length;c.cndindex<a;c.cndindex++)this.conditions[c.cndindex].trigger||this.conditions[c.cndindex].run()&&(b=!0);(c.last_event_true=b)&&this.run_actions_and_subevents()}else{c.cndindex=0;for(a=this.conditions.length;c.cndindex<a;c.cndindex++)if(!this.conditions[c.cndindex].run()){c.last_event_true=
!1;this.toplevelevent&&(!this.runtime.deathRow.isEmpty()||this.runtime.createRow.length)&&this.runtime.ClearDeathRow();return}c.last_event_true=!0;this.run_actions_and_subevents()}c.last_event_true&&this.has_else_block&&(c.else_branch_ran=!0);this.toplevelevent&&(!this.runtime.deathRow.isEmpty()||this.runtime.createRow.length)&&this.runtime.ClearDeathRow()};f.prototype.run_orblocktrigger=function(a){this.runtime.getCurrentEventStack().current_event=this;this.conditions[a].run()&&this.run_actions_and_subevents()};
f.prototype.run_actions_and_subevents=function(){var a=this.runtime.getCurrentEventStack(),b;a.actindex=0;for(b=this.actions.length;a.actindex<b;a.actindex++)if(this.actions[a.actindex].run())return;this.run_subevents()};f.prototype.resume_actions_and_subevents=function(){var a=this.runtime.getCurrentEventStack(),b;for(b=this.actions.length;a.actindex<b;a.actindex++)if(this.actions[a.actindex].run())return;this.run_subevents()};f.prototype.run_subevents=function(){if(this.subevents.length){var a,
b,c,d,e=this.subevents.length-1;this.runtime.pushEventStack(this);if(this.solWriterAfterCnds){a=0;for(b=this.subevents.length;a<b;a++)c=this.subevents[a],(d=!this.toplevelgroup||!this.group&&a<e)&&this.runtime.pushCopySol(c.solModifiers),c.run(),d?this.runtime.popSol(c.solModifiers):this.runtime.clearSol(c.solModifiers)}else{a=0;for(b=this.subevents.length;a<b;a++)this.subevents[a].run()}this.runtime.popEventStack()}};f.prototype.run_pretrigger=function(){var a=this.runtime.getCurrentEventStack();
a.current_event=this;var b=!1,c;a.cndindex=0;for(c=this.conditions.length;a.cndindex<c;a.cndindex++)if(this.conditions[a.cndindex].run())b=!0;else if(!this.orblock)return!1;return this.orblock?b:!0};f.prototype.retrigger=function(){this.runtime.execcount++;var a=this.runtime.getCurrentEventStack().cndindex,b=this.runtime.pushEventStack(this);if(!this.orblock){b.cndindex=a+1;for(a=this.conditions.length;b.cndindex<a;b.cndindex++)if(!this.conditions[b.cndindex].run())return this.runtime.popEventStack(),
!1}this.run_actions_and_subevents();this.runtime.popEventStack();return!0};cr.eventblock=f;h.prototype.postInit=function(){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.parameters[a].postInit()};h.prototype.run_true=function(){return!0};h.prototype.run_system=function(){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.results[a]=this.parameters[a].get();return cr.xor(this.func.apply(this.runtime.system,this.results),this.inverted)};h.prototype.run_static=function(){var a,b;a=0;for(b=
this.parameters.length;a<b;a++)this.results[a]=this.parameters[a].get(a);a=this.func.apply(this.behaviortype?this.behaviortype:this.type,this.results);this.type.applySolToContainer();return a};h.prototype.run_object=function(){var a,b,c,d,e,k,h,f=this.type.getCurrentSol(),g=this.block.orblock&&!this.trigger,m=0,l=this.type.is_contained;if(f.select_all){f.instances.length=0;a=f.else_instances.length=0;for(c=this.type.instances.length;a<c;a++){k=this.type.instances[a];b=0;for(d=this.parameters.length;b<
d;b++)this.results[b]=this.parameters[b].get(a);-1<this.beh_index?(this.type.is_family&&(m=k.type.family_beh_map[this.type.family_index]),b=this.func.apply(k.behavior_insts[this.beh_index+m],this.results)):b=this.func.apply(k,this.results);(e=cr.xor(b,this.inverted))?f.instances.push(k):g&&f.else_instances.push(k)}this.type.finish&&this.type.finish(!0);f.select_all=!1;this.type.applySolToContainer();return f.hasObjects()}var p=0,n=(e=g&&0<this.runtime.getCurrentEventStack().cndindex)?f.else_instances:
f.instances,r=!1;a=0;for(c=n.length;a<c;a++){k=n[a];b=0;for(d=this.parameters.length;b<d;b++)this.results[b]=this.parameters[b].get(a);-1<this.beh_index?(this.type.is_family&&(m=k.type.family_beh_map[this.type.family_index]),b=this.func.apply(k.behavior_insts[this.beh_index+m],this.results)):b=this.func.apply(k,this.results);if(cr.xor(b,this.inverted))if(r=!0,e){if(f.instances.push(k),l){b=0;for(d=k.siblings.length;b<d;b++)h=k.siblings[b],h.type.getCurrentSol().instances.push(h)}}else{n[p]=k;if(l){b=
0;for(d=k.siblings.length;b<d;b++)h=k.siblings[b],h.type.getCurrentSol().instances[p]=h}p++}else if(e){n[p]=k;if(l){b=0;for(d=k.siblings.length;b<d;b++)h=k.siblings[b],h.type.getCurrentSol().else_instances[p]=h}p++}else if(f.else_instances.push(k),l){b=0;for(d=k.siblings.length;b<d;b++)h=k.siblings[b],h.type.getCurrentSol().else_instances.push(h)}}n.length=p;if(l){a=0;for(c=this.type.container.length;a<c;a++)k=this.type.container[a].getCurrentSol(),e?k.else_instances.length=p:k.instances.length=p}m=
r;if(e&&!r){a=0;for(c=f.instances.length;a<c;a++){k=f.instances[a];b=0;for(d=this.parameters.length;b<d;b++)this.results[b]=this.parameters[b].get(a);b=-1<this.beh_index?this.func.apply(k.behavior_insts[this.beh_index],this.results):this.func.apply(k,this.results);if(cr.xor(b,this.inverted)){r=!0;break}}}this.type.finish&&this.type.finish(m||g);return g?r:f.hasObjects()};cr.condition=h;l.prototype.postInit=function(){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.parameters[a].postInit()};
l.prototype.run_system=function(){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.results[a]=this.parameters[a].get();return this.func.apply(this.runtime.system,this.results)};l.prototype.run_object=function(){var a=this.type.getCurrentSol().getObjects(),b,c,d,e,k;b=0;for(d=a.length;b<d;b++){k=a[b];c=0;for(e=this.parameters.length;c<e;c++)this.results[c]=this.parameters[c].get(b);-1<this.beh_index?(c=0,this.type.is_family&&(c=k.type.family_beh_map[this.type.family_index]),this.func.apply(k.behavior_insts[this.beh_index+
c],this.results)):this.func.apply(k,this.results)}return!1};cr.action=l;var r=[],s=-1;k.prototype.postInit=function(){var a,b;if(11===this.type)this.eventvar=this.runtime.getEventVariableByName(this.varname,this.block.parent);else if(13===this.type){a=0;for(b=this.subparams.length;a<b;a++)this.subparams[a].postInit()}this.expression&&this.expression.postInit()};k.prototype.pushTempValue=function(){s++;r.length===s&&r.push(new cr.expvalue);return r[s]};k.prototype.popTempValue=function(){s--};k.prototype.get_exp=
function(a){this.solindex=a||0;a=this.pushTempValue();this.expression.get(a);this.popTempValue();return a.data};k.prototype.get_exp_str=function(a){this.solindex=a||0;a=this.pushTempValue();this.expression.get(a);this.popTempValue();return cr.is_string(a.data)?a.data:""};k.prototype.get_object=function(){return this.object};k.prototype.get_combosel=function(){return this.combosel};k.prototype.get_layer=function(a){this.solindex=a||0;a=this.pushTempValue();this.expression.get(a);this.popTempValue();
return a.is_number()?this.runtime.getLayerByNumber(a.data):this.runtime.getLayerByName(a.data)};k.prototype.get_layout=function(){return this.layout};k.prototype.get_key=function(){return this.key};k.prototype.get_instvar=function(){return this.index};k.prototype.get_familyvar=function(a){var b=this.owner.type,c=null,c=b.getCurrentSol(),d=c.getObjects(),c=d.length?d[a%d.length].type:c.else_instances[a%c.else_instances.length].type;return this.index+c.family_var_map[b.family_index]};k.prototype.get_eventvar=
function(){return this.eventvar};k.prototype.get_audiofile=function(){return this.fileinfo};k.prototype.get_variadic=function(){var a,b;a=0;for(b=this.subparams.length;a<b;a++)this.variadicret[a]=this.subparams[a].get();return this.variadicret};cr.parameter=k;m.prototype.postInit=function(){this.solModifiers=c(this.solModifiers)};m.prototype.setValue=function(a){var b=this.runtime.getCurrentLocalVarStack();!this.parent||this.is_static||!b?this.data=a:(this.localIndex>=b.length&&(b.length=this.localIndex+
1),b[this.localIndex]=a)};m.prototype.getValue=function(){var a=this.runtime.getCurrentLocalVarStack();return!this.parent||this.is_static||!a||this.is_constant?this.data:this.localIndex>=a.length||"undefined"===typeof a[this.localIndex]?this.initial:a[this.localIndex]};m.prototype.run=function(){this.parent&&(!this.is_static&&!this.is_constant)&&this.setValue(this.initial)};cr.eventvariable=m;n.prototype.toString=function(){return"include:"+this.include_sheet.toString()};n.prototype.postInit=function(){this.include_sheet=
this.runtime.eventsheets[this.include_sheet_name];this.sheet.includes.add(this);this.solModifiers=c(this.solModifiers)};n.prototype.run=function(){this.parent&&this.runtime.pushCleanSol(this.runtime.types_by_index);this.include_sheet.hasRun||this.include_sheet.run();this.parent&&this.runtime.popSol(this.runtime.types_by_index)};n.prototype.isActive=function(){for(var a=this.parent;a;){if(a.group&&!this.runtime.activeGroups[a.group_name.toLowerCase()])return!1;a=a.parent}return!0};cr.eventinclude=
n;q.prototype.reset=function(a){this.current_event=a;this.actindex=this.cndindex=0;this.temp_parents_arr.length=0;this.else_branch_ran=this.last_event_true=!1};q.prototype.isModifierAfterCnds=function(){return this.current_event.solWriterAfterCnds?!0:this.cndindex<this.current_event.conditions.length-1?!!this.current_event.solModifiers.length:!1};cr.eventStackFrame=q})();
(function(){function a(a,b){this.owner=a;this.runtime=a.runtime;this.type=b[0];this.get=[this.eval_int,this.eval_float,this.eval_string,this.eval_unaryminus,this.eval_add,this.eval_subtract,this.eval_multiply,this.eval_divide,this.eval_mod,this.eval_power,this.eval_and,this.eval_or,this.eval_equal,this.eval_notequal,this.eval_less,this.eval_lessequal,this.eval_greater,this.eval_greaterequal,this.eval_conditional,this.eval_system_exp,this.eval_object_behavior_exp,this.eval_instvar_exp,this.eval_object_behavior_exp,
this.eval_eventvar_exp][this.type];var e=null;this.object_type=this.parameters=this.results=this.func=this.third=this.second=this.first=this.value=null;this.beh_index=-1;this.instance_expr=null;this.varindex=-1;this.eventvar=this.varname=this.behavior_type=null;this.return_string=!1;switch(this.type){case 0:case 1:case 2:this.value=b[1];break;case 3:this.first=new cr.expNode(a,b[1]);break;case 18:this.first=new cr.expNode(a,b[1]);this.second=new cr.expNode(a,b[2]);this.third=new cr.expNode(a,b[3]);
break;case 19:this.func=b[1];this.results=[];this.parameters=[];3===b.length?(e=b[2],this.results.length=e.length+1):this.results.length=1;break;case 20:this.object_type=this.runtime.types_by_index[b[1]];this.beh_index=-1;this.func=b[2];this.return_string=b[3];this.instance_expr=b[4]?new cr.expNode(a,b[4]):null;this.results=[];this.parameters=[];6===b.length?(e=b[5],this.results.length=e.length+1):this.results.length=1;break;case 21:this.object_type=this.runtime.types_by_index[b[1]];this.return_string=
b[2];this.instance_expr=b[3]?new cr.expNode(a,b[3]):null;this.varindex=b[4];break;case 22:this.object_type=this.runtime.types_by_index[b[1]];this.behavior_type=this.object_type.getBehaviorByName(b[2]);this.beh_index=this.object_type.getBehaviorIndexByName(b[2]);this.func=b[3];this.return_string=b[4];this.instance_expr=b[5]?new cr.expNode(a,b[5]):null;this.results=[];this.parameters=[];7===b.length?(e=b[6],this.results.length=e.length+1):this.results.length=1;break;case 23:this.varname=b[1],this.eventvar=
null}4<=this.type&&17>=this.type&&(this.first=new cr.expNode(a,b[1]),this.second=new cr.expNode(a,b[2]));if(e){var f,g;f=0;for(g=e.length;f<g;f++)this.parameters.push(new cr.expNode(a,e[f]))}cr.seal(this)}function b(a,b){this.type=a||cr.exptype.Integer;this.data=b||0;this.object_class=null;this.type==cr.exptype.Integer&&(this.data=Math.floor(this.data));cr.seal(this)}a.prototype.postInit=function(){23===this.type&&(this.eventvar=this.owner.runtime.getEventVariableByName(this.varname,this.owner.block.parent));
this.first&&this.first.postInit();this.second&&this.second.postInit();this.third&&this.third.postInit();this.instance_expr&&this.instance_expr.postInit();if(this.parameters){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.parameters[a].postInit()}};a.prototype.eval_system_exp=function(a){this.results[0]=a;a=this.owner.pushTempValue();var b,e;b=0;for(e=this.parameters.length;b<e;b++)this.parameters[b].get(a),this.results[b+1]=a.data;this.owner.popTempValue();this.func.apply(this.runtime.system,
this.results)};a.prototype.eval_object_behavior_exp=function(a){var b=this.object_type.getCurrentSol(),e=b.getObjects();if(!e.length)if(b.else_instances.length)e=b.else_instances;else{this.return_string?a.set_string(""):a.set_int(0);return}this.results[0]=a;a.object_class=this.object_type;a=this.owner.pushTempValue();var f,b=0;for(f=this.parameters.length;b<f;b++)this.parameters[b].get(a),this.results[b+1]=a.data;b=this.owner.solindex;this.instance_expr&&(this.instance_expr.get(a),a.is_number()&&
(b=a.data,e=this.object_type.instances));this.owner.popTempValue();b%=e.length;0>b&&(b+=e.length);e=e[b];-1<this.beh_index?(a=0,this.object_type.is_family&&(a=e.type.family_beh_map[this.object_type.family_index]),this.func.apply(e.behavior_insts[this.beh_index+a],this.results)):this.func.apply(e,this.results)};a.prototype.eval_instvar_exp=function(a){var b=this.object_type.getCurrentSol(),e=b.getObjects();if(!e.length)if(b.else_instances.length)e=b.else_instances;else{this.return_string?a.set_string(""):
a.set_int(0);return}b=this.owner.solindex;if(this.instance_expr){var f=this.owner.pushTempValue();this.instance_expr.get(f);if(f.is_number()){b=f.data;e=this.object_type.instances;b%=e.length;0>b&&(b+=e.length);e=e[b].instance_vars[this.varindex];cr.is_string(e)?a.set_string(e):a.set_float(e);this.owner.popTempValue();return}this.owner.popTempValue()}b%=e.length;0>b&&(b+=e.length);e=e[b];b=0;this.object_type.is_family&&(b=e.type.family_var_map[this.object_type.family_index]);e=e.instance_vars[this.varindex+
b];cr.is_string(e)?a.set_string(e):a.set_float(e)};a.prototype.eval_int=function(a){a.type=cr.exptype.Integer;a.data=this.value};a.prototype.eval_float=function(a){a.type=cr.exptype.Float;a.data=this.value};a.prototype.eval_string=function(a){a.type=cr.exptype.String;a.data=this.value};a.prototype.eval_unaryminus=function(a){this.first.get(a);a.is_number()&&(a.data=-a.data)};a.prototype.eval_add=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&
(a.data+=b.data,b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_subtract=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data-=b.data,b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_multiply=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data*=b.data,b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_divide=
function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data/=b.data,a.make_float());this.owner.popTempValue()};a.prototype.eval_mod=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data%=b.data,b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_power=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&
(a.data=Math.pow(a.data,b.data),b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_and=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()?b.is_string()?a.set_string(a.data.toString()+b.data):a.data&&b.data?a.set_int(1):a.set_int(0):a.is_string()&&(b.is_string()?a.data+=b.data:a.data+=(Math.round(1E10*b.data)/1E10).toString());this.owner.popTempValue()};a.prototype.eval_or=function(a){this.first.get(a);var b=this.owner.pushTempValue();
this.second.get(b);a.is_number()&&b.is_number()&&(a.data||b.data?a.set_int(1):a.set_int(0));this.owner.popTempValue()};a.prototype.eval_conditional=function(a){this.first.get(a);a.data?this.second.get(a):this.third.get(a)};a.prototype.eval_equal=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data===b.data?1:0);this.owner.popTempValue()};a.prototype.eval_notequal=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data!==
b.data?1:0);this.owner.popTempValue()};a.prototype.eval_less=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data<b.data?1:0);this.owner.popTempValue()};a.prototype.eval_lessequal=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data<=b.data?1:0);this.owner.popTempValue()};a.prototype.eval_greater=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data>b.data?1:0);
this.owner.popTempValue()};a.prototype.eval_greaterequal=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data>=b.data?1:0);this.owner.popTempValue()};a.prototype.eval_eventvar_exp=function(a){var b=this.eventvar.getValue();cr.is_number(b)?a.set_float(b):a.set_string(b)};cr.expNode=a;b.prototype.is_int=function(){return this.type===cr.exptype.Integer};b.prototype.is_float=function(){return this.type===cr.exptype.Float};b.prototype.is_number=function(){return this.type===
cr.exptype.Integer||this.type===cr.exptype.Float};b.prototype.is_string=function(){return this.type===cr.exptype.String};b.prototype.make_int=function(){this.is_int()||(this.is_float()?this.data=Math.floor(this.data):this.is_string()&&(this.data=parseInt(this.data,10)),this.type=cr.exptype.Integer)};b.prototype.make_float=function(){this.is_float()||(this.is_string()&&(this.data=parseFloat(this.data)),this.type=cr.exptype.Float)};b.prototype.make_string=function(){this.is_string()||(this.data=this.data.toString(),
this.type=cr.exptype.String)};b.prototype.set_int=function(a){this.type=cr.exptype.Integer;this.data=Math.floor(a)};b.prototype.set_float=function(a){this.type=cr.exptype.Float;this.data=a};b.prototype.set_string=function(a){this.type=cr.exptype.String;this.data=a};b.prototype.set_any=function(a){cr.is_number(a)?(this.type=cr.exptype.Float,this.data=a):cr.is_string(a)?(this.type=cr.exptype.String,this.data=a.toString()):(this.type=cr.exptype.Integer,this.data=0)};cr.expvalue=b;cr.exptype={Integer:0,
Float:1,String:2}})();cr.system_object=function(a){this.runtime=a;this.waits=[]};
cr.system_object.prototype.saveToJSON=function(){var a={},b,c,d,e,f,g,h,l;a.waits=[];var k=a.waits,m;b=0;for(c=this.waits.length;b<c;b++){g=this.waits[b];m={t:g.time,ev:g.ev.sid,sm:[],sols:{}};g.ev.actions[g.actindex]&&(m.act=g.ev.actions[g.actindex].sid);d=0;for(e=g.solModifiers.length;d<e;d++)m.sm.push(g.solModifiers[d].sid);for(f in g.sols)if(g.sols.hasOwnProperty(f)){h=this.runtime.types_by_index[parseInt(f,10)];l={sa:g.sols[f].sa,insts:[]};d=0;for(e=g.sols[f].insts.length;d<e;d++)l.insts.push(g.sols[f].insts[d].uid);
m.sols[h.sid.toString()]=l}k.push(m)}return a};
cr.system_object.prototype.loadFromJSON=function(a){a=a.waits;var b,c,d,e,f,g,h,l,k,m,n;b=this.waits.length=0;for(c=a.length;b<c;b++)if(g=a[b],l=this.runtime.blocksBySid[g.ev.toString()]){k=-1;d=0;for(e=l.actions.length;d<e;d++)if(l.actions[d].sid===g.act){k=d;break}if(-1!==k){h={sols:{},solModifiers:[],deleteme:!1};h.time=g.t;h.ev=l;h.actindex=k;d=0;for(e=g.sm.length;d<e;d++)(l=this.runtime.getObjectTypeBySid(g.sm[d]))&&h.solModifiers.push(l);for(f in g.sols)if(g.sols.hasOwnProperty(f)&&(l=this.runtime.getObjectTypeBySid(parseInt(f,
10)))){k=g.sols[f];m={sa:k.sa,insts:[]};d=0;for(e=k.insts.length;d<e;d++)(n=this.runtime.getObjectByUID(k.insts[d]))&&m.insts.push(n);h.sols[l.index.toString()]=m}this.waits.push(h)}}};
(function(){function a(){}function b(a,b){var c=a.extra.c2_foreachordered_val,d=b.extra.c2_foreachordered_val;if(cr.is_number(c)&&cr.is_number(d))return c-d;c=""+c;d=""+d;return c<d?-1:c>d?1:0}function c(a,b){if(!k||a!==m||b!==n)k=RegExp(a,b),m=a,n=b;k.lastIndex=0;return k}function d(){}function e(){}function f(a,b,d){if(!(a===t&&b===v&&d===y)){var e=c(b,d);s=a.match(e);t=a;v=b;y=d}}var g=cr.system_object.prototype;a.prototype.EveryTick=function(){return!0};a.prototype.OnLayoutStart=function(){return!0};
a.prototype.OnLayoutEnd=function(){return!0};a.prototype.Compare=function(a,b,c){return cr.do_cmp(a,b,c)};a.prototype.CompareTime=function(a,b){var c=this.runtime.kahanTime.sum;if(0===a){var d=this.runtime.getCurrentCondition();return!d.extra.CompareTime_executed&&c>=b?d.extra.CompareTime_executed=!0:!1}return cr.do_cmp(c,a,b)};a.prototype.LayerVisible=function(a){return a?a.visible:!1};a.prototype.LayerCmpOpacity=function(a,b,c){return!a?!1:cr.do_cmp(100*a.opacity,b,c)};a.prototype.Repeat=function(a){var b=
this.runtime.getCurrentEventStack(),c=b.current_event,d=b.isModifierAfterCnds(),b=this.runtime.pushLoopStack();if(d)for(d=0;d<a&&!b.stopped;d++)this.runtime.pushCopySol(c.solModifiers),b.index=d,c.retrigger(),this.runtime.popSol(c.solModifiers);else for(d=0;d<a&&!b.stopped;d++)b.index=d,c.retrigger();this.runtime.popLoopStack();return!1};a.prototype.While=function(a){var b=this.runtime.getCurrentEventStack();a=b.current_event;var c=b.isModifierAfterCnds(),b=this.runtime.pushLoopStack();if(c)for(c=
0;!b.stopped;c++)this.runtime.pushCopySol(a.solModifiers),b.index=c,a.retrigger()||(b.stopped=!0),this.runtime.popSol(a.solModifiers);else for(c=0;!b.stopped;c++)b.index=c,a.retrigger()||(b.stopped=!0);this.runtime.popLoopStack();return!1};a.prototype.For=function(a,b,c){var d=this.runtime.getCurrentEventStack(),e=d.current_event,d=d.isModifierAfterCnds();a=this.runtime.pushLoopStack(a);if(c<b)if(d)for(;b>=c&&!a.stopped;--b)this.runtime.pushCopySol(e.solModifiers),a.index=b,e.retrigger(),this.runtime.popSol(e.solModifiers);
else for(;b>=c&&!a.stopped;--b)a.index=b,e.retrigger();else if(d)for(;b<=c&&!a.stopped;++b)this.runtime.pushCopySol(e.solModifiers),a.index=b,e.retrigger(),this.runtime.popSol(e.solModifiers);else for(;b<=c&&!a.stopped;++b)a.index=b,e.retrigger();this.runtime.popLoopStack();return!1};var h=[],l=-1;a.prototype.ForEach=function(a){var b=a.getCurrentSol();l++;h.length===l&&h.push([]);var c=h[l];cr.shallowAssignArray(c,b.getObjects());var d=this.runtime.getCurrentEventStack(),e=d.current_event,k=d.isModifierAfterCnds(),
d=this.runtime.pushLoopStack(),f,g,m,p,n,r,q=a.is_contained;if(k){k=0;for(f=c.length;k<f&&!d.stopped;k++){this.runtime.pushCopySol(e.solModifiers);p=c[k];b=a.getCurrentSol();b.select_all=!1;b.instances.length=1;b.instances[0]=p;if(q){g=0;for(m=p.siblings.length;g<m;g++)n=p.siblings[g],r=n.type.getCurrentSol(),r.select_all=!1,r.instances.length=1,r.instances[0]=n}d.index=k;e.retrigger();this.runtime.popSol(e.solModifiers)}}else{b.select_all=!1;b.instances.length=1;k=0;for(f=c.length;k<f&&!d.stopped;k++){p=
c[k];b.instances[0]=p;if(q){g=0;for(m=p.siblings.length;g<m;g++)n=p.siblings[g],r=n.type.getCurrentSol(),r.select_all=!1,r.instances.length=1,r.instances[0]=n}d.index=k;e.retrigger()}}c.length=0;this.runtime.popLoopStack();l--;return!1};a.prototype.ForEachOrdered=function(a,c,d){c=a.getCurrentSol();l++;h.length===l&&h.push([]);var e=h[l];cr.shallowAssignArray(e,c.getObjects());var k=this.runtime.getCurrentEventStack(),f=k.current_event,g=this.runtime.getCurrentCondition(),m=k.isModifierAfterCnds(),
k=this.runtime.pushLoopStack(),p,n,r,q,s;p=0;for(n=e.length;p<n;p++)e[p].extra.c2_foreachordered_val=g.parameters[1].get(p);e.sort(b);1===d&&e.reverse();d=a.is_contained;if(m){p=0;for(n=e.length;p<n&&!k.stopped;p++){this.runtime.pushCopySol(f.solModifiers);r=e[p];c=a.getCurrentSol();c.select_all=!1;c.instances.length=1;c.instances[0]=r;if(d){g=0;for(m=r.siblings.length;g<m;g++)q=r.siblings[g],s=q.type.getCurrentSol(),s.select_all=!1,s.instances.length=1,s.instances[0]=q}k.index=p;f.retrigger();this.runtime.popSol(f.solModifiers)}}else{c.select_all=
!1;c.instances.length=1;p=0;for(n=e.length;p<n&&!k.stopped;p++){r=e[p];c.instances[0]=r;if(d){g=0;for(m=r.siblings.length;g<m;g++)q=r.siblings[g],s=q.type.getCurrentSol(),s.select_all=!1,s.instances.length=1,s.instances[0]=q}k.index=p;f.retrigger()}}e.length=0;this.runtime.popLoopStack();l--;return!1};a.prototype.PickByComparison=function(a,b,c,d){var e,k,f,g;if(a){l++;h.length===l&&h.push([]);var m=h[l],p=a.getCurrentSol();cr.shallowAssignArray(m,p.getObjects());p.select_all&&(p.else_instances.length=
0);var n=this.runtime.getCurrentCondition();f=e=0;for(k=m.length;e<k;e++)g=m[e],m[f]=g,b=n.parameters[1].get(e),d=n.parameters[3].get(e),cr.do_cmp(b,c,d)?f++:p.else_instances.push(g);m.length=f;p.select_all=!1;cr.shallowAssignArray(p.instances,m);m.length=0;l--;a.applySolToContainer();return!!p.instances.length}};a.prototype.PickByEvaluate=function(a,b){var c,d,e,k;if(a){l++;h.length===l&&h.push([]);var f=h[l],g=a.getCurrentSol();cr.shallowAssignArray(f,g.getObjects());g.select_all&&(g.else_instances.length=
0);var m=this.runtime.getCurrentCondition();e=c=0;for(d=f.length;c<d;c++)k=f[c],f[e]=k,(b=m.parameters[1].get(c))?e++:g.else_instances.push(k);f.length=e;g.select_all=!1;cr.shallowAssignArray(g.instances,f);f.length=0;l--;a.applySolToContainer();return!!g.instances.length}};a.prototype.TriggerOnce=function(){var a=this.runtime.getCurrentCondition().extra;"undefined"===typeof a.TriggerOnce_lastTick&&(a.TriggerOnce_lastTick=-1);var b=a.TriggerOnce_lastTick,c=this.runtime.tickcount;a.TriggerOnce_lastTick=
c;return this.runtime.layout_first_tick||b!==c-1};a.prototype.Every=function(a){var b=this.runtime.getCurrentCondition(),c=b.extra.Every_lastTime||0,d=this.runtime.kahanTime.sum;"undefined"===typeof b.extra.Every_seconds&&(b.extra.Every_seconds=a);var e=b.extra.Every_seconds;return d>=c+e?(b.extra.Every_lastTime=c+e,d>=b.extra.Every_lastTime+e&&(b.extra.Every_lastTime=d),b.extra.Every_seconds=a,!0):!1};a.prototype.PickNth=function(a,b){if(!a)return!1;var c=a.getCurrentSol(),d=c.getObjects();b=cr.floor(b);
if(0>b||b>=d.length)return!1;c.pick_one(d[b]);a.applySolToContainer();return!0};a.prototype.PickRandom=function(a){if(!a)return!1;var b=a.getCurrentSol(),c=b.getObjects(),d=cr.floor(Math.random()*c.length);if(d>=c.length)return!1;b.pick_one(c[d]);a.applySolToContainer();return!0};a.prototype.CompareVar=function(a,b,c){return cr.do_cmp(a.getValue(),b,c)};a.prototype.IsGroupActive=function(a){return this.runtime.activeGroups[a.toLowerCase()]};a.prototype.IsPreview=function(){return"undefined"!==typeof cr_is_preview};
a.prototype.PickAll=function(a){if(!a||!a.instances.length)return!1;a.getCurrentSol().select_all=!0;a.applySolToContainer();return!0};a.prototype.IsMobile=function(){return this.runtime.isMobile};a.prototype.CompareBetween=function(a,b,c){return a>=b&&a<=c};a.prototype.Else=function(){var a=this.runtime.getCurrentEventStack();return a.else_branch_ran?!1:!a.last_event_true};a.prototype.OnLoadFinished=function(){return!0};a.prototype.OnCanvasSnapshot=function(){return!0};a.prototype.EffectsSupported=
function(){return!!this.runtime.glwrap};a.prototype.OnSaveComplete=function(){return!0};a.prototype.OnLoadComplete=function(){return!0};a.prototype.OnLoadFailed=function(){return!0};a.prototype.ObjectUIDExists=function(a){return!!this.runtime.getObjectByUID(a)};a.prototype.IsOnPlatform=function(a){var b=this.runtime;switch(a){case 0:return!b.isDomFree&&!b.isNodeWebkit&&!b.isPhoneGap&&!b.isWindows8App&&!b.isWindowsPhone8&&!b.isBlackberry10;case 1:return b.isiOS;case 2:return b.isAndroid;case 3:return b.isWindows8App;
case 4:return b.isWindowsPhone8;case 5:return b.isBlackberry10;case 6:return b.isTizen;case 7:return b.isNodeWebkit;case 8:return b.isCocoonJs;case 9:return b.isPhoneGap;case 10:return b.isArcade;case 11:return b.isNodeWebkit;default:return!1}};var k=null,m="",n="";a.prototype.RegexTest=function(a,b,d){return c(b,d).test(a)};var q=[];a.prototype.PickOverlappingPoint=function(a,b,c){if(!a)return!1;var d=a.getCurrentSol(),e=d.getObjects(),k=this.runtime.getCurrentEventStack().current_event.orblock,
h=this.runtime.getCurrentCondition(),f,g;d.select_all?(cr.shallowAssignArray(q,e),d.else_instances.length=0,d.select_all=!1,d.instances.length=0):k?(cr.shallowAssignArray(q,d.else_instances),d.else_instances.length=0):(cr.shallowAssignArray(q,e),d.instances.length=0);e=0;for(k=q.length;e<k;++e)f=q[e],(g=cr.xor(f.contains_pt(b,c),h.inverted))?d.instances.push(f):d.else_instances.push(f);a.applySolToContainer();return cr.xor(!!d.instances.length,h.inverted)};g.cnds=new a;d.prototype.GoToLayout=function(a){!this.runtime.isloading&&
!this.runtime.changelayout&&(this.runtime.changelayout=a)};d.prototype.CreateObject=function(a,b,c,d){if(b&&a&&(b=this.runtime.createInstance(a,b,c,d))){this.runtime.isInOnDestroy++;var e;this.runtime.trigger(Object.getPrototypeOf(a.plugin).cnds.OnCreated,b);if(b.is_contained){c=0;for(d=b.siblings.length;c<d;c++)e=b.siblings[c],this.runtime.trigger(Object.getPrototypeOf(e.type.plugin).cnds.OnCreated,e)}this.runtime.isInOnDestroy--;a=a.getCurrentSol();a.select_all=!1;a.instances.length=1;a.instances[0]=
b;if(b.is_contained){c=0;for(d=b.siblings.length;c<d;c++)e=b.siblings[c],a=e.type.getCurrentSol(),a.select_all=!1,a.instances.length=1,a.instances[0]=e}}};d.prototype.SetLayerVisible=function(a,b){a&&a.visible!==b&&(a.visible=b,this.runtime.redraw=!0)};d.prototype.SetLayerOpacity=function(a,b){a&&(b=cr.clamp(b/100,0,1),a.opacity!==b&&(a.opacity=b,this.runtime.redraw=!0))};d.prototype.SetLayerScaleRate=function(a,b){a&&a.zoomRate!==b&&(a.zoomRate=b,this.runtime.redraw=!0)};d.prototype.SetLayoutScale=
function(a){this.runtime.running_layout&&this.runtime.running_layout.scale!==a&&(this.runtime.running_layout.scale=a,this.runtime.running_layout.boundScrolling(),this.runtime.redraw=!0)};d.prototype.ScrollX=function(a){this.runtime.running_layout.scrollToX(a)};d.prototype.ScrollY=function(a){this.runtime.running_layout.scrollToY(a)};d.prototype.Scroll=function(a,b){this.runtime.running_layout.scrollToX(a);this.runtime.running_layout.scrollToY(b)};d.prototype.ScrollToObject=function(a){if(a=a.getFirstPicked())this.runtime.running_layout.scrollToX(a.x),
this.runtime.running_layout.scrollToY(a.y)};d.prototype.SetVar=function(a,b){0===a.vartype?cr.is_number(b)?a.setValue(b):a.setValue(parseFloat(b)):1===a.vartype&&a.setValue(b.toString())};d.prototype.AddVar=function(a,b){0===a.vartype?cr.is_number(b)?a.setValue(a.getValue()+b):a.setValue(a.getValue()+parseFloat(b)):1===a.vartype&&a.setValue(a.getValue()+b.toString())};d.prototype.SubVar=function(a,b){0===a.vartype&&(cr.is_number(b)?a.setValue(a.getValue()-b):a.setValue(a.getValue()-parseFloat(b)))};
d.prototype.SetGroupActive=function(a,b){var c=this.runtime.activeGroups,d=a.toLowerCase();switch(b){case 0:c[d]=!1;break;case 1:c[d]=!0;break;case 2:c[d]=!c[d]}};d.prototype.SetTimescale=function(a){0>a&&(a=0);this.runtime.timescale=a};d.prototype.SetObjectTimescale=function(a,b){var c=b;0>c&&(c=0);if(a){var d=a.getCurrentSol().getObjects(),e,k;e=0;for(k=d.length;e<k;e++)d[e].my_timescale=c}};d.prototype.RestoreObjectTimescale=function(a){if(!a)return!1;a=a.getCurrentSol().getObjects();var b,c;b=
0;for(c=a.length;b<c;b++)a[b].my_timescale=-1};var p=[],r=[];d.prototype.Wait=function(a){if(!(0>a)){var b,c,d,e=this.runtime.getCurrentEventStack(),k;k=p.length?p.pop():{sols:{},solModifiers:[]};k.deleteme=!1;k.time=this.runtime.kahanTime.sum+a;k.ev=e.current_event;k.actindex=e.actindex+1;a=0;for(b=this.runtime.types_by_index.length;a<b;a++)d=this.runtime.types_by_index[a],c=d.getCurrentSol(),c.select_all&&-1===e.current_event.solModifiers.indexOf(d)||(k.solModifiers.push(d),d=void 0,d=r.length?
r.pop():{insts:[]},d.sa=!1,d.sa=c.select_all,cr.shallowAssignArray(d.insts,c.instances),k.sols[a.toString()]=d);this.waits.push(k);return!0}};d.prototype.SetLayerScale=function(a,b){a&&a.scale!==b&&(a.scale=b,this.runtime.redraw=!0)};d.prototype.ResetGlobals=function(){var a,b,c;a=0;for(b=this.runtime.all_global_vars.length;a<b;a++)c=this.runtime.all_global_vars[a],c.data=c.initial};d.prototype.SetLayoutAngle=function(a){a=cr.to_radians(a);a=cr.clamp_angle(a);this.runtime.running_layout&&this.runtime.running_layout.angle!==
a&&(this.runtime.running_layout.angle=a,this.runtime.redraw=!0)};d.prototype.SetLayerAngle=function(a,b){a&&(b=cr.to_radians(b),b=cr.clamp_angle(b),a.angle!==b&&(a.angle=b,this.runtime.redraw=!0))};d.prototype.SetLayerParallax=function(a,b,c){a&&!(a.parallaxX===b/100&&a.parallaxY===c/100)&&(a.parallaxX=b/100,a.parallaxY=c/100,this.runtime.redraw=!0)};d.prototype.SetLayerBackground=function(a,b){if(a){var c=cr.GetRValue(b),d=cr.GetGValue(b),e=cr.GetBValue(b);a.background_color[0]===c&&a.background_color[1]===
d&&a.background_color[2]===e||(a.background_color[0]=c,a.background_color[1]=d,a.background_color[2]=e,this.runtime.redraw=!0)}};d.prototype.SetLayerTransparent=function(a,b){a&&!!b!==!!a.transparent&&(a.transparent=!!b,this.runtime.redraw=!0)};d.prototype.StopLoop=function(){0>this.runtime.loop_stack_index||(this.runtime.getCurrentLoop().stopped=!0)};d.prototype.GoToLayoutByName=function(a){if(!this.runtime.isloading&&!this.runtime.changelayout)for(var b in this.runtime.layouts)if(this.runtime.layouts.hasOwnProperty(b)&&
cr.equals_nocase(b,a)){this.runtime.changelayout=this.runtime.layouts[b];break}};d.prototype.RestartLayout=function(a){if(!this.runtime.isloading&&!this.runtime.changelayout&&this.runtime.running_layout){this.runtime.changelayout=this.runtime.running_layout;var b,c;a=0;for(b=this.runtime.allGroups.length;a<b;a++)c=this.runtime.allGroups[a],this.runtime.activeGroups[c.group_name.toLowerCase()]=c.initially_activated}};d.prototype.SnapshotCanvas=function(a,b){this.runtime.snapshotCanvas=[0===a?"image/png":
"image/jpeg",b/100];this.runtime.redraw=!0};d.prototype.SetCanvasSize=function(a,b){0>=a||0>=b||this.runtime.setSize(a,b)};d.prototype.SetLayoutEffectEnabled=function(a,b){if(this.runtime.running_layout&&this.runtime.glwrap){var c=this.runtime.running_layout.getEffectByName(b);if(c){var d=1===a;c.active!=d&&(c.active=d,this.runtime.running_layout.updateActiveEffects(),this.runtime.redraw=!0)}}};d.prototype.SetLayerEffectEnabled=function(a,b,c){if(a&&this.runtime.glwrap&&(c=a.getEffectByName(c)))b=
1===b,c.active!=b&&(c.active=b,a.updateActiveEffects(),this.runtime.redraw=!0)};d.prototype.SetLayoutEffectParam=function(a,b,c){if(this.runtime.running_layout&&this.runtime.glwrap&&(a=this.runtime.running_layout.getEffectByName(a))){var d=this.runtime.running_layout.effect_params[a.index];b=Math.floor(b);0>b||b>=d.length||(1===this.runtime.glwrap.getProgramParameterType(a.shaderindex,b)&&(c/=100),d[b]!==c&&(d[b]=c,a.active&&(this.runtime.redraw=!0)))}};d.prototype.SetLayerEffectParam=function(a,
b,c,d){if(a&&this.runtime.glwrap&&(b=a.getEffectByName(b)))a=a.effect_params[b.index],c=Math.floor(c),0>c||c>=a.length||(1===this.runtime.glwrap.getProgramParameterType(b.shaderindex,c)&&(d/=100),a[c]!==d&&(a[c]=d,b.active&&(this.runtime.redraw=!0)))};d.prototype.SaveState=function(a){this.runtime.saveToSlot=a};d.prototype.LoadState=function(a){this.runtime.loadFromSlot=a};d.prototype.LoadStateJSON=function(a){this.runtime.loadFromJson=a};g.acts=new d;e.prototype["int"]=function(a,b){cr.is_string(b)?
(a.set_int(parseInt(b,10)),isNaN(a.data)&&(a.data=0)):a.set_int(b)};e.prototype["float"]=function(a,b){cr.is_string(b)?(a.set_float(parseFloat(b)),isNaN(a.data)&&(a.data=0)):a.set_float(b)};e.prototype.str=function(a,b){cr.is_string(b)?a.set_string(b):a.set_string(b.toString())};e.prototype.len=function(a,b){a.set_int(b.length||0)};e.prototype.random=function(a,b,c){void 0===c?a.set_float(Math.random()*b):a.set_float(Math.random()*(c-b)+b)};e.prototype.sqrt=function(a,b){a.set_float(Math.sqrt(b))};
e.prototype.abs=function(a,b){a.set_float(Math.abs(b))};e.prototype.round=function(a,b){a.set_int(Math.round(b))};e.prototype.floor=function(a,b){a.set_int(Math.floor(b))};e.prototype.ceil=function(a,b){a.set_int(Math.ceil(b))};e.prototype.sin=function(a,b){a.set_float(Math.sin(cr.to_radians(b)))};e.prototype.cos=function(a,b){a.set_float(Math.cos(cr.to_radians(b)))};e.prototype.tan=function(a,b){a.set_float(Math.tan(cr.to_radians(b)))};e.prototype.asin=function(a,b){a.set_float(cr.to_degrees(Math.asin(b)))};
e.prototype.acos=function(a,b){a.set_float(cr.to_degrees(Math.acos(b)))};e.prototype.atan=function(a,b){a.set_float(cr.to_degrees(Math.atan(b)))};e.prototype.exp=function(a,b){a.set_float(Math.exp(b))};e.prototype.ln=function(a,b){a.set_float(Math.log(b))};e.prototype.log10=function(a,b){a.set_float(Math.log(b)/Math.LN10)};e.prototype.max=function(a){var b=arguments[1],c,d;c=2;for(d=arguments.length;c<d;c++)b<arguments[c]&&(b=arguments[c]);a.set_float(b)};e.prototype.min=function(a){var b=arguments[1],
c,d;c=2;for(d=arguments.length;c<d;c++)b>arguments[c]&&(b=arguments[c]);a.set_float(b)};e.prototype.dt=function(a){a.set_float(this.runtime.dt)};e.prototype.timescale=function(a){a.set_float(this.runtime.timescale)};e.prototype.wallclocktime=function(a){a.set_float((Date.now()-this.runtime.start_time)/1E3)};e.prototype.time=function(a){a.set_float(this.runtime.kahanTime.sum)};e.prototype.tickcount=function(a){a.set_int(this.runtime.tickcount)};e.prototype.objectcount=function(a){a.set_int(this.runtime.objectcount)};
e.prototype.fps=function(a){a.set_int(this.runtime.fps)};e.prototype.loopindex=function(a,b){var c,d,e;if(this.runtime.loop_stack.length)if(b){d=0;for(e=this.runtime.loop_stack.length;d<e;d++)if(c=this.runtime.loop_stack[d],c.name===b){a.set_int(c.index);return}a.set_int(0)}else c=this.runtime.getCurrentLoop(),a.set_int(c?c.index:-1);else a.set_int(0)};e.prototype.distance=function(a,b,c,d,e){a.set_float(cr.distanceTo(b,c,d,e))};e.prototype.angle=function(a,b,c,d,e){a.set_float(cr.to_degrees(cr.angleTo(b,
c,d,e)))};e.prototype.scrollx=function(a){a.set_float(this.runtime.running_layout.scrollX)};e.prototype.scrolly=function(a){a.set_float(this.runtime.running_layout.scrollY)};e.prototype.newline=function(a){a.set_string("\n")};e.prototype.lerp=function(a,b,c,d){a.set_float(cr.lerp(b,c,d))};e.prototype.windowwidth=function(a){a.set_int(this.runtime.width)};e.prototype.windowheight=function(a){a.set_int(this.runtime.height)};e.prototype.uppercase=function(a,b){a.set_string(cr.is_string(b)?b.toUpperCase():
"")};e.prototype.lowercase=function(a,b){a.set_string(cr.is_string(b)?b.toLowerCase():"")};e.prototype.clamp=function(a,b,c,d){b<c?a.set_float(c):b>d?a.set_float(d):a.set_float(b)};e.prototype.layerscale=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(c.scale):a.set_float(0)};e.prototype.layeropacity=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(100*c.opacity):a.set_float(0)};e.prototype.layerscalerate=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(c.zoomRate):
a.set_float(0)};e.prototype.layerparallaxx=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(100*c.parallaxX):a.set_float(0)};e.prototype.layerparallaxy=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(100*c.parallaxY):a.set_float(0)};e.prototype.layoutscale=function(a){this.runtime.running_layout?a.set_float(this.runtime.running_layout.scale):a.set_float(0)};e.prototype.layoutangle=function(a){a.set_float(cr.to_degrees(this.runtime.running_layout.angle))};e.prototype.layerangle=
function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(cr.to_degrees(c.angle)):a.set_float(0)};e.prototype.layoutwidth=function(a){a.set_int(this.runtime.running_layout.width)};e.prototype.layoutheight=function(a){a.set_int(this.runtime.running_layout.height)};e.prototype.find=function(a,b,c){cr.is_string(b)&&cr.is_string(c)?a.set_int(b.search(RegExp(cr.regexp_escape(c),"i"))):a.set_int(-1)};e.prototype.left=function(a,b,c){a.set_string(cr.is_string(b)?b.substr(0,c):"")};e.prototype.right=function(a,
b,c){a.set_string(cr.is_string(b)?b.substr(b.length-c):"")};e.prototype.mid=function(a,b,c,d){a.set_string(cr.is_string(b)?b.substr(c,d):"")};e.prototype.tokenat=function(a,b,c,d){cr.is_string(b)&&cr.is_string(d)?(b=b.split(d),c=cr.floor(c),0>c||c>=b.length?a.set_string(""):a.set_string(b[c])):a.set_string("")};e.prototype.tokencount=function(a,b,c){cr.is_string(b)&&b.length?a.set_int(b.split(c).length):a.set_int(0)};e.prototype.replace=function(a,b,c,d){cr.is_string(b)&&cr.is_string(c)&&cr.is_string(d)?
a.set_string(b.replace(RegExp(cr.regexp_escape(c),"gi"),d)):a.set_string(cr.is_string(b)?b:"")};e.prototype.trim=function(a,b){a.set_string(cr.is_string(b)?b.trim():"")};e.prototype.pi=function(a){a.set_float(cr.PI)};e.prototype.layoutname=function(a){this.runtime.running_layout?a.set_string(this.runtime.running_layout.name):a.set_string("")};e.prototype.renderer=function(a){a.set_string(this.runtime.gl?"webgl":"canvas2d")};e.prototype.anglediff=function(a,b,c){a.set_float(cr.to_degrees(cr.angleDiff(cr.to_radians(b),
cr.to_radians(c))))};e.prototype.choose=function(a){var b=cr.floor(Math.random()*(arguments.length-1));a.set_any(arguments[b+1])};e.prototype.rgb=function(a,b,c,d){a.set_int(cr.RGB(b,c,d))};e.prototype.projectversion=function(a){a.set_string(this.runtime.versionstr)};e.prototype.anglelerp=function(a,b,c,d){b=cr.to_radians(b);c=cr.to_radians(c);var e=cr.angleDiff(b,c);cr.angleClockwise(c,b)?a.set_float(cr.to_clamped_degrees(b+e*d)):a.set_float(cr.to_clamped_degrees(b-e*d))};e.prototype.anglerotate=
function(a,b,c,d){b=cr.to_radians(b);c=cr.to_radians(c);d=cr.to_radians(d);a.set_float(cr.to_clamped_degrees(cr.angleRotate(b,c,d)))};e.prototype.zeropad=function(a,b,c){var d=0>b?"-":"";0>b&&(b=-b);c-=b.toString().length;for(var e=0;e<c;e++)d+="0";a.set_string(d+b.toString())};e.prototype.cpuutilisation=function(a){a.set_float(this.runtime.cpuutilisation/1E3)};e.prototype.viewportleft=function(a,b){var c=this.runtime.getLayer(b);a.set_float(c?c.viewLeft:0)};e.prototype.viewporttop=function(a,b){var c=
this.runtime.getLayer(b);a.set_float(c?c.viewTop:0)};e.prototype.viewportright=function(a,b){var c=this.runtime.getLayer(b);a.set_float(c?c.viewRight:0)};e.prototype.viewportbottom=function(a,b){var c=this.runtime.getLayer(b);a.set_float(c?c.viewBottom:0)};e.prototype.loadingprogress=function(a){a.set_float(this.runtime.loadingprogress)};e.prototype.unlerp=function(a,b,c,d){a.set_float((d-b)/(c-b))};e.prototype.canvassnapshot=function(a){a.set_string(this.runtime.snapshotData)};e.prototype.urlencode=
function(a,b){a.set_string(encodeURIComponent(b))};e.prototype.urldecode=function(a,b){a.set_string(decodeURIComponent(b))};e.prototype.canvastolayerx=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.canvasToLayer(c,d,!0):0)};e.prototype.canvastolayery=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.canvasToLayer(c,d,!1):0)};e.prototype.layertocanvasx=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.layerToCanvas(c,d,!0):0)};e.prototype.layertocanvasy=function(a,
b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.layerToCanvas(c,d,!1):0)};e.prototype.savestatejson=function(a){a.set_string(this.runtime.lastSaveJson)};e.prototype.imagememoryusage=function(a){this.runtime.glwrap?a.set_float(Math.round(100*this.runtime.glwrap.estimateVRAM()/1048576)/100):a.set_float(0)};e.prototype.regexsearch=function(a,b,d,e){d=c(d,e);a.set_int(b?b.search(d):-1)};e.prototype.regexreplace=function(a,b,d,e,k){d=c(d,e);a.set_string(b?b.replace(d,k):"")};var s=[],t="",v="",y="";
e.prototype.regexmatchcount=function(a,b,d,e){c(d,e);f(b,d,e);a.set_int(s?s.length:0)};e.prototype.regexmatchat=function(a,b,d,e,k){k=Math.floor(k);c(d,e);f(b,d,e);!s||0>k||k>=s.length?a.set_string(""):a.set_string(s[k])};e.prototype.infinity=function(a){a.set_float(Infinity)};g.exps=new e;g.runWaits=function(){var a,b,c,d,e,k,h=this.runtime.getCurrentEventStack();a=0;for(c=this.waits.length;a<c;a++)if(d=this.waits[a],!(d.time>this.runtime.kahanTime.sum)){h.current_event=d.ev;h.actindex=d.actindex;
h.cndindex=0;for(b in d.sols)d.sols.hasOwnProperty(b)&&(e=this.runtime.types_by_index[parseInt(b,10)].getCurrentSol(),k=d.sols[b],e.select_all=k.sa,cr.shallowAssignArray(e.instances,k.insts),e=k,e.insts.length=0,r.push(e));d.ev.resume_actions_and_subevents();this.runtime.clearSol(d.solModifiers);d.deleteme=!0}b=a=0;for(c=this.waits.length;a<c;a++)d=this.waits[a],this.waits[b]=d,d.deleteme?(cr.wipe(d.sols),d.solModifiers.length=0,p.push(d)):b++;this.waits.length=b}})();
cr.add_common_aces=function(a){var b=a[0].prototype,c=a[1],d=a[3],e=a[4],f=a[5],g=a[6],h=a[7];a=a[8];b.cnds||(b.cnds={});b.acts||(b.acts={});b.exps||(b.exps={});var l=b.cnds,k=b.acts,b=b.exps;d&&(l.CompareX=function(a,b){return cr.do_cmp(this.x,a,b)},l.CompareY=function(a,b){return cr.do_cmp(this.y,a,b)},l.IsOnScreen=function(){var a=this.layer;this.update_bbox();var b=this.bbox;return!(b.right<a.viewLeft||b.bottom<a.viewTop||b.left>a.viewRight||b.top>a.viewBottom)},l.IsOutsideLayout=function(){this.update_bbox();
var a=this.bbox,b=this.runtime.running_layout;return 0>a.right||0>a.bottom||a.left>b.width||a.top>b.height},l.PickDistance=function(a,b,c){var d=this.getCurrentSol(),e=d.getObjects();if(!e.length)return!1;var k=e[0],h=k,f=cr.distanceTo(k.x,k.y,b,c),g,l,C;g=1;for(l=e.length;g<l;g++)if(k=e[g],C=cr.distanceTo(k.x,k.y,b,c),0===a&&C<f||1===a&&C>f)f=C,h=k;d.pick_one(h);return!0},k.SetX=function(a){this.x!==a&&(this.x=a,this.set_bbox_changed())},k.SetY=function(a){this.y!==a&&(this.y=a,this.set_bbox_changed())},
k.SetPos=function(a,b){if(this.x!==a||this.y!==b)this.x=a,this.y=b,this.set_bbox_changed()},k.SetPosToObject=function(a,b){var c=a.getPairedInstance(this);if(c){var d;c.getImagePoint?(d=c.getImagePoint(b,!0),c=c.getImagePoint(b,!1)):(d=c.x,c=c.y);if(this.x!==d||this.y!==c)this.x=d,this.y=c,this.set_bbox_changed()}},k.MoveForward=function(a){0!==a&&(this.x+=Math.cos(this.angle)*a,this.y+=Math.sin(this.angle)*a,this.set_bbox_changed())},k.MoveAtAngle=function(a,b){0!==b&&(this.x+=Math.cos(cr.to_radians(a))*
b,this.y+=Math.sin(cr.to_radians(a))*b,this.set_bbox_changed())},b.X=function(a){a.set_float(this.x)},b.Y=function(a){a.set_float(this.y)},b.dt=function(a){a.set_float(this.runtime.getDt(this))});e&&(l.CompareWidth=function(a,b){return cr.do_cmp(this.width,a,b)},l.CompareHeight=function(a,b){return cr.do_cmp(this.height,a,b)},k.SetWidth=function(a){this.width!==a&&(this.width=a,this.set_bbox_changed())},k.SetHeight=function(a){this.height!==a&&(this.height=a,this.set_bbox_changed())},k.SetSize=function(a,
b){if(this.width!==a||this.height!==b)this.width=a,this.height=b,this.set_bbox_changed()},b.Width=function(a){a.set_float(this.width)},b.Height=function(a){a.set_float(this.height)},b.BBoxLeft=function(a){this.update_bbox();a.set_float(this.bbox.left)},b.BBoxTop=function(a){this.update_bbox();a.set_float(this.bbox.top)},b.BBoxRight=function(a){this.update_bbox();a.set_float(this.bbox.right)},b.BBoxBottom=function(a){this.update_bbox();a.set_float(this.bbox.bottom)});f&&(l.AngleWithin=function(a,b){return cr.angleDiff(this.angle,
cr.to_radians(b))<=cr.to_radians(a)},l.IsClockwiseFrom=function(a){return cr.angleClockwise(this.angle,cr.to_radians(a))},l.IsBetweenAngles=function(a,b){var c=cr.to_clamped_radians(a),d=cr.to_clamped_radians(b),e=cr.clamp_angle(this.angle);return cr.angleClockwise(d,c)?cr.angleClockwise(e,c)&&!cr.angleClockwise(e,d):!(!cr.angleClockwise(e,c)&&cr.angleClockwise(e,d))},k.SetAngle=function(a){a=cr.to_radians(cr.clamp_angle_degrees(a));!isNaN(a)&&this.angle!==a&&(this.angle=a,this.set_bbox_changed())},
k.RotateClockwise=function(a){0!==a&&!isNaN(a)&&(this.angle+=cr.to_radians(a),this.angle=cr.clamp_angle(this.angle),this.set_bbox_changed())},k.RotateCounterclockwise=function(a){0!==a&&!isNaN(a)&&(this.angle-=cr.to_radians(a),this.angle=cr.clamp_angle(this.angle),this.set_bbox_changed())},k.RotateTowardAngle=function(a,b){var c=cr.angleRotate(this.angle,cr.to_radians(b),cr.to_radians(a));!isNaN(c)&&this.angle!==c&&(this.angle=c,this.set_bbox_changed())},k.RotateTowardPosition=function(a,b,c){b=Math.atan2(c-
this.y,b-this.x);a=cr.angleRotate(this.angle,b,cr.to_radians(a));!isNaN(a)&&this.angle!==a&&(this.angle=a,this.set_bbox_changed())},k.SetTowardPosition=function(a,b){var c=Math.atan2(b-this.y,a-this.x);!isNaN(c)&&this.angle!==c&&(this.angle=c,this.set_bbox_changed())},b.Angle=function(a){a.set_float(cr.to_clamped_degrees(this.angle))});c||(l.CompareInstanceVar=function(a,b,c){return cr.do_cmp(this.instance_vars[a],b,c)},l.IsBoolInstanceVarSet=function(a){return this.instance_vars[a]},l.PickInstVarHiLow=
function(a,b){var c=this.getCurrentSol(),d=c.getObjects();if(!d.length)return!1;var e=d[0],k=e,h=e.instance_vars[b],f,g,l;f=1;for(g=d.length;f<g;f++)if(e=d[f],l=e.instance_vars[b],0===a&&l<h||1===a&&l>h)h=l,k=e;c.pick_one(k);return!0},l.PickByUID=function(a){var b,c,d,e,k;if(this.runtime.getCurrentCondition().inverted){k=this.getCurrentSol();if(k.select_all){k.select_all=!1;k.instances.length=0;k.else_instances.length=0;d=this.instances;b=0;for(c=d.length;b<c;b++)e=d[b],e.uid===a?k.else_instances.push(e):
k.instances.push(e)}else{d=b=0;for(c=k.instances.length;b<c;b++)e=k.instances[b],k.instances[d]=e,e.uid===a?k.else_instances.push(e):d++;k.instances.length=d}return!!k.instances.length}e=this.runtime.getObjectByUID(a);if(!e)return!1;k=this.getCurrentSol();if(!k.select_all&&-1===k.instances.indexOf(e))return!1;if(this.is_family){a=e.type.families;b=0;for(c=a.length;b<c;b++)if(a[b]===this)return k.pick_one(e),!0}else if(e.type===this)return k.pick_one(e),!0;return!1},l.OnCreated=function(){return!0},
l.OnDestroyed=function(){return!0},k.SetInstanceVar=function(a,b){var c=this.instance_vars;cr.is_number(c[a])?cr.is_number(b)?c[a]=b:c[a]=parseFloat(b):cr.is_string(c[a])&&(cr.is_string(b)?c[a]=b:c[a]=b.toString())},k.AddInstanceVar=function(a,b){var c=this.instance_vars;cr.is_number(c[a])?cr.is_number(b)?c[a]+=b:c[a]+=parseFloat(b):cr.is_string(c[a])&&(cr.is_string(b)?c[a]+=b:c[a]+=b.toString())},k.SubInstanceVar=function(a,b){var c=this.instance_vars;cr.is_number(c[a])&&(cr.is_number(b)?c[a]-=b:
c[a]-=parseFloat(b))},k.SetBoolInstanceVar=function(a,b){this.instance_vars[a]=b?1:0},k.ToggleBoolInstanceVar=function(a){this.instance_vars[a]=1-this.instance_vars[a]},k.Destroy=function(){this.runtime.DestroyInstance(this)},b.Count=function(a){var b=a.object_class.instances.length,c,d,e;c=0;for(d=this.runtime.createRow.length;c<d;c++)e=this.runtime.createRow[c],a.object_class.is_family?0<=e.type.families.indexOf(a.object_class)&&b++:e.type===a.object_class&&b++;a.set_int(b)},b.PickedCount=function(a){a.set_int(a.object_class.getCurrentSol().getObjects().length)},
b.UID=function(a){a.set_int(this.uid)},b.IID=function(a){a.set_int(this.get_iid())});g&&(l.IsVisible=function(){return this.visible},k.SetVisible=function(a){!a!==!this.visible&&(this.visible=a,this.runtime.redraw=!0)},l.CompareOpacity=function(a,b){return cr.do_cmp(cr.round6dp(100*this.opacity),a,b)},k.SetOpacity=function(a){a/=100;0>a?a=0:1<a&&(a=1);a!==this.opacity&&(this.opacity=a,this.runtime.redraw=!0)},b.Opacity=function(a){a.set_float(cr.round6dp(100*this.opacity))});h&&(l.IsOnLayer=function(a){return!a?
!1:this.layer===a},l.PickTopBottom=function(a){var b=this.getCurrentSol(),c=b.getObjects();if(!c.length)return!1;var d=c[0],e=d,k,h;k=1;for(h=c.length;k<h;k++)if(d=c[k],0===a){if(d.layer.index>e.layer.index||d.layer.index===e.layer.index&&d.get_zindex()>e.get_zindex())e=d}else if(d.layer.index<e.layer.index||d.layer.index===e.layer.index&&d.get_zindex()<e.get_zindex())e=d;b.pick_one(e);return!0},k.MoveToTop=function(){var a=this.get_zindex();a!==this.layer.instances.length-1&&(cr.arrayRemove(this.layer.instances,
a),this.layer.instances.push(this),this.runtime.redraw=!0,this.layer.zindices_stale=!0)},k.MoveToBottom=function(){var a=this.get_zindex();0!==a&&(cr.arrayRemove(this.layer.instances,a),this.layer.instances.unshift(this),this.runtime.redraw=!0,this.layer.zindices_stale=!0)},k.MoveToLayer=function(a){a&&a!=this.layer&&(cr.arrayRemove(this.layer.instances,this.get_zindex()),this.layer.zindices_stale=!0,this.layer=a,this.zindex=a.instances.length,a.instances.push(this),this.runtime.redraw=!0)},k.ZMoveToObject=
function(a,b){var c=0===a;if(b){var d=b.getFirstPicked(this);if(d&&d.uid!==this.uid){this.layer.index!==d.layer.index&&(cr.arrayRemove(this.layer.instances,this.get_zindex()),this.layer.zindices_stale=!0,this.layer=d.layer,this.zindex=d.layer.instances.length,d.layer.instances.push(this));var e=this.get_zindex(),d=d.get_zindex();cr.arrayRemove(this.layer.instances,e);e<d&&d--;c&&d++;d===this.layer.instances.length?this.layer.instances.push(this):this.layer.instances.splice(d,0,this);this.layer.zindices_stale=
!0;this.runtime.redraw=!0}}},b.LayerNumber=function(a){a.set_int(this.layer.number)},b.LayerName=function(a){a.set_string(this.layer.name)},b.ZIndex=function(a){a.set_int(this.get_zindex())});a&&(k.SetEffectEnabled=function(a,b){if(this.runtime.glwrap){var c=this.type.getEffectIndexByName(b);if(!(0>c)){var d=1===a;this.active_effect_flags[c]!==d&&(this.active_effect_flags[c]=d,this.updateActiveEffects(),this.runtime.redraw=!0)}}},k.SetEffectParam=function(a,b,c){if(this.runtime.glwrap){var d=this.type.getEffectIndexByName(a);
0>d||(a=this.type.effect_types[d],d=this.effect_params[d],b=Math.floor(b),0>b||b>=d.length||(1===this.runtime.glwrap.getProgramParameterType(a.shaderindex,b)&&(c/=100),d[b]!==c&&(d[b]=c,a.active&&(this.runtime.redraw=!0))))}})};cr.set_bbox_changed=function(){this.bbox_changed=!0;this.runtime.redraw=!0;var a,b;a=0;for(b=this.bbox_changed_callbacks.length;a<b;a++)this.bbox_changed_callbacks[a](this)};cr.add_bbox_changed_callback=function(a){a&&this.bbox_changed_callbacks.push(a)};
cr.update_bbox=function(){if(this.bbox_changed){this.bbox.set(this.x,this.y,this.x+this.width,this.y+this.height);this.bbox.offset(-this.hotspotX*this.width,-this.hotspotY*this.height);this.angle?(this.bbox.offset(-this.x,-this.y),this.bquad.set_from_rotated_rect(this.bbox,this.angle),this.bquad.offset(this.x,this.y),this.bquad.bounding_box(this.bbox)):this.bquad.set_from_rect(this.bbox);var a=0;this.bbox.left>this.bbox.right&&(a=this.bbox.left,this.bbox.left=this.bbox.right,this.bbox.right=a);this.bbox.top>
this.bbox.bottom&&(a=this.bbox.top,this.bbox.top=this.bbox.bottom,this.bbox.bottom=a);this.bbox_changed=!1}};cr.inst_contains_pt=function(a,b){return!this.bbox.contains_pt(a,b)||!this.bquad.contains_pt(a,b)?!1:this.collision_poly&&!this.collision_poly.is_empty()?(this.collision_poly.cache_poly(this.width,this.height,this.angle),this.collision_poly.contains_pt(a-this.x,b-this.y)):!0};cr.inst_get_iid=function(){this.type.updateIIDs();return this.iid};
cr.inst_get_zindex=function(){this.layer.updateZIndices();return this.zindex};cr.inst_updateActiveEffects=function(){this.active_effect_types.length=0;var a,b;a=0;for(b=this.active_effect_flags.length;a<b;a++)this.active_effect_flags[a]&&this.active_effect_types.push(this.type.effect_types[a]);this.uses_shaders=!!this.active_effect_types.length};cr.inst_toString=function(){return"Inst"+this.puid};
cr.type_getFirstPicked=function(a){if(a&&a.is_contained&&a.type!=this){var b,c,d;b=0;for(c=a.siblings.length;b<c;b++)if(d=a.siblings[b],d.type==this)return d}a=this.getCurrentSol().getObjects();return a.length?a[0]:null};cr.type_getPairedInstance=function(a){var b=this.getCurrentSol().getObjects();return b.length?b[a.get_iid()%b.length]:null};
cr.type_updateIIDs=function(){if(this.stale_iids&&!this.is_family){var a,b;a=0;for(b=this.instances.length;a<b;a++)this.instances[a].iid=a;var c=a,d=this.runtime.createRow;a=0;for(b=d.length;a<b;++a)d[a].type===this&&(d[a].iid=c++);this.stale_iids=!1}};cr.type_getCurrentSol=function(){return this.solstack[this.cur_sol]};cr.type_pushCleanSol=function(){this.cur_sol++;this.cur_sol===this.solstack.length?this.solstack.push(new cr.selection(this)):this.solstack[this.cur_sol].select_all=!0};
cr.type_pushCopySol=function(){this.cur_sol++;this.cur_sol===this.solstack.length&&this.solstack.push(new cr.selection(this));var a=this.solstack[this.cur_sol],b=this.solstack[this.cur_sol-1];b.select_all?a.select_all=!0:(a.select_all=!1,cr.shallowAssignArray(a.instances,b.instances))};cr.type_popSol=function(){this.cur_sol--};
cr.type_getBehaviorByName=function(a){var b,c,d,e,f,g=0;if(!this.is_family){b=0;for(c=this.families.length;b<c;b++){f=this.families[b];d=0;for(e=f.behaviors.length;d<e;d++){if(a===f.behaviors[d].name)return this.extra.lastBehIndex=g,f.behaviors[d];g++}}}b=0;for(c=this.behaviors.length;b<c;b++){if(a===this.behaviors[b].name)return this.extra.lastBehIndex=g,this.behaviors[b];g++}return null};cr.type_getBehaviorIndexByName=function(a){return this.getBehaviorByName(a)?this.extra.lastBehIndex:-1};
cr.type_getEffectIndexByName=function(a){var b,c;b=0;for(c=this.effect_types.length;b<c;b++)if(this.effect_types[b].name===a)return b;return-1};
cr.type_applySolToContainer=function(){if(this.is_contained&&!this.is_family){var a,b,c,d,e,f,g;this.updateIIDs();f=this.getCurrentSol();var h=f.select_all,l=(a=this.runtime.getCurrentEventStack())&&a.current_event&&a.current_event.orblock;a=0;for(b=this.container.length;a<b;a++)if(e=this.container[a],e!==this&&(e.updateIIDs(),g=e.getCurrentSol(),g.select_all=h,!h)){g.instances.length=f.instances.length;c=0;for(d=f.instances.length;c<d;c++)g.instances[c]=e.instances[f.instances[c].iid];if(l){g.else_instances.length=
f.else_instances.length;c=0;for(d=f.else_instances.length;c<d;c++)g.else_instances[c]=e.instances[f.else_instances[c].iid]}}}};cr.type_toString=function(){return"Type"+this.sid};cr.do_cmp=function(a,b,c){if("undefined"===typeof a||"undefined"===typeof c)return!1;switch(b){case 0:return a===c;case 1:return a!==c;case 2:return a<c;case 3:return a<=c;case 4:return a>c;case 5:return a>=c;default:return!1}};cr.shaders={};cr.plugins_.Arr=function(a){this.runtime=a};
(function(){function a(){return l.length?l.pop():[]}function b(a){var c,d;c=0;for(d=a.length;c<d;c++)Array.isArray(a[c])&&b(a[c]);a.length=0;l.push(a)}function c(){}function d(){}function e(a,b){if(cr.is_number(a)&&cr.is_number(b))return a-b;var c=""+a,d=""+b;return c<d?-1:c>d?1:0}function f(){}var g=cr.plugins_.Arr.prototype;g.Type=function(a){this.plugin=a;this.runtime=a.runtime};g.Type.prototype.onCreate=function(){};g.Instance=function(a){this.type=a;this.runtime=a.runtime};var h=g.Instance.prototype,
l=[];Array.isArray||(Array.isArray=function(a){return"[object Array]"===Object.prototype.toString.call(a)});h.onCreate=function(){this.cx=this.properties[0];this.cy=this.properties[1];this.cz=this.properties[2];this.recycled||(this.arr=a());var b=this.arr;b.length=this.cx;var c,d,e;for(c=0;c<this.cx;c++){b[c]||(b[c]=a());b[c].length=this.cy;for(d=0;d<this.cy;d++){b[c][d]||(b[c][d]=a());b[c][d].length=this.cz;for(e=0;e<this.cz;e++)b[c][d][e]=0}}this.forZ=this.forY=this.forX=0};h.onDestroy=function(){var a;
for(a=0;a<this.cx;a++)b(this.arr[a]);this.arr.length=0};h.at=function(a,b,c){a=Math.floor(a);b=Math.floor(b);c=Math.floor(c);return isNaN(a)||0>a||a>this.cx-1||isNaN(b)||0>b||b>this.cy-1||isNaN(c)||0>c||c>this.cz-1?0:this.arr[a][b][c]};h.set=function(a,b,c,d){a=Math.floor(a);b=Math.floor(b);c=Math.floor(c);if(!isNaN(a)&&!(0>a||a>this.cx-1))if(!isNaN(b)&&!(0>b||b>this.cy-1))if(!isNaN(c)&&!(0>c||c>this.cz-1))this.arr[a][b][c]=d};h.getAsJSON=function(){return JSON.stringify({c2array:!0,size:[this.cx,
this.cy,this.cz],data:this.arr})};h.saveToJSON=function(){return{size:[this.cx,this.cy,this.cz],data:this.arr}};h.loadFromJSON=function(a){var b=a.size;this.cx=b[0];this.cy=b[1];this.cz=b[2];this.arr=a.data};h.setSize=function(b,c,d){0>b&&(b=0);0>c&&(c=0);0>d&&(d=0);if(!(this.cx===b&&this.cy===c&&this.cz===d)){this.cx=b;this.cy=c;this.cz=d;var e,h,f=this.arr;f.length=b;for(b=0;b<this.cx;b++){cr.is_undefined(f[b])&&(f[b]=a());f[b].length=c;for(e=0;e<this.cy;e++){cr.is_undefined(f[b][e])&&(f[b][e]=
a());f[b][e].length=d;for(h=0;h<this.cz;h++)cr.is_undefined(f[b][e][h])&&(f[b][e][h]=0)}}}};c.prototype.CompareX=function(a,b,c){return cr.do_cmp(this.at(a,0,0),b,c)};c.prototype.CompareXY=function(a,b,c,d){return cr.do_cmp(this.at(a,b,0),c,d)};c.prototype.CompareXYZ=function(a,b,c,d,e){return cr.do_cmp(this.at(a,b,c),d,e)};h.doForEachTrigger=function(a){this.runtime.pushCopySol(a.solModifiers);a.retrigger();this.runtime.popSol(a.solModifiers)};c.prototype.ArrForEach=function(a){var b=this.runtime.getCurrentEventStack().current_event;
this.forZ=this.forY=this.forX=0;switch(a){case 0:for(this.forX=0;this.forX<this.cx;this.forX++)for(this.forY=0;this.forY<this.cy;this.forY++)for(this.forZ=0;this.forZ<this.cz;this.forZ++)this.doForEachTrigger(b);break;case 1:for(this.forX=0;this.forX<this.cx;this.forX++)for(this.forY=0;this.forY<this.cy;this.forY++)this.doForEachTrigger(b);break;case 2:for(this.forX=0;this.forX<this.cx;this.forX++)this.doForEachTrigger(b)}this.forZ=this.forY=this.forX=0;return!1};c.prototype.CompareCurrent=function(a,
b){return cr.do_cmp(this.at(this.forX,this.forY,this.forZ),a,b)};c.prototype.Contains=function(a){var b,c,d;for(b=0;b<this.cx;b++)for(c=0;c<this.cy;c++)for(d=0;d<this.cz;d++)if(this.arr[b][c][d]===a)return!0;return!1};c.prototype.IsEmpty=function(){return 0===this.cx||0===this.cy||0===this.cz};g.cnds=new c;d.prototype.Clear=function(){var a,b,c;for(a=0;a<this.cx;a++)for(b=0;b<this.cy;b++)for(c=0;c<this.cz;c++)this.arr[a][b][c]=0};d.prototype.SetSize=function(a,b,c){this.setSize(a,b,c)};d.prototype.SetX=
function(a,b){this.set(a,0,0,b)};d.prototype.SetXY=function(a,b,c){this.set(a,b,0,c)};d.prototype.SetXYZ=function(a,b,c,d){this.set(a,b,c,d)};d.prototype.Push=function(b,c,d){var e=0,h=0,f=0,g=this.arr;switch(d){case 0:0===b?(e=g.length,g.push(a())):(e=0,g.unshift(a()));for(g[e].length=this.cy;h<this.cy;h++){g[e][h]=a();g[e][h].length=this.cz;for(f=0;f<this.cz;f++)g[e][h][f]=c}this.cx++;break;case 1:for(;e<this.cx;e++){0===b?(h=g[e].length,g[e].push(a())):(h=0,g[e].unshift(a()));g[e][h].length=this.cz;
for(f=0;f<this.cz;f++)g[e][h][f]=c}this.cy++;break;case 2:for(;e<this.cx;e++)for(h=0;h<this.cy;h++)0===b?g[e][h].push(c):g[e][h].unshift(c);this.cz++}};d.prototype.Pop=function(a,c){var d=0,e=0,h=this.arr;switch(c){case 0:if(0===this.cx)break;0===a?b(h.pop()):b(h.shift());this.cx--;break;case 1:if(0===this.cy)break;for(;d<this.cx;d++)0===a?b(h[d].pop()):b(h[d].shift());this.cy--;break;case 2:if(0===this.cz)break;for(;d<this.cx;d++)for(e=0;e<this.cy;e++)0===a?h[d][e].pop():h[d][e].shift();this.cz--}};
d.prototype.Reverse=function(a){var b=0,c=0,d=this.arr;if(!(0===this.cx||0===this.cy||0===this.cz))switch(a){case 0:d.reverse();break;case 1:for(;b<this.cx;b++)d[b].reverse();break;case 2:for(;b<this.cx;b++)for(c=0;c<this.cy;c++)d[b][c].reverse();this.cz--}};d.prototype.Sort=function(a){var b=0,c=0,d=this.arr;if(!(0===this.cx||0===this.cy||0===this.cz))switch(a){case 0:d.sort(function(a,b){return e(a[0][0],b[0][0])});break;case 1:for(;b<this.cx;b++)d[b].sort(function(a,b){return e(a[0],b[0])});break;
case 2:for(;b<this.cx;b++)for(c=0;c<this.cy;c++)d[b][c].sort(e)}};d.prototype.Delete=function(a,c){var d=0,e=0;a=Math.floor(a);var h=this.arr;if(!(0>a))switch(c){case 0:if(a>=this.cx)break;b(h[a]);h.splice(a,1);this.cx--;break;case 1:if(a>=this.cy)break;for(;d<this.cx;d++)b(h[d][a]),h[d].splice(a,1);this.cy--;break;case 2:if(a>=this.cz)break;for(;d<this.cx;d++)for(e=0;e<this.cy;e++)h[d][e].splice(a,1);this.cz--}};d.prototype.Insert=function(b,c,d){var e=0,h=0,f=0;c=Math.floor(c);var g=this.arr;if(!(0>
c))switch(d){case 0:if(c>this.cx)break;e=c;g.splice(e,0,a());for(g[e].length=this.cy;h<this.cy;h++){g[e][h]=a();g[e][h].length=this.cz;for(f=0;f<this.cz;f++)g[e][h][f]=b}this.cx++;break;case 1:if(c>this.cy)break;for(;e<this.cx;e++){h=c;g[e].splice(h,0,a());g[e][h].length=this.cz;for(f=0;f<this.cz;f++)g[e][h][f]=b}this.cy++;break;case 2:if(c>this.cz)break;for(;e<this.cx;e++)for(h=0;h<this.cy;h++)g[e][h].splice(c,0,b);this.cz++}};d.prototype.JSONLoad=function(a){var b;try{b=JSON.parse(a)}catch(c){return}b.c2array&&
(a=b.size,this.cx=a[0],this.cy=a[1],this.cz=a[2],this.arr=b.data)};d.prototype.JSONDownload=function(a){var b=document.createElement("a");if("undefined"===typeof b.download)b="data:text/html,"+encodeURIComponent("<p><a download='"+a+"' href=\"data:application/json,"+encodeURIComponent(this.getAsJSON())+'">Download link</a></p>'),window.open(b);else{var c=document.getElementsByTagName("body")[0];b.textContent=a;b.href="data:application/json,"+encodeURIComponent(this.getAsJSON());b.download=a;c.appendChild(b);
a=document.createEvent("MouseEvent");a.initMouseEvent("click",!0,!0,window,0,0,0,0,0,!1,!1,!1,!1,0,null);b.dispatchEvent(a);c.removeChild(b)}};g.acts=new d;f.prototype.At=function(a,b,c,d){a.set_any(this.at(b,c||0,d||0))};f.prototype.Width=function(a){a.set_int(this.cx)};f.prototype.Height=function(a){a.set_int(this.cy)};f.prototype.Depth=function(a){a.set_int(this.cz)};f.prototype.CurX=function(a){a.set_int(this.forX)};f.prototype.CurY=function(a){a.set_int(this.forY)};f.prototype.CurZ=function(a){a.set_int(this.forZ)};
f.prototype.CurValue=function(a){a.set_any(this.at(this.forX,this.forY,this.forZ))};f.prototype.Front=function(a){a.set_any(this.at(0,0,0))};f.prototype.Back=function(a){a.set_any(this.at(this.cx-1,0,0))};f.prototype.IndexOf=function(a,b){for(var c=0;c<this.cx;c++)if(this.arr[c][0][0]===b){a.set_int(c);return}a.set_int(-1)};f.prototype.LastIndexOf=function(a,b){for(var c=this.cx-1;0<=c;c--)if(this.arr[c][0][0]===b){a.set_int(c);return}a.set_int(-1)};f.prototype.AsJSON=function(a){a.set_string(this.getAsJSON())};
g.exps=new f})();cr.plugins_.Audio=function(a){this.runtime=a};
(function(){function a(a){a=Math.pow(10,a/20);0>a&&(a=0);1<a&&(a=1);return a}function b(a){0>a&&(a=0);1<a&&(a=1);return 20*(Math.log(a)/Math.log(10))}function c(a){a=a.toLowerCase();return N.hasOwnProperty(a)&&N[a].length?N[a][0].getInputNode():I.destination}function d(){return I.createGain?I.createGain():I.createGainNode()}function e(a){return I.createDelay?I.createDelay(a):I.createDelayNode(a)}function f(a){a.start?a.start(0):a.noteOn(0)}function g(a,b,c){a.start?a.start(0,b):a.noteGrainOn(0,b,
c-b)}function h(a){a.stop?a.stop(0):a.noteOff(0)}function l(a,b,c,d){if(a)if(a.cancelScheduledValues(0),0===d)a.value=b;else{var e=I.currentTime;d+=e;switch(c){case 0:a.setValueAtTime(b,d);break;case 1:a.setValueAtTime(a.value,e);a.linearRampToValueAtTime(b,d);break;case 2:a.setValueAtTime(a.value,e),a.exponentialRampToValueAtTime(b,d)}}}function k(a,b,c,e,h,f){this.type="filter";this.params=[a,b,c,e,h,f];this.inputNode=d();this.wetNode=d();this.wetNode.gain.value=f;this.dryNode=d();this.dryNode.gain.value=
1-f;this.filterNode=I.createBiquadFilter();this.filterNode.type="number"===typeof this.filterNode.type?a:ja[a];this.filterNode.frequency.value=b;this.filterNode.detune&&(this.filterNode.detune.value=c);this.filterNode.Q.value=e;this.filterNode.gain.value=h;this.inputNode.connect(this.filterNode);this.inputNode.connect(this.dryNode);this.filterNode.connect(this.wetNode)}function m(a,b,c){this.type="delay";this.params=[a,b,c];this.inputNode=d();this.wetNode=d();this.wetNode.gain.value=c;this.dryNode=
d();this.dryNode.gain.value=1-c;this.mainNode=d();this.delayNode=e(a);this.delayNode.delayTime.value=a;this.delayGainNode=d();this.delayGainNode.gain.value=b;this.inputNode.connect(this.mainNode);this.inputNode.connect(this.dryNode);this.mainNode.connect(this.wetNode);this.mainNode.connect(this.delayNode);this.delayNode.connect(this.delayGainNode);this.delayGainNode.connect(this.mainNode)}function n(a,b,c,e){this.type="convolve";this.params=[b,c,e];this.inputNode=d();this.wetNode=d();this.wetNode.gain.value=
c;this.dryNode=d();this.dryNode.gain.value=1-c;this.convolveNode=I.createConvolver();a&&(this.convolveNode.normalize=b,this.convolveNode.buffer=a);this.inputNode.connect(this.convolveNode);this.inputNode.connect(this.dryNode);this.convolveNode.connect(this.wetNode)}function q(a,b,c,h,k){this.type="flanger";this.params=[a,b,c,h,k];this.inputNode=d();this.dryNode=d();this.dryNode.gain.value=1-k/2;this.wetNode=d();this.wetNode.gain.value=k/2;this.feedbackNode=d();this.feedbackNode.gain.value=h;this.delayNode=
e(a+b);this.delayNode.delayTime.value=a;this.oscNode=I.createOscillator();this.oscNode.frequency.value=c;this.oscGainNode=d();this.oscGainNode.gain.value=b;this.inputNode.connect(this.delayNode);this.inputNode.connect(this.dryNode);this.delayNode.connect(this.wetNode);this.delayNode.connect(this.feedbackNode);this.feedbackNode.connect(this.delayNode);this.oscNode.connect(this.oscGainNode);this.oscGainNode.connect(this.delayNode.delayTime);f(this.oscNode)}function p(a,b,c,e,h,k){this.type="phaser";
this.params=[a,b,c,e,h,k];this.inputNode=d();this.dryNode=d();this.dryNode.gain.value=1-k/2;this.wetNode=d();this.wetNode.gain.value=k/2;this.filterNode=I.createBiquadFilter();this.filterNode.type="number"===typeof this.filterNode.type?7:"allpass";this.filterNode.frequency.value=a;this.filterNode.detune&&(this.filterNode.detune.value=b);this.filterNode.Q.value=c;this.oscNode=I.createOscillator();this.oscNode.frequency.value=h;this.oscGainNode=d();this.oscGainNode.gain.value=e;this.inputNode.connect(this.filterNode);
this.inputNode.connect(this.dryNode);this.filterNode.connect(this.wetNode);this.oscNode.connect(this.oscGainNode);this.oscGainNode.connect(this.filterNode.frequency);f(this.oscNode)}function r(a){this.type="gain";this.params=[a];this.node=d();this.node.gain.value=a}function s(a,b){this.type="tremolo";this.params=[a,b];this.node=d();this.node.gain.value=1-b/2;this.oscNode=I.createOscillator();this.oscNode.frequency.value=a;this.oscGainNode=d();this.oscGainNode.gain.value=b/2;this.oscNode.connect(this.oscGainNode);
this.oscGainNode.connect(this.node.gain);f(this.oscNode)}function t(a,b){this.type="ringmod";this.params=[a,b];this.inputNode=d();this.wetNode=d();this.wetNode.gain.value=b;this.dryNode=d();this.dryNode.gain.value=1-b;this.ringNode=d();this.ringNode.gain.value=0;this.oscNode=I.createOscillator();this.oscNode.frequency.value=a;this.oscNode.connect(this.ringNode.gain);f(this.oscNode);this.inputNode.connect(this.ringNode);this.inputNode.connect(this.dryNode);this.ringNode.connect(this.wetNode)}function v(a,
b,c,e,h){this.type="distortion";this.params=[a,b,c,e,h];this.inputNode=d();this.preGain=d();this.postGain=d();this.setDrive(c,Math.pow(10,e/20));this.wetNode=d();this.wetNode.gain.value=h;this.dryNode=d();this.dryNode.gain.value=1-h;this.waveShaper=I.createWaveShaper();this.curve=new Float32Array(65536);this.generateColortouchCurve(a,b);this.waveShaper.curve=this.curve;this.inputNode.connect(this.preGain);this.inputNode.connect(this.dryNode);this.preGain.connect(this.waveShaper);this.waveShaper.connect(this.postGain);
this.postGain.connect(this.wetNode)}function y(a,b,c,d,e){this.type="compressor";this.params=[a,b,c,d,e];this.node=I.createDynamicsCompressor();this.node.threshold.value=a;this.node.knee.value=b;this.node.ratio.value=c;this.node.attack.value=d;this.node.release.value=e}function z(a,b){this.type="analyser";this.params=[a,b];this.node=I.createAnalyser();this.node.fftSize=a;this.node.smoothingTimeConstant=b;this.freqBins=new Float32Array(this.node.frequencyBinCount);this.signal=new Uint8Array(a);this.rms=
this.peak=0}function C(){this.obj=null;this.loadUid=0;this.speeds=[];this.moveAngle=this.lastY=this.lastX=0}function A(a,b){this.src=a;this.myapi=J;this.is_music=b;this.added_end_listener=!1;var c=this;this.mediaSourceNode=this.outNode=null;this.panWhenReady=[];this.seekWhenReady=0;this.pauseWhenReady=!1;J===G&&(b&&!M.isMobile)&&(this.myapi=R,this.outNode=d());this.audioData=this.bufferObject=null;var e;switch(this.myapi){case R:this.bufferObject=new Audio;J===G&&I.createMediaElementSource&&this.bufferObject.addEventListener("canplay",
function(){c.mediaSourceNode=I.createMediaElementSource(c.bufferObject);c.mediaSourceNode.connect(c.outNode)});this.bufferObject.autoplay=!1;this.bufferObject.preload="auto";this.bufferObject.src=a;break;case G:e=new XMLHttpRequest;e.open("GET",a,!0);e.responseType="arraybuffer";e.onload=function(){c.audioData=e.response;c.decodeAudioBuffer()};e.send();break;case U:this.bufferObject=!0;break;case aa:this.bufferObject=!0}}function x(a,b){var e=this;this.tag=b;this.stopped=this.fresh=!0;this.src=a.src;
this.buffer=a;this.myapi=J;this.is_music=a.is_music;this.playbackRate=1;this.pgended=!0;this.is_paused=this.resume_me=!1;this.resume_position=0;this.is_silent=this.is_muted=this.looping=!1;this.mutevol=this.volume=1;this.startTime=M.kahanTime.sum;this.pannerNode=this.gainNode=null;this.pannerEnabled=!1;this.objectTracker=null;this.panConeOuterGain=this.panConeOuter=this.panConeInner=this.panAngle=this.panY=this.panX=0;this.instanceObject=null;var h=!1;switch(this.myapi){case R:this.is_music?(this.instanceObject=
a.bufferObject,h=!a.added_end_listener,a.added_end_listener=!0):(this.instanceObject=new Audio,this.instanceObject.autoplay=!1,this.instanceObject.src=a.bufferObject.src,h=!0);h&&this.instanceObject.addEventListener("ended",function(){V=e.tag;e.stopped=!0;M.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded,Q)});break;case G:this.gainNode=d();this.gainNode.connect(c(b));this.buffer.myapi===G?a.bufferObject&&(this.instanceObject=I.createBufferSource(),this.instanceObject.buffer=a.bufferObject,this.instanceObject.connect(this.gainNode)):
(this.instanceObject=this.buffer.bufferObject,this.buffer.outNode.connect(this.gainNode));break;case U:this.instanceObject=new window.Media(T+this.src,null,null,function(a){a===window.Media.MEDIA_STOPPED&&(e.pgended=!0,e.stopped=!0,V=e.tag,M.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded,Q))});break;case aa:this.instanceObject=!0}}function w(a){O.length=0;if(a.length){var b,c,d;b=0;for(c=L.length;b<c;b++)d=L[b],cr.equals_nocase(a,d.tag)&&O.push(d)}else P&&!P.hasEnded()&&(O.length=1,O[0]=P)}function D(a){var b,
c,d,e,h=I.destination;if(N.hasOwnProperty(a)&&(d=N[a],d.length)){h=d[0].getInputNode();b=0;for(c=d.length;b<c;b++)e=d[b],b+1===c?e.connectTo(I.destination):e.connectTo(d[b+1].getInputNode())}w(a);b=0;for(c=O.length;b<c;b++)O[b].reconnect(h);ca&&ga===a&&(ca.disconnect(),ca.connect(h))}function E(a,b){N.hasOwnProperty(a)?N[a].push(b):N[a]=[b];D(a)}function H(){}function u(){}function B(){}function K(a,b){var c=null;N.hasOwnProperty(a)&&(c=N[a]);return c&&0<=b&&b<c.length&&c[b].freqBins?c[b]:null}var F=
cr.plugins_.Audio.prototype;F.Type=function(a){this.plugin=a;this.runtime=a.runtime};F.Type.prototype.onCreate=function(){};var M=null,Q=null,V="",T="",R=0,G=1,U=2,aa=3,J=R,I=null,da=[],L=[],P=null,W=!1,fa=0,S=!1,X=1,Y=0,Z=0,ha=1,ia=1,ka=10,la=1E4,ma=1,ca=null,ga="",N={},ja="lowpass highpass bandpass lowshelf highshelf peaking notch allpass".split(" ");k.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};k.prototype.remove=
function(){this.inputNode.disconnect();this.filterNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};k.prototype.getInputNode=function(){return this.inputNode};k.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[4]=b;l(this.wetNode.gain,b,c,d);l(this.dryNode.gain,1-b,c,d);break;case 1:this.params[0]=b;l(this.filterNode.frequency,b,c,d);break;case 2:this.params[1]=b;l(this.filterNode.detune,b,c,d);break;case 3:this.params[2]=b;l(this.filterNode.Q,
b,c,d);break;case 4:this.params[3]=b,l(this.filterNode.gain,b,c,d)}};m.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};m.prototype.remove=function(){this.inputNode.disconnect();this.mainNode.disconnect();this.delayNode.disconnect();this.delayGainNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};m.prototype.getInputNode=function(){return this.inputNode};m.prototype.setParam=function(b,c,d,e){switch(b){case 0:c/=
100;0>c&&(c=0);1<c&&(c=1);this.params[2]=c;l(this.wetNode.gain,c,d,e);l(this.dryNode.gain,1-c,d,e);break;case 4:this.params[1]=a(c);l(this.delayGainNode.gain,a(c),d,e);break;case 5:this.params[0]=c,l(this.delayNode.delayTime,c,d,e)}};n.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};n.prototype.remove=function(){this.inputNode.disconnect();this.convolveNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};
n.prototype.getInputNode=function(){return this.inputNode};n.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100,0>b&&(b=0),1<b&&(b=1),this.params[1]=b,l(this.wetNode.gain,b,c,d),l(this.dryNode.gain,1-b,c,d)}};q.prototype.connectTo=function(a){this.dryNode.disconnect();this.dryNode.connect(a);this.wetNode.disconnect();this.wetNode.connect(a)};q.prototype.remove=function(){this.inputNode.disconnect();this.delayNode.disconnect();this.oscNode.disconnect();this.oscGainNode.disconnect();this.dryNode.disconnect();
this.wetNode.disconnect();this.feedbackNode.disconnect()};q.prototype.getInputNode=function(){return this.inputNode};q.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[4]=b;l(this.wetNode.gain,b/2,c,d);l(this.dryNode.gain,1-b/2,c,d);break;case 6:this.params[1]=b/1E3;l(this.oscGainNode.gain,b/1E3,c,d);break;case 7:this.params[2]=b;l(this.oscNode.frequency,b,c,d);break;case 8:this.params[3]=b/100,l(this.feedbackNode.gain,b/100,c,d)}};p.prototype.connectTo=
function(a){this.dryNode.disconnect();this.dryNode.connect(a);this.wetNode.disconnect();this.wetNode.connect(a)};p.prototype.remove=function(){this.inputNode.disconnect();this.filterNode.disconnect();this.oscNode.disconnect();this.oscGainNode.disconnect();this.dryNode.disconnect();this.wetNode.disconnect()};p.prototype.getInputNode=function(){return this.inputNode};p.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[5]=b;l(this.wetNode.gain,b/2,c,d);l(this.dryNode.gain,
1-b/2,c,d);break;case 1:this.params[0]=b;l(this.filterNode.frequency,b,c,d);break;case 2:this.params[1]=b;l(this.filterNode.detune,b,c,d);break;case 3:this.params[2]=b;l(this.filterNode.Q,b,c,d);break;case 6:this.params[3]=b;l(this.oscGainNode.gain,b,c,d);break;case 7:this.params[4]=b,l(this.oscNode.frequency,b,c,d)}};r.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};r.prototype.remove=function(){this.node.disconnect()};r.prototype.getInputNode=function(){return this.node};
r.prototype.setParam=function(b,c,d,e){switch(b){case 4:this.params[0]=a(c),l(this.node.gain,a(c),d,e)}};s.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};s.prototype.remove=function(){this.oscNode.disconnect();this.oscGainNode.disconnect();this.node.disconnect()};s.prototype.getInputNode=function(){return this.node};s.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[1]=b;l(this.node.gain.value,1-b/2,c,d);l(this.oscGainNode.gain.value,
b/2,c,d);break;case 7:this.params[0]=b,l(this.oscNode.frequency,b,c,d)}};t.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};t.prototype.remove=function(){this.oscNode.disconnect();this.ringNode.disconnect();this.inputNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};t.prototype.getInputNode=function(){return this.inputNode};t.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=
0);1<b&&(b=1);this.params[1]=b;l(this.wetNode.gain,b,c,d);l(this.dryNode.gain,1-b,c,d);break;case 7:this.params[0]=b,l(this.oscNode.frequency,b,c,d)}};v.prototype.setDrive=function(a,b){0.01>a&&(a=0.01);this.preGain.gain.value=a;this.postGain.gain.value=Math.pow(1/a,0.6)*b};v.prototype.shape=function(a,b,c){var d=1.05*c*b-b;c=0>a?-1:1;a=0>a?-a:a;b=a<b?a:b+d*(1-Math.exp(-(1/d)*(a-b)));return b*c};v.prototype.generateColortouchCurve=function(a,b){for(var c=Math.pow(10,a/20),d=Math.pow(10,b/20),e=0,
h=0;32768>h;++h)e=h/32768,e=this.shape(e,c,d),this.curve[32768+h]=e,this.curve[32768-h-1]=-e};v.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};v.prototype.remove=function(){this.inputNode.disconnect();this.preGain.disconnect();this.waveShaper.disconnect();this.postGain.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};v.prototype.getInputNode=function(){return this.inputNode};v.prototype.setParam=
function(a,b,c,d){switch(a){case 0:b/=100,0>b&&(b=0),1<b&&(b=1),this.params[4]=b,l(this.wetNode.gain,b,c,d),l(this.dryNode.gain,1-b,c,d)}};y.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};y.prototype.remove=function(){this.node.disconnect()};y.prototype.getInputNode=function(){return this.node};y.prototype.setParam=function(a,b,c,d){};z.prototype.tick=function(){this.node.getFloatFrequencyData(this.freqBins);this.node.getByteTimeDomainData(this.signal);for(var a=this.node.fftSize,
c=0,d=this.peak=0,e=0;c<a;c++)e=(this.signal[c]-128)/128,0>e&&(e=-e),this.peak<e&&(this.peak=e),d+=e*e;this.peak=b(this.peak);this.rms=b(Math.sqrt(d/a))};z.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};z.prototype.remove=function(){this.node.disconnect()};z.prototype.getInputNode=function(){return this.node};z.prototype.setParam=function(a,b,c,d){};C.prototype.setObject=function(a){if(this.obj=a)this.lastX=this.obj.x,this.lastY=this.obj.y;this.speeds.length=0};C.prototype.hasObject=
function(){return!!this.obj};C.prototype.tick=function(a){this.obj&&(this.moveAngle=cr.angleTo(this.lastX,this.lastY,this.obj.x,this.obj.y),a=cr.distanceTo(this.lastX,this.lastY,this.obj.x,this.obj.y)/a,4>this.speeds.length||this.speeds.shift(),this.speeds.push(a),this.lastX=this.obj.x,this.lastY=this.obj.y)};C.prototype.getSpeed=function(){if(!this.speeds.length)return 0;var a,b,c=0;a=0;for(b=this.speeds.length;a<b;a++)c+=this.speeds[a];return c/this.speeds.length};C.prototype.getVelocityX=function(){return Math.cos(this.moveAngle)*
this.getSpeed()};C.prototype.getVelocityY=function(){return Math.sin(this.moveAngle)*this.getSpeed()};var na=!1;A.prototype.decodeAudioBuffer=function(){if(!this.bufferObject&&this.audioData){var a=this;if(I.decodeAudioData)I.decodeAudioData(this.audioData,function(b){a.bufferObject=b;var c,d,e;if(cr.is_undefined(a.playTagWhenReady))cr.is_undefined(a.convolveWhenReady)||(c=a.convolveWhenReady.convolveNode,c.normalize=a.normalizeWhenReady,c.buffer=b);else if(a.panWhenReady.length){c=0;for(d=a.panWhenReady.length;c<
d;c++){b=a.panWhenReady[c];e=new x(a,b.thistag);e.setPannerEnabled(!0);if("undefined"!==typeof b.objUid&&(b.obj=M.getObjectByUID(b.objUid),!b.obj))continue;if(b.obj){var h=cr.rotatePtAround(b.obj.x,b.obj.y,-b.obj.layer.getAngle(),Y,Z,!0),f=cr.rotatePtAround(b.obj.x,b.obj.y,-b.obj.layer.getAngle(),Y,Z,!1);e.setPan(h,f,cr.to_degrees(b.obj.angle-b.obj.layer.getAngle()),b.ia,b.oa,b.og);e.setObject(b.obj)}else e.setPan(b.x,b.y,b.a,b.ia,b.oa,b.og);e.play(a.loopWhenReady,a.volumeWhenReady,a.seekWhenReady);
a.pauseWhenReady&&e.pause();L.push(e)}a.panWhenReady.length=0}else e=new x(a,a.playTagWhenReady),e.play(a.loopWhenReady,a.volumeWhenReady,a.seekWhenReady),a.pauseWhenReady&&e.pause(),L.push(e)});else if(this.bufferObject=I.createBuffer(this.audioData,!1),cr.is_undefined(this.playTagWhenReady)){if(!cr.is_undefined(this.convolveWhenReady)){var b=this.convolveWhenReady.convolveNode;b.normalize=this.normalizeWhenReady;b.buffer=this.bufferObject}}else b=new x(this,this.playTagWhenReady),b.play(this.loopWhenReady,
this.volumeWhenReady,this.seekWhenReady),this.pauseWhenReady&&b.pause(),L.push(b)}};A.prototype.isLoaded=function(){switch(this.myapi){case R:return 4===this.bufferObject.readyState;case G:return!!this.audioData;case U:return!0;case aa:return!0}return!1};x.prototype.hasEnded=function(){switch(this.myapi){case R:return this.instanceObject.ended;case G:return this.buffer.myapi===G?!this.fresh&&!this.stopped&&this.instanceObject.loop||this.is_paused?!1:M.kahanTime.sum-this.startTime>this.buffer.bufferObject.duration:
this.instanceObject.ended;case U:return this.pgended;case aa:!0}return!0};x.prototype.canBeRecycled=function(){return this.fresh||this.stopped?!0:this.hasEnded()};x.prototype.setPannerEnabled=function(a){J===G&&(!this.pannerEnabled&&a?(this.pannerNode||(this.pannerNode=I.createPanner(),this.pannerNode.panningModel="number"===typeof this.pannerNode.panningModel?ha:["equalpower","HRTF","soundfield"][ha],this.pannerNode.distanceModel="number"===typeof this.pannerNode.distanceModel?ia:["linear","inverse",
"exponential"][ia],this.pannerNode.refDistance=ka,this.pannerNode.maxDistance=la,this.pannerNode.rolloffFactor=ma),this.gainNode.disconnect(),this.gainNode.connect(this.pannerNode),this.pannerNode.connect(c(this.tag)),this.pannerEnabled=!0):this.pannerEnabled&&!a&&(this.pannerNode.disconnect(),this.gainNode.disconnect(),this.gainNode.connect(c(this.tag)),this.pannerEnabled=!1))};x.prototype.setPan=function(a,b,c,d,e,h){this.pannerEnabled&&J===G&&(this.pannerNode.setPosition(a,b,0),this.pannerNode.setOrientation(Math.cos(cr.to_radians(c)),
Math.sin(cr.to_radians(c)),0),this.pannerNode.coneInnerAngle=d,this.pannerNode.coneOuterAngle=e,this.pannerNode.coneOuterGain=h,this.panX=a,this.panY=b,this.panAngle=c,this.panConeInner=d,this.panConeOuter=e,this.panConeOuterGain=h)};x.prototype.setObject=function(a){this.pannerEnabled&&J===G&&(this.objectTracker||(this.objectTracker=new C),this.objectTracker.setObject(a))};x.prototype.tick=function(a){if(this.pannerEnabled&&!(J!==G||!this.objectTracker||!this.objectTracker.hasObject()||!this.isPlaying())){this.objectTracker.tick(a);
a=this.objectTracker.obj;var b=cr.rotatePtAround(a.x,a.y,-a.layer.getAngle(),Y,Z,!0),c=cr.rotatePtAround(a.x,a.y,-a.layer.getAngle(),Y,Z,!1);this.pannerNode.setPosition(b,c,0);b=0;"undefined"!==typeof this.objectTracker.obj.angle&&(b=a.angle-a.layer.getAngle(),this.pannerNode.setOrientation(Math.cos(b),Math.sin(b),0));this.pannerNode.setVelocity(this.objectTracker.getVelocityX(),this.objectTracker.getVelocityY(),0)}};x.prototype.play=function(a,b,c){var d=this.instanceObject;this.looping=a;this.volume=
b;c=c||0;switch(this.myapi){case R:1!==d.playbackRate&&(d.playbackRate=1);d.volume!==b*X&&(d.volume=b*X);d.loop!==a&&(d.loop=a);d.muted&&(d.muted=!1);if(d.currentTime!==c)try{d.currentTime=c}catch(e){}this.instanceObject.play();break;case G:this.muted=!1;this.mutevol=1;if(this.buffer.myapi===G)this.fresh||(this.instanceObject=I.createBufferSource(),this.instanceObject.buffer=this.buffer.bufferObject,this.instanceObject.connect(this.gainNode)),this.instanceObject.loop=a,this.gainNode.gain.value=b*
X,0===c?f(this.instanceObject):g(this.instanceObject,c,this.getDuration());else{1!==d.playbackRate&&(d.playbackRate=1);d.loop!==a&&(d.loop=a);this.gainNode.gain.value=b*X;if(d.currentTime!==c)try{d.currentTime=c}catch(h){}d.play()}break;case U:(!this.fresh&&this.stopped||0!==c)&&d.seekTo(c);d.play();this.pgended=!1;break;case aa:M.isDirectCanvas?AppMobi.context.playSound(this.src):AppMobi.player.playSound(this.src)}this.playbackRate=1;this.startTime=M.kahanTime.sum-c;this.is_paused=this.stopped=this.fresh=
!1};x.prototype.stop=function(){switch(this.myapi){case R:this.instanceObject.paused||this.instanceObject.pause();break;case G:this.buffer.myapi===G?h(this.instanceObject):this.instanceObject.paused||this.instanceObject.pause();break;case U:this.instanceObject.stop()}this.stopped=!0;this.is_paused=!1};x.prototype.pause=function(){if(!this.fresh&&!this.stopped&&!this.hasEnded()&&!this.is_paused){switch(this.myapi){case R:this.instanceObject.paused||this.instanceObject.pause();break;case G:this.buffer.myapi===
G?(this.resume_position=this.getPlaybackTime(),this.looping&&(this.resume_position%=this.getDuration()),h(this.instanceObject)):this.instanceObject.paused||this.instanceObject.pause();break;case U:this.instanceObject.pause()}this.is_paused=!0}};x.prototype.resume=function(){if(!this.fresh&&!this.stopped&&!this.hasEnded()&&this.is_paused){switch(this.myapi){case R:this.instanceObject.play();break;case G:this.buffer.myapi===G?(this.instanceObject=I.createBufferSource(),this.instanceObject.buffer=this.buffer.bufferObject,
this.instanceObject.connect(this.gainNode),this.instanceObject.loop=this.looping,this.gainNode.gain.value=X*this.volume*this.mutevol,this.startTime=M.kahanTime.sum-this.resume_position,g(this.instanceObject,this.resume_position,this.getDuration())):this.instanceObject.play();break;case U:this.instanceObject.play()}this.is_paused=!1}};x.prototype.seek=function(a){if(!this.fresh&&!this.stopped&&!this.hasEnded())switch(this.myapi){case R:try{this.instanceObject.currentTime=a}catch(b){}break;case G:if(this.buffer.myapi===
G)this.is_paused?this.resume_position=a:(this.pause(),this.resume_position=a,this.resume());else try{this.instanceObject.currentTime=a}catch(c){}}};x.prototype.reconnect=function(a){this.myapi===G&&(this.pannerEnabled?(this.pannerNode.disconnect(),this.pannerNode.connect(a)):(this.gainNode.disconnect(),this.gainNode.connect(a)))};x.prototype.getDuration=function(){switch(this.myapi){case R:if("undefined"!==typeof this.instanceObject.duration)return this.instanceObject.duration;break;case G:return this.buffer.bufferObject.duration;
case U:return this.instanceObject.getDuration()}return 0};x.prototype.getPlaybackTime=function(){var a=this.getDuration(),b=0;switch(this.myapi){case R:"undefined"!==typeof this.instanceObject.currentTime&&(b=this.instanceObject.currentTime);break;case G:if(this.buffer.myapi===G){if(this.is_paused)return this.resume_position;b=M.kahanTime.sum-this.startTime}else"undefined"!==typeof this.instanceObject.currentTime&&(b=this.instanceObject.currentTime)}!this.looping&&b>a&&(b=a);return b};x.prototype.isPlaying=
function(){return!this.is_paused&&!this.fresh&&!this.stopped&&!this.hasEnded()};x.prototype.setVolume=function(a){this.volume=a;this.updateVolume()};x.prototype.updateVolume=function(){var a=this.volume*X;switch(this.myapi){case R:this.instanceObject.volume&&this.instanceObject.volume!==a&&(this.instanceObject.volume=a);break;case G:this.gainNode.gain.value=a*this.mutevol}};x.prototype.getVolume=function(){return this.volume};x.prototype.doSetMuted=function(a){switch(this.myapi){case R:this.instanceObject.muted!==
!!a&&(this.instanceObject.muted=!!a);break;case G:this.mutevol=a?0:1,this.gainNode.gain.value=X*this.volume*this.mutevol}};x.prototype.setMuted=function(a){this.is_muted=!!a;this.doSetMuted(this.is_muted||this.is_silent)};x.prototype.setSilent=function(a){this.is_silent=!!a;this.doSetMuted(this.is_muted||this.is_silent)};x.prototype.setLooping=function(a){this.looping=a;switch(this.myapi){case R:this.instanceObject.loop!==!!a&&(this.instanceObject.loop=!!a);break;case G:this.instanceObject.loop!==
!!a&&(this.instanceObject.loop=!!a)}};x.prototype.setPlaybackRate=function(a){this.playbackRate=a;this.updatePlaybackRate()};x.prototype.updatePlaybackRate=function(){var a=this.playbackRate;if(1===fa&&!this.is_music||2===fa)a*=M.timescale;switch(this.myapi){case R:this.instanceObject.playbackRate!==a&&(this.instanceObject.playbackRate=a);break;case G:this.buffer.myapi===G?this.instanceObject.playbackRate.value!==a&&(this.instanceObject.playbackRate.value=a):this.instanceObject.playbackRate!==a&&
(this.instanceObject.playbackRate=a)}};x.prototype.setSuspended=function(a){switch(this.myapi){case R:a?this.isPlaying()?(this.instanceObject.pause(),this.resume_me=!0):this.resume_me=!1:this.resume_me&&this.instanceObject.play();break;case G:a?this.isPlaying()?(this.buffer.myapi===G?(this.resume_position=this.getPlaybackTime(),this.looping&&(this.resume_position%=this.getDuration()),h(this.instanceObject)):this.instanceObject.pause(),this.resume_me=!0):this.resume_me=!1:this.resume_me&&(this.buffer.myapi===
G?(this.instanceObject=I.createBufferSource(),this.instanceObject.buffer=this.buffer.bufferObject,this.instanceObject.connect(this.gainNode),this.instanceObject.loop=this.looping,this.gainNode.gain.value=X*this.volume*this.mutevol,this.startTime=M.kahanTime.sum-this.resume_position,g(this.instanceObject,this.resume_position,this.getDuration())):this.instanceObject.play());break;case U:a?this.isPlaying()?(this.instanceObject.pause(),this.resume_me=!0):this.resume_me=!1:this.resume_me&&this.instanceObject.play()}};
F.Instance=function(a){this.type=a;M=this.runtime=a.runtime;Q=this;this.listenerTracker=null;this.listenerZ=-600;I=null;"undefined"!==typeof AudioContext?(J=G,I=new AudioContext):"undefined"!==typeof webkitAudioContext&&(J=G,I=new webkitAudioContext);this.runtime.isiOS&&J===G&&document.addEventListener("touchstart",function(){if(!na){var a=I.createBuffer(1,1,22050),b=I.createBufferSource();b.buffer=a;b.connect(I.destination);f(b);na=!0}},!0);J!==G&&(this.runtime.isPhoneGap?J=U:this.runtime.isAppMobi&&
(J=aa));J===U&&(T=location.href,a=T.lastIndexOf("/"),-1<a&&(T=T.substr(0,a+1)),T=T.replace("file://",""));if(this.runtime.isSafari&&this.runtime.isWindows&&"undefined"===typeof Audio)alert("It looks like you're using Safari for Windows without Quicktime.  Audio cannot be played until Quicktime is installed."),this.runtime.DestroyInstance(this);else{if(this.runtime.isDirectCanvas)W=this.runtime.isAndroid;else try{W=!!(new Audio).canPlayType('audio/ogg; codecs="vorbis"')}catch(b){W=!1}this.runtime.tickMe(this)}};
var ba=F.Instance.prototype;ba.onCreate=function(){fa=this.properties[0];ha=this.properties[1];ia=this.properties[2];this.listenerZ=-this.properties[3];ka=this.properties[4];la=this.properties[5];ma=this.properties[6];this.listenerTracker=new C;J===G&&(I.listener.speedOfSound=this.properties[7],I.listener.dopplerFactor=this.properties[8],I.listener.setPosition(this.runtime.width/2,this.runtime.height/2,this.listenerZ),I.listener.setOrientation(0,0,1,0,-1,0),window.c2OnAudioMicStream=function(a,b){ca&&
ca.disconnect();ga=b.toLowerCase();ca=I.createMediaStreamSource(a);ca.connect(c(ga))});this.runtime.addSuspendCallback(function(a){Q.onSuspend(a)});var a=this;this.runtime.addDestroyCallback(function(b){a.onInstanceDestroyed(b)})};ba.onInstanceDestroyed=function(a){var b,c,d;b=0;for(c=L.length;b<c;b++)d=L[b],d.objectTracker&&d.objectTracker.obj===a&&(d.objectTracker.obj=null,d.pannerEnabled&&(d.isPlaying()&&d.looping)&&d.stop());this.listenerTracker.obj===a&&(this.listenerTracker.obj=null)};ba.saveToJSON=
function(){var a={silent:S,masterVolume:X,listenerZ:this.listenerZ,listenerUid:this.listenerTracker.hasObject()?this.listenerTracker.obj.uid:-1,playing:[],effects:{}},b=a.playing,c,d,e,h,f,k;c=0;for(d=L.length;c<d;c++)e=L[c],e.isPlaying()&&(h=e.getPlaybackTime(),e.looping&&(h%=e.getDuration()),h={tag:e.tag,buffersrc:e.buffer.src,is_music:e.is_music,playbackTime:h,volume:e.volume,looping:e.looping,muted:e.is_muted,playbackRate:e.playbackRate,paused:e.is_paused,resume_position:e.resume_position},e.pannerEnabled&&
(h.pan={},k=h.pan,e.objectTracker&&e.objectTracker.hasObject()?k.objUid=e.objectTracker.obj.uid:(k.x=e.panX,k.y=e.panY,k.a=e.panAngle),k.ia=e.panConeInner,k.oa=e.panConeOuter,k.og=e.panConeOuterGain),b.push(h));b=a.effects;for(f in N)if(N.hasOwnProperty(f)){e=[];c=0;for(d=N[f].length;c<d;c++)e.push({type:N[f][c].type,params:N[f][c].params});b[f]=e}return a};var ea=[];ba.loadFromJSON=function(a){var b=a.silent;X=a.masterVolume;this.listenerZ=a.listenerZ;this.listenerTracker.setObject(null);var c=a.listenerUid;
-1!==c&&(this.listenerTracker.loadUid=c,ea.push(this.listenerTracker));var c=a.playing,d,e,h,f,g,l,u,A,x,w,D;d=0;for(e=L.length;d<e;d++)L[d].stop();for(g in N)if(N.hasOwnProperty(g)){d=0;for(e=N[g].length;d<e;d++)N[g][d].remove()}cr.wipe(N);for(g in a.effects)if(a.effects.hasOwnProperty(g)){l=a.effects[g];d=0;for(e=l.length;d<e;d++)switch(h=l[d].type,w=l[d].params,h){case "filter":E(g,new k(w[0],w[1],w[2],w[3],w[4],w[5]));break;case "delay":E(g,new m(w[0],w[1],w[2]));break;case "convolve":h=w[2];
f=this.getAudioBuffer(h,!1);f.bufferObject?h=new n(f.bufferObject,w[0],w[1],h):(h=new n(null,w[0],w[1],h),f.normalizeWhenReady=w[0],f.convolveWhenReady=h);E(g,h);break;case "flanger":E(g,new q(w[0],w[1],w[2],w[3],w[4]));break;case "phaser":E(g,new p(w[0],w[1],w[2],w[3],w[4],w[5]));break;case "gain":E(g,new r(w[0]));break;case "tremolo":E(g,new s(w[0],w[1]));break;case "ringmod":E(g,new t(w[0],w[1]));break;case "distortion":E(g,new v(w[0],w[1],w[2],w[3],w[4]));break;case "compressor":E(g,new y(w[0],
w[1],w[2],w[3],w[4]));break;case "analyser":E(g,new z(w[0],w[1]))}}d=0;for(e=c.length;d<e;d++)a=c[d],h=a.buffersrc,f=a.is_music,g=a.tag,l=a.playbackTime,u=a.looping,A=a.volume,D=(w=a.pan)&&w.hasOwnProperty("objUid")?w.objUid:-1,(x=this.getAudioInstance(h,g,f,u,A))?(x.resume_position=a.resume_position,x.setPannerEnabled(!!w),x.play(u,A,l),x.updatePlaybackRate(),x.updateVolume(),x.doSetMuted(x.is_muted||x.is_silent),a.paused&&x.pause(),a.muted&&x.mute(),w&&(-1!==D?(x.objectTracker=x.objectTracker||
new C,x.objectTracker.loadUid=D,ea.push(x.objectTracker)):x.setPan(w.x,w.y,w.a,w.ia,w.oa,w.og))):(f=this.getAudioBuffer(h,f),f.seekWhenReady=l,f.pauseWhenReady=a.paused,w&&(-1!==D?f.panWhenReady.push({objUid:D,ia:w.ia,oa:w.oa,og:w.og,thistag:g}):f.panWhenReady.push({x:w.x,y:w.y,a:w.a,ia:w.ia,oa:w.oa,og:w.og,thistag:g})));if(b&&!S){d=0;for(e=L.length;d<e;d++)L[d].setSilent(!0);S=!0}else if(!b&&S){d=0;for(e=L.length;d<e;d++)L[d].setSilent(!1);S=!1}};ba.afterLoad=function(){var a,b,c,d;a=0;for(b=ea.length;a<
b;a++)c=ea[a],d=this.runtime.getObjectByUID(c.loadUid),c.setObject(d),c.loadUid=-1,d&&(Y=d.x,Z=d.y);ea.length=0};ba.onSuspend=function(a){var b,c;b=0;for(c=L.length;b<c;b++)L[b].setSuspended(a)};ba.tick=function(){var a=this.runtime.dt,b,c,d;b=0;for(c=L.length;b<c;b++)d=L[b],d.tick(a),d.myapi!==R&&d.myapi!==aa&&(!d.fresh&&!d.stopped&&d.hasEnded())&&(d.stopped=!0,V=d.tag,M.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded,Q)),0!==fa&&d.updatePlaybackRate();var e,h;for(e in N)if(N.hasOwnProperty(e)){d=
N[e];b=0;for(c=d.length;b<c;b++)h=d[b],h.tick&&h.tick()}J===G&&this.listenerTracker.hasObject()&&(this.listenerTracker.tick(a),Y=this.listenerTracker.obj.x,Z=this.listenerTracker.obj.y,I.listener.setPosition(this.listenerTracker.obj.x,this.listenerTracker.obj.y,this.listenerZ),I.listener.setVelocity(this.listenerTracker.getVelocityX(),this.listenerTracker.getVelocityY(),0))};ba.getAudioBuffer=function(a,b){var c,d,e,h=null,f,k,g,l;c=0;for(d=da.length;c<d;c++)if(e=da[c],e.src===a){h=e;break}h||(h=
new A(a,b),da.push(h));if(h.is_music&&M.isMobile){c=0;for(d=da.length;c<d;++c)if(e=da[c],e!==h&&e.is_music){e.bufferObject=null;k=f=0;for(g=L.length;f<g;++f)l=L[f],L[k]=l,l.buffer===e&&l.myapi===G?(l.gainNode.disconnect(),e.myapi===G&&l.instanceObject.disconnect()):++k;L.length=k}h.decodeAudioBuffer()}return h};ba.getAudioInstance=function(a,b,c,d,e){var h,f,k;h=0;for(f=L.length;h<f;h++)if(k=L[h],k.src===a&&(k.canBeRecycled()||c))return k.tag=b,k;a=this.getAudioBuffer(a,c);if(!a.bufferObject)return"<preload>"!==
b&&(a.playTagWhenReady=b,a.loopWhenReady=d,a.volumeWhenReady=e),null;k=new x(a,b);L.push(k);return k};var O=[];H.prototype.OnEnded=function(a){return cr.equals_nocase(V,a)};H.prototype.PreloadsComplete=function(){var a,b;a=0;for(b=da.length;a<b;a++)if(!da[a].isLoaded())return!1;return!0};H.prototype.AdvancedAudioSupported=function(){return J===G};H.prototype.IsSilent=function(){return S};H.prototype.IsAnyPlaying=function(){var a,b;a=0;for(b=L.length;a<b;a++)if(L[a].isPlaying())return!0;return!1};
H.prototype.IsTagPlaying=function(a){w(a);var b;a=0;for(b=O.length;a<b;a++)if(O[a].isPlaying())return!0;return!1};F.cnds=new H;u.prototype.Play=function(b,c,d,e){if(!S&&(d=a(d),P=this.getAudioInstance(this.runtime.files_subfolder+b[0]+(W?".ogg":".m4a"),e,b[1],0!==c,d)))P.setPannerEnabled(!1),P.play(0!==c,d)};u.prototype.PlayAtPosition=function(b,c,d,e,h,f,k,g,l,m){if(!S){d=a(d);var p=b[1];b=this.runtime.files_subfolder+b[0]+(W?".ogg":".m4a");(P=this.getAudioInstance(b,m,p,0!==c,d))?(P.setPannerEnabled(!0),
P.setPan(e,h,f,k,g,a(l)),P.play(0!==c,d)):this.getAudioBuffer(b,p).panWhenReady.push({x:e,y:h,a:f,ia:k,oa:g,og:a(l),thistag:m})}};u.prototype.PlayAtObject=function(b,c,d,e,h,f,k,g){if(!S&&e&&(e=e.getFirstPicked())){d=a(d);var l=b[1];b=this.runtime.files_subfolder+b[0]+(W?".ogg":".m4a");(P=this.getAudioInstance(b,g,l,0!==c,d))?(P.setPannerEnabled(!0),g=cr.rotatePtAround(e.x,e.y,-e.layer.getAngle(),Y,Z,!0),b=cr.rotatePtAround(e.x,e.y,-e.layer.getAngle(),Y,Z,!1),P.setPan(g,b,cr.to_degrees(e.angle-e.layer.getAngle()),
h,f,a(k)),P.setObject(e),P.play(0!==c,d)):this.getAudioBuffer(b,l).panWhenReady.push({obj:e,ia:h,oa:f,og:a(k),thistag:g})}};u.prototype.PlayByName=function(b,c,d,e,h){if(!S&&(e=a(e),b=1===b,c=this.runtime.files_subfolder+c.toLowerCase()+(W?".ogg":".m4a"),P=this.getAudioInstance(c,h,b,0!==d,e)))P.setPannerEnabled(!1),P.play(0!==d,e)};u.prototype.PlayAtPositionByName=function(b,c,d,e,h,f,k,g,l,m,p){S||(e=a(e),b=1===b,c=this.runtime.files_subfolder+c.toLowerCase()+(W?".ogg":".m4a"),(P=this.getAudioInstance(c,
p,b,0!==d,e))?(P.setPannerEnabled(!0),P.setPan(h,f,k,g,l,a(m)),P.play(0!==d,e)):this.getAudioBuffer(c,b).panWhenReady.push({x:h,y:f,a:k,ia:g,oa:l,og:a(m),thistag:p}))};u.prototype.PlayAtObjectByName=function(b,c,d,e,h,f,k,g,l){if(!S&&h&&(h=h.getFirstPicked()))e=a(e),b=1===b,c=this.runtime.files_subfolder+c.toLowerCase()+(W?".ogg":".m4a"),(P=this.getAudioInstance(c,l,b,0!==d,e))?(P.setPannerEnabled(!0),l=cr.rotatePtAround(h.x,h.y,-h.layer.getAngle(),Y,Z,!0),c=cr.rotatePtAround(h.x,h.y,-h.layer.getAngle(),
Y,Z,!1),P.setPan(l,c,cr.to_degrees(h.angle-h.layer.getAngle()),f,k,a(g)),P.setObject(h),P.play(0!==d,e)):this.getAudioBuffer(c,b).panWhenReady.push({obj:h,ia:f,oa:k,og:a(g),thistag:l})};u.prototype.SetLooping=function(a,b){w(a);var c,d;c=0;for(d=O.length;c<d;c++)O[c].setLooping(0===b)};u.prototype.SetMuted=function(a,b){w(a);var c,d;c=0;for(d=O.length;c<d;c++)O[c].setMuted(0===b)};u.prototype.SetVolume=function(b,c){w(b);var d=a(c),e,h;e=0;for(h=O.length;e<h;e++)O[e].setVolume(d)};u.prototype.Preload=
function(a){if(!S){var b=a[1];a=this.runtime.files_subfolder+a[0]+(W?".ogg":".m4a");J===aa?this.runtime.isDirectCanvas?AppMobi.context.loadSound(a):AppMobi.player.loadSound(a):J!==U&&this.getAudioInstance(a,"<preload>",b,!1)}};u.prototype.PreloadByName=function(a,b){if(!S){var c=1===a,d=this.runtime.files_subfolder+b.toLowerCase()+(W?".ogg":".m4a");J===aa?this.runtime.isDirectCanvas?AppMobi.context.loadSound(d):AppMobi.player.loadSound(d):J!==U&&this.getAudioInstance(d,"<preload>",c,!1)}};u.prototype.SetPlaybackRate=
function(a,b){w(a);0>b&&(b=0);var c,d;c=0;for(d=O.length;c<d;c++)O[c].setPlaybackRate(b)};u.prototype.Stop=function(a){w(a);var b;a=0;for(b=O.length;a<b;a++)O[a].stop()};u.prototype.StopAll=function(){var a,b;a=0;for(b=L.length;a<b;a++)L[a].stop()};u.prototype.SetPaused=function(a,b){w(a);var c,d;c=0;for(d=O.length;c<d;c++)0===b?O[c].pause():O[c].resume()};u.prototype.Seek=function(a,b){w(a);var c,d;c=0;for(d=O.length;c<d;c++)O[c].seek(b)};u.prototype.SetSilent=function(a){var b;2===a&&(a=S?1:0);
if(0===a&&!S){a=0;for(b=L.length;a<b;a++)L[a].setSilent(!0);S=!0}else if(1===a&&S){a=0;for(b=L.length;a<b;a++)L[a].setSilent(!1);S=!1}};u.prototype.SetMasterVolume=function(b){X=a(b);var c;b=0;for(c=L.length;b<c;b++)L[b].updateVolume()};u.prototype.AddFilterEffect=function(a,b,c,d,e,h,f){J!==G||(0>b||b>=ja.length)||(a=a.toLowerCase(),f/=100,0>f&&(f=0),1<f&&(f=1),E(a,new k(b,c,d,e,h,f)))};u.prototype.AddDelayEffect=function(b,c,d,e){J===G&&(b=b.toLowerCase(),e/=100,0>e&&(e=0),1<e&&(e=1),E(b,new m(c,
a(d),e)))};u.prototype.AddFlangerEffect=function(a,b,c,d,e,h){J===G&&(a=a.toLowerCase(),h/=100,0>h&&(h=0),1<h&&(h=1),E(a,new q(b/1E3,c/1E3,d,e/100,h)))};u.prototype.AddPhaserEffect=function(a,b,c,d,e,h,f){J===G&&(a=a.toLowerCase(),f/=100,0>f&&(f=0),1<f&&(f=1),E(a,new p(b,c,d,e,h,f)))};u.prototype.AddConvolutionEffect=function(a,b,c,d){if(J===G){c=0===c;var e=this.runtime.files_subfolder+b[0]+(W?".ogg":".m4a");b=this.getAudioBuffer(e,!1);a=a.toLowerCase();d/=100;0>d&&(d=0);1<d&&(d=1);b.bufferObject?
d=new n(b.bufferObject,c,d,e):(d=new n(null,c,d,e),b.normalizeWhenReady=c,b.convolveWhenReady=d);E(a,d)}};u.prototype.AddGainEffect=function(b,c){J===G&&(b=b.toLowerCase(),E(b,new r(a(c))))};u.prototype.AddMuteEffect=function(a){J===G&&(a=a.toLowerCase(),E(a,new r(0)))};u.prototype.AddTremoloEffect=function(a,b,c){J===G&&(a=a.toLowerCase(),c/=100,0>c&&(c=0),1<c&&(c=1),E(a,new s(b,c)))};u.prototype.AddRingModEffect=function(a,b,c){J===G&&(a=a.toLowerCase(),c/=100,0>c&&(c=0),1<c&&(c=1),E(a,new t(b,
c)))};u.prototype.AddDistortionEffect=function(a,b,c,d,e,h){J===G&&(a=a.toLowerCase(),h/=100,0>h&&(h=0),1<h&&(h=1),E(a,new v(b,c,d,e,h)))};u.prototype.AddCompressorEffect=function(a,b,c,d,e,h){J===G&&(a=a.toLowerCase(),E(a,new y(b,c,d,e/1E3,h/1E3)))};u.prototype.AddAnalyserEffect=function(a,b,c){J===G&&(a=a.toLowerCase(),E(a,new z(b,c)))};u.prototype.RemoveEffects=function(a){if(J===G){a=a.toLowerCase();var b,c,d;if(N.hasOwnProperty(a)&&(d=N[a],d.length)){b=0;for(c=d.length;b<c;b++)d[b].remove();
d.length=0;D(a)}}};u.prototype.SetEffectParameter=function(a,b,c,d,e,h){J===G&&(a=a.toLowerCase(),b=Math.floor(b),N.hasOwnProperty(a)&&(a=N[a],0>b||b>=a.length||a[b].setParam(c,d,e,h)))};u.prototype.SetListenerObject=function(a){if(a&&J===G&&(a=a.getFirstPicked()))this.listenerTracker.setObject(a),Y=a.x,Z=a.y};u.prototype.SetListenerZ=function(a){this.listenerZ=a};F.acts=new u;B.prototype.Duration=function(a,b){w(b);O.length?a.set_float(O[0].getDuration()):a.set_float(0)};B.prototype.PlaybackTime=
function(a,b){w(b);O.length?a.set_float(O[0].getPlaybackTime()):a.set_float(0)};B.prototype.Volume=function(a,c){w(c);if(O.length){var d=O[0].getVolume();a.set_float(b(d))}else a.set_float(0)};B.prototype.MasterVolume=function(a){a.set_float(X)};B.prototype.EffectCount=function(a,b){b=b.toLowerCase();var c=null;N.hasOwnProperty(b)&&(c=N[b]);a.set_int(c?c.length:0)};B.prototype.AnalyserFreqBinCount=function(a,b,c){b=b.toLowerCase();c=Math.floor(c);b=K(b,c);a.set_int(b?b.node.frequencyBinCount:0)};
B.prototype.AnalyserFreqBinAt=function(a,b,c,d){b=b.toLowerCase();c=Math.floor(c);d=Math.floor(d);(b=K(b,c))?0>d||d>=b.node.frequencyBinCount?a.set_float(0):a.set_float(b.freqBins[d]):a.set_float(0)};B.prototype.AnalyserPeakLevel=function(a,b,c){b=b.toLowerCase();c=Math.floor(c);(b=K(b,c))?a.set_float(b.peak):a.set_float(0)};B.prototype.AnalyserRMSLevel=function(a,b,c){b=b.toLowerCase();c=Math.floor(c);(b=K(b,c))?a.set_float(b.rms):a.set_float(0)};F.exps=new B})();
cr.plugins_.Browser=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){"undefined"!==typeof jQuery&&g.setSize(jQuery(window).width(),jQuery(window).height())}function d(){}var e=cr.plugins_.Browser.prototype;e.Type=function(a){this.plugin=a;this.runtime=a.runtime};e.Type.prototype.onCreate=function(){};e.Instance=function(a){this.type=a;this.runtime=a.runtime};e.Instance.prototype.onCreate=function(){var a=this;window.addEventListener("resize",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnResize,a)});
"undefined"!==typeof navigator.onLine&&(window.addEventListener("online",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOnline,a)}),window.addEventListener("offline",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOffline,a)}));"undefined"!==typeof window.applicationCache&&(window.applicationCache.addEventListener("updateready",function(){a.runtime.loadingprogress=1;a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady,a)}),window.applicationCache.addEventListener("progress",
function(b){a.runtime.loadingprogress=b.loaded/b.total}));this.runtime.isDirectCanvas||(document.addEventListener("appMobi.device.update.available",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady,a)}),document.addEventListener("menubutton",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton,a)}),document.addEventListener("searchbutton",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnSearchButton,a)}));this.runtime.addSuspendCallback(function(b){b?
a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageHidden,a):a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageVisible,a)});this.is_arcade="undefined"!==typeof window.is_scirra_arcade;this.fullscreenOldMarginCss=""};a.prototype.CookiesEnabled=function(){return navigator?navigator.cookieEnabled:!1};a.prototype.IsOnline=function(){return navigator?navigator.onLine:!1};a.prototype.HasJava=function(){return navigator?navigator.javaEnabled():!1};a.prototype.OnOnline=function(){return!0};
a.prototype.OnOffline=function(){return!0};a.prototype.IsDownloadingUpdate=function(){return"undefined"===typeof window.applicationCache?!1:window.applicationCache.status===window.applicationCache.DOWNLOADING};a.prototype.OnUpdateReady=function(){return!0};a.prototype.PageVisible=function(){return!this.runtime.isSuspended};a.prototype.OnPageVisible=function(){return!0};a.prototype.OnPageHidden=function(){return!0};a.prototype.OnResize=function(){return!0};a.prototype.IsFullscreen=function(){return!(!document.mozFullScreen&&
!document.webkitIsFullScreen&&!document.fullScreen&&!this.runtime.isNodeFullscreen)};a.prototype.OnMenuButton=function(){return!0};a.prototype.OnSearchButton=function(){return!0};a.prototype.IsMetered=function(){var a=navigator.connection||navigator.mozConnection||navigator.webkitConnection;return!a?!1:a.metered};a.prototype.IsCharging=function(){var a=navigator.battery||navigator.mozBattery||navigator.webkitBattery;return!a?!0:a.charging};a.prototype.IsPortraitLandscape=function(a){return(window.innerWidth<=
window.innerHeight?0:1)===a};e.cnds=new a;b.prototype.Alert=function(a){this.runtime.isDomFree||alert(a.toString())};b.prototype.Close=function(){this.runtime.isCocoonJs?CocoonJS.App.forceToFinish():!this.is_arcade&&!this.runtime.isDomFree&&window.close()};b.prototype.Focus=function(){this.runtime.isNodeWebkit?window.nwgui.Window.get().focus():!this.is_arcade&&!this.runtime.isDomFree&&window.focus()};b.prototype.Blur=function(){this.runtime.isNodeWebkit?window.nwgui.Window.get().blur():!this.is_arcade&&
!this.runtime.isDomFree&&window.blur()};b.prototype.GoBack=function(){!this.is_arcade&&(!this.runtime.isDomFree&&window.back)&&window.back()};b.prototype.GoForward=function(){!this.is_arcade&&(!this.runtime.isDomFree&&window.forward)&&window.forward()};b.prototype.GoHome=function(){!this.is_arcade&&(!this.runtime.isDomFree&&window.home)&&window.home()};b.prototype.GoToURL=function(a){this.runtime.isCocoonJs?CocoonJS.App.openURL(a):!this.is_arcade&&!this.runtime.isDomFree&&(window.location=a)};b.prototype.GoToURLWindow=
function(a,b){this.runtime.isCocoonJs?CocoonJS.App.openURL(a):!this.is_arcade&&!this.runtime.isDomFree&&window.open(a,b)};b.prototype.Reload=function(){!this.is_arcade&&!this.runtime.isDomFree&&window.location.reload()};var f=!0,g=null;b.prototype.RequestFullScreen=function(a){this.runtime.isDomFree?cr.logexport("[Construct 2] Requesting fullscreen is not supported on this platform - the request has been ignored"):(2<=a&&(a+=1),6===a&&(a=2),this.runtime.isNodeWebkit?this.runtime.isNodeFullscreen||
(window.nwgui.Window.get().enterFullscreen(),this.runtime.isNodeFullscreen=!0):!document.mozFullScreen&&(!document.webkitIsFullScreen&&!document.fullScreen)&&(this.fullscreenOldMarginCss=jQuery(this.runtime.canvasdiv).css("margin"),jQuery(this.runtime.canvasdiv).css("margin","0"),window.c2resizestretchmode=0<a?1:0,this.runtime.fullscreen_scaling=2<=a?a:0,a=this.runtime.canvasdiv||this.runtime.canvas,f&&(f=!1,g=this.runtime,a.addEventListener("mozfullscreenerror",c),a.addEventListener("webkitfullscreenerror",
c),a.addEventListener("msfullscreenerror",c),a.addEventListener("fullscreenerror",c)),cr.is_undefined(a.webkitRequestFullScreen)?cr.is_undefined(a.mozRequestFullScreen)?cr.is_undefined(a.requestFullscreen)||a.requestFullscreen():a.mozRequestFullScreen():"undefined"!==typeof Element&&"undefined"!==typeof Element.ALLOW_KEYBOARD_INPUT?a.webkitRequestFullScreen(Element.ALLOW_KEYBOARD_INPUT):a.webkitRequestFullScreen()))};b.prototype.CancelFullScreen=function(){this.runtime.isDomFree?cr.logexport("[Construct 2] Exiting fullscreen is not supported on this platform - the request has been ignored"):
this.runtime.isNodeWebkit?this.runtime.isNodeFullscreen&&(window.nwgui.Window.get().leaveFullscreen(),this.runtime.isNodeFullscreen=!1):(cr.is_undefined(document.webkitCancelFullScreen)||document.webkitCancelFullScreen(),cr.is_undefined(document.mozCancelFullScreen)||document.mozCancelFullScreen(),cr.is_undefined(document.exitFullscreen)||document.exitFullscreen(),jQuery(this.runtime.canvasdiv).css("margin",this.fullscreenOldMarginCss))};b.prototype.Vibrate=function(a){try{var b=a.split(","),c,d;
c=0;for(d=b.length;c<d;c++)b[c]=parseInt(b[c],10);navigator.vibrate?navigator.vibrate(b):navigator.mozVibrate?navigator.mozVibrate(b):navigator.webkitVibrate&&navigator.webkitVibrate(b)}catch(e){}};b.prototype.InvokeDownload=function(a,b){var c=document.createElement("a");if("undefined"===typeof c.download)window.open(a);else{var d=document.getElementsByTagName("body")[0];c.textContent=b;c.href=a;c.download=b;d.appendChild(c);var e=document.createEvent("MouseEvent");e.initMouseEvent("click",!0,!0,
window,0,0,0,0,0,!1,!1,!1,!1,0,null);c.dispatchEvent(e);d.removeChild(c)}};b.prototype.ConsoleLog=function(a,b){console&&(0===a&&console.log&&console.log(b),1===a&&console.warn&&console.warn(b),2===a&&console.error&&console.error(b))};b.prototype.ConsoleGroup=function(a){console&&console.group&&console.group(a)};b.prototype.ConsoleGroupEnd=function(){console&&console.groupEnd&&console.groupEnd()};b.prototype.ExecJs=function(a){eval&&eval(a)};e.acts=new b;d.prototype.URL=function(a){a.set_string(this.runtime.isDomFree?
"":window.location.toString())};d.prototype.Protocol=function(a){a.set_string(this.runtime.isDomFree?"":window.location.protocol)};d.prototype.Domain=function(a){a.set_string(this.runtime.isDomFree?"":window.location.hostname)};d.prototype.PathName=function(a){a.set_string(this.runtime.isDomFree?"":window.location.pathname)};d.prototype.Hash=function(a){a.set_string(this.runtime.isDomFree?"":window.location.hash)};d.prototype.Referrer=function(a){a.set_string(this.runtime.isDomFree?"":document.referrer)};
d.prototype.Title=function(a){a.set_string(this.runtime.isDomFree?"":document.title)};d.prototype.Name=function(a){a.set_string(this.runtime.isDomFree?"":navigator.appName)};d.prototype.Version=function(a){a.set_string(this.runtime.isDomFree?"":navigator.appVersion)};d.prototype.Language=function(a){navigator&&navigator.language?a.set_string(navigator.language):a.set_string("")};d.prototype.Platform=function(a){a.set_string(this.runtime.isDomFree?"":navigator.platform)};d.prototype.Product=function(a){navigator&&
navigator.product?a.set_string(navigator.product):a.set_string("")};d.prototype.Vendor=function(a){navigator&&navigator.vendor?a.set_string(navigator.vendor):a.set_string("")};d.prototype.UserAgent=function(a){a.set_string(this.runtime.isDomFree?"":navigator.userAgent)};d.prototype.QueryString=function(a){a.set_string(this.runtime.isDomFree?"":window.location.search)};d.prototype.QueryParam=function(a,b){if(this.runtime.isDomFree)a.set_string("");else{var c=RegExp("[?&]"+b+"=([^&]*)").exec(window.location.search);
c?a.set_string(decodeURIComponent(c[1].replace(/\+/g," "))):a.set_string("")}};d.prototype.Bandwidth=function(a){var b=navigator.connection||navigator.mozConnection||navigator.webkitConnection;b?a.set_float(b.bandwidth):a.set_float(Number.POSITIVE_INFINITY)};d.prototype.BatteryLevel=function(a){var b=navigator.battery||navigator.mozBattery||navigator.webkitBattery;b?a.set_float(b.level):a.set_float(1)};d.prototype.BatteryTimeLeft=function(a){var b=navigator.battery||navigator.mozBattery||navigator.webkitBattery;
b?a.set_float(b.dischargingTime):a.set_float(Number.POSITIVE_INFINITY)};d.prototype.ExecJS=function(a,b){if(eval){var c=eval(b);"number"===typeof c?a.set_any(c):"string"===typeof c?a.set_any(c):"boolean"===typeof c?a.set_any(c?1:0):a.set_any(0)}else a.set_any(0)};d.prototype.ScreenWidth=function(a){a.set_int(screen.width)};d.prototype.ScreenHeight=function(a){a.set_int(screen.height)};e.exps=new d})();cr.plugins_.Button=function(a){this.runtime=a};
(function(){function a(){}function b(){}var c=cr.plugins_.Button.prototype;c.Type=function(a){this.plugin=a;this.runtime=a.runtime};c.Type.prototype.onCreate=function(){};c.Instance=function(a){this.type=a;this.runtime=a.runtime};var d=c.Instance.prototype;d.onCreate=function(){this.runtime.isDomFree?cr.logexport("[Construct 2] Button plugin not supported on this platform - the object will not be created"):(this.isCheckbox=1===this.properties[0],this.inputElem=document.createElement("input"),this.elem=
this.isCheckbox?document.createElement("label"):this.inputElem,this.labelText=null,this.inputElem.type=this.isCheckbox?"checkbox":"button",this.inputElem.id=this.properties[6],jQuery(this.elem).appendTo(this.runtime.canvasdiv?this.runtime.canvasdiv:"body"),this.isCheckbox?(jQuery(this.inputElem).appendTo(this.elem),this.labelText=document.createTextNode(this.properties[1]),jQuery(this.elem).append(this.labelText),this.inputElem.checked=0!==this.properties[7],jQuery(this.elem).css("font-family","sans-serif"),
jQuery(this.elem).css("display","inline-block"),jQuery(this.elem).css("color","black")):this.inputElem.value=this.properties[1],this.elem.title=this.properties[2],this.inputElem.disabled=0===this.properties[4],this.autoFontSize=0!==this.properties[5],0===this.properties[3]&&(jQuery(this.elem).hide(),this.visible=!1),this.inputElem.onclick=function(a){return function(b){b.stopPropagation();a.runtime.trigger(cr.plugins_.Button.prototype.cnds.OnClicked,a)}}(this),this.elem.addEventListener("touchstart",
function(a){a.stopPropagation()},!1),this.elem.addEventListener("touchmove",function(a){a.stopPropagation()},!1),this.elem.addEventListener("touchend",function(a){a.stopPropagation()},!1),jQuery(this.elem).mousedown(function(a){a.stopPropagation()}),jQuery(this.elem).mouseup(function(a){a.stopPropagation()}),jQuery(this.elem).keydown(function(a){a.stopPropagation()}),jQuery(this.elem).keyup(function(a){a.stopPropagation()}),this.updatePosition(),this.runtime.tickMe(this))};d.saveToJSON=function(){var a=
{tooltip:this.elem.title,disabled:!!this.inputElem.disabled};this.isCheckbox?(a.checked=!!this.inputElem.checked,a.text=this.labelText.nodeValue):a.text=this.elem.value;return a};d.loadFromJSON=function(a){this.elem.title=a.tooltip;this.inputElem.disabled=a.disabled;this.isCheckbox?(this.inputElem.checked=a.checked,this.labelText.nodeValue=a.text):this.elem.value=a.text};d.onDestroy=function(){this.runtime.isDomFree||(jQuery(this.elem).remove(),this.elem=null)};d.tick=function(){this.updatePosition()};
d.updatePosition=function(){if(!this.runtime.isDomFree){var a=this.layer.layerToCanvas(this.x,this.y,!0),b=this.layer.layerToCanvas(this.x,this.y,!1),c=this.layer.layerToCanvas(this.x+this.width,this.y+this.height,!0),d=this.layer.layerToCanvas(this.x+this.width,this.y+this.height,!1);if(!this.visible||!this.layer.visible||0>=c||0>=d||a>=this.runtime.width||b>=this.runtime.height)jQuery(this.elem).hide();else{1>a&&(a=1);1>b&&(b=1);c>=this.runtime.width&&(c=this.runtime.width-1);d>=this.runtime.height&&
(d=this.runtime.height-1);jQuery(this.elem).show();var l=Math.round(a)+jQuery(this.runtime.canvas).offset().left,k=Math.round(b)+jQuery(this.runtime.canvas).offset().top;jQuery(this.elem).offset({left:l,top:k});jQuery(this.elem).width(Math.round(c-a));jQuery(this.elem).height(Math.round(d-b));this.autoFontSize&&jQuery(this.elem).css("font-size",this.layer.getScale()/this.runtime.devicePixelRatio-0.2+"em")}}};d.draw=function(a){};d.drawGL=function(a){};a.prototype.OnClicked=function(){return!0};a.prototype.IsChecked=
function(){return this.isCheckbox&&this.inputElem.checked};c.cnds=new a;b.prototype.SetText=function(a){this.runtime.isDomFree||(this.isCheckbox?this.labelText.nodeValue=a:this.elem.value=a)};b.prototype.SetTooltip=function(a){this.runtime.isDomFree||(this.elem.title=a)};b.prototype.SetVisible=function(a){this.runtime.isDomFree||(this.visible=0!==a)};b.prototype.SetEnabled=function(a){this.runtime.isDomFree||(this.inputElem.disabled=0===a)};b.prototype.SetFocus=function(){this.runtime.isDomFree||
this.inputElem.focus()};b.prototype.SetBlur=function(){this.runtime.isDomFree||this.inputElem.blur()};b.prototype.SetCSSStyle=function(a,b){this.runtime.isDomFree||jQuery(this.elem).css(a,b)};b.prototype.SetChecked=function(a){!this.runtime.isDomFree&&this.isCheckbox&&(this.inputElem.checked=1===a)};b.prototype.ToggleChecked=function(){!this.runtime.isDomFree&&this.isCheckbox&&(this.inputElem.checked=!this.inputElem.checked)};c.acts=new b;c.exps=new function(){}})();
cr.plugins_.CJSAds=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){}var d="",e=[],f=0,g=0,h=!1,l=!1,k=!1,m=cr.plugins_.CJSAds.prototype;m.Type=function(a){this.plugin=a;this.runtime=a.runtime};m.Type.prototype.onCreate=function(){};m.Instance=function(a){this.type=a;this.runtime=a.runtime};m.Instance.prototype.onCreate=function(){this.isShowingFullscreen=this.isShowingBanner=!1;this.triggerProduct="";this.socialService=null;this.socialServiceAvailable=!1;this.storeServiceAvailable=this.runtime.isCocoonJs&&"undefined"!==
typeof CocoonJS.Store.nativeExtensionObjectAvailable;this.storeManaged=1!==this.properties[1];this.storeSandboxed=0!==this.properties[2];this.onConsumePurchaseCompleted=this.onConsumePurchaseFailedTransactionId="";var a=this;this.runtime.isCocoonJs&&(CocoonJS.App.onTextDialogFinished.addEventListener(function(b){d=b;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardOK,a)}),CocoonJS.App.onTextDialogCancelled.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardCancelled,
a)}),CocoonJS.Ad.onBannerShown.addEventListener(function(){a.isShowingBanner=!0;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnBannerShown,a)}),CocoonJS.Ad.onBannerReady.addEventListener(function(){l=!0;h||(CocoonJS.Ad.setBannerLayout(g),CocoonJS.Ad.showBanner())}),CocoonJS.Ad.onFullScreenShown.addEventListener(function(){a.isShowingFullscreen=!0;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenShown,a)}),CocoonJS.Ad.onFullScreenHidden.addEventListener(function(){a.isShowingFullscreen=
!1;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenHidden,a)}),CocoonJS.Ad.onFullScreenReady.addEventListener(function(){k=!0;preloadFullScreen||CocoonJS.Ad.showFullScreen()}),this.storeServiceAvailable&&(CocoonJS.Store.onProductPurchaseCompleted.addEventListener(function(b){a.triggerProduct=b.productId;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete,a);CocoonJS.Store.addPurchase(b);CocoonJS.Store.consumePurchase(b.transactionId,b.productId);CocoonJS.Store.finishPurchase(b.transactionId)}),
CocoonJS.Store.onConsumePurchaseFailed.addEventListener(function(b,c){this.onConsumePurchaseFailedTransactionId=b;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseFailed,a)}),CocoonJS.Store.onConsumePurchaseCompleted.addEventListener(function(b){this.onConsumePurchaseCompleted=b;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseCompleted,a)}),CocoonJS.Store.onProductPurchaseFailed.addEventListener(function(b,c){a.triggerProduct=b;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail,
a)}),CocoonJS.Store.onProductPurchaseStarted.addEventListener(function(b){a.triggerProduct=b.productId;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseStart,a)}),CocoonJS.Store.onProductsFetchStarted.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchStarted,a)}),CocoonJS.Store.onProductsFetchFailed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchFailed,a)}),CocoonJS.Store.onProductsFetchCompleted.addEventListener(function(b){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchCompleted,
a)}),CocoonJS.Store.requestInitialization({managed:this.storeManaged,sandbox:this.storeSandboxed}),CocoonJS.Store.start()),this.socialService=CocoonJS.SocialGaming.GameCenter,this.socialServiceAvailable=!!this.socialService.nativeExtensionObjectAvailable,this.socialService.onRequestLoginSucceed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLoginSuccess,a)}),this.socialService.onRequestLoginFailed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLoginFail,
a)}),this.socialService.onLogout.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLogout,a)}),this.socialService.onRequestUserScoreSucceed.addEventListener(function(b){f=b.score||0;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreReceived,a)}),this.socialService.onRequestUserScoreFailed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreUnavailable,a)}),this.socialService.onSubmitUserScoreSucceed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreSubmitSuccess,
a)}),this.socialService.onSubmitUserScoreFailed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreSubmitFail,a)}),this.socialService.onLeaderboardViewSucceed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLeaderboardOpen,a)}),this.socialService.onLeaderboardViewClosed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLeaderboardClose,a)}))};a.prototype.IsShowingBanner=function(){return this.isShowingBanner};
a.prototype.IsCocoonJS=function(){return this.runtime.isCocoonJs};a.prototype.OnBannerShown=function(){return!0};a.prototype.OnFullscreenShown=function(){return!0};a.prototype.OnFullscreenHidden=function(){return!0};a.prototype.IsShowingFullscreen=function(){return this.isShowingFullscreen};a.prototype.IsStoreAvailable=function(){return this.runtime.isCocoonJs?this.storeServiceAvailable&&CocoonJS.Store.canPurchase():!1};a.prototype.OnPurchaseStart=function(a){return this.triggerProduct===a};a.prototype.OnPurchaseComplete=
function(a){return this.triggerProduct===a};a.prototype.OnPurchaseFail=function(a){return this.triggerProduct===a};a.prototype.onProductsFetchStarted=function(){return!0};a.prototype.onConsumePurchaseFailed=function(){return!0};a.prototype.onProductsFetchCompleted=function(){return!0};a.prototype.onProductsFetchFailed=function(){return!0};a.prototype.IsProductPurchased=function(a){return this.runtime.isCocoonJs?CocoonJS.Store.isProductPurchased(a):!1};a.prototype.OnKeyboardCancelled=function(){return!0};
a.prototype.OnKeyboardOK=function(){return!0};a.prototype.IsGCAvailable=function(){return this.socialServiceAvailable};a.prototype.IsGCLoggedIn=function(){return!this.socialServiceAvailable?!1:this.socialService.isLoggedIn()};a.prototype.OnGCLoginSuccess=function(){return!0};a.prototype.OnGCLoginFail=function(){return!0};a.prototype.OnGCLogout=function(){return!0};a.prototype.OnGCScoreReceived=function(){return!0};a.prototype.OnGCScoreUnavailable=function(){return!0};a.prototype.OnGCScoreSubmitSuccess=
function(){return!0};a.prototype.OnGCScoreSubmitFail=function(){return!0};a.prototype.OnGCLeaderboardOpen=function(){return!0};a.prototype.OnGCLeaderboardClose=function(){return!0};m.cnds=new a;b.prototype.ShowBanner=function(a){this.runtime.isCocoonJs&&(g=0===a?CocoonJS.Ad.BannerLayout.TOP_CENTER:CocoonJS.Ad.BannerLayout.BOTTOM_CENTER,h=!1,l?(CocoonJS.Ad.setBannerLayout(g),CocoonJS.Ad.showBanner()):CocoonJS.Ad.preloadBanner())};b.prototype.ShowFullscreen=function(){this.runtime.isCocoonJs&&(k?CocoonJS.Ad.showFullScreen():
CocoonJS.Ad.preloadFullScreen())};b.prototype.HideBanner=function(){this.runtime.isCocoonJs&&(CocoonJS.Ad.hideBanner(),this.isShowingBanner=!1)};b.prototype.PreloadBanner=function(){this.runtime.isCocoonJs&&(h=!0,CocoonJS.Ad.preloadBanner())};b.prototype.PreloadFullscreen=function(){this.runtime.isCocoonJs&&CocoonJS.Ad.preloadFullScreen()};b.prototype.RefreshBanner=function(){this.runtime.isCocoonJs&&CocoonJS.Ad.refreshBanner()};b.prototype.RefreshFullScreen=function(){this.runtime.isCocoonJs&&CocoonJS.Ad.refreshFullScreen()};
b.prototype.Purchase=function(a){this.runtime.isCocoonJs&&CocoonJS.Store.purchaseProduct(a)};b.prototype.fetchProductsFromStore=function(a){this.runtime.isCocoonJs&&CocoonJS.Store.fetchProductsFromStore(a.split(","))};b.prototype.restorePurchases=function(){if(this.runtime.isCocoonJs)return CocoonJS.Store.restorePurchases()};b.prototype.PurchasePreview=function(a){this.runtime.isCocoonJs&&CocoonJS.Store.purchaseProductModalWithPreview(a)};b.prototype.RestorePurchases=function(){this.runtime.isCocoonJs&&
CocoonJS.Store.restorePurchases()};b.prototype.PromptKeyboard=function(a,b,c,d,e,f){this.runtime.isCocoonJs&&CocoonJS.App.showTextDialog(a,b,c,["text","num","phone","email","url"][d],e,f)};b.prototype.UpdateProductsList=function(){this.runtime.isCocoonJs&&CocoonJS.Store.canPurchase()&&(e=CocoonJS.Store.getProducts())};b.prototype.GCLogin=function(){this.socialServiceAvailable&&!this.socialService.isLoggedIn()&&this.socialService.requestLogin()};b.prototype.GCLogout=function(){this.socialServiceAvailable&&
this.socialService.isLoggedIn()&&this.socialService.requestLogout()};b.prototype.GCSubmitScore=function(a,b){this.socialServiceAvailable&&this.socialService.isLoggedIn()&&this.socialService.submitUserScore(a,b)};b.prototype.GCRequestScore=function(a){this.socialServiceAvailable&&this.socialService.isLoggedIn()&&this.socialService.requestUserScore(a)};b.prototype.GCOpenLeaderboard=function(a){this.socialServiceAvailable&&this.socialService.isLoggedIn()&&this.socialService.showLeaderboardView(a)};m.acts=
new b;c.prototype.InputText=function(a){a.set_string(d)};c.prototype.ProductCount=function(a){a.set_int(e.length)};c.prototype.ProductDescription=function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].description)};c.prototype.ProductLocalizedPrice=function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].localizedPrice)};c.prototype.ProductPrice=function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].price)};c.prototype.ProductAlias=
function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].productAlias)};c.prototype.ProductID=function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].productId)};c.prototype.ProductTitle=function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].title)};c.prototype.GameCenterScore=function(a){a.set_float(f)};m.exps=new c})();cr.plugins_.Particles=function(a){this.runtime=a};
(function(){function a(a){this.owner=a;this.active=!1;this.angle=this.speed=this.y=this.x=0;this.opacity=1;this.age=this.gs=this.size=this.grow=0;cr.seal(this)}function b(){}function c(){}function d(){}var e=cr.plugins_.Particles.prototype;e.Type=function(a){this.plugin=a;this.runtime=a.runtime};var f=e.Type.prototype;f.onCreate=function(){this.is_family||(this.texture_img=new Image,this.texture_img.idtkLoadDisposed=!0,this.texture_img.src=this.texture_file,this.texture_img.cr_filesize=this.texture_filesize,
this.webGL_texture=null,this.runtime.wait_for_textures.push(this.texture_img))};f.onLostWebGLContext=function(){this.is_family||(this.webGL_texture=null)};f.onRestoreWebGLContext=function(){!this.is_family&&this.instances.length&&!this.webGL_texture&&(this.webGL_texture=this.runtime.glwrap.loadTexture(this.texture_img,!0,this.runtime.linearSampling,this.texture_pixelformat))};f.loadTextures=function(){!this.is_family&&(!this.webGL_texture&&this.runtime.glwrap)&&(this.webGL_texture=this.runtime.glwrap.loadTexture(this.texture_img,
!0,this.runtime.linearSampling,this.texture_pixelformat))};f.unloadTextures=function(){!this.is_family&&(!this.instances.length&&this.webGL_texture)&&(this.runtime.glwrap.deleteTexture(this.webGL_texture),this.webGL_texture=null)};f.preloadCanvas2D=function(a){a.drawImage(this.texture_img,0,0)};a.prototype.init=function(){var a=this.owner;this.x=a.x-a.xrandom/2+Math.random()*a.xrandom;this.y=a.y-a.yrandom/2+Math.random()*a.yrandom;this.speed=a.initspeed-a.speedrandom/2+Math.random()*a.speedrandom;
this.angle=a.angle-a.spraycone/2+Math.random()*a.spraycone;this.opacity=a.initopacity;this.size=a.initsize-a.sizerandom/2+Math.random()*a.sizerandom;this.grow=a.growrate-a.growrandom/2+Math.random()*a.growrandom;this.age=this.gs=0};a.prototype.tick=function(a){var b=this.owner;this.x+=Math.cos(this.angle)*this.speed*a;this.y+=Math.sin(this.angle)*this.speed*a;this.y+=this.gs*a;this.speed+=b.acc*a;this.size+=this.grow*a;this.gs+=b.g*a;this.age+=a;1>this.size?this.active=!1:(0!==b.lifeanglerandom&&
(this.angle+=Math.random()*b.lifeanglerandom*a-b.lifeanglerandom*a/2),0!==b.lifespeedrandom&&(this.speed+=Math.random()*b.lifespeedrandom*a-b.lifespeedrandom*a/2),0!==b.lifeopacityrandom&&(this.opacity+=Math.random()*b.lifeopacityrandom*a-b.lifeopacityrandom*a/2,0>this.opacity?this.opacity=0:1<this.opacity&&(this.opacity=1)),1>=b.destroymode&&this.age>=b.timeout&&(this.active=!1),2===b.destroymode&&0>=this.speed&&(this.active=!1))};a.prototype.draw=function(a){var b=this.owner.opacity*this.opacity;
if(0!==b){0===this.owner.destroymode&&(b*=1-this.age/this.owner.timeout);a.globalAlpha=b;var b=this.x-this.size/2,c=this.y-this.size/2;this.owner.runtime.pixel_rounding&&(b=b+0.5|0,c=c+0.5|0);a.drawImage(this.owner.type.texture_img,b,c,this.size,this.size)}};a.prototype.drawGL=function(a){var b=this.owner.opacity*this.opacity;0===this.owner.destroymode&&(b*=1-this.age/this.owner.timeout);var c=this.size,d=c*this.owner.particlescale,e=this.x-c/2,f=this.y-c/2;this.owner.runtime.pixel_rounding&&(e=e+
0.5|0,f=f+0.5|0);1>d||0===b||(d<a.minPointSize||d>a.maxPointSize?(a.setOpacity(b),a.quad(e,f,e+c,f,e+c,f+c,e,f+c)):a.point(this.x,this.y,d,b))};a.prototype.left=function(){return this.x-this.size/2};a.prototype.right=function(){return this.x+this.size/2};a.prototype.top=function(){return this.y-this.size/2};a.prototype.bottom=function(){return this.y+this.size/2};e.Instance=function(a){this.type=a;this.runtime=a.runtime};var f=e.Instance.prototype,g=[];f.onCreate=function(){var a=this.properties;
this.rate=a[0];this.spraycone=cr.to_radians(a[1]);this.spraytype=a[2];this.spraying=!0;this.initspeed=a[3];this.initsize=a[4];this.initopacity=a[5]/100;this.growrate=a[6];this.xrandom=a[7];this.yrandom=a[8];this.speedrandom=a[9];this.sizerandom=a[10];this.growrandom=a[11];this.acc=a[12];this.g=a[13];this.lifeanglerandom=a[14];this.lifespeedrandom=a[15];this.lifeopacityrandom=a[16];this.destroymode=a[17];this.timeout=a[18];this.particleCreateCounter=0;this.particlescale=1;this.particleBoxLeft=this.x;
this.particleBoxTop=this.y;this.particleBoxRight=this.x;this.particleBoxBottom=this.y;this.add_bbox_changed_callback(function(a){a.bbox.set(a.particleBoxLeft,a.particleBoxTop,a.particleBoxRight,a.particleBoxBottom);a.bquad.set_from_rect(a.bbox);a.bbox_changed=!1});this.recycled||(this.particles=[]);this.runtime.tickMe(this);this.type.loadTextures();if(1===this.spraytype)for(a=0;a<this.rate;a++)this.allocateParticle().opacity=0;this.first_tick=!0};f.saveToJSON=function(){var a={r:this.rate,sc:this.spraycone,
st:this.spraytype,s:this.spraying,isp:this.initspeed,isz:this.initsize,io:this.initopacity,gr:this.growrate,xr:this.xrandom,yr:this.yrandom,spr:this.speedrandom,szr:this.sizerandom,grnd:this.growrandom,acc:this.acc,g:this.g,lar:this.lifeanglerandom,lsr:this.lifespeedrandom,lor:this.lifeopacityrandom,dm:this.destroymode,to:this.timeout,pcc:this.particleCreateCounter,ft:this.first_tick,p:[]},b,c,d,e=a.p;b=0;for(c=this.particles.length;b<c;b++)d=this.particles[b],e.push([d.x,d.y,d.speed,d.angle,d.opacity,
d.grow,d.size,d.gs,d.age]);return a};f.loadFromJSON=function(a){this.rate=a.r;this.spraycone=a.sc;this.spraytype=a.st;this.spraying=a.s;this.initspeed=a.isp;this.initsize=a.isz;this.initopacity=a.io;this.growrate=a.gr;this.xrandom=a.xr;this.yrandom=a.yr;this.speedrandom=a.spr;this.sizerandom=a.szr;this.growrandom=a.grnd;this.acc=a.acc;this.g=a.g;this.lifeanglerandom=a.lar;this.lifespeedrandom=a.lsr;this.lifeopacityrandom=a.lor;this.destroymode=a.dm;this.timeout=a.to;this.particleCreateCounter=a.pcc;
this.first_tick=a.ft;g.push.apply(g,this.particles);this.particles.length=0;var b,c,d,e=a.p;a=0;for(b=e.length;a<b;a++)c=this.allocateParticle(),d=e[a],c.x=d[0],c.y=d[1],c.speed=d[2],c.angle=d[3],c.opacity=d[4],c.grow=d[5],c.size=d[6],c.gs=d[7],c.age=d[8]};f.onDestroy=function(){g.push.apply(g,this.particles);this.particles.length=0};f.allocateParticle=function(){var b;g.length?(b=g.pop(),b.owner=this):b=new a(this);this.particles.push(b);b.active=!0;return b};f.tick=function(){var a=this.runtime.getDt(this),
b,c,d,e;if(0===this.spraytype&&this.spraying){this.particleCreateCounter+=a*this.rate;c=cr.floor(this.particleCreateCounter);this.particleCreateCounter-=c;for(b=0;b<c;b++)d=this.allocateParticle(),d.init()}this.particleBoxLeft=this.x;this.particleBoxTop=this.y;this.particleBoxRight=this.x;this.particleBoxBottom=this.y;e=b=0;for(c=this.particles.length;b<c;b++)d=this.particles[b],this.particles[e]=d,this.runtime.redraw=!0,1===this.spraytype&&this.first_tick&&d.init(),d.tick(a),d.active?(d.left()<this.particleBoxLeft&&
(this.particleBoxLeft=d.left()),d.right()>this.particleBoxRight&&(this.particleBoxRight=d.right()),d.top()<this.particleBoxTop&&(this.particleBoxTop=d.top()),d.bottom()>this.particleBoxBottom&&(this.particleBoxBottom=d.bottom()),e++):g.push(d);this.particles.length=e;this.set_bbox_changed();this.first_tick=!1;1===this.spraytype&&0===this.particles.length&&this.runtime.DestroyInstance(this)};f.draw=function(a){var b,c,d,e=this.layer;b=0;for(c=this.particles.length;b<c;b++)d=this.particles[b],d.right()>=
e.viewLeft&&(d.bottom()>=e.viewTop&&d.left()<=e.viewRight&&d.top()<=e.viewBottom)&&d.draw(a)};f.drawGL=function(a){this.particlescale=this.layer.getScale();a.setTexture(this.type.webGL_texture);var b,c,d,e=this.layer;b=0;for(c=this.particles.length;b<c;b++)d=this.particles[b],d.right()>=e.viewLeft&&(d.bottom()>=e.viewTop&&d.left()<=e.viewRight&&d.top()<=e.viewBottom)&&d.drawGL(a)};b.prototype.IsSpraying=function(){return this.spraying};e.cnds=new b;c.prototype.SetSpraying=function(a){this.spraying=
0!==a};c.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);this.runtime.redraw=!0};c.prototype.SetRate=function(a){this.rate=a;var b;if(1===this.spraytype&&this.first_tick)if(a<this.particles.length){a=this.particles.length-a;for(b=0;b<a;b++)g.push(this.particles.pop())}else if(a>this.particles.length){a-=this.particles.length;for(b=0;b<a;b++)this.allocateParticle().opacity=0}};c.prototype.SetSprayCone=function(a){this.spraycone=cr.to_radians(a)};
c.prototype.SetInitSpeed=function(a){this.initspeed=a};c.prototype.SetInitSize=function(a){this.initsize=a};c.prototype.SetInitOpacity=function(a){this.initopacity=a/100};c.prototype.SetGrowRate=function(a){this.growrate=a};c.prototype.SetXRandomiser=function(a){this.xrandom=a};c.prototype.SetYRandomiser=function(a){this.yrandom=a};c.prototype.SetSpeedRandomiser=function(a){this.speedrandom=a};c.prototype.SetSizeRandomiser=function(a){this.sizerandom=a};c.prototype.SetGrowRateRandomiser=function(a){this.growrandom=
a};c.prototype.SetParticleAcc=function(a){this.acc=a};c.prototype.SetGravity=function(a){this.g=a};c.prototype.SetAngleRandomiser=function(a){this.lifeanglerandom=a};c.prototype.SetSpeedRandomiser=function(a){this.lifespeedrandom=a};c.prototype.SetOpacityRandomiser=function(a){this.lifeopacityrandom=a};c.prototype.SetTimeout=function(a){this.timeout=a};e.acts=new c;d.prototype.ParticleCount=function(a){a.set_int(this.particles.length)};d.prototype.Rate=function(a){a.set_float(this.rate)};d.prototype.SprayCone=
function(a){a.set_float(cr.to_degrees(this.spraycone))};d.prototype.InitSpeed=function(a){a.set_float(this.initspeed)};d.prototype.InitSize=function(a){a.set_float(this.initsize)};d.prototype.InitOpacity=function(a){a.set_float(100*this.initopacity)};d.prototype.InitGrowRate=function(a){a.set_float(this.growrate)};d.prototype.XRandom=function(a){a.set_float(this.xrandom)};d.prototype.YRandom=function(a){a.set_float(this.yrandom)};d.prototype.InitSpeedRandom=function(a){a.set_float(this.speedrandom)};
d.prototype.InitSizeRandom=function(a){a.set_float(this.sizerandom)};d.prototype.InitGrowRandom=function(a){a.set_float(this.growrandom)};d.prototype.ParticleAcceleration=function(a){a.set_float(this.acc)};d.prototype.Gravity=function(a){a.set_float(this.g)};d.prototype.ParticleAngleRandom=function(a){a.set_float(this.lifeanglerandom)};d.prototype.ParticleSpeedRandom=function(a){a.set_float(this.lifespeedrandom)};d.prototype.ParticleOpacityRandom=function(a){a.set_float(this.lifeopacityrandom)};d.prototype.Timeout=
function(a){a.set_float(this.timeout)};e.exps=new d})();cr.plugins_.Sprite=function(a){this.runtime=a};
(function(){function a(){if(0===this.datauri.length){var a=document.createElement("canvas");a.width=this.width;a.height=this.height;var b=a.getContext("2d");this.spritesheeted?b.drawImage(this.texture_img,this.offx,this.offy,this.width,this.height,0,0,this.width,this.height):b.drawImage(this.texture_img,0,0,this.width,this.height);this.datauri=a.toDataURL("image/png")}return this.datauri}function b(){}function c(a,b,c){var d;d=q.length?q.pop():[0,0];d[0]=b.uid;d[1]=c.uid;a.push(d)}function d(a,b,
c){b=b.uid;var d=c.uid,e=0,f,k;c=0;for(f=a.length;c<f;c++)k=a[c],k[0]===b&&k[1]===d||k[0]===d&&k[1]===b||(a[e][0]=a[c][0],a[e][1]=a[c][1],e++);for(c=e;c<f;c++)b=a[c],b[0]=0,b[1]=0,q.push(b);a.length=e}function e(a,b,c){b=b.uid;c=c.uid;var d,e,f;d=0;for(e=a.length;d<e;d++)if(f=a[d],f[0]===b&&f[1]===c||f[0]===c&&f[1]===b)return!0;return!1}function f(a,b,c){if(!a)return!1;var d=0!==b||0!==c,e,f,k=!1,h,g=this.runtime.getCurrentCondition(),l=g.type,g=g.inverted,m=a.getCurrentSol();h=this.runtime.getCurrentEventStack().current_event.orblock;
m=m.select_all?m.type.instances:h?m.else_instances:m.instances;p=a;s=l!==a&&!g;d&&(e=this.x,f=this.y,this.x+=b,this.y+=c,this.set_bbox_changed());b=0;for(c=m.length;b<c;b++)if(h=m[b],this.runtime.testOverlap(this,h)){k=!0;if(g)break;l!==a&&r.add(h)}d&&(this.x=e,this.y=f,this.set_bbox_changed());return k}function g(){}function h(){}var l=cr.plugins_.Sprite.prototype;l.Type=function(a){this.plugin=a;this.runtime=a.runtime};var k=l.Type.prototype;k.onCreate=function(){if(!this.is_family){var b,c,d,e,
f,k,h,g,l;this.all_frames=[];this.has_loaded_textures=!1;b=0;for(c=this.animations.length;b<c;b++){f=this.animations[b];h={};h.name=f[0];h.speed=f[1];h.loop=f[2];h.repeatcount=f[3];h.repeatto=f[4];h.pingpong=f[5];h.sid=f[6];h.frames=[];d=0;for(e=f[7].length;d<e;d++)k=f[7][d],g={},g.texture_file=k[0],g.texture_filesize=k[1],g.offx=k[2],g.offy=k[3],g.width=k[4],g.height=k[5],g.duration=k[6],g.hotspotX=k[7],g.hotspotY=k[8],g.image_points=k[9],g.poly_pts=k[10],g.pixelformat=k[11],g.spritesheeted=0!==
g.width,g.datauri="",g.getDataUri=a,l={left:0,top:0,right:1,bottom:1},g.sheetTex=l,g.webGL_texture=null,(l=this.runtime.findWaitingTexture(k[0]))?g.texture_img=l:(g.texture_img=new Image,g.texture_img.idtkLoadDisposed=!0,g.texture_img.src=k[0],g.texture_img.cr_src=k[0],g.texture_img.cr_filesize=k[1],g.texture_img.c2webGL_texture=null,this.runtime.wait_for_textures.push(g.texture_img)),cr.seal(g),h.frames.push(g),this.all_frames.push(g);cr.seal(h);this.animations[b]=h}}};k.updateAllCurrentTexture=
function(){var a,b,c;a=0;for(b=this.instances.length;a<b;a++)c=this.instances[a],c.curWebGLTexture=c.curFrame.webGL_texture};k.onLostWebGLContext=function(){if(!this.is_family){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],c.texture_img.c2webGL_texture=null,c.webGL_texture=null}};k.onRestoreWebGLContext=function(){if(!this.is_family&&this.instances.length){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],c.webGL_texture=this.runtime.glwrap.loadTexture(c.texture_img,
!1,this.runtime.linearSampling,c.pixelformat);this.updateAllCurrentTexture()}};k.loadTextures=function(){if(!this.is_family&&!this.has_loaded_textures&&this.runtime.glwrap){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],c.webGL_texture=this.runtime.glwrap.loadTexture(c.texture_img,!1,this.runtime.linearSampling,c.pixelformat);this.has_loaded_textures=!0}};k.unloadTextures=function(){if(!this.is_family&&!this.instances.length&&this.has_loaded_textures){var a,b,c;a=0;for(b=
this.all_frames.length;a<b;++a)c=this.all_frames[a],this.runtime.glwrap.deleteTexture(c.webGL_texture);this.has_loaded_textures=!1}};var m=[];k.preloadCanvas2D=function(a){var b,c,d;b=m.length=0;for(c=this.all_frames.length;b<c;++b)d=this.all_frames[b].texture_img,-1===m.indexOf(d)&&(a.drawImage(d,0,0),m.push(d))};l.Instance=function(a){this.type=a;this.runtime=a.runtime;a=this.type.animations[0].frames[0].poly_pts;this.recycled?this.collision_poly.set_pts(a):this.collision_poly=new cr.CollisionPoly(a)};
var n=l.Instance.prototype;n.onCreate=function(){this.visible=0===this.properties[0];this.inAnimTrigger=this.isTicking=!1;this.collisionsEnabled=0!==this.properties[3];!(1===this.type.animations.length&&1===this.type.animations[0].frames.length)&&0!==this.type.animations[0].speed&&(this.runtime.tickMe(this),this.isTicking=!0);this.cur_animation=this.getAnimationByName(this.properties[1])||this.type.animations[0];this.cur_frame=this.properties[2];0>this.cur_frame&&(this.cur_frame=0);this.cur_frame>=
this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1);var a=this.cur_animation.frames[this.cur_frame];this.collision_poly.set_pts(a.poly_pts);this.hotspotX=a.hotspotX;this.hotspotY=a.hotspotY;this.cur_anim_speed=this.cur_animation.speed;this.recycled?this.animTimer.reset():this.animTimer=new cr.KahanAdder;this.frameStart=this.getNowTime();this.animPlaying=!0;this.animRepeats=0;this.animForwards=!0;this.changeAnimName=this.animTriggerName="";this.changeAnimFrom=0;this.changeAnimFrame=
-1;this.type.loadTextures();var b,c,d,e,f,k,h,a=0;for(b=this.type.animations.length;a<b;a++){e=this.type.animations[a];c=0;for(d=e.frames.length;c<d;c++)f=e.frames[c],0===f.width&&(f.width=f.texture_img.width,f.height=f.texture_img.height),f.spritesheeted&&(h=f.texture_img,k=f.sheetTex,k.left=f.offx/h.width,k.top=f.offy/h.height,k.right=(f.offx+f.width)/h.width,k.bottom=(f.offy+f.height)/h.height,0===f.offx&&(0===f.offy&&f.width===h.width&&f.height===h.height)&&(f.spritesheeted=!1))}this.curFrame=
this.cur_animation.frames[this.cur_frame];this.curWebGLTexture=this.curFrame.webGL_texture};n.saveToJSON=function(){var a={a:this.cur_animation.sid,f:this.cur_frame,cas:this.cur_anim_speed,fs:this.frameStart,ar:this.animRepeats,at:this.animTimer.sum};this.animPlaying||(a.ap=this.animPlaying);this.animForwards||(a.af=this.animForwards);return a};n.loadFromJSON=function(a){var b=this.getAnimationBySid(a.a);b&&(this.cur_animation=b);this.cur_frame=a.f;0>this.cur_frame&&(this.cur_frame=0);this.cur_frame>=
this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1);this.cur_anim_speed=a.cas;this.frameStart=a.fs;this.animRepeats=a.ar;this.animTimer.reset();this.animTimer.sum=a.at;this.animPlaying=a.hasOwnProperty("ap")?a.ap:!0;this.animForwards=a.hasOwnProperty("af")?a.af:!0;this.curFrame=this.cur_animation.frames[this.cur_frame];this.curWebGLTexture=this.curFrame.webGL_texture;this.collision_poly.set_pts(this.curFrame.poly_pts);this.hotspotX=this.curFrame.hotspotX;this.hotspotY=
this.curFrame.hotspotY};n.animationFinish=function(a){this.cur_frame=a?0:this.cur_animation.frames.length-1;this.animPlaying=!1;this.animTriggerName=this.cur_animation.name;this.inAnimTrigger=!0;this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,this);this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,this);this.inAnimTrigger=!1;this.animRepeats=0};n.getNowTime=function(){return this.animTimer.sum};n.tick=function(){this.animTimer.add(this.runtime.getDt(this));
this.changeAnimName.length&&this.doChangeAnim();0<=this.changeAnimFrame&&this.doChangeAnimFrame();var a=this.getNowTime(),b=this.cur_animation,c=b.frames[this.cur_frame],d=c.duration/this.cur_anim_speed;this.animPlaying&&a>=this.frameStart+d&&(this.animForwards?this.cur_frame++:this.cur_frame--,this.frameStart+=d,this.cur_frame>=b.frames.length&&(b.pingpong?(this.animForwards=!1,this.cur_frame=b.frames.length-2):b.loop?this.cur_frame=b.repeatto:(this.animRepeats++,this.animRepeats>=b.repeatcount?
this.animationFinish(!1):this.cur_frame=b.repeatto)),0>this.cur_frame&&(b.pingpong?(this.cur_frame=1,this.animForwards=!0,b.loop||(this.animRepeats++,this.animRepeats>=b.repeatcount&&this.animationFinish(!0))):b.loop?this.cur_frame=b.repeatto:(this.animRepeats++,this.animRepeats>=b.repeatcount?this.animationFinish(!0):this.cur_frame=b.repeatto)),0>this.cur_frame?this.cur_frame=0:this.cur_frame>=b.frames.length&&(this.cur_frame=b.frames.length-1),a>this.frameStart+b.frames[this.cur_frame].duration/
this.cur_anim_speed&&(this.frameStart=a),a=b.frames[this.cur_frame],this.OnFrameChanged(c,a),this.runtime.redraw=!0)};n.getAnimationByName=function(a){var b,c,d;b=0;for(c=this.type.animations.length;b<c;b++)if(d=this.type.animations[b],cr.equals_nocase(d.name,a))return d;return null};n.getAnimationBySid=function(a){var b,c,d;b=0;for(c=this.type.animations.length;b<c;b++)if(d=this.type.animations[b],d.sid===a)return d;return null};n.doChangeAnim=function(){var a=this.cur_animation.frames[this.cur_frame],
b=this.getAnimationByName(this.changeAnimName);this.changeAnimName="";if(b&&(!cr.equals_nocase(b.name,this.cur_animation.name)||!this.animPlaying))this.cur_animation=b,this.cur_anim_speed=b.speed,0>this.cur_frame&&(this.cur_frame=0),this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1),1===this.changeAnimFrom&&(this.cur_frame=0),this.animPlaying=!0,this.frameStart=this.getNowTime(),this.animForwards=!0,this.OnFrameChanged(a,this.cur_animation.frames[this.cur_frame]),
this.runtime.redraw=!0};n.doChangeAnimFrame=function(){var a=this.cur_animation.frames[this.cur_frame],b=this.cur_frame;this.cur_frame=cr.floor(this.changeAnimFrame);0>this.cur_frame&&(this.cur_frame=0);this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1);b!==this.cur_frame&&(this.OnFrameChanged(a,this.cur_animation.frames[this.cur_frame]),this.frameStart=this.getNowTime(),this.runtime.redraw=!0);this.changeAnimFrame=-1};n.OnFrameChanged=function(a,
b){var c=a.width,d=a.height,e=b.width,f=b.height;c!=e&&(this.width*=e/c);d!=f&&(this.height*=f/d);this.hotspotX=b.hotspotX;this.hotspotY=b.hotspotY;this.collision_poly.set_pts(b.poly_pts);this.set_bbox_changed();this.curFrame=b;this.curWebGLTexture=b.webGL_texture;c=0;for(d=this.behavior_insts.length;c<d;c++)if(e=this.behavior_insts[c],e.onSpriteFrameChanged)e.onSpriteFrameChanged(a,b);this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnFrameChanged,this)};n.draw=function(a){a.globalAlpha=this.opacity;
var b=this.curFrame,c=b.spritesheeted,d=b.texture_img,e=this.x,f=this.y,k=this.width,h=this.height;if(0===this.angle&&0<=k&&0<=h)e-=this.hotspotX*k,f-=this.hotspotY*h,this.runtime.pixel_rounding&&(e=e+0.5|0,f=f+0.5|0),c?a.drawImage(d,b.offx,b.offy,b.width,b.height,e,f,k,h):a.drawImage(d,e,f,k,h);else{this.runtime.pixel_rounding&&(e=e+0.5|0,f=f+0.5|0);a.save();var g=0<k?1:-1,l=0<h?1:-1;a.translate(e,f);(1!==g||1!==l)&&a.scale(g,l);a.rotate(this.angle*g*l);e=0-this.hotspotX*cr.abs(k);f=0-this.hotspotY*
cr.abs(h);c?a.drawImage(d,b.offx,b.offy,b.width,b.height,e,f,cr.abs(k),cr.abs(h)):a.drawImage(d,e,f,cr.abs(k),cr.abs(h));a.restore()}};n.drawGL=function(a){a.setTexture(this.curWebGLTexture);a.setOpacity(this.opacity);var b=this.curFrame,c=this.bquad;if(this.runtime.pixel_rounding){var d=(this.x+0.5|0)-this.x,e=(this.y+0.5|0)-this.y;b.spritesheeted?a.quadTex(c.tlx+d,c.tly+e,c.trx+d,c.try_+e,c.brx+d,c.bry+e,c.blx+d,c.bly+e,b.sheetTex):a.quad(c.tlx+d,c.tly+e,c.trx+d,c.try_+e,c.brx+d,c.bry+e,c.blx+d,
c.bly+e)}else b.spritesheeted?a.quadTex(c.tlx,c.tly,c.trx,c.try_,c.brx,c.bry,c.blx,c.bly,b.sheetTex):a.quad(c.tlx,c.tly,c.trx,c.try_,c.brx,c.bry,c.blx,c.bly)};n.getImagePointIndexByName=function(a){var b=this.curFrame,c,d;c=0;for(d=b.image_points.length;c<d;c++)if(cr.equals_nocase(a,b.image_points[c][0]))return c;return-1};n.getImagePoint=function(a,b){var c=this.curFrame,d=c.image_points,e;e=cr.is_string(a)?this.getImagePointIndexByName(a):a-1;e=cr.floor(e);if(0>e||e>=d.length)return b?this.x:this.y;
var f=(d[e][1]-c.hotspotX)*this.width,d=d[e][2],d=(d-c.hotspotY)*this.height,c=Math.cos(this.angle);e=Math.sin(this.angle);var k=f*c-d*e,d=d*c+f*e,f=k+this.x,d=d+this.y;return b?f:d};var q=[];b.prototype.OnCollision=function(a){if(!a)return!1;var b=this.runtime,f=b.getCurrentCondition(),k=f.type;f.extra.collmemory||(f.extra.collmemory=[],b.addDestroyCallback(function(a){return function(b){var c=0,d,e,f=b.uid;b=0;for(d=a.length;b<d;b++)e=a[b],e[0]!==f&&e[1]!==f&&(a[c][0]=a[b][0],a[c][1]=a[b][1],c++);
for(b=c;b<d;b++)e=a[b],e[0]=0,e[1]=0,q.push(e);a.length=c}}(f.extra.collmemory)));var h=k.getCurrentSol(),g=a.getCurrentSol(),h=h.getObjects(),g=g.getObjects(),l,m,p,n,r,s,B=b.getCurrentEventStack().current_event;for(l=0;l<h.length;l++){m=h[l];for(p=0;p<g.length;p++)n=g[p],b.testOverlap(m,n)||b.checkRegisteredCollision(m,n)?e(f.extra.collmemory,m,n)||(c(f.extra.collmemory,m,n),b.pushCopySol(B.solModifiers),r=k.getCurrentSol(),s=a.getCurrentSol(),r.select_all=!1,s.select_all=!1,k===a?(r.instances.length=
2,r.instances[0]=m,r.instances[1]=n,k.applySolToContainer()):(r.instances.length=1,s.instances.length=1,r.instances[0]=m,s.instances[0]=n,k.applySolToContainer(),a.applySolToContainer()),B.retrigger(),b.popSol(B.solModifiers)):d(f.extra.collmemory,m,n)}return!1};var p=null,r=new cr.ObjectSet,s=!1;k.finish=function(a){if(s){if(a){var b=this.runtime.getCurrentEventStack().current_event.orblock;a=p.getCurrentSol();var c=r.valuesRef(),d,e;if(a.select_all){a.select_all=!1;a.instances.length=c.length;d=
0;for(e=c.length;d<e;d++)a.instances[d]=c[d];if(b){d=a.else_instances.length=0;for(e=p.instances.length;d<e;d++)b=p.instances[d],r.contains(b)||a.else_instances.push(b)}}else{var f=a.instances.length;a.instances.length=f+c.length;d=0;for(e=c.length;d<e;d++)a.instances[f+d]=c[d],b&&cr.arrayFindRemove(a.else_instances,c[d])}p.applySolToContainer()}r.clear();s=!1}};b.prototype.IsOverlapping=function(a){return f.call(this,a,0,0)};b.prototype.IsOverlappingOffset=function(a,b,c){return f.call(this,a,b,
c)};b.prototype.IsAnimPlaying=function(a){return this.changeAnimName.length?cr.equals_nocase(this.changeAnimName,a):cr.equals_nocase(this.cur_animation.name,a)};b.prototype.CompareFrame=function(a,b){return cr.do_cmp(this.cur_frame,a,b)};b.prototype.OnAnimFinished=function(a){return cr.equals_nocase(this.animTriggerName,a)};b.prototype.OnAnyAnimFinished=function(){return!0};b.prototype.OnFrameChanged=function(){return!0};b.prototype.IsMirrored=function(){return 0>this.width};b.prototype.IsFlipped=
function(){return 0>this.height};b.prototype.OnURLLoaded=function(){return!0};b.prototype.IsCollisionEnabled=function(){return this.collisionsEnabled};l.cnds=new b;g.prototype.Spawn=function(a,b,c){if(a&&b&&(b=this.runtime.createInstance(a,b,this.getImagePoint(c,!0),this.getImagePoint(c,!1)))){"undefined"!==typeof b.angle&&(b.angle=this.angle,b.set_bbox_changed());this.runtime.isInOnDestroy++;var d,e,f;this.runtime.trigger(Object.getPrototypeOf(a.plugin).cnds.OnCreated,b);if(b.is_contained){d=0;for(e=
b.siblings.length;d<e;d++)f=b.siblings[d],this.runtime.trigger(Object.getPrototypeOf(f.type.plugin).cnds.OnCreated,f)}this.runtime.isInOnDestroy--;d=this.runtime.getCurrentAction();c=!1;if(cr.is_undefined(d.extra.Spawn_LastExec)||d.extra.Spawn_LastExec<this.runtime.execcount)c=!0,d.extra.Spawn_LastExec=this.runtime.execcount;if(a!=this.type&&(a=a.getCurrentSol(),a.select_all=!1,c?(a.instances.length=1,a.instances[0]=b):a.instances.push(b),b.is_contained)){d=0;for(e=b.siblings.length;d<e;d++)f=b.siblings[d],
a=f.type.getCurrentSol(),a.select_all=!1,c?(a.instances.length=1,a.instances[0]=f):a.instances.push(f)}}};g.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);this.runtime.redraw=!0};g.prototype.StopAnim=function(){this.animPlaying=!1};g.prototype.StartAnim=function(a){this.animPlaying=!0;this.frameStart=this.getNowTime();1===a&&0!==this.cur_frame&&(this.changeAnimFrame=0,this.inAnimTrigger||this.doChangeAnimFrame());this.isTicking||(this.runtime.tickMe(this),
this.isTicking=!0)};g.prototype.SetAnim=function(a,b){this.changeAnimName=a;this.changeAnimFrom=b;this.isTicking||(this.runtime.tickMe(this),this.isTicking=!0);this.inAnimTrigger||this.doChangeAnim()};g.prototype.SetAnimFrame=function(a){this.changeAnimFrame=a;this.isTicking||(this.runtime.tickMe(this),this.isTicking=!0);this.inAnimTrigger||this.doChangeAnimFrame()};g.prototype.SetAnimSpeed=function(a){this.cur_anim_speed=cr.abs(a);this.animForwards=0<=a;this.isTicking||(this.runtime.tickMe(this),
this.isTicking=!0)};g.prototype.SetMirrored=function(a){a=cr.abs(this.width)*(0===a?-1:1);this.width!==a&&(this.width=a,this.set_bbox_changed())};g.prototype.SetFlipped=function(a){a=cr.abs(this.height)*(0===a?-1:1);this.height!==a&&(this.height=a,this.set_bbox_changed())};g.prototype.SetScale=function(a){var b=this.curFrame,c=b.width*a*(0>this.width?-1:1);a=b.height*a*(0>this.height?-1:1);if(this.width!==c||this.height!==a)this.width=c,this.height=a,this.set_bbox_changed()};g.prototype.LoadURL=function(a,
b){var c=new Image,d=this,e=this.curFrame;c.onload=function(){e.texture_img.src===c.src?d.runtime.glwrap&&d.curFrame===e&&(d.curWebGLTexture=e.webGL_texture):(e.texture_img=c,e.offx=0,e.offy=0,e.width=c.width,e.height=c.height,e.spritesheeted=!1,e.datauri="",d.runtime.glwrap&&(e.webGL_texture&&d.runtime.glwrap.deleteTexture(e.webGL_texture),e.webGL_texture=d.runtime.glwrap.loadTexture(c,!1,d.runtime.linearSampling),d.curFrame===e&&(d.curWebGLTexture=e.webGL_texture),d.type.updateAllCurrentTexture()),
0===b&&(d.width=c.width,d.height=c.height,d.set_bbox_changed()));d.runtime.redraw=!0;d.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnURLLoaded,d)};"data:"!==a.substr(0,5)&&(c.crossOrigin="anonymous");c.src=a};g.prototype.SetCollisions=function(a){this.collisionsEnabled=0!==a};l.acts=new g;h.prototype.AnimationFrame=function(a){a.set_int(this.cur_frame)};h.prototype.AnimationFrameCount=function(a){a.set_int(this.cur_animation.frames.length)};h.prototype.AnimationName=function(a){a.set_string(this.cur_animation.name)};
h.prototype.AnimationSpeed=function(a){a.set_float(this.cur_anim_speed)};h.prototype.ImagePointX=function(a,b){a.set_float(this.getImagePoint(b,!0))};h.prototype.ImagePointY=function(a,b){a.set_float(this.getImagePoint(b,!1))};h.prototype.ImagePointCount=function(a){a.set_int(this.curFrame.image_points.length)};h.prototype.ImageWidth=function(a){a.set_float(this.curFrame.width)};h.prototype.ImageHeight=function(a){a.set_float(this.curFrame.height)};l.exps=new h})();
cr.plugins_.Text=function(a){this.runtime=a};
(function(){function a(){return k.length?k.pop():{}}function b(a){var b,c;b=0;for(c=a.length;b<c;b++)k.push(a[b]);a.length=0}function c(){}function d(){}function e(){}var f=cr.plugins_.Text.prototype;f.onCreate=function(){f.acts.SetWidth=function(a){this.width!==a&&(this.width=a,this.text_changed=!0,this.set_bbox_changed())}};f.Type=function(a){this.plugin=a;this.runtime=a.runtime};var g=f.Type.prototype;g.onCreate=function(){};g.onLostWebGLContext=function(){if(!this.is_family){var a,b,c;a=0;for(b=
this.instances.length;a<b;a++)c=this.instances[a],c.mycanvas=null,c.myctx=null,c.mytex=null}};f.Instance=function(a){this.type=a;this.runtime=a.runtime;this.recycled?this.lines.length=0:this.lines=[];this.text_changed=!0};var g=f.Instance.prototype,h={};g.onCreate=function(){this.text=this.properties[0];this.visible=0===this.properties[1];this.font=this.properties[2];this.color=this.properties[3];this.halign=this.properties[4];this.valign=this.properties[5];this.wrapbyword=0===this.properties[7];
this.lastwrapwidth=this.lastwidth=this.width;this.lastheight=this.height;this.line_height_offset=this.properties[8];this.fontstyle=this.facename="";this.textHeight=this.textWidth=this.ptSize=0;this.parseFont();this.mytex=this.myctx=this.mycanvas=null;this.need_text_redraw=!1;this.last_render_tick=this.runtime.tickcount;this.recycled?this.rcTex.set(0,0,1,1):this.rcTex=new cr.rect(0,0,1,1);this.runtime.glwrap&&this.runtime.tickMe(this)};g.parseFont=function(){var a=this.font.split(" "),b;for(b=0;b<
a.length;b++)if("pt"===a[b].substr(a[b].length-2,2)){this.ptSize=parseInt(a[b].substr(0,a[b].length-2));this.pxHeight=Math.ceil(96*(this.ptSize/72))+4;0<b&&(this.fontstyle=a[b-1]);this.facename=a[b+1];for(b+=2;b<a.length;b++)this.facename+=" "+a[b];break}};g.saveToJSON=function(){return{t:this.text,f:this.font,c:this.color,ha:this.halign,va:this.valign,wr:this.wrapbyword,lho:this.line_height_offset,fn:this.facename,fs:this.fontstyle,ps:this.ptSize,pxh:this.pxHeight,tw:this.textWidth,th:this.textHeight,
lrt:this.last_render_tick}};g.loadFromJSON=function(a){this.text=a.t;this.font=a.f;this.color=a.c;this.halign=a.ha;this.valign=a.va;this.wrapbyword=a.wr;this.line_height_offset=a.lho;this.facename=a.fn;this.fontstyle=a.fs;this.ptSize=a.ps;this.pxHeight=a.pxh;this.textWidth=a.tw;this.textHeight=a.th;this.last_render_tick=a.lrt;this.text_changed=!0;this.lastwrapwidth=this.lastwidth=this.width;this.lastheight=this.height};g.tick=function(){if(this.runtime.glwrap&&this.mytex&&300<=this.runtime.tickcount-
this.last_render_tick){var a=this.layer;this.update_bbox();var b=this.bbox;if(b.right<a.viewLeft||b.bottom<a.viewTop||b.left>a.viewRight||b.top>a.viewBottom)this.runtime.glwrap.deleteTexture(this.mytex),this.mycanvas=this.myctx=this.mytex=null}};g.onDestroy=function(){this.mycanvas=this.myctx=null;this.runtime.glwrap&&this.mytex&&this.runtime.glwrap.deleteTexture(this.mytex);this.mytex=null};g.updateFont=function(){this.font=this.fontstyle+" "+this.ptSize.toString()+"pt "+this.facename;this.text_changed=
!0;this.runtime.redraw=!0};g.draw=function(a,b){a.font=this.font;a.textBaseline="top";a.fillStyle=this.color;a.globalAlpha=b?1:this.opacity;var c=1;b&&(c=this.layer.getScale(),a.save(),a.scale(c,c));if(this.text_changed||this.width!==this.lastwrapwidth)this.type.plugin.WordWrap(this.text,this.lines,a,this.width,this.wrapbyword),this.text_changed=!1,this.lastwrapwidth=this.width;this.update_bbox();var c=b?0:this.bquad.tlx,d=b?0:this.bquad.tly;this.runtime.pixel_rounding&&(c=c+0.5|0,d=d+0.5|0);0!==
this.angle&&!b&&(a.save(),a.translate(c,d),a.rotate(this.angle),d=c=0);var e=d+this.height,f=this.pxHeight,f=f+this.line_height_offset*this.runtime.devicePixelRatio,k,h;1===this.valign?d+=Math.max(this.height/2-this.lines.length*f/2,0):2===this.valign&&(d+=Math.max(this.height-this.lines.length*f-2,0));for(h=0;h<this.lines.length&&!(k=c,1===this.halign?k=c+(this.width-this.lines[h].width)/2:2===this.halign&&(k=c+(this.width-this.lines[h].width)),a.fillText(this.lines[h].text,k,d),d+=f,d>=e-f);h++);
(0!==this.angle||b)&&a.restore();this.last_render_tick=this.runtime.tickcount};g.drawGL=function(a){if(!(1>this.width||1>this.height)){var b=this.text_changed||this.need_text_redraw;this.need_text_redraw=!1;var c=this.layer.getScale(),d=this.layer.getAngle(),e=this.rcTex,f=c*this.width,k=c*this.height,h=Math.ceil(f),g=Math.ceil(k),l=this.runtime.width/2,C=this.runtime.height/2;this.myctx||(this.mycanvas=document.createElement("canvas"),this.mycanvas.width=h,this.mycanvas.height=g,this.lastwidth=h,
this.lastheight=g,b=!0,this.myctx=this.mycanvas.getContext("2d"));if(h!==this.lastwidth||g!==this.lastheight)this.mycanvas.width=h,this.mycanvas.height=g,this.mytex&&(a.deleteTexture(this.mytex),this.mytex=null),b=!0;b&&(this.myctx.clearRect(0,0,h,g),this.draw(this.myctx,!0),this.mytex||(this.mytex=a.createEmptyTexture(h,g,this.runtime.linearSampling,this.runtime.isMobile)),a.videoToTexture(this.mycanvas,this.mytex,this.runtime.isMobile));this.lastwidth=h;this.lastheight=g;a.setTexture(this.mytex);
a.setOpacity(this.opacity);a.resetModelView();a.translate(-l,-C);a.updateModelView();var A=this.bquad,b=this.layer.layerToCanvas(A.tlx,A.tly,!0),l=this.layer.layerToCanvas(A.tlx,A.tly,!1),C=this.layer.layerToCanvas(A.trx,A.try_,!0),x=this.layer.layerToCanvas(A.trx,A.try_,!1),w=this.layer.layerToCanvas(A.brx,A.bry,!0),D=this.layer.layerToCanvas(A.brx,A.bry,!1),E=this.layer.layerToCanvas(A.blx,A.bly,!0),A=this.layer.layerToCanvas(A.blx,A.bly,!1);if(this.runtime.pixel_rounding||0===this.angle&&0===d)var H=
(b+0.5|0)-b,u=(l+0.5|0)-l,b=b+H,l=l+u,C=C+H,x=x+u,w=w+H,D=D+u,E=E+H,A=A+u;0===this.angle&&0===d?(C=b+h,x=l,w=C,D=l+g,E=b,A=D,e.right=1,e.bottom=1):(e.right=f/h,e.bottom=k/g);a.quadTex(b,l,C,x,w,D,E,A,e);a.resetModelView();a.scale(c,c);a.rotateZ(-this.layer.getAngle());a.translate((this.layer.viewLeft+this.layer.viewRight)/-2,(this.layer.viewTop+this.layer.viewBottom)/-2);a.updateModelView();this.last_render_tick=this.runtime.tickcount}};var l=[];f.TokeniseWords=function(a){l.length=0;for(var b="",
c,d=0;d<a.length;)if(c=a.charAt(d),"\n"===c)b.length&&(l.push(b),b=""),l.push("\n"),++d;else if(" "===c||"\t"===c||"-"===c){do b+=a.charAt(d),d++;while(d<a.length&&(" "===a.charAt(d)||"\t"===a.charAt(d)));l.push(b);b=""}else d<a.length&&(b+=c,d++);b.length&&l.push(b)};var k=[];f.WordWrap=function(c,d,e,f,k){if(!c||!c.length)b(d);else if(2>=f)b(d);else{if(100>=c.length&&-1===c.indexOf("\n")){var h=e.measureText(c).width;if(h<=f){b(d);d.push(a());d[0].text=c;d[0].width=h;return}}this.WrapText(c,d,e,
f,k)}};f.WrapText=function(b,c,d,e,f){f&&(this.TokeniseWords(b),b=l);var h="",g,v,y,z=0;for(y=0;y<b.length;y++)"\n"===b[y]?(z>=c.length&&c.push(a()),v=c[z],v.text=h,v.width=d.measureText(h).width,z++,h=""):(g=h,h+=b[y],v=d.measureText(h).width,v>=e&&(z>=c.length&&c.push(a()),v=c[z],v.text=g,v.width=d.measureText(g).width,z++,h=b[y],!f&&" "===h&&(h="")));h.length&&(z>=c.length&&c.push(a()),v=c[z],v.text=h,v.width=d.measureText(h).width,z++);for(y=z;y<c.length;y++)k.push(c[y]);c.length=z};c.prototype.CompareText=
function(a,b){return b?this.text==a:cr.equals_nocase(this.text,a)};f.cnds=new c;d.prototype.SetText=function(a){cr.is_number(a)&&1E9>a&&(a=Math.round(1E10*a)/1E10);a=a.toString();this.text!==a&&(this.text=a,this.text_changed=!0,this.runtime.redraw=!0)};d.prototype.AppendText=function(a){cr.is_number(a)&&(a=Math.round(1E10*a)/1E10);if(a=a.toString())this.text+=a,this.text_changed=!0,this.runtime.redraw=!0};d.prototype.SetFontFace=function(a,b){var c="";switch(b){case 1:c="bold";break;case 2:c="italic";
break;case 3:c="bold italic"}a===this.facename&&c===this.fontstyle||(this.facename=a,this.fontstyle=c,this.updateFont())};d.prototype.SetFontSize=function(a){this.ptSize!==a&&(this.ptSize=a,this.pxHeight=Math.ceil(96*(this.ptSize/72))+4,this.updateFont())};d.prototype.SetFontColor=function(a){a="rgb("+cr.GetRValue(a).toString()+","+cr.GetGValue(a).toString()+","+cr.GetBValue(a).toString()+")";a!==this.color&&(this.color=a,this.need_text_redraw=!0,this.runtime.redraw=!0)};d.prototype.SetWebFont=function(a,
b){if(this.runtime.isDomFree)cr.logexport("[Construct 2] Text plugin: 'Set web font' not supported on this platform - the action has been ignored");else{var c=this,d=function(){c.runtime.redraw=!0;c.text_changed=!0};if(h.hasOwnProperty(b)){var e="'"+a+"'";if(this.facename!==e){this.facename=e;this.updateFont();for(e=1;10>e;e++)setTimeout(d,100*e),setTimeout(d,1E3*e)}}else{e=document.createElement("link");e.href=b;e.rel="stylesheet";e.type="text/css";e.onload=d;document.getElementsByTagName("head")[0].appendChild(e);
h[b]=!0;this.facename="'"+a+"'";this.updateFont();for(e=1;10>e;e++)setTimeout(d,100*e),setTimeout(d,1E3*e)}}};d.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);this.runtime.redraw=!0};f.acts=new d;e.prototype.Text=function(a){a.set_string(this.text)};e.prototype.FaceName=function(a){a.set_string(this.facename)};e.prototype.FaceSize=function(a){a.set_int(this.ptSize)};e.prototype.TextWidth=function(a){var b=0,c,d,e;c=0;for(d=this.lines.length;c<
d;c++)e=this.lines[c].width,b<e&&(b=e);a.set_int(b)};e.prototype.TextHeight=function(a){a.set_int(this.lines.length*this.pxHeight)};f.exps=new e})();cr.plugins_.TiledBg=function(a){this.runtime=a};
(function(){function a(){}function b(){}var c=cr.plugins_.TiledBg.prototype;c.Type=function(a){this.plugin=a;this.runtime=a.runtime};var d=c.Type.prototype;d.onCreate=function(){this.is_family||(this.texture_img=new Image,this.texture_img.idtkLoadDisposed=!0,this.texture_img.src=this.texture_file,this.texture_img.cr_filesize=this.texture_filesize,this.runtime.wait_for_textures.push(this.texture_img),this.webGL_texture=this.pattern=null)};d.onLostWebGLContext=function(){this.is_family||(this.webGL_texture=
null)};d.onRestoreWebGLContext=function(){if(!this.is_family&&this.instances.length){this.webGL_texture||(this.webGL_texture=this.runtime.glwrap.loadTexture(this.texture_img,!0,this.runtime.linearSampling,this.texture_pixelformat));var a,b;a=0;for(b=this.instances.length;a<b;a++)this.instances[a].webGL_texture=this.webGL_texture}};d.loadTextures=function(){!this.is_family&&(!this.webGL_texture&&this.runtime.glwrap)&&(this.webGL_texture=this.runtime.glwrap.loadTexture(this.texture_img,!0,this.runtime.linearSampling,
this.texture_pixelformat))};d.unloadTextures=function(){!this.is_family&&(!this.instances.length&&this.webGL_texture)&&(this.runtime.glwrap.deleteTexture(this.webGL_texture),this.webGL_texture=null)};d.preloadCanvas2D=function(a){a.drawImage(this.texture_img,0,0)};c.Instance=function(a){this.type=a;this.runtime=a.runtime};d=c.Instance.prototype;d.onCreate=function(){this.visible=0===this.properties[0];this.rcTex=new cr.rect(0,0,0,0);this.has_own_texture=!1;this.texture_img=this.type.texture_img;this.runtime.glwrap?
(this.type.loadTextures(),this.webGL_texture=this.type.webGL_texture):(this.type.pattern||(this.type.pattern=this.runtime.ctx.createPattern(this.type.texture_img,"repeat")),this.pattern=this.type.pattern)};d.afterLoad=function(){this.has_own_texture=!1;this.texture_img=this.type.texture_img};d.onDestroy=function(){this.runtime.glwrap&&(this.has_own_texture&&this.webGL_texture)&&(this.runtime.glwrap.deleteTexture(this.webGL_texture),this.webGL_texture=null)};d.draw=function(a){a.globalAlpha=this.opacity;
a.save();a.fillStyle=this.pattern;var b=this.x,c=this.y;this.runtime.pixel_rounding&&(b=b+0.5|0,c=c+0.5|0);var d=-(this.hotspotX*this.width),l=-(this.hotspotY*this.height),k=d%this.texture_img.width,m=l%this.texture_img.height;0>k&&(k+=this.texture_img.width);0>m&&(m+=this.texture_img.height);a.translate(b,c);a.rotate(this.angle);a.translate(k,m);a.fillRect(d-k,l-m,this.width,this.height);a.restore()};d.drawGL=function(a){a.setTexture(this.webGL_texture);a.setOpacity(this.opacity);var b=this.rcTex;
b.right=this.width/this.texture_img.width;b.bottom=this.height/this.texture_img.height;var c=this.bquad;if(this.runtime.pixel_rounding){var d=(this.x+0.5|0)-this.x,l=(this.y+0.5|0)-this.y;a.quadTex(c.tlx+d,c.tly+l,c.trx+d,c.try_+l,c.brx+d,c.bry+l,c.blx+d,c.bly+l,b)}else a.quadTex(c.tlx,c.tly,c.trx,c.try_,c.brx,c.bry,c.blx,c.bly,b)};a.prototype.OnURLLoaded=function(){return!0};c.cnds=new a;b.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);
this.runtime.redraw=!0};b.prototype.LoadURL=function(a){var b=new Image,c=this;b.onload=function(){c.texture_img=b;c.runtime.glwrap?(c.has_own_texture&&c.webGL_texture&&c.runtime.glwrap.deleteTexture(c.webGL_texture),c.webGL_texture=c.runtime.glwrap.loadTexture(b,!0,c.runtime.linearSampling)):c.pattern=c.runtime.ctx.createPattern(b,"repeat");c.has_own_texture=!0;c.runtime.redraw=!0;c.runtime.trigger(cr.plugins_.TiledBg.prototype.cnds.OnURLLoaded,c)};"data:"!==a.substr(0,5)&&(b.crossOrigin="anonymous");
b.src=a};c.acts=new b;c.exps=new function(){}})();cr.plugins_.Touch=function(a){this.runtime=a};
(function(){function a(a){h=a.x;l=a.y;k=a.z}function b(a){m=a.x;n=a.y;q=a.z}function c(){}function d(){}var e=cr.plugins_.Touch.prototype;e.Type=function(a){this.plugin=a;this.runtime=a.runtime};e.Type.prototype.onCreate=function(){};e.Instance=function(a){this.type=a;this.runtime=a.runtime;this.touches=[];this.mouseDown=!1};var f=e.Instance.prototype,g={left:0,top:0};f.findTouch=function(a){var b,c;b=0;for(c=this.touches.length;b<c;b++)if(this.touches[b].id===a)return b;return-1};var h=0,l=0,k=0,
m=0,n=0,q=0;f.onCreate=function(){this.isWindows8=!!("undefined"!==typeof window.c2isWindows8&&window.c2isWindows8);this.trigger_id=this.trigger_index=this.curTouchY=this.curTouchX=this.acc_z=this.acc_y=this.acc_x=this.acc_g_z=this.acc_g_y=this.acc_g_x=this.orient_gamma=this.orient_beta=this.orient_alpha=0;this.useMouseInput=0!==this.properties[0];var c=0<this.runtime.fullscreen_mode?document:this.runtime.canvas,d=document;this.runtime.isDirectCanvas?d=c=window.Canvas:this.runtime.isCocoonJs&&(d=
c=window);var e=this;window.navigator.msPointerEnabled?(c.addEventListener("MSPointerDown",function(a){e.onPointerStart(a)},!1),c.addEventListener("MSPointerMove",function(a){e.onPointerMove(a)},!1),d.addEventListener("MSPointerUp",function(a){e.onPointerEnd(a)},!1),d.addEventListener("MSPointerCancel",function(a){e.onPointerEnd(a)},!1),this.runtime.canvas&&(this.runtime.canvas.addEventListener("MSGestureHold",function(a){a.preventDefault()},!1),document.addEventListener("MSGestureHold",function(a){a.preventDefault()},
!1))):(c.addEventListener("touchstart",function(a){e.onTouchStart(a)},!1),c.addEventListener("touchmove",function(a){e.onTouchMove(a)},!1),d.addEventListener("touchend",function(a){e.onTouchEnd(a)},!1),d.addEventListener("touchcancel",function(a){e.onTouchEnd(a)},!1));if(this.isWindows8){var f=function(a){a=a.reading;e.acc_x=a.accelerationX;e.acc_y=a.accelerationY;e.acc_z=a.accelerationZ},k=function(a){a=a.reading;e.orient_alpha=a.yawDegrees;e.orient_beta=a.pitchDegrees;e.orient_gamma=a.rollDegrees},
h=Windows.Devices.Sensors.Accelerometer.getDefault();h&&(h.reportInterval=Math.max(h.minimumReportInterval,16),h.addEventListener("readingchanged",f));var g=Windows.Devices.Sensors.Inclinometer.getDefault();g&&(g.reportInterval=Math.max(g.minimumReportInterval,16),g.addEventListener("readingchanged",k));document.addEventListener("visibilitychange",function(a){document.hidden||document.msHidden?(h&&h.removeEventListener("readingchanged",f),g&&g.removeEventListener("readingchanged",k)):(h&&h.addEventListener("readingchanged",
f),g&&g.addEventListener("readingchanged",k))},!1)}else window.addEventListener("deviceorientation",function(a){e.orient_alpha=a.alpha||0;e.orient_beta=a.beta||0;e.orient_gamma=a.gamma||0},!1),window.addEventListener("devicemotion",function(a){a.accelerationIncludingGravity&&(e.acc_g_x=a.accelerationIncludingGravity.x,e.acc_g_y=a.accelerationIncludingGravity.y,e.acc_g_z=a.accelerationIncludingGravity.z);a.acceleration&&(e.acc_x=a.acceleration.x,e.acc_y=a.acceleration.y,e.acc_z=a.acceleration.z)},
!1);this.useMouseInput&&!this.runtime.isDomFree&&(jQuery(document).mousemove(function(a){e.onMouseMove(a)}),jQuery(document).mousedown(function(a){e.onMouseDown(a)}),jQuery(document).mouseup(function(a){e.onMouseUp(a)}));this.runtime.isAppMobi&&!this.runtime.isDirectCanvas&&AppMobi.accelerometer.watchAcceleration(a,{frequency:40,adjustForRotation:!0});this.runtime.isPhoneGap&&navigator.accelerometer.watchAcceleration(b,null,{frequency:40});this.runtime.tick2Me(this)};f.onPointerMove=function(a){if(a.pointerType!==
a.MSPOINTER_TYPE_MOUSE){a.preventDefault&&a.preventDefault();var b=this.findTouch(a.pointerId),c=cr.performance_now();if(0<=b){var d=this.runtime.isDomFree?g:jQuery(this.runtime.canvas).offset(),b=this.touches[b];2>c-b.time||(b.lasttime=b.time,b.lastx=b.x,b.lasty=b.y,b.time=c,b.x=a.pageX-d.left,b.y=a.pageY-d.top)}}};f.onPointerStart=function(a){if(a.pointerType!==a.MSPOINTER_TYPE_MOUSE){a.preventDefault&&a.preventDefault();var b=this.runtime.isDomFree?g:jQuery(this.runtime.canvas).offset(),c=a.pageX-
b.left,b=a.pageY-b.top,d=cr.performance_now();this.trigger_index=this.touches.length;this.trigger_id=a.pointerId;this.touches.push({time:d,x:c,y:b,lasttime:d,lastx:c,lasty:b,id:a.pointerId,startindex:this.trigger_index});this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart,this);this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart,this);this.curTouchX=c;this.curTouchY=b;this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject,this)}};f.onPointerEnd=function(a){a.pointerType!==
a.MSPOINTER_TYPE_MOUSE&&(a.preventDefault&&a.preventDefault(),a=this.findTouch(a.pointerId),this.trigger_index=0<=a?this.touches[a].startindex:-1,this.trigger_id=0<=a?this.touches[a].id:-1,this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd,this),this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd,this),0<=a&&this.touches.splice(a,1))};f.onTouchMove=function(a){a.preventDefault&&a.preventDefault();var b=cr.performance_now(),c,d,e,f;c=0;for(d=a.changedTouches.length;c<
d;c++)if(e=a.changedTouches[c],f=this.findTouch(e.identifier),0<=f){var k=this.runtime.isDomFree?g:jQuery(this.runtime.canvas).offset();f=this.touches[f];2>b-f.time||(f.lasttime=f.time,f.lastx=f.x,f.lasty=f.y,f.time=b,f.x=e.pageX-k.left,f.y=e.pageY-k.top)}};f.onTouchStart=function(a){a.preventDefault&&a.preventDefault();var b=this.runtime.isDomFree?g:jQuery(this.runtime.canvas).offset(),c=cr.performance_now(),d,e,f,k;d=0;for(e=a.changedTouches.length;d<e;d++)if(f=a.changedTouches[d],k=this.findTouch(f.identifier),
-1===k){k=f.pageX-b.left;var h=f.pageY-b.top;this.trigger_index=this.touches.length;this.trigger_id=f.identifier;this.touches.push({time:c,x:k,y:h,lasttime:c,lastx:k,lasty:h,id:f.identifier,startindex:this.trigger_index});this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart,this);this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart,this);this.curTouchX=k;this.curTouchY=h;this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject,this)}};f.onTouchEnd=function(a){a.preventDefault&&
a.preventDefault();var b,c,d;b=0;for(c=a.changedTouches.length;b<c;b++)d=a.changedTouches[b],d=this.findTouch(d.identifier),0<=d&&(this.trigger_index=this.touches[d].startindex,this.trigger_id=this.touches[d].id,this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd,this),this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd,this),this.touches.splice(d,1))};f.getAlpha=function(){return this.runtime.isAppMobi&&0===this.orient_alpha&&0!==k?90*k:this.runtime.isPhoneGap&&0===this.orient_alpha&&
0!==q?90*q:this.orient_alpha};f.getBeta=function(){return this.runtime.isAppMobi&&0===this.orient_beta&&0!==l?-90*l:this.runtime.isPhoneGap&&0===this.orient_beta&&0!==n?-90*n:this.orient_beta};f.getGamma=function(){return this.runtime.isAppMobi&&0===this.orient_gamma&&0!==h?90*h:this.runtime.isPhoneGap&&0===this.orient_gamma&&0!==m?90*m:this.orient_gamma};f.onMouseDown=function(a){a.preventDefault&&this.runtime.had_a_click&&a.preventDefault();this.onTouchStart({changedTouches:[{pageX:a.pageX,pageY:a.pageY,
identifier:0}]});this.mouseDown=!0};f.onMouseMove=function(a){a.preventDefault&&this.runtime.had_a_click&&a.preventDefault();if(this.mouseDown)this.onTouchMove({changedTouches:[{pageX:a.pageX,pageY:a.pageY,identifier:0}]})};f.onMouseUp=function(a){a.preventDefault&&this.runtime.had_a_click&&a.preventDefault();this.runtime.had_a_click=!0;this.onTouchEnd({changedTouches:[{pageX:a.pageX,pageY:a.pageY,identifier:0}]});this.mouseDown=!1};f.tick2=function(){var a,b,c,d=cr.performance_now();a=0;for(b=this.touches.length;a<
b;a++)c=this.touches[a],c.time<=d-50&&(c.lasttime=d)};c.prototype.OnTouchStart=function(){return!0};c.prototype.OnTouchEnd=function(){return!0};c.prototype.IsInTouch=function(){return this.touches.length};c.prototype.OnTouchObject=function(a){return!a?!1:this.runtime.testAndSelectCanvasPointOverlap(a,this.curTouchX,this.curTouchY,!1)};c.prototype.IsTouchingObject=function(a){if(!a)return!1;a=a.getCurrentSol();var b=a.getObjects(),c,d,e=[],f,k,h,g;f=0;for(k=b.length;f<k;f++){var l=b[f];l.update_bbox();
h=0;for(g=this.touches.length;h<g;h++)if(d=this.touches[h],c=l.layer.canvasToLayer(d.x,d.y,!0),d=l.layer.canvasToLayer(d.x,d.y,!1),l.contains_pt(c,d)){e.push(l);break}}return e.length?(a.select_all=!1,a.instances=e,!0):!1};c.prototype.CompareTouchSpeed=function(a,b,c){a=Math.floor(a);if(0>a||a>=this.touches.length)return!1;var d=this.touches[a];a=cr.distanceTo(d.x,d.y,d.lastx,d.lasty);var d=(d.time-d.lasttime)/1E3,e=0;0<d&&(e=a/d);return cr.do_cmp(e,b,c)};c.prototype.OrientationSupported=function(){return"undefined"!==
typeof window.DeviceOrientationEvent};c.prototype.MotionSupported=function(){return"undefined"!==typeof window.DeviceMotionEvent};c.prototype.CompareOrientation=function(a,b,c){var d=0,d=0===a?this.getAlpha():1===a?this.getBeta():this.getGamma();return cr.do_cmp(d,b,c)};c.prototype.CompareAcceleration=function(a,b,c){var d=0;0===a?d=this.acc_g_x:1===a?d=this.acc_g_y:2===a?d=this.acc_g_z:3===a?d=this.acc_x:4===a?d=this.acc_y:5===a&&(d=this.acc_z);return cr.do_cmp(d,b,c)};c.prototype.OnNthTouchStart=
function(a){a=Math.floor(a);return a===this.trigger_index};c.prototype.OnNthTouchEnd=function(a){a=Math.floor(a);return a===this.trigger_index};c.prototype.HasNthTouch=function(a){a=Math.floor(a);return this.touches.length>=a+1};e.cnds=new c;d.prototype.TouchCount=function(a){a.set_int(this.touches.length)};d.prototype.X=function(a,b){if(this.touches.length){var c,d,e,f,k;cr.is_undefined(b)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,f=c.parallaxX,k=c.angle,c.scale=this.runtime.running_layout.scale,
c.zoomRate=1,c.parallaxX=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[0].x,this.touches[0].y,!0)),c.scale=d,c.zoomRate=e,c.parallaxX=f,c.angle=k):(c=cr.is_number(b)?this.runtime.getLayerByNumber(b):this.runtime.getLayerByName(b))?a.set_float(c.canvasToLayer(this.touches[0].x,this.touches[0].y,!0)):a.set_float(0)}else a.set_float(0)};d.prototype.XAt=function(a,b,c){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var d,e,f,k;cr.is_undefined(c)?
(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,f=c.parallaxX,k=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxX=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!0)),c.scale=d,c.zoomRate=e,c.parallaxX=f,c.angle=k):(c=cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!0)):a.set_float(0)}};d.prototype.XForID=function(a,
b,c){b=this.findTouch(b);if(0>b)a.set_float(0);else{b=this.touches[b];var d,e,f,k;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,f=c.parallaxX,k=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxX=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(b.x,b.y,!0)),c.scale=d,c.zoomRate=e,c.parallaxX=f,c.angle=k):(c=cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?a.set_float(c.canvasToLayer(b.x,b.y,
!0)):a.set_float(0)}};d.prototype.Y=function(a,b){if(this.touches.length){var c,d,e,f,k;cr.is_undefined(b)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,f=c.parallaxY,k=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxY=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[0].x,this.touches[0].y,!1)),c.scale=d,c.zoomRate=e,c.parallaxY=f,c.angle=k):(c=cr.is_number(b)?this.runtime.getLayerByNumber(b):this.runtime.getLayerByName(b))?
a.set_float(c.canvasToLayer(this.touches[0].x,this.touches[0].y,!1)):a.set_float(0)}else a.set_float(0)};d.prototype.YAt=function(a,b,c){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var d,e,f,k;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,f=c.parallaxY,k=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxY=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!1)),c.scale=
d,c.zoomRate=e,c.parallaxY=f,c.angle=k):(c=cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!1)):a.set_float(0)}};d.prototype.YForID=function(a,b,c){b=this.findTouch(b);if(0>b)a.set_float(0);else{b=this.touches[b];var d,e,f,k;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,f=c.parallaxY,k=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxY=1,c.angle=
this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(b.x,b.y,!1)),c.scale=d,c.zoomRate=e,c.parallaxY=f,c.angle=k):(c=cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?a.set_float(c.canvasToLayer(b.x,b.y,!1)):a.set_float(0)}};d.prototype.AbsoluteX=function(a){this.touches.length?a.set_float(this.touches[0].x):a.set_float(0)};d.prototype.AbsoluteXAt=function(a,b){b=Math.floor(b);0>b||b>=this.touches.length?a.set_float(0):a.set_float(this.touches[b].x)};d.prototype.AbsoluteXForID=
function(a,b){var c=this.findTouch(b);0>c?a.set_float(0):a.set_float(this.touches[c].x)};d.prototype.AbsoluteY=function(a){this.touches.length?a.set_float(this.touches[0].y):a.set_float(0)};d.prototype.AbsoluteYAt=function(a,b){b=Math.floor(b);0>b||b>=this.touches.length?a.set_float(0):a.set_float(this.touches[b].y)};d.prototype.AbsoluteYForID=function(a,b){var c=this.findTouch(b);0>c?a.set_float(0):a.set_float(this.touches[c].y)};d.prototype.SpeedAt=function(a,b){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);
else{var c=this.touches[b],d=cr.distanceTo(c.x,c.y,c.lastx,c.lasty),c=(c.time-c.lasttime)/1E3;0===c?a.set_float(0):a.set_float(d/c)}};d.prototype.SpeedForID=function(a,b){var c=this.findTouch(b);if(0>c)a.set_float(0);else{var d=this.touches[c],c=cr.distanceTo(d.x,d.y,d.lastx,d.lasty),d=(d.time-d.lasttime)/1E3;0===d?a.set_float(0):a.set_float(c/d)}};d.prototype.AngleAt=function(a,b){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var c=this.touches[b];a.set_float(cr.to_degrees(cr.angleTo(c.lastx,
c.lasty,c.x,c.y)))}};d.prototype.AngleForID=function(a,b){var c=this.findTouch(b);0>c?a.set_float(0):(c=this.touches[c],a.set_float(cr.to_degrees(cr.angleTo(c.lastx,c.lasty,c.x,c.y))))};d.prototype.Alpha=function(a){a.set_float(this.getAlpha())};d.prototype.Beta=function(a){a.set_float(this.getBeta())};d.prototype.Gamma=function(a){a.set_float(this.getGamma())};d.prototype.AccelerationXWithG=function(a){a.set_float(this.acc_g_x)};d.prototype.AccelerationYWithG=function(a){a.set_float(this.acc_g_y)};
d.prototype.AccelerationZWithG=function(a){a.set_float(this.acc_g_z)};d.prototype.AccelerationX=function(a){a.set_float(this.acc_x)};d.prototype.AccelerationY=function(a){a.set_float(this.acc_y)};d.prototype.AccelerationZ=function(a){a.set_float(this.acc_z)};d.prototype.TouchIndex=function(a){a.set_int(this.trigger_index)};d.prototype.TouchID=function(a){a.set_float(this.trigger_id)};e.exps=new d})();cr.plugins_.WebStorage=function(a){this.runtime=a};
(function(){function a(){l||(cr.logexport("[Construct 2] Webstorage plugin: session storage is not supported on this platform. Try using local storage or global variables instead."),l=!0)}function b(){}function c(){}function d(){}var e=cr.plugins_.WebStorage.prototype;e.Type=function(a){this.plugin=a;this.runtime=a.runtime};e.Type.prototype.onCreate=function(){};e.Instance=function(a){this.type=a;this.runtime=a.runtime};var f=e.Instance.prototype,g="",h="undefined"!==typeof window.is_scirra_arcade;
h&&(g="arcade"+window.scirra_arcade_id);var l=!1;f.onCreate=function(){};b.prototype.LocalStorageEnabled=function(){return!0};b.prototype.SessionStorageEnabled=function(){return!0};b.prototype.LocalStorageExists=function(a){return null!=localStorage.getItem(g+a)};b.prototype.SessionStorageExists=function(b){return this.runtime.isCocoonJs||!sessionStorage?(a(),!1):null!=sessionStorage.getItem(g+b)};b.prototype.OnQuotaExceeded=function(){return!0};b.prototype.CompareKeyText=function(a,b,c){a=localStorage.getItem(g+
a)||"";return c?a==b:cr.equals_nocase(a,b)};b.prototype.CompareKeyNumber=function(a,b,c){a=localStorage.getItem(g+a)||"";return cr.do_cmp(parseFloat(a),b,c)};e.cnds=new b;c.prototype.StoreLocal=function(a,b){try{localStorage.setItem(g+a,b)}catch(c){this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded,this)}};c.prototype.StoreSession=function(b,c){if(this.runtime.isCocoonJs||!sessionStorage)a();else try{sessionStorage.setItem(g+b,c)}catch(d){this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded,
this)}};c.prototype.RemoveLocal=function(a){localStorage.removeItem(g+a)};c.prototype.RemoveSession=function(b){this.runtime.isCocoonJs||!sessionStorage?a():sessionStorage.removeItem(g+b)};c.prototype.ClearLocal=function(){h||localStorage.clear()};c.prototype.ClearSession=function(){this.runtime.isCocoonJs||!sessionStorage?a():h||sessionStorage.clear()};c.prototype.JSONLoad=function(a,b){var c;try{c=JSON.parse(a)}catch(d){return}if(c.c2dictionary){c=c.data;0===b&&!h&&localStorage.clear();for(var e in c)if(c.hasOwnProperty(e))try{localStorage.setItem(g+
e,c[e])}catch(f){this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded,this);break}}};e.acts=new c;d.prototype.LocalValue=function(a,b){a.set_string(localStorage.getItem(g+b)||"")};d.prototype.SessionValue=function(b,c){this.runtime.isCocoonJs||!sessionStorage?(a(),b.set_string("")):b.set_string(sessionStorage.getItem(g+c)||"")};d.prototype.LocalCount=function(a){a.set_int(h?0:localStorage.length)};d.prototype.SessionCount=function(b){this.runtime.isCocoonJs||!sessionStorage?
(a(),b.set_int(0)):b.set_int(h?0:sessionStorage.length)};d.prototype.LocalAt=function(a,b){h?a.set_string(""):a.set_string(localStorage.getItem(localStorage.key(b))||"")};d.prototype.SessionAt=function(b,c){this.runtime.isCocoonJs||!sessionStorage?(a(),b.set_string("")):h?b.set_string(""):b.set_string(sessionStorage.getItem(sessionStorage.key(c))||"")};d.prototype.LocalKeyAt=function(a,b){h?a.set_string(""):a.set_string(localStorage.key(b)||"")};d.prototype.SessionKeyAt=function(b,c){this.runtime.isCocoonJs||
!sessionStorage?(a(),b.set_string("")):h?b.set_string(""):b.set_string(sessionStorage.key(c)||"")};d.prototype.AsJSON=function(a){var b={},c,d,e;c=0;for(d=localStorage.length;c<d;c++)e=localStorage.key(c),h?e.substr(0,g.length)===g&&(b[e.substr(g.length)]=localStorage.getItem(e)):b[e]=localStorage.getItem(e);a.set_string(JSON.stringify({c2dictionary:!0,data:b}))};e.exps=new d})();cr.behaviors.Anchor=function(a){this.runtime=a};
(function(){function a(){}var b=cr.behaviors.Anchor.prototype;b.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};b.Type.prototype.onCreate=function(){};b.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var c=b.Instance.prototype;c.onCreate=function(){this.anch_left=this.properties[0];this.anch_top=this.properties[1];this.anch_right=this.properties[2];this.anch_bottom=this.properties[3];this.inst.update_bbox();this.xleft=this.inst.bbox.left;
this.ytop=this.inst.bbox.top;this.xright=this.runtime.original_width-this.inst.bbox.left;this.ybottom=this.runtime.original_height-this.inst.bbox.top;this.rdiff=this.runtime.original_width-this.inst.bbox.right;this.bdiff=this.runtime.original_height-this.inst.bbox.bottom;this.enabled=0!==this.properties[4]};c.saveToJSON=function(){return{xleft:this.xleft,ytop:this.ytop,xright:this.xright,ybottom:this.ybottom,rdiff:this.rdiff,bdiff:this.bdiff,enabled:this.enabled}};c.loadFromJSON=function(a){this.xleft=
a.xleft;this.ytop=a.ytop;this.xright=a.xright;this.ybottom=a.ybottom;this.rdiff=a.rdiff;this.bdiff=a.bdiff;this.enabled=a.enabled};c.tick=function(){if(this.enabled){var a,b=this.inst.layer,c=this.inst,g=this.inst.bbox;0===this.anch_left?(c.update_bbox(),a=b.viewLeft+this.xleft-g.left,0!==a&&(c.x+=a,c.set_bbox_changed())):1===this.anch_left&&(c.update_bbox(),a=b.viewRight-this.xright-g.left,0!==a&&(c.x+=a,c.set_bbox_changed()));0===this.anch_top?(c.update_bbox(),a=b.viewTop+this.ytop-g.top,0!==a&&
(c.y+=a,c.set_bbox_changed())):1===this.anch_top&&(c.update_bbox(),a=b.viewBottom-this.ybottom-g.top,0!==a&&(c.y+=a,c.set_bbox_changed()));1===this.anch_right&&(c.update_bbox(),a=b.viewRight-this.rdiff-g.right,0!==a&&(c.width+=a,0>c.width&&(c.width=0),c.set_bbox_changed()));1===this.anch_bottom&&(c.update_bbox(),a=b.viewBottom-this.bdiff-g.bottom,0!==a&&(c.height+=a,0>c.height&&(c.height=0),c.set_bbox_changed()))}};b.cnds=new function(){};a.prototype.SetEnabled=function(a){this.enabled&&0===a?this.enabled=
!1:!this.enabled&&0!==a&&(this.inst.update_bbox(),this.xleft=this.inst.bbox.left,this.ytop=this.inst.bbox.top,this.xright=this.runtime.original_width-this.inst.bbox.left,this.ybottom=this.runtime.original_height-this.inst.bbox.top,this.rdiff=this.runtime.original_width-this.inst.bbox.right,this.bdiff=this.runtime.original_height-this.inst.bbox.bottom,this.enabled=!0)};b.acts=new a;b.exps=new function(){}})();cr.behaviors.Bullet=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){}var d=cr.behaviors.Bullet.prototype;d.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};d.Type.prototype.onCreate=function(){};d.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var e=d.Instance.prototype;e.onCreate=function(){var a=this.properties[0];this.acc=this.properties[1];this.g=this.properties[2];this.bounceOffSolid=0!==this.properties[3];this.setAngle=0!==this.properties[4];
this.dx=Math.cos(this.inst.angle)*a;this.dy=Math.sin(this.inst.angle)*a;this.lastx=this.inst.x;this.lasty=this.inst.y;this.lastKnownAngle=this.inst.angle;this.travelled=0;this.enabled=0!==this.properties[5]};e.saveToJSON=function(){return{acc:this.acc,g:this.g,dx:this.dx,dy:this.dy,lx:this.lastx,ly:this.lasty,lka:this.lastKnownAngle,t:this.travelled,e:this.enabled}};e.loadFromJSON=function(a){this.acc=a.acc;this.g=a.g;this.dx=a.dx;this.dy=a.dy;this.lastx=a.lx;this.lasty=a.ly;this.lastKnownAngle=a.lka;
this.travelled=a.t;this.enabled=a.e};e.tick=function(){if(this.enabled){var a=this.runtime.getDt(this.inst),b,c;this.inst.angle!==this.lastKnownAngle&&(this.setAngle&&(b=cr.distanceTo(0,0,this.dx,this.dy),this.dx=Math.cos(this.inst.angle)*b,this.dy=Math.sin(this.inst.angle)*b),this.lastKnownAngle=this.inst.angle);0!==this.acc&&(b=cr.distanceTo(0,0,this.dx,this.dy),c=0===this.dx&&0===this.dy?this.inst.angle:cr.angleTo(0,0,this.dx,this.dy),b+=this.acc*a,0>b&&(b=0),this.dx=Math.cos(c)*b,this.dy=Math.sin(c)*
b);0!==this.g&&(this.dy+=this.g*a);this.lastx=this.inst.x;this.lasty=this.inst.y;if(0!==this.dx||0!==this.dy)if(this.inst.x+=this.dx*a,this.inst.y+=this.dy*a,this.travelled+=cr.distanceTo(0,0,this.dx*a,this.dy*a),this.setAngle&&(this.inst.angle=cr.angleTo(0,0,this.dx,this.dy),this.inst.set_bbox_changed(),this.lastKnownAngle=this.inst.angle),this.inst.set_bbox_changed(),this.bounceOffSolid&&(b=this.runtime.testOverlapSolid(this.inst)))this.runtime.registerCollision(this.inst,b),b=cr.distanceTo(0,0,
this.dx,this.dy),c=this.runtime.calculateSolidBounceAngle(this.inst,this.lastx,this.lasty),this.dx=Math.cos(c)*b,this.dy=Math.sin(c)*b,this.inst.x+=this.dx*a,this.inst.y+=this.dy*a,this.inst.set_bbox_changed(),this.setAngle&&(this.lastKnownAngle=this.inst.angle=c,this.inst.set_bbox_changed()),this.runtime.pushOutSolid(this.inst,this.dx/b,this.dy/b,Math.max(2.5*b*a,30))||this.runtime.pushOutSolidNearest(this.inst,100)}};a.prototype.CompareSpeed=function(a,b){return cr.do_cmp(cr.distanceTo(0,0,this.dx,
this.dy),a,b)};a.prototype.CompareTravelled=function(a,b){return cr.do_cmp(this.travelled,a,b)};d.cnds=new a;b.prototype.SetSpeed=function(a){var b=cr.angleTo(0,0,this.dx,this.dy);this.dx=Math.cos(b)*a;this.dy=Math.sin(b)*a};b.prototype.SetAcceleration=function(a){this.acc=a};b.prototype.SetGravity=function(a){this.g=a};b.prototype.SetAngleOfMotion=function(a){a=cr.to_radians(a);var b=cr.distanceTo(0,0,this.dx,this.dy);this.dx=Math.cos(a)*b;this.dy=Math.sin(a)*b};b.prototype.Bounce=function(a){if(a&&
(a=a.getFirstPicked(this.inst))){var b=this.runtime.getDt(this.inst),c=cr.distanceTo(0,0,this.dx,this.dy),d=this.runtime.calculateSolidBounceAngle(this.inst,this.lastx,this.lasty,a);this.dx=Math.cos(d)*c;this.dy=Math.sin(d)*c;this.inst.x+=this.dx*b;this.inst.y+=this.dy*b;this.inst.set_bbox_changed();this.setAngle&&(this.lastKnownAngle=this.inst.angle=d,this.inst.set_bbox_changed());this.bounceOffSolid?this.runtime.pushOutSolid(this.inst,this.dx/c,this.dy/c,Math.max(2.5*c*b,30))||this.runtime.pushOutSolidNearest(this.inst,
100):this.runtime.pushOut(this.inst,this.dx/c,this.dy/c,Math.max(2.5*c*b,30),a)}};b.prototype.SetEnabled=function(a){this.enabled=1===a};d.acts=new b;c.prototype.Speed=function(a){var b=cr.distanceTo(0,0,this.dx,this.dy),b=cr.round6dp(b);a.set_float(b)};c.prototype.Acceleration=function(a){a.set_float(this.acc)};c.prototype.AngleOfMotion=function(a){a.set_float(cr.to_degrees(cr.angleTo(0,0,this.dx,this.dy)))};c.prototype.DistanceTravelled=function(a){a.set_float(this.travelled)};d.exps=new c})();
cr.behaviors.Flash=function(a){this.runtime=a};
(function(){function a(){}function b(){}var c=cr.behaviors.Flash.prototype;c.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};c.Type.prototype.onCreate=function(){};c.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var d=c.Instance.prototype;d.onCreate=function(){this.timeleft=this.stagetimeleft=this.stage=this.offtime=this.ontime=0};d.saveToJSON=function(){return{ontime:this.ontime,offtime:this.offtime,stage:this.stage,stagetimeleft:this.stagetimeleft,
timeleft:this.timeleft}};d.loadFromJSON=function(a){this.ontime=a.ontime;this.offtime=a.offtime;this.stage=a.stage;this.stagetimeleft=a.stagetimeleft;this.timeleft=a.timeleft};d.tick=function(){if(!(0>=this.timeleft)){var a=this.runtime.getDt(this.inst);this.timeleft-=a;0>=this.timeleft?(this.timeleft=0,this.inst.visible=!0,this.runtime.redraw=!0,this.runtime.trigger(cr.behaviors.Flash.prototype.cnds.OnFlashEnded,this.inst)):(this.stagetimeleft-=a,0>=this.stagetimeleft&&(0===this.stage?(this.inst.visible=
!1,this.stage=1,this.stagetimeleft+=this.offtime):(this.inst.visible=!0,this.stage=0,this.stagetimeleft+=this.ontime),this.runtime.redraw=!0))}};a.prototype.IsFlashing=function(){return 0<this.timeleft};a.prototype.OnFlashEnded=function(){return!0};c.cnds=new a;b.prototype.Flash=function(a,b,c){this.ontime=a;this.offtime=b;this.stage=1;this.stagetimeleft=b;this.timeleft=c;this.inst.visible=!1;this.runtime.redraw=!0};b.prototype.StopFlashing=function(){this.timeleft=0;this.inst.visible=!0;this.runtime.redraw=
!0};c.acts=new b;c.exps=new function(){}})();cr.behaviors.Pathfinding=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){}var d=cr.behaviors.Pathfinding.prototype;d.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};d.Type.prototype.onCreate=function(){this.obstacleTypes=[];this.costTypes=[]};var e={};d.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var f=d.Instance.prototype;f.onCreate=function(){this.cellSize=this.properties[0];3>this.cellSize&&(this.cellSize=3);this.cellBorder=this.properties[1];
this.obstacles=this.properties[2];this.maxSpeed=this.properties[3];this.acc=this.properties[4];this.dec=this.properties[5];this.av=cr.to_radians(this.properties[6]);this.rotateEnabled=0!==this.properties[7];this.diagonalsEnabled=0!==this.properties[8];this.enabled=0!==this.properties[9];this.hasPath=this.firstTickMovingWhileMoving=this.movingFromStopped=this.isMoving=!1;this.moveNode=0;this.lastKnownAngle=this.a=this.inst.angle;this.rabbitA=this.rabbitY=this.rabbitX=this.s=0;this.myHcells=Math.ceil(this.runtime.running_layout.width/
this.cellSize);this.myVcells=Math.ceil(this.runtime.running_layout.height/this.cellSize);this.myPath=[];this.delayFindPath=!1;this.delayPathY=this.delayPathX=0;this.isCalculating=this.is_destroyed=!1;this.calcPathY=this.calcPathX=0;this.firstRun=!0;var a=this;this.recycled||(this.pathSuccessFn=function(){a.is_destroyed||(a.isCalculating=!1,a.copyResultPath(),a.hasPath=0<a.myPath.length,a.moveNode=0,a.runtime.trigger(cr.behaviors.Pathfinding.prototype.cnds.OnPathFound,a.inst),a.doDelayFindPath())},
this.pathFailFn=function(){a.is_destroyed||(a.isCalculating=!1,a.clearResultPath(),a.hasPath=!1,a.isMoving=!1,a.moveNode=0,a.runtime.trigger(cr.behaviors.Pathfinding.prototype.cnds.OnFailedToFindPath,a.inst),a.doDelayFindPath())})};f.onDestroy=function(){this.is_destroyed=!0;this.delayFindPath=!1};f.saveToJSON=function(){var a={cs:this.cellSize,cb:this.cellBorder,ms:this.maxSpeed,acc:this.acc,dec:this.dec,av:this.av,re:this.rotateEnabled,de:this.diagonalsEnabled,im:this.isMoving,mfs:this.movingFromStopped,
ftmwm:this.firstTickMovingWhileMoving,hp:this.hasPath,mn:this.moveNode,a:this.a,lka:this.lastKnownAngle,s:this.s,rx:this.rabbitX,ry:this.rabbitY,ra:this.rabbitA,myhc:this.myHcells,myvc:this.myVcells,path:this.myPath,en:this.enabled,fr:this.firstRun,obs:[],costs:[]};this.isCalculating?(a.dfp=!0,a.dpx=this.calcPathX,a.dpy=this.calcPathY):(a.dfp=this.delayFindPath,a.dpx=this.delayPathX,a.dpy=this.delayPathY);var b,c;b=0;for(c=this.type.obstacleTypes.length;b<c;b++)a.obs.push(this.type.obstacleTypes[b].sid);
b=0;for(c=this.type.costTypes.length;b<c;b++)a.costs.push({sid:this.type.costTypes[b].obj.sid,cost:this.type.costTypes[b].cost});return a};f.loadFromJSON=function(a){this.cellSize=a.cs;this.cellBorder=a.cb;this.maxSpeed=a.ms;this.acc=a.acc;this.dec=a.dec;this.av=a.av;this.rotateEnabled=a.re;this.diagonalsEnabled=a.de;this.isMoving=a.im;this.movingFromStopped=a.mfs;this.firstTickMovingWhileMoving=a.ftmwm;this.hasPath=a.hp;this.moveNode=a.mn;this.a=a.a;this.lastKnownAngle=a.lka;this.s=a.s;this.rabbitX=
a.rx;this.rabbitY=a.ry;this.rabbitA=a.ra;this.myHcells=a.myhc;this.myVcells=a.myvc;this.myPath=a.path;this.enabled=a.en;this.firstRun=a.fr;this.delayFindPath=a.dfp;this.delayPathX=a.dpx;this.delayPathY=a.dpy;this.type.obstacleTypes.length=0;var b=a.obs,c,d,e;c=0;for(d=b.length;c<d;c++)(e=this.runtime.getObjectTypeBySid(b[c]))&&this.type.obstacleTypes.push(e);this.type.costTypes.length=0;a=a.costs;c=0;for(d=a.length;c<d;c++)(e=this.runtime.getObjectTypeBySid(a[c].sid))&&this.type.costTypes.push({obj:e,
cost:a[c].cost});this.getMyInfo().pathfinder.setDiagonals(this.diagonalsEnabled)};f.afterLoad=function(){this.getMyInfo().regenerate=!0};f.tick=function(){if(this.enabled&&this.isMoving){this.rotateEnabled&&this.inst.angle!==this.lastKnownAngle&&(this.a=this.inst.angle);var a=this.runtime.getDt(this.inst),b,c,d,e,f,g=this.inst,r=Math.min(0.4*this.maxSpeed,2*Math.abs(this.inst.width)),s=Math.max(1.5*this.s,30);this.moveNode<this.myPath.length?(e=this.myPath[this.moveNode].x,f=this.myPath[this.moveNode].y,
d=cr.distanceTo(this.rabbitX,this.rabbitY,e,f),d<3*s*a&&(this.moveNode++,this.rabbitX=e,this.rabbitY=f,this.moveNode<this.myPath.length&&(e=this.myPath[this.moveNode].x,f=this.myPath[this.moveNode].y))):(e=this.myPath[this.myPath.length-1].x,f=this.myPath[this.myPath.length-1].y);this.rabbitA=cr.angleTo(this.rabbitX,this.rabbitY,e,f);d=cr.distanceTo(g.x,g.y,this.rabbitX,this.rabbitY);d<r&&this.moveNode<this.myPath.length&&(this.firstTickMovingWhileMoving?this.firstTickMovingWhileMoving=!1:r=s*a,this.rabbitX+=
Math.cos(this.rabbitA)*r,this.rabbitY+=Math.sin(this.rabbitA)*r);b=cr.angleTo(g.x,g.y,this.rabbitX,this.rabbitY);c=cr.angleDiff(this.a,b);r=cr.distanceTo(g.x,g.y,this.myPath[this.myPath.length-1].x,this.myPath[this.myPath.length-1].y);s=this.maxSpeed*this.maxSpeed/(2*this.dec);1<d&&(this.a=cr.angleRotate(this.a,b,this.av*a),0.5>=cr.to_degrees(c)?c=this.maxSpeed:120<=cr.to_degrees(c)||this.movingFromStopped&&0===this.moveNode?(c=0,this.movingFromStopped=!0):(b=c/this.av,d=cr.distanceTo(g.x,g.y,this.rabbitX,
this.rabbitY),d/=2*Math.sin(c),c=d*c/b,0>c&&(c=0),c>this.maxSpeed&&(c=this.maxSpeed)),r<s&&(c=Math.min(c,r/s*this.maxSpeed+this.maxSpeed/40)),this.s+=this.acc*a,this.s>c&&(this.s=c));g.x+=Math.cos(this.a)*this.s*a;g.y+=Math.sin(this.a)*this.s*a;this.rotateEnabled&&(this.lastKnownAngle=g.angle=this.a);g.set_bbox_changed();this.moveNode===this.myPath.length&&cr.distanceTo(g.x,g.y,e,f)<Math.max(3*this.s*a,10)&&(this.hasPath=this.isMoving=!1,this.s=this.moveNode=0,this.runtime.trigger(cr.behaviors.Pathfinding.prototype.cnds.OnArrived,
g))}};f.tick2=function(){this.enabled&&(this.generateMap(),this.doDelayFindPath())};f.doDelayFindPath=function(){this.delayFindPath&&!this.is_destroyed&&(this.delayFindPath=!1,this.doFindPath(this.inst.x,this.inst.y,this.delayPathX,this.delayPathY))};f.getMyInfo=function(){var a=""+this.cellSize+","+this.cellBorder;e.hasOwnProperty(a)||(e[a]={pathfinder:new window.Pathfinder,cells:null,regenerate:!1});return e[a]};f.generateMap=function(){var a=this.getMyInfo();if(!a.pathfinder.isReady()||a.regenerate){var b=
[];b.length=this.myHcells;var c,d,e=this.myHcells,f=this.myVcells;for(c=0;c<e;c++){b[c]=[];b[c].length=f;for(d=0;d<f;d++)b[c][d]=this.queryCellCollision(c,d)}a.cells=b;a.pathfinder.init(this.myHcells,this.myVcells,b,this.diagonalsEnabled);a.regenerate=!1}};f.clearResultPath=function(){var a,b;a=0;for(b=this.myPath.length;a<b;a++)window.freeResultNode(this.myPath[a]);this.myPath.length=0};f.copyResultPath=function(){var a=this.getMyInfo().pathfinder.pathList;this.clearResultPath();var b,c,d,e;b=0;
for(c=a.length;b<c;b++)d=a[b],e=window.allocResultNode(),e.x=(d.x+0.5)*this.cellSize,e.y=(d.y+0.5)*this.cellSize,this.myPath.push(e)};var g=new cr.rect;f.queryCellCollision=function(a,b){var c,d,e,f,p,r,s=0;g.left=a*this.cellSize-this.cellBorder;g.top=b*this.cellSize-this.cellBorder;g.right=(a+1)*this.cellSize+this.cellBorder;g.bottom=(b+1)*this.cellSize+this.cellBorder;if(0===this.obstacles){if(this.runtime.testRectOverlapSolid(g))return window.PF_OBSTACLE}else{c=0;for(d=this.type.obstacleTypes.length;c<
d;c++){e=this.type.obstacleTypes[c];f=0;for(p=e.instances.length;f<p;f++)if(this.runtime.testRectOverlap(g,e.instances[f]))return window.PF_OBSTACLE}}c=0;for(d=this.type.costTypes.length;c<d;c++){e=this.type.costTypes[c].obj;r=this.type.costTypes[c].cost;f=0;for(p=e.instances.length;f<p;f++)this.runtime.testRectOverlap(g,e.instances[f])&&(s+=r)}return s};f.doFindPath=function(a,b,c,d){var e=this.getMyInfo().pathfinder;if(!e.isReady())return!1;this.isCalculating=!0;this.calcPathX=c;this.calcPathY=
d;a=Math.floor(a/this.cellSize);b=Math.floor(b/this.cellSize);c=Math.floor(c/this.cellSize);d=Math.floor(d/this.cellSize);var f,g,r,s,t,v,y;if(e.at(c,d)===window.PF_OBSTACLE){f=1E6;for(s=r=g=0;s<this.myHcells;s++)for(t=0;t<this.myVcells;t++)e.at(s,t)!==window.PF_OBSTACLE&&(v=c-s,y=d-t,v=v*v+y*y,v<f&&(f=v,g=s,r=t));c=g;d=r}e.findPath(a,b,c,d,this.pathSuccessFn,this.pathFailFn)};f.onLayoutChange=function(){this.getMyInfo().regenerate=!0};a.prototype.OnPathFound=function(){return!0};a.prototype.OnFailedToFindPath=
function(){return!0};a.prototype.IsCellObstacle=function(a,b){return this.getMyInfo().pathfinder.at(a,b)===window.PF_OBSTACLE};a.prototype.IsCalculatingPath=function(){return this.isCalculating};a.prototype.IsMoving=function(){return this.isMoving};a.prototype.OnArrived=function(){return!0};a.prototype.CompareSpeed=function(a,b){return cr.do_cmp(this.s,a,b)};a.prototype.DiagonalsEnabled=function(a,b){return this.diagonalsEnabled};d.cnds=new a;b.prototype.FindPath=function(a,b){this.enabled&&(this.isCalculating||
!this.getMyInfo().pathfinder.isReady()?(this.delayFindPath=!0,this.delayPathX=a,this.delayPathY=b):this.doFindPath(this.inst.x,this.inst.y,a,b))};b.prototype.StartMoving=function(){this.hasPath&&(this.isMoving&&(this.firstTickMovingWhileMoving=!0),this.movingFromStopped=!this.isMoving,this.isMoving=!0,this.rabbitX=this.inst.x,this.rabbitY=this.inst.y,this.rabbitA=this.inst.angle)};b.prototype.Stop=function(){this.isMoving=!1};b.prototype.SetEnabled=function(a){this.enabled=0!==a};b.prototype.RegenerateMap=
function(){this.getMyInfo().regenerate=!0};b.prototype.AddObstacle=function(a){var b=this.type.obstacleTypes;if(-1===b.indexOf(a)){var c,d,e;c=0;for(d=b.length;c<d;c++)if(e=b[c],e.is_family&&-1!==e.members.indexOf(a))return;b.push(a)}};b.prototype.ClearObstacles=function(){this.type.obstacleTypes.length=0};b.prototype.AddCost=function(a,b){var c=this.type.costTypes,d,e,f;d=0;for(e=c.length;d<e;d++)if(f=c[d].obj,f===a||f.is_family&&-1!==f.members.indexOf(a))return;c.push({obj:a,cost:b})};b.prototype.ClearCost=
function(){this.type.costTypes.length=0};b.prototype.SetMaxSpeed=function(a){this.maxSpeed=a};b.prototype.SetSpeed=function(a){0>a&&(a=0);a>this.maxSpeed&&(a=this.maxSpeed);this.s=a};b.prototype.SetAcc=function(a){this.acc=a};b.prototype.SetDec=function(a){this.dec=a};b.prototype.SetRotateSpeed=function(a){this.av=cr.to_radians(a)};b.prototype.SetDiagonalsEnabled=function(a){this.diagonalsEnabled=0!==a;this.getMyInfo().pathfinder.setDiagonals(this.diagonalsEnabled)};d.acts=new b;c.prototype.NodeCount=
function(a){a.set_int(this.myPath.length)};c.prototype.NodeXAt=function(a,b){b=Math.floor(b);0>b||b>=this.myPath.length?a.set_float(0):a.set_float(this.myPath[b].x)};c.prototype.NodeYAt=function(a,b){b=Math.floor(b);0>b||b>=this.myPath.length?a.set_float(0):a.set_float(this.myPath[b].y)};c.prototype.CellSize=function(a){a.set_int(this.cellSize)};c.prototype.RabbitX=function(a){a.set_float(this.rabbitX)};c.prototype.RabbitY=function(a){a.set_float(this.rabbitY)};c.prototype.MaxSpeed=function(a){a.set_float(this.maxSpeed)};
c.prototype.Acceleration=function(a){a.set_float(this.acc)};c.prototype.Deceleration=function(a){a.set_float(this.dec)};c.prototype.RotateSpeed=function(a){a.set_float(cr.to_degrees(this.av))};c.prototype.MovingAngle=function(a){a.set_float(cr.to_degrees(this.a))};c.prototype.CurrentNode=function(a){a.set_int(this.moveNode)};c.prototype.Speed=function(a){a.set_float(this.isMoving?this.s:0)};d.exps=new c})();var Box2D={Dynamics:{}};Box2D.Dynamics.Joints={};Box2D.Common={};Box2D.Common.Math={};
Box2D.Collision={};Box2D.Collision.Shapes={};function c2inherit(a,b){for(var c in b.prototype)b.prototype.hasOwnProperty(c)&&(a.prototype[c]=b.prototype[c])}
if(navigator.isCocoonJS&&"undefined"!==typeof window.cr_cjs_accelerated_physics)cr.logexport("Using CocoonJS native physics"),!window.ext||"undefined"===typeof window.ext.IDTK_SRV_BOX2D?console.log("The CocoonJS binding for Box2D has been ignored because ext.IDTK_SRV_BOX2D is not available"):function(){var a=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);this.x=a;this.y=b};Box2D.Common.Math.b2Vec2=a;a._freeCache=[];a.Get=function(a,b){if(0<Box2D.Common.Math.b2Vec2._freeCache.length){var c=Box2D.Common.Math.b2Vec2._freeCache.pop();
c.Set(a,b);return c}return new Box2D.Common.Math.b2Vec2(a,b)};a.Free=function(a){1E4>Box2D.Common.Math.b2Vec2._freeCache.length&&Box2D.Common.Math.b2Vec2._freeCache.push(a)};a.prototype.SetZero=function(){this.y=this.x=0};a.prototype.Set=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);this.x=a;this.y=b};a.prototype.SetV=function(a){this.x=a.x;this.y=a.y};a.Make=function(b,c){void 0===b&&(b=0);void 0===c&&(c=0);return a.Get(b,c)};a.prototype.Copy=function(){return a.Get(this.x,this.y)};a.prototype.Add=
function(a){this.x+=a.x;this.y+=a.y};a.prototype.Subtract=function(a){this.x-=a.x;this.y-=a.y};a.prototype.Multiply=function(a){void 0===a&&(a=0);this.x*=a;this.y*=a};a.prototype.Length=function(){return Math.sqrt(this.x*this.x+this.y*this.y)};a.prototype.LengthSquared=function(){return this.x*this.x+this.y*this.y};a.prototype.Normalize=function(){var a=Math.sqrt(this.x*this.x+this.y*this.y);if(a<Number.MIN_VALUE)return 0;var b=1/a;this.x*=b;this.y*=b;return a};var b=function(){this.col1=a.Get(0,
0);this.col2=a.Get(0,0);this.SetIdentity()};Box2D.Common.Math.b2Mat22=b;b.FromAngle=function(a){void 0===a&&(a=0);var c=new b;c.Set(a);return c};b.FromVV=function(a,c){var d=new b;d.SetVV(a,c);return d};b.prototype.Set=function(a){void 0===a&&(a=0);var b=Math.cos(a);a=Math.sin(a);this.col1.x=b;this.col2.x=-a;this.col1.y=a;this.col2.y=b};b.prototype.SetVV=function(a,b){this.col1.SetV(a);this.col2.SetV(b)};b.prototype.Copy=function(){var a=new b;a.SetM(this);return a};b.prototype.SetM=function(a){this.col1.SetV(a.col1);
this.col2.SetV(a.col2)};b.prototype.AddM=function(a){this.col1.x+=a.col1.x;this.col1.y+=a.col1.y;this.col2.x+=a.col2.x;this.col2.y+=a.col2.y};b.prototype.SetIdentity=function(){this.col1.x=1;this.col2.x=0;this.col1.y=0;this.col2.y=1};b.prototype.SetZero=function(){this.col1.x=0;this.col2.x=0;this.col1.y=0;this.col2.y=0};b.prototype.GetAngle=function(){return Math.atan2(this.col1.y,this.col1.x)};b.prototype.GetInverse=function(a){var b=this.col1.x,c=this.col2.x,d=this.col1.y,e=this.col2.y,f=b*e-c*
d;0!==f&&(f=1/f);a.col1.x=f*e;a.col2.x=-f*c;a.col1.y=-f*d;a.col2.y=f*b;return a};b.prototype.Solve=function(a,b,c){void 0===b&&(b=0);void 0===c&&(c=0);var d=this.col1.x,e=this.col2.x,f=this.col1.y,g=this.col2.y,h=d*g-e*f;0!==h&&(h=1/h);a.x=h*(g*b-e*c);a.y=h*(d*c-f*b);return a};b.prototype.Abs=function(){this.col1.Abs();this.col2.Abs()};var c=function(c,d){this.position=a.Get(0,0);this.R=new b;void 0===c&&(c=null);void 0===d&&(d=null);c&&(this.position.SetV(c),this.R.SetM(d))};Box2D.Common.Math.b2Transform=
c;c.prototype.Initialize=function(a,b){this.position.SetV(a);this.R.SetM(b)};c.prototype.SetIdentity=function(){this.position.SetZero();this.R.SetIdentity()};c.prototype.Set=function(a){this.position.SetV(a.position);this.R.SetM(a.R)};c.prototype.SetAngle=function(){return Math.atan2(this.R.col1.y,this.R.col1.x)};var d=function(){};Box2D.Common.Math.b2Math=d;d.IsValid=function(a){void 0===a&&(a=0);return isFinite(a)};d.Dot=function(a,b){return a.x*b.x+a.y*b.y};d.CrossVV=function(a,b){return a.x*b.y-
a.y*b.x};d.CrossVF=function(b,c){void 0===c&&(c=0);return a.Get(c*b.y,-c*b.x)};d.CrossFV=function(b,c){void 0===b&&(b=0);return a.Get(-b*c.y,b*c.x)};d.MulMV=function(b,c){return a.Get(b.col1.x*c.x+b.col2.x*c.y,b.col1.y*c.x+b.col2.y*c.y)};d.MulTMV=function(b,c){return a.Get(d.Dot(c,b.col1),d.Dot(c,b.col2))};d.MulX=function(a,b){var c=d.MulMV(a.R,b);c.x+=a.position.x;c.y+=a.position.y;return c};d.MulXT=function(a,b){var c=d.SubtractVV(b,a.position),e=c.x*a.R.col1.x+c.y*a.R.col1.y;c.y=c.x*a.R.col2.x+
c.y*a.R.col2.y;c.x=e;return c};d.AddVV=function(b,c){return a.Get(b.x+c.x,b.y+c.y)};d.SubtractVV=function(b,c){return a.Get(b.x-c.x,b.y-c.y)};d.Distance=function(a,b){var c=a.x-b.x,d=a.y-b.y;return Math.sqrt(c*c+d*d)};d.DistanceSquared=function(a,b){var c=a.x-b.x,d=a.y-b.y;return c*c+d*d};d.MulFV=function(b,c){void 0===b&&(b=0);return a.Get(b*c.x,b*c.y)};d.AddMM=function(a,c){return b.FromVV(d.AddVV(a.col1,c.col1),d.AddVV(a.col2,c.col2))};d.MulMM=function(a,c){return b.FromVV(d.MulMV(a,c.col1),d.MulMV(a,
c.col2))};d.MulTMM=function(c,e){var f=a.Get(d.Dot(c.col1,e.col1),d.Dot(c.col2,e.col1)),g=a.Get(d.Dot(c.col1,e.col2),d.Dot(c.col2,e.col2));return b.FromVV(f,g)};d.Abs=function(a){void 0===a&&(a=0);return 0<a?a:-a};d.AbsV=function(b){return a.Get(d.Abs(b.x),d.Abs(b.y))};d.AbsM=function(a){return b.FromVV(d.AbsV(a.col1),d.AbsV(a.col2))};d.Min=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);return a<b?a:b};d.MinV=function(b,c){return a.Get(d.Min(b.x,c.x),d.Min(b.y,c.y))};d.Max=function(a,b){void 0===
a&&(a=0);void 0===b&&(b=0);return a>b?a:b};d.MaxV=function(b,c){return a.Get(d.Max(b.x,c.x),d.Max(b.y,c.y))};d.Clamp=function(a,b,c){void 0===a&&(a=0);void 0===b&&(b=0);void 0===c&&(c=0);return a<b?b:a>c?c:a};d.ClampV=function(a,b,c){return d.MaxV(b,d.MinV(a,c))};d.Swap=function(a,b){var c=a[0];a[0]=b[0];b[0]=c};d.Random=function(){return 2*Math.random()-1};d.RandomRange=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);var c=Math.random();return(b-a)*c+a};d.NextPowerOfTwo=function(a){void 0===a&&
(a=0);a|=a>>1&2147483647;a|=a>>2&1073741823;a|=a>>4&268435455;a|=a>>8&16777215;return(a|a>>16&65535)+1};d.IsPowerOfTwo=function(a){void 0===a&&(a=0);return 0<a&&0===(a&a-1)};d.b2Vec2_zero=new a(0,0);d.b2Mat22_identity=b.FromVV(new a(1,0),new a(0,1));d.b2Transform_identity=new c(d.b2Vec2_zero,d.b2Mat22_identity);var e=function(){this.e_aabbBit=4;this.e_centerOfMassBit=16;this.e_controllerBit=32;this.e_jointBit=2;this.e_pairBit=8;this.e_shapeBit=0};Box2D.Dynamics.b2DebugDraw=e;e.prototype.AppendFlags=
function(){};e.prototype.ClearFlags=function(){};e.prototype.DrawCircle=function(){};e.prototype.DrawPolygon=function(){};e.prototype.DrawSegment=function(){};e.prototype.DrawSolidCircle=function(){};e.prototype.DrawSolidPolygon=function(){};e.prototype.DrawTransform=function(){};e.prototype.GetAlpha=function(){};e.prototype.GetDrawScale=function(){};e.prototype.GetFillAlpha=function(){};e.prototype.GetFlags=function(){};e.prototype.GetLineThickness=function(){};e.prototype.GetSprite=function(){};
e.prototype.GetXFormScale=function(){};e.prototype.SetAlpha=function(){};e.prototype.SetDrawScale=function(){};e.prototype.SetFillAlpha=function(){};e.prototype.SetFlags=function(){};e.prototype.SetLineThickness=function(){};e.prototype.SetSprite=function(){};e.prototype.SetXFormScale=function(){};Box2D.Dynamics.b2BodyDef=function(){this.position=a.Get(0,0);this.linearVelocity=a.Get(0,0);this.userData=null;this.angle=0;this.linearVelocity.Set(0,0);this.angularDamping=this.linearDamping=this.angularVelocity=
0;this.awake=this.allowSleep=!0;this.bullet=this.fixedRotation=!1;this.type=g.b2_staticBody;this.active=!0;this.inertiaScale=1};var f=function(b,c,d,e){this.m_body=b;this.m_userData=c;this.m_fixtureID=d;this.m_shape={};this.m_shape.m_centroid=a.Get(0,0);this.m_isSensor=!1;this.m_density=e.density;this.m_friction=e.friction;this.m_restitution=e.restitution;this.m_isSensor=e.isSensor};Box2D.Dynamics.b2Fixture=f;f.prototype.GetBody=function(){return this.m_body};f.prototype.GetShape=function(){console.log("fixture.GetShape not yet supported in CocoonJS Box2D binding");
return null};f.prototype.GetUserData=function(){return this.m_userData};f.prototype.SetSensor=function(a){this.m_isSensor=a;window.ext.IDTK_SRV_BOX2D.makeCall("setSensor",this.m_body.m_world.m_worldID,this.m_fixtureID,this.m_isSensor)};f.prototype.IsSensor=function(){return this.m_isSensor};f.prototype.SetDensity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setDensity",this.m_body.m_world.m_worldID,this.m_fixtureID,a);this.m_density=a};f.prototype.SetFriction=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setFriction",
this.m_body.m_world.m_worldID,this.m_fixtureID,a);this.m_friction=a};f.prototype.SetRestitution=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setRestitution",this.m_body.m_world.m_worldID,this.m_fixtureID,a);this.m_restitution=a};f.prototype.GetDensity=function(){return this.m_density};f.prototype.GetFriction=function(){return this.m_friction};f.prototype.GetRestitution=function(){return this.m_restitution};var g=function(a,d){var e=a.userData;a.userData=null;this.m_world=d;this.m_xf=new c(a.position,
b.FromAngle(a.angle));this.m_fixtures=[];this.m_active=a.active;a.type===g.b2_staticBody&&(a.density=0);this.m_bodyID=window.ext.IDTK_SRV_BOX2D.makeCall("createBody",d.m_worldID,a);this.m_userData=e;a.userData=e};Box2D.Dynamics.b2Body=g;g.prototype.CreateFixture=function(a){var b=a.userData;a.userData=null;var c=window.ext.IDTK_SRV_BOX2D.makeCall("createFixture",this.m_world.m_worldID,this.m_bodyID,a);a.userData=b;a=new f(this,b,c,a);this.m_world.m_fixturesList[c]=a;this.m_fixtures.push(a);return a};
g.prototype.GetFixtureList=function(){return 0===this.m_fixtures.length?null:this.m_fixtures[0]};g.prototype.DestroyFixture=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("deleteFixture",this.m_world.m_worldID,a.m_fixtureID);delete this.m_world.m_fixturesList[a.m_fixtureID]};g.prototype.SetPositionAndAngle=function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("setBodyTransform",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b);this.m_xf.R.Set(b);this.m_xf.position.SetV(a)};g.prototype.GetPosition=function(){return this.m_xf.position};
g.prototype.SetPosition=function(a){this.SetPositionAndAngle(a,this.GetAngle())};g.prototype.GetLinearVelocity=function(){var b=window.ext.IDTK_SRV_BOX2D.makeCall("getLinearVelocity",this.m_world.m_worldID,this.m_bodyID);return a.Get(b[0],b[1])};g.prototype.GetWorldCenter=function(){var b=window.ext.IDTK_SRV_BOX2D.makeCall("getWorldCenter",this.m_world.m_worldID,this.m_bodyID);return a.Get(b[0],b[1])};g.prototype.GetLocalCenter=function(){var b=window.ext.IDTK_SRV_BOX2D.makeCall("getLocalCenter",
this.m_world.m_worldID,this.m_bodyID);return a.Get(b[0],b[1])};g.prototype.ApplyImpulse=function(a,b,c){window.ext.IDTK_SRV_BOX2D.makeCall("applyImpulse",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b.x,b.y,c)};g.prototype.IsAwake=function(){return window.ext.IDTK_SRV_BOX2D.makeCall("isAwake",this.m_world.m_worldID,this.m_bodyID)};g.prototype.GetAngularVelocity=function(){return window.ext.IDTK_SRV_BOX2D.makeCall("getAngularVelocity",this.m_world.m_worldID,this.m_bodyID)};g.prototype.SetAwake=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setAwake",
this.m_world.m_worldID,this.m_bodyID,a)};g.prototype.SetLinearVelocity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setLinearVelocity",this.m_world.m_worldID,this.m_bodyID,a.x,a.y)};g.prototype.ApplyForceToCenter=function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("applyForceToCenter",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b)};g.prototype.ApplyForce=function(a,b,c){window.ext.IDTK_SRV_BOX2D.makeCall("applyForce",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b.x,b.y,c)};g.prototype.ApplyTorque=
function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("applyTorque",this.m_world.m_worldID,this.m_bodyID,a,b)};g.prototype.SetLinearDamping=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setLinearDamping",this.m_world.m_worldID,this.m_bodyID,a)};g.prototype.SetAngularVelocity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setAngularVelocity",this.m_world.m_worldID,this.m_bodyID,a)};g.prototype.SetType=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setType",this.m_world.m_worldID,this.m_bodyID,a)};g.prototype.SetActive=
function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setActive",this.m_world.m_worldID,this.m_bodyID,a);this.m_active=a};g.prototype.IsActive=function(){return this.m_active};g.prototype.GetAngle=function(){return this.m_xf.R.GetAngle()};g.prototype.SetAngle=function(a){void 0===a&&(a=0);this.SetPositionAndAngle(this.GetPosition(),a)};g.prototype.GetContactList=function(){for(var a=window.ext.IDTK_SRV_BOX2D.makeCall("getObjectContacts",this.m_world.m_worldID,this.m_bodyID),b=[],c=0;c<a.length;c++)b.push(this.m_world.m_bodyList[a[c]]);
return b};g.prototype.SetUserData=function(a){this.m_userData=a};g.prototype.GetUserData=function(){return this.m_userData};g.prototype.GetWorld=function(){return this.m_world};Box2D.Dynamics.b2Body.b2_staticBody=0;Box2D.Dynamics.b2Body.b2_kinematicBody=1;Box2D.Dynamics.b2Body.b2_dynamicBody=2;var h=function(a,b,c){this.m_fixtureA=a;this.m_fixtureB=b;this.m_touching=c};Box2D.Dynamics.b2Contact=h;h.prototype.GetFixtureA=function(){return this.m_fixtureA};h.prototype.GetFixtureB=function(){return this.m_fixtureB};
h.prototype.IsTouching=function(){return this.m_touching};e=function(){};Box2D.Dynamics.b2ContactListener=e;e.prototype.BeginContact=function(){};e.prototype.EndContact=function(){};e.prototype.PreSolve=function(){};e.prototype.PostSolve=function(){};Box2D.Dynamics.b2ContactListener.b2_defaultListener=new e;window.Box2D.Dynamics.b2ContactFilter=function(){};e=function(a,b){this.m_bodyList=[];this.m_jointList=[];this.m_fixturesList=[];this.m_contactListener=null;this.m_jointsList=[];this.m_worldID=
window.ext.IDTK_SRV_BOX2D.makeCall("createWorld",a.x,a.y,b)};Box2D.Dynamics.b2World=e;e.prototype.SetContactListener=function(a){this.m_contactListener=a};e.prototype.SetContactFilter=function(a){var b=this;window.ext.IDTK_SRV_BOX2D.makeCall("setContactFilter",function(c,d){return a.ShouldCollide(b.m_fixturesList[c],b.m_fixturesList[d])})};e.prototype.CreateBody=function(a){a=new g(a,this);return this.m_bodyList[a.m_bodyID]=a};e.prototype.DestroyBody=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("deleteBody",
this.m_worldID,a.m_bodyID);delete this.m_bodyList[a.m_bodyID];for(var b=0;b<a.m_fixtures.length;++b)delete this.m_fixturesList[a.m_fixtures[b].m_fixtureID]};e.prototype.CreateJoint=function(a){if(a.bodyA.m_bodyID!==a.bodyB.m_bodyID){var b=a.bodyA,c=a.bodyB;a.bodyA=b.m_bodyID;a.bodyB=c.m_bodyID;window.ext.IDTK_SRV_BOX2D.makeCall("createDistanceJoint",this.m_worldID,a);a.bodyA=b;a.bodyB=c;a=new l(a);this.m_jointsList.push(a);return a}};e.prototype.GetJointList=function(){if(0===this.m_jointsList.length)return null;
for(var a=0;a<this.m_jointsList.length-1;++a)this.m_jointsList[a].next=this.m_jointsList[a+1];this.m_jointsList[this.m_jointsList.length-1].next=null;return this.m_jointsList[0]};e.prototype.SetContinuousPhysics=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setContinuous",this.m_worldID,a)};e.prototype.SetGravity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setGravity",this.m_worldID,a.x,a.y)};e.prototype.Step=function(a,b,c){c=window.ext.IDTK_SRV_BOX2D.makeCall("step",this.m_worldID,a,b,c);
b=c[0];for(a=1;a<=4*b;a+=4){var d=this.m_bodyList[c[a+0]];if(null===d)break;d.m_xf.position.Set(c[a+1],c[a+2]);d.m_xf.R.Set(c[a+3])}if(null!==this.m_contactListener){c=window.ext.IDTK_SRV_BOX2D.makeCall("getLastContacts",this.m_worldID);b=c[0];for(a=1;a<=3*b;a+=3){var d=c[a+2],e=this.m_fixturesList[c[a+0]],f=this.m_fixturesList[c[a+1]];"undefined"===typeof e||"undefined"===typeof f?console.log("One of the fixtures in a contact DOESN'T EXIST!!"):this.m_contactListener.BeginContact(new h(e,f,d))}}};
e.prototype.ClearForces=function(){window.ext.IDTK_SRV_BOX2D.makeCall("clearForces",this.m_worldID)};e.prototype.SetDebugDraw=function(){};e.prototype.DrawDebugData=function(){};Box2D.Collision.Shapes.b2CircleShape=function(a){this.radius=a;this.type="circle"};Box2D.Collision.Shapes.b2PolygonShape=function(){};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsBox=function(a,b){this.type="box";this.width=a;this.height=b};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsEdge=function(a,b){this.type=
"edge";this.p1x=a.x;this.p1y=a.y;this.p2x=b.x;this.p2y=b.y};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsArray=function(a,b){this.type="polygon";this.vertices=[];for(var c=0;c<b;c++)this.vertices.push(a[c].x),this.vertices.push(a[c].y)};Box2D.Dynamics.b2FixtureDef=function(){this.userData=this.shape=null;this.friction=0.2;this.density=this.restitution=0;this.isSensor=!1;this.filter={categoryBits:1,maskBits:65535,groupIndex:0}};var l=function(a){this.bodyA=a.bodyA;this.bodyB=a.bodyB;this.userData=
a.userData;this.type=a.type;this.next=null};Box2D.Dynamics.Joints.b2Joint=l;l.prototype.GetBodyA=function(){return this.bodyA};l.prototype.GetBodyB=function(){return this.bodyB};l.prototype.GetUserData=function(){return this.userData};l.prototype.GetType=function(){return this.type};l.prototype.GetNext=function(){return this.next};l.e_distanceJoint=0;Box2D.Dynamics.Joints.b2DistanceJointDef=function(b,c,d,e){this.type=l.e_distanceJoint;this.localAnchorA=a.Get(0,0);this.localAnchorB=a.Get(0,0);this.userData=
null;void 0!==b&&(this.bodyA=b);void 0!==c&&(this.bodyB=c);void 0!==d&&this.localAnchorA.SetV(d);void 0!==e&&this.localAnchorB.SetV(e);void 0!==d&&void 0!==e&&(b=e.x-d.x,d=e.y-d.y,this.length=Math.sqrt(b*b+d*d));this.dampingRatio=this.frequencyHz=0}}();else{Box2D.Collision.b2Collision={};Box2D.Collision.b2Distance={};Box2D.Common.b2Settings={};Box2D.Common.Math.b2Math={};Box2D.Consts={};Box2D.Dynamics.Contacts={};Box2D.Dynamics.Controllers={};Box2D.generateCallback=function(a,b){return function(){b.apply(a,
arguments)}};Box2D.Consts.MIN_VALUE_SQUARED=Number.MIN_VALUE*Number.MIN_VALUE;Box2D.Common.b2Settings.b2MixFriction=function(a,b){return Math.sqrt(a*b)};Box2D.Common.b2Settings.b2MixRestitution=function(a,b){return a>b?a:b};Box2D.Common.b2Settings.VERSION="2.1alpha-illandril";Box2D.Common.b2Settings.USHRT_MAX=65535;Box2D.Common.b2Settings.b2_maxManifoldPoints=2;Box2D.Common.b2Settings.b2_aabbExtension=0.1;Box2D.Common.b2Settings.b2_aabbMultiplier=2;Box2D.Common.b2Settings.b2_polygonRadius=2*Box2D.Common.b2Settings.b2_linearSlop;
Box2D.Common.b2Settings.b2_linearSlop=0.0050;Box2D.Common.b2Settings.b2_angularSlop=2/180*Math.PI;Box2D.Common.b2Settings.b2_toiSlop=8*Box2D.Common.b2Settings.b2_linearSlop;Box2D.Common.b2Settings.b2_maxTOIContactsPerIsland=32;Box2D.Common.b2Settings.b2_maxTOIJointsPerIsland=32;Box2D.Common.b2Settings.b2_velocityThreshold=1;Box2D.Common.b2Settings.b2_maxLinearCorrection=0.2;Box2D.Common.b2Settings.b2_maxAngularCorrection=8/180*Math.PI;Box2D.Common.b2Settings.b2_maxTranslation=2;Box2D.Common.b2Settings.b2_maxTranslationSquared=
Box2D.Common.b2Settings.b2_maxTranslation*Box2D.Common.b2Settings.b2_maxTranslation;Box2D.Common.b2Settings.b2_maxRotation=0.5*Math.PI;Box2D.Common.b2Settings.b2_maxRotationSquared=Box2D.Common.b2Settings.b2_maxRotation*Box2D.Common.b2Settings.b2_maxRotation;Box2D.Common.b2Settings.b2_contactBaumgarte=0.2;Box2D.Common.b2Settings.b2_timeToSleep=0.5;Box2D.Common.b2Settings.b2_linearSleepTolerance=0.01;Box2D.Common.b2Settings.b2_linearSleepToleranceSquared=Box2D.Common.b2Settings.b2_linearSleepTolerance*
Box2D.Common.b2Settings.b2_linearSleepTolerance;Box2D.Common.b2Settings.b2_angularSleepTolerance=2/180*Math.PI;Box2D.Common.b2Settings.b2_angularSleepToleranceSquared=Box2D.Common.b2Settings.b2_angularSleepTolerance*Box2D.Common.b2Settings.b2_angularSleepTolerance;Box2D.Common.b2Settings.MIN_VALUE_SQUARED=Number.MIN_VALUE*Number.MIN_VALUE;Box2D.Common.Math.b2Math.Dot=function(a,b){return a.x*b.x+a.y*b.y};Box2D.Common.Math.b2Math.CrossVV=function(a,b){return a.x*b.y-a.y*b.x};Box2D.Common.Math.b2Math.CrossVF=
function(a,b){return Box2D.Common.Math.b2Vec2.Get(b*a.y,-b*a.x)};Box2D.Common.Math.b2Math.CrossFV=function(a,b){return Box2D.Common.Math.b2Vec2.Get(-a*b.y,a*b.x)};Box2D.Common.Math.b2Math.MulMV=function(a,b){return Box2D.Common.Math.b2Vec2.Get(a.col1.x*b.x+a.col2.x*b.y,a.col1.y*b.x+a.col2.y*b.y)};Box2D.Common.Math.b2Math.MulTMV=function(a,b){return Box2D.Common.Math.b2Vec2.Get(Box2D.Common.Math.b2Math.Dot(b,a.col1),Box2D.Common.Math.b2Math.Dot(b,a.col2))};Box2D.Common.Math.b2Math.MulX=function(a,
b){var c=Box2D.Common.Math.b2Math.MulMV(a.R,b);c.x+=a.position.x;c.y+=a.position.y;return c};Box2D.Common.Math.b2Math.MulXT=function(a,b){var c=Box2D.Common.Math.b2Math.SubtractVV(b,a.position),d=c.x*a.R.col1.x+c.y*a.R.col1.y;c.y=c.x*a.R.col2.x+c.y*a.R.col2.y;c.x=d;return c};Box2D.Common.Math.b2Math.AddVV=function(a,b){return Box2D.Common.Math.b2Vec2.Get(a.x+b.x,a.y+b.y)};Box2D.Common.Math.b2Math.SubtractVV=function(a,b){return Box2D.Common.Math.b2Vec2.Get(a.x-b.x,a.y-b.y)};Box2D.Common.Math.b2Math.Distance=
function(a,b){return Math.sqrt(Box2D.Common.Math.b2Math.DistanceSquared(a,b))};Box2D.Common.Math.b2Math.DistanceSquared=function(a,b){var c=a.x-b.x,d=a.y-b.y;return c*c+d*d};Box2D.Common.Math.b2Math.MulFV=function(a,b){return Box2D.Common.Math.b2Vec2.Get(a*b.x,a*b.y)};Box2D.Common.Math.b2Math.AddMM=function(a,b){return Box2D.Common.Math.b2Mat22.FromVV(Box2D.Common.Math.b2Math.AddVV(a.col1,b.col1),Box2D.Common.Math.b2Math.AddVV(a.col2,b.col2))};Box2D.Common.Math.b2Math.MulMM=function(a,b){return Box2D.Common.Math.b2Mat22.FromVV(Box2D.Common.Math.b2Math.MulMV(a,
b.col1),Box2D.Common.Math.b2Math.MulMV(a,b.col2))};Box2D.Common.Math.b2Math.MulTMM=function(a,b){var c=Box2D.Common.Math.b2Vec2.Get(Box2D.Common.Math.b2Math.Dot(a.col1,b.col1),Box2D.Common.Math.b2Math.Dot(a.col2,b.col1)),d=Box2D.Common.Math.b2Vec2.Get(Box2D.Common.Math.b2Math.Dot(a.col1,b.col2),Box2D.Common.Math.b2Math.Dot(a.col2,b.col2));return Box2D.Common.Math.b2Mat22.FromVV(c,d)};Box2D.Common.Math.b2Math.AbsV=function(a){return Box2D.Common.Math.b2Vec2.Get(Math.abs(a.x),Math.abs(a.y))};Box2D.Common.Math.b2Math.AbsM=
function(a){return Box2D.Common.Math.b2Mat22.FromVV(Box2D.Common.Math.b2Math.AbsV(a.col1),Box2D.Common.Math.b2Math.AbsV(a.col2))};Box2D.Common.Math.b2Math.Clamp=function(a,b,c){return a<b?b:a>c?c:a};Box2D.Common.Math.b2Math.ClampV=function(a,b,c){var d=Box2D.Common.Math.b2Math.Clamp(a.x,b.x,c.x);a=Box2D.Common.Math.b2Math.Clamp(a.y,b.y,c.y);return Box2D.Common.Math.b2Vec2.Get(d,a)};Box2D.Common.Math.b2Mat22=function(){this.col1=Box2D.Common.Math.b2Vec2.Get(0,0);this.col2=Box2D.Common.Math.b2Vec2.Get(0,
0);this.SetIdentity()};Box2D.Common.Math.b2Mat22.FromAngle=function(a){var b=new Box2D.Common.Math.b2Mat22;b.Set(a);return b};Box2D.Common.Math.b2Mat22.FromVV=function(a,b){var c=new Box2D.Common.Math.b2Mat22;c.SetVV(a,b);return c};Box2D.Common.Math.b2Mat22.prototype.Set=function(a){var b=Math.cos(a);a=Math.sin(a);this.col1.Set(b,a);this.col2.Set(-a,b)};Box2D.Common.Math.b2Mat22.prototype.SetVV=function(a,b){this.col1.SetV(a);this.col2.SetV(b)};Box2D.Common.Math.b2Mat22.prototype.Copy=function(){var a=
new Box2D.Common.Math.b2Mat22;a.SetM(this);return a};Box2D.Common.Math.b2Mat22.prototype.SetM=function(a){this.col1.SetV(a.col1);this.col2.SetV(a.col2)};Box2D.Common.Math.b2Mat22.prototype.AddM=function(a){this.col1.Add(a.col1);this.col2.Add(a.col2)};Box2D.Common.Math.b2Mat22.prototype.SetIdentity=function(){this.col1.Set(1,0);this.col2.Set(0,1)};Box2D.Common.Math.b2Mat22.prototype.SetZero=function(){this.col1.Set(0,0);this.col2.Set(0,0)};Box2D.Common.Math.b2Mat22.prototype.GetAngle=function(){return Math.atan2(this.col1.y,
this.col1.x)};Box2D.Common.Math.b2Mat22.prototype.GetInverse=function(a){var b=this.col1.x*this.col2.y-this.col2.x*this.col1.y;0!==b&&(b=1/b);a.col1.x=b*this.col2.y;a.col2.x=-b*this.col2.x;a.col1.y=-b*this.col1.y;a.col2.y=b*this.col1.x;return a};Box2D.Common.Math.b2Mat22.prototype.Solve=function(a,b,c){var d=this.col1.x*this.col2.y-this.col2.x*this.col1.y;0!==d&&(d=1/d);a.x=d*(this.col2.y*b-this.col2.x*c);a.y=d*(this.col1.x*c-this.col1.y*b);return a};Box2D.Common.Math.b2Mat22.prototype.Abs=function(){this.col1.Abs();
this.col2.Abs()};Box2D.Common.Math.b2Mat33=function(a,b,c){this.col1=new Box2D.Common.Math.b2Vec3(0,0,0);this.col2=new Box2D.Common.Math.b2Vec3(0,0,0);this.col3=new Box2D.Common.Math.b2Vec3(0,0,0);a&&this.col1.SetV(a);b&&this.col2.SetV(b);c&&this.col3.SetV(c)};Box2D.Common.Math.b2Mat33.prototype.SetVVV=function(a,b,c){this.col1.SetV(a);this.col2.SetV(b);this.col3.SetV(c)};Box2D.Common.Math.b2Mat33.prototype.Copy=function(){return new Box2D.Common.Math.b2Mat33(this.col1,this.col2,this.col3)};Box2D.Common.Math.b2Mat33.prototype.SetM=
function(a){this.col1.SetV(a.col1);this.col2.SetV(a.col2);this.col3.SetV(a.col3)};Box2D.Common.Math.b2Mat33.prototype.AddM=function(a){this.col1.x+=a.col1.x;this.col1.y+=a.col1.y;this.col1.z+=a.col1.z;this.col2.x+=a.col2.x;this.col2.y+=a.col2.y;this.col2.z+=a.col2.z;this.col3.x+=a.col3.x;this.col3.y+=a.col3.y;this.col3.z+=a.col3.z};Box2D.Common.Math.b2Mat33.prototype.SetIdentity=function(){this.col1.Set(1,0,0);this.col2.Set(0,1,0);this.col3.Set(0,0,1)};Box2D.Common.Math.b2Mat33.prototype.SetZero=
function(){this.col1.Set(0,0,0);this.col2.Set(0,0,0);this.col3.Set(0,0,0)};Box2D.Common.Math.b2Mat33.prototype.Solve22=function(a,b,c){var d=this.col1.x,e=this.col2.x,f=this.col1.y,g=this.col2.y,h=d*g-e*f;0!=h&&(h=1/h);a.x=h*(g*b-e*c);a.y=h*(d*c-f*b);return a};Box2D.Common.Math.b2Mat33.prototype.Solve33=function(a,b,c,d){var e=this.col1.x,f=this.col1.y,g=this.col1.z,h=this.col2.x,l=this.col2.y,k=this.col2.z,m=this.col3.x,n=this.col3.y,q=this.col3.z,p=e*(l*q-k*n)+f*(k*m-h*q)+g*(h*n-l*m);0!=p&&(p=1/
p);a.x=p*(b*(l*q-k*n)+c*(k*m-h*q)+d*(h*n-l*m));a.y=p*(e*(c*q-d*n)+f*(d*m-b*q)+g*(b*n-c*m));a.z=p*(e*(l*d-k*c)+f*(k*b-h*d)+g*(h*c-l*b));return a};Box2D.Common.Math.b2Sweep=function(){this.localCenter=Box2D.Common.Math.b2Vec2.Get(0,0);this.c0=Box2D.Common.Math.b2Vec2.Get(0,0);this.c=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Common.Math.b2Sweep.prototype.Set=function(a){this.localCenter.SetV(a.localCenter);this.c0.SetV(a.c0);this.c.SetV(a.c);this.a0=a.a0;this.a=a.a;this.t0=a.t0};Box2D.Common.Math.b2Sweep.prototype.Copy=
function(){var a=new Box2D.Common.Math.b2Sweep;a.localCenter.SetV(this.localCenter);a.c0.SetV(this.c0);a.c.SetV(this.c);a.a0=this.a0;a.a=this.a;a.t0=this.t0;return a};Box2D.Common.Math.b2Sweep.prototype.GetTransform=function(a,b){void 0===b&&(b=0);a.position.x=(1-b)*this.c0.x+b*this.c.x;a.position.y=(1-b)*this.c0.y+b*this.c.y;a.R.Set((1-b)*this.a0+b*this.a);var c=a.R;a.position.x-=c.col1.x*this.localCenter.x+c.col2.x*this.localCenter.y;a.position.y-=c.col1.y*this.localCenter.x+c.col2.y*this.localCenter.y};
Box2D.Common.Math.b2Sweep.prototype.Advance=function(a){void 0===a&&(a=0);if(this.t0<a&&1-this.t0>Number.MIN_VALUE){var b=(a-this.t0)/(1-this.t0);this.c0.x=(1-b)*this.c0.x+b*this.c.x;this.c0.y=(1-b)*this.c0.y+b*this.c.y;this.a0=(1-b)*this.a0+b*this.a;this.t0=a}};Box2D.Common.Math.b2Transform=function(a,b){this.position=Box2D.Common.Math.b2Vec2.Get(0,0);this.R=new Box2D.Common.Math.b2Mat22;a&&this.position.SetV(a);b&&this.R.SetM(b)};Box2D.Common.Math.b2Transform.prototype.Initialize=function(a,b){this.position.SetV(a);
this.R.SetM(b)};Box2D.Common.Math.b2Transform.prototype.SetIdentity=function(){this.position.SetZero();this.R.SetIdentity()};Box2D.Common.Math.b2Transform.prototype.Set=function(a){this.position.SetV(a.position);this.R.SetM(a.R)};Box2D.Common.Math.b2Transform.prototype.GetAngle=function(){return Math.atan2(this.R.col1.y,this.R.col1.x)};Box2D.Common.Math.b2Vec2=function(a,b){this.x=a;this.y=b};Box2D.Common.Math.b2Vec2._freeCache=[];Box2D.Common.Math.b2Vec2.Get=function(a,b){if(0<Box2D.Common.Math.b2Vec2._freeCache.length){var c=
Box2D.Common.Math.b2Vec2._freeCache.pop();c.Set(a,b);return c}return new Box2D.Common.Math.b2Vec2(a,b)};Box2D.Common.Math.b2Vec2.Free=function(a){Box2D.Common.Math.b2Vec2._freeCache.push(a)};Box2D.Common.Math.b2Vec2.prototype.SetZero=function(){this.y=this.x=0};Box2D.Common.Math.b2Vec2.prototype.Set=function(a,b){this.x=a;this.y=b};Box2D.Common.Math.b2Vec2.prototype.SetV=function(a){this.x=a.x;this.y=a.y};Box2D.Common.Math.b2Vec2.prototype.GetNegative=function(){return Box2D.Common.Math.b2Vec2.Get(-this.x,
-this.y)};Box2D.Common.Math.b2Vec2.prototype.NegativeSelf=function(){this.x=-this.x;this.y=-this.y};Box2D.Common.Math.b2Vec2.prototype.Copy=function(){return Box2D.Common.Math.b2Vec2.Get(this.x,this.y)};Box2D.Common.Math.b2Vec2.prototype.Add=function(a){this.x+=a.x;this.y+=a.y};Box2D.Common.Math.b2Vec2.prototype.Subtract=function(a){this.x-=a.x;this.y-=a.y};Box2D.Common.Math.b2Vec2.prototype.Multiply=function(a){this.x*=a;this.y*=a};Box2D.Common.Math.b2Vec2.prototype.MulM=function(a){var b=this.x;
this.x=a.col1.x*b+a.col2.x*this.y;this.y=a.col1.y*b+a.col2.y*this.y};Box2D.Common.Math.b2Vec2.prototype.MulTM=function(a){var b=this.x*a.col1.x+this.y*a.col1.y;this.y=this.x*a.col2.x+this.y*a.col2.y;this.x=b};Box2D.Common.Math.b2Vec2.prototype.CrossVF=function(a){var b=this.x;this.x=a*this.y;this.y=-a*b};Box2D.Common.Math.b2Vec2.prototype.CrossFV=function(a){var b=this.x;this.x=-a*this.y;this.y=a*b};Box2D.Common.Math.b2Vec2.prototype.MinV=function(a){this.x=Math.min(this.x,a.x);this.y=Math.min(this.y,
a.y)};Box2D.Common.Math.b2Vec2.prototype.MaxV=function(a){this.x=Math.max(this.x,a.x);this.y=Math.max(this.y,a.y)};Box2D.Common.Math.b2Vec2.prototype.Abs=function(){this.x=Math.abs(this.x);this.y=Math.abs(this.y)};Box2D.Common.Math.b2Vec2.prototype.Length=function(){return Math.sqrt(this.LengthSquared())};Box2D.Common.Math.b2Vec2.prototype.LengthSquared=function(){return this.x*this.x+this.y*this.y};Box2D.Common.Math.b2Vec2.prototype.Normalize=function(){var a=this.Length();if(a<Number.MIN_VALUE)return 0;
var b=1/a;this.x*=b;this.y*=b;return a};Box2D.Common.Math.b2Vec2.prototype.IsValid=function(){return isFinite(this.x)&&isFinite(this.y)};Box2D.Common.Math.b2Vec3=function(a,b,c){this.x=a;this.y=b;this.z=c};Box2D.Common.Math.b2Vec3.prototype.SetZero=function(){this.z=this.y=this.x=0};Box2D.Common.Math.b2Vec3.prototype.Set=function(a,b,c){this.x=a;this.y=b;this.z=c};Box2D.Common.Math.b2Vec3.prototype.SetV=function(a){this.x=a.x;this.y=a.y;this.z=a.z};Box2D.Common.Math.b2Vec3.prototype.GetNegative=function(){return new Box2D.Common.Math.b2Vec3(-this.x,
-this.y,-this.z)};Box2D.Common.Math.b2Vec3.prototype.NegativeSelf=function(){this.x=-this.x;this.y=-this.y;this.z=-this.z};Box2D.Common.Math.b2Vec3.prototype.Copy=function(){return new Box2D.Common.Math.b2Vec3(this.x,this.y,this.z)};Box2D.Common.Math.b2Vec3.prototype.Add=function(a){this.x+=a.x;this.y+=a.y;this.z+=a.z};Box2D.Common.Math.b2Vec3.prototype.Subtract=function(a){this.x-=a.x;this.y-=a.y;this.z-=a.z};Box2D.Common.Math.b2Vec3.prototype.Multiply=function(a){this.x*=a;this.y*=a;this.z*=a};
Box2D.Collision.Shapes.b2Shape=function(){this.m_radius=Box2D.Common.b2Settings.b2_linearSlop};Box2D.Collision.Shapes.b2Shape.prototype.GetTypeName=function(){};Box2D.Collision.Shapes.b2Shape.prototype.Copy=function(){};Box2D.Collision.Shapes.b2Shape.prototype.Set=function(a){this.m_radius=a.m_radius};Box2D.Collision.Shapes.b2Shape.prototype.TestPoint=function(){};Box2D.Collision.Shapes.b2Shape.prototype.RayCast=function(){};Box2D.Collision.Shapes.b2Shape.prototype.ComputeAABB=function(){};Box2D.Collision.Shapes.b2Shape.prototype.ComputeMass=
function(){};Box2D.Collision.Shapes.b2Shape.prototype.ComputeSubmergedArea=function(){};Box2D.Collision.Shapes.b2Shape.prototype.SetDistanceProxy=function(){};Box2D.Collision.Shapes.b2Shape.TestOverlap=function(a,b,c,d){var e=new Box2D.Collision.b2DistanceInput;e.proxyA=new Box2D.Collision.b2DistanceProxy;e.proxyA.Set(a);e.proxyB=new Box2D.Collision.b2DistanceProxy;e.proxyB.Set(c);e.transformA=b;e.transformB=d;e.useRadii=!0;a=new Box2D.Collision.b2SimplexCache;a.count=0;b=new Box2D.Collision.b2DistanceOutput;
Box2D.Collision.b2Distance.Distance(b,a,e);return b.distance<10*Number.MIN_VALUE};Box2D.Collision.Shapes.b2Shape.e_startsInsideCollide=-1;Box2D.Collision.Shapes.b2Shape.e_missCollide=0;Box2D.Collision.Shapes.b2Shape.e_hitCollide=1;Box2D.Collision.Shapes.b2CircleShape=function(a){Box2D.Collision.Shapes.b2Shape.call(this);this.m_radius=a;this.m_radiusSquared=a*a;this.m_p=Box2D.Common.Math.b2Vec2.Get(0,0)};c2inherit(Box2D.Collision.Shapes.b2CircleShape,Box2D.Collision.Shapes.b2Shape);Box2D.Collision.Shapes.b2CircleShape.prototype.GetTypeName=
function(){return Box2D.Collision.Shapes.b2CircleShape.NAME};Box2D.Collision.Shapes.b2CircleShape.prototype.Copy=function(){var a=new Box2D.Collision.Shapes.b2CircleShape(this.m_radius);a.Set(this);return a};Box2D.Collision.Shapes.b2CircleShape.prototype.Set=function(a){Box2D.Collision.Shapes.b2Shape.prototype.Set.call(this,a);a instanceof Box2D.Collision.Shapes.b2CircleShape&&this.m_p.SetV(a.m_p)};Box2D.Collision.Shapes.b2CircleShape.prototype.TestPoint=function(a,b){var c=b.x-(a.position.x+(a.R.col1.x*
this.m_p.x+a.R.col2.x*this.m_p.y)),d=b.y-(a.position.y+(a.R.col1.y*this.m_p.x+a.R.col2.y*this.m_p.y));return c*c+d*d<=this.m_radiusSquared};Box2D.Collision.Shapes.b2CircleShape.prototype.RayCast=function(a,b,c){var d=c.R,e=b.p1.x-(c.position.x+(d.col1.x*this.m_p.x+d.col2.x*this.m_p.y));c=b.p1.y-(c.position.y+(d.col1.y*this.m_p.x+d.col2.y*this.m_p.y));var d=b.p2.x-b.p1.x,f=b.p2.y-b.p1.y,g=e*d+c*f,h=d*d+f*f,l=g*g-h*(e*e+c*c-this.m_radiusSquared);if(0>l||h<Number.MIN_VALUE)return!1;g=-(g+Math.sqrt(l));
return 0<=g&&g<=b.maxFraction*h?(g/=h,a.fraction=g,a.normal.x=e+g*d,a.normal.y=c+g*f,a.normal.Normalize(),!0):!1};Box2D.Collision.Shapes.b2CircleShape.prototype.ComputeAABB=function(a,b){var c=b.R,d=b.position.x+(c.col1.x*this.m_p.x+c.col2.x*this.m_p.y),c=b.position.y+(c.col1.y*this.m_p.x+c.col2.y*this.m_p.y);a.lowerBound_.Set(d-this.m_radius,c-this.m_radius);a.upperBound_.Set(d+this.m_radius,c+this.m_radius)};Box2D.Collision.Shapes.b2CircleShape.prototype.ComputeMass=function(a,b){a.mass=b*Math.PI*
this.m_radiusSquared;a.center.SetV(this.m_p);a.I=a.mass*(0.5*this.m_radiusSquared+(this.m_p.x*this.m_p.x+this.m_p.y*this.m_p.y))};Box2D.Collision.Shapes.b2CircleShape.prototype.ComputeSubmergedArea=function(a,b,c,d){c=Box2D.Common.Math.b2Math.MulX(c,this.m_p);var e=-(Box2D.Common.Math.b2Math.Dot(a,c)-b);if(e<-this.m_radius+Number.MIN_VALUE)return 0;if(e>this.m_radius)return d.SetV(c),Math.PI*this.m_radiusSquared;b=e*e;e=this.m_radiusSquared*(Math.asin(e/this.m_radius)+Math.PI/2)+e*Math.sqrt(this.m_radiusSquared-
b);b=-2/3*Math.pow(this.m_radiusSquared-b,1.5)/e;d.x=c.x+a.x*b;d.y=c.y+a.y*b;return e};Box2D.Collision.Shapes.b2CircleShape.prototype.SetDistanceProxy=function(a){a.m_vertices=[this.m_p];a.m_count=1;a.m_radius=this.m_radius};Box2D.Collision.Shapes.b2CircleShape.prototype.GetLocalPosition=function(){return this.m_p};Box2D.Collision.Shapes.b2CircleShape.prototype.SetLocalPosition=function(a){this.m_p.SetV(a)};Box2D.Collision.Shapes.b2CircleShape.prototype.GetRadius=function(){return this.m_radius};
Box2D.Collision.Shapes.b2CircleShape.prototype.SetRadius=function(a){this.m_radius=a;this.m_radiusSquared=a*a};Box2D.Collision.Shapes.b2CircleShape.NAME="b2CircleShape";Box2D.Collision.Shapes.b2EdgeChainDef=function(){this.vertexCount=0;this.isALoop=!0;this.vertices=[]};Box2D.Collision.Shapes.b2EdgeShape=function(a,b){Box2D.Collision.Shapes.b2Shape.call(this);this.m_nextEdge=this.m_prevEdge=null;this.m_v1=a;this.m_v2=b;this.m_direction=Box2D.Common.Math.b2Vec2.Get(this.m_v2.x-this.m_v1.x,this.m_v2.y-
this.m_v1.y);this.m_length=this.m_direction.Normalize();this.m_normal=Box2D.Common.Math.b2Vec2.Get(this.m_direction.y,-this.m_direction.x);this.m_coreV1=Box2D.Common.Math.b2Vec2.Get(-Box2D.Common.b2Settings.b2_toiSlop*(this.m_normal.x-this.m_direction.x)+this.m_v1.x,-Box2D.Common.b2Settings.b2_toiSlop*(this.m_normal.y-this.m_direction.y)+this.m_v1.y);this.m_coreV2=Box2D.Common.Math.b2Vec2.Get(-Box2D.Common.b2Settings.b2_toiSlop*(this.m_normal.x+this.m_direction.x)+this.m_v2.x,-Box2D.Common.b2Settings.b2_toiSlop*
(this.m_normal.y+this.m_direction.y)+this.m_v2.y);this.m_cornerDir1=this.m_normal;this.m_cornerDir2=Box2D.Common.Math.b2Vec2.Get(-this.m_normal.x,-this.m_normal.y);this.m_cornerConvex2=this.m_cornerConvex1=!1};c2inherit(Box2D.Collision.Shapes.b2EdgeShape,Box2D.Collision.Shapes.b2Shape);Box2D.Collision.Shapes.b2EdgeShape.prototype.GetTypeName=function(){return Box2D.Collision.Shapes.b2EdgeShape.NAME};Box2D.Collision.Shapes.b2EdgeShape.prototype.TestPoint=function(a,b){return!1};Box2D.Collision.Shapes.b2EdgeShape.prototype.RayCast=
function(a,b,c){var d=b.p2.x-b.p1.x,e=b.p2.y-b.p1.y,f=c.R,g=c.position.x+(f.col1.x*this.m_v1.x+f.col2.x*this.m_v1.y),h=c.position.y+(f.col1.y*this.m_v1.x+f.col2.y*this.m_v1.y),l=c.position.y+(f.col1.y*this.m_v2.x+f.col2.y*this.m_v2.y)-h;c=-(c.position.x+(f.col1.x*this.m_v2.x+f.col2.x*this.m_v2.y)-g);var f=100*Number.MIN_VALUE,k=-(d*l+e*c);if(k>f){var g=b.p1.x-g,m=b.p1.y-h,h=g*l+m*c;if(0<=h&&h<=b.maxFraction*k&&(b=-d*m+e*g,-f*k<=b&&b<=k*(1+f)))return a.fraction=h/k,b=Math.sqrt(l*l+c*c),a.normal.x=
l/b,a.normal.y=c/b,!0}return!1};Box2D.Collision.Shapes.b2EdgeShape.prototype.ComputeAABB=function(a,b){var c=b.R,d=b.position.x+(c.col1.x*this.m_v1.x+c.col2.x*this.m_v1.y),e=b.position.y+(c.col1.y*this.m_v1.x+c.col2.y*this.m_v1.y),f=b.position.x+(c.col1.x*this.m_v2.x+c.col2.x*this.m_v2.y),c=b.position.y+(c.col1.y*this.m_v2.x+c.col2.y*this.m_v2.y);d<f?(a.lowerBound_.x=d,a.upperBound_.x=f):(a.lowerBound_.x=f,a.upperBound_.x=d);e<c?(a.lowerBound_.y=e,a.upperBound_.y=c):(a.lowerBound_.y=c,a.upperBound_.y=
e)};Box2D.Collision.Shapes.b2EdgeShape.prototype.ComputeMass=function(a,b){a.mass=0;a.center.SetV(this.m_v1);a.I=0};Box2D.Collision.Shapes.b2EdgeShape.prototype.ComputeSubmergedArea=function(a,b,c,d){void 0===b&&(b=0);var e=Box2D.Common.Math.b2Vec2.Get(a.x*b,a.y*b),f=Box2D.Common.Math.b2Math.MulX(c,this.m_v1);c=Box2D.Common.Math.b2Math.MulX(c,this.m_v2);var g=Box2D.Common.Math.b2Math.Dot(a,f)-b;a=Box2D.Common.Math.b2Math.Dot(a,c)-b;if(0<g){if(0<a)return 0;f.x=-a/(g-a)*f.x+g/(g-a)*c.x;f.y=-a/(g-a)*
f.y+g/(g-a)*c.y}else 0<a&&(c.x=-a/(g-a)*f.x+g/(g-a)*c.x,c.y=-a/(g-a)*f.y+g/(g-a)*c.y);d.x=(e.x+f.x+c.x)/3;d.y=(e.y+f.y+c.y)/3;return 0.5*((f.x-e.x)*(c.y-e.y)-(f.y-e.y)*(c.x-e.x))};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetLength=function(){return this.m_length};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetVertex1=function(){return this.m_v1};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetVertex2=function(){return this.m_v2};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetCoreVertex1=function(){return this.m_coreV1};
Box2D.Collision.Shapes.b2EdgeShape.prototype.GetCoreVertex2=function(){return this.m_coreV2};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetNormalVector=function(){return this.m_normal};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetDirectionVector=function(){return this.m_direction};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetCorner1Vector=function(){return this.m_cornerDir1};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetCorner2Vector=function(){return this.m_cornerDir2};Box2D.Collision.Shapes.b2EdgeShape.prototype.Corner1IsConvex=
function(){return this.m_cornerConvex1};Box2D.Collision.Shapes.b2EdgeShape.prototype.Corner2IsConvex=function(){return this.m_cornerConvex2};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetFirstVertex=function(a){var b=a.R;return Box2D.Common.Math.b2Vec2.Get(a.position.x+(b.col1.x*this.m_coreV1.x+b.col2.x*this.m_coreV1.y),a.position.y+(b.col1.y*this.m_coreV1.x+b.col2.y*this.m_coreV1.y))};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetNextEdge=function(){return this.m_nextEdge};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetPrevEdge=
function(){return this.m_prevEdge};Box2D.Collision.Shapes.b2EdgeShape.prototype.Support=function(a,b,c){var d=a.R,e=a.position.x+(d.col1.x*this.m_coreV1.x+d.col2.x*this.m_coreV1.y),f=a.position.y+(d.col1.y*this.m_coreV1.x+d.col2.y*this.m_coreV1.y),g=a.position.x+(d.col1.x*this.m_coreV2.x+d.col2.x*this.m_coreV2.y);a=a.position.y+(d.col1.y*this.m_coreV2.x+d.col2.y*this.m_coreV2.y);return e*b+f*c>g*b+a*c?Box2D.Common.Math.b2Vec2.Get(e,f):Box2D.Common.Math.b2Vec2.Get(g,a)};Box2D.Collision.Shapes.b2EdgeShape.prototype.SetPrevEdge=
function(a,b,c,d){this.m_prevEdge=a;this.m_coreV1=b;this.m_cornerDir1=c;this.m_cornerConvex1=d};Box2D.Collision.Shapes.b2EdgeShape.prototype.SetNextEdge=function(a,b,c,d){this.m_nextEdge=a;this.m_coreV2=b;this.m_cornerDir2=c;this.m_cornerConvex2=d};Box2D.Collision.Shapes.b2EdgeShape.NAME="b2EdgeShape";Box2D.Collision.Shapes.b2MassData=function(){this.mass=0;this.center=Box2D.Common.Math.b2Vec2.Get(0,0);this.I=0};Box2D.Collision.Shapes.b2PolygonShape=function(){Box2D.Collision.Shapes.b2Shape.call(this);
this.m_centroid=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_vertices=[];this.m_normals=[]};c2inherit(Box2D.Collision.Shapes.b2PolygonShape,Box2D.Collision.Shapes.b2Shape);Box2D.Collision.Shapes.b2PolygonShape.prototype.GetTypeName=function(){return Box2D.Collision.Shapes.b2PolygonShape.NAME};Box2D.Collision.Shapes.b2PolygonShape.prototype.Copy=function(){var a=new Box2D.Collision.Shapes.b2PolygonShape;a.Set(this);return a};Box2D.Collision.Shapes.b2PolygonShape.prototype.Set=function(a){Box2D.Collision.Shapes.b2Shape.prototype.Set.call(this,
a);if(a instanceof Box2D.Collision.Shapes.b2PolygonShape){this.m_centroid.SetV(a.m_centroid);this.m_vertexCount=a.m_vertexCount;this.Reserve(this.m_vertexCount);for(var b=0;b<this.m_vertexCount;b++)this.m_vertices[b].SetV(a.m_vertices[b]),this.m_normals[b].SetV(a.m_normals[b])}};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsArray=function(a){this.SetAsVector(a)};Box2D.Collision.Shapes.b2PolygonShape.AsArray=function(a){var b=new Box2D.Collision.Shapes.b2PolygonShape;b.SetAsArray(a);return b};
Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsVector=function(a){var b=a.length;this.m_vertexCount=b;this.Reserve(b);for(b=b=0;b<this.m_vertexCount;b++)this.m_vertices[b].SetV(a[b]);for(b=0;b<this.m_vertexCount;++b)a=Box2D.Common.Math.b2Math.SubtractVV(this.m_vertices[b+1<this.m_vertexCount?b+1:0],this.m_vertices[b]),this.m_normals[b].SetV(Box2D.Common.Math.b2Math.CrossVF(a,1)),this.m_normals[b].Normalize();this.m_centroid=Box2D.Collision.Shapes.b2PolygonShape.ComputeCentroid(this.m_vertices,
this.m_vertexCount)};Box2D.Collision.Shapes.b2PolygonShape.AsVector=function(a){var b=new Box2D.Collision.Shapes.b2PolygonShape;b.SetAsVector(a);return b};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsBox=function(a,b){this.m_vertexCount=4;this.Reserve(4);this.m_vertices[0].Set(-a,-b);this.m_vertices[1].Set(a,-b);this.m_vertices[2].Set(a,b);this.m_vertices[3].Set(-a,b);this.m_normals[0].Set(0,-1);this.m_normals[1].Set(1,0);this.m_normals[2].Set(0,1);this.m_normals[3].Set(-1,0);this.m_centroid.SetZero()};
Box2D.Collision.Shapes.b2PolygonShape.AsBox=function(a,b){var c=new Box2D.Collision.Shapes.b2PolygonShape;c.SetAsBox(a,b);return c};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsOrientedBox=function(a,b,c,d){this.m_vertexCount=4;this.Reserve(4);this.m_vertices[0].Set(-a,-b);this.m_vertices[1].Set(a,-b);this.m_vertices[2].Set(a,b);this.m_vertices[3].Set(-a,b);this.m_normals[0].Set(0,-1);this.m_normals[1].Set(1,0);this.m_normals[2].Set(0,1);this.m_normals[3].Set(-1,0);this.m_centroid=c;a=new Box2D.Common.Math.b2Mat22;
a.Set(d);c=new Box2D.Common.Math.b2Transform(c,a);for(d=0;d<this.m_vertexCount;++d)this.m_vertices[d]=Box2D.Common.Math.b2Math.MulX(c,this.m_vertices[d]),this.m_normals[d]=Box2D.Common.Math.b2Math.MulMV(c.R,this.m_normals[d])};Box2D.Collision.Shapes.b2PolygonShape.AsOrientedBox=function(a,b,c,d){var e=new Box2D.Collision.Shapes.b2PolygonShape;e.SetAsOrientedBox(a,b,c,d);return e};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsEdge=function(a,b){this.m_vertexCount=2;this.Reserve(2);this.m_vertices[0].SetV(a);
this.m_vertices[1].SetV(b);this.m_centroid.x=0.5*(a.x+b.x);this.m_centroid.y=0.5*(a.y+b.y);this.m_normals[0]=Box2D.Common.Math.b2Math.CrossVF(Box2D.Common.Math.b2Math.SubtractVV(b,a),1);this.m_normals[0].Normalize();this.m_normals[1].x=-this.m_normals[0].x;this.m_normals[1].y=-this.m_normals[0].y};Box2D.Collision.Shapes.b2PolygonShape.AsEdge=function(a,b){var c=new Box2D.Collision.Shapes.b2PolygonShape;c.SetAsEdge(a,b);return c};Box2D.Collision.Shapes.b2PolygonShape.prototype.TestPoint=function(a,
b){var c;c=a.R;for(var d=b.x-a.position.x,e=b.y-a.position.y,f=d*c.col1.x+e*c.col1.y,g=d*c.col2.x+e*c.col2.y,h=0;h<this.m_vertexCount;++h)if(c=this.m_vertices[h],d=f-c.x,e=g-c.y,c=this.m_normals[h],0<c.x*d+c.y*e)return!1;return!0};Box2D.Collision.Shapes.b2PolygonShape.prototype.RayCast=function(a,b,c){var d=0,e=b.maxFraction,f=0,g=0,h,l,f=b.p1.x-c.position.x,g=b.p1.y-c.position.y;h=c.R;var k=f*h.col1.x+g*h.col1.y,m=f*h.col2.x+g*h.col2.y,f=b.p2.x-c.position.x,g=b.p2.y-c.position.y;h=c.R;b=f*h.col1.x+
g*h.col1.y-k;h=f*h.col2.x+g*h.col2.y-m;for(var n=-1,q=0;q<this.m_vertexCount;++q){l=this.m_vertices[q];f=l.x-k;g=l.y-m;l=this.m_normals[q];f=l.x*f+l.y*g;g=l.x*b+l.y*h;if(0==g){if(0>f)return!1}else 0>g&&f<d*g?(d=f/g,n=q):0<g&&f<e*g&&(e=f/g);if(e<d-Number.MIN_VALUE)return!1}return 0<=n?(a.fraction=d,h=c.R,l=this.m_normals[n],a.normal.x=h.col1.x*l.x+h.col2.x*l.y,a.normal.y=h.col1.y*l.x+h.col2.y*l.y,!0):!1};Box2D.Collision.Shapes.b2PolygonShape.prototype.ComputeAABB=function(a,b){for(var c=b.R,d=this.m_vertices[0],
e=b.position.x+(c.col1.x*d.x+c.col2.x*d.y),f=b.position.y+(c.col1.y*d.x+c.col2.y*d.y),g=e,h=f,l=1;l<this.m_vertexCount;++l)var d=this.m_vertices[l],k=b.position.x+(c.col1.x*d.x+c.col2.x*d.y),d=b.position.y+(c.col1.y*d.x+c.col2.y*d.y),e=e<k?e:k,f=f<d?f:d,g=g>k?g:k,h=h>d?h:d;a.lowerBound_.x=e-this.m_radius;a.lowerBound_.y=f-this.m_radius;a.upperBound_.x=g+this.m_radius;a.upperBound_.y=h+this.m_radius};Box2D.Collision.Shapes.b2PolygonShape.prototype.ComputeMass=function(a,b){if(2==this.m_vertexCount)a.center.x=
0.5*(this.m_vertices[0].x+this.m_vertices[1].x),a.center.y=0.5*(this.m_vertices[0].y+this.m_vertices[1].y),a.mass=0,a.I=0;else{for(var c=0,d=0,e=0,f=0,g=1/3,h=0;h<this.m_vertexCount;++h)var l=this.m_vertices[h],k=h+1<this.m_vertexCount?this.m_vertices[h+1]:this.m_vertices[0],m=l.x-0,n=l.y-0,q=k.x-0,p=k.y-0,r=m*p-n*q,s=0.5*r,e=e+s,c=c+s*g*(0+l.x+k.x),d=d+s*g*(0+l.y+k.y),l=m,f=f+r*(g*(0.25*(l*l+q*l+q*q)+(0*l+0*q))+0+(g*(0.25*(n*n+p*n+p*p)+(0*n+0*p))+0));a.mass=b*e;a.center.Set(c*(1/e),d*(1/e));a.I=
b*f}};Box2D.Collision.Shapes.b2PolygonShape.prototype.ComputeSubmergedArea=function(a,b,c,d){var e=Box2D.Common.Math.b2Math.MulTMV(c.R,a),f=b-Box2D.Common.Math.b2Math.Dot(a,c.position),g=[],h=0,l=-1;b=-1;var k=!1;for(a=a=0;a<this.m_vertexCount;++a){g[a]=Box2D.Common.Math.b2Math.Dot(e,this.m_vertices[a])-f;var m=g[a]<-Number.MIN_VALUE;0<a&&(m?k||(l=a-1,h++):k&&(b=a-1,h++));k=m}switch(h){case 0:return k?(a=new Box2D.Collision.Shapes.b2MassData,this.ComputeMass(a,1),d.SetV(Box2D.Common.Math.b2Math.MulX(c,
a.center)),a.mass):0;case 1:-1==l?l=this.m_vertexCount-1:b=this.m_vertexCount-1}a=(l+1)%this.m_vertexCount;e=(b+1)%this.m_vertexCount;f=(0-g[l])/(g[a]-g[l]);g=(0-g[b])/(g[e]-g[b]);l=Box2D.Common.Math.b2Vec2.Get(this.m_vertices[l].x*(1-f)+this.m_vertices[a].x*f,this.m_vertices[l].y*(1-f)+this.m_vertices[a].y*f);b=Box2D.Common.Math.b2Vec2.Get(this.m_vertices[b].x*(1-g)+this.m_vertices[e].x*g,this.m_vertices[b].y*(1-g)+this.m_vertices[e].y*g);g=0;f=Box2D.Common.Math.b2Vec2.Get(0,0);for(h=this.m_vertices[a];a!=
e;)a=(a+1)%this.m_vertexCount,k=a==e?b:this.m_vertices[a],m=0.5*((h.x-l.x)*(k.y-l.y)-(h.y-l.y)*(k.x-l.x)),g+=m,f.x+=m*(l.x+h.x+k.x)/3,f.y+=m*(l.y+h.y+k.y)/3,h=k;f.Multiply(1/g);d.SetV(Box2D.Common.Math.b2Math.MulX(c,f));return g};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetDistanceProxy=function(a){a.m_vertices=this.m_vertices;a.m_count=this.m_vertexCount;a.m_radius=this.m_radius};Box2D.Collision.Shapes.b2PolygonShape.prototype.GetVertexCount=function(){return this.m_vertexCount};Box2D.Collision.Shapes.b2PolygonShape.prototype.GetVertices=
function(){return this.m_vertices};Box2D.Collision.Shapes.b2PolygonShape.prototype.GetNormals=function(){return this.m_normals};Box2D.Collision.Shapes.b2PolygonShape.prototype.GetSupport=function(a){for(var b=0,c=this.m_vertices[0].x*a.x+this.m_vertices[0].y*a.y,d=1;d<this.m_vertexCount;++d){var e=this.m_vertices[d].x*a.x+this.m_vertices[d].y*a.y;e>c&&(b=d,c=e)}return b};Box2D.Collision.Shapes.b2PolygonShape.prototype.GetSupportVertex=function(a){for(var b=0,c=this.m_vertices[0].x*a.x+this.m_vertices[0].y*
a.y,d=1;d<this.m_vertexCount;++d){var e=this.m_vertices[d].x*a.x+this.m_vertices[d].y*a.y;e>c&&(b=d,c=e)}return this.m_vertices[b]};Box2D.Collision.Shapes.b2PolygonShape.prototype.Reserve=function(a){this.m_vertices=[];this.m_normals=[];for(var b=this.m_vertices.length;b<a;b++)this.m_vertices[b]=Box2D.Common.Math.b2Vec2.Get(0,0),this.m_normals[b]=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.Shapes.b2PolygonShape.ComputeCentroid=function(a,b){for(var c=Box2D.Common.Math.b2Vec2.Get(0,0),d=0,e=
1/3,f=0;f<b;++f){var g=a[f],h=f+1<b?a[f+1]:a[0],l=0.5*((g.x-0)*(h.y-0)-(g.y-0)*(h.x-0)),d=d+l;c.x+=l*e*(0+g.x+h.x);c.y+=l*e*(0+g.y+h.y)}c.x*=1/d;c.y*=1/d;return c};Box2D.Collision.Shapes.b2PolygonShape.s_mat=new Box2D.Common.Math.b2Mat22;Box2D.Collision.Shapes.b2PolygonShape.NAME="b2PolygonShape";Box2D.Collision.b2ContactID=function(){this._incidentVertex=this._incidentEdge=this._referenceEdge=this._key=0};Box2D.Collision.b2ContactID.prototype.GetKey=function(){return this._key};Box2D.Collision.b2ContactID.prototype.SetKey=
function(a){this._key=a;this._referenceEdge=this._key&255;this._incidentEdge=(this._key&65280)>>8&255;this._incidentVertex=(this._key&16711680)>>16&255;this._flip=(this._key&4278190080)>>24&255};Box2D.Collision.b2ContactID.prototype.Set=function(a){this.SetKey(a._key)};Box2D.Collision.b2ContactID.prototype.SetReferenceEdge=function(a){this._referenceEdge=a;this._key=this._key&4294967040|this._referenceEdge&255};Box2D.Collision.b2ContactID.prototype.SetIncidentEdge=function(a){this._incidentEdge=a;
this._key=this._key&4294902015|this._incidentEdge<<8&65280};Box2D.Collision.b2ContactID.prototype.SetIncidentVertex=function(a){this._incidentVertex=a;this._key=this._key&4278255615|this._incidentVertex<<16&16711680};Box2D.Collision.b2ContactID.prototype.SetFlip=function(a){this._flip=a;this._key=this._key&16777215|this._flip<<24&4278190080};Box2D.Collision.b2ContactID.prototype.Copy=function(){var a=new Box2D.Collision.b2ContactID;a.Set(this);return a};Box2D.Collision.ClipVertex=function(){this.v=
Box2D.Common.Math.b2Vec2.Get(0,0);this.id=new Box2D.Collision.b2ContactID};Box2D.Collision.ClipVertex.prototype.Set=function(a){this.v.SetV(a.v);this.id.Set(a.id)};Box2D.Collision.IBroadPhase="Box2D.Collision.IBroadPhase";Box2D.Collision.b2AABB=function(){this.lowerBound_=Box2D.Common.Math.b2Vec2.Get(0,0);this.upperBound_=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2AABB._freeCache=[];Box2D.Collision.b2AABB.Get=function(){if(0<Box2D.Collision.b2AABB._freeCache.length){var a=Box2D.Collision.b2AABB._freeCache.pop();
a.SetZero();return a}return new Box2D.Collision.b2AABB};Box2D.Collision.b2AABB.Free=function(a){Box2D.Collision.b2AABB._freeCache.push(a)};Box2D.Collision.b2AABB.prototype.SetZero=function(){this.lowerBound_.Set(0,0);this.upperBound_.Set(0,0)};Box2D.Collision.b2AABB.prototype.IsValid=function(){return 0>this.upperBound_.x-this.lowerBound_.x||0>this.upperBound_.y-this.lowerBound_.y?!1:this.lowerBound_.IsValid()&&this.upperBound_.IsValid()};Box2D.Collision.b2AABB.prototype.GetCenter=function(){return Box2D.Common.Math.b2Vec2.Get((this.lowerBound_.x+
this.upperBound_.x)/2,(this.lowerBound_.y+this.upperBound_.y)/2)};Box2D.Collision.b2AABB.prototype.SetCenter=function(a){var b=this.GetCenter();this.lowerBound_.Subtract(b);this.upperBound_.Subtract(b);this.lowerBound_.Add(a);this.upperBound_.Add(a);Box2D.Common.Math.b2Vec2.Free(b)};Box2D.Collision.b2AABB.prototype.GetExtents=function(){return Box2D.Common.Math.b2Vec2.Get((this.upperBound_.x-this.lowerBound_.x)/2,(this.upperBound_.y-this.lowerBound_.y)/2)};Box2D.Collision.b2AABB.prototype.Contains=
function(a){var b;return b=(b=(b=(b=this.lowerBound_.x<=a.lowerBound_.x)&&this.lowerBound_.y<=a.lowerBound_.y)&&a.upperBound_.x<=this.upperBound_.x)&&a.upperBound_.y<=this.upperBound_.y};Box2D.Collision.b2AABB.prototype.RayCast=function(a,b){var c=-Number.MAX_VALUE,d=Number.MAX_VALUE,e=b.p2.x-b.p1.x;if(Math.abs(e)<Number.MIN_VALUE){if(b.p1.x<this.lowerBound_.x||this.upperBound_.x<b.p1.x)return!1}else{var f=1/e,e=(this.lowerBound_.x-b.p1.x)*f,f=(this.upperBound_.x-b.p1.x)*f,g=-1;e>f&&(g=e,e=f,f=g,
g=1);e>c&&(a.normal.x=g,a.normal.y=0,c=e);d=Math.min(d,f);if(c>d)return!1}e=b.p2.y-b.p1.y;if(Math.abs(e)<Number.MIN_VALUE){if(b.p1.y<this.lowerBound_.y||this.upperBound_.y<b.p1.y)return!1}else if(f=1/e,e=(this.lowerBound_.y-b.p1.y)*f,f*=this.upperBound_.y-b.p1.y,g=-1,e>f&&(g=e,e=f,f=g,g=1),e>c&&(a.normal.y=g,a.normal.x=0,c=e),d=Math.min(d,f),c>d)return!1;a.fraction=c;return!0};Box2D.Collision.b2AABB.prototype.TestOverlap=function(a){return 0<a.lowerBound_.x-this.upperBound_.x||0<a.lowerBound_.y-this.upperBound_.y||
0<this.lowerBound_.x-a.upperBound_.x||0<this.lowerBound_.y-a.upperBound_.y?!1:!0};Box2D.Collision.b2AABB.Combine=function(a,b){var c=Box2D.Collision.b2AABB.Get();c.Combine(a,b);return c};Box2D.Collision.b2AABB.prototype.Combine=function(a,b){this.lowerBound_.x=Math.min(a.lowerBound_.x,b.lowerBound_.x);this.lowerBound_.y=Math.min(a.lowerBound_.y,b.lowerBound_.y);this.upperBound_.x=Math.max(a.upperBound_.x,b.upperBound_.x);this.upperBound_.y=Math.max(a.upperBound_.y,b.upperBound_.y)};Box2D.Collision.b2Collision.ClipSegmentToLine=
function(a,b,c,d){var e=0,f=b[0].v,g=b[1].v,h=c.x*f.x+c.y*f.y-d;c=c.x*g.x+c.y*g.y-d;0>=h&&a[e++].Set(b[0]);0>=c&&a[e++].Set(b[1]);0>h*c&&(c=h/(h-c),d=a[e].v,d.x=f.x+c*(g.x-f.x),d.y=f.y+c*(g.y-f.y),a[e].id=0<h?b[0].id:b[1].id,e++);return e};Box2D.Collision.b2Collision.EdgeSeparation=function(a,b,c,d,e){for(var f=b.R.col1.x*a.m_normals[c].x+b.R.col2.x*a.m_normals[c].y,g=b.R.col1.y*a.m_normals[c].x+b.R.col2.y*a.m_normals[c].y,h=e.R.col1.x*f+e.R.col1.y*g,l=e.R.col2.x*f+e.R.col2.y*g,k=0,m=Number.MAX_VALUE,
n=0;n<d.m_vertexCount;n++){var q=d.m_vertices[n].x*h+d.m_vertices[n].y*l;q<m&&(m=q,k=n)}return(e.position.x+(e.R.col1.x*d.m_vertices[k].x+e.R.col2.x*d.m_vertices[k].y)-(b.position.x+(b.R.col1.x*a.m_vertices[c].x+b.R.col2.x*a.m_vertices[c].y)))*f+(e.position.y+(e.R.col1.y*d.m_vertices[k].x+e.R.col2.y*d.m_vertices[k].y)-(b.position.y+(b.R.col1.y*a.m_vertices[c].x+b.R.col2.y*a.m_vertices[c].y)))*g};Box2D.Collision.b2Collision.FindMaxSeparation=function(a,b,c,d){for(var e=d.position.x+(d.R.col1.x*c.m_centroid.x+
d.R.col2.x*c.m_centroid.y),f=d.position.y+(d.R.col1.y*c.m_centroid.x+d.R.col2.y*c.m_centroid.y),e=e-(b.position.x+(b.R.col1.x*a.m_centroid.x+b.R.col2.x*a.m_centroid.y)),f=f-(b.position.y+(b.R.col1.y*a.m_centroid.x+b.R.col2.y*a.m_centroid.y)),g=e*b.R.col1.x+f*b.R.col1.y,f=e*b.R.col2.x+f*b.R.col2.y,e=0,h=-Number.MAX_VALUE,l=0;l<a.m_vertexCount;++l){var k=a.m_normals[l].x*g+a.m_normals[l].y*f;k>h&&(h=k,e=l)}g=Box2D.Collision.b2Collision.EdgeSeparation(a,b,e,c,d);f=e-1;0>f&&(f=a.m_vertexCount-1);h=Box2D.Collision.b2Collision.EdgeSeparation(a,
b,f,c,d);l=e+1;l>=a.m_vertexCount&&(l=0);var k=Box2D.Collision.b2Collision.EdgeSeparation(a,b,l,c,d),m=0,n=0;if(h>g&&h>k){m=f;for(n=h;;)if(e=m-1,0>e&&(e=a.m_vertexCount-1),g=Box2D.Collision.b2Collision.EdgeSeparation(a,b,e,c,d),g>n)m=e,n=g;else break}else if(k>g){m=l;for(n=k;;)if(e=m+1,e>=a.m_vertexCount&&(e=0),g=Box2D.Collision.b2Collision.EdgeSeparation(a,b,e,c,d),g>n)m=e,n=g;else break}else m=e,n=g;return{bestEdge:m,separation:n}};Box2D.Collision.b2Collision.FindIncidentEdge=function(a,b,c,d,e,
f){void 0===d&&(d=0);var g=c.R.col1.x*b.m_normals[d].x+c.R.col2.x*b.m_normals[d].y;b=c.R.col1.y*b.m_normals[d].x+c.R.col2.y*b.m_normals[d].y;c=f.R.col1.x*g+f.R.col1.y*b;b=f.R.col2.x*g+f.R.col2.y*b;g=c;c=0;for(var h=Number.MAX_VALUE,l=0;l<e.m_vertexCount;l++){var k=g*e.m_normals[l].x+b*e.m_normals[l].y;k<h&&(h=k,c=l)}g=c+1;g>=e.m_vertexCount&&(g=0);a[0].v.x=f.position.x+(f.R.col1.x*e.m_vertices[c].x+f.R.col2.x*e.m_vertices[c].y);a[0].v.y=f.position.y+(f.R.col1.y*e.m_vertices[c].x+f.R.col2.y*e.m_vertices[c].y);
a[0].id.SetReferenceEdge(d);a[0].id.SetIncidentEdge(c);a[0].id.SetIncidentVertex(0);a[1].v.x=f.position.x+(f.R.col1.x*e.m_vertices[g].x+f.R.col2.x*e.m_vertices[g].y);a[1].v.y=f.position.y+(f.R.col1.y*e.m_vertices[g].x+f.R.col2.y*e.m_vertices[g].y);a[1].id.SetReferenceEdge(d);a[1].id.SetIncidentEdge(g);a[1].id.SetIncidentVertex(1)};Box2D.Collision.b2Collision.MakeClipPointVector=function(){return[new Box2D.Collision.ClipVertex,new Box2D.Collision.ClipVertex]};Box2D.Collision.b2Collision.CollidePolygons=
function(a,b,c,d,e){a.m_pointCount=0;var f=b.m_radius+d.m_radius,g=Box2D.Collision.b2Collision.FindMaxSeparation(b,c,d,e),h=g.bestEdge;if(!(g.separation>f)){var l=Box2D.Collision.b2Collision.FindMaxSeparation(d,e,b,c);if(!(l.separation>f)){var k=b,m=d,n=c,q=e,p=0;a.m_type=Box2D.Collision.b2Manifold.e_faceA;l.separation>0.98*g.separation+0.0010&&(k=d,m=b,n=e,q=c,h=l.bestEdge,a.m_type=Box2D.Collision.b2Manifold.e_faceB,p=1);b=Box2D.Collision.b2Collision.s_incidentEdge;Box2D.Collision.b2Collision.FindIncidentEdge(b,
k,n,h,m,q);m=k.m_vertices[h];h=h+1<k.m_vertexCount?k.m_vertices[h+1]:k.m_vertices[0];Box2D.Collision.b2Collision.s_localTangent.Set(h.x-m.x,h.y-m.y);Box2D.Collision.b2Collision.s_localTangent.Normalize();Box2D.Collision.b2Collision.s_localNormal.x=Box2D.Collision.b2Collision.s_localTangent.y;Box2D.Collision.b2Collision.s_localNormal.y=-Box2D.Collision.b2Collision.s_localTangent.x;Box2D.Collision.b2Collision.s_planePoint.Set(0.5*(m.x+h.x),0.5*(m.y+h.y));Box2D.Collision.b2Collision.s_tangent.x=n.R.col1.x*
Box2D.Collision.b2Collision.s_localTangent.x+n.R.col2.x*Box2D.Collision.b2Collision.s_localTangent.y;Box2D.Collision.b2Collision.s_tangent.y=n.R.col1.y*Box2D.Collision.b2Collision.s_localTangent.x+n.R.col2.y*Box2D.Collision.b2Collision.s_localTangent.y;Box2D.Collision.b2Collision.s_tangent2.x=-Box2D.Collision.b2Collision.s_tangent.x;Box2D.Collision.b2Collision.s_tangent2.y=-Box2D.Collision.b2Collision.s_tangent.y;Box2D.Collision.b2Collision.s_normal.x=Box2D.Collision.b2Collision.s_tangent.y;Box2D.Collision.b2Collision.s_normal.y=
-Box2D.Collision.b2Collision.s_tangent.x;Box2D.Collision.b2Collision.s_v11.x=n.position.x+(n.R.col1.x*m.x+n.R.col2.x*m.y);Box2D.Collision.b2Collision.s_v11.y=n.position.y+(n.R.col1.y*m.x+n.R.col2.y*m.y);Box2D.Collision.b2Collision.s_v12.x=n.position.x+(n.R.col1.x*h.x+n.R.col2.x*h.y);Box2D.Collision.b2Collision.s_v12.y=n.position.y+(n.R.col1.y*h.x+n.R.col2.y*h.y);if(!(2>Box2D.Collision.b2Collision.ClipSegmentToLine(Box2D.Collision.b2Collision.s_clipPoints1,b,Box2D.Collision.b2Collision.s_tangent2,
-Box2D.Collision.b2Collision.s_tangent.x*Box2D.Collision.b2Collision.s_v11.x-Box2D.Collision.b2Collision.s_tangent.y*Box2D.Collision.b2Collision.s_v11.y+f))&&!(2>Box2D.Collision.b2Collision.ClipSegmentToLine(Box2D.Collision.b2Collision.s_clipPoints2,Box2D.Collision.b2Collision.s_clipPoints1,Box2D.Collision.b2Collision.s_tangent,Box2D.Collision.b2Collision.s_tangent.x*Box2D.Collision.b2Collision.s_v12.x+Box2D.Collision.b2Collision.s_tangent.y*Box2D.Collision.b2Collision.s_v12.y+f))){a.m_localPlaneNormal.SetV(Box2D.Collision.b2Collision.s_localNormal);
a.m_localPoint.SetV(Box2D.Collision.b2Collision.s_planePoint);n=Box2D.Collision.b2Collision.s_normal.x*Box2D.Collision.b2Collision.s_v11.x+Box2D.Collision.b2Collision.s_normal.y*Box2D.Collision.b2Collision.s_v11.y;for(k=h=0;k<Box2D.Common.b2Settings.b2_maxManifoldPoints;++k)Box2D.Collision.b2Collision.s_normal.x*Box2D.Collision.b2Collision.s_clipPoints2[k].v.x+Box2D.Collision.b2Collision.s_normal.y*Box2D.Collision.b2Collision.s_clipPoints2[k].v.y-n<=f&&(m=Box2D.Collision.b2Collision.s_clipPoints2[k].v.x-
q.position.x,b=Box2D.Collision.b2Collision.s_clipPoints2[k].v.y-q.position.y,a.m_points[h].m_localPoint.x=m*q.R.col1.x+b*q.R.col1.y,a.m_points[h].m_localPoint.y=m*q.R.col2.x+b*q.R.col2.y,a.m_points[h].m_id.Set(Box2D.Collision.b2Collision.s_clipPoints2[k].id),a.m_points[h].m_id.SetFlip(p),h++);a.m_pointCount=h}}}};Box2D.Collision.b2Collision.CollideCircles=function(a,b,c,d,e){a.m_pointCount=0;var f=e.position.x+(e.R.col1.x*d.m_p.x+e.R.col2.x*d.m_p.y)-(c.position.x+(c.R.col1.x*b.m_p.x+c.R.col2.x*b.m_p.y));
c=e.position.y+(e.R.col1.y*d.m_p.x+e.R.col2.y*d.m_p.y)-(c.position.y+(c.R.col1.y*b.m_p.x+c.R.col2.y*b.m_p.y));e=b.m_radius+d.m_radius;f*f+c*c>e*e||(a.m_type=Box2D.Collision.b2Manifold.e_circles,a.m_localPoint.SetV(b.m_p),a.m_localPlaneNormal.SetZero(),a.m_pointCount=1,a.m_points[0].m_localPoint.SetV(d.m_p),a.m_points[0].m_id.SetKey(0))};Box2D.Collision.b2Collision.CollidePolygonAndCircle=function(a,b,c,d,e){a.m_pointCount=0;var f=e.position.x+(e.R.col1.x*d.m_p.x+e.R.col2.x*d.m_p.y)-c.position.x,g=
e.position.y+(e.R.col1.y*d.m_p.x+e.R.col2.y*d.m_p.y)-c.position.y;e=f*c.R.col1.x+g*c.R.col1.y;c=f*c.R.col2.x+g*c.R.col2.y;for(var f=0,g=-Number.MAX_VALUE,h=b.m_radius+d.m_radius,l=0;l<b.m_vertexCount;++l){var k=b.m_normals[l].x*(e-b.m_vertices[l].x)+b.m_normals[l].y*(c-b.m_vertices[l].y);if(k>h)return;k>g&&(g=k,f=l)}k=f+1;k>=b.m_vertexCount&&(k=0);var l=b.m_vertices[f],m=b.m_vertices[k];g<Number.MIN_VALUE?(a.m_pointCount=1,a.m_type=Box2D.Collision.b2Manifold.e_faceA,a.m_localPlaneNormal.SetV(b.m_normals[f]),
a.m_localPoint.x=0.5*(l.x+m.x),a.m_localPoint.y=0.5*(l.y+m.y),a.m_points[0].m_localPoint.SetV(d.m_p),a.m_points[0].m_id.SetKey(0)):0>=(e-l.x)*(m.x-l.x)+(c-l.y)*(m.y-l.y)?(e-l.x)*(e-l.x)+(c-l.y)*(c-l.y)>h*h||(a.m_pointCount=1,a.m_type=Box2D.Collision.b2Manifold.e_faceA,a.m_localPlaneNormal.x=e-l.x,a.m_localPlaneNormal.y=c-l.y,a.m_localPlaneNormal.Normalize(),a.m_localPoint.SetV(l),a.m_points[0].m_localPoint.SetV(d.m_p),a.m_points[0].m_id.SetKey(0)):0>=(e-m.x)*(l.x-m.x)+(c-m.y)*(l.y-m.y)?(e-m.x)*(e-
m.x)+(c-m.y)*(c-m.y)>h*h||(a.m_pointCount=1,a.m_type=Box2D.Collision.b2Manifold.e_faceA,a.m_localPlaneNormal.x=e-m.x,a.m_localPlaneNormal.y=c-m.y,a.m_localPlaneNormal.Normalize(),a.m_localPoint.SetV(m),a.m_points[0].m_localPoint.SetV(d.m_p),a.m_points[0].m_id.SetKey(0)):(k=0.5*(l.x+m.x),l=0.5*(l.y+m.y),g=(e-k)*b.m_normals[f].x+(c-l)*b.m_normals[f].y,g>h||(a.m_pointCount=1,a.m_type=Box2D.Collision.b2Manifold.e_faceA,a.m_localPlaneNormal.x=b.m_normals[f].x,a.m_localPlaneNormal.y=b.m_normals[f].y,a.m_localPlaneNormal.Normalize(),
a.m_localPoint.Set(k,l),a.m_points[0].m_localPoint.SetV(d.m_p),a.m_points[0].m_id.SetKey(0)))};Box2D.Collision.b2Collision.TestOverlap=function(a,b){return 0<b.lowerBound_.x-a.upperBound_.x||0<b.lowerBound_.y-a.upperBound_.y||0<a.lowerBound_.x-b.upperBound_.x||0<a.lowerBound_.y-b.upperBound_.y?!1:!0};Box2D.Collision.b2ContactPoint=function(){this.position=Box2D.Common.Math.b2Vec2.Get(0,0);this.velocity=Box2D.Common.Math.b2Vec2.Get(0,0);this.normal=Box2D.Common.Math.b2Vec2.Get(0,0);this.id=new Box2D.Collision.b2ContactID};
Box2D.Collision.b2Distance.Distance=function(a,b,c){var d=new Box2D.Collision.b2Simplex;d.ReadCache(b,c.proxyA,c.transformA,c.proxyB,c.transformB);for(var e=0;20>e;){for(var f=[],g=0;g<d.m_count;g++)f[g]={},f[g].indexA=d.m_vertices[g].indexA,f[g].indexB=d.m_vertices[g].indexB;2==d.m_count?d.Solve2():3==d.m_count&&d.Solve3();if(3==d.m_count)break;g=d.GetSearchDirection();if(g.LengthSquared()<Box2D.Common.b2Settings.MIN_VALUE_SQUARED)break;var h=g.GetNegative();d.m_vertices[d.m_count].indexA=c.proxyA.GetSupport(Box2D.Common.Math.b2Math.MulTMV(c.transformA.R,
h));d.m_vertices[d.m_count].wA=Box2D.Common.Math.b2Math.MulX(c.transformA,c.proxyA.GetVertex(d.m_vertices[d.m_count].indexA));d.m_vertices[d.m_count].indexB=c.proxyB.GetSupport(Box2D.Common.Math.b2Math.MulTMV(c.transformB.R,g));d.m_vertices[d.m_count].wB=Box2D.Common.Math.b2Math.MulX(c.transformB,c.proxyB.GetVertex(d.m_vertices[d.m_count].indexB));d.m_vertices[d.m_count].w=Box2D.Common.Math.b2Math.SubtractVV(d.m_vertices[d.m_count].wB,d.m_vertices[d.m_count].wA);Box2D.Common.Math.b2Vec2.Free(g);Box2D.Common.Math.b2Vec2.Free(h);
e++;h=!1;for(g=0;g<f.length;g++)if(d.m_vertices[d.m_count].indexA==f[g].indexA&&d.m_vertices[d.m_count].indexB==f[g].indexB){h=!0;break}if(h)break;d.m_count++}d.GetWitnessPoints(a.pointA,a.pointB);a.distance=Box2D.Common.Math.b2Math.SubtractVV(a.pointA,a.pointB).Length();d.WriteCache(b);c.useRadii&&(b=c.proxyA.m_radius,c=c.proxyB.m_radius,a.distance>b+c&&a.distance>Number.MIN_VALUE?(a.distance-=b+c,d=Box2D.Common.Math.b2Math.SubtractVV(a.pointB,a.pointA),d.Normalize(),a.pointA.x+=b*d.x,a.pointA.y+=
b*d.y,a.pointB.x-=c*d.x,a.pointB.y-=c*d.y,Box2D.Common.Math.b2Vec2.Free(d)):(c=Box2D.Common.Math.b2Vec2.Get(0,0),c.x=0.5*(a.pointA.x+a.pointB.x),c.y=0.5*(a.pointA.y+a.pointB.y),a.pointA.x=a.pointB.x=c.x,a.pointA.y=a.pointB.y=c.y,a.distance=0,Box2D.Common.Math.b2Vec2.Free(c)))};Box2D.Collision.b2DistanceInput=function(){};Box2D.Collision.b2DistanceOutput=function(){this.pointA=Box2D.Common.Math.b2Vec2.Get(0,0);this.pointB=Box2D.Common.Math.b2Vec2.Get(0,0);this.distance=0};Box2D.Collision.b2DistanceProxy=
function(){};Box2D.Collision.b2DistanceProxy.prototype.Set=function(a){a.SetDistanceProxy(this)};Box2D.Collision.b2DistanceProxy.prototype.GetSupport=function(a){for(var b=0,c=this.m_vertices[0].x*a.x+this.m_vertices[0].y*a.y,d=1;d<this.m_count;d++){var e=this.m_vertices[d].x*a.x+this.m_vertices[d].y*a.y;e>c&&(b=d,c=e)}return b};Box2D.Collision.b2DistanceProxy.prototype.GetSupportVertex=function(a){return this.m_vertices[this.GetSupport(a)]};Box2D.Collision.b2DistanceProxy.prototype.GetVertexCount=
function(){return this.m_count};Box2D.Collision.b2DistanceProxy.prototype.GetVertex=function(a){void 0===a&&(a=0);return this.m_vertices[a]};Box2D.Collision.b2DynamicTree=function(){this.m_root=null;this.m_insertionCount=this.m_path=0};Box2D.Collision.b2DynamicTree.prototype.CreateProxy=function(a,b){var c=Box2D.Collision.b2DynamicTreeNode.Get(b),d=Box2D.Common.b2Settings.b2_aabbExtension,e=Box2D.Common.b2Settings.b2_aabbExtension;c.aabb.lowerBound_.x=a.lowerBound_.x-d;c.aabb.lowerBound_.y=a.lowerBound_.y-
e;c.aabb.upperBound_.x=a.upperBound_.x+d;c.aabb.upperBound_.y=a.upperBound_.y+e;this.InsertLeaf(c);return c};Box2D.Collision.b2DynamicTree.prototype.DestroyProxy=function(a){this.RemoveLeaf(a);a.Destroy()};Box2D.Collision.b2DynamicTree.prototype.MoveProxy=function(a,b,c){if(a.aabb.Contains(b))return!1;this.RemoveLeaf(a);var d=Box2D.Common.b2Settings.b2_aabbExtension+Box2D.Common.b2Settings.b2_aabbMultiplier*Math.abs(c.x);c=Box2D.Common.b2Settings.b2_aabbExtension+Box2D.Common.b2Settings.b2_aabbMultiplier*
Math.abs(c.y);a.aabb.lowerBound_.x=b.lowerBound_.x-d;a.aabb.lowerBound_.y=b.lowerBound_.y-c;a.aabb.upperBound_.x=b.upperBound_.x+d;a.aabb.upperBound_.y=b.upperBound_.y+c;this.InsertLeaf(a);return!0};Box2D.Collision.b2DynamicTree.prototype.Rebalance=function(a){if(null!==this.m_root)for(var b=0;b<a;b++){for(var c=this.m_root,d=0;!c.IsLeaf();)c=this.m_path>>d&1?c.child2:c.child1,d=d+1&31;this.m_path++;this.RemoveLeaf(c);this.InsertLeaf(c)}};Box2D.Collision.b2DynamicTree.prototype.GetFatAABB=function(a){return a.aabb};
Box2D.Collision.b2DynamicTree.prototype.Query=function(a,b){if(null!==this.m_root){var c=[];for(c.push(this.m_root);0<c.length;){var d=c.pop();if(d.aabb.TestOverlap(b))if(d.IsLeaf()){if(!a(d.fixture))break}else c.push(d.child1),c.push(d.child2)}}};Box2D.Collision.b2DynamicTree.prototype.RayCast=function(a,b){if(null!==this.m_root){var c=Box2D.Common.Math.b2Math.SubtractVV(b.p1,b.p2);c.Normalize();var c=Box2D.Common.Math.b2Math.CrossFV(1,c),d=Box2D.Common.Math.b2Math.AbsV(c),e=b.maxFraction,f=b.p1.x+
e*(b.p2.x-b.p1.x),e=b.p1.y+e*(b.p2.y-b.p1.y),g=Box2D.Collision.b2AABB.Get();g.lowerBound_.x=Math.min(b.p1.x,f);g.lowerBound_.y=Math.min(b.p1.y,e);g.upperBound_.x=Math.max(b.p1.x,f);g.upperBound_.y=Math.max(b.p1.y,e);var h=[];for(h.push(this.m_root);0<h.length;)if(f=h.pop(),f.aabb.TestOverlap(g)){var e=f.aabb.GetCenter(),l=f.aabb.GetExtents();if(!(0<Math.abs(c.x*(b.p1.x-e.x)+c.y*(b.p1.y-e.y))-d.x*l.x-d.y*l.y))if(f.IsLeaf()){new Box2D.Collision.b2RayCastInput(b.p1,b.p2,b.maxFraction);e=a(b,f.fixture);
if(0==e)break;0<e&&(f=b.p1.x+e*(b.p2.x-b.p1.x),e=b.p1.y+e*(b.p2.y-b.p1.y),g.lowerBound_.x=Math.min(b.p1.x,f),g.lowerBound_.y=Math.min(b.p1.y,e),g.upperBound_.x=Math.max(b.p1.x,f),g.upperBound_.y=Math.max(b.p1.y,e))}else h.push(f.child1),h.push(f.child2)}Box2D.Collision.b2AABB.Free(g)}};Box2D.Collision.b2DynamicTree.prototype.InsertLeaf=function(a){this.m_insertionCount++;if(null===this.m_root)this.m_root=a,this.m_root.parent=null;else{var b=this.GetBestSibling(a),c=b.parent,d=Box2D.Collision.b2DynamicTreeNode.Get();
d.parent=c;d.aabb.Combine(a.aabb,b.aabb);if(c){b.parent.child1==b?c.child1=d:c.child2=d;d.child1=b;d.child2=a;b.parent=d;for(a.parent=d;c&&!c.aabb.Contains(d.aabb);)c.aabb.Combine(c.child1.aabb,c.child2.aabb),d=c,c=c.parent}else d.child1=b,d.child2=a,b.parent=d,this.m_root=a.parent=d}};Box2D.Collision.b2DynamicTree.prototype.GetBestSibling=function(a){a=a.aabb.GetCenter();for(var b=this.m_root;!b.IsLeaf();)var c=b.child1,b=b.child2,d=Math.abs((c.aabb.lowerBound_.x+c.aabb.upperBound_.x)/2-a.x)+Math.abs((c.aabb.lowerBound_.y+
c.aabb.upperBound_.y)/2-a.y),e=Math.abs((b.aabb.lowerBound_.x+b.aabb.upperBound_.x)/2-a.x)+Math.abs((b.aabb.lowerBound_.y+b.aabb.upperBound_.y)/2-a.y),b=d<e?c:b;Box2D.Common.Math.b2Vec2.Free(a);return b};Box2D.Collision.b2DynamicTree.prototype.RemoveLeaf=function(a){if(a==this.m_root)this.m_root=null;else{var b=a.parent,c=b.parent;a=b.child1==a?b.child2:b.child1;if(c){c.child1==b?c.child1=a:c.child2=a;for(a.parent=c;c;){a=c.aabb;c.aabb.Combine(c.child1.aabb,c.child2.aabb);if(a.Contains(c.aabb))break;
c=c.parent}}else this.m_root=a,a.parent=null;b.Destroy()}};Box2D.Collision.b2DynamicTreeBroadPhase=function(){this.m_tree=new Box2D.Collision.b2DynamicTree;this.m_moveBuffer=[]};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.CreateProxy=function(a,b){var c=this.m_tree.CreateProxy(a,b);this.BufferMove(c);return c};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.DestroyProxy=function(a){this.UnBufferMove(a);this.m_tree.DestroyProxy(a)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.MoveProxy=
function(a,b,c){this.m_tree.MoveProxy(a,b,c)&&this.BufferMove(a)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.TestOverlap=function(a,b){var c=this.m_tree.GetFatAABB(a),d=this.m_tree.GetFatAABB(b);return c.TestOverlap(d)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.GetFatAABB=function(a){return this.m_tree.GetFatAABB(a)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.GetProxyCount=function(){return this.m_tree.length};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.UpdatePairs=function(a){for(var b=
[];0<this.m_moveBuffer.length;){var c=this.m_moveBuffer.pop(),d=this.m_tree.GetFatAABB(c);this.m_tree.Query(function(a){a!=c.fixture&&b.push(new Box2D.Collision.b2DynamicTreePair(c.fixture,a));return!0},d)}for(d=0;d<b.length;){var e=b[d];a(e.fixtureA,e.fixtureB);for(d++;d<b.length;){var f=b[d];if(!(f.fixtureA==e.fixtureA&&f.fixtureB==e.fixtureB)&&!(f.fixtureA==e.fixtureB&&f.fixtureB==e.fixtureA))break;d++}}};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.Query=function(a,b){this.m_tree.Query(a,
b)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.RayCast=function(a,b){this.m_tree.RayCast(a,b)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.Rebalance=function(a){this.m_tree.Rebalance(a)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.BufferMove=function(a){this.m_moveBuffer.push(a)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.UnBufferMove=function(a){cr.arrayFindRemove(this.m_moveBuffer,a)};Box2D.Collision.b2DynamicTreeBroadPhase.__implements={};Box2D.Collision.b2DynamicTreeBroadPhase.__implements[Box2D.Collision.IBroadPhase]=
!0;Box2D.Collision.b2DynamicTreeNode=function(a){this.aabb=Box2D.Collision.b2AABB.Get();this.fixture=this.parent=this.child2=this.child1=null;"undefined"!=typeof a&&(this.fixture=a)};Box2D.Collision.b2DynamicTreeNode._freeCache=[];Box2D.Collision.b2DynamicTreeNode.Get=function(a){if(0<Box2D.Collision.b2DynamicTreeNode._freeCache.length){var b=Box2D.Collision.b2DynamicTreeNode._freeCache.pop();"undefined"!=typeof a&&(b.fixture=a);b.aabb.SetZero();return b}return new Box2D.Collision.b2DynamicTreeNode(a)};
Box2D.Collision.b2DynamicTreeNode.prototype.Destroy=function(){this.fixture=this.parent=this.child2=this.child1=null;Box2D.Collision.b2DynamicTreeNode._freeCache.push(this)};Box2D.Collision.b2DynamicTreeNode.prototype.IsLeaf=function(){return null===this.child1};Box2D.Collision.b2DynamicTreePair=function(a,b){this.fixtureA=a;this.fixtureB=b};Box2D.Collision.b2Manifold=function(){this.m_type=this.m_pointCount=0;this.m_points=[];for(var a=0;a<Box2D.Common.b2Settings.b2_maxManifoldPoints;a++)this.m_points[a]=
new Box2D.Collision.b2ManifoldPoint;this.m_localPlaneNormal=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localPoint=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2Manifold.prototype.Reset=function(){for(var a=0;a<Box2D.Common.b2Settings.b2_maxManifoldPoints;a++)this.m_points[a].Reset();this.m_localPlaneNormal.SetZero();this.m_localPoint.SetZero();this.m_pointCount=this.m_type=0};Box2D.Collision.b2Manifold.prototype.Set=function(a){this.m_pointCount=a.m_pointCount;for(var b=0;b<Box2D.Common.b2Settings.b2_maxManifoldPoints;b++)this.m_points[b].Set(a.m_points[b]);
this.m_localPlaneNormal.SetV(a.m_localPlaneNormal);this.m_localPoint.SetV(a.m_localPoint);this.m_type=a.m_type};Box2D.Collision.b2Manifold.prototype.Copy=function(){var a=new Box2D.Collision.b2Manifold;a.Set(this);return a};Box2D.Collision.b2Manifold.e_circles=1;Box2D.Collision.b2Manifold.e_faceA=2;Box2D.Collision.b2Manifold.e_faceB=4;Box2D.Collision.b2ManifoldPoint=function(){this.m_localPoint=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_id=new Box2D.Collision.b2ContactID;this.Reset()};Box2D.Collision.b2ManifoldPoint.prototype.Reset=
function(){this.m_localPoint.SetZero();this.m_tangentImpulse=this.m_normalImpulse=0;this.m_id.SetKey(0)};Box2D.Collision.b2ManifoldPoint.prototype.Set=function(a){this.m_localPoint.SetV(a.m_localPoint);this.m_normalImpulse=a.m_normalImpulse;this.m_tangentImpulse=a.m_tangentImpulse;this.m_id.Set(a.m_id)};Box2D.Collision.b2RayCastInput=function(a,b,c){this.p1=Box2D.Common.Math.b2Vec2.Get(0,0);this.p2=Box2D.Common.Math.b2Vec2.Get(0,0);void 0===c&&(c=1);a&&this.p1.SetV(a);b&&this.p2.SetV(b);this.maxFraction=
c};Box2D.Collision.b2RayCastOutput=function(){this.normal=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2Segment=function(){this.p1=Box2D.Common.Math.b2Vec2.Get(0,0);this.p2=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2Segment.prototype.TestSegment=function(a,b,c,d){void 0===d&&(d=0);var e=c.p1,f=c.p2.x-e.x,g=c.p2.y-e.y;c=this.p2.y-this.p1.y;var h=-(this.p2.x-this.p1.x),l=100*Number.MIN_VALUE,k=-(f*c+g*h);if(k>l){var m=e.x-this.p1.x,n=e.y-this.p1.y,e=m*c+n*h;if(0<=e&&e<=d*k&&(d=-f*n+
g*m,-l*k<=d&&d<=k*(1+l)))return e/=k,d=Math.sqrt(c*c+h*h),a[0]=e,b.Set(c/d,h/d),!0}return!1};Box2D.Collision.b2Segment.prototype.Extend=function(a){this.ExtendForward(a);this.ExtendBackward(a)};Box2D.Collision.b2Segment.prototype.ExtendForward=function(a){var b=this.p2.x-this.p1.x,c=this.p2.y-this.p1.y;a=Math.min(0<b?(a.upperBound_.x-this.p1.x)/b:0>b?(a.lowerBound_.x-this.p1.x)/b:Number.POSITIVE_INFINITY,0<c?(a.upperBound_.y-this.p1.y)/c:0>c?(a.lowerBound_.y-this.p1.y)/c:Number.POSITIVE_INFINITY);
this.p2.x=this.p1.x+b*a;this.p2.y=this.p1.y+c*a};Box2D.Collision.b2Segment.prototype.ExtendBackward=function(a){var b=-this.p2.x+this.p1.x,c=-this.p2.y+this.p1.y;a=Math.min(0<b?(a.upperBound_.x-this.p2.x)/b:0>b?(a.lowerBound_.x-this.p2.x)/b:Number.POSITIVE_INFINITY,0<c?(a.upperBound_.y-this.p2.y)/c:0>c?(a.lowerBound_.y-this.p2.y)/c:Number.POSITIVE_INFINITY);this.p1.x=this.p2.x+b*a;this.p1.y=this.p2.y+c*a};Box2D.Collision.b2SeparationFunction=function(){this.m_localPoint=Box2D.Common.Math.b2Vec2.Get(0,
0);this.m_axis=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2SeparationFunction.prototype.Initialize=function(a,b,c,d,e){this.m_proxyA=b;this.m_proxyB=d;var f,g,h,l=h=g=0,k=0;d=b=0;var m,n,l=0;1==a.count?(this.m_type=Box2D.Collision.b2SeparationFunction.e_points,f=this.m_proxyA.GetVertex(a.indexA[0]),a=this.m_proxyB.GetVertex(a.indexB[0]),n=f,m=c.R,g=c.position.x+(m.col1.x*n.x+m.col2.x*n.y),h=c.position.y+(m.col1.y*n.x+m.col2.y*n.y),n=a,m=e.R,l=e.position.x+(m.col1.x*n.x+m.col2.x*n.y),k=e.position.y+
(m.col1.y*n.x+m.col2.y*n.y),this.m_axis.x=l-g,this.m_axis.y=k-h,this.m_axis.Normalize()):(a.indexB[0]==a.indexB[1]?(this.m_type=Box2D.Collision.b2SeparationFunction.e_faceA,b=this.m_proxyA.GetVertex(a.indexA[0]),d=this.m_proxyA.GetVertex(a.indexA[1]),a=this.m_proxyB.GetVertex(a.indexB[0]),this.m_localPoint.x=0.5*(b.x+d.x),this.m_localPoint.y=0.5*(b.y+d.y),this.m_axis=Box2D.Common.Math.b2Math.CrossVF(Box2D.Common.Math.b2Math.SubtractVV(d,b),1),this.m_axis.Normalize(),n=this.m_axis,m=c.R,b=m.col1.x*
n.x+m.col2.x*n.y,d=m.col1.y*n.x+m.col2.y*n.y,n=this.m_localPoint,m=c.R,g=c.position.x+(m.col1.x*n.x+m.col2.x*n.y),h=c.position.y+(m.col1.y*n.x+m.col2.y*n.y),n=a,m=e.R,l=e.position.x+(m.col1.x*n.x+m.col2.x*n.y),k=e.position.y+(m.col1.y*n.x+m.col2.y*n.y),l=(l-g)*b+(k-h)*d):a.indexA[0]==a.indexA[0]?(this.m_type=Box2D.Collision.b2SeparationFunction.e_faceB,g=this.m_proxyB.GetVertex(a.indexB[0]),h=this.m_proxyB.GetVertex(a.indexB[1]),f=this.m_proxyA.GetVertex(a.indexA[0]),this.m_localPoint.x=0.5*(g.x+
h.x),this.m_localPoint.y=0.5*(g.y+h.y),this.m_axis=Box2D.Common.Math.b2Math.CrossVF(Box2D.Common.Math.b2Math.SubtractVV(h,g),1),this.m_axis.Normalize(),n=this.m_axis,m=e.R,b=m.col1.x*n.x+m.col2.x*n.y,d=m.col1.y*n.x+m.col2.y*n.y,n=this.m_localPoint,m=e.R,l=e.position.x+(m.col1.x*n.x+m.col2.x*n.y),k=e.position.y+(m.col1.y*n.x+m.col2.y*n.y),n=f,m=c.R,g=c.position.x+(m.col1.x*n.x+m.col2.x*n.y),h=c.position.y+(m.col1.y*n.x+m.col2.y*n.y),l=(g-l)*b+(h-k)*d):(b=this.m_proxyA.GetVertex(a.indexA[0]),d=this.m_proxyA.GetVertex(a.indexA[1]),
g=this.m_proxyB.GetVertex(a.indexB[0]),h=this.m_proxyB.GetVertex(a.indexB[1]),l=Box2D.Common.Math.b2Math.MulMV(c.R,Box2D.Common.Math.b2Math.SubtractVV(d,b)),k=Box2D.Common.Math.b2Math.MulMV(e.R,Box2D.Common.Math.b2Math.SubtractVV(h,g)),e=l.x*l.x+l.y*l.y,c=k.x*k.x+k.y*k.y,f=Box2D.Common.Math.b2Math.SubtractVV(k,l),a=l.x*f.x+l.y*f.y,f=k.x*f.x+k.y*f.y,k=l.x*k.x+l.y*k.y,m=e*c-k*k,l=0,0!=m&&(l=Box2D.Common.Math.b2Math.Clamp((k*f-a*c)/m,0,1)),0>(k*l+f)/c&&(l=Box2D.Common.Math.b2Math.Clamp((k-a)/e,0,1)),
f=Box2D.Common.Math.b2Vec2.Get(0,0),f.x=b.x+l*(d.x-b.x),f.y=b.y+l*(d.y-b.y),a=Box2D.Common.Math.b2Vec2.Get(0,0),a.x=g.x+l*(h.x-g.x),a.y=g.y+l*(h.y-g.y),0==l||1==l?(this.m_type=Box2D.Collision.b2SeparationFunction.e_faceB,this.m_axis=Box2D.Common.Math.b2Math.CrossVF(Box2D.Common.Math.b2Math.SubtractVV(h,g),1),this.m_axis.Normalize(),this.m_localPoint=a):(this.m_type=Box2D.Collision.b2SeparationFunction.e_faceA,this.m_axis=Box2D.Common.Math.b2Math.CrossVF(Box2D.Common.Math.b2Math.SubtractVV(d,b),1),
this.m_localPoint=f)),0>l&&this.m_axis.NegativeSelf())};Box2D.Collision.b2SeparationFunction.prototype.Evaluate=function(a,b){var c,d,e=0;switch(this.m_type){case Box2D.Collision.b2SeparationFunction.e_points:c=Box2D.Common.Math.b2Math.MulTMV(a.R,this.m_axis);d=Box2D.Common.Math.b2Math.MulTMV(b.R,this.m_axis.GetNegative());c=this.m_proxyA.GetSupportVertex(c);d=this.m_proxyB.GetSupportVertex(d);c=Box2D.Common.Math.b2Math.MulX(a,c);d=Box2D.Common.Math.b2Math.MulX(b,d);e=(d.x-c.x)*this.m_axis.x+(d.y-
c.y)*this.m_axis.y;break;case Box2D.Collision.b2SeparationFunction.e_faceA:e=Box2D.Common.Math.b2Math.MulMV(a.R,this.m_axis);c=Box2D.Common.Math.b2Math.MulX(a,this.m_localPoint);d=Box2D.Common.Math.b2Math.MulTMV(b.R,e.GetNegative());d=this.m_proxyB.GetSupportVertex(d);d=Box2D.Common.Math.b2Math.MulX(b,d);e=(d.x-c.x)*e.x+(d.y-c.y)*e.y;break;case Box2D.Collision.b2SeparationFunction.e_faceB:e=Box2D.Common.Math.b2Math.MulMV(b.R,this.m_axis),d=Box2D.Common.Math.b2Math.MulX(b,this.m_localPoint),c=Box2D.Common.Math.b2Math.MulTMV(a.R,
e.GetNegative()),c=this.m_proxyA.GetSupportVertex(c),c=Box2D.Common.Math.b2Math.MulX(a,c),e=(c.x-d.x)*e.x+(c.y-d.y)*e.y}return e};Box2D.Collision.b2SeparationFunction.e_points=1;Box2D.Collision.b2SeparationFunction.e_faceA=2;Box2D.Collision.b2SeparationFunction.e_faceB=4;Box2D.Collision.b2Simplex=function(){this.m_v1=new Box2D.Collision.b2SimplexVertex;this.m_v2=new Box2D.Collision.b2SimplexVertex;this.m_v3=new Box2D.Collision.b2SimplexVertex;this.m_vertices=[this.m_v1,this.m_v2,this.m_v3]};Box2D.Collision.b2Simplex.prototype.ReadCache=
function(a,b,c,d,e){var f,g;this.m_count=a.count;for(var h=this.m_vertices,l=0;l<this.m_count;l++){var k=h[l];k.indexA=a.indexA[l];k.indexB=a.indexB[l];f=b.GetVertex(k.indexA);g=d.GetVertex(k.indexB);k.wA=Box2D.Common.Math.b2Math.MulX(c,f);k.wB=Box2D.Common.Math.b2Math.MulX(e,g);k.w=Box2D.Common.Math.b2Math.SubtractVV(k.wB,k.wA);k.a=0}if(1<this.m_count&&(a=a.metric,f=this.GetMetric(),f<0.5*a||2*a<f||f<Number.MIN_VALUE))this.m_count=0;0==this.m_count&&(k=h[0],k.indexA=0,k.indexB=0,f=b.GetVertex(0),
g=d.GetVertex(0),k.wA=Box2D.Common.Math.b2Math.MulX(c,f),k.wB=Box2D.Common.Math.b2Math.MulX(e,g),k.w=Box2D.Common.Math.b2Math.SubtractVV(k.wB,k.wA),this.m_count=1)};Box2D.Collision.b2Simplex.prototype.WriteCache=function(a){a.metric=this.GetMetric();a.count=this.m_count;for(var b=this.m_vertices,c=0;c<this.m_count;c++)a.indexA[c]=b[c].indexA,a.indexB[c]=b[c].indexB};Box2D.Collision.b2Simplex.prototype.GetSearchDirection=function(){if(1==this.m_count)return this.m_v1.w.GetNegative();if(2==this.m_count){var a=
Box2D.Common.Math.b2Math.SubtractVV(this.m_v2.w,this.m_v1.w);return 0<Box2D.Common.Math.b2Math.CrossVV(a,this.m_v1.w.GetNegative())?Box2D.Common.Math.b2Math.CrossFV(1,a):Box2D.Common.Math.b2Math.CrossVF(a,1)}return Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2Simplex.prototype.GetClosestPoint=function(){return 1==this.m_count?this.m_v1.w:2==this.m_count?Box2D.Common.Math.b2Vec2.Get(this.m_v1.a*this.m_v1.w.x+this.m_v2.a*this.m_v2.w.x,this.m_v1.a*this.m_v1.w.y+this.m_v2.a*this.m_v2.w.y):Box2D.Common.Math.b2Vec2.Get(0,
0)};Box2D.Collision.b2Simplex.prototype.GetWitnessPoints=function(a,b){1==this.m_count?(a.SetV(this.m_v1.wA),b.SetV(this.m_v1.wB)):2==this.m_count?(a.x=this.m_v1.a*this.m_v1.wA.x+this.m_v2.a*this.m_v2.wA.x,a.y=this.m_v1.a*this.m_v1.wA.y+this.m_v2.a*this.m_v2.wA.y,b.x=this.m_v1.a*this.m_v1.wB.x+this.m_v2.a*this.m_v2.wB.x,b.y=this.m_v1.a*this.m_v1.wB.y+this.m_v2.a*this.m_v2.wB.y):3==this.m_count&&(b.x=a.x=this.m_v1.a*this.m_v1.wA.x+this.m_v2.a*this.m_v2.wA.x+this.m_v3.a*this.m_v3.wA.x,b.y=a.y=this.m_v1.a*
this.m_v1.wA.y+this.m_v2.a*this.m_v2.wA.y+this.m_v3.a*this.m_v3.wA.y)};Box2D.Collision.b2Simplex.prototype.GetMetric=function(){return 1==this.m_count?0:2==this.m_count?Box2D.Common.Math.b2Math.SubtractVV(this.m_v1.w,this.m_v2.w).Length():3==this.m_count?Box2D.Common.Math.b2Math.CrossVV(Box2D.Common.Math.b2Math.SubtractVV(this.m_v2.w,this.m_v1.w),Box2D.Common.Math.b2Math.SubtractVV(this.m_v3.w,this.m_v1.w)):0};Box2D.Collision.b2Simplex.prototype.Solve2=function(){var a=this.m_v1.w,b=this.m_v2.w,c=
Box2D.Common.Math.b2Math.SubtractVV(b,a),a=-(a.x*c.x+a.y*c.y);0>=a?this.m_count=this.m_v1.a=1:(b=b.x*c.x+b.y*c.y,0>=b?(this.m_count=this.m_v2.a=1,this.m_v1.Set(this.m_v2)):(c=1/(b+a),this.m_v1.a=b*c,this.m_v2.a=a*c,this.m_count=2))};Box2D.Collision.b2Simplex.prototype.Solve3=function(){var a=this.m_v1.w,b=this.m_v2.w,c=this.m_v3.w,d=Box2D.Common.Math.b2Math.SubtractVV(b,a),e=Box2D.Common.Math.b2Math.Dot(a,d),f=Box2D.Common.Math.b2Math.Dot(b,d),e=-e,g=Box2D.Common.Math.b2Math.SubtractVV(c,a),h=Box2D.Common.Math.b2Math.Dot(a,
g),l=Box2D.Common.Math.b2Math.Dot(c,g),h=-h,k=Box2D.Common.Math.b2Math.SubtractVV(c,b),m=Box2D.Common.Math.b2Math.Dot(b,k),k=Box2D.Common.Math.b2Math.Dot(c,k),m=-m,g=Box2D.Common.Math.b2Math.CrossVV(d,g),d=g*Box2D.Common.Math.b2Math.CrossVV(b,c),c=g*Box2D.Common.Math.b2Math.CrossVV(c,a),a=g*Box2D.Common.Math.b2Math.CrossVV(a,b);0>=e&&0>=h?this.m_count=this.m_v1.a=1:0<f&&0<e&&0>=a?(l=1/(f+e),this.m_v1.a=f*l,this.m_v2.a=e*l,this.m_count=2):0<l&&0<h&&0>=c?(f=1/(l+h),this.m_v1.a=l*f,this.m_v3.a=h*f,this.m_count=
2,this.m_v2.Set(this.m_v3)):0>=f&&0>=m?(this.m_count=this.m_v2.a=1,this.m_v1.Set(this.m_v2)):0>=l&&0>=k?(this.m_count=this.m_v3.a=1,this.m_v1.Set(this.m_v3)):0<k&&0<m&&0>=d?(f=1/(k+m),this.m_v2.a=k*f,this.m_v3.a=m*f,this.m_count=2,this.m_v1.Set(this.m_v3)):(f=1/(d+c+a),this.m_v1.a=d*f,this.m_v2.a=c*f,this.m_v3.a=a*f,this.m_count=3)};Box2D.Collision.b2SimplexCache=function(){this.indexA=[0,0,0];this.indexB=[0,0,0]};Box2D.Collision.b2SimplexVertex=function(){};Box2D.Collision.b2SimplexVertex.prototype.Set=
function(a){this.wA.SetV(a.wA);this.wB.SetV(a.wB);this.w.SetV(a.w);this.a=a.a;this.indexA=a.indexA;this.indexB=a.indexB};Box2D.Collision.b2TOIInput=function(){this.proxyA=new Box2D.Collision.b2DistanceProxy;this.proxyB=new Box2D.Collision.b2DistanceProxy;this.sweepA=new Box2D.Common.Math.b2Sweep;this.sweepB=new Box2D.Common.Math.b2Sweep};Box2D.Collision.b2TimeOfImpact={};Box2D.Collision.b2TimeOfImpact.TimeOfImpact=function(a){Box2D.Collision.b2TimeOfImpact.b2_toiCalls++;var b=a.proxyA,c=a.proxyB,
d=a.sweepA,e=a.sweepB,f=b.m_radius+c.m_radius;a=a.tolerance;var g=0,h=0,l=0;Box2D.Collision.b2TimeOfImpact.s_cache.count=0;for(Box2D.Collision.b2TimeOfImpact.s_distanceInput.useRadii=!1;;){d.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfA,g);e.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfB,g);Box2D.Collision.b2TimeOfImpact.s_distanceInput.proxyA=b;Box2D.Collision.b2TimeOfImpact.s_distanceInput.proxyB=c;Box2D.Collision.b2TimeOfImpact.s_distanceInput.transformA=Box2D.Collision.b2TimeOfImpact.s_xfA;
Box2D.Collision.b2TimeOfImpact.s_distanceInput.transformB=Box2D.Collision.b2TimeOfImpact.s_xfB;Box2D.Collision.b2Distance.Distance(Box2D.Collision.b2TimeOfImpact.s_distanceOutput,Box2D.Collision.b2TimeOfImpact.s_cache,Box2D.Collision.b2TimeOfImpact.s_distanceInput);if(0>=Box2D.Collision.b2TimeOfImpact.s_distanceOutput.distance){g=1;break}Box2D.Collision.b2TimeOfImpact.s_fcn.Initialize(Box2D.Collision.b2TimeOfImpact.s_cache,b,Box2D.Collision.b2TimeOfImpact.s_xfA,c,Box2D.Collision.b2TimeOfImpact.s_xfB);
var k=Box2D.Collision.b2TimeOfImpact.s_fcn.Evaluate(Box2D.Collision.b2TimeOfImpact.s_xfA,Box2D.Collision.b2TimeOfImpact.s_xfB);if(0>=k){g=1;break}0==h&&(l=k>f?Math.max(f-a,0.75*f):Math.max(k-a,0.02*f));if(k-l<0.5*a){if(0==h){g=1;break}break}var m=g,n=g,q=1;d.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfA,q);e.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfB,q);var p=Box2D.Collision.b2TimeOfImpact.s_fcn.Evaluate(Box2D.Collision.b2TimeOfImpact.s_xfA,Box2D.Collision.b2TimeOfImpact.s_xfB);if(p>=l){g=
1;break}for(var r=0;;){var s=0,s=r&1?n+(l-k)*(q-n)/(p-k):0.5*(n+q);d.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfA,s);e.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfB,s);var t=Box2D.Collision.b2TimeOfImpact.s_fcn.Evaluate(Box2D.Collision.b2TimeOfImpact.s_xfA,Box2D.Collision.b2TimeOfImpact.s_xfB);if(Math.abs(t-l)<0.025*a){m=s;break}t>l?(n=s,k=t):(q=s,p=t);r++;Box2D.Collision.b2TimeOfImpact.b2_toiRootIters++;if(50==r)break}Box2D.Collision.b2TimeOfImpact.b2_toiMaxRootIters=Math.max(Box2D.Collision.b2TimeOfImpact.b2_toiMaxRootIters,
r);if(m<(1+100*Number.MIN_VALUE)*g)break;g=m;h++;Box2D.Collision.b2TimeOfImpact.b2_toiIters++;if(1E3==h)break}Box2D.Collision.b2TimeOfImpact.b2_toiMaxIters=Math.max(Box2D.Collision.b2TimeOfImpact.b2_toiMaxIters,h);return g};Box2D.Collision.b2WorldManifold=function(){this.m_normal=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_points=[];for(var a=this.m_pointCount=0;a<Box2D.Common.b2Settings.b2_maxManifoldPoints;a++)this.m_points[a]=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2WorldManifold.prototype.Initialize=
function(a,b,c,d,e){if(0!=a.m_pointCount){var f=0,g,h,l=0,k=0,m=0,n=0,q=0;g=0;switch(a.m_type){case Box2D.Collision.b2Manifold.e_circles:h=b.R;g=a.m_localPoint;f=b.position.x+h.col1.x*g.x+h.col2.x*g.y;b=b.position.y+h.col1.y*g.x+h.col2.y*g.y;h=d.R;g=a.m_points[0].m_localPoint;a=d.position.x+h.col1.x*g.x+h.col2.x*g.y;d=d.position.y+h.col1.y*g.x+h.col2.y*g.y;g=a-f;h=d-b;l=g*g+h*h;l>Box2D.Common.b2Settings.MIN_VALUE_SQUARED?(l=Math.sqrt(l),this.m_normal.x=g/l,this.m_normal.y=h/l):(this.m_normal.x=1,
this.m_normal.y=0);g=b+c*this.m_normal.y;d-=e*this.m_normal.y;this.m_points[0].x=0.5*(f+c*this.m_normal.x+(a-e*this.m_normal.x));this.m_points[0].y=0.5*(g+d);break;case Box2D.Collision.b2Manifold.e_faceA:h=b.R;g=a.m_localPlaneNormal;l=h.col1.x*g.x+h.col2.x*g.y;k=h.col1.y*g.x+h.col2.y*g.y;h=b.R;g=a.m_localPoint;m=b.position.x+h.col1.x*g.x+h.col2.x*g.y;n=b.position.y+h.col1.y*g.x+h.col2.y*g.y;this.m_normal.x=l;this.m_normal.y=k;for(f=0;f<a.m_pointCount;f++)h=d.R,g=a.m_points[f].m_localPoint,q=d.position.x+
h.col1.x*g.x+h.col2.x*g.y,g=d.position.y+h.col1.y*g.x+h.col2.y*g.y,this.m_points[f].x=q+0.5*(c-(q-m)*l-(g-n)*k-e)*l,this.m_points[f].y=g+0.5*(c-(q-m)*l-(g-n)*k-e)*k;break;case Box2D.Collision.b2Manifold.e_faceB:h=d.R;g=a.m_localPlaneNormal;l=h.col1.x*g.x+h.col2.x*g.y;k=h.col1.y*g.x+h.col2.y*g.y;h=d.R;g=a.m_localPoint;m=d.position.x+h.col1.x*g.x+h.col2.x*g.y;n=d.position.y+h.col1.y*g.x+h.col2.y*g.y;this.m_normal.x=-l;this.m_normal.y=-k;for(f=0;f<a.m_pointCount;f++)h=b.R,g=a.m_points[f].m_localPoint,
q=b.position.x+h.col1.x*g.x+h.col2.x*g.y,g=b.position.y+h.col1.y*g.x+h.col2.y*g.y,this.m_points[f].x=q+0.5*(e-(q-m)*l-(g-n)*k-c)*l,this.m_points[f].y=g+0.5*(e-(q-m)*l-(g-n)*k-c)*k}}};Box2D.Dynamics.b2Body=function(a,b){this.ID="Body"+Box2D.Dynamics.b2Body.NEXT_ID++;this.m_xf=new Box2D.Common.Math.b2Transform;this.m_xf.position.SetV(a.position);this.m_xf.R.Set(a.angle);this.m_sweep=new Box2D.Common.Math.b2Sweep;this.m_sweep.localCenter.SetZero();this.m_sweep.t0=1;this.m_sweep.a0=this.m_sweep.a=a.angle;
this.m_sweep.c.x=this.m_xf.R.col1.x*this.m_sweep.localCenter.x+this.m_xf.R.col2.x*this.m_sweep.localCenter.y;this.m_sweep.c.y=this.m_xf.R.col1.y*this.m_sweep.localCenter.x+this.m_xf.R.col2.y*this.m_sweep.localCenter.y;this.m_sweep.c.x+=this.m_xf.position.x;this.m_sweep.c.y+=this.m_xf.position.y;this.m_sweep.c0.SetV(this.m_sweep.c);this.m_linearVelocity=a.linearVelocity.Copy();this.m_force=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_bullet=a.bullet;this.m_fixedRotation=a.fixedRotation;this.m_allowSleep=
a.allowSleep;this.m_awake=a.awake;this.m_active=a.active;this.m_world=b;this.m_jointList=null;this.contactList=new Box2D.Dynamics.Contacts.b2ContactList;this.controllerList=new Box2D.Dynamics.Controllers.b2ControllerList;this.m_controllerCount=0;this.m_angularVelocity=a.angularVelocity;this.m_linearDamping=a.linearDamping;this.m_angularDamping=a.angularDamping;this.m_sleepTime=this.m_torque=0;this.m_type=a.type;this.m_mass=this.m_type==Box2D.Dynamics.b2BodyDef.b2_dynamicBody?1:0;this.m_invMass=this.m_type==
Box2D.Dynamics.b2BodyDef.b2_dynamicBody?1:0;this.m_invI=this.m_I=0;this.m_inertiaScale=a.inertiaScale;this.fixtureList=new Box2D.Dynamics.b2FixtureList;this.m_lists=[]};Box2D.Dynamics.b2Body.prototype.CreateFixture=function(a){a=new Box2D.Dynamics.b2Fixture(this,this.m_xf,a);this.m_active&&a.CreateProxy(this.m_world.m_contactManager.m_broadPhase,this.m_xf);this.fixtureList.AddFixture(a);a.m_body=this;0<a.m_density&&this.ResetMassData();this.m_world.m_newFixture=!0;return a};Box2D.Dynamics.b2Body.prototype.CreateFixture2=
function(a,b){void 0===b&&(b=0);var c=new Box2D.Dynamics.b2FixtureDef;c.shape=a;c.density=b;return this.CreateFixture(c)};Box2D.Dynamics.b2Body.prototype.Destroy=function(){Box2D.Common.Math.b2Vec2.Free(this.m_linearVelocity);Box2D.Common.Math.b2Vec2.Free(this.m_force)};Box2D.Dynamics.b2Body.prototype.DestroyFixture=function(a){this.fixtureList.RemoveFixture(a);for(var b=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);b;b=b.GetNextNode())(a==b.contact.m_fixtureA||
a==b.contact.m_fixtureB)&&this.m_world.m_contactManager.Destroy(b.contact);this.m_active&&a.DestroyProxy(this.m_world.m_contactManager.m_broadPhase);a.Destroy();a.m_body=null;this.ResetMassData()};Box2D.Dynamics.b2Body.prototype.SetPositionAndAngle=function(a,b){this.m_xf.R.Set(b);this.m_xf.position.SetV(a);var c=this.m_xf.R,d=this.m_sweep.localCenter;this.m_sweep.c.x=c.col1.x*d.x+c.col2.x*d.y;this.m_sweep.c.y=c.col1.y*d.x+c.col2.y*d.y;this.m_sweep.c.x+=this.m_xf.position.x;this.m_sweep.c.y+=this.m_xf.position.y;
this.m_sweep.c0.SetV(this.m_sweep.c);this.m_sweep.a0=this.m_sweep.a=b;c=this.m_world.m_contactManager.m_broadPhase;for(d=this.fixtureList.GetFirstNode();d;d=d.GetNextNode())d.fixture.Synchronize(c,this.m_xf,this.m_xf);this.m_world.m_contactManager.FindNewContacts()};Box2D.Dynamics.b2Body.prototype.SetTransform=function(a){this.SetPositionAndAngle(a.position,a.GetAngle())};Box2D.Dynamics.b2Body.prototype.GetTransform=function(){return this.m_xf};Box2D.Dynamics.b2Body.prototype.GetPosition=function(){return this.m_xf.position};
Box2D.Dynamics.b2Body.prototype.SetPosition=function(a){this.SetPositionAndAngle(a,this.GetAngle())};Box2D.Dynamics.b2Body.prototype.GetAngle=function(){return this.m_sweep.a};Box2D.Dynamics.b2Body.prototype.SetAngle=function(a){this.SetPositionAndAngle(this.GetPosition(),a)};Box2D.Dynamics.b2Body.prototype.GetWorldCenter=function(){return this.m_sweep.c};Box2D.Dynamics.b2Body.prototype.GetLocalCenter=function(){return this.m_sweep.localCenter};Box2D.Dynamics.b2Body.prototype.SetLinearVelocity=function(a){this.m_type!=
Box2D.Dynamics.b2BodyDef.b2_staticBody&&this.m_linearVelocity.SetV(a)};Box2D.Dynamics.b2Body.prototype.GetLinearVelocity=function(){return this.m_linearVelocity};Box2D.Dynamics.b2Body.prototype.SetAngularVelocity=function(a){void 0===a&&(a=0);this.m_type!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&(this.m_angularVelocity=a)};Box2D.Dynamics.b2Body.prototype.GetAngularVelocity=function(){return this.m_angularVelocity};Box2D.Dynamics.b2Body.prototype.GetDefinition=function(){var a=new Box2D.Dynamics.b2BodyDef;
a.type=this.GetType();a.allowSleep=this.m_allowSleep;a.angle=this.GetAngle();a.angularDamping=this.m_angularDamping;a.angularVelocity=this.m_angularVelocity;a.fixedRotation=this.m_fixedRotation;a.bullet=this.m_bullet;a.active=this.m_active;a.awake=this.m_awake;a.linearDamping=this.m_linearDamping;a.linearVelocity.SetV(this.GetLinearVelocity());a.position=this.GetPosition();return a};Box2D.Dynamics.b2Body.prototype.ApplyForce=function(a,b){this.m_type==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&(this.SetAwake(!0),
this.m_force.x+=a.x,this.m_force.y+=a.y,this.m_torque+=(b.x-this.m_sweep.c.x)*a.y-(b.y-this.m_sweep.c.y)*a.x)};Box2D.Dynamics.b2Body.prototype.ApplyTorque=function(a){void 0===a&&(a=0);this.m_type==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&(this.SetAwake(!0),this.m_torque+=a)};Box2D.Dynamics.b2Body.prototype.ApplyImpulse=function(a,b){this.m_type==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&(this.SetAwake(!0),this.m_linearVelocity.x+=this.m_invMass*a.x,this.m_linearVelocity.y+=this.m_invMass*a.y,this.m_angularVelocity+=
this.m_invI*((b.x-this.m_sweep.c.x)*a.y-(b.y-this.m_sweep.c.y)*a.x))};Box2D.Dynamics.b2Body.prototype.Split=function(a){for(var b=this.GetLinearVelocity().Copy(),c=this.GetAngularVelocity(),d=this.GetWorldCenter(),e=this.m_world.CreateBody(this.GetDefinition()),f=this.fixtureList.GetFirstNode();f;f=f.GetNextNode()){var g=f.fixture;a(g)&&(this.fixtureList.RemoveFixture(g),e.fixtureList.AddFixture(g))}this.ResetMassData();e.ResetMassData();f=this.GetWorldCenter();a=e.GetWorldCenter();f=Box2D.Common.Math.b2Math.AddVV(b,
Box2D.Common.Math.b2Math.CrossFV(c,Box2D.Common.Math.b2Math.SubtractVV(f,d)));b=Box2D.Common.Math.b2Math.AddVV(b,Box2D.Common.Math.b2Math.CrossFV(c,Box2D.Common.Math.b2Math.SubtractVV(a,d)));this.SetLinearVelocity(f);e.SetLinearVelocity(b);this.SetAngularVelocity(c);e.SetAngularVelocity(c);this.SynchronizeFixtures();e.SynchronizeFixtures();return e};Box2D.Dynamics.b2Body.prototype.Merge=function(a){for(var b=a.fixtureList.GetFirstNode();b;b=b.GetNextNode())this.fixtureList.AddFixture(b.fixture),a.fixtureList.RemoveFixture(b.fixture);
a.ResetMassData();this.ResetMassData();this.SynchronizeFixtures()};Box2D.Dynamics.b2Body.prototype.GetMass=function(){return this.m_mass};Box2D.Dynamics.b2Body.prototype.GetInertia=function(){return this.m_I};Box2D.Dynamics.b2Body.prototype.GetMassData=function(a){a||(a=new Box2D.Collision.Shapes.b2MassData);a.mass=this.m_mass;a.I=this.m_I;a.center.SetV(this.m_sweep.localCenter);return a};Box2D.Dynamics.b2Body.prototype.SetMassData=function(a){if(this.m_type==Box2D.Dynamics.b2BodyDef.b2_dynamicBody){this.m_invI=
this.m_I=this.m_invMass=0;this.m_mass=a.mass;0>=this.m_mass&&(this.m_mass=1);this.m_invMass=1/this.m_mass;0<a.I&&!this.m_fixedRotation&&(this.m_I=a.I-this.m_mass*(a.center.x*a.center.x+a.center.y*a.center.y),this.m_invI=1/this.m_I);var b=this.m_sweep.c.Copy();this.m_sweep.localCenter.SetV(a.center);this.m_sweep.c0.SetV(Box2D.Common.Math.b2Math.MulX(this.m_xf,this.m_sweep.localCenter));this.m_sweep.c.SetV(this.m_sweep.c0);this.m_linearVelocity.x+=this.m_angularVelocity*-(this.m_sweep.c.y-b.y);this.m_linearVelocity.y+=
this.m_angularVelocity*+(this.m_sweep.c.x-b.x)}};Box2D.Dynamics.b2Body.prototype.ResetMassData=function(){this.m_invI=this.m_I=this.m_invMass=this.m_mass=0;this.m_sweep.localCenter.SetZero();if(!(this.m_type==Box2D.Dynamics.b2BodyDef.b2_staticBody||this.m_type==Box2D.Dynamics.b2BodyDef.b2_kinematicBody)){for(var a=Box2D.Common.Math.b2Vec2.Get(0,0),b=this.fixtureList.GetFirstNode();b;b=b.GetNextNode()){var c=b.fixture;0!=c.m_density&&(c=c.GetMassData(),this.m_mass+=c.mass,a.x+=c.center.x*c.mass,a.y+=
c.center.y*c.mass,this.m_I+=c.I)}0<this.m_mass?(this.m_invMass=1/this.m_mass,a.x*=this.m_invMass,a.y*=this.m_invMass):this.m_invMass=this.m_mass=1;0<this.m_I&&!this.m_fixedRotation?(this.m_I-=this.m_mass*(a.x*a.x+a.y*a.y),this.m_I*=this.m_inertiaScale,this.m_invI=1/this.m_I):this.m_invI=this.m_I=0;b=this.m_sweep.c.Copy();this.m_sweep.localCenter.SetV(a);this.m_sweep.c0.SetV(Box2D.Common.Math.b2Math.MulX(this.m_xf,this.m_sweep.localCenter));this.m_sweep.c.SetV(this.m_sweep.c0);this.m_linearVelocity.x+=
this.m_angularVelocity*-(this.m_sweep.c.y-b.y);this.m_linearVelocity.y+=this.m_angularVelocity*+(this.m_sweep.c.x-b.x);Box2D.Common.Math.b2Vec2.Free(a);Box2D.Common.Math.b2Vec2.Free(b)}};Box2D.Dynamics.b2Body.prototype.GetWorldPoint=function(a){var b=this.m_xf.R;a=Box2D.Common.Math.b2Vec2.Get(b.col1.x*a.x+b.col2.x*a.y,b.col1.y*a.x+b.col2.y*a.y);a.x+=this.m_xf.position.x;a.y+=this.m_xf.position.y;return a};Box2D.Dynamics.b2Body.prototype.GetWorldVector=function(a){return Box2D.Common.Math.b2Math.MulMV(this.m_xf.R,
a)};Box2D.Dynamics.b2Body.prototype.GetLocalPoint=function(a){return Box2D.Common.Math.b2Math.MulXT(this.m_xf,a)};Box2D.Dynamics.b2Body.prototype.GetLocalVector=function(a){return Box2D.Common.Math.b2Math.MulTMV(this.m_xf.R,a)};Box2D.Dynamics.b2Body.prototype.GetLinearVelocityFromWorldPoint=function(a){return Box2D.Common.Math.b2Vec2.Get(this.m_linearVelocity.x-this.m_angularVelocity*(a.y-this.m_sweep.c.y),this.m_linearVelocity.y+this.m_angularVelocity*(a.x-this.m_sweep.c.x))};Box2D.Dynamics.b2Body.prototype.GetLinearVelocityFromLocalPoint=
function(a){var b=this.m_xf.R;a=Box2D.Common.Math.b2Vec2.Get(b.col1.x*a.x+b.col2.x*a.y,b.col1.y*a.x+b.col2.y*a.y);a.x+=this.m_xf.position.x;a.y+=this.m_xf.position.y;b=Box2D.Common.Math.b2Vec2.Get(this.m_linearVelocity.x-this.m_angularVelocity*(a.y-this.m_sweep.c.y),this.m_linearVelocity.y+this.m_angularVelocity*(a.x-this.m_sweep.c.x));Box2D.Common.Math.b2Vec2.Free(a);return b};Box2D.Dynamics.b2Body.prototype.GetLinearDamping=function(){return this.m_linearDamping};Box2D.Dynamics.b2Body.prototype.SetLinearDamping=
function(a){this.m_linearDamping=a};Box2D.Dynamics.b2Body.prototype.GetAngularDamping=function(){return this.m_angularDamping};Box2D.Dynamics.b2Body.prototype.SetAngularDamping=function(a){this.m_angularDamping=a};Box2D.Dynamics.b2Body.prototype.SetType=function(a){if(this.m_type!=a){this.m_type=a;this.ResetMassData();this.m_type==Box2D.Dynamics.b2BodyDef.b2_staticBody&&(this.m_linearVelocity.SetZero(),this.m_angularVelocity=0);this.SetAwake(!0);this.m_force.SetZero();this.m_torque=0;for(a=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=
a.GetNextNode())a.contact.FlagForFiltering();for(a=0;a<this.m_lists.length;a++)this.m_lists[a].UpdateBody(this)}};Box2D.Dynamics.b2Body.prototype.GetType=function(){return this.m_type};Box2D.Dynamics.b2Body.prototype.SetBullet=function(a){this.m_bullet=a};Box2D.Dynamics.b2Body.prototype.IsBullet=function(){return this.m_bullet};Box2D.Dynamics.b2Body.prototype.SetSleepingAllowed=function(a){(this.m_allowSleep=a)||this.SetAwake(!0)};Box2D.Dynamics.b2Body.prototype.SetAwake=function(a){if(this.m_awake!=
a){this.m_awake=a;this.m_sleepTime=0;a||(this.m_linearVelocity.SetZero(),this.m_angularVelocity=0,this.m_force.SetZero(),this.m_torque=0);for(a=0;a<this.m_lists.length;a++)this.m_lists[a].UpdateBody(this)}};Box2D.Dynamics.b2Body.prototype.IsAwake=function(){return this.m_awake};Box2D.Dynamics.b2Body.prototype.SetFixedRotation=function(a){this.m_fixedRotation=a;this.ResetMassData()};Box2D.Dynamics.b2Body.prototype.IsFixedRotation=function(){return this.m_fixedRotation};Box2D.Dynamics.b2Body.prototype.SetActive=
function(a){if(a!=this.m_active){if(a){this.m_active=!0;a=this.m_world.m_contactManager.m_broadPhase;for(var b=this.fixtureList.GetFirstNode();b;b=b.GetNextNode())b.fixture.CreateProxy(a,this.m_xf)}else{this.m_active=!1;a=this.m_world.m_contactManager.m_broadPhase;for(b=this.fixtureList.GetFirstNode();b;b=b.GetNextNode())b.fixture.DestroyProxy(a);for(a=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=a.GetNextNode())this.m_world.m_contactManager.Destroy(a.contact)}for(a=
0;a<this.m_lists.length;a++)this.m_lists[a].UpdateBody(this)}};Box2D.Dynamics.b2Body.prototype.IsActive=function(){return this.m_active};Box2D.Dynamics.b2Body.prototype.IsSleepingAllowed=function(){return this.m_allowSleep};Box2D.Dynamics.b2Body.prototype.GetFixtureList=function(){return this.fixtureList};Box2D.Dynamics.b2Body.prototype.GetJointList=function(){return this.m_jointList};Box2D.Dynamics.b2Body.prototype.GetControllerList=function(){return this.controllerList};Box2D.Dynamics.b2Body.prototype.AddController=
function(a){this.controllerList.AddController(a)};Box2D.Dynamics.b2Body.prototype.RemoveController=function(a){this.controllerList.RemoveController(a)};Box2D.Dynamics.b2Body.prototype.GetContactList=function(){return this.contactList};Box2D.Dynamics.b2Body.prototype.GetWorld=function(){return this.m_world};Box2D.Dynamics.b2Body.prototype.SynchronizeFixtures=function(){var a=Box2D.Dynamics.b2Body.s_xf1;a.R.Set(this.m_sweep.a0);var b=a.R,c=this.m_sweep.localCenter;a.position.x=this.m_sweep.c0.x-(b.col1.x*
c.x+b.col2.x*c.y);a.position.y=this.m_sweep.c0.y-(b.col1.y*c.x+b.col2.y*c.y);b=this.m_world.m_contactManager.m_broadPhase;for(c=this.fixtureList.GetFirstNode();c;c=c.GetNextNode())c.fixture.Synchronize(b,a,this.m_xf)};Box2D.Dynamics.b2Body.prototype.SynchronizeTransform=function(){this.m_xf.R.Set(this.m_sweep.a);var a=this.m_xf.R,b=this.m_sweep.localCenter;this.m_xf.position.x=this.m_sweep.c.x-(a.col1.x*b.x+a.col2.x*b.y);this.m_xf.position.y=this.m_sweep.c.y-(a.col1.y*b.x+a.col2.y*b.y)};Box2D.Dynamics.b2Body.prototype.ShouldCollide=
function(a){if(this.m_type!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&a.m_type!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody)return!1;for(var b=this.m_jointList;b;b=b.next)if(b.other==a&&!1==b.joint.m_collideConnected)return!1;return!0};Box2D.Dynamics.b2Body.prototype.Advance=function(a){this.m_sweep.Advance(a);this.m_sweep.c.SetV(this.m_sweep.c0);this.m_sweep.a=this.m_sweep.a0;this.SynchronizeTransform()};Box2D.Dynamics.b2Body.NEXT_ID=0;Box2D.Dynamics.b2BodyDef=function(){this.position=Box2D.Common.Math.b2Vec2.Get(0,
0);this.linearVelocity=Box2D.Common.Math.b2Vec2.Get(0,0);this.angularDamping=this.linearDamping=this.angularVelocity=this.angle=0;this.awake=this.allowSleep=!0;this.bullet=this.fixedRotation=!1;this.type=Box2D.Dynamics.b2BodyDef.b2_staticBody;this.active=!0;this.inertiaScale=1};Box2D.Dynamics.b2BodyDef.b2_staticBody=0;Box2D.Dynamics.b2BodyDef.b2_kinematicBody=1;Box2D.Dynamics.b2BodyDef.b2_dynamicBody=2;Box2D.Dynamics.b2BodyList=function(){this.bodyFirstNodes=[];for(var a=0;a<=Box2D.Dynamics.b2BodyList.TYPES.allBodies;a++)this.bodyFirstNodes[a]=
null;this.bodyLastNodes=[];for(a=0;a<=Box2D.Dynamics.b2BodyList.TYPES.allBodies;a++)this.bodyLastNodes[a]=null;this.bodyNodeLookup={};this.bodyCount=0};Box2D.Dynamics.b2BodyList.prototype.GetFirstNode=function(a){return this.bodyFirstNodes[a]};Box2D.Dynamics.b2BodyList.prototype.AddBody=function(a){var b=a.ID;null==this.bodyNodeLookup[b]&&(this.CreateNode(a,b,Box2D.Dynamics.b2BodyList.TYPES.allBodies),this.UpdateBody(a),a.m_lists.push(this),this.bodyCount++)};Box2D.Dynamics.b2BodyList.prototype.UpdateBody=
function(a){var b=a.GetType(),c=a.ID,d=a.IsAwake(),e=a.IsActive();b==Box2D.Dynamics.b2BodyDef.b2_dynamicBody?this.CreateNode(a,c,Box2D.Dynamics.b2BodyList.TYPES.dynamicBodies):this.RemoveNode(c,Box2D.Dynamics.b2BodyList.TYPES.dynamicBodies);b!=Box2D.Dynamics.b2BodyDef.b2_staticBody?this.CreateNode(a,c,Box2D.Dynamics.b2BodyList.TYPES.nonStaticBodies):this.RemoveNode(c,Box2D.Dynamics.b2BodyList.TYPES.nonStaticBodies);b!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&e&&d?this.CreateNode(a,c,Box2D.Dynamics.b2BodyList.TYPES.nonStaticActiveAwakeBodies):
this.RemoveNode(c,Box2D.Dynamics.b2BodyList.TYPES.nonStaticActiveAwakeBodies);d?this.CreateNode(a,c,Box2D.Dynamics.b2BodyList.TYPES.awakeBodies):this.RemoveNode(c,Box2D.Dynamics.b2BodyList.TYPES.awakeBodies);e?this.CreateNode(a,c,Box2D.Dynamics.b2BodyList.TYPES.activeBodies):this.RemoveNode(c,Box2D.Dynamics.b2BodyList.TYPES.activeBodies)};Box2D.Dynamics.b2BodyList.prototype.RemoveBody=function(a){var b=a.ID;if(null!=this.bodyNodeLookup[b]){cr.arrayFindRemove(a.m_lists,this);for(a=0;a<=Box2D.Dynamics.b2BodyList.TYPES.allBodies;a++)this.RemoveNode(b,
a);delete this.bodyNodeLookup[b];this.bodyCount--}};Box2D.Dynamics.b2BodyList.prototype.RemoveNode=function(a,b){var c=this.bodyNodeLookup[a];if(null!=c){var d=c[b];null!=d&&(c[b]=null,c=d.GetPreviousNode(),d=d.GetNextNode(),null==c?this.bodyFirstNodes[b]=d:c.SetNextNode(d),null==d?this.bodyLastNodes[b]=c:d.SetPreviousNode(c))}};Box2D.Dynamics.b2BodyList.prototype.CreateNode=function(a,b,c){var d=this.bodyNodeLookup[b];if(null==d){for(var d=[],e=0;e<=Box2D.Dynamics.b2BodyList.TYPES.allBodies;e++)d[e]=
null;this.bodyNodeLookup[b]=d}null==d[c]&&(d[c]=new Box2D.Dynamics.b2BodyListNode(a),a=this.bodyLastNodes[c],null!=a?a.SetNextNode(d[c]):this.bodyFirstNodes[c]=d[c],d[c].SetPreviousNode(a),this.bodyLastNodes[c]=d[c])};Box2D.Dynamics.b2BodyList.prototype.GetBodyCount=function(){return this.bodyCount};Box2D.Dynamics.b2BodyList.TYPES={dynamicBodies:0,nonStaticBodies:1,activeBodies:2,nonStaticActiveAwakeBodies:3,awakeBodies:4,allBodies:5};Box2D.Dynamics.b2BodyListNode=function(a){this.body=a;this.previous=
this.next=null};Box2D.Dynamics.b2BodyListNode.prototype.SetNextNode=function(a){this.next=a};Box2D.Dynamics.b2BodyListNode.prototype.SetPreviousNode=function(a){this.previous=a};Box2D.Dynamics.b2BodyListNode.prototype.GetBody=function(){return this.body};Box2D.Dynamics.b2BodyListNode.prototype.GetNextNode=function(){return this.next};Box2D.Dynamics.b2BodyListNode.prototype.GetPreviousNode=function(){return this.previous};Box2D.Dynamics.b2ContactFilter=function(){};Box2D.Dynamics.b2ContactFilter.prototype.ShouldCollide=
function(a,b){var c=a.GetFilterData(),d=b.GetFilterData();return c.groupIndex==d.groupIndex&&0!=c.groupIndex?0<c.groupIndex:0!=(c.maskBits&d.categoryBits)&&0!=(c.categoryBits&d.maskBits)};Box2D.Dynamics.b2ContactFilter.b2_defaultFilter=new Box2D.Dynamics.b2ContactFilter;Box2D.Dynamics.b2ContactImpulse=function(){this.normalImpulses=[];this.tangentImpulses=[]};Box2D.Dynamics.b2ContactListener=function(){};Box2D.Dynamics.b2ContactListener.prototype.BeginContact=function(a){};Box2D.Dynamics.b2ContactListener.prototype.EndContact=
function(a){};Box2D.Dynamics.b2ContactListener.prototype.PreSolve=function(a,b){};Box2D.Dynamics.b2ContactListener.prototype.PostSolve=function(a,b){};Box2D.Dynamics.b2ContactManager=function(a){this.m_world=a;this.m_contactFilter=Box2D.Dynamics.b2ContactFilter.b2_defaultFilter;this.m_contactListener=Box2D.Dynamics.b2ContactListener.b2_defaultListener;this.m_contactFactory=new Box2D.Dynamics.Contacts.b2ContactFactory;this.m_broadPhase=new Box2D.Collision.b2DynamicTreeBroadPhase};Box2D.Dynamics.b2ContactManager.prototype.AddPair=
function(a,b){var c=a.GetBody(),d=b.GetBody();if(c!=d&&d.ShouldCollide(c)&&this.m_contactFilter.ShouldCollide(a,b)){for(c=d.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);c;c=c.GetNextNode())if(d=c.contact.m_fixtureA,d==a){if(d=c.contact.m_fixtureB,d==b)return}else if(d==b&&(d=c.contact.m_fixtureB,d==a))return;this.m_contactFactory.Create(a,b)}};Box2D.Dynamics.b2ContactManager.prototype.FindNewContacts=function(){var a=this;this.m_broadPhase.UpdatePairs(function(b,
c){a.AddPair(b,c)})};Box2D.Dynamics.b2ContactManager.prototype.Destroy=function(a){var b=a.m_fixtureB;a.m_fixtureA.GetBody();b.GetBody();a.touching&&this.m_contactListener.EndContact(a);0<a.m_manifold.m_pointCount&&(a.m_fixtureA.GetBody().SetAwake(!0),a.m_fixtureB.GetBody().SetAwake(!0));a.RemoveFromLists();this.m_contactFactory.Destroy(a)};Box2D.Dynamics.b2ContactManager.prototype.Collide=function(){for(var a=this.m_world.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=
a.GetNextNode()){var b=a.contact,c=b.m_fixtureA,d=b.m_fixtureB,e=c.GetBody(),f=d.GetBody();if(!(!1==e.IsAwake()&&!1==f.IsAwake())){if(b.IsFiltering()){if(!1==f.ShouldCollide(e)){this.Destroy(b);continue}if(!1==this.m_contactFilter.ShouldCollide(c,d)){this.Destroy(b);continue}b.ClearFiltering()}!1==this.m_broadPhase.TestOverlap(c.m_proxy,d.m_proxy)?this.Destroy(b):b.Update(this.m_contactListener)}}};Box2D.Dynamics.b2DestructionListener=function(){};Box2D.Dynamics.b2DestructionListener.prototype.SayGoodbyeJoint=
function(a){};Box2D.Dynamics.b2DestructionListener.prototype.SayGoodbyeFixture=function(a){};Box2D.Dynamics.b2FilterData=function(){this.categoryBits=1;this.maskBits=65535;this.groupIndex=0};Box2D.Dynamics.b2FilterData.prototype.Copy=function(){var a=new Box2D.Dynamics.b2FilterData;a.categoryBits=this.categoryBits;a.maskBits=this.maskBits;a.groupIndex=this.groupIndex;return a};Box2D.Dynamics.b2Fixture=function(a,b,c){this.ID="Fixture"+Box2D.Dynamics.b2Fixture.NEXT_ID++;this.m_filter=c.filter.Copy();
this.m_aabb=Box2D.Collision.b2AABB.Get();this.m_body=a;this.m_shape=c.shape.Copy();this.m_density=c.density;this.m_friction=c.friction;this.m_restitution=c.restitution;this.m_isSensor=c.isSensor};Box2D.Dynamics.b2Fixture.prototype.GetShape=function(){return this.m_shape};Box2D.Dynamics.b2Fixture.prototype.SetSensor=function(a){if(this.m_isSensor!=a&&(this.m_isSensor=a,null!=this.m_body))for(a=this.m_body.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=a.GetNextNode()){var b=
a.contact.m_fixtureA,c=a.contact.m_fixtureB;if(b==this||c==this)a.contact.SetSensor(b.sensor||c.sensor)}};Box2D.Dynamics.b2Fixture.prototype.IsSensor=function(){return this.m_isSensor};Box2D.Dynamics.b2Fixture.prototype.SetFilterData=function(a){this.m_filter=a.Copy();if(null!=this.m_body)for(a=this.m_body.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=a.GetNextNode())(a.contact.m_fixtureA==this||a.contact.m_fixtureB==this)&&a.contact.FlagForFiltering()};Box2D.Dynamics.b2Fixture.prototype.GetFilterData=
function(){return this.m_filter.Copy()};Box2D.Dynamics.b2Fixture.prototype.GetBody=function(){return this.m_body};Box2D.Dynamics.b2Fixture.prototype.TestPoint=function(a){return this.m_shape.TestPoint(this.m_body.GetTransform(),a)};Box2D.Dynamics.b2Fixture.prototype.RayCast=function(a,b){return this.m_shape.RayCast(a,b,this.m_body.GetTransform())};Box2D.Dynamics.b2Fixture.prototype.GetMassData=function(a){a||(a=new Box2D.Collision.Shapes.b2MassData);this.m_shape.ComputeMass(a,this.m_density);return a};
Box2D.Dynamics.b2Fixture.prototype.SetDensity=function(a){this.m_density=a};Box2D.Dynamics.b2Fixture.prototype.GetDensity=function(){return this.m_density};Box2D.Dynamics.b2Fixture.prototype.GetFriction=function(){return this.m_friction};Box2D.Dynamics.b2Fixture.prototype.SetFriction=function(a){this.m_friction=a};Box2D.Dynamics.b2Fixture.prototype.GetRestitution=function(){return this.m_restitution};Box2D.Dynamics.b2Fixture.prototype.SetRestitution=function(a){this.m_restitution=a};Box2D.Dynamics.b2Fixture.prototype.GetAABB=
function(){return this.m_aabb};Box2D.Dynamics.b2Fixture.prototype.Destroy=function(){Box2D.Collision.b2AABB.Free(this.m_aabb)};Box2D.Dynamics.b2Fixture.prototype.CreateProxy=function(a,b){this.m_shape.ComputeAABB(this.m_aabb,b);this.m_proxy=a.CreateProxy(this.m_aabb,this)};Box2D.Dynamics.b2Fixture.prototype.DestroyProxy=function(a){null!=this.m_proxy&&(a.DestroyProxy(this.m_proxy),this.m_proxy=null)};Box2D.Dynamics.b2Fixture.prototype.Synchronize=function(a,b,c){if(this.m_proxy){var d=Box2D.Collision.b2AABB.Get(),
e=Box2D.Collision.b2AABB.Get();this.m_shape.ComputeAABB(d,b);this.m_shape.ComputeAABB(e,c);this.m_aabb.Combine(d,e);Box2D.Collision.b2AABB.Free(d);Box2D.Collision.b2AABB.Free(e);b=Box2D.Common.Math.b2Math.SubtractVV(c.position,b.position);a.MoveProxy(this.m_proxy,this.m_aabb,b);Box2D.Common.Math.b2Vec2.Free(b)}};Box2D.Dynamics.b2Fixture.NEXT_ID=0;Box2D.Dynamics.b2FixtureDef=function(){this.filter=new Box2D.Dynamics.b2FilterData;this.filter.categoryBits=1;this.filter.maskBits=65535;this.filter.groupIndex=
0;this.shape=null;this.friction=0.2;this.density=this.restitution=0;this.isSensor=!1};Box2D.Dynamics.b2FixtureList=function(){this.fixtureLastNode=this.fixtureFirstNode=null;this.fixtureNodeLookup={};this.fixtureCount=0};Box2D.Dynamics.b2FixtureList.prototype.GetFirstNode=function(){return this.fixtureFirstNode};Box2D.Dynamics.b2FixtureList.prototype.AddFixture=function(a){var b=a.ID;if(null==this.fixtureNodeLookup[b]){a=new Box2D.Dynamics.b2FixtureListNode(a);var c=this.fixtureLastNode;null!=c?c.SetNextNode(a):
this.fixtureFirstNode=a;a.SetPreviousNode(c);this.fixtureLastNode=a;this.fixtureNodeLookup[b]=a;this.fixtureCount++}};Box2D.Dynamics.b2FixtureList.prototype.RemoveFixture=function(a){a=a.ID;var b=this.fixtureNodeLookup[a];if(null!=b){var c=b.GetPreviousNode(),b=b.GetNextNode();null==c?this.fixtureFirstNode=b:c.SetNextNode(b);null==b?this.fixtureLastNode=c:b.SetPreviousNode(c);delete this.fixtureNodeLookup[a];this.fixtureCount--}};Box2D.Dynamics.b2FixtureList.prototype.GetFixtureCount=function(){return this.fixtureCount};
Box2D.Dynamics.b2FixtureListNode=function(a){this.fixture=a;this.previous=this.next=null};Box2D.Dynamics.b2FixtureListNode.prototype.SetNextNode=function(a){this.next=a};Box2D.Dynamics.b2FixtureListNode.prototype.SetPreviousNode=function(a){this.previous=a};Box2D.Dynamics.b2FixtureListNode.prototype.GetNextNode=function(){return this.next};Box2D.Dynamics.b2FixtureListNode.prototype.GetPreviousNode=function(){return this.previous};Box2D.Dynamics.b2Island=function(a,b){this.m_listener=a;this.m_contactSolver=
b;this.m_bodies=[];this.m_dynamicBodies=[];this.m_nonStaticBodies=[];this.m_contacts=[];this.m_joints=[]};Box2D.Dynamics.b2Island.prototype.Clear=function(){this.m_bodies=[];this.m_dynamicBodies=[];this.m_nonStaticBodies=[];this.m_contacts=[];this.m_joints=[]};Box2D.Dynamics.b2Island.prototype.Solve=function(a,b,c){this._InitializeVelocities(a,b);this.m_contactSolver.Initialize(a,this.m_contacts,this.m_contacts.length);this._SolveVelocityConstraints(a);this._SolveBodies(a);this._SolvePositionConstraints(a);
this.Report(this.m_contactSolver.m_constraints);c&&this._SleepIfTired(a)};Box2D.Dynamics.b2Island.prototype._InitializeVelocities=function(a,b){for(var c=0;c<this.m_dynamicBodies.length;c++){var d=this.m_dynamicBodies[c];d.m_linearVelocity.x+=a.dt*(b.x+d.m_invMass*d.m_force.x);d.m_linearVelocity.y+=a.dt*(b.y+d.m_invMass*d.m_force.y);d.m_angularVelocity+=a.dt*d.m_invI*d.m_torque;d.m_linearVelocity.Multiply(Box2D.Common.Math.b2Math.Clamp(1-a.dt*d.m_linearDamping,0,1));d.m_angularVelocity*=Box2D.Common.Math.b2Math.Clamp(1-
a.dt*d.m_angularDamping,0,1)}};Box2D.Dynamics.b2Island.prototype._SolveVelocityConstraints=function(a){this.m_contactSolver.InitVelocityConstraints(a);for(var b=0;b<this.m_joints.length;b++)this.m_joints[b].InitVelocityConstraints(a);for(b=0;b<a.velocityIterations;b++){for(var c=0;c<this.m_joints.length;c++)this.m_joints[c].SolveVelocityConstraints(a);this.m_contactSolver.SolveVelocityConstraints()}for(a=0;a<this.m_joints.length;a++)this.m_joints[a].FinalizeVelocityConstraints();this.m_contactSolver.FinalizeVelocityConstraints()};
Box2D.Dynamics.b2Island.prototype._SolveBodies=function(a){for(var b=0;b<this.m_nonStaticBodies.length;++b){var c=this.m_nonStaticBodies[b],d=a.dt*c.m_linearVelocity.x,e=a.dt*c.m_linearVelocity.y;d*d+e*e>Box2D.Common.b2Settings.b2_maxTranslationSquared&&(c.m_linearVelocity.Normalize(),c.m_linearVelocity.x*=Box2D.Common.b2Settings.b2_maxTranslation*a.inv_dt,c.m_linearVelocity.y*=Box2D.Common.b2Settings.b2_maxTranslation*a.inv_dt);d=a.dt*c.m_angularVelocity;d*d>Box2D.Common.b2Settings.b2_maxRotationSquared&&
(c.m_angularVelocity=0>c.m_angularVelocity?-Box2D.Common.b2Settings.b2_maxRotation*a.inv_dt:Box2D.Common.b2Settings.b2_maxRotation*a.inv_dt);c.m_sweep.c0.SetV(c.m_sweep.c);c.m_sweep.a0=c.m_sweep.a;c.m_sweep.c.x+=a.dt*c.m_linearVelocity.x;c.m_sweep.c.y+=a.dt*c.m_linearVelocity.y;c.m_sweep.a+=a.dt*c.m_angularVelocity;c.SynchronizeTransform()}};Box2D.Dynamics.b2Island.prototype._SolvePositionConstraints=function(a){for(var b=0;b<a.positionIterations;b++){for(var c=this.m_contactSolver.SolvePositionConstraints(Box2D.Common.b2Settings.b2_contactBaumgarte),
d=!0,e=0;e<this.m_joints.length;e++)var f=this.m_joints[e].SolvePositionConstraints(Box2D.Common.b2Settings.b2_contactBaumgarte),d=d&&f;if(c&&d)break}};Box2D.Dynamics.b2Island.prototype._SleepIfTired=function(a){for(var b=Number.MAX_VALUE,c=0;c<this.m_nonStaticBodies.length;c++){var d=this.m_nonStaticBodies[c];!d.m_allowSleep||Math.abs(d.m_angularVelocity)>Box2D.Common.b2Settings.b2_angularSleepTolerance||Box2D.Common.Math.b2Math.Dot(d.m_linearVelocity,d.m_linearVelocity)>Box2D.Common.b2Settings.b2_linearSleepToleranceSquared?
b=d.m_sleepTime=0:(d.m_sleepTime+=a.dt,b=Math.min(b,d.m_sleepTime))}if(b>=Box2D.Common.b2Settings.b2_timeToSleep)for(a=0;a<this.m_bodies.length;a++)this.m_bodies[a].SetAwake(!1)};Box2D.Dynamics.b2Island.prototype.SolveTOI=function(a){var b=0,c=0;this.m_contactSolver.Initialize(a,this.m_contacts,this.m_contacts.length);for(var d=this.m_contactSolver,b=0;b<this.m_joints.length;++b)this.m_joints[b].InitVelocityConstraints(a);for(b=0;b<a.velocityIterations;++b){d.SolveVelocityConstraints();for(c=0;c<
this.m_joints.length;++c)this.m_joints[c].SolveVelocityConstraints(a)}for(b=0;b<this.m_nonStaticBodies.length;++b){var c=this.m_nonStaticBodies[b],e=a.dt*c.m_linearVelocity.x,f=a.dt*c.m_linearVelocity.y;e*e+f*f>Box2D.Common.b2Settings.b2_maxTranslationSquared&&(c.m_linearVelocity.Normalize(),c.m_linearVelocity.x*=Box2D.Common.b2Settings.b2_maxTranslation*a.inv_dt,c.m_linearVelocity.y*=Box2D.Common.b2Settings.b2_maxTranslation*a.inv_dt);e=a.dt*c.m_angularVelocity;e*e>Box2D.Common.b2Settings.b2_maxRotationSquared&&
(c.m_angularVelocity=0>c.m_angularVelocity?-Box2D.Common.b2Settings.b2_maxRotation*a.inv_dt:Box2D.Common.b2Settings.b2_maxRotation*a.inv_dt);c.m_sweep.c0.SetV(c.m_sweep.c);c.m_sweep.a0=c.m_sweep.a;c.m_sweep.c.x+=a.dt*c.m_linearVelocity.x;c.m_sweep.c.y+=a.dt*c.m_linearVelocity.y;c.m_sweep.a+=a.dt*c.m_angularVelocity;c.SynchronizeTransform()}for(b=0;b<a.positionIterations;++b){e=d.SolvePositionConstraints(0.75);f=!0;for(c=0;c<this.m_joints.length;++c)var g=this.m_joints[c].SolvePositionConstraints(Box2D.Common.b2Settings.b2_contactBaumgarte),
f=f&&g;if(e&&f)break}this.Report(d.m_constraints)};Box2D.Dynamics.b2Island.prototype.Report=function(a){if(null!=this.m_listener)for(var b=0;b<this.m_contacts.length;++b){for(var c=this.m_contacts[b],d=a[b],e=new Box2D.Dynamics.b2ContactImpulse,f=0;f<d.pointCount;++f)e.normalImpulses[f]=d.points[f].normalImpulse,e.tangentImpulses[f]=d.points[f].tangentImpulse;this.m_listener.PostSolve(c,e)}};Box2D.Dynamics.b2Island.prototype.AddBody=function(a){this.m_bodies.push(a);a.GetType()!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&
(this.m_nonStaticBodies.push(a),a.GetType()==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&this.m_dynamicBodies.push(a))};Box2D.Dynamics.b2Island.prototype.AddContact=function(a){this.m_contacts.push(a)};Box2D.Dynamics.b2Island.prototype.AddJoint=function(a){this.m_joints.push(a)};Box2D.Dynamics.b2TimeStep=function(a,b,c,d,e){this.dt=a;var f=0;0<a&&(f=1/a);this.inv_dt=f;this.dtRatio=b;this.positionIterations=c;this.velocityIterations=d;this.warmStarting=e};Box2D.Dynamics.b2World=function(a,b){this.m_contactManager=
new Box2D.Dynamics.b2ContactManager(this);this.m_contactSolver=new Box2D.Dynamics.Contacts.b2ContactSolver;this.m_newFixture=this.m_isLocked=!1;this.m_destructionListener=null;this.bodyList=new Box2D.Dynamics.b2BodyList;this.contactList=new Box2D.Dynamics.Contacts.b2ContactList;this.m_jointList=null;this.controllerList=new Box2D.Dynamics.Controllers.b2ControllerList;this.m_jointCount=0;this.m_continuousPhysics=this.m_warmStarting=!0;this.m_allowSleep=b;this.m_gravity=a;this.m_inv_dt0=0;this.m_groundBody=
this.CreateBody(new Box2D.Dynamics.b2BodyDef)};Box2D.Dynamics.b2World.MAX_TOI=1-100*Number.MIN_VALUE;Box2D.Dynamics.b2World.prototype.SetDestructionListener=function(a){this.m_destructionListener=a};Box2D.Dynamics.b2World.prototype.SetContactFilter=function(a){this.m_contactManager.m_contactFilter=a};Box2D.Dynamics.b2World.prototype.SetContactListener=function(a){this.m_contactManager.m_contactListener=a};Box2D.Dynamics.b2World.prototype.SetBroadPhase=function(a){var b=this.m_contactManager.m_broadPhase;
this.m_contactManager.m_broadPhase=a;for(var c=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);c;c=c.GetNextNode())for(var d=c.body.GetFixtureList().GetFirstNode();d;d=d.GetNextNode()){var e=d.fixture;e.m_proxy=a.CreateProxy(b.GetFatAABB(e.m_proxy),e)}};Box2D.Dynamics.b2World.prototype.GetProxyCount=function(){return this.m_contactManager.m_broadPhase.GetProxyCount()};Box2D.Dynamics.b2World.prototype.CreateBody=function(a){a=new Box2D.Dynamics.b2Body(a,this);this.bodyList.AddBody(a);
return a};Box2D.Dynamics.b2World.prototype.DestroyBody=function(a){for(var b=a.m_jointList;b;){var c=b,b=b.next;this.m_destructionListener&&this.m_destructionListener.SayGoodbyeJoint(c.joint);this.DestroyJoint(c.joint)}for(b=a.GetControllerList().GetFirstNode();b;b=b.GetNextNode())b.controller.RemoveBody(a);for(b=a.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);b;b=b.GetNextNode())this.m_contactManager.Destroy(b.contact);for(b=a.GetFixtureList().GetFirstNode();b;b=
b.GetNextNode())this.m_destructionListener&&this.m_destructionListener.SayGoodbyeFixture(b.fixture),a.DestroyFixture(b.fixture);a.Destroy();this.bodyList.RemoveBody(a)};Box2D.Dynamics.b2World.prototype.CreateJoint=function(a){var b=Box2D.Dynamics.Joints.b2Joint.Create(a);b.m_prev=null;if(b.m_next=this.m_jointList)this.m_jointList.m_prev=b;this.m_jointList=b;this.m_jointCount++;b.m_edgeA.joint=b;b.m_edgeA.other=b.m_bodyB;b.m_edgeA.prev=null;if(b.m_edgeA.next=b.m_bodyA.m_jointList)b.m_bodyA.m_jointList.prev=
b.m_edgeA;b.m_bodyA.m_jointList=b.m_edgeA;b.m_edgeB.joint=b;b.m_edgeB.other=b.m_bodyA;b.m_edgeB.prev=null;if(b.m_edgeB.next=b.m_bodyB.m_jointList)b.m_bodyB.m_jointList.prev=b.m_edgeB;b.m_bodyB.m_jointList=b.m_edgeB;var c=a.bodyA,d=a.bodyB;if(!a.collideConnected)for(a=d.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=a.GetNextNode())a.contact.GetOther(d)==c&&a.contact.FlagForFiltering();return b};Box2D.Dynamics.b2World.prototype.DestroyJoint=function(a){var b=
a.m_collideConnected;a.m_prev&&(a.m_prev.m_next=a.m_next);a.m_next&&(a.m_next.m_prev=a.m_prev);a==this.m_jointList&&(this.m_jointList=a.m_next);var c=a.m_bodyA,d=a.m_bodyB;c.SetAwake(!0);d.SetAwake(!0);a.m_edgeA.prev&&(a.m_edgeA.prev.next=a.m_edgeA.next);a.m_edgeA.next&&(a.m_edgeA.next.prev=a.m_edgeA.prev);a.m_edgeA==c.m_jointList&&(c.m_jointList=a.m_edgeA.next);a.m_edgeA.prev=null;a.m_edgeA.next=null;a.m_edgeB.prev&&(a.m_edgeB.prev.next=a.m_edgeB.next);a.m_edgeB.next&&(a.m_edgeB.next.prev=a.m_edgeB.prev);
a.m_edgeB==d.m_jointList&&(d.m_jointList=a.m_edgeB.next);a.m_edgeB.prev=null;a.m_edgeB.next=null;this.m_jointCount--;if(!b)for(a=d.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=a.GetNextNode())a.contact.GetOther(d)==c&&a.contact.FlagForFiltering()};Box2D.Dynamics.b2World.prototype.GetControllerList=function(){return this.controllerList};Box2D.Dynamics.b2World.prototype.AddController=function(a){if(null!==a.m_world&&a.m_world!=this)throw Error("Controller can only be a member of one world");
this.controllerList.AddController(a);a.m_world=this;return a};Box2D.Dynamics.b2World.prototype.RemoveController=function(a){this.controllerList.RemoveController(a);a.m_world=null;a.Clear()};Box2D.Dynamics.b2World.prototype.CreateController=function(a){return this.AddController(a)};Box2D.Dynamics.b2World.prototype.DestroyController=function(a){this.RemoveController(a)};Box2D.Dynamics.b2World.prototype.SetWarmStarting=function(a){this.m_warmStarting=a};Box2D.Dynamics.b2World.prototype.SetContinuousPhysics=
function(a){this.m_continuousPhysics=a};Box2D.Dynamics.b2World.prototype.GetBodyCount=function(){return this.bodyList.GetBodyCount()};Box2D.Dynamics.b2World.prototype.GetJointCount=function(){return this.m_jointCount};Box2D.Dynamics.b2World.prototype.GetContactCount=function(){return this.contactList.GetContactCount()};Box2D.Dynamics.b2World.prototype.SetGravity=function(a){this.m_gravity=a};Box2D.Dynamics.b2World.prototype.GetGravity=function(){return this.m_gravity};Box2D.Dynamics.b2World.prototype.GetGroundBody=
function(){return this.m_groundBody};Box2D.Dynamics.b2World.prototype.Step=function(a,b,c){this.m_newFixture&&(this.m_contactManager.FindNewContacts(),this.m_newFixture=!1);this.m_isLocked=!0;a=new Box2D.Dynamics.b2TimeStep(a,this.m_inv_dt0*a,b,c,this.m_warmStarting);this.m_contactManager.Collide();0<a.dt&&(this.Solve(a),this.m_continuousPhysics&&this.SolveTOI(a),this.m_inv_dt0=a.inv_dt);this.m_isLocked=!1};Box2D.Dynamics.b2World.prototype.ClearForces=function(){for(var a=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.dynamicBodies);a;a=
a.GetNextNode())a.body.m_force.SetZero(),a.body.m_torque=0};Box2D.Dynamics.b2World.prototype.QueryAABB=function(a,b){this.m_contactManager.m_broadPhase.Query(a,b)};Box2D.Dynamics.b2World.prototype.QueryPoint=function(a,b){var c=Box2D.Collision.b2AABB.Get();c.lowerBound_.Set(b.x-Box2D.Common.b2Settings.b2_linearSlop,b.y-Box2D.Common.b2Settings.b2_linearSlop);c.upperBound_.Set(b.x+Box2D.Common.b2Settings.b2_linearSlop,b.y+Box2D.Common.b2Settings.b2_linearSlop);this.m_contactManager.m_broadPhase.Query(function(c){return c.TestPoint(b)?
a(c):!0},c);Box2D.Collision.b2AABB.Free(c)};Box2D.Dynamics.b2World.prototype.RayCast=function(a,b,c){var d=this.m_contactManager.m_broadPhase,e=new Box2D.Collision.b2RayCastOutput,f=new Box2D.Collision.b2RayCastInput(b,c,1);d.RayCast(function(d,f){if(f.RayCast(e,d)){var l=1-e.fraction,l=Box2D.Common.Math.b2Vec2.Get(l*b.x+e.fraction*c.x,l*b.y+e.fraction*c.y),k=a(f,l,e.normal,e.fraction);Box2D.Common.Math.b2Vec2.Free(l);return k}return d.maxFraction},f)};Box2D.Dynamics.b2World.prototype.RayCastOne=
function(a,b){var c=null;this.RayCast(function(a,b,f,g){c=a;return g},a,b);return c};Box2D.Dynamics.b2World.prototype.RayCastAll=function(a,b){var c=[];this.RayCast(function(a,b,f,g){c.push(a);return 1},a,b);return c};Box2D.Dynamics.b2World.prototype.GetBodyList=function(){return this.bodyList};Box2D.Dynamics.b2World.prototype.GetJointList=function(){return this.m_jointList};Box2D.Dynamics.b2World.prototype.GetContactList=function(){return this.contactList};Box2D.Dynamics.b2World.prototype.IsLocked=
function(){return this.m_isLocked};var b2solvearray=[];Box2D.Dynamics.b2World.prototype.Solve=function(a){for(var b=this.controllerList.GetFirstNode();b;b=b.GetNextNode())b.controller.Step(a);for(var b=new Box2D.Dynamics.b2Island(this.m_contactManager.m_contactListener,this.m_contactSolver),c=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);c;c=c.GetNextNode())c.body.m_islandFlag=!1;for(var d=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);d;d=
d.GetNextNode())d.contact.m_islandFlag=!1;for(c=this.m_jointList;c;c=c.m_next)c.m_islandFlag=!1;for(c=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.nonStaticActiveAwakeBodies);c;c=c.GetNextNode())if(d=c.body,!d.m_islandFlag){b.Clear();b2solvearray.length=0;var e=b2solvearray;e.push(d);for(d.m_islandFlag=!0;0<e.length;){var f=e.pop();b.AddBody(f);f.IsAwake()||f.SetAwake(!0);if(f.GetType()!=Box2D.Dynamics.b2BodyDef.b2_staticBody){for(d=f.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledTouchingContacts);d;d=
d.GetNextNode()){var g=d.contact;g.m_islandFlag||(b.AddContact(g),g.m_islandFlag=!0,g=g.GetOther(f),g.m_islandFlag||(e.push(g),g.m_islandFlag=!0))}for(d=f.m_jointList;d;d=d.next)!d.joint.m_islandFlag&&d.other.IsActive()&&(b.AddJoint(d.joint),d.joint.m_islandFlag=!0,d.other.m_islandFlag||(e.push(d.other),d.other.m_islandFlag=!0))}}b.Solve(a,this.m_gravity,this.m_allowSleep)}for(c=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.nonStaticActiveAwakeBodies);c;c=c.GetNextNode())c.body.SynchronizeFixtures();
this.m_contactManager.FindNewContacts()};Box2D.Dynamics.b2World.prototype.SolveTOI=function(a){for(var b=new Box2D.Dynamics.b2Island(this.m_contactManager.m_contactListener,this.m_contactSolver),c=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);c;c=c.GetNextNode()){var d=c.body;d.m_islandFlag=!1;d.m_sweep.t0=0}for(var e=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);e;e=e.GetNextNode())e.contact.m_islandFlag=!1,e.contact.m_toi=null;for(c=
this.m_jointList;c;c=c.m_next)c.m_islandFlag=!1;for(;;){var c=this._SolveTOI2(a),f=c.minContact,c=c.minTOI;if(null===f||Box2D.Dynamics.b2World.MAX_TOI<c)break;e=f.m_fixtureA.GetBody();d=f.m_fixtureB.GetBody();Box2D.Dynamics.b2World.s_backupA.Set(e.m_sweep);Box2D.Dynamics.b2World.s_backupB.Set(d.m_sweep);e.Advance(c);d.Advance(c);f.Update(this.m_contactManager.m_contactListener);f.m_toi=null;if(f.sensor||!f.enabled)e.m_sweep.Set(Box2D.Dynamics.b2World.s_backupA),d.m_sweep.Set(Box2D.Dynamics.b2World.s_backupB),
e.SynchronizeTransform(),d.SynchronizeTransform();else if(f.touching){e.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&(e=d);b.Clear();b2solvearray.length=0;f=b2solvearray;f.push(e);for(e.m_islandFlag=!0;0<f.length;)if(d=f.pop(),b.AddBody(d),d.IsAwake()||d.SetAwake(!0),d.GetType()==Box2D.Dynamics.b2BodyDef.b2_dynamicBody){for(e=d.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledTouchingContacts);e&&b.m_contactCount!=Box2D.Common.b2Settings.b2_maxTOIContactsPerIsland;e=
e.GetNextNode()){var g=e.contact;g.m_islandFlag||(b.AddContact(g),g.m_islandFlag=!0,g=g.GetOther(d),g.m_islandFlag||(g.GetType()!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&(g.Advance(c),g.SetAwake(!0),f.push(g)),g.m_islandFlag=!0))}for(d=d.m_jointList;d;d=d.next)b.m_jointCount!=Box2D.Common.b2Settings.b2_maxTOIJointsPerIsland&&(!d.joint.m_islandFlag&&d.other.IsActive())&&(b.AddJoint(d.joint),d.joint.m_islandFlag=!0,d.other.m_islandFlag||(d.other.GetType()!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&(d.other.Advance(c),
d.other.SetAwake(!0),f.push(d.other)),d.other.m_islandFlag=!0))}b.SolveTOI(new Box2D.Dynamics.b2TimeStep((1-c)*a.dt,0,a.velocityIterations,a.positionIterations,!1));for(c=0;c<b.m_bodies.length;c++)if(b.m_bodies[c].m_islandFlag=!1,b.m_bodies[c].IsAwake()&&b.m_bodies[c].GetType()==Box2D.Dynamics.b2BodyDef.b2_dynamicBody){b.m_bodies[c].SynchronizeFixtures();for(e=b.m_bodies[c].contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);e;e=e.GetNextNode())e.contact.m_toi=null}for(c=
0;c<b.m_contactCount;c++)b.m_contacts[c].m_islandFlag=!1,b.m_contacts[c].m_toi=null;for(c=0;c<b.m_jointCount;c++)b.m_joints[c].m_islandFlag=!1;this.m_contactManager.FindNewContacts()}}};Box2D.Dynamics.b2World.prototype._SolveTOI2=function(a){for(var b=null,c=1,d=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledContinuousContacts);d;d=d.GetNextNode()){var e=d.contact;if(!this._SolveTOI2SkipContact(a,e)){var f=1;if(null!=e.m_toi)f=e.m_toi;else{if(e.touching)f=
1;else{var f=e.m_fixtureA.GetBody(),g=e.m_fixtureB.GetBody(),h=f.m_sweep.t0;f.m_sweep.t0<g.m_sweep.t0?(h=g.m_sweep.t0,f.m_sweep.Advance(h)):g.m_sweep.t0<f.m_sweep.t0&&(h=f.m_sweep.t0,g.m_sweep.Advance(h));f=e.ComputeTOI(f.m_sweep,g.m_sweep);0<f&&1>f&&(f=(1-f)*h+f)}e.m_toi=f}Number.MIN_VALUE<f&&f<c&&(b=e,c=f)}}return{minContact:b,minTOI:c}};Box2D.Dynamics.b2World.prototype._SolveTOI2SkipContact=function(a,b){var c=b.m_fixtureA.GetBody(),d=b.m_fixtureB.GetBody();return(c.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||
!c.IsAwake())&&(d.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||!d.IsAwake())?!0:!1};Box2D.Dynamics.Contacts.b2Contact=function(a,b){this.ID="Contact"+Box2D.Dynamics.Contacts.b2Contact.NEXT_ID++;this.m_manifold=new Box2D.Collision.b2Manifold;this.m_oldManifold=new Box2D.Collision.b2Manifold;this.touching=!1;var c=a.GetBody(),d=b.GetBody();this.continuous=c.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||c.IsBullet()||d.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||d.IsBullet();this.sensor=
a.IsSensor()||b.IsSensor();this.filtering=!1;this.m_fixtureA=a;this.m_fixtureB=b;this.enabled=!0;this.bodyAList=c.GetContactList();this.bodyBList=d.GetContactList();this.worldList=d.GetWorld().GetContactList();this.AddToLists()};Box2D.Dynamics.Contacts.b2Contact.prototype.Reset=function(a,b){this.m_manifold.Reset();this.m_oldManifold.Reset();this.touching=!1;var c=a.GetBody(),d=b.GetBody();this.continuous=c.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||c.IsBullet()||d.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||
d.IsBullet();this.sensor=a.IsSensor()||b.IsSensor();this.filtering=!1;this.m_fixtureA=a;this.m_fixtureB=b;this.enabled=!0;this.bodyAList=c.GetContactList();this.bodyBList=d.GetContactList();this.worldList=d.GetWorld().GetContactList();this.AddToLists()};Box2D.Dynamics.Contacts.b2Contact.prototype.AddToLists=function(){this.bodyAList.AddContact(this);this.bodyBList.AddContact(this);this.worldList.AddContact(this);this.UpdateLists()};Box2D.Dynamics.Contacts.b2Contact.prototype.UpdateLists=function(){var a=
!1,b=!1;!this.IsSensor()&&this.IsEnabled()&&(this.IsTouching()&&(a=!0),this.IsContinuous()&&(b=!0));this.bodyAList.UpdateContact(this,a,b);this.bodyBList.UpdateContact(this,a,b);this.worldList.UpdateContact(this,a,b)};Box2D.Dynamics.Contacts.b2Contact.prototype.RemoveFromLists=function(){this.bodyAList.RemoveContact(this);this.bodyBList.RemoveContact(this);this.worldList.RemoveContact(this)};Box2D.Dynamics.Contacts.b2Contact.prototype.GetManifold=function(){return this.m_manifold};Box2D.Dynamics.Contacts.b2Contact.prototype.GetWorldManifold=
function(a){var b=this.m_fixtureA.GetBody(),c=this.m_fixtureB.GetBody(),d=this.m_fixtureA.GetShape(),e=this.m_fixtureB.GetShape();a.Initialize(this.m_manifold,b.GetTransform(),d.m_radius,c.GetTransform(),e.m_radius)};Box2D.Dynamics.Contacts.b2Contact.prototype.IsTouching=function(){return this.touching};Box2D.Dynamics.Contacts.b2Contact.prototype.IsContinuous=function(){return this.continuous};Box2D.Dynamics.Contacts.b2Contact.prototype.SetSensor=function(a){this.sensor=a;this.UpdateLists()};Box2D.Dynamics.Contacts.b2Contact.prototype.IsSensor=
function(){return this.sensor};Box2D.Dynamics.Contacts.b2Contact.prototype.SetEnabled=function(a){this.enabled=a;this.UpdateLists()};Box2D.Dynamics.Contacts.b2Contact.prototype.IsEnabled=function(){return this.enabled};Box2D.Dynamics.Contacts.b2Contact.prototype.GetNext=function(){return this.m_next};Box2D.Dynamics.Contacts.b2Contact.prototype.GetFixtureA=function(){return this.m_fixtureA};Box2D.Dynamics.Contacts.b2Contact.prototype.GetFixtureB=function(){return this.m_fixtureB};Box2D.Dynamics.Contacts.b2Contact.prototype.GetOther=
function(a){var b=this.m_fixtureA.GetBody();return b!=a?b:this.m_fixtureB.GetBody()};Box2D.Dynamics.Contacts.b2Contact.prototype.FlagForFiltering=function(){this.filtering=!0};Box2D.Dynamics.Contacts.b2Contact.prototype.ClearFiltering=function(){this.filtering=!1};Box2D.Dynamics.Contacts.b2Contact.prototype.IsFiltering=function(){return this.filtering};Box2D.Dynamics.Contacts.b2Contact.prototype.Update=function(a){var b=this.m_oldManifold;this.m_oldManifold=this.m_manifold;this.m_manifold=b;this.enabled=
!0;var b=!1,c=this.IsTouching(),d=this.m_fixtureA.GetBody(),e=this.m_fixtureB.GetBody(),f=this.m_fixtureA.m_aabb.TestOverlap(this.m_fixtureB.m_aabb);if(this.sensor)f&&(b=Box2D.Collision.Shapes.b2Shape.TestOverlap(this.m_fixtureA.GetShape(),d.GetTransform(),this.m_fixtureB.GetShape(),e.GetTransform())),this.m_manifold.m_pointCount=0;else{d.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||d.IsBullet()||e.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||e.IsBullet()?this.continuous=!0:this.continuous=
!1;if(f){this.Evaluate();b=0<this.m_manifold.m_pointCount;for(f=0;f<this.m_manifold.m_pointCount;f++){var g=this.m_manifold.m_points[f];g.m_normalImpulse=0;for(var h=g.m_tangentImpulse=0;h<this.m_oldManifold.m_pointCount;h++){var l=this.m_oldManifold.m_points[h];if(l.m_id.GetKey()==g.m_id.GetKey()){g.m_normalImpulse=l.m_normalImpulse;g.m_tangentImpulse=l.m_tangentImpulse;break}}}}else this.m_manifold.m_pointCount=0;b!=c&&(d.SetAwake(!0),e.SetAwake(!0))}this.touching=b;b!=c&&this.UpdateLists();!c&&
b&&a.BeginContact(this);c&&!b&&a.EndContact(this);this.sensor||a.PreSolve(this,this.m_oldManifold)};Box2D.Dynamics.Contacts.b2Contact.prototype.Evaluate=function(){};Box2D.Dynamics.Contacts.b2Contact.prototype.ComputeTOI=function(a,b){Box2D.Dynamics.Contacts.b2Contact.s_input.proxyA.Set(this.m_fixtureA.GetShape());Box2D.Dynamics.Contacts.b2Contact.s_input.proxyB.Set(this.m_fixtureB.GetShape());Box2D.Dynamics.Contacts.b2Contact.s_input.sweepA=a;Box2D.Dynamics.Contacts.b2Contact.s_input.sweepB=b;Box2D.Dynamics.Contacts.b2Contact.s_input.tolerance=
Box2D.Common.b2Settings.b2_linearSlop;return Box2D.Collision.b2TimeOfImpact.TimeOfImpact(Box2D.Dynamics.Contacts.b2Contact.s_input)};Box2D.Dynamics.Contacts.b2Contact.s_input=new Box2D.Collision.b2TOIInput;Box2D.Dynamics.Contacts.b2Contact.NEXT_ID=0;Box2D.Dynamics.Contacts.b2CircleContact=function(a,b){Box2D.Dynamics.Contacts.b2Contact.call(this,a,b)};c2inherit(Box2D.Dynamics.Contacts.b2CircleContact,Box2D.Dynamics.Contacts.b2Contact);Box2D.Dynamics.Contacts.b2CircleContact.prototype.Reset=function(a,
b){Box2D.Dynamics.Contacts.b2Contact.prototype.Reset.call(this,a,b)};Box2D.Dynamics.Contacts.b2CircleContact.prototype.Evaluate=function(){Box2D.Collision.b2Collision.CollideCircles(this.m_manifold,this.m_fixtureA.GetShape(),this.m_fixtureA.GetBody().m_xf,this.m_fixtureB.GetShape(),this.m_fixtureB.GetBody().m_xf)};Box2D.Dynamics.Contacts.b2ContactConstraint=function(){this.localPlaneNormal=Box2D.Common.Math.b2Vec2.Get(0,0);this.localPoint=Box2D.Common.Math.b2Vec2.Get(0,0);this.normal=Box2D.Common.Math.b2Vec2.Get(0,
0);this.normalMass=new Box2D.Common.Math.b2Mat22;this.K=new Box2D.Common.Math.b2Mat22;this.points=[];for(var a=0;a<Box2D.Common.b2Settings.b2_maxManifoldPoints;a++)this.points[a]=new Box2D.Dynamics.Contacts.b2ContactConstraintPoint};Box2D.Dynamics.Contacts.b2ContactConstraintPoint=function(){this.localPoint=Box2D.Common.Math.b2Vec2.Get(0,0);this.rA=Box2D.Common.Math.b2Vec2.Get(0,0);this.rB=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Dynamics.Contacts.b2ContactConstraintPoint.prototype.Reset=function(){this.localPoint.Set(0,
0);this.rA.Set(0,0);this.rB.Set(0,0)};Box2D.Dynamics.Contacts.b2ContactFactory=function(){this.m_registers={};this.m_freeContacts={};this.AddType(Box2D.Dynamics.Contacts.b2CircleContact,Box2D.Collision.Shapes.b2CircleShape.NAME,Box2D.Collision.Shapes.b2CircleShape.NAME);this.AddType(Box2D.Dynamics.Contacts.b2PolyAndCircleContact,Box2D.Collision.Shapes.b2PolygonShape.NAME,Box2D.Collision.Shapes.b2CircleShape.NAME);this.AddType(Box2D.Dynamics.Contacts.b2PolygonContact,Box2D.Collision.Shapes.b2PolygonShape.NAME,
Box2D.Collision.Shapes.b2PolygonShape.NAME);this.AddType(Box2D.Dynamics.Contacts.b2EdgeAndCircleContact,Box2D.Collision.Shapes.b2EdgeShape.NAME,Box2D.Collision.Shapes.b2CircleShape.NAME);this.AddType(Box2D.Dynamics.Contacts.b2PolyAndEdgeContact,Box2D.Collision.Shapes.b2PolygonShape.NAME,Box2D.Collision.Shapes.b2EdgeShape.NAME)};Box2D.Dynamics.Contacts.b2ContactFactory.prototype.AddType=function(a,b,c){this.m_freeContacts[b]=this.m_freeContacts[b]||{};this.m_freeContacts[b][c]=this.m_freeContacts[b][c]||
[];this.m_registers[b]=this.m_registers[b]||{};this.m_registers[b][c]=new Box2D.Dynamics.Contacts.b2ContactRegister;this.m_registers[b][c].ctor=a;this.m_registers[b][c].primary=!0;b!=c&&(this.m_registers[c]=this.m_registers[c]||{},this.m_registers[c][b]=new Box2D.Dynamics.Contacts.b2ContactRegister,this.m_registers[c][b].ctor=a,this.m_registers[c][b].primary=!1)};Box2D.Dynamics.Contacts.b2ContactFactory.prototype.Create=function(a,b){var c=a.GetShape().GetTypeName(),d=b.GetShape().GetTypeName(),e=
this.m_registers[c][d],f=e.ctor;return null!=f?e.primary?0<this.m_freeContacts[c][d].length?(c=this.m_freeContacts[c][d].pop(),c.Reset(a,b),c):new f(a,b):0<this.m_freeContacts[d][c].length?(c=this.m_freeContacts[d][c].pop(),c.Reset(b,a),c):new f(b,a):null};Box2D.Dynamics.Contacts.b2ContactFactory.prototype.Destroy=function(a){var b=a.m_fixtureA.GetShape().GetTypeName(),c=a.m_fixtureB.GetShape().GetTypeName();this.m_freeContacts[b][c].push(a)};Box2D.Dynamics.Contacts.b2ContactList=function(){this.contactFirstNodes=
[];for(var a=0;a<=Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts;a++)this.contactFirstNodes[a]=null;this.contactLastNodes=[];for(a=0;a<=Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts;a++)this.contactLastNodes[a]=null;this.contactNodeLookup={};this.contactCount=0};Box2D.Dynamics.Contacts.b2ContactList.prototype.GetFirstNode=function(a){return this.contactFirstNodes[a]};Box2D.Dynamics.Contacts.b2ContactList.prototype.AddContact=function(a){var b=a.ID;if(null==this.contactNodeLookup[b]){this.contactNodeLookup[b]=
[];for(var c=0;c<=Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts;c++)this.contactNodeLookup[b][c]=null;this.CreateNode(a,b,Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);this.contactCount++}};Box2D.Dynamics.Contacts.b2ContactList.prototype.UpdateContact=function(a,b,c){b?this.CreateNode(a,a.ID,Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledTouchingContacts):this.RemoveNode(a.ID,Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledTouchingContacts);c?this.CreateNode(a,
a.ID,Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledContinuousContacts):this.RemoveNode(a.ID,Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledContinuousContacts)};Box2D.Dynamics.Contacts.b2ContactList.prototype.RemoveContact=function(a){a=a.ID;if(null!=this.contactNodeLookup[a]){for(var b=0;b<=Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts;b++)this.RemoveNode(a,b);delete this.contactNodeLookup[a];this.contactCount--}};Box2D.Dynamics.Contacts.b2ContactList.prototype.RemoveNode=
function(a,b){var c=this.contactNodeLookup[a];if(null!=c){var d=c[b];if(null!=d){c[b]=null;var c=d.GetPreviousNode(),e=d.GetNextNode();null==c?this.contactFirstNodes[b]=e:c.SetNextNode(e);null==e?this.contactLastNodes[b]=c:e.SetPreviousNode(c);Box2D.Dynamics.Contacts.b2ContactListNode.FreeNode(d)}}};Box2D.Dynamics.Contacts.b2ContactList.prototype.CreateNode=function(a,b,c){b=this.contactNodeLookup[b];null==b[c]&&(b[c]=Box2D.Dynamics.Contacts.b2ContactListNode.GetNode(a),a=this.contactLastNodes[c],
null!=a?(a.SetNextNode(b[c]),b[c].SetPreviousNode(a)):this.contactFirstNodes[c]=b[c],this.contactLastNodes[c]=b[c])};Box2D.Dynamics.Contacts.b2ContactList.prototype.GetContactCount=function(){return this.contactCount};Box2D.Dynamics.Contacts.b2ContactList.TYPES={nonSensorEnabledTouchingContacts:0,nonSensorEnabledContinuousContacts:1,allContacts:2};Box2D.Dynamics.Contacts.b2ContactListNode=function(a){this.contact=a;this.previous=this.next=null};Box2D.Dynamics.Contacts.b2ContactListNode.freeNodes=
[];Box2D.Dynamics.Contacts.b2ContactListNode.GetNode=function(a){if(0<Box2D.Dynamics.Contacts.b2ContactListNode.freeNodes.length){var b=Box2D.Dynamics.Contacts.b2ContactListNode.freeNodes.pop();b.next=null;b.previous=null;b.contact=a;return b}return new Box2D.Dynamics.Contacts.b2ContactListNode(a)};Box2D.Dynamics.Contacts.b2ContactListNode.FreeNode=function(a){Box2D.Dynamics.Contacts.b2ContactListNode.freeNodes.push(a)};Box2D.Dynamics.Contacts.b2ContactListNode.prototype.SetNextNode=function(a){this.next=
a};Box2D.Dynamics.Contacts.b2ContactListNode.prototype.SetPreviousNode=function(a){this.previous=a};Box2D.Dynamics.Contacts.b2ContactListNode.prototype.GetContact=function(){return this.contact};Box2D.Dynamics.Contacts.b2ContactListNode.prototype.GetNextNode=function(){return this.next};Box2D.Dynamics.Contacts.b2ContactListNode.prototype.GetPreviousNode=function(){return this.previous};Box2D.Dynamics.Contacts.b2ContactRegister=function(){this.pool=null;this.poolCount=0};Box2D.Dynamics.Contacts.b2PositionSolverManifold=
function(){this.m_normal=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_separations=[];this.m_points=[];for(var a=0;a<Box2D.Common.b2Settings.b2_maxManifoldPoints;a++)this.m_points[a]=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Dynamics.Contacts.b2PositionSolverManifold.prototype.Initialize=function(a){switch(a.type){case Box2D.Collision.b2Manifold.e_circles:this._InitializeCircles(a);break;case Box2D.Collision.b2Manifold.e_faceA:this._InitializeFaceA(a);break;case Box2D.Collision.b2Manifold.e_faceB:this._InitializeFaceB(a)}};
Box2D.Dynamics.Contacts.b2PositionSolverManifold.prototype._InitializeCircles=function(a){var b=a.bodyA.m_xf.R,c=a.localPoint,d=a.bodyA.m_xf.position.x+(b.col1.x*c.x+b.col2.x*c.y),e=a.bodyA.m_xf.position.y+(b.col1.y*c.x+b.col2.y*c.y),b=a.bodyB.m_xf.R,c=a.points[0].localPoint,f=a.bodyB.m_xf.position.x+(b.col1.x*c.x+b.col2.x*c.y),b=a.bodyB.m_xf.position.y+(b.col1.y*c.x+b.col2.y*c.y),c=f-d,g=b-e,h=c*c+g*g;h>Box2D.Common.b2Settings.MIN_VALUE_SQUARED?(h=Math.sqrt(h),this.m_normal.x=c/h,this.m_normal.y=
g/h):(this.m_normal.x=1,this.m_normal.y=0);this.m_points[0].x=0.5*(d+f);this.m_points[0].y=0.5*(e+b);this.m_separations[0]=c*this.m_normal.x+g*this.m_normal.y-a.radius};Box2D.Dynamics.Contacts.b2PositionSolverManifold.prototype._InitializeFaceA=function(a){this.m_normal.x=a.bodyA.m_xf.R.col1.x*a.localPlaneNormal.x+a.bodyA.m_xf.R.col2.x*a.localPlaneNormal.y;this.m_normal.y=a.bodyA.m_xf.R.col1.y*a.localPlaneNormal.x+a.bodyA.m_xf.R.col2.y*a.localPlaneNormal.y;for(var b=a.bodyA.m_xf.position.x+(a.bodyA.m_xf.R.col1.x*
a.localPoint.x+a.bodyA.m_xf.R.col2.x*a.localPoint.y),c=a.bodyA.m_xf.position.y+(a.bodyA.m_xf.R.col1.y*a.localPoint.x+a.bodyA.m_xf.R.col2.y*a.localPoint.y),d=0;d<a.pointCount;d++){var e=a.bodyB.m_xf.position.x+(a.bodyB.m_xf.R.col1.x*a.points[d].localPoint.x+a.bodyB.m_xf.R.col2.x*a.points[d].localPoint.y),f=a.bodyB.m_xf.position.y+(a.bodyB.m_xf.R.col1.y*a.points[d].localPoint.x+a.bodyB.m_xf.R.col2.y*a.points[d].localPoint.y);this.m_separations[d]=(e-b)*this.m_normal.x+(f-c)*this.m_normal.y-a.radius;
this.m_points[d].x=e;this.m_points[d].y=f}};Box2D.Dynamics.Contacts.b2PositionSolverManifold.prototype._InitializeFaceB=function(a){this.m_normal.x=a.bodyB.m_xf.R.col1.x*a.localPlaneNormal.x+a.bodyB.m_xf.R.col2.x*a.localPlaneNormal.y;this.m_normal.y=a.bodyB.m_xf.R.col1.y*a.localPlaneNormal.x+a.bodyB.m_xf.R.col2.y*a.localPlaneNormal.y;for(var b=a.bodyB.m_xf.position.x+(a.bodyB.m_xf.R.col1.x*a.localPoint.x+a.bodyB.m_xf.R.col2.x*a.localPoint.y),c=a.bodyB.m_xf.position.y+(a.bodyB.m_xf.R.col1.y*a.localPoint.x+
a.bodyB.m_xf.R.col2.y*a.localPoint.y),d=0;d<a.pointCount;d++){var e=a.bodyA.m_xf.position.x+(a.bodyA.m_xf.R.col1.x*a.points[d].localPoint.x+a.bodyA.m_xf.R.col2.x*a.points[d].localPoint.y),f=a.bodyA.m_xf.position.y+(a.bodyA.m_xf.R.col1.y*a.points[d].localPoint.x+a.bodyA.m_xf.R.col2.y*a.points[d].localPoint.y);this.m_separations[d]=(e-b)*this.m_normal.x+(f-c)*this.m_normal.y-a.radius;this.m_points[d].Set(e,f)}this.m_normal.x*=-1;this.m_normal.y*=-1};Box2D.Dynamics.Contacts.b2ContactSolver=function(){this.m_constraints=
[]};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.Initialize=function(a,b,c){for(this.m_constraintCount=c;this.m_constraints.length<this.m_constraintCount;)this.m_constraints[this.m_constraints.length]=new Box2D.Dynamics.Contacts.b2ContactConstraint;for(a=0;a<c;a++){var d=b[a],e=d.m_fixtureA,f=d.m_fixtureB,g=e.m_shape.m_radius,h=f.m_shape.m_radius,l=e.GetBody(),k=f.GetBody(),m=d.GetManifold(),n=Box2D.Common.b2Settings.b2MixFriction(e.GetFriction(),f.GetFriction()),q=Box2D.Common.b2Settings.b2MixRestitution(e.GetRestitution(),
f.GetRestitution()),p=l.m_linearVelocity.x,r=l.m_linearVelocity.y,s=k.m_linearVelocity.x,t=k.m_linearVelocity.y,v=l.m_angularVelocity,y=k.m_angularVelocity;Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.Initialize(m,l.m_xf,g,k.m_xf,h);f=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_normal.x;d=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_normal.y;e=this.m_constraints[a];e.bodyA=l;e.bodyB=k;e.manifold=m;e.normal.x=f;e.normal.y=d;e.pointCount=m.m_pointCount;e.friction=
n;e.restitution=q;e.localPlaneNormal.x=m.m_localPlaneNormal.x;e.localPlaneNormal.y=m.m_localPlaneNormal.y;e.localPoint.x=m.m_localPoint.x;e.localPoint.y=m.m_localPoint.y;e.radius=g+h;e.type=m.m_type;for(g=0;g<e.pointCount;++g){n=m.m_points[g];h=e.points[g];h.normalImpulse=n.m_normalImpulse;h.tangentImpulse=n.m_tangentImpulse;h.localPoint.SetV(n.m_localPoint);var n=h.rA.x=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_points[g].x-l.m_sweep.c.x,q=h.rA.y=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_points[g].y-
l.m_sweep.c.y,z=h.rB.x=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_points[g].x-k.m_sweep.c.x,C=h.rB.y=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_points[g].y-k.m_sweep.c.y,A=n*d-q*f,x=z*d-C*f,A=A*A,x=x*x;h.normalMass=1/(l.m_invMass+k.m_invMass+l.m_invI*A+k.m_invI*x);var w=l.m_mass*l.m_invMass+k.m_mass*k.m_invMass,w=w+(l.m_mass*l.m_invI*A+k.m_mass*k.m_invI*x);h.equalizedMass=1/w;x=d;w=-f;A=n*w-q*x;x=z*w-C*x;A*=A;x*=x;h.tangentMass=1/(l.m_invMass+k.m_invMass+l.m_invI*A+k.m_invI*
x);h.velocityBias=0;n=e.normal.x*(s+-y*C-p- -v*q)+e.normal.y*(t+y*z-r-v*n);n<-Box2D.Common.b2Settings.b2_velocityThreshold&&(h.velocityBias+=-e.restitution*n)}2==e.pointCount&&(t=e.points[0],s=e.points[1],m=l.m_invMass,l=l.m_invI,p=k.m_invMass,k=k.m_invI,r=t.rA.x*d-t.rA.y*f,t=t.rB.x*d-t.rB.y*f,v=s.rA.x*d-s.rA.y*f,s=s.rB.x*d-s.rB.y*f,f=m+p+l*r*r+k*t*t,d=m+p+l*v*v+k*s*s,k=m+p+l*r*v+k*t*s,f*f<100*(f*d-k*k)?(e.K.col1.Set(f,k),e.K.col2.Set(k,d),e.K.GetInverse(e.normalMass)):e.pointCount=1)}};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.InitVelocityConstraints=
function(a){for(var b=0;b<this.m_constraintCount;++b){var c=this.m_constraints[b],d=c.bodyA,e=c.bodyB,f=d.m_invMass,g=d.m_invI,h=e.m_invMass,l=e.m_invI,k=c.normal.x,m=c.normal.y,n=m,q=-k,p=0,r=0;if(a.warmStarting){r=c.pointCount;for(p=0;p<r;++p){var s=c.points[p];s.normalImpulse*=a.dtRatio;s.tangentImpulse*=a.dtRatio;var t=s.normalImpulse*k+s.tangentImpulse*n,v=s.normalImpulse*m+s.tangentImpulse*q;d.m_angularVelocity-=g*(s.rA.x*v-s.rA.y*t);d.m_linearVelocity.x-=f*t;d.m_linearVelocity.y-=f*v;e.m_angularVelocity+=
l*(s.rB.x*v-s.rB.y*t);e.m_linearVelocity.x+=h*t;e.m_linearVelocity.y+=h*v}}else{r=c.pointCount;for(p=0;p<r;++p)d=c.points[p],d.normalImpulse=0,d.tangentImpulse=0}}};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolveVelocityConstraints=function(){for(var a=0;a<this.m_constraintCount;a++)this.SolveVelocityConstraints_Constraint(this.m_constraints[a])};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolveVelocityConstraints_Constraint=function(a){for(var b=a.normal.x,c=a.normal.y,d=0;d<a.pointCount;d++)Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolveVelocityConstraints_ConstraintPoint(a,
a.points[d]);if(1==a.pointCount){var d=a.points[0],e=d.normalImpulse-d.normalMass*((a.bodyB.m_linearVelocity.x-a.bodyB.m_angularVelocity*d.rB.y-a.bodyA.m_linearVelocity.x+a.bodyA.m_angularVelocity*d.rA.y)*b+(a.bodyB.m_linearVelocity.y+a.bodyB.m_angularVelocity*d.rB.x-a.bodyA.m_linearVelocity.y-a.bodyA.m_angularVelocity*d.rA.x)*c-d.velocityBias),e=0<e?e:0,f=e-d.normalImpulse,g=f*b,c=f*c;a.bodyA.m_linearVelocity.x-=a.bodyA.m_invMass*g;a.bodyA.m_linearVelocity.y-=a.bodyA.m_invMass*c;a.bodyA.m_angularVelocity-=
a.bodyA.m_invI*(d.rA.x*c-d.rA.y*g);a.bodyB.m_linearVelocity.x+=a.bodyB.m_invMass*g;a.bodyB.m_linearVelocity.y+=a.bodyB.m_invMass*c;a.bodyB.m_angularVelocity+=a.bodyB.m_invI*(d.rB.x*c-d.rB.y*g);d.normalImpulse=e}else for(var d=a.points[0],e=a.points[1],f=d.normalImpulse,g=e.normalImpulse,h=(a.bodyB.m_linearVelocity.x-a.bodyB.m_angularVelocity*d.rB.y-a.bodyA.m_linearVelocity.x+a.bodyA.m_angularVelocity*d.rA.y)*b+(a.bodyB.m_linearVelocity.y+a.bodyB.m_angularVelocity*d.rB.x-a.bodyA.m_linearVelocity.y-
a.bodyA.m_angularVelocity*d.rA.x)*c-d.velocityBias,c=(a.bodyB.m_linearVelocity.x-a.bodyB.m_angularVelocity*e.rB.y-a.bodyA.m_linearVelocity.x+a.bodyA.m_angularVelocity*e.rA.y)*b+(a.bodyB.m_linearVelocity.y+a.bodyB.m_angularVelocity*e.rB.x-a.bodyA.m_linearVelocity.y-a.bodyA.m_angularVelocity*e.rA.x)*c-e.velocityBias,h=h-(a.K.col1.x*f+a.K.col2.x*g),c=c-(a.K.col1.y*f+a.K.col2.y*g);;){b=-(a.normalMass.col1.x*h+a.normalMass.col2.x*c);if(0<=b){var l=-(a.normalMass.col1.y*h+a.normalMass.col2.y*c);if(0<=l){this.SolveVelocityConstraints_ConstraintPointUpdate(a,
d,e,b-f,l-g);d.normalImpulse=b;e.normalImpulse=l;break}}b=-d.normalMass*h;if(0<=b&&0<=a.K.col1.y*b+c){this.SolveVelocityConstraints_ConstraintPointUpdate(a,d,e,b-f,-g);d.normalImpulse=b;e.normalImpulse=0;break}b=-e.normalMass*c;if(0<=b&&0<=a.K.col2.x*b+h){this.SolveVelocityConstraints_ConstraintPointUpdate(a,d,e,-f,b-g);d.normalImpulse=0;e.normalImpulse=b;break}if(0<=h&&0<=c){this.SolveVelocityConstraints_ConstraintPointUpdate(a,d,e,-f,-g);d.normalImpulse=0;e.normalImpulse=0;break}break}};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolveVelocityConstraints_ConstraintPoint=
function(a,b){var c=a.normal.y,d=-a.normal.x,e=a.friction*b.normalImpulse,e=Box2D.Common.Math.b2Math.Clamp(b.tangentImpulse-b.tangentMass*((a.bodyB.m_linearVelocity.x-a.bodyB.m_angularVelocity*b.rB.y-a.bodyA.m_linearVelocity.x+a.bodyA.m_angularVelocity*b.rA.y)*c+(a.bodyB.m_linearVelocity.y+a.bodyB.m_angularVelocity*b.rB.x-a.bodyA.m_linearVelocity.y-a.bodyA.m_angularVelocity*b.rA.x)*d),-e,e),f=e-b.tangentImpulse,c=f*c,d=f*d;a.bodyA.m_linearVelocity.x-=a.bodyA.m_invMass*c;a.bodyA.m_linearVelocity.y-=
a.bodyA.m_invMass*d;a.bodyA.m_angularVelocity-=a.bodyA.m_invI*(b.rA.x*d-b.rA.y*c);a.bodyB.m_linearVelocity.x+=a.bodyB.m_invMass*c;a.bodyB.m_linearVelocity.y+=a.bodyB.m_invMass*d;a.bodyB.m_angularVelocity+=a.bodyB.m_invI*(b.rB.x*d-b.rB.y*c);b.tangentImpulse=e};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolveVelocityConstraints_ConstraintPointUpdate=function(a,b,c,d,e){var f=d*a.normal.x;d*=a.normal.y;var g=e*a.normal.x;e*=a.normal.y;a.bodyA.m_linearVelocity.x-=a.bodyA.m_invMass*(f+g);a.bodyA.m_linearVelocity.y-=
a.bodyA.m_invMass*(d+e);a.bodyA.m_angularVelocity-=a.bodyA.m_invI*(b.rA.x*d-b.rA.y*f+c.rA.x*e-c.rA.y*g);a.bodyB.m_linearVelocity.x+=a.bodyB.m_invMass*(f+g);a.bodyB.m_linearVelocity.y+=a.bodyB.m_invMass*(d+e);a.bodyB.m_angularVelocity+=a.bodyB.m_invI*(b.rB.x*d-b.rB.y*f+c.rB.x*e-c.rB.y*g);b.normalImpulse=0;c.normalImpulse=0};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.FinalizeVelocityConstraints=function(){for(var a=0;a<this.m_constraintCount;++a)for(var b=this.m_constraints[a],c=b.manifold,d=
0;d<b.pointCount;++d){var e=c.m_points[d],f=b.points[d];e.m_normalImpulse=f.normalImpulse;e.m_tangentImpulse=f.tangentImpulse}};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolvePositionConstraints=function(a){void 0===a&&(a=0);for(var b=0,c=0;c<this.m_constraintCount;c++){var d=this.m_constraints[c],e=d.bodyA,f=d.bodyB,g=e.m_mass*e.m_invMass,h=e.m_mass*e.m_invI,l=f.m_mass*f.m_invMass,k=f.m_mass*f.m_invI;Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.Initialize(d);for(var m=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_normal,
n=0;n<d.pointCount;n++){var q=d.points[n],p=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_points[n],r=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_separations[n],s=p.x-e.m_sweep.c.x,t=p.y-e.m_sweep.c.y,v=p.x-f.m_sweep.c.x,p=p.y-f.m_sweep.c.y,b=b<r?b:r,r=Box2D.Common.Math.b2Math.Clamp(a*(r+Box2D.Common.b2Settings.b2_linearSlop),-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),r=-q.equalizedMass*r,q=r*m.x,r=r*m.y;e.m_sweep.c.x-=g*q;e.m_sweep.c.y-=g*r;e.m_sweep.a-=h*(s*r-t*q);e.SynchronizeTransform();
f.m_sweep.c.x+=l*q;f.m_sweep.c.y+=l*r;f.m_sweep.a+=k*(v*r-p*q);f.SynchronizeTransform()}}return b>-1.5*Box2D.Common.b2Settings.b2_linearSlop};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolvePositionConstraints_NEW=function(a){void 0===a&&(a=0);for(var b=0,c=0;c<this.m_constraintCount;c++){var d=this.m_constraints[c],e=d.bodyA,f=d.bodyB,g=e.m_mass*e.m_invMass,h=e.m_mass*e.m_invI,l=f.m_mass*f.m_invMass,k=f.m_mass*f.m_invI;Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.Initialize(d);for(var m=
Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_normal,n=0;n<d.pointCount;n++){var q=d.points[n],p=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_points[n],r=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_separations[n],s=p.x-e.m_sweep.c.x,t=p.y-e.m_sweep.c.y,v=p.x-f.m_sweep.c.x,p=p.y-f.m_sweep.c.y;r<b&&(b=r);0!=a&&Box2D.Common.Math.b2Math.Clamp(a*(r+Box2D.Common.b2Settings.b2_linearSlop),-Box2D.Common.b2Settings.b2_maxLinearCorrection,0);r=0*-q.equalizedMass;q=r*m.x;r*=m.y;e.m_sweep.c.x-=g*q;e.m_sweep.c.y-=
g*r;e.m_sweep.a-=h*(s*r-t*q);e.SynchronizeTransform();f.m_sweep.c.x+=l*q;f.m_sweep.c.y+=l*r;f.m_sweep.a+=k*(v*r-p*q);f.SynchronizeTransform()}}return b>-1.5*Box2D.Common.b2Settings.b2_linearSlop};Box2D.Dynamics.Contacts.b2EdgeAndCircleContact=function(a,b){Box2D.Dynamics.Contacts.b2Contact.call(this,a,b)};c2inherit(Box2D.Dynamics.Contacts.b2EdgeAndCircleContact,Box2D.Dynamics.Contacts.b2Contact);Box2D.Dynamics.Contacts.b2EdgeAndCircleContact.prototype.Reset=function(a,b){Box2D.Dynamics.Contacts.b2Contact.prototype.Reset.call(this,
a,b)};Box2D.Dynamics.Contacts.b2EdgeAndCircleContact.prototype.Evaluate=function(){this.m_fixtureA.GetBody();this.m_fixtureB.GetBody();this.b2CollideEdgeAndCircle(this.m_manifold,this.m_fixtureA.GetShape(),this.m_fixtureA.GetBody().m_xf,this.m_fixtureB.GetShape(),this.m_fixtureB.GetBody().m_xf)};Box2D.Dynamics.Contacts.b2EdgeAndCircleContact.prototype.b2CollideEdgeAndCircle=function(a,b,c,d,e){};Box2D.Dynamics.Contacts.b2PolyAndCircleContact=function(a,b){Box2D.Dynamics.Contacts.b2Contact.call(this,
a,b)};c2inherit(Box2D.Dynamics.Contacts.b2PolyAndCircleContact,Box2D.Dynamics.Contacts.b2Contact);Box2D.Dynamics.Contacts.b2PolyAndCircleContact.prototype.Reset=function(a,b){Box2D.Dynamics.Contacts.b2Contact.prototype.Reset.call(this,a,b)};Box2D.Dynamics.Contacts.b2PolyAndCircleContact.prototype.Evaluate=function(){Box2D.Collision.b2Collision.CollidePolygonAndCircle(this.m_manifold,this.m_fixtureA.GetShape(),this.m_fixtureA.GetBody().m_xf,this.m_fixtureB.GetShape(),this.m_fixtureB.GetBody().m_xf)};
Box2D.Dynamics.Contacts.b2PolyAndEdgeContact=function(a,b){Box2D.Dynamics.Contacts.b2Contact.call(this,a,b)};c2inherit(Box2D.Dynamics.Contacts.b2PolyAndEdgeContact,Box2D.Dynamics.Contacts.b2Contact);Box2D.Dynamics.Contacts.b2PolyAndEdgeContact.prototype.Reset=function(a,b){Box2D.Dynamics.Contacts.b2Contact.prototype.Reset.call(this,a,b)};Box2D.Dynamics.Contacts.b2PolyAndEdgeContact.prototype.Evaluate=function(){this.b2CollidePolyAndEdge(this.m_manifold,this.m_fixtureA.GetShape(),this.m_fixtureA.GetBody().m_xf,
this.m_fixtureB.GetShape(),this.m_fixtureB.GetBody().m_xf)};Box2D.Dynamics.Contacts.b2PolyAndEdgeContact.prototype.b2CollidePolyAndEdge=function(a,b,c,d,e){};Box2D.Dynamics.Contacts.b2PolygonContact=function(a,b){Box2D.Dynamics.Contacts.b2Contact.call(this,a,b)};c2inherit(Box2D.Dynamics.Contacts.b2PolygonContact,Box2D.Dynamics.Contacts.b2Contact);Box2D.Dynamics.Contacts.b2PolygonContact.prototype.Reset=function(a,b){Box2D.Dynamics.Contacts.b2Contact.prototype.Reset.call(this,a,b)};Box2D.Dynamics.Contacts.b2PolygonContact.prototype.Evaluate=
function(){Box2D.Collision.b2Collision.CollidePolygons(this.m_manifold,this.m_fixtureA.GetShape(),this.m_fixtureA.GetBody().m_xf,this.m_fixtureB.GetShape(),this.m_fixtureB.GetBody().m_xf)};Box2D.Dynamics.Controllers.b2Controller=function(){this.ID="Controller"+Box2D.Dynamics.Controllers.b2Controller.NEXT_ID++;this.m_world=null;this.bodyList=new Box2D.Dynamics.b2BodyList};Box2D.Dynamics.Controllers.b2Controller.prototype.Step=function(a){};Box2D.Dynamics.Controllers.b2Controller.prototype.AddBody=
function(a){this.bodyList.AddBody(a);a.AddController(this)};Box2D.Dynamics.Controllers.b2Controller.prototype.RemoveBody=function(a){this.bodyList.RemoveBody(a);a.RemoveController(this)};Box2D.Dynamics.Controllers.b2Controller.prototype.Clear=function(){for(var a=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);a;a=a.GetNextNode())this.RemoveBody(a.body)};Box2D.Dynamics.Controllers.b2Controller.prototype.GetBodyList=function(){return this.bodyList};Box2D.Dynamics.Controllers.b2Controller.NEXT_ID=
0;Box2D.Dynamics.Controllers.b2BuoyancyController=function(){Box2D.Dynamics.Controllers.b2Controller.call(this);this.normal=Box2D.Common.Math.b2Vec2.Get(0,-1);this.density=this.offset=0;this.velocity=Box2D.Common.Math.b2Vec2.Get(0,0);this.linearDrag=2;this.angularDrag=1;this.useDensity=!1;this.useWorldGravity=!0;this.gravity=null};c2inherit(Box2D.Dynamics.Controllers.b2BuoyancyController,Box2D.Dynamics.Controllers.b2Controller);Box2D.Dynamics.Controllers.b2BuoyancyController.prototype.Step=function(a){this.useWorldGravity&&
(this.gravity=this.m_world.GetGravity().Copy());for(a=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.awakeBodies);a;a=a.GetNextNode()){for(var b=a.body,c=Box2D.Common.Math.b2Vec2.Get(0,0),d=Box2D.Common.Math.b2Vec2.Get(0,0),e=0,f=0,g=b.GetFixtureList().GetFirstNode();g;g=g.GetNextNode()){var h=Box2D.Common.Math.b2Vec2.Get(0,0),l=g.fixture.GetShape().ComputeSubmergedArea(this.normal,this.offset,b.GetTransform(),h),e=e+l;c.x+=l*h.x;c.y+=l*h.y;var k=0,k=1,f=f+l*k;d.x+=l*h.x*k;d.y+=l*h.y*
k}e<Number.MIN_VALUE||(c.x/=e,c.y/=e,d.x/=f,d.y/=f,f=this.gravity.GetNegative(),f.Multiply(this.density*e),b.ApplyForce(f,d),f=b.GetLinearVelocityFromWorldPoint(c),f.Subtract(this.velocity),f.Multiply(-this.linearDrag*e),b.ApplyForce(f,c),b.ApplyTorque(-b.GetInertia()/b.GetMass()*e*b.GetAngularVelocity()*this.angularDrag),Box2D.Common.Math.b2Vec2.Free(c),Box2D.Common.Math.b2Vec2.Free(d))}};Box2D.Dynamics.Controllers.b2ConstantAccelController=function(){Box2D.Dynamics.Controllers.b2Controller.call(this);
this.A=Box2D.Common.Math.b2Vec2.Get(0,0)};c2inherit(Box2D.Dynamics.Controllers.b2ConstantAccelController,Box2D.Dynamics.Controllers.b2Controller);Box2D.Dynamics.Controllers.b2ConstantAccelController.prototype.Step=function(a){a=Box2D.Common.Math.b2Vec2.Get(this.A.x*a.dt,this.A.y*a.dt);for(var b=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.awakeBodies);b;b=b.GetNextNode()){var c=b.body,d=c.GetLinearVelocity();c.SetLinearVelocity(Box2D.Common.Math.b2Vec2.Get(d.x+a.x,d.y+a.y))}Box2D.Common.Math.b2Vec2.Free(a)};
Box2D.Dynamics.Controllers.b2ConstantForceController=function(){Box2D.Dynamics.Controllers.b2Controller.call(this);this.F=Box2D.Common.Math.b2Vec2.Get(0,0)};c2inherit(Box2D.Dynamics.Controllers.b2ConstantForceController,Box2D.Dynamics.Controllers.b2Controller);Box2D.Dynamics.Controllers.b2ConstantForceController.prototype.Step=function(a){for(a=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.awakeBodies);a;a=a.GetNextNode()){var b=a.body;b.ApplyForce(this.F,b.GetWorldCenter())}};Box2D.Dynamics.Controllers.b2ControllerList=
function(){this.controllerLastNode=this.controllerFirstNode=null;this.controllerNodeLookup={};this.controllerCount=0};Box2D.Dynamics.Controllers.b2ControllerList.prototype.GetFirstNode=function(){return this.controllerFirstNode};Box2D.Dynamics.Controllers.b2ControllerList.prototype.AddController=function(a){var b=a.ID;if(null==this.controllerNodeLookup[b]){a=new Box2D.Dynamics.Controllers.b2ControllerListNode(a);var c=this.controllerLastNode;null!=c?c.SetNextNode(a):this.controllerFirstNode=a;a.SetPreviousNode(c);
this.controllerLastNode=a;this.controllerNodeLookup[b]=a;this.controllerCount++}};Box2D.Dynamics.Controllers.b2ControllerList.prototype.RemoveController=function(a){a=a.ID;var b=this.controllerNodeLookup[a];if(null!=b){var c=b.GetPreviousNode(),b=b.GetNextNode();null==c?this.controllerFirstNode=b:c.SetNextNode(b);null==b?this.controllerLastNode=c:b.SetPreviousNode(c);delete this.controllerNodeLookup[a];this.controllerCount--}};Box2D.Dynamics.Controllers.b2ControllerList.prototype.GetControllerCount=
function(){return this.controllerCount};Box2D.Dynamics.Controllers.b2ControllerListNode=function(a){this.controller=a;this.previous=this.next=null};Box2D.Dynamics.Controllers.b2ControllerListNode.prototype.SetNextNode=function(a){this.next=a};Box2D.Dynamics.Controllers.b2ControllerListNode.prototype.SetPreviousNode=function(a){this.previous=a};Box2D.Dynamics.Controllers.b2ControllerListNode.prototype.GetNextNode=function(){return this.next};Box2D.Dynamics.Controllers.b2ControllerListNode.prototype.GetPreviousNode=
function(){return this.previous};Box2D.Dynamics.Controllers.b2GravityController=function(){Box2D.Dynamics.Controllers.b2Controller.call(this);this.G=1;this.invSqr=!0};c2inherit(Box2D.Dynamics.Controllers.b2GravityController,Box2D.Dynamics.Controllers.b2Controller);Box2D.Dynamics.Controllers.b2GravityController.prototype.Step=function(a){var b=a=null,c=0,d=null,e=null,f=0,g=0,h=0,f=null;if(this.invSqr)for(var l=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);l;l=l.GetNextNode()){a=
l.body;for(var b=a.GetWorldCenter(),c=a.GetMass(),k=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);k;k=k.GetNextNode())if(d=k.body,a.IsAwake()||d.IsAwake())e=d.GetWorldCenter(),f=e.x-b.x,g=e.y-b.y,h=f*f+g*g,h<Number.MIN_VALUE||(f=Box2D.Common.Math.b2Vec2.Get(f,g),f.Multiply(this.G/h/Math.sqrt(h)*c*d.GetMass()),a.IsAwake()&&a.ApplyForce(f,b),f.Multiply(-1),d.IsAwake()&&d.ApplyForce(f,e),Box2D.Common.Math.b2Vec2.Free(f))}else for(l=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);l;l=
l.GetNextNode()){a=bodyNode.body;b=a.GetWorldCenter();c=a.GetMass();for(k=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);k;k=k.GetNextNode())if(d=bodyNode.body,a.IsAwake()||d.IsAwake())e=d.GetWorldCenter(),f=e.x-b.x,g=e.y-b.y,h=f*f+g*g,h<Number.MIN_VALUE||(f=Box2D.Common.Math.b2Vec2.Get(f,g),f.Multiply(this.G/h*c*d.GetMass()),a.IsAwake()&&a.ApplyForce(f,b),f.Multiply(-1),d.IsAwake()&&d.ApplyForce(f,e),Box2D.Common.Math.b2Vec2.Free(f))}};Box2D.Dynamics.Controllers.b2TensorDampingController=
function(){Box2D.Dynamics.Controllers.b2Controller.call(this);this.T=new Box2D.Common.Math.b2Mat22;this.maxTimestep=0};c2inherit(Box2D.Dynamics.Controllers.b2TensorDampingController,Box2D.Dynamics.Controllers.b2Controller);Box2D.Dynamics.Controllers.b2TensorDampingController.prototype.SetAxisAligned=function(a,b){this.T.col1.x=-a;this.T.col1.y=0;this.T.col2.x=0;this.T.col2.y=-b;this.maxTimestep=0<a||0<b?1/Math.max(a,b):0};Box2D.Dynamics.Controllers.b2TensorDampingController.prototype.Step=function(a){a=
a.dt;if(!(a<=Number.MIN_VALUE)){a>this.maxTimestep&&0<this.maxTimestep&&(a=this.maxTimestep);for(var b=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.awakeBodies);b;b=b.GetNextNode()){var c=b.body,d=c.GetWorldVector(Box2D.Common.Math.b2Math.MulMV(this.T,c.GetLocalVector(c.GetLinearVelocity())));c.SetLinearVelocity(Box2D.Common.Math.b2Vec2.Get(c.GetLinearVelocity().x+d.x*a,c.GetLinearVelocity().y+d.y*a))}}};Box2D.Dynamics.Joints.b2Joint=function(a){this.m_edgeA=new Box2D.Dynamics.Joints.b2JointEdge;
this.m_edgeB=new Box2D.Dynamics.Joints.b2JointEdge;this.m_localCenterA=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localCenterB=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_type=a.type;this.m_next=this.m_prev=null;this.m_bodyA=a.bodyA;this.m_bodyB=a.bodyB;this.m_collideConnected=a.collideConnected};Box2D.Dynamics.Joints.b2Joint.prototype.GetType=function(){return this.m_type};Box2D.Dynamics.Joints.b2Joint.prototype.GetAnchorA=function(){return null};Box2D.Dynamics.Joints.b2Joint.prototype.GetAnchorB=function(){return null};
Box2D.Dynamics.Joints.b2Joint.prototype.GetReactionForce=function(a){return null};Box2D.Dynamics.Joints.b2Joint.prototype.GetReactionTorque=function(a){return 0};Box2D.Dynamics.Joints.b2Joint.prototype.GetBodyA=function(){return this.m_bodyA};Box2D.Dynamics.Joints.b2Joint.prototype.GetBodyB=function(){return this.m_bodyB};Box2D.Dynamics.Joints.b2Joint.prototype.GetNext=function(){return this.m_next};Box2D.Dynamics.Joints.b2Joint.prototype.IsActive=function(){return this.m_bodyA.IsActive()&&this.m_bodyB.IsActive()};
Box2D.Dynamics.Joints.b2Joint.Create=function(a){return a.Create()};Box2D.Dynamics.Joints.b2Joint.prototype.InitVelocityConstraints=function(a){};Box2D.Dynamics.Joints.b2Joint.prototype.SolveVelocityConstraints=function(a){};Box2D.Dynamics.Joints.b2Joint.prototype.FinalizeVelocityConstraints=function(){};Box2D.Dynamics.Joints.b2Joint.prototype.SolvePositionConstraints=function(a){return!1};Box2D.Dynamics.Joints.b2Joint.e_unknownJoint=0;Box2D.Dynamics.Joints.b2Joint.e_revoluteJoint=1;Box2D.Dynamics.Joints.b2Joint.e_prismaticJoint=
2;Box2D.Dynamics.Joints.b2Joint.e_distanceJoint=3;Box2D.Dynamics.Joints.b2Joint.e_pulleyJoint=4;Box2D.Dynamics.Joints.b2Joint.e_mouseJoint=5;Box2D.Dynamics.Joints.b2Joint.e_gearJoint=6;Box2D.Dynamics.Joints.b2Joint.e_lineJoint=7;Box2D.Dynamics.Joints.b2Joint.e_weldJoint=8;Box2D.Dynamics.Joints.b2Joint.e_frictionJoint=9;Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit=0;Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit=1;Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit=2;Box2D.Dynamics.Joints.b2Joint.e_equalLimits=
3;Box2D.Dynamics.Joints.b2JointDef=function(){this.type=Box2D.Dynamics.Joints.b2Joint.e_unknownJoint;this.bodyB=this.bodyA=null;this.collideConnected=!1};Box2D.Dynamics.Joints.b2JointEdge=function(){};Box2D.Dynamics.Joints.b2DistanceJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_u=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor1.SetV(a.localAnchorA);this.m_localAnchor2.SetV(a.localAnchorB);
this.m_length=a.length;this.m_frequencyHz=a.frequencyHz;this.m_dampingRatio=a.dampingRatio;this.m_bias=this.m_gamma=this.m_impulse=0};c2inherit(Box2D.Dynamics.Joints.b2DistanceJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetAnchorA=function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetReactionForce=
function(a){return Box2D.Common.Math.b2Vec2.Get(a*this.m_impulse*this.m_u.x,a*this.m_impulse*this.m_u.y)};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetReactionTorque=function(a){return 0};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetLength=function(){return this.m_length};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.SetLength=function(a){this.m_length=a};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetFrequency=function(){return this.m_frequencyHz};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.SetFrequency=
function(a){this.m_frequencyHz=a};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetDampingRatio=function(){return this.m_dampingRatio};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.SetDampingRatio=function(a){this.m_dampingRatio=a};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.InitVelocityConstraints=function(a){var b,c=0,d=this.m_bodyA,e=this.m_bodyB;b=d.m_xf.R;var f=this.m_localAnchor1.x-d.m_sweep.localCenter.x,g=this.m_localAnchor1.y-d.m_sweep.localCenter.y,c=b.col1.x*f+b.col2.x*g,g=b.col1.y*
f+b.col2.y*g,f=c;b=e.m_xf.R;var h=this.m_localAnchor2.x-e.m_sweep.localCenter.x,l=this.m_localAnchor2.y-e.m_sweep.localCenter.y,c=b.col1.x*h+b.col2.x*l,l=b.col1.y*h+b.col2.y*l,h=c;this.m_u.x=e.m_sweep.c.x+h-d.m_sweep.c.x-f;this.m_u.y=e.m_sweep.c.y+l-d.m_sweep.c.y-g;c=Math.sqrt(this.m_u.x*this.m_u.x+this.m_u.y*this.m_u.y);c>Box2D.Common.b2Settings.b2_linearSlop?this.m_u.Multiply(1/c):this.m_u.SetZero();b=f*this.m_u.y-g*this.m_u.x;var k=h*this.m_u.y-l*this.m_u.x;b=d.m_invMass+d.m_invI*b*b+e.m_invMass+
e.m_invI*k*k;this.m_mass=0!=b?1/b:0;if(0<this.m_frequencyHz){var c=c-this.m_length,k=2*Math.PI*this.m_frequencyHz,m=this.m_mass*k*k;this.m_gamma=a.dt*(2*this.m_mass*this.m_dampingRatio*k+a.dt*m);this.m_gamma=0!=this.m_gamma?1/this.m_gamma:0;this.m_bias=c*a.dt*m*this.m_gamma;this.m_mass=b+this.m_gamma;this.m_mass=0!=this.m_mass?1/this.m_mass:0}a.warmStarting?(this.m_impulse*=a.dtRatio,a=this.m_impulse*this.m_u.x,b=this.m_impulse*this.m_u.y,d.m_linearVelocity.x-=d.m_invMass*a,d.m_linearVelocity.y-=
d.m_invMass*b,d.m_angularVelocity-=d.m_invI*(f*b-g*a),e.m_linearVelocity.x+=e.m_invMass*a,e.m_linearVelocity.y+=e.m_invMass*b,e.m_angularVelocity+=e.m_invI*(h*b-l*a)):this.m_impulse=0};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.SolveVelocityConstraints=function(a){a=this.m_localAnchor1.x-this.m_bodyA.m_sweep.localCenter.x;var b=this.m_localAnchor1.y-this.m_bodyA.m_sweep.localCenter.y,c=this.m_bodyA.m_xf.R.col1.x*a+this.m_bodyA.m_xf.R.col2.x*b,b=this.m_bodyA.m_xf.R.col1.y*a+this.m_bodyA.m_xf.R.col2.y*
b;a=c;var d=this.m_localAnchor2.x-this.m_bodyB.m_sweep.localCenter.x,e=this.m_localAnchor2.y-this.m_bodyB.m_sweep.localCenter.y,c=this.m_bodyB.m_xf.R.col1.x*d+this.m_bodyB.m_xf.R.col2.x*e,e=this.m_bodyB.m_xf.R.col1.y*d+this.m_bodyB.m_xf.R.col2.y*e,d=c,f=-this.m_mass*(this.m_u.x*(this.m_bodyB.m_linearVelocity.x-this.m_bodyB.m_angularVelocity*e-(this.m_bodyA.m_linearVelocity.x-this.m_bodyA.m_angularVelocity*b))+this.m_u.y*(this.m_bodyB.m_linearVelocity.y+this.m_bodyB.m_angularVelocity*d-(this.m_bodyA.m_linearVelocity.y+
this.m_bodyA.m_angularVelocity*a))+this.m_bias+this.m_gamma*this.m_impulse);this.m_impulse+=f;c=f*this.m_u.x;f*=this.m_u.y;this.m_bodyA.m_linearVelocity.x-=this.m_bodyA.m_invMass*c;this.m_bodyA.m_linearVelocity.y-=this.m_bodyA.m_invMass*f;this.m_bodyA.m_angularVelocity-=this.m_bodyA.m_invI*(a*f-b*c);this.m_bodyB.m_linearVelocity.x+=this.m_bodyB.m_invMass*c;this.m_bodyB.m_linearVelocity.y+=this.m_bodyB.m_invMass*f;this.m_bodyB.m_angularVelocity+=this.m_bodyB.m_invI*(d*f-e*c)};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.SolvePositionConstraints=
function(a){if(0<this.m_frequencyHz)return!0;a=this.m_localAnchor1.x-this.m_bodyA.m_sweep.localCenter.x;var b=this.m_localAnchor1.y-this.m_bodyA.m_sweep.localCenter.y,c=this.m_bodyA.m_xf.R.col1.x*a+this.m_bodyA.m_xf.R.col2.x*b,b=this.m_bodyA.m_xf.R.col1.y*a+this.m_bodyA.m_xf.R.col2.y*b;a=c;var d=this.m_localAnchor2.x-this.m_bodyB.m_sweep.localCenter.x,e=this.m_localAnchor2.y-this.m_bodyB.m_sweep.localCenter.y,c=this.m_bodyB.m_xf.R.col1.x*d+this.m_bodyB.m_xf.R.col2.x*e,e=this.m_bodyB.m_xf.R.col1.y*
d+this.m_bodyB.m_xf.R.col2.y*e,d=c,f=this.m_bodyB.m_sweep.c.x+d-this.m_bodyA.m_sweep.c.x-a,g=this.m_bodyB.m_sweep.c.y+e-this.m_bodyA.m_sweep.c.y-b,c=Math.sqrt(f*f+g*g),f=f/c,g=g/c,c=Box2D.Common.Math.b2Math.Clamp(c-this.m_length,-Box2D.Common.b2Settings.b2_maxLinearCorrection,Box2D.Common.b2Settings.b2_maxLinearCorrection),h=-this.m_mass*c;this.m_u.Set(f,g);f=h*this.m_u.x;g=h*this.m_u.y;this.m_bodyA.m_sweep.c.x-=this.m_bodyA.m_invMass*f;this.m_bodyA.m_sweep.c.y-=this.m_bodyA.m_invMass*g;this.m_bodyA.m_sweep.a-=
this.m_bodyA.m_invI*(a*g-b*f);this.m_bodyB.m_sweep.c.x+=this.m_bodyB.m_invMass*f;this.m_bodyB.m_sweep.c.y+=this.m_bodyB.m_invMass*g;this.m_bodyB.m_sweep.a+=this.m_bodyB.m_invI*(d*g-e*f);this.m_bodyA.SynchronizeTransform();this.m_bodyB.SynchronizeTransform();return Math.abs(c)<Box2D.Common.b2Settings.b2_linearSlop};Box2D.Dynamics.Joints.b2DistanceJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,
0);this.type=Box2D.Dynamics.Joints.b2Joint.e_distanceJoint;this.length=1;this.dampingRatio=this.frequencyHz=0};c2inherit(Box2D.Dynamics.Joints.b2DistanceJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2DistanceJointDef.prototype.Initialize=function(a,b,c,d){this.bodyA=a;this.bodyB=b;this.localAnchorA.SetV(this.bodyA.GetLocalPoint(c));this.localAnchorB.SetV(this.bodyB.GetLocalPoint(d));a=d.x-c.x;c=d.y-c.y;this.length=Math.sqrt(a*a+c*c);this.dampingRatio=this.frequencyHz=0};Box2D.Dynamics.Joints.b2DistanceJointDef.prototype.Create=
function(){return new Box2D.Dynamics.Joints.b2DistanceJoint(this)};Box2D.Dynamics.Joints.b2FrictionJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_linearMass=new Box2D.Common.Math.b2Mat22;this.m_linearImpulse=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchorA.SetV(a.localAnchorA);this.m_localAnchorB.SetV(a.localAnchorB);this.m_linearMass.SetZero();this.m_angularMass=0;
this.m_linearImpulse.SetZero();this.m_angularImpulse=0;this.m_maxForce=a.maxForce;this.m_maxTorque=a.maxTorque};c2inherit(Box2D.Dynamics.Joints.b2FrictionJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetAnchorA=function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchorA)};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchorB)};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetReactionForce=
function(a){void 0===a&&(a=0);return new b2Vec2(a*this.m_linearImpulse.x,a*this.m_linearImpulse.y)};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetReactionTorque=function(a){void 0===a&&(a=0);return a*this.m_angularImpulse};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.SetMaxForce=function(a){void 0===a&&(a=0);this.m_maxForce=a};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetMaxForce=function(){return this.m_maxForce};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.SetMaxTorque=function(a){void 0===
a&&(a=0);this.m_maxTorque=a};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetMaxTorque=function(){return this.m_maxTorque};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.InitVelocityConstraints=function(a){var b,c=0,d=this.m_bodyA,e=this.m_bodyB;b=d.m_xf.R;var f=this.m_localAnchorA.x-d.m_sweep.localCenter.x,g=this.m_localAnchorA.y-d.m_sweep.localCenter.y,c=b.col1.x*f+b.col2.x*g,g=b.col1.y*f+b.col2.y*g,f=c;b=e.m_xf.R;var h=this.m_localAnchorB.x-e.m_sweep.localCenter.x,l=this.m_localAnchorB.y-e.m_sweep.localCenter.y,
c=b.col1.x*h+b.col2.x*l,l=b.col1.y*h+b.col2.y*l,h=c;b=d.m_invMass;var c=e.m_invMass,k=d.m_invI,m=e.m_invI,n=new Box2D.Common.Math.b2Mat22;n.col1.x=b+c;n.col2.x=0;n.col1.y=0;n.col2.y=b+c;n.col1.x+=k*g*g;n.col2.x+=-k*f*g;n.col1.y+=-k*f*g;n.col2.y+=k*f*f;n.col1.x+=m*l*l;n.col2.x+=-m*h*l;n.col1.y+=-m*h*l;n.col2.y+=m*h*h;n.GetInverse(this.m_linearMass);this.m_angularMass=k+m;0<this.m_angularMass&&(this.m_angularMass=1/this.m_angularMass);a.warmStarting?(this.m_linearImpulse.x*=a.dtRatio,this.m_linearImpulse.y*=
a.dtRatio,this.m_angularImpulse*=a.dtRatio,a=this.m_linearImpulse,d.m_linearVelocity.x-=b*a.x,d.m_linearVelocity.y-=b*a.y,d.m_angularVelocity-=k*(f*a.y-g*a.x+this.m_angularImpulse),e.m_linearVelocity.x+=c*a.x,e.m_linearVelocity.y+=c*a.y,e.m_angularVelocity+=m*(h*a.y-l*a.x+this.m_angularImpulse)):(this.m_linearImpulse.SetZero(),this.m_angularImpulse=0)};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.SolveVelocityConstraints=function(a){var b,c=0,d=this.m_bodyA,e=this.m_bodyB,f=d.m_linearVelocity,
g=d.m_angularVelocity,h=e.m_linearVelocity,l=e.m_angularVelocity,k=d.m_invMass,m=e.m_invMass,n=d.m_invI,q=e.m_invI;b=d.m_xf.R;var p=this.m_localAnchorA.x-d.m_sweep.localCenter.x,r=this.m_localAnchorA.y-d.m_sweep.localCenter.y,c=b.col1.x*p+b.col2.x*r,r=b.col1.y*p+b.col2.y*r,p=c;b=e.m_xf.R;var s=this.m_localAnchorB.x-e.m_sweep.localCenter.x,t=this.m_localAnchorB.y-e.m_sweep.localCenter.y,c=b.col1.x*s+b.col2.x*t,t=b.col1.y*s+b.col2.y*t,s=c;b=0;var c=-this.m_angularMass*(l-g),v=this.m_angularImpulse;
b=a.dt*this.m_maxTorque;this.m_angularImpulse=Box2D.Common.Math.b2Math.Clamp(this.m_angularImpulse+c,-b,b);c=this.m_angularImpulse-v;g-=n*c;l+=q*c;b=Box2D.Common.Math.b2Math.MulMV(this.m_linearMass,Box2D.Common.Math.b2Vec2.Get(-(h.x-l*t-f.x+g*r),-(h.y+l*s-f.y-g*p)));c=this.m_linearImpulse.Copy();this.m_linearImpulse.Add(b);b=a.dt*this.m_maxForce;this.m_linearImpulse.LengthSquared()>b*b&&(this.m_linearImpulse.Normalize(),this.m_linearImpulse.Multiply(b));b=Box2D.Common.Math.b2Math.SubtractVV(this.m_linearImpulse,
c);f.x-=k*b.x;f.y-=k*b.y;g-=n*(p*b.y-r*b.x);h.x+=m*b.x;h.y+=m*b.y;l+=q*(s*b.y-t*b.x);d.m_angularVelocity=g;e.m_angularVelocity=l};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.SolvePositionConstraints=function(a){return!0};Box2D.Dynamics.Joints.b2FrictionJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_frictionJoint;this.maxTorque=this.maxForce=
0};c2inherit(Box2D.Dynamics.Joints.b2FrictionJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2FrictionJointDef.prototype.Initialize=function(a,b,c){this.bodyA=a;this.bodyB=b;this.localAnchorA.SetV(this.bodyA.GetLocalPoint(c));this.localAnchorB.SetV(this.bodyB.GetLocalPoint(c))};Box2D.Dynamics.Joints.b2FrictionJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2FrictionJoint(this)};Box2D.Dynamics.Joints.b2GearJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,
a);this.m_groundAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_groundAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_J=new Box2D.Dynamics.Joints.b2Jacobian;var b=a.joint1.m_type,c=a.joint2.m_type;this.m_prismatic2=this.m_revolute2=this.m_prismatic1=this.m_revolute1=null;var d=0,e=0;this.m_ground1=a.joint1.GetBodyA();this.m_bodyA=a.joint1.GetBodyB();b==Box2D.Dynamics.Joints.b2Joint.e_revoluteJoint?
(this.m_revolute1=a.joint1,this.m_groundAnchor1.SetV(this.m_revolute1.m_localAnchor1),this.m_localAnchor1.SetV(this.m_revolute1.m_localAnchor2),d=this.m_revolute1.GetJointAngle()):(this.m_prismatic1=a.joint1,this.m_groundAnchor1.SetV(this.m_prismatic1.m_localAnchor1),this.m_localAnchor1.SetV(this.m_prismatic1.m_localAnchor2),d=this.m_prismatic1.GetJointTranslation());this.m_ground2=a.joint2.GetBodyA();this.m_bodyB=a.joint2.GetBodyB();c==Box2D.Dynamics.Joints.b2Joint.e_revoluteJoint?(this.m_revolute2=
a.joint2,this.m_groundAnchor2.SetV(this.m_revolute2.m_localAnchor1),this.m_localAnchor2.SetV(this.m_revolute2.m_localAnchor2),e=this.m_revolute2.GetJointAngle()):(this.m_prismatic2=a.joint2,this.m_groundAnchor2.SetV(this.m_prismatic2.m_localAnchor1),this.m_localAnchor2.SetV(this.m_prismatic2.m_localAnchor2),e=this.m_prismatic2.GetJointTranslation());this.m_ratio=a.ratio;this.m_constant=d+this.m_ratio*e;this.m_impulse=0};c2inherit(Box2D.Dynamics.Joints.b2GearJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2GearJoint.prototype.GetAnchorA=
function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2GearJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2GearJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return Box2D.Common.Math.b2Vec2.Get(a*this.m_impulse*this.m_J.linearB.x,a*this.m_impulse*this.m_J.linearB.y)};Box2D.Dynamics.Joints.b2GearJoint.prototype.GetReactionTorque=function(a){void 0===a&&(a=0);var b=this.m_bodyB.m_xf.R,
c=this.m_localAnchor1.x-this.m_bodyB.m_sweep.localCenter.x,d=this.m_localAnchor1.y-this.m_bodyB.m_sweep.localCenter.y,e=b.col1.x*c+b.col2.x*d,d=b.col1.y*c+b.col2.y*d;return a*(this.m_impulse*this.m_J.angularB-e*this.m_impulse*this.m_J.linearB.y+d*this.m_impulse*this.m_J.linearB.x)};Box2D.Dynamics.Joints.b2GearJoint.prototype.GetRatio=function(){return this.m_ratio};Box2D.Dynamics.Joints.b2GearJoint.prototype.SetRatio=function(a){void 0===a&&(a=0);this.m_ratio=a};Box2D.Dynamics.Joints.b2GearJoint.prototype.InitVelocityConstraints=
function(a){var b=this.m_ground1,c=this.m_ground2,d=this.m_bodyA,e=this.m_bodyB,f=0,g=0,h=0,l=0,k=h=0,m=0;this.m_J.SetZero();this.m_revolute1?(this.m_J.angularA=-1,m+=d.m_invI):(b=b.m_xf.R,g=this.m_prismatic1.m_localXAxis1,f=b.col1.x*g.x+b.col2.x*g.y,g=b.col1.y*g.x+b.col2.y*g.y,b=d.m_xf.R,h=this.m_localAnchor1.x-d.m_sweep.localCenter.x,l=this.m_localAnchor1.y-d.m_sweep.localCenter.y,k=b.col1.x*h+b.col2.x*l,l=b.col1.y*h+b.col2.y*l,h=k*g-l*f,this.m_J.linearA.Set(-f,-g),this.m_J.angularA=-h,m+=d.m_invMass+
d.m_invI*h*h);this.m_revolute2?(this.m_J.angularB=-this.m_ratio,m+=this.m_ratio*this.m_ratio*e.m_invI):(b=c.m_xf.R,g=this.m_prismatic2.m_localXAxis1,f=b.col1.x*g.x+b.col2.x*g.y,g=b.col1.y*g.x+b.col2.y*g.y,b=e.m_xf.R,h=this.m_localAnchor2.x-e.m_sweep.localCenter.x,l=this.m_localAnchor2.y-e.m_sweep.localCenter.y,k=b.col1.x*h+b.col2.x*l,l=b.col1.y*h+b.col2.y*l,h=k*g-l*f,this.m_J.linearB.Set(-this.m_ratio*f,-this.m_ratio*g),this.m_J.angularB=-this.m_ratio*h,m+=this.m_ratio*this.m_ratio*(e.m_invMass+e.m_invI*
h*h));this.m_mass=0<m?1/m:0;a.warmStarting?(d.m_linearVelocity.x+=d.m_invMass*this.m_impulse*this.m_J.linearA.x,d.m_linearVelocity.y+=d.m_invMass*this.m_impulse*this.m_J.linearA.y,d.m_angularVelocity+=d.m_invI*this.m_impulse*this.m_J.angularA,e.m_linearVelocity.x+=e.m_invMass*this.m_impulse*this.m_J.linearB.x,e.m_linearVelocity.y+=e.m_invMass*this.m_impulse*this.m_J.linearB.y,e.m_angularVelocity+=e.m_invI*this.m_impulse*this.m_J.angularB):this.m_impulse=0};Box2D.Dynamics.Joints.b2GearJoint.prototype.SolveVelocityConstraints=
function(a){a=this.m_bodyA;var b=this.m_bodyB,c=this.m_J.Compute(a.m_linearVelocity,a.m_angularVelocity,b.m_linearVelocity,b.m_angularVelocity),c=-this.m_mass*c;this.m_impulse+=c;a.m_linearVelocity.x+=a.m_invMass*c*this.m_J.linearA.x;a.m_linearVelocity.y+=a.m_invMass*c*this.m_J.linearA.y;a.m_angularVelocity+=a.m_invI*c*this.m_J.angularA;b.m_linearVelocity.x+=b.m_invMass*c*this.m_J.linearB.x;b.m_linearVelocity.y+=b.m_invMass*c*this.m_J.linearB.y;b.m_angularVelocity+=b.m_invI*c*this.m_J.angularB};Box2D.Dynamics.Joints.b2GearJoint.prototype.SolvePositionConstraints=
function(a){a=this.m_bodyA;var b=this.m_bodyB,c=0,d=0,c=this.m_revolute1?this.m_revolute1.GetJointAngle():this.m_prismatic1.GetJointTranslation(),d=this.m_revolute2?this.m_revolute2.GetJointAngle():this.m_prismatic2.GetJointTranslation(),c=-this.m_mass*(this.m_constant-(c+this.m_ratio*d));a.m_sweep.c.x+=a.m_invMass*c*this.m_J.linearA.x;a.m_sweep.c.y+=a.m_invMass*c*this.m_J.linearA.y;a.m_sweep.a+=a.m_invI*c*this.m_J.angularA;b.m_sweep.c.x+=b.m_invMass*c*this.m_J.linearB.x;b.m_sweep.c.y+=b.m_invMass*
c*this.m_J.linearB.y;b.m_sweep.a+=b.m_invI*c*this.m_J.angularB;a.SynchronizeTransform();b.SynchronizeTransform();return 0<Box2D.Common.b2Settings.b2_linearSlop};Box2D.Dynamics.Joints.b2GearJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.type=Box2D.Dynamics.Joints.b2Joint.e_gearJoint;this.joint2=this.joint1=null;this.ratio=1};c2inherit(Box2D.Dynamics.Joints.b2GearJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2GearJointDef.prototype.Initialize=function(a,b,c){this.joint1=
a;this.bodyA=a.GetBodyA();this.joint2=b;this.bodyB=b.GetBodyA();this.ratio=c};Box2D.Dynamics.Joints.b2GearJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2GearJoint(this)};Box2D.Dynamics.Joints.b2Jacobian=function(){this.linearA=Box2D.Common.Math.b2Vec2.Get(0,0);this.linearB=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Dynamics.Joints.b2Jacobian.prototype.SetZero=function(){this.linearA.SetZero();this.angularA=0;this.linearB.SetZero();this.angularB=0};Box2D.Dynamics.Joints.b2Jacobian.prototype.Set=
function(a,b,c,d){void 0===b&&(b=0);void 0===d&&(d=0);this.linearA.SetV(a);this.angularA=b;this.linearB.SetV(c);this.angularB=d};Box2D.Dynamics.Joints.b2Jacobian.prototype.Compute=function(a,b,c,d){void 0===b&&(b=0);void 0===d&&(d=0);return this.linearA.x*a.x+this.linearA.y*a.y+this.angularA*b+(this.linearB.x*c.x+this.linearB.y*c.y)+this.angularB*d};Box2D.Dynamics.Joints.b2LineJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor2=
Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localXAxis1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localYAxis1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_axis=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_perp=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_K=new Box2D.Common.Math.b2Mat22;this.m_impulse=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor1.SetV(a.localAnchorA);this.m_localAnchor2.SetV(a.localAnchorB);this.m_localXAxis1.SetV(a.localAxisA);this.m_localYAxis1.x=-this.m_localXAxis1.y;this.m_localYAxis1.y=
this.m_localXAxis1.x;this.m_impulse.SetZero();this.m_motorImpulse=this.m_motorMass=0;this.m_lowerTranslation=a.lowerTranslation;this.m_upperTranslation=a.upperTranslation;this.m_maxMotorForce=a.maxMotorForce;this.m_motorSpeed=a.motorSpeed;this.m_enableLimit=a.enableLimit;this.m_enableMotor=a.enableMotor;this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit;this.m_axis.SetZero();this.m_perp.SetZero()};c2inherit(Box2D.Dynamics.Joints.b2LineJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2LineJoint.prototype.GetAnchorA=
function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return Box2D.Common.Math.b2Vec2.Get(a*(this.m_impulse.x*this.m_perp.x+(this.m_motorImpulse+this.m_impulse.y)*this.m_axis.x),a*(this.m_impulse.x*this.m_perp.y+(this.m_motorImpulse+this.m_impulse.y)*this.m_axis.y))};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetReactionTorque=
function(a){void 0===a&&(a=0);return a*this.m_impulse.y};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetJointTranslation=function(){var a=this.m_bodyA,b=this.m_bodyB,c=a.GetWorldPoint(this.m_localAnchor1),d=b.GetWorldPoint(this.m_localAnchor2),b=d.x-c.x,c=d.y-c.y,a=a.GetWorldVector(this.m_localXAxis1);return a.x*b+a.y*c};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetJointSpeed=function(){var a=this.m_bodyA,b=this.m_bodyB,c;c=a.m_xf.R;var d=this.m_localAnchor1.x-a.m_sweep.localCenter.x,e=this.m_localAnchor1.y-
a.m_sweep.localCenter.y,f=c.col1.x*d+c.col2.x*e,e=c.col1.y*d+c.col2.y*e,d=f;c=b.m_xf.R;var g=this.m_localAnchor2.x-b.m_sweep.localCenter.x,h=this.m_localAnchor2.y-b.m_sweep.localCenter.y,f=c.col1.x*g+c.col2.x*h,h=c.col1.y*g+c.col2.y*h,g=f;c=b.m_sweep.c.x+g-(a.m_sweep.c.x+d);var f=b.m_sweep.c.y+h-(a.m_sweep.c.y+e),l=a.GetWorldVector(this.m_localXAxis1),k=a.m_linearVelocity,m=b.m_linearVelocity,a=a.m_angularVelocity,b=b.m_angularVelocity;return c*-a*l.y+f*a*l.x+(l.x*(m.x+-b*h-k.x- -a*e)+l.y*(m.y+b*
g-k.y-a*d))};Box2D.Dynamics.Joints.b2LineJoint.prototype.IsLimitEnabled=function(){return this.m_enableLimit};Box2D.Dynamics.Joints.b2LineJoint.prototype.EnableLimit=function(a){this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_enableLimit=a};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetLowerLimit=function(){return this.m_lowerTranslation};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetUpperLimit=function(){return this.m_upperTranslation};Box2D.Dynamics.Joints.b2LineJoint.prototype.SetLimits=
function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_lowerTranslation=a;this.m_upperTranslation=b};Box2D.Dynamics.Joints.b2LineJoint.prototype.IsMotorEnabled=function(){return this.m_enableMotor};Box2D.Dynamics.Joints.b2LineJoint.prototype.EnableMotor=function(a){this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_enableMotor=a};Box2D.Dynamics.Joints.b2LineJoint.prototype.SetMotorSpeed=function(a){void 0===a&&(a=0);this.m_bodyA.SetAwake(!0);
this.m_bodyB.SetAwake(!0);this.m_motorSpeed=a};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetMotorSpeed=function(){return this.m_motorSpeed};Box2D.Dynamics.Joints.b2LineJoint.prototype.SetMaxMotorForce=function(a){void 0===a&&(a=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_maxMotorForce=a};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetMaxMotorForce=function(){return this.m_maxMotorForce};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetMotorForce=function(){return this.m_motorImpulse};
Box2D.Dynamics.Joints.b2LineJoint.prototype.InitVelocityConstraints=function(a){var b=this.m_bodyA,c=this.m_bodyB,d,e=0;this.m_localCenterA.SetV(b.GetLocalCenter());this.m_localCenterB.SetV(c.GetLocalCenter());var f=b.GetTransform();c.GetTransform();d=b.m_xf.R;var g=this.m_localAnchor1.x-this.m_localCenterA.x,h=this.m_localAnchor1.y-this.m_localCenterA.y,e=d.col1.x*g+d.col2.x*h,h=d.col1.y*g+d.col2.y*h,g=e;d=c.m_xf.R;var l=this.m_localAnchor2.x-this.m_localCenterB.x,k=this.m_localAnchor2.y-this.m_localCenterB.y,
e=d.col1.x*l+d.col2.x*k,k=d.col1.y*l+d.col2.y*k,l=e;d=c.m_sweep.c.x+l-b.m_sweep.c.x-g;e=c.m_sweep.c.y+k-b.m_sweep.c.y-h;this.m_invMassA=b.m_invMass;this.m_invMassB=c.m_invMass;this.m_invIA=b.m_invI;this.m_invIB=c.m_invI;this.m_axis.SetV(Box2D.Common.Math.b2Math.MulMV(f.R,this.m_localXAxis1));this.m_a1=(d+g)*this.m_axis.y-(e+h)*this.m_axis.x;this.m_a2=l*this.m_axis.y-k*this.m_axis.x;this.m_motorMass=this.m_invMassA+this.m_invMassB+this.m_invIA*this.m_a1*this.m_a1+this.m_invIB*this.m_a2*this.m_a2;this.m_motorMass=
this.m_motorMass>Number.MIN_VALUE?1/this.m_motorMass:0;this.m_perp.SetV(Box2D.Common.Math.b2Math.MulMV(f.R,this.m_localYAxis1));this.m_s1=(d+g)*this.m_perp.y-(e+h)*this.m_perp.x;this.m_s2=l*this.m_perp.y-k*this.m_perp.x;f=this.m_invMassA;g=this.m_invMassB;h=this.m_invIA;l=this.m_invIB;this.m_K.col1.x=f+g+h*this.m_s1*this.m_s1+l*this.m_s2*this.m_s2;this.m_K.col1.y=h*this.m_s1*this.m_a1+l*this.m_s2*this.m_a2;this.m_K.col2.x=this.m_K.col1.y;this.m_K.col2.y=f+g+h*this.m_a1*this.m_a1+l*this.m_a2*this.m_a2;
this.m_enableLimit?(d=this.m_axis.x*d+this.m_axis.y*e,Math.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*Box2D.Common.b2Settings.b2_linearSlop?this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_equalLimits:d<=this.m_lowerTranslation?this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit&&(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit,this.m_impulse.y=0):d>=this.m_upperTranslation?this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(this.m_limitState=
Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit,this.m_impulse.y=0):(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_impulse.y=0)):this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit;!1==this.m_enableMotor&&(this.m_motorImpulse=0);a.warmStarting?(this.m_impulse.x*=a.dtRatio,this.m_impulse.y*=a.dtRatio,this.m_motorImpulse*=a.dtRatio,a=this.m_impulse.x*this.m_perp.x+(this.m_motorImpulse+this.m_impulse.y)*this.m_axis.x,d=this.m_impulse.x*this.m_perp.y+(this.m_motorImpulse+
this.m_impulse.y)*this.m_axis.y,e=this.m_impulse.x*this.m_s1+(this.m_motorImpulse+this.m_impulse.y)*this.m_a1,f=this.m_impulse.x*this.m_s2+(this.m_motorImpulse+this.m_impulse.y)*this.m_a2,b.m_linearVelocity.x-=this.m_invMassA*a,b.m_linearVelocity.y-=this.m_invMassA*d,b.m_angularVelocity-=this.m_invIA*e,c.m_linearVelocity.x+=this.m_invMassB*a,c.m_linearVelocity.y+=this.m_invMassB*d,c.m_angularVelocity+=this.m_invIB*f):(this.m_impulse.SetZero(),this.m_motorImpulse=0)};Box2D.Dynamics.Joints.b2LineJoint.prototype.SolveVelocityConstraints=
function(a){var b=this.m_bodyA,c=this.m_bodyB,d=b.m_linearVelocity,e=b.m_angularVelocity,f=c.m_linearVelocity,g=c.m_angularVelocity,h=0,l=0,k=0,m=0;this.m_enableMotor&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_equalLimits&&(m=this.m_motorMass*(this.m_motorSpeed-(this.m_axis.x*(f.x-d.x)+this.m_axis.y*(f.y-d.y)+this.m_a2*g-this.m_a1*e)),h=this.m_motorImpulse,l=a.dt*this.m_maxMotorForce,this.m_motorImpulse=Box2D.Common.Math.b2Math.Clamp(this.m_motorImpulse+m,-l,l),m=this.m_motorImpulse-h,h=
m*this.m_axis.x,l=m*this.m_axis.y,k=m*this.m_a1,m*=this.m_a2,d.x-=this.m_invMassA*h,d.y-=this.m_invMassA*l,e-=this.m_invIA*k,f.x+=this.m_invMassB*h,f.y+=this.m_invMassB*l,g+=this.m_invIB*m);l=this.m_perp.x*(f.x-d.x)+this.m_perp.y*(f.y-d.y)+this.m_s2*g-this.m_s1*e;this.m_enableLimit&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit?(k=this.m_axis.x*(f.x-d.x)+this.m_axis.y*(f.y-d.y)+this.m_a2*g-this.m_a1*e,h=this.m_impulse.Copy(),a=this.m_K.Solve(Box2D.Common.Math.b2Vec2.Get(0,0),-l,
-k),this.m_impulse.Add(a),this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit?this.m_impulse.y=Math.max(this.m_impulse.y,0):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(this.m_impulse.y=Math.min(this.m_impulse.y,0)),l=-l-(this.m_impulse.y-h.y)*this.m_K.col2.x,k=0,k=0!=this.m_K.col1.x?l/this.m_K.col1.x+h.x:h.x,this.m_impulse.x=k,a.x=this.m_impulse.x-h.x,a.y=this.m_impulse.y-h.y,h=a.x*this.m_perp.x+a.y*this.m_axis.x,l=a.x*this.m_perp.y+a.y*this.m_axis.y,k=a.x*this.m_s1+
a.y*this.m_a1,m=a.x*this.m_s2+a.y*this.m_a2):(a=0,a=0!=this.m_K.col1.x?-l/this.m_K.col1.x:0,this.m_impulse.x+=a,h=a*this.m_perp.x,l=a*this.m_perp.y,k=a*this.m_s1,m=a*this.m_s2);d.x-=this.m_invMassA*h;d.y-=this.m_invMassA*l;e-=this.m_invIA*k;f.x+=this.m_invMassB*h;f.y+=this.m_invMassB*l;g+=this.m_invIB*m;b.m_linearVelocity.SetV(d);b.m_angularVelocity=e;c.m_linearVelocity.SetV(f);c.m_angularVelocity=g};Box2D.Dynamics.Joints.b2LineJoint.prototype.SolvePositionConstraints=function(a){a=this.m_bodyA;var b=
this.m_bodyB,c=a.m_sweep.c,d=a.m_sweep.a,e=b.m_sweep.c,f=b.m_sweep.a,g,h=0,l=0,k=0,m=0,n=g=0,q=0,l=!1,p=0,r=Box2D.Common.Math.b2Mat22.FromAngle(d),k=Box2D.Common.Math.b2Mat22.FromAngle(f);g=r;var q=this.m_localAnchor1.x-this.m_localCenterA.x,s=this.m_localAnchor1.y-this.m_localCenterA.y,h=g.col1.x*q+g.col2.x*s,s=g.col1.y*q+g.col2.y*s,q=h;g=k;k=this.m_localAnchor2.x-this.m_localCenterB.x;m=this.m_localAnchor2.y-this.m_localCenterB.y;h=g.col1.x*k+g.col2.x*m;m=g.col1.y*k+g.col2.y*m;k=h;g=e.x+k-c.x-q;
h=e.y+m-c.y-s;if(this.m_enableLimit){this.m_axis=Box2D.Common.Math.b2Math.MulMV(r,this.m_localXAxis1);this.m_a1=(g+q)*this.m_axis.y-(h+s)*this.m_axis.x;this.m_a2=k*this.m_axis.y-m*this.m_axis.x;var t=this.m_axis.x*g+this.m_axis.y*h;Math.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*Box2D.Common.b2Settings.b2_linearSlop?(p=Box2D.Common.Math.b2Math.Clamp(t,-Box2D.Common.b2Settings.b2_maxLinearCorrection,Box2D.Common.b2Settings.b2_maxLinearCorrection),n=Math.abs(t),l=!0):t<=this.m_lowerTranslation?
(p=Box2D.Common.Math.b2Math.Clamp(t-this.m_lowerTranslation+Box2D.Common.b2Settings.b2_linearSlop,-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),n=this.m_lowerTranslation-t,l=!0):t>=this.m_upperTranslation&&(p=Box2D.Common.Math.b2Math.Clamp(t-this.m_upperTranslation+Box2D.Common.b2Settings.b2_linearSlop,0,Box2D.Common.b2Settings.b2_maxLinearCorrection),n=t-this.m_upperTranslation,l=!0)}this.m_perp=Box2D.Common.Math.b2Math.MulMV(r,this.m_localYAxis1);this.m_s1=(g+q)*this.m_perp.y-(h+s)*this.m_perp.x;
this.m_s2=k*this.m_perp.y-m*this.m_perp.x;r=Box2D.Common.Math.b2Vec2.Get(0,0);s=this.m_perp.x*g+this.m_perp.y*h;n=Math.max(n,Math.abs(s));q=0;l?(l=this.m_invMassA,k=this.m_invMassB,m=this.m_invIA,g=this.m_invIB,this.m_K.col1.x=l+k+m*this.m_s1*this.m_s1+g*this.m_s2*this.m_s2,this.m_K.col1.y=m*this.m_s1*this.m_a1+g*this.m_s2*this.m_a2,this.m_K.col2.x=this.m_K.col1.y,this.m_K.col2.y=l+k+m*this.m_a1*this.m_a1+g*this.m_a2*this.m_a2,this.m_K.Solve(r,-s,-p)):(l=this.m_invMassA,k=this.m_invMassB,m=this.m_invIA,
g=this.m_invIB,p=l+k+m*this.m_s1*this.m_s1+g*this.m_s2*this.m_s2,r.x=0!=p?-s/p:0,r.y=0);p=r.x*this.m_perp.x+r.y*this.m_axis.x;l=r.x*this.m_perp.y+r.y*this.m_axis.y;s=r.x*this.m_s1+r.y*this.m_a1;r=r.x*this.m_s2+r.y*this.m_a2;c.x-=this.m_invMassA*p;c.y-=this.m_invMassA*l;d-=this.m_invIA*s;e.x+=this.m_invMassB*p;e.y+=this.m_invMassB*l;f+=this.m_invIB*r;a.m_sweep.a=d;b.m_sweep.a=f;a.SynchronizeTransform();b.SynchronizeTransform();return n<=Box2D.Common.b2Settings.b2_linearSlop&&q<=Box2D.Common.b2Settings.b2_angularSlop};
Box2D.Dynamics.Joints.b2LineJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAxisA=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_lineJoint;this.localAxisA.Set(1,0);this.enableLimit=!1;this.upperTranslation=this.lowerTranslation=0;this.enableMotor=!1;this.motorSpeed=this.maxMotorForce=0};c2inherit(Box2D.Dynamics.Joints.b2LineJointDef,Box2D.Dynamics.Joints.b2JointDef);
Box2D.Dynamics.Joints.b2LineJointDef.prototype.Initialize=function(a,b,c,d){this.bodyA=a;this.bodyB=b;this.localAnchorA=this.bodyA.GetLocalPoint(c);this.localAnchorB=this.bodyB.GetLocalPoint(c);this.localAxisA=this.bodyA.GetLocalVector(d)};Box2D.Dynamics.Joints.b2LineJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2LineJoint(this)};Box2D.Dynamics.Joints.b2PrismaticJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,
0);this.m_localAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localXAxis1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localYAxis1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_axis=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_perp=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_K=new Box2D.Common.Math.b2Mat33;this.m_impulse=new Box2D.Common.Math.b2Vec3(0,0,0);this.m_localAnchor1.SetV(a.localAnchorA);this.m_localAnchor2.SetV(a.localAnchorB);this.m_localXAxis1.SetV(a.localAxisA);this.m_localYAxis1.x=-this.m_localXAxis1.y;
this.m_localYAxis1.y=this.m_localXAxis1.x;this.m_refAngle=a.referenceAngle;this.m_impulse.SetZero();this.m_motorImpulse=this.m_motorMass=0;this.m_lowerTranslation=a.lowerTranslation;this.m_upperTranslation=a.upperTranslation;this.m_maxMotorForce=a.maxMotorForce;this.m_motorSpeed=a.motorSpeed;this.m_enableLimit=a.enableLimit;this.m_enableMotor=a.enableMotor;this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit;this.m_axis.SetZero();this.m_perp.SetZero()};c2inherit(Box2D.Dynamics.Joints.b2PrismaticJoint,
Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetAnchorA=function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return Box2D.Common.Math.b2Vec2.Get(a*(this.m_impulse.x*this.m_perp.x+(this.m_motorImpulse+this.m_impulse.z)*this.m_axis.x),
a*(this.m_impulse.x*this.m_perp.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_axis.y))};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetReactionTorque=function(a){void 0===a&&(a=0);return a*this.m_impulse.y};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetJointTranslation=function(){var a=this.m_bodyA,b=this.m_bodyB,c=a.GetWorldPoint(this.m_localAnchor1),d=b.GetWorldPoint(this.m_localAnchor2),b=d.x-c.x,c=d.y-c.y,a=a.GetWorldVector(this.m_localXAxis1);return a.x*b+a.y*c};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetJointSpeed=
function(){var a=this.m_bodyA,b=this.m_bodyB,c;c=a.m_xf.R;var d=this.m_localAnchor1.x-a.m_sweep.localCenter.x,e=this.m_localAnchor1.y-a.m_sweep.localCenter.y,f=c.col1.x*d+c.col2.x*e,e=c.col1.y*d+c.col2.y*e,d=f;c=b.m_xf.R;var g=this.m_localAnchor2.x-b.m_sweep.localCenter.x,h=this.m_localAnchor2.y-b.m_sweep.localCenter.y,f=c.col1.x*g+c.col2.x*h,h=c.col1.y*g+c.col2.y*h,g=f;c=b.m_sweep.c.x+g-(a.m_sweep.c.x+d);var f=b.m_sweep.c.y+h-(a.m_sweep.c.y+e),l=a.GetWorldVector(this.m_localXAxis1),k=a.m_linearVelocity,
m=b.m_linearVelocity,a=a.m_angularVelocity,b=b.m_angularVelocity;return c*-a*l.y+f*a*l.x+(l.x*(m.x+-b*h-k.x- -a*e)+l.y*(m.y+b*g-k.y-a*d))};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.IsLimitEnabled=function(){return this.m_enableLimit};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.EnableLimit=function(a){this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_enableLimit=a};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetLowerLimit=function(){return this.m_lowerTranslation};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetUpperLimit=
function(){return this.m_upperTranslation};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.SetLimits=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_lowerTranslation=a;this.m_upperTranslation=b};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.IsMotorEnabled=function(){return this.m_enableMotor};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.EnableMotor=function(a){this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_enableMotor=
a};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.SetMotorSpeed=function(a){void 0===a&&(a=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_motorSpeed=a};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetMotorSpeed=function(){return this.m_motorSpeed};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.SetMaxMotorForce=function(a){void 0===a&&(a=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_maxMotorForce=a};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetMotorForce=
function(){return this.m_motorImpulse};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.InitVelocityConstraints=function(a){var b=this.m_bodyA,c=this.m_bodyB,d,e=0;this.m_localCenterA.SetV(b.GetLocalCenter());this.m_localCenterB.SetV(c.GetLocalCenter());var f=b.GetTransform();c.GetTransform();d=b.m_xf.R;var g=this.m_localAnchor1.x-this.m_localCenterA.x,h=this.m_localAnchor1.y-this.m_localCenterA.y,e=d.col1.x*g+d.col2.x*h,h=d.col1.y*g+d.col2.y*h,g=e;d=c.m_xf.R;var l=this.m_localAnchor2.x-this.m_localCenterB.x,
k=this.m_localAnchor2.y-this.m_localCenterB.y,e=d.col1.x*l+d.col2.x*k,k=d.col1.y*l+d.col2.y*k,l=e;d=c.m_sweep.c.x+l-b.m_sweep.c.x-g;e=c.m_sweep.c.y+k-b.m_sweep.c.y-h;this.m_invMassA=b.m_invMass;this.m_invMassB=c.m_invMass;this.m_invIA=b.m_invI;this.m_invIB=c.m_invI;this.m_axis.SetV(Box2D.Common.Math.b2Math.MulMV(f.R,this.m_localXAxis1));this.m_a1=(d+g)*this.m_axis.y-(e+h)*this.m_axis.x;this.m_a2=l*this.m_axis.y-k*this.m_axis.x;this.m_motorMass=this.m_invMassA+this.m_invMassB+this.m_invIA*this.m_a1*
this.m_a1+this.m_invIB*this.m_a2*this.m_a2;this.m_motorMass>Number.MIN_VALUE&&(this.m_motorMass=1/this.m_motorMass);this.m_perp.SetV(Box2D.Common.Math.b2Math.MulMV(f.R,this.m_localYAxis1));this.m_s1=(d+g)*this.m_perp.y-(e+h)*this.m_perp.x;this.m_s2=l*this.m_perp.y-k*this.m_perp.x;f=this.m_invMassA;g=this.m_invMassB;h=this.m_invIA;l=this.m_invIB;this.m_K.col1.x=f+g+h*this.m_s1*this.m_s1+l*this.m_s2*this.m_s2;this.m_K.col1.y=h*this.m_s1+l*this.m_s2;this.m_K.col1.z=h*this.m_s1*this.m_a1+l*this.m_s2*
this.m_a2;this.m_K.col2.x=this.m_K.col1.y;this.m_K.col2.y=h+l;this.m_K.col2.z=h*this.m_a1+l*this.m_a2;this.m_K.col3.x=this.m_K.col1.z;this.m_K.col3.y=this.m_K.col2.z;this.m_K.col3.z=f+g+h*this.m_a1*this.m_a1+l*this.m_a2*this.m_a2;this.m_enableLimit?(d=this.m_axis.x*d+this.m_axis.y*e,Math.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*Box2D.Common.b2Settings.b2_linearSlop?this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_equalLimits:d<=this.m_lowerTranslation?this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit&&
(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit,this.m_impulse.z=0):d>=this.m_upperTranslation?this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit,this.m_impulse.z=0):(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_impulse.z=0)):this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit;!1==this.m_enableMotor&&(this.m_motorImpulse=0);a.warmStarting?(this.m_impulse.x*=a.dtRatio,
this.m_impulse.y*=a.dtRatio,this.m_motorImpulse*=a.dtRatio,a=this.m_impulse.x*this.m_perp.x+(this.m_motorImpulse+this.m_impulse.z)*this.m_axis.x,d=this.m_impulse.x*this.m_perp.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_axis.y,e=this.m_impulse.x*this.m_s1+this.m_impulse.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_a1,f=this.m_impulse.x*this.m_s2+this.m_impulse.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_a2,b.m_linearVelocity.x-=this.m_invMassA*a,b.m_linearVelocity.y-=this.m_invMassA*d,
b.m_angularVelocity-=this.m_invIA*e,c.m_linearVelocity.x+=this.m_invMassB*a,c.m_linearVelocity.y+=this.m_invMassB*d,c.m_angularVelocity+=this.m_invIB*f):(this.m_impulse.SetZero(),this.m_motorImpulse=0)};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.SolveVelocityConstraints=function(a){var b=this.m_bodyA,c=this.m_bodyB,d=b.m_linearVelocity,e=b.m_angularVelocity,f=c.m_linearVelocity,g=c.m_angularVelocity,h=0,l=0,k=0,m=0;this.m_enableMotor&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_equalLimits&&
(m=this.m_motorMass*(this.m_motorSpeed-(this.m_axis.x*(f.x-d.x)+this.m_axis.y*(f.y-d.y)+this.m_a2*g-this.m_a1*e)),h=this.m_motorImpulse,a=a.dt*this.m_maxMotorForce,this.m_motorImpulse=Box2D.Common.Math.b2Math.Clamp(this.m_motorImpulse+m,-a,a),m=this.m_motorImpulse-h,h=m*this.m_axis.x,l=m*this.m_axis.y,k=m*this.m_a1,m*=this.m_a2,d.x-=this.m_invMassA*h,d.y-=this.m_invMassA*l,e-=this.m_invIA*k,f.x+=this.m_invMassB*h,f.y+=this.m_invMassB*l,g+=this.m_invIB*m);k=this.m_perp.x*(f.x-d.x)+this.m_perp.y*(f.y-
d.y)+this.m_s2*g-this.m_s1*e;l=g-e;this.m_enableLimit&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit?(a=this.m_axis.x*(f.x-d.x)+this.m_axis.y*(f.y-d.y)+this.m_a2*g-this.m_a1*e,h=this.m_impulse.Copy(),a=this.m_K.Solve33(new Box2D.Common.Math.b2Vec3(0,0,0),-k,-l,-a),this.m_impulse.Add(a),this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit?this.m_impulse.z=Math.max(this.m_impulse.z,0):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(this.m_impulse.z=Math.min(this.m_impulse.z,
0)),k=-k-(this.m_impulse.z-h.z)*this.m_K.col3.x,l=-l-(this.m_impulse.z-h.z)*this.m_K.col3.y,l=this.m_K.Solve22(Box2D.Common.Math.b2Vec2.Get(0,0),k,l),l.x+=h.x,l.y+=h.y,this.m_impulse.x=l.x,this.m_impulse.y=l.y,a.x=this.m_impulse.x-h.x,a.y=this.m_impulse.y-h.y,a.z=this.m_impulse.z-h.z,h=a.x*this.m_perp.x+a.z*this.m_axis.x,l=a.x*this.m_perp.y+a.z*this.m_axis.y,k=a.x*this.m_s1+a.y+a.z*this.m_a1,m=a.x*this.m_s2+a.y+a.z*this.m_a2):(a=this.m_K.Solve22(Box2D.Common.Math.b2Vec2.Get(0,0),-k,-l),this.m_impulse.x+=
a.x,this.m_impulse.y+=a.y,h=a.x*this.m_perp.x,l=a.x*this.m_perp.y,k=a.x*this.m_s1+a.y,m=a.x*this.m_s2+a.y);d.x-=this.m_invMassA*h;d.y-=this.m_invMassA*l;e-=this.m_invIA*k;f.x+=this.m_invMassB*h;f.y+=this.m_invMassB*l;g+=this.m_invIB*m;b.m_linearVelocity.SetV(d);b.m_angularVelocity=e;c.m_linearVelocity.SetV(f);c.m_angularVelocity=g};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.SolvePositionConstraints=function(a){a=this.m_bodyA;var b=this.m_bodyB,c=a.m_sweep.c,d=a.m_sweep.a,e=b.m_sweep.c,f=b.m_sweep.a,
g,h=0,l=0,k=0,m=h=g=0,n=0,l=!1,q=0,p=Box2D.Common.Math.b2Mat22.FromAngle(d),r=Box2D.Common.Math.b2Mat22.FromAngle(f);g=p;var n=this.m_localAnchor1.x-this.m_localCenterA.x,s=this.m_localAnchor1.y-this.m_localCenterA.y,h=g.col1.x*n+g.col2.x*s,s=g.col1.y*n+g.col2.y*s,n=h;g=r;r=this.m_localAnchor2.x-this.m_localCenterB.x;k=this.m_localAnchor2.y-this.m_localCenterB.y;h=g.col1.x*r+g.col2.x*k;k=g.col1.y*r+g.col2.y*k;r=h;g=e.x+r-c.x-n;h=e.y+k-c.y-s;if(this.m_enableLimit){this.m_axis=Box2D.Common.Math.b2Math.MulMV(p,
this.m_localXAxis1);this.m_a1=(g+n)*this.m_axis.y-(h+s)*this.m_axis.x;this.m_a2=r*this.m_axis.y-k*this.m_axis.x;var t=this.m_axis.x*g+this.m_axis.y*h;Math.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*Box2D.Common.b2Settings.b2_linearSlop?(q=Box2D.Common.Math.b2Math.Clamp(t,-Box2D.Common.b2Settings.b2_maxLinearCorrection,Box2D.Common.b2Settings.b2_maxLinearCorrection),m=Math.abs(t),l=!0):t<=this.m_lowerTranslation?(q=Box2D.Common.Math.b2Math.Clamp(t-this.m_lowerTranslation+Box2D.Common.b2Settings.b2_linearSlop,
-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),m=this.m_lowerTranslation-t,l=!0):t>=this.m_upperTranslation&&(q=Box2D.Common.Math.b2Math.Clamp(t-this.m_upperTranslation+Box2D.Common.b2Settings.b2_linearSlop,0,Box2D.Common.b2Settings.b2_maxLinearCorrection),m=t-this.m_upperTranslation,l=!0)}this.m_perp=Box2D.Common.Math.b2Math.MulMV(p,this.m_localYAxis1);this.m_s1=(g+n)*this.m_perp.y-(h+s)*this.m_perp.x;this.m_s2=r*this.m_perp.y-k*this.m_perp.x;p=new Box2D.Common.Math.b2Vec3(0,0,0);s=this.m_perp.x*
g+this.m_perp.y*h;r=f-d-this.m_refAngle;m=Math.max(m,Math.abs(s));n=Math.abs(r);l?(l=this.m_invMassA,k=this.m_invMassB,g=this.m_invIA,h=this.m_invIB,this.m_K.col1.x=l+k+g*this.m_s1*this.m_s1+h*this.m_s2*this.m_s2,this.m_K.col1.y=g*this.m_s1+h*this.m_s2,this.m_K.col1.z=g*this.m_s1*this.m_a1+h*this.m_s2*this.m_a2,this.m_K.col2.x=this.m_K.col1.y,this.m_K.col2.y=g+h,this.m_K.col2.z=g*this.m_a1+h*this.m_a2,this.m_K.col3.x=this.m_K.col1.z,this.m_K.col3.y=this.m_K.col2.z,this.m_K.col3.z=l+k+g*this.m_a1*
this.m_a1+h*this.m_a2*this.m_a2,this.m_K.Solve33(p,-s,-r,-q)):(l=this.m_invMassA,k=this.m_invMassB,g=this.m_invIA,h=this.m_invIB,q=g*this.m_s1+h*this.m_s2,t=g+h,this.m_K.col1.Set(l+k+g*this.m_s1*this.m_s1+h*this.m_s2*this.m_s2,q,0),this.m_K.col2.Set(q,t,0),q=this.m_K.Solve22(Box2D.Common.Math.b2Vec2.Get(0,0),-s,-r),p.x=q.x,p.y=q.y,p.z=0);q=p.x*this.m_perp.x+p.z*this.m_axis.x;l=p.x*this.m_perp.y+p.z*this.m_axis.y;s=p.x*this.m_s1+p.y+p.z*this.m_a1;p=p.x*this.m_s2+p.y+p.z*this.m_a2;c.x-=this.m_invMassA*
q;c.y-=this.m_invMassA*l;d-=this.m_invIA*s;e.x+=this.m_invMassB*q;e.y+=this.m_invMassB*l;f+=this.m_invIB*p;a.m_sweep.a=d;b.m_sweep.a=f;a.SynchronizeTransform();b.SynchronizeTransform();return m<=Box2D.Common.b2Settings.b2_linearSlop&&n<=Box2D.Common.b2Settings.b2_angularSlop};Box2D.Dynamics.Joints.b2PrismaticJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAxisA=Box2D.Common.Math.b2Vec2.Get(0,
0);this.type=Box2D.Dynamics.Joints.b2Joint.e_prismaticJoint;this.localAxisA.Set(1,0);this.referenceAngle=0;this.enableLimit=!1;this.upperTranslation=this.lowerTranslation=0;this.enableMotor=!1;this.motorSpeed=this.maxMotorForce=0};c2inherit(Box2D.Dynamics.Joints.b2PrismaticJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2PrismaticJointDef.prototype.Initialize=function(a,b,c,d){this.bodyA=a;this.bodyB=b;this.localAnchorA=this.bodyA.GetLocalPoint(c);this.localAnchorB=this.bodyB.GetLocalPoint(c);
this.localAxisA=this.bodyA.GetLocalVector(d);this.referenceAngle=this.bodyB.GetAngle()-this.bodyA.GetAngle()};Box2D.Dynamics.Joints.b2PrismaticJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2PrismaticJoint(this)};Box2D.Dynamics.Joints.b2PulleyJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_groundAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_groundAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor2=
Box2D.Common.Math.b2Vec2.Get(0,0);this.m_u1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_u2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_ground=this.m_bodyA.m_world.m_groundBody;this.m_groundAnchor1.x=a.groundAnchorA.x-this.m_ground.m_xf.position.x;this.m_groundAnchor1.y=a.groundAnchorA.y-this.m_ground.m_xf.position.y;this.m_groundAnchor2.x=a.groundAnchorB.x-this.m_ground.m_xf.position.x;this.m_groundAnchor2.y=a.groundAnchorB.y-this.m_ground.m_xf.position.y;this.m_localAnchor1.SetV(a.localAnchorA);this.m_localAnchor2.SetV(a.localAnchorB);
this.m_ratio=a.ratio;this.m_constant=a.lengthA+this.m_ratio*a.lengthB;this.m_maxLength1=Math.min(a.maxLengthA,this.m_constant-this.m_ratio*Box2D.Dynamics.Joints.b2PulleyJoint.b2_minPulleyLength);this.m_maxLength2=Math.min(a.maxLengthB,(this.m_constant-Box2D.Dynamics.Joints.b2PulleyJoint.b2_minPulleyLength)/this.m_ratio);this.m_limitImpulse2=this.m_limitImpulse1=this.m_impulse=0};c2inherit(Box2D.Dynamics.Joints.b2PulleyJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetAnchorA=
function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return Box2D.Common.Math.b2Vec2.Get(a*this.m_impulse*this.m_u2.x,a*this.m_impulse*this.m_u2.y)};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetReactionTorque=function(a){return 0};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetGroundAnchorA=
function(){var a=this.m_ground.m_xf.position.Copy();a.Add(this.m_groundAnchor1);return a};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetGroundAnchorB=function(){var a=this.m_ground.m_xf.position.Copy();a.Add(this.m_groundAnchor2);return a};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetLength1=function(){var a=this.m_bodyA.GetWorldPoint(this.m_localAnchor1),b=a.x-(this.m_ground.m_xf.position.x+this.m_groundAnchor1.x),a=a.y-(this.m_ground.m_xf.position.y+this.m_groundAnchor1.y);return Math.sqrt(b*
b+a*a)};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetLength2=function(){var a=this.m_bodyB.GetWorldPoint(this.m_localAnchor2),b=a.x-(this.m_ground.m_xf.position.x+this.m_groundAnchor2.x),a=a.y-(this.m_ground.m_xf.position.y+this.m_groundAnchor2.y);return Math.sqrt(b*b+a*a)};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetRatio=function(){return this.m_ratio};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.InitVelocityConstraints=function(a){var b=this.m_bodyA,c=this.m_bodyB,d;d=b.m_xf.R;var e=
this.m_localAnchor1.x-b.m_sweep.localCenter.x,f=this.m_localAnchor1.y-b.m_sweep.localCenter.y,g=d.col1.x*e+d.col2.x*f,f=d.col1.y*e+d.col2.y*f,e=g;d=c.m_xf.R;var h=this.m_localAnchor2.x-c.m_sweep.localCenter.x,l=this.m_localAnchor2.y-c.m_sweep.localCenter.y,g=d.col1.x*h+d.col2.x*l,l=d.col1.y*h+d.col2.y*l,h=g;d=c.m_sweep.c.x+h;var g=c.m_sweep.c.y+l,k=this.m_ground.m_xf.position.x+this.m_groundAnchor2.x,m=this.m_ground.m_xf.position.y+this.m_groundAnchor2.y;this.m_u1.Set(b.m_sweep.c.x+e-(this.m_ground.m_xf.position.x+
this.m_groundAnchor1.x),b.m_sweep.c.y+f-(this.m_ground.m_xf.position.y+this.m_groundAnchor1.y));this.m_u2.Set(d-k,g-m);d=this.m_u1.Length();g=this.m_u2.Length();d>Box2D.Common.b2Settings.b2_linearSlop?this.m_u1.Multiply(1/d):this.m_u1.SetZero();g>Box2D.Common.b2Settings.b2_linearSlop?this.m_u2.Multiply(1/g):this.m_u2.SetZero();0<this.m_constant-d-this.m_ratio*g?(this.m_state=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_impulse=0):this.m_state=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit;d<
this.m_maxLength1?(this.m_limitState1=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_limitImpulse1=0):this.m_limitState1=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit;g<this.m_maxLength2?(this.m_limitState2=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_limitImpulse2=0):this.m_limitState2=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit;d=e*this.m_u1.y-f*this.m_u1.x;g=h*this.m_u2.y-l*this.m_u2.x;this.m_limitMass1=b.m_invMass+b.m_invI*d*d;this.m_limitMass2=c.m_invMass+c.m_invI*g*g;this.m_pulleyMass=
this.m_limitMass1+this.m_ratio*this.m_ratio*this.m_limitMass2;this.m_limitMass1=1/this.m_limitMass1;this.m_limitMass2=1/this.m_limitMass2;this.m_pulleyMass=1/this.m_pulleyMass;a.warmStarting?(this.m_impulse*=a.dtRatio,this.m_limitImpulse1*=a.dtRatio,this.m_limitImpulse2*=a.dtRatio,a=(-this.m_impulse-this.m_limitImpulse1)*this.m_u1.x,d=(-this.m_impulse-this.m_limitImpulse1)*this.m_u1.y,g=(-this.m_ratio*this.m_impulse-this.m_limitImpulse2)*this.m_u2.x,k=(-this.m_ratio*this.m_impulse-this.m_limitImpulse2)*
this.m_u2.y,b.m_linearVelocity.x+=b.m_invMass*a,b.m_linearVelocity.y+=b.m_invMass*d,b.m_angularVelocity+=b.m_invI*(e*d-f*a),c.m_linearVelocity.x+=c.m_invMass*g,c.m_linearVelocity.y+=c.m_invMass*k,c.m_angularVelocity+=c.m_invI*(h*k-l*g)):this.m_limitImpulse2=this.m_limitImpulse1=this.m_impulse=0};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.SolveVelocityConstraints=function(a){a=this.m_bodyA;var b=this.m_bodyB,c;c=a.m_xf.R;var d=this.m_localAnchor1.x-a.m_sweep.localCenter.x,e=this.m_localAnchor1.y-
a.m_sweep.localCenter.y,f=c.col1.x*d+c.col2.x*e,e=c.col1.y*d+c.col2.y*e,d=f;c=b.m_xf.R;var g=this.m_localAnchor2.x-b.m_sweep.localCenter.x,h=this.m_localAnchor2.y-b.m_sweep.localCenter.y,f=c.col1.x*g+c.col2.x*h,h=c.col1.y*g+c.col2.y*h,g=f,l=f=c=0,k=0;c=k=c=k=l=f=c=0;this.m_state==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(c=a.m_linearVelocity.x+-a.m_angularVelocity*e,f=a.m_linearVelocity.y+a.m_angularVelocity*d,l=b.m_linearVelocity.x+-b.m_angularVelocity*h,k=b.m_linearVelocity.y+b.m_angularVelocity*
g,c=-(this.m_u1.x*c+this.m_u1.y*f)-this.m_ratio*(this.m_u2.x*l+this.m_u2.y*k),k=this.m_pulleyMass*-c,c=this.m_impulse,this.m_impulse=Math.max(0,this.m_impulse+k),k=this.m_impulse-c,c=-k*this.m_u1.x,f=-k*this.m_u1.y,l=-this.m_ratio*k*this.m_u2.x,k=-this.m_ratio*k*this.m_u2.y,a.m_linearVelocity.x+=a.m_invMass*c,a.m_linearVelocity.y+=a.m_invMass*f,a.m_angularVelocity+=a.m_invI*(d*f-e*c),b.m_linearVelocity.x+=b.m_invMass*l,b.m_linearVelocity.y+=b.m_invMass*k,b.m_angularVelocity+=b.m_invI*(g*k-h*l));this.m_limitState1==
Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(c=a.m_linearVelocity.x+-a.m_angularVelocity*e,f=a.m_linearVelocity.y+a.m_angularVelocity*d,c=-(this.m_u1.x*c+this.m_u1.y*f),k=-this.m_limitMass1*c,c=this.m_limitImpulse1,this.m_limitImpulse1=Math.max(0,this.m_limitImpulse1+k),k=this.m_limitImpulse1-c,c=-k*this.m_u1.x,f=-k*this.m_u1.y,a.m_linearVelocity.x+=a.m_invMass*c,a.m_linearVelocity.y+=a.m_invMass*f,a.m_angularVelocity+=a.m_invI*(d*f-e*c));this.m_limitState2==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&
(l=b.m_linearVelocity.x+-b.m_angularVelocity*h,k=b.m_linearVelocity.y+b.m_angularVelocity*g,c=-(this.m_u2.x*l+this.m_u2.y*k),k=-this.m_limitMass2*c,c=this.m_limitImpulse2,this.m_limitImpulse2=Math.max(0,this.m_limitImpulse2+k),k=this.m_limitImpulse2-c,l=-k*this.m_u2.x,k=-k*this.m_u2.y,b.m_linearVelocity.x+=b.m_invMass*l,b.m_linearVelocity.y+=b.m_invMass*k,b.m_angularVelocity+=b.m_invI*(g*k-h*l))};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.SolvePositionConstraints=function(a){a=this.m_bodyA;var b=
this.m_bodyB,c,d=this.m_ground.m_xf.position.x+this.m_groundAnchor1.x,e=this.m_ground.m_xf.position.y+this.m_groundAnchor1.y,f=this.m_ground.m_xf.position.x+this.m_groundAnchor2.x,g=this.m_ground.m_xf.position.y+this.m_groundAnchor2.y,h=0,l=0,k=0,m=0,n=c=0,q=0,p=0,r=n=p=c=n=c=0;this.m_state==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(c=a.m_xf.R,h=this.m_localAnchor1.x-a.m_sweep.localCenter.x,l=this.m_localAnchor1.y-a.m_sweep.localCenter.y,n=c.col1.x*h+c.col2.x*l,l=c.col1.y*h+c.col2.y*l,h=n,c=
b.m_xf.R,k=this.m_localAnchor2.x-b.m_sweep.localCenter.x,m=this.m_localAnchor2.y-b.m_sweep.localCenter.y,n=c.col1.x*k+c.col2.x*m,m=c.col1.y*k+c.col2.y*m,k=n,c=a.m_sweep.c.x+h,n=a.m_sweep.c.y+l,q=b.m_sweep.c.x+k,p=b.m_sweep.c.y+m,this.m_u1.Set(c-d,n-e),this.m_u2.Set(q-f,p-g),c=this.m_u1.Length(),n=this.m_u2.Length(),c>Box2D.Common.b2Settings.b2_linearSlop?this.m_u1.Multiply(1/c):this.m_u1.SetZero(),n>Box2D.Common.b2Settings.b2_linearSlop?this.m_u2.Multiply(1/n):this.m_u2.SetZero(),c=this.m_constant-
c-this.m_ratio*n,r=Math.max(r,-c),c=Box2D.Common.Math.b2Math.Clamp(c+Box2D.Common.b2Settings.b2_linearSlop,-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),p=-this.m_pulleyMass*c,c=-p*this.m_u1.x,n=-p*this.m_u1.y,q=-this.m_ratio*p*this.m_u2.x,p=-this.m_ratio*p*this.m_u2.y,a.m_sweep.c.x+=a.m_invMass*c,a.m_sweep.c.y+=a.m_invMass*n,a.m_sweep.a+=a.m_invI*(h*n-l*c),b.m_sweep.c.x+=b.m_invMass*q,b.m_sweep.c.y+=b.m_invMass*p,b.m_sweep.a+=b.m_invI*(k*p-m*q),a.SynchronizeTransform(),b.SynchronizeTransform());
this.m_limitState1==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(c=a.m_xf.R,h=this.m_localAnchor1.x-a.m_sweep.localCenter.x,l=this.m_localAnchor1.y-a.m_sweep.localCenter.y,n=c.col1.x*h+c.col2.x*l,l=c.col1.y*h+c.col2.y*l,h=n,c=a.m_sweep.c.x+h,n=a.m_sweep.c.y+l,this.m_u1.Set(c-d,n-e),c=this.m_u1.Length(),c>Box2D.Common.b2Settings.b2_linearSlop?(this.m_u1.x*=1/c,this.m_u1.y*=1/c):this.m_u1.SetZero(),c=this.m_maxLength1-c,r=Math.max(r,-c),c=Box2D.Common.Math.b2Math.Clamp(c+Box2D.Common.b2Settings.b2_linearSlop,
-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),p=-this.m_limitMass1*c,c=-p*this.m_u1.x,n=-p*this.m_u1.y,a.m_sweep.c.x+=a.m_invMass*c,a.m_sweep.c.y+=a.m_invMass*n,a.m_sweep.a+=a.m_invI*(h*n-l*c),a.SynchronizeTransform());this.m_limitState2==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(c=b.m_xf.R,k=this.m_localAnchor2.x-b.m_sweep.localCenter.x,m=this.m_localAnchor2.y-b.m_sweep.localCenter.y,n=c.col1.x*k+c.col2.x*m,m=c.col1.y*k+c.col2.y*m,k=n,q=b.m_sweep.c.x+k,p=b.m_sweep.c.y+m,this.m_u2.Set(q-
f,p-g),n=this.m_u2.Length(),n>Box2D.Common.b2Settings.b2_linearSlop?(this.m_u2.x*=1/n,this.m_u2.y*=1/n):this.m_u2.SetZero(),c=this.m_maxLength2-n,r=Math.max(r,-c),c=Box2D.Common.Math.b2Math.Clamp(c+Box2D.Common.b2Settings.b2_linearSlop,-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),p=-this.m_limitMass2*c,q=-p*this.m_u2.x,p=-p*this.m_u2.y,b.m_sweep.c.x+=b.m_invMass*q,b.m_sweep.c.y+=b.m_invMass*p,b.m_sweep.a+=b.m_invI*(k*p-m*q),b.SynchronizeTransform());return r<Box2D.Common.b2Settings.b2_linearSlop};
Box2D.Dynamics.Joints.b2PulleyJoint.b2_minPulleyLength=1;Box2D.Dynamics.Joints.b2PulleyJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.groundAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.groundAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_pulleyJoint;this.groundAnchorA.Set(-1,1);this.groundAnchorB.Set(1,1);this.localAnchorA.Set(-1,0);this.localAnchorB.Set(1,
0);this.maxLengthB=this.lengthB=this.maxLengthA=this.lengthA=0;this.ratio=1;this.collideConnected=!0};c2inherit(Box2D.Dynamics.Joints.b2PulleyJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2PulleyJointDef.prototype.Initialize=function(a,b,c,d,e,f,g){void 0===g&&(g=0);this.bodyA=a;this.bodyB=b;this.groundAnchorA.SetV(c);this.groundAnchorB.SetV(d);this.localAnchorA=this.bodyA.GetLocalPoint(e);this.localAnchorB=this.bodyB.GetLocalPoint(f);a=e.x-c.x;c=e.y-c.y;this.lengthA=Math.sqrt(a*
a+c*c);c=f.x-d.x;d=f.y-d.y;this.lengthB=Math.sqrt(c*c+d*d);this.ratio=g;g=this.lengthA+this.ratio*this.lengthB;this.maxLengthA=g-this.ratio*Box2D.Dynamics.Joints.b2PulleyJoint.b2_minPulleyLength;this.maxLengthB=(g-Box2D.Dynamics.Joints.b2PulleyJoint.b2_minPulleyLength)/this.ratio};Box2D.Dynamics.Joints.b2PulleyJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2PulleyJoint(this)};Box2D.Dynamics.Joints.b2RevoluteJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.K=
new Box2D.Common.Math.b2Mat22;this.K1=new Box2D.Common.Math.b2Mat22;this.K2=new Box2D.Common.Math.b2Mat22;this.K3=new Box2D.Common.Math.b2Mat22;this.impulse3=new Box2D.Common.Math.b2Vec3(0,0,0);this.impulse2=Box2D.Common.Math.b2Vec2.Get(0,0);this.reduced=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_impulse=new Box2D.Common.Math.b2Vec3(0,0,0);this.m_mass=new Box2D.Common.Math.b2Mat33;this.m_localAnchor1.SetV(a.localAnchorA);
this.m_localAnchor2.SetV(a.localAnchorB);this.m_referenceAngle=a.referenceAngle;this.m_impulse.SetZero();this.m_motorImpulse=0;this.m_lowerAngle=a.lowerAngle;this.m_upperAngle=a.upperAngle;this.m_maxMotorTorque=a.maxMotorTorque;this.m_motorSpeed=a.motorSpeed;this.m_enableLimit=a.enableLimit;this.m_enableMotor=a.enableMotor;this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit};c2inherit(Box2D.Dynamics.Joints.b2RevoluteJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetAnchorA=
function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return Box2D.Common.Math.b2Vec2.Get(a*this.m_impulse.x,a*this.m_impulse.y)};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetReactionTorque=function(a){void 0===a&&(a=0);return a*this.m_impulse.z};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetJointAngle=
function(){return this.m_bodyB.m_sweep.a-this.m_bodyA.m_sweep.a-this.m_referenceAngle};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetJointSpeed=function(){return this.m_bodyB.m_angularVelocity-this.m_bodyA.m_angularVelocity};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.IsLimitEnabled=function(){return this.m_enableLimit};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.EnableLimit=function(a){this.m_enableLimit=a};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetLowerLimit=function(){return this.m_lowerAngle};
Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetUpperLimit=function(){return this.m_upperAngle};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.SetLimits=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);this.m_lowerAngle=a;this.m_upperAngle=b};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.IsMotorEnabled=function(){this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);return this.m_enableMotor};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.EnableMotor=function(a){this.m_enableMotor=a};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.SetMotorSpeed=
function(a){void 0===a&&(a=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_motorSpeed=a};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetMotorSpeed=function(){return this.m_motorSpeed};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.SetMaxMotorTorque=function(a){void 0===a&&(a=0);this.m_maxMotorTorque=a};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetMotorTorque=function(){return this.m_maxMotorTorque};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.InitVelocityConstraints=function(a){var b=
this.m_bodyA,c=this.m_bodyB,d,e=0;d=b.m_xf.R;var f=this.m_localAnchor1.x-b.m_sweep.localCenter.x,g=this.m_localAnchor1.y-b.m_sweep.localCenter.y,e=d.col1.x*f+d.col2.x*g,g=d.col1.y*f+d.col2.y*g,f=e;d=c.m_xf.R;var h=this.m_localAnchor2.x-c.m_sweep.localCenter.x,l=this.m_localAnchor2.y-c.m_sweep.localCenter.y,e=d.col1.x*h+d.col2.x*l,l=d.col1.y*h+d.col2.y*l,h=e;d=b.m_invMass;var e=c.m_invMass,k=b.m_invI,m=c.m_invI;this.m_mass.col1.x=d+e+g*g*k+l*l*m;this.m_mass.col2.x=-g*f*k-l*h*m;this.m_mass.col3.x=-g*
k-l*m;this.m_mass.col1.y=this.m_mass.col2.x;this.m_mass.col2.y=d+e+f*f*k+h*h*m;this.m_mass.col3.y=f*k+h*m;this.m_mass.col1.z=this.m_mass.col3.x;this.m_mass.col2.z=this.m_mass.col3.y;this.m_mass.col3.z=k+m;this.m_motorMass=1/(k+m);this.m_enableMotor||(this.m_motorImpulse=0);if(this.m_enableLimit){var n=c.m_sweep.a-b.m_sweep.a-this.m_referenceAngle;Math.abs(this.m_upperAngle-this.m_lowerAngle)<2*Box2D.Common.b2Settings.b2_angularSlop?this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_equalLimits:n<=
this.m_lowerAngle?(this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit&&(this.m_impulse.z=0),this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit):n>=this.m_upperAngle?(this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(this.m_impulse.z=0),this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit):(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_impulse.z=0)}else this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit;a.warmStarting?
(this.m_impulse.x*=a.dtRatio,this.m_impulse.y*=a.dtRatio,this.m_motorImpulse*=a.dtRatio,a=this.m_impulse.x,n=this.m_impulse.y,b.m_linearVelocity.x-=d*a,b.m_linearVelocity.y-=d*n,b.m_angularVelocity-=k*(f*n-g*a+this.m_motorImpulse+this.m_impulse.z),c.m_linearVelocity.x+=e*a,c.m_linearVelocity.y+=e*n,c.m_angularVelocity+=m*(h*n-l*a+this.m_motorImpulse+this.m_impulse.z)):(this.m_impulse.SetZero(),this.m_motorImpulse=0)};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.SolveVelocityConstraints=function(a){var b=
this.m_bodyA,c=this.m_bodyB,d=0,e=d=0,f=0,g=0,h=0,l=b.m_linearVelocity,k=b.m_angularVelocity,m=c.m_linearVelocity,n=c.m_angularVelocity,q=b.m_invMass,p=c.m_invMass,r=b.m_invI,s=c.m_invI;this.m_enableMotor&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_equalLimits&&(e=this.m_motorMass*-(n-k-this.m_motorSpeed),f=this.m_motorImpulse,g=a.dt*this.m_maxMotorTorque,this.m_motorImpulse=Box2D.Common.Math.b2Math.Clamp(this.m_motorImpulse+e,-g,g),e=this.m_motorImpulse-f,k-=r*e,n+=s*e);if(this.m_enableLimit&&
this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit){a=b.m_xf.R;e=this.m_localAnchor1.x-b.m_sweep.localCenter.x;f=this.m_localAnchor1.y-b.m_sweep.localCenter.y;d=a.col1.x*e+a.col2.x*f;f=a.col1.y*e+a.col2.y*f;e=d;a=c.m_xf.R;g=this.m_localAnchor2.x-c.m_sweep.localCenter.x;h=this.m_localAnchor2.y-c.m_sweep.localCenter.y;d=a.col1.x*g+a.col2.x*h;h=a.col1.y*g+a.col2.y*h;g=d;a=m.x+-n*h-l.x- -k*f;var t=m.y+n*g-l.y-k*e;this.m_mass.Solve33(this.impulse3,-a,-t,-(n-k));this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_equalLimits?
this.m_impulse.Add(this.impulse3):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit?(d=this.m_impulse.z+this.impulse3.z,0>d&&(this.m_mass.Solve22(this.reduced,-a,-t),this.impulse3.x=this.reduced.x,this.impulse3.y=this.reduced.y,this.impulse3.z=-this.m_impulse.z,this.m_impulse.x+=this.reduced.x,this.m_impulse.y+=this.reduced.y,this.m_impulse.z=0)):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(d=this.m_impulse.z+this.impulse3.z,0<d&&(this.m_mass.Solve22(this.reduced,
-a,-t),this.impulse3.x=this.reduced.x,this.impulse3.y=this.reduced.y,this.impulse3.z=-this.m_impulse.z,this.m_impulse.x+=this.reduced.x,this.m_impulse.y+=this.reduced.y,this.m_impulse.z=0));l.x-=q*this.impulse3.x;l.y-=q*this.impulse3.y;k-=r*(e*this.impulse3.y-f*this.impulse3.x+this.impulse3.z);m.x+=p*this.impulse3.x;m.y+=p*this.impulse3.y;n+=s*(g*this.impulse3.y-h*this.impulse3.x+this.impulse3.z)}else a=b.m_xf.R,e=this.m_localAnchor1.x-b.m_sweep.localCenter.x,f=this.m_localAnchor1.y-b.m_sweep.localCenter.y,
d=a.col1.x*e+a.col2.x*f,f=a.col1.y*e+a.col2.y*f,e=d,a=c.m_xf.R,g=this.m_localAnchor2.x-c.m_sweep.localCenter.x,h=this.m_localAnchor2.y-c.m_sweep.localCenter.y,d=a.col1.x*g+a.col2.x*h,h=a.col1.y*g+a.col2.y*h,g=d,this.m_mass.Solve22(this.impulse2,-(m.x+-n*h-l.x- -k*f),-(m.y+n*g-l.y-k*e)),this.m_impulse.x+=this.impulse2.x,this.m_impulse.y+=this.impulse2.y,l.x-=q*this.impulse2.x,l.y-=q*this.impulse2.y,k-=r*(e*this.impulse2.y-f*this.impulse2.x),m.x+=p*this.impulse2.x,m.y+=p*this.impulse2.y,n+=s*(g*this.impulse2.y-
h*this.impulse2.x);b.m_linearVelocity.SetV(l);b.m_angularVelocity=k;c.m_linearVelocity.SetV(m);c.m_angularVelocity=n};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.SolvePositionConstraints=function(a){var b=0,c;a=this.m_bodyA;var d=this.m_bodyB,e=0,f=c=0,g=0,h=0;if(this.m_enableLimit&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit){var b=d.m_sweep.a-a.m_sweep.a-this.m_referenceAngle,l=0;this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_equalLimits?(b=Box2D.Common.Math.b2Math.Clamp(b-
this.m_lowerAngle,-Box2D.Common.b2Settings.b2_maxAngularCorrection,Box2D.Common.b2Settings.b2_maxAngularCorrection),l=-this.m_motorMass*b,e=Math.abs(b)):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit?(b-=this.m_lowerAngle,e=-b,b=Box2D.Common.Math.b2Math.Clamp(b+Box2D.Common.b2Settings.b2_angularSlop,-Box2D.Common.b2Settings.b2_maxAngularCorrection,0),l=-this.m_motorMass*b):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(e=b-=this.m_upperAngle,b=Box2D.Common.Math.b2Math.Clamp(b-
Box2D.Common.b2Settings.b2_angularSlop,0,Box2D.Common.b2Settings.b2_maxAngularCorrection),l=-this.m_motorMass*b);a.m_sweep.a-=a.m_invI*l;d.m_sweep.a+=d.m_invI*l;a.SynchronizeTransform();d.SynchronizeTransform()}c=a.m_xf.R;l=this.m_localAnchor1.x-a.m_sweep.localCenter.x;b=this.m_localAnchor1.y-a.m_sweep.localCenter.y;f=c.col1.x*l+c.col2.x*b;b=c.col1.y*l+c.col2.y*b;l=f;c=d.m_xf.R;var k=this.m_localAnchor2.x-d.m_sweep.localCenter.x,m=this.m_localAnchor2.y-d.m_sweep.localCenter.y,f=c.col1.x*k+c.col2.x*
m,m=c.col1.y*k+c.col2.y*m,k=f,g=d.m_sweep.c.x+k-a.m_sweep.c.x-l,h=d.m_sweep.c.y+m-a.m_sweep.c.y-b,n=g*g+h*h;c=Math.sqrt(n);var f=a.m_invMass,q=d.m_invMass,p=a.m_invI,r=d.m_invI,s=10*Box2D.Common.b2Settings.b2_linearSlop;n>s*s&&(n=1/(f+q),g=n*-g,h=n*-h,a.m_sweep.c.x-=0.5*f*g,a.m_sweep.c.y-=0.5*f*h,d.m_sweep.c.x+=0.5*q*g,d.m_sweep.c.y+=0.5*q*h,g=d.m_sweep.c.x+k-a.m_sweep.c.x-l,h=d.m_sweep.c.y+m-a.m_sweep.c.y-b);this.K1.col1.x=f+q;this.K1.col2.x=0;this.K1.col1.y=0;this.K1.col2.y=f+q;this.K2.col1.x=p*
b*b;this.K2.col2.x=-p*l*b;this.K2.col1.y=-p*l*b;this.K2.col2.y=p*l*l;this.K3.col1.x=r*m*m;this.K3.col2.x=-r*k*m;this.K3.col1.y=-r*k*m;this.K3.col2.y=r*k*k;this.K.SetM(this.K1);this.K.AddM(this.K2);this.K.AddM(this.K3);this.K.Solve(Box2D.Dynamics.Joints.b2RevoluteJoint.tImpulse,-g,-h);g=Box2D.Dynamics.Joints.b2RevoluteJoint.tImpulse.x;h=Box2D.Dynamics.Joints.b2RevoluteJoint.tImpulse.y;a.m_sweep.c.x-=a.m_invMass*g;a.m_sweep.c.y-=a.m_invMass*h;a.m_sweep.a-=a.m_invI*(l*h-b*g);d.m_sweep.c.x+=d.m_invMass*
g;d.m_sweep.c.y+=d.m_invMass*h;d.m_sweep.a+=d.m_invI*(k*h-m*g);a.SynchronizeTransform();d.SynchronizeTransform();return c<=Box2D.Common.b2Settings.b2_linearSlop&&e<=Box2D.Common.b2Settings.b2_angularSlop};Box2D.Dynamics.Joints.b2RevoluteJoint.tImpulse=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Dynamics.Joints.b2RevoluteJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_revoluteJoint;
this.localAnchorA.SetZero();this.localAnchorB.SetZero();this.motorSpeed=this.maxMotorTorque=this.upperAngle=this.lowerAngle=this.referenceAngle=0;this.enableMotor=this.enableLimit=!1};c2inherit(Box2D.Dynamics.Joints.b2RevoluteJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2RevoluteJointDef.prototype.Initialize=function(a,b,c){this.bodyA=a;this.bodyB=b;this.localAnchorA=this.bodyA.GetLocalPoint(c);this.localAnchorB=this.bodyB.GetLocalPoint(c);this.referenceAngle=this.bodyB.GetAngle()-
this.bodyA.GetAngle()};Box2D.Dynamics.Joints.b2RevoluteJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2RevoluteJoint(this)};Box2D.Dynamics.Joints.b2WeldJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_impulse=new Box2D.Common.Math.b2Vec3(0,0,0);this.m_mass=new Box2D.Common.Math.b2Mat33;this.m_localAnchorA.SetV(a.localAnchorA);this.m_localAnchorB.SetV(a.localAnchorB);
this.m_referenceAngle=a.referenceAngle};c2inherit(Box2D.Dynamics.Joints.b2WeldJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2WeldJoint.prototype.GetAnchorA=function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchorA)};Box2D.Dynamics.Joints.b2WeldJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchorB)};Box2D.Dynamics.Joints.b2WeldJoint.prototype.GetReactionForce=function(a){return Box2D.Common.Math.b2Vec2.Get(a*this.m_impulse.x,a*this.m_impulse.y)};
Box2D.Dynamics.Joints.b2WeldJoint.prototype.GetReactionTorque=function(a){return a*this.m_impulse.z};Box2D.Dynamics.Joints.b2WeldJoint.prototype.InitVelocityConstraints=function(a){var b,c=0,d=this.m_bodyA,e=this.m_bodyB;b=d.m_xf.R;var f=this.m_localAnchorA.x-d.m_sweep.localCenter.x,g=this.m_localAnchorA.y-d.m_sweep.localCenter.y,c=b.col1.x*f+b.col2.x*g,g=b.col1.y*f+b.col2.y*g,f=c;b=e.m_xf.R;var h=this.m_localAnchorB.x-e.m_sweep.localCenter.x,l=this.m_localAnchorB.y-e.m_sweep.localCenter.y,c=b.col1.x*
h+b.col2.x*l,l=b.col1.y*h+b.col2.y*l,h=c;b=d.m_invMass;var c=e.m_invMass,k=d.m_invI,m=e.m_invI;this.m_mass.col1.x=b+c+g*g*k+l*l*m;this.m_mass.col2.x=-g*f*k-l*h*m;this.m_mass.col3.x=-g*k-l*m;this.m_mass.col1.y=this.m_mass.col2.x;this.m_mass.col2.y=b+c+f*f*k+h*h*m;this.m_mass.col3.y=f*k+h*m;this.m_mass.col1.z=this.m_mass.col3.x;this.m_mass.col2.z=this.m_mass.col3.y;this.m_mass.col3.z=k+m;a.warmStarting?(this.m_impulse.x*=a.dtRatio,this.m_impulse.y*=a.dtRatio,this.m_impulse.z*=a.dtRatio,d.m_linearVelocity.x-=
b*this.m_impulse.x,d.m_linearVelocity.y-=b*this.m_impulse.y,d.m_angularVelocity-=k*(f*this.m_impulse.y-g*this.m_impulse.x+this.m_impulse.z),e.m_linearVelocity.x+=c*this.m_impulse.x,e.m_linearVelocity.y+=c*this.m_impulse.y,e.m_angularVelocity+=m*(h*this.m_impulse.y-l*this.m_impulse.x+this.m_impulse.z)):this.m_impulse.SetZero()};Box2D.Dynamics.Joints.b2WeldJoint.prototype.SolveVelocityConstraints=function(a){var b,c=0;a=this.m_bodyA;var d=this.m_bodyB,e=a.m_linearVelocity,f=a.m_angularVelocity,g=d.m_linearVelocity,
h=d.m_angularVelocity,l=a.m_invMass,k=d.m_invMass,m=a.m_invI,n=d.m_invI;b=a.m_xf.R;var q=this.m_localAnchorA.x-a.m_sweep.localCenter.x,p=this.m_localAnchorA.y-a.m_sweep.localCenter.y,c=b.col1.x*q+b.col2.x*p,p=b.col1.y*q+b.col2.y*p,q=c;b=d.m_xf.R;var r=this.m_localAnchorB.x-d.m_sweep.localCenter.x,s=this.m_localAnchorB.y-d.m_sweep.localCenter.y,c=b.col1.x*r+b.col2.x*s,s=b.col1.y*r+b.col2.y*s,r=c;b=g.x-h*s-e.x+f*p;var c=g.y+h*r-e.y-f*q,t=h-f,v=new Box2D.Common.Math.b2Vec3(0,0,0);this.m_mass.Solve33(v,
-b,-c,-t);this.m_impulse.Add(v);e.x-=l*v.x;e.y-=l*v.y;f-=m*(q*v.y-p*v.x+v.z);g.x+=k*v.x;g.y+=k*v.y;h+=n*(r*v.y-s*v.x+v.z);a.m_angularVelocity=f;d.m_angularVelocity=h};Box2D.Dynamics.Joints.b2WeldJoint.prototype.SolvePositionConstraints=function(a){var b,c=0;a=this.m_bodyA;var d=this.m_bodyB;b=a.m_xf.R;var e=this.m_localAnchorA.x-a.m_sweep.localCenter.x,f=this.m_localAnchorA.y-a.m_sweep.localCenter.y,c=b.col1.x*e+b.col2.x*f,f=b.col1.y*e+b.col2.y*f,e=c;b=d.m_xf.R;var g=this.m_localAnchorB.x-d.m_sweep.localCenter.x,
h=this.m_localAnchorB.y-d.m_sweep.localCenter.y,c=b.col1.x*g+b.col2.x*h,h=b.col1.y*g+b.col2.y*h,g=c;b=a.m_invMass;var c=d.m_invMass,l=a.m_invI,k=d.m_invI,m=d.m_sweep.c.x+g-a.m_sweep.c.x-e,n=d.m_sweep.c.y+h-a.m_sweep.c.y-f,q=d.m_sweep.a-a.m_sweep.a-this.m_referenceAngle,p=10*Box2D.Common.b2Settings.b2_linearSlop,r=Math.sqrt(m*m+n*n),s=Math.abs(q);r>p&&(l*=1,k*=1);this.m_mass.col1.x=b+c+f*f*l+h*h*k;this.m_mass.col2.x=-f*e*l-h*g*k;this.m_mass.col3.x=-f*l-h*k;this.m_mass.col1.y=this.m_mass.col2.x;this.m_mass.col2.y=
b+c+e*e*l+g*g*k;this.m_mass.col3.y=e*l+g*k;this.m_mass.col1.z=this.m_mass.col3.x;this.m_mass.col2.z=this.m_mass.col3.y;this.m_mass.col3.z=l+k;p=new Box2D.Common.Math.b2Vec3(0,0,0);this.m_mass.Solve33(p,-m,-n,-q);a.m_sweep.c.x-=b*p.x;a.m_sweep.c.y-=b*p.y;a.m_sweep.a-=l*(e*p.y-f*p.x+p.z);d.m_sweep.c.x+=c*p.x;d.m_sweep.c.y+=c*p.y;d.m_sweep.a+=k*(g*p.y-h*p.x+p.z);a.SynchronizeTransform();d.SynchronizeTransform();return r<=Box2D.Common.b2Settings.b2_linearSlop&&s<=Box2D.Common.b2Settings.b2_angularSlop};
Box2D.Dynamics.Joints.b2WeldJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_weldJoint;this.referenceAngle=0};c2inherit(Box2D.Dynamics.Joints.b2WeldJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2WeldJointDef.prototype.Initialize=function(a,b,c){this.bodyA=a;this.bodyB=b;this.localAnchorA.SetV(this.bodyA.GetLocalPoint(c));
this.localAnchorB.SetV(this.bodyB.GetLocalPoint(c));this.referenceAngle=this.bodyB.GetAngle()-this.bodyA.GetAngle()};Box2D.Dynamics.Joints.b2WeldJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2WeldJoint(this)};Box2D.Collision.b2Collision.s_incidentEdge=Box2D.Collision.b2Collision.MakeClipPointVector();Box2D.Collision.b2Collision.s_clipPoints1=Box2D.Collision.b2Collision.MakeClipPointVector();Box2D.Collision.b2Collision.s_clipPoints2=Box2D.Collision.b2Collision.MakeClipPointVector();
Box2D.Collision.b2Collision.s_localTangent=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_localNormal=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_planePoint=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_normal=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_tangent=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_tangent2=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_v11=Box2D.Common.Math.b2Vec2.Get(0,
0);Box2D.Collision.b2Collision.s_v12=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2TimeOfImpact.b2_toiCalls=0;Box2D.Collision.b2TimeOfImpact.b2_toiIters=0;Box2D.Collision.b2TimeOfImpact.b2_toiMaxIters=0;Box2D.Collision.b2TimeOfImpact.b2_toiRootIters=0;Box2D.Collision.b2TimeOfImpact.b2_toiMaxRootIters=0;Box2D.Collision.b2TimeOfImpact.s_cache=new Box2D.Collision.b2SimplexCache;Box2D.Collision.b2TimeOfImpact.s_distanceInput=new Box2D.Collision.b2DistanceInput;Box2D.Collision.b2TimeOfImpact.s_xfA=
new Box2D.Common.Math.b2Transform;Box2D.Collision.b2TimeOfImpact.s_xfB=new Box2D.Common.Math.b2Transform;Box2D.Collision.b2TimeOfImpact.s_fcn=new Box2D.Collision.b2SeparationFunction;Box2D.Collision.b2TimeOfImpact.s_distanceOutput=new Box2D.Collision.b2DistanceOutput;Box2D.Dynamics.b2Body.s_xf1=new Box2D.Common.Math.b2Transform;Box2D.Dynamics.b2ContactListener.b2_defaultListener=new Box2D.Dynamics.b2ContactListener;Box2D.Dynamics.b2ContactManager.s_evalCP=new Box2D.Collision.b2ContactPoint;Box2D.Dynamics.b2World.s_xf=
new Box2D.Common.Math.b2Transform;Box2D.Dynamics.b2World.s_backupA=new Box2D.Common.Math.b2Sweep;Box2D.Dynamics.b2World.s_backupB=new Box2D.Common.Math.b2Sweep;Box2D.Dynamics.Contacts.b2Contact.s_input=new Box2D.Collision.b2TOIInput;Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold=new Box2D.Collision.b2WorldManifold;Box2D.Dynamics.Contacts.b2ContactSolver.s_psm=new Box2D.Dynamics.Contacts.b2PositionSolverManifold}cr.b2Separator=function(){};
cr.b2Separator.det=function(a,b,c,d,e,f){return a*d+c*f+e*b-b*c-d*e-f*a};cr.b2Separator.hitRay=function(a,b,c,d,e,f,g,h){var l=c-a,k=d-b,m=g-e,n=h-f,m=(m*(f-b)-n*(e-a))/(k*m-l*n),l=a+m*l,k=b+m*k;a=cr.b2Separator.isOnSegment(c,d,a,b,l,k);e=cr.b2Separator.isOnSegment(l,k,e,f,g,h);return a&&e?Box2D.Common.Math.b2Vec2.Get(l,k):null};
cr.b2Separator.isOnSegment=function(a,b,c,d,e,f){return(c+0.1>=a&&a>=e-0.1||c-0.1<=a&&a<=e+0.1)&&(d+0.1>=b&&b>=f-0.1||d-0.1<=b&&b<=f+0.1)&&cr.b2Separator.isOnLine(a,b,c,d,e,f)};cr.b2Separator.isOnLine=function(a,b,c,d,e,f){return 0.1<Math.abs(e-c)?0.1>Math.abs((f-d)/(e-c)*(a-c)+d-b):0.1>Math.abs(a-c)};cr.b2Separator.pointsMatch=function(a,b,c,d){return 0.1>Math.abs(c-a)&&0.1>Math.abs(d-b)};
cr.b2Separator.Separate=function(a,b){var c=Box2D.Common.Math.b2Vec2,d=cr.b2Separator.calcShapes(a),e=[],f,g,h,l,k,m,n,q,p;k=0;for(m=d.length;k<m;k++){g=d[k];f=[];f.length=g.length;n=p=0;for(q=g.length;n<q;n++)h=g[n],l=g[(n+1)%q],p+=h.x*l.y-h.y*l.x,f[n]=c.Get(h.x,h.y);p=Math.abs(p/2);p>=0.0010*b&&e.push(f)}return e};
cr.b2Separator.calcShapes=function(a){var b=[],c=0,d=0,e=0,f=0,g=0,h=g=0,l=0,k=0,m=0,f=0,n,q,p,r=f=c=0,s=0,e=[],l=[],t=!1,v=[],y=[];for(y.push(a);y.length;){b=y[0];d=b.length;t=!0;for(c=0;c<d;c++)if(k=c,m=c<d-1?c+1:c+1-d,f=c<d-2?c+2:c+2-d,a=b[k],n=b[m],f=b[f],f=cr.b2Separator.det(a.x,a.y,n.x,n.y,f.x,f.y),0>f){t=!1;l=1E9;for(e=0;e<d;e++)if(e!==k&&e!==m&&(c=e,f=e<d-1?e+1:0,g=b[c],h=b[f],q=cr.b2Separator.hitRay(a.x,a.y,n.x,n.y,g.x,g.y,h.x,h.y)))g=n.x-q.x,h=n.y-q.y,g=g*g+h*h,g<l&&(s=c,r=f,p=q,l=g);if(1E9===
l)return[];e=[];l=[];c=s;f=r;g=b[c];h=b[f];cr.b2Separator.pointsMatch(p.x,p.y,h.x,h.y)||e.push(p);cr.b2Separator.pointsMatch(p.x,p.y,g.x,g.y)||l.push(p);s=-1;for(r=k;;){if(r!==f)e.push(b[r]);else{if(0>s||s>=d)return[];cr.b2Separator.isOnSegment(h.x,h.y,b[s].x,b[s].y,a.x,a.y)||e.push(b[r]);break}s=r;0>r-1?r=d-1:r--}e.reverse();s=-1;for(r=m;;){if(r!==c)l.push(b[r]);else{if(0>s||s>=d)return[];r===c&&!cr.b2Separator.isOnSegment(g.x,g.y,b[s].x,b[s].y,n.x,n.y)&&l.push(b[r]);break}s=r;r+1>d-1?r=0:r++}y.push(e,
l);y.shift();break}t&&v.push(y.shift())}return v};
cr.behaviors.Physics=function(a){for(var b=0;4E3>b;b++)Box2D.Common.Math.b2Vec2._freeCache.push(new Box2D.Common.Math.b2Vec2(0,0));this.runtime=a;this.world=new Box2D.Dynamics.b2World(Box2D.Common.Math.b2Vec2.Get(0,10),!0);this.worldG=10;this.lastUpdateTick=-1;a=new Box2D.Dynamics.b2ContactListener;a.behavior=this;a.BeginContact=function(a){var b=a.m_fixtureA.GetBody().c2userdata;a=a.m_fixtureB.GetBody().c2userdata;this.behavior.runtime.registerCollision(b.inst,a.inst)};this.world.SetContactListener(a);
a=new Box2D.Dynamics.b2ContactFilter;a.behavior=this;a.ShouldCollide=function(a,b){if(this.behavior.allCollisionsEnabled)return!0;var e=a.GetBody().c2userdata.inst.type,f=b.GetBody().c2userdata.inst.type,g=e.extra.Physics_DisabledCollisions;return g&&g.contains(f)?!1:(g=f.extra.Physics_DisabledCollisions)&&g.contains(e)?!1:!0};this.world.SetContactFilter(a);this.steppingMode=0;this.velocityIterations=8;this.positionIterations=3;this.allCollisionsEnabled=!0};
(function(){function a(){}function b(){}function c(a,b,c){c?((c=a.extra.Physics_DisabledCollisions)&&c.remove(b),(c=b.extra.Physics_DisabledCollisions)&&c.remove(a)):(a.extra.Physics_DisabledCollisions||(a.extra.Physics_DisabledCollisions=new cr.ObjectSet),a.extra.Physics_DisabledCollisions.add(b),b.extra.Physics_DisabledCollisions||(b.extra.Physics_DisabledCollisions=new cr.ObjectSet),b.extra.Physics_DisabledCollisions.add(a))}function d(){}var e=Box2D.Common.Math.b2Vec2,f=Box2D.Dynamics.b2BodyDef,
g=Box2D.Dynamics.b2FixtureDef,h=Box2D.Collision.Shapes.b2PolygonShape,l=Box2D.Collision.Shapes.b2CircleShape,k=Box2D.Dynamics.Joints.b2DistanceJointDef,m=Box2D.Dynamics.Joints.b2RevoluteJointDef,n=cr.behaviors.Physics.prototype;n.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};n.Type.prototype.onCreate=function(){};n.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime;this.world=this.behavior.world};var q=n.Instance.prototype;q.onCreate=
function(){this.immovable=0!==this.properties[0];this.collisionmask=this.properties[1];this.preventRotation=0!==this.properties[2];this.density=this.properties[3];this.friction=this.properties[4];this.restitution=this.properties[5];this.linearDamping=this.properties[6];this.angularDamping=this.properties[7];this.bullet=0!==this.properties[8];this.enabled=0!==this.properties[9];this.body=null;this.inst.update_bbox();this.lastKnownX=this.inst.x;this.lastKnownY=this.inst.y;this.lastKnownAngle=this.inst.angle;
this.lastHeight=this.lastWidth=0;this.recreateBody=this.lastTickOverride=!1;this.lastAnimation=null;this.lastAnimationFrame=-1;this.myJoints?(this.myJoints.length=0,this.myCreatedJoints.length=0,this.joiningMe.clear()):(this.myJoints=[],this.myCreatedJoints=[],this.joiningMe=new cr.ObjectSet);var a=this;this.recycled||(this.myDestroyCallback=function(b){a.onInstanceDestroyed(b)});this.runtime.addDestroyCallback(this.myDestroyCallback)};q.postCreate=function(){this.inst.update_bbox();this.createBody();
this.lastAnimation=this.inst.cur_animation;this.lastAnimationFrame=this.inst.cur_frame};q.onDestroy=function(){this.destroyMyJoints();this.myCreatedJoints.length=0;this.joiningMe.clear();this.body&&(this.world.DestroyBody(this.body),this.body=null);this.runtime.removeDestroyCallback(this.myDestroyCallback)};q.saveToJSON=function(){var a={e:this.enabled,im:this.immovable,pr:this.preventRotation,d:this.density,fr:this.friction,re:this.restitution,ld:this.linearDamping,ad:this.angularDamping,b:this.bullet,
mcj:this.myCreatedJoints};if(this.enabled){var b=e.Get(0,0);b.SetV(this.body.GetLinearVelocity());a.vx=b.x;a.vy=b.y;a.om=this.body.GetAngularVelocity()}return a};q.loadFromJSON=function(a){this.destroyMyJoints();this.myCreatedJoints.length=0;this.joiningMe.clear();this.body&&(this.world.DestroyBody(this.body),this.body=null);this.enabled=a.e;this.immovable=a.im;this.preventRotation=a.pr;this.density=a.d;this.friction=a.fr;this.restitution=a.re;this.linearDamping=a.ld;this.angularDamping=a.ad;this.bullet=
a.b;this.lastKnownX=this.inst.x;this.lastKnownY=this.inst.y;this.lastKnownAngle=this.inst.angle;this.lastWidth=this.inst.width;this.lastHeight=this.inst.height;this.enabled&&(this.createBody(),this.body.SetLinearVelocity(e.Get(a.vx,a.vy)),this.body.SetAngularVelocity(a.om),(0!==a.vx||0!==a.vy||0!==a.om)&&this.body.SetAwake(!0),this.myCreatedJoints=a.mcj)};q.afterLoad=function(){this.enabled&&this.recreateMyJoints();this.behavior.lastUpdateTick=this.runtime.tickcount-1};q.onInstanceDestroyed=function(a){var b,
c,d,e=a.uid;d=b=0;for(c=this.myCreatedJoints.length;b<c;b++)this.myCreatedJoints[d]=this.myCreatedJoints[b],d<this.myJoints.length&&(this.myJoints[d]=this.myJoints[b]),this.myCreatedJoints[b].params[1]==e?this.world.DestroyJoint(this.myJoints[b]):d++;this.myCreatedJoints.length=d;d<this.myJoints.length&&(this.myJoints.length=d);this.joiningMe.remove(a)};q.destroyMyJoints=function(){var a,b;a=0;for(b=this.myJoints.length;a<b;a++)this.world.DestroyJoint(this.myJoints[a]);this.myJoints.length=0};q.recreateMyJoints=
function(){var a,b,c;a=0;for(b=this.myCreatedJoints.length;a<b;a++)switch(c=this.myCreatedJoints[a],c.type){case 0:this.doCreateDistanceJoint(c.params[0],c.params[1],c.params[2],c.params[3],c.params[4]);break;case 1:this.doCreateRevoluteJoint(c.params[0],c.params[1]);break;case 2:this.doCreateLimitedRevoluteJoint(c.params[0],c.params[1],c.params[2],c.params[3])}};q.destroyBody=function(){this.body&&(this.destroyMyJoints(),this.world.DestroyBody(this.body),this.body=null,this.inst.extra.box2dbody=
null)};q.createBody=function(){if(this.enabled){var a=this.inst,b=!1,c=null,d=null,k,m,n,q,A,x;this.body&&(b=!0,c=e.Get(0,0),c.SetV(this.body.GetLinearVelocity()),d=this.body.GetAngularVelocity(),this.destroyBody());var w=new g;w.density=this.density;w.friction=this.friction;w.restitution=this.restitution;k=new f;k.type=this.immovable?0:2;a.update_bbox();k.position.x=0.02*a.bquad.midX();k.position.y=0.02*a.bquad.midY();k.angle=a.angle;k.fixedRotation=this.preventRotation;k.linearDamping=this.linearDamping;
k.angularDamping=this.angularDamping;k.bullet=this.bullet;x=this.inst.collision_poly&&!this.inst.collision_poly.is_empty();this.body=this.world.CreateBody(k);this.body.c2userdata=this;k=this.collisionmask;!x&&0===this.collisionmask&&(k=1);m=Math.max(Math.abs(a.width),1);n=Math.max(Math.abs(a.height),1);var D=0>a.width;q=0>a.height;if(0===k){k=a.angle;a.angle=0;a.set_bbox_changed();a.update_bbox();A=a.bquad.midX()-a.x;var E=a.bquad.midY()-a.y;a.angle=k;a.set_bbox_changed();a.collision_poly.cache_poly(D?
-m:m,q?-n:n,0);var H=a.collision_poly.pts_cache,u=a.collision_poly.pts_count;x=[];x.length=u;for(k=0;k<u;k++)x[k]=e.Get(H[2*k]-A,H[2*k+1]-E);D!==q&&x.reverse();D=cr.b2Separator.Separate(x,m*n);for(k=0;k<u;k++)e.Free(x[k]);if(D.length){k=0;for(m=D.length;k<m;k++){x=D[k];n=0;for(q=x.length;n<q;n++)A=x[n],A.x*=0.02,A.y*=0.02;w.shape=new h;w.shape.SetAsArray(x,x.length);this.body.CreateFixture(w);n=0;for(q=x.length;n<q;n++)e.Free(x[n])}}else w.shape=new h,w.shape.SetAsBox(0.01*m,0.01*n),this.body.CreateFixture(w)}else 1===
k?(w.shape=new h,w.shape.SetAsBox(0.01*m,0.01*n)):w.shape=new l(0.01*Math.min(m,n)),this.body.CreateFixture(w);a.extra.box2dbody=this.body;this.lastWidth=a.width;this.lastHeight=a.height;if(b){this.body.SetLinearVelocity(c);this.body.SetAngularVelocity(d);e.Free(c);this.recreateMyJoints();x=this.joiningMe.valuesRef();k=0;for(m=x.length;k<m;k++)a=x[k].extra.box2dbody.c2userdata,a.destroyMyJoints(),a.recreateMyJoints()}}};q.tick=function(){if(this.enabled){var a=this.inst,b;0===this.behavior.steppingMode?
b=this.runtime.timescale/60:(b=this.runtime.getDt(this.inst),b>1/30&&(b=1/30));this.runtime.tickcount>this.behavior.lastUpdateTick&&0<this.runtime.timescale&&(this.world.Step(b,this.behavior.velocityIterations,this.behavior.positionIterations),this.world.ClearForces(),this.behavior.lastUpdateTick=this.runtime.tickcount);if(this.recreateBody||a.width!==this.lastWidth||a.height!==this.lastHeight||a.cur_animation!==this.lastAnimation||a.cur_frame!==this.lastAnimationFrame)this.createBody(),this.recreateBody=
!1,this.lastAnimation=a.cur_animation,this.lastAnimationFrame=a.cur_frame;b=a.angle!==this.lastKnownAngle;if(a.x!==this.lastKnownX||a.y!==this.lastKnownY){a.update_bbox();var c=a.bquad.midX(),d=a.bquad.midY(),f=c-this.lastKnownX,g=d-this.lastKnownY;this.body.SetPosition(e.Get(0.02*c,0.02*d));this.body.SetLinearVelocity(e.Get(f,g));this.lastTickOverride=!0;this.body.SetAwake(!0)}else this.lastTickOverride&&(this.lastTickOverride=!1,this.body.SetLinearVelocity(e.Get(0,0)),this.body.SetPosition(e.Get(0.02*
a.bquad.midX(),0.02*a.bquad.midY())));b&&(this.body.SetAngle(a.angle),this.body.SetAwake(!0));c=this.body.GetPosition();b=c.x/0.02;c=c.y/0.02;d=this.body.GetAngle();if(b!==a.x||c!==a.y||d!==a.angle)if(a.x=b,a.y=c,a.angle=d,a.set_bbox_changed(),a.update_bbox(),b=a.bquad.midX()-a.x,c=a.bquad.midY()-a.y,0!==b||0!==c)a.x-=b,a.y-=c,a.set_bbox_changed();this.lastKnownX=a.x;this.lastKnownY=a.y;this.lastKnownAngle=a.angle}};q.getInstImgPointX=function(a){return-1===a||!this.inst.getImagePoint?this.inst.x:
0===a&&this.body?(this.body.GetPosition().x+this.body.GetLocalCenter().x)/0.02:this.inst.getImagePoint(a,!0)};q.getInstImgPointY=function(a){return-1===a||!this.inst.getImagePoint?this.inst.y:0===a&&this.body?(this.body.GetPosition().y+this.body.GetLocalCenter().y)/0.02:this.inst.getImagePoint(a,!1)};a.prototype.IsSleeping=function(){return!this.enabled?!1:!this.body.IsAwake()};a.prototype.CompareVelocity=function(a,b,c){if(!this.enabled)return!1;var d=this.body.GetLinearVelocity();0===a?d=d.x/0.02:
1===a?d=d.y/0.02:(a=d.x/0.02,d=d.y/0.02,d=cr.distanceTo(0,0,a,d));return cr.do_cmp(d,b,c)};a.prototype.CompareAngularVelocity=function(a,b){if(!this.enabled)return!1;var c=cr.to_degrees(this.body.GetAngularVelocity());return cr.do_cmp(c,a,b)};a.prototype.CompareMass=function(a,b){if(!this.enabled)return!1;var c=this.body.GetMass()/0.02;return cr.do_cmp(c,a,b)};a.prototype.IsEnabled=function(){return this.enabled};n.cnds=new a;b.prototype.ApplyForce=function(a,b,c){if(this.enabled){var d=this.getInstImgPointX(c);
c=this.getInstImgPointY(c);this.body.ApplyForce(e.Get(a,b),e.Get(0.02*d,0.02*c))}};b.prototype.ApplyForceToward=function(a,b,c,d){if(this.enabled){var f=this.getInstImgPointX(d);d=this.getInstImgPointY(d);b=cr.angleTo(f,d,b,c);this.body.ApplyForce(e.Get(Math.cos(b)*a,Math.sin(b)*a),e.Get(0.02*f,0.02*d))}};b.prototype.ApplyForceAtAngle=function(a,b,c){if(this.enabled){b=cr.to_radians(b);var d=this.getInstImgPointX(c);c=this.getInstImgPointY(c);this.body.ApplyForce(e.Get(Math.cos(b)*a,Math.sin(b)*a),
e.Get(0.02*d,0.02*c))}};b.prototype.ApplyImpulse=function(a,b,c){if(this.enabled){var d=this.getInstImgPointX(c);c=this.getInstImgPointY(c);this.body.ApplyImpulse(e.Get(a,b),e.Get(0.02*d,0.02*c));this.lastTickOverride=!1;this.lastKnownX=this.inst.x;this.lastKnownY=this.inst.y}};b.prototype.ApplyImpulseToward=function(a,b,c,d){if(this.enabled){var f=this.getInstImgPointX(d);d=this.getInstImgPointY(d);b=cr.angleTo(f,d,b,c);this.body.ApplyImpulse(e.Get(Math.cos(b)*a,Math.sin(b)*a),e.Get(0.02*f,0.02*
d));this.lastTickOverride=!1;this.lastKnownX=this.inst.x;this.lastKnownY=this.inst.y}};b.prototype.ApplyImpulseAtAngle=function(a,b,c){if(this.enabled){b=cr.to_radians(b);var d=this.getInstImgPointX(c);c=this.getInstImgPointY(c);this.body.ApplyImpulse(e.Get(Math.cos(b)*a,Math.sin(b)*a),e.Get(0.02*d,0.02*c));this.lastTickOverride=!1;this.lastKnownX=this.inst.x;this.lastKnownY=this.inst.y}};b.prototype.ApplyTorque=function(a){this.enabled&&this.body.ApplyTorque(cr.to_radians(a))};b.prototype.ApplyTorqueToAngle=
function(a,b){this.enabled&&(a=cr.to_radians(a),b=cr.to_radians(b),cr.angleClockwise(this.inst.angle,b)?this.body.ApplyTorque(-a):this.body.ApplyTorque(a))};b.prototype.ApplyTorqueToPosition=function(a,b,c){this.enabled&&(a=cr.to_radians(a),b=cr.angleTo(this.inst.x,this.inst.y,b,c),cr.angleClockwise(this.inst.angle,b)?this.body.ApplyTorque(-a):this.body.ApplyTorque(a))};b.prototype.SetAngularVelocity=function(a){this.enabled&&(this.body.SetAngularVelocity(cr.to_radians(a)),this.body.SetAwake(!0))};
b.prototype.CreateDistanceJoint=function(a,b,c,d,e){if(b&&this.enabled&&(b=b.getFirstPicked(this.inst))&&b!=this.inst&&b.extra.box2dbody)this.myCreatedJoints.push({type:0,params:[a,b.uid,c,d,e]}),this.doCreateDistanceJoint(a,b.uid,c,d,e)};q.doCreateDistanceJoint=function(a,b,c,d,f){if(this.enabled&&(b=this.runtime.getObjectByUID(b))&&b!=this.inst&&b.extra.box2dbody){b.extra.box2dbody.c2userdata.joiningMe.add(this.inst);var g=this.getInstImgPointX(a);a=this.getInstImgPointY(a);var h;b.getImagePoint?
(h=b.getImagePoint(c,!0),c=b.getImagePoint(c,!1)):(h=b.x,c=b.y);var l=g-h,m=a-c,n=new k;n.Initialize(this.body,b.extra.box2dbody,e.Get(0.02*g,0.02*a),e.Get(0.02*h,0.02*c));n.length=0.02*Math.sqrt(l*l+m*m);n.dampingRatio=d;n.frequencyHz=f;this.myJoints.push(this.world.CreateJoint(n))}};b.prototype.CreateRevoluteJoint=function(a,b){if(b&&this.enabled){var c=b.getFirstPicked(this.inst);c&&c!=this.inst&&c.extra.box2dbody&&(this.myCreatedJoints.push({type:1,params:[a,c.uid]}),this.doCreateRevoluteJoint(a,
c.uid))}};q.doCreateRevoluteJoint=function(a,b){if(this.enabled){var c=this.runtime.getObjectByUID(b);if(c&&c!=this.inst&&c.extra.box2dbody){c.extra.box2dbody.c2userdata.joiningMe.add(this.inst);var d=this.getInstImgPointX(a),f=this.getInstImgPointY(a),g=new m;g.Initialize(this.body,c.extra.box2dbody,e.Get(0.02*d,0.02*f));this.myJoints.push(this.world.CreateJoint(g))}}};b.prototype.CreateLimitedRevoluteJoint=function(a,b,c,d){if(b&&this.enabled&&(b=b.getFirstPicked(this.inst))&&b!=this.inst&&b.extra.box2dbody)this.myCreatedJoints.push({type:2,
params:[a,b.uid,c,d]}),this.doCreateLimitedRevoluteJoint(a,b.uid,c,d)};q.doCreateLimitedRevoluteJoint=function(a,b,c,d){if(this.enabled&&(b=this.runtime.getObjectByUID(b))&&b!=this.inst&&b.extra.box2dbody){b.extra.box2dbody.c2userdata.joiningMe.add(this.inst);var f=this.getInstImgPointX(a);a=this.getInstImgPointY(a);var g=new m;g.Initialize(this.body,b.extra.box2dbody,e.Get(0.02*f,0.02*a));g.enableLimit=!0;g.lowerAngle=cr.to_radians(c);g.upperAngle=cr.to_radians(d);this.myJoints.push(this.world.CreateJoint(g))}};
b.prototype.SetWorldGravity=function(a){if(a!==this.behavior.worldG){this.world.SetGravity(e.Get(0,a));this.behavior.worldG=a;var b,c=this.behavior.my_instances.valuesRef();a=0;for(b=c.length;a<b;a++)c[a].extra.box2dbody&&c[a].extra.box2dbody.SetAwake(!0)}};b.prototype.SetSteppingMode=function(a){this.behavior.steppingMode=a};b.prototype.SetIterations=function(a,b){1>a&&(a=1);1>b&&(b=1);this.behavior.velocityIterations=a;this.behavior.positionIterations=b};b.prototype.SetVelocity=function(a,b){this.enabled&&
(this.body.SetLinearVelocity(e.Get(0.02*a,0.02*b)),this.body.SetAwake(!0),this.lastTickOverride=!1,this.lastKnownX=this.inst.x,this.lastKnownY=this.inst.y)};b.prototype.SetDensity=function(a){this.enabled&&this.density!==a&&(this.density=a,this.recreateBody=!0)};b.prototype.SetFriction=function(a){this.enabled&&this.friction!==a&&(this.friction=a,this.recreateBody=!0)};b.prototype.SetElasticity=function(a){this.enabled&&this.restitution!==a&&(this.restitution=a,this.recreateBody=!0)};b.prototype.SetLinearDamping=
function(a){this.enabled&&this.linearDamping!==a&&(this.linearDamping=a,this.body.SetLinearDamping(a))};b.prototype.SetAngularDamping=function(a){this.enabled&&this.angularDamping!==a&&(this.angularDamping=a,this.body.SetAngularDamping(a))};b.prototype.SetImmovable=function(a){this.enabled&&this.immovable!==(0!==a)&&(this.immovable=0!==a,this.body.SetType(this.immovable?0:2),this.body.SetAwake(!0))};b.prototype.EnableCollisions=function(a,b){if(a&&this.enabled){var d,e;if(a.is_family){d=0;for(e=a.members.length;d<
e;d++)c(this.inst.type,a.members[d],0!==b)}else c(this.inst.type,a,0!==b);this.behavior.allCollisionsEnabled=!1}};b.prototype.SetPreventRotate=function(a){this.enabled&&this.preventRotation!==(0!==a)&&(this.preventRotation=0!==a,this.body.SetFixedRotation(this.preventRotation),this.body.m_torque=0,this.body.SetAngularVelocity(0),this.body.SetAwake(!0))};b.prototype.SetBullet=function(a){this.enabled&&this.bullet!==(0!==a)&&(this.bullet=0!==a,this.body.SetBullet(this.bullet),this.body.SetAwake(!0))};
b.prototype.RemoveJoints=function(){this.enabled&&(this.destroyMyJoints(),this.myCreatedJoints.length=0,this.joiningMe.clear())};b.prototype.SetEnabled=function(a){this.enabled&&0===a?(this.destroyBody(),this.enabled=!1):!this.enabled&&1===a&&(this.enabled=!0,this.createBody())};n.acts=new b;d.prototype.VelocityX=function(a){a.set_float(this.enabled?this.body.GetLinearVelocity().x/0.02:0)};d.prototype.VelocityY=function(a){a.set_float(this.enabled?this.body.GetLinearVelocity().y/0.02:0)};d.prototype.AngularVelocity=
function(a){a.set_float(this.enabled?cr.to_degrees(this.body.GetAngularVelocity()):0)};d.prototype.Mass=function(a){a.set_float(this.enabled?this.body.GetMass()/0.02:0)};d.prototype.CenterOfMassX=function(a){a.set_float(this.enabled?(this.body.GetPosition().x+this.body.GetLocalCenter().x)/0.02:0)};d.prototype.CenterOfMassY=function(a){a.set_float(this.enabled?(this.body.GetPosition().y+this.body.GetLocalCenter().y)/0.02:0)};d.prototype.Density=function(a){a.set_float(this.enabled?this.density:0)};
d.prototype.Friction=function(a){a.set_float(this.enabled?this.friction:0)};d.prototype.Elasticity=function(a){a.set_float(this.enabled?this.restitution:0)};d.prototype.LinearDamping=function(a){a.set_float(this.enabled?this.linearDamping:0)};d.prototype.AngularDamping=function(a){a.set_float(this.enabled?this.angularDamping:0)};n.exps=new d})();cr.behaviors.Pin=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){}var d=cr.behaviors.Pin.prototype;d.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};d.Type.prototype.onCreate=function(){};d.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var e=d.Instance.prototype;e.onCreate=function(){this.pinObject=null;this.pinObjectUid=-1;this.mode=this.lastKnownAngle=this.theirStartAngle=this.myStartAngle=this.pinDist=this.pinAngle=0;var a=this;this.recycled||
(this.myDestroyCallback=function(b){a.onInstanceDestroyed(b)});this.runtime.addDestroyCallback(this.myDestroyCallback)};e.saveToJSON=function(){return{uid:this.pinObject?this.pinObject.uid:-1,pa:this.pinAngle,pd:this.pinDist,msa:this.myStartAngle,tsa:this.theirStartAngle,lka:this.lastKnownAngle,m:this.mode}};e.loadFromJSON=function(a){this.pinObjectUid=a.uid;this.pinAngle=a.pa;this.pinDist=a.pd;this.myStartAngle=a.msa;this.theirStartAngle=a.tsa;this.lastKnownAngle=a.lka;this.mode=a.m};e.afterLoad=
function(){this.pinObject=-1===this.pinObjectUid?null:this.runtime.getObjectByUID(this.pinObjectUid);this.pinObjectUid=-1};e.onInstanceDestroyed=function(a){this.pinObject==a&&(this.pinObject=null)};e.onDestroy=function(){this.pinObject=null;this.runtime.removeDestroyCallback(this.myDestroyCallback)};e.tick=function(){};e.tick2=function(){if(this.pinObject){this.lastKnownAngle!==this.inst.angle&&(this.myStartAngle=cr.clamp_angle(this.myStartAngle+(this.inst.angle-this.lastKnownAngle)));var a=this.inst.x,
b=this.inst.y;if(3===this.mode||4===this.mode){var c=cr.distanceTo(this.inst.x,this.inst.y,this.pinObject.x,this.pinObject.y);if(c>this.pinDist||4===this.mode&&c<this.pinDist)b=cr.angleTo(this.pinObject.x,this.pinObject.y,this.inst.x,this.inst.y),a=this.pinObject.x+Math.cos(b)*this.pinDist,b=this.pinObject.y+Math.sin(b)*this.pinDist}else a=this.pinObject.x+Math.cos(this.pinObject.angle+this.pinAngle)*this.pinDist,b=this.pinObject.y+Math.sin(this.pinObject.angle+this.pinAngle)*this.pinDist;this.lastKnownAngle=
c=cr.clamp_angle(this.myStartAngle+(this.pinObject.angle-this.theirStartAngle));if((0===this.mode||1===this.mode||3===this.mode||4===this.mode)&&(this.inst.x!==a||this.inst.y!==b))this.inst.x=a,this.inst.y=b,this.inst.set_bbox_changed();if((0===this.mode||2===this.mode)&&this.inst.angle!==c)this.inst.angle=c,this.inst.set_bbox_changed()}};a.prototype.IsPinned=function(){return!!this.pinObject};d.cnds=new a;b.prototype.Pin=function(a,b){if(a){var c=a.getFirstPicked(this.inst);c&&(this.pinObject=c,
this.pinAngle=cr.angleTo(c.x,c.y,this.inst.x,this.inst.y)-c.angle,this.pinDist=cr.distanceTo(c.x,c.y,this.inst.x,this.inst.y),this.lastKnownAngle=this.myStartAngle=this.inst.angle,this.theirStartAngle=c.angle,this.mode=b)}};b.prototype.Unpin=function(){this.pinObject=null};d.acts=new b;c.prototype.PinnedUID=function(a){a.set_int(this.pinObject?this.pinObject.uid:-1)};d.exps=new c})();cr.behaviors.Platform=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){}var d=cr.behaviors.Platform.prototype;d.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};d.Type.prototype.onCreate=function(){};d.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime;this.simjump=this.simright=this.simleft=this.ignoreInput=this.jumped=this.jumpkey=this.rightkey=this.leftkey=!1;this.lastFloorObject=null;this.loadFloorObject=-1;this.lastFloorY=this.lastFloorX=0;this.floorIsJumpthru=
!1;this.fallthrough=this.animMode=0;this.firstTick=!0;this.dy=this.dx=0};var e=d.Instance.prototype;e.updateGravity=function(){this.downx=Math.cos(this.ga);this.downy=Math.sin(this.ga);this.rightx=Math.cos(this.ga-Math.PI/2);this.righty=Math.sin(this.ga-Math.PI/2);this.downx=cr.round6dp(this.downx);this.downy=cr.round6dp(this.downy);this.rightx=cr.round6dp(this.rightx);this.righty=cr.round6dp(this.righty);this.g1=this.g;0>this.g&&(this.downx*=-1,this.downy*=-1,this.g=Math.abs(this.g))};e.onCreate=
function(){this.maxspeed=this.properties[0];this.acc=this.properties[1];this.dec=this.properties[2];this.jumpStrength=this.properties[3];this.g1=this.g=this.properties[4];this.maxFall=this.properties[5];this.defaultControls=1===this.properties[6];this.enabled=0!==this.properties[7];this.wasOnFloor=!1;this.wasOverJumpthru=this.runtime.testOverlapJumpThru(this.inst);this.ga=cr.to_radians(90);this.updateGravity();var a=this;this.defaultControls&&!this.runtime.isDomFree&&(jQuery(document).keydown(function(b){a.onKeyDown(b)}),
jQuery(document).keyup(function(b){a.onKeyUp(b)}));this.recycled||(this.myDestroyCallback=function(b){a.onInstanceDestroyed(b)});this.runtime.addDestroyCallback(this.myDestroyCallback)};e.saveToJSON=function(){return{ii:this.ignoreInput,lfx:this.lastFloorX,lfy:this.lastFloorY,lfo:this.lastFloorObject?this.lastFloorObject.uid:-1,am:this.animMode,en:this.enabled,fall:this.fallthrough,ft:this.firstTick,dx:this.dx,dy:this.dy,ms:this.maxspeed,acc:this.acc,dec:this.dec,js:this.jumpStrength,g:this.g,g1:this.g1,
mf:this.maxFall,wof:this.wasOnFloor,woj:this.wasOverJumpthru,ga:this.ga}};e.loadFromJSON=function(a){this.ignoreInput=a.ii;this.lastFloorX=a.lfx;this.lastFloorY=a.lfy;this.loadFloorObject=a.lfo;this.animMode=a.am;this.enabled=a.en;this.fallthrough=a.fall;this.firstTick=a.ft;this.dx=a.dx;this.dy=a.dy;this.maxspeed=a.ms;this.acc=a.acc;this.dec=a.dec;this.jumpStrength=a.js;this.g=a.g;this.g1=a.g1;this.maxFall=a.mf;this.wasOnFloor=a.wof;this.wasOverJumpthru=a.woj;this.ga=a.ga;this.simjump=this.simright=
this.simleft=this.jumped=this.jumpkey=this.rightkey=this.leftkey=!1;this.updateGravity()};e.afterLoad=function(){this.lastFloorObject=-1===this.loadFloorObject?null:this.runtime.getObjectByUID(this.loadFloorObject)};e.onInstanceDestroyed=function(a){this.lastFloorObject==a&&(this.lastFloorObject=null)};e.onDestroy=function(){this.lastFloorObject=null;this.runtime.removeDestroyCallback(this.myDestroyCallback)};e.onKeyDown=function(a){switch(a.which){case 38:a.preventDefault();this.jumpkey=!0;break;
case 37:a.preventDefault();this.leftkey=!0;break;case 39:a.preventDefault(),this.rightkey=!0}};e.onKeyUp=function(a){switch(a.which){case 38:a.preventDefault();this.jumped=this.jumpkey=!1;break;case 37:a.preventDefault();this.leftkey=!1;break;case 39:a.preventDefault(),this.rightkey=!1}};e.getGDir=function(){return 0>this.g?-1:1};e.isOnFloor=function(){var a=null,b=null,c,d;c=this.inst.x;d=this.inst.y;this.inst.x+=this.downx;this.inst.y+=this.downy;this.inst.set_bbox_changed();if(this.lastFloorObject&&
this.runtime.testOverlap(this.inst,this.lastFloorObject))return this.inst.x=c,this.inst.y=d,this.inst.set_bbox_changed(),this.lastFloorObject;a=this.runtime.testOverlapSolid(this.inst);!a&&0===this.fallthrough&&(b=this.runtime.testOverlapJumpThru(this.inst,!0));this.inst.x=c;this.inst.y=d;this.inst.set_bbox_changed();if(a){if(this.runtime.testOverlap(this.inst,a))return null;this.floorIsJumpthru=!1;return a}if(b&&b.length){d=a=0;for(c=b.length;a<c;a++)b[d]=b[a],this.runtime.testOverlap(this.inst,
b[a])||d++;if(1<=d)return this.floorIsJumpthru=!0,b[0]}return null};e.tick=function(){};e.posttick=function(){var a=this.runtime.getDt(this.inst),b,c,d,e,m,n,q,p,r;!this.jumpkey&&!this.simjump&&(this.jumped=!1);var s=this.leftkey||this.simleft;d=this.rightkey||this.simright;var t=(this.jumpkey||this.simjump)&&!this.jumped;this.simjump=this.simright=this.simleft=!1;if(this.enabled){this.ignoreInput&&(t=d=s=!1);p=this.lastFloorObject;r=!1;this.firstTick&&((this.runtime.testOverlapSolid(this.inst)||
this.runtime.testOverlapJumpThru(this.inst))&&this.runtime.pushOutSolid(this.inst,-this.downx,-this.downy,4,!0),this.firstTick=!1);if(p&&0===this.dy&&(p.y!==this.lastFloorY||p.x!==this.lastFloorX))b=p.x-this.lastFloorX,c=p.y-this.lastFloorY,this.inst.x+=b,this.inst.y+=c,this.inst.set_bbox_changed(),this.lastFloorX=p.x,this.lastFloorY=p.y,r=!0,this.runtime.testOverlapSolid(this.inst)&&this.runtime.pushOutSolid(this.inst,-b,-c,2.5*Math.sqrt(b*b+c*c));var v=this.isOnFloor();if(c=this.runtime.testOverlapSolid(this.inst))if(this.runtime.pushOutSolidNearest(this.inst,
Math.max(this.inst.width,this.inst.height)/2))this.runtime.registerCollision(this.inst,c);else return;if(v){0<this.dy&&(this.wasOnFloor||(this.runtime.pushInFractional(this.inst,-this.downx,-this.downy,v,16),this.wasOnFloor=!0),this.dy=0);if(p!=v)this.lastFloorObject=v,this.lastFloorX=v.x,this.lastFloorY=v.y,this.runtime.registerCollision(this.inst,v);else if(r&&(c=this.runtime.testOverlapSolid(this.inst)))this.runtime.registerCollision(this.inst,c),0!==b&&(0<b?this.runtime.pushOutSolid(this.inst,
-this.rightx,-this.righty):this.runtime.pushOutSolid(this.inst,this.rightx,this.righty)),this.runtime.pushOutSolid(this.inst,-this.downx,-this.downy);t&&(p=this.inst.x,r=this.inst.y,this.inst.x-=this.downx,this.inst.y-=this.downy,this.inst.set_bbox_changed(),this.runtime.testOverlapSolid(this.inst)?t=!1:(this.runtime.trigger(cr.behaviors.Platform.prototype.cnds.OnJump,this.inst),this.animMode=2,this.dy=-this.jumpStrength,this.jumped=!0),this.inst.x=p,this.inst.y=r,this.inst.set_bbox_changed())}else this.lastFloorObject=
null,this.dy+=this.g*a,this.dy>this.maxFall&&(this.dy=this.maxFall),t&&(this.jumped=!0);this.wasOnFloor=!!v;s==d&&(0>this.dx?(this.dx+=this.dec*a,0<this.dx&&(this.dx=0)):0<this.dx&&(this.dx-=this.dec*a,0>this.dx&&(this.dx=0)));s&&!d&&(this.dx=0<this.dx?this.dx-(this.acc+this.dec)*a:this.dx-this.acc*a);d&&!s&&(this.dx=0>this.dx?this.dx+(this.acc+this.dec)*a:this.dx+this.acc*a);this.dx>this.maxspeed?this.dx=this.maxspeed:this.dx<-this.maxspeed&&(this.dx=-this.maxspeed);s=!1;if(0!==this.dx){p=this.inst.x;
r=this.inst.y;b=this.dx*a*this.rightx;c=this.dx*a*this.righty;this.inst.x+=this.rightx*(1<this.dx?1:-1)-this.downx;this.inst.y+=this.righty*(1<this.dx?1:-1)-this.downy;this.inst.set_bbox_changed();e=!1;m=this.runtime.testOverlapSolid(this.inst);this.inst.x=p+b;this.inst.y=r+c;this.inst.set_bbox_changed();d=this.runtime.testOverlapSolid(this.inst);if(!d&&v&&(d=this.runtime.testOverlapJumpThru(this.inst)))this.inst.x=p,this.inst.y=r,this.inst.set_bbox_changed(),this.runtime.testOverlap(this.inst,d)?
(d=null,e=!1):e=!0,this.inst.x=p+b,this.inst.y=r+c,this.inst.set_bbox_changed();d?(b=Math.abs(this.dx*a)+2,m||!this.runtime.pushOutSolid(this.inst,-this.downx,-this.downy,b,e,d)?(this.runtime.registerCollision(this.inst,d),b=Math.max(Math.abs(2.5*this.dx*a),30),this.runtime.pushOutSolid(this.inst,this.rightx*(0>this.dx?1:-1),this.righty*(0>this.dx?1:-1),b,!1)?v&&(!e&&!this.floorIsJumpthru)&&(p=this.inst.x,r=this.inst.y,this.inst.x+=this.downx,this.inst.y+=this.downy,this.runtime.testOverlapSolid(this.inst)?
this.runtime.pushOutSolid(this.inst,-this.downx,-this.downy,3,!1)||(this.inst.x=p,this.inst.y=r,this.inst.set_bbox_changed()):(this.inst.x=p,this.inst.y=r,this.inst.set_bbox_changed())):(this.inst.x=p,this.inst.y=r,this.inst.set_bbox_changed()),e||(this.dx=0)):!m&&15>Math.abs(this.dy)&&(this.dy=0,v||(s=!0))):(p=this.isOnFloor(),v&&!p?(c=Math.ceil(Math.abs(this.dx*a))+2,p=this.inst.x,r=this.inst.y,this.inst.x+=this.downx*c,this.inst.y+=this.downy*c,this.inst.set_bbox_changed(),this.runtime.testOverlapSolid(this.inst)||
this.runtime.testOverlapJumpThru(this.inst)?this.runtime.pushOutSolid(this.inst,-this.downx,-this.downy,c+2,!0):(this.inst.x=p,this.inst.y=r,this.inst.set_bbox_changed())):p&&0===this.dy&&this.runtime.pushInFractional(this.inst,-this.downx,-this.downy,p,16))}if(0!==this.dy){p=this.inst.x;r=this.inst.y;this.inst.x+=this.dy*a*this.downx;this.inst.y+=this.dy*a*this.downy;b=this.inst.x;d=this.inst.y;this.inst.set_bbox_changed();c=this.runtime.testOverlapSolid(this.inst);e=!1;if(!c&&0<this.dy&&!v){if((e=
0<this.fallthrough?null:this.runtime.testOverlapJumpThru(this.inst,!0))&&e.length){if(this.wasOverJumpthru){this.inst.x=p;this.inst.y=r;this.inst.set_bbox_changed();q=m=0;for(n=e.length;m<n;m++)e[q]=e[m],this.runtime.testOverlap(this.inst,e[m])||q++;e.length=q;this.inst.x=b;this.inst.y=d;this.inst.set_bbox_changed()}1<=e.length&&(c=e[0])}e=!!c}c&&(this.runtime.registerCollision(this.inst,c),b=e?Math.abs(2.5*this.dy*a+10):Math.max(Math.abs(2.5*this.dy*a+10),30),this.runtime.pushOutSolid(this.inst,
this.downx*(0>this.dy?1:-1),this.downy*(0>this.dy?1:-1),b,e,c)?(this.lastFloorObject=c,this.lastFloorX=c.x,this.lastFloorY=c.y,(this.floorIsJumpthru=e)&&(s=!0),this.dy=0):(this.inst.x=p,this.inst.y=r,this.inst.set_bbox_changed(),this.wasOnFloor=!0,e||(this.dy=0)))}3!==this.animMode&&(0<this.dy&&!v)&&(this.runtime.trigger(cr.behaviors.Platform.prototype.cnds.OnFall,this.inst),this.animMode=3);if(v||s)if(3===this.animMode||s||t&&0===this.dy)this.runtime.trigger(cr.behaviors.Platform.prototype.cnds.OnLand,
this.inst),this.animMode=0===this.dx&&0===this.dy?0:1;else if(0!==this.animMode&&(0===this.dx&&0===this.dy)&&(this.runtime.trigger(cr.behaviors.Platform.prototype.cnds.OnStop,this.inst),this.animMode=0),1!==this.animMode&&(0!==this.dx||0!==this.dy)&&!t)this.runtime.trigger(cr.behaviors.Platform.prototype.cnds.OnMove,this.inst),this.animMode=1;0<this.fallthrough&&this.fallthrough--;this.wasOverJumpthru=this.runtime.testOverlapJumpThru(this.inst)}};a.prototype.IsMoving=function(){return 0!==this.dx||
0!==this.dy};a.prototype.CompareSpeed=function(a,b){var c=Math.sqrt(this.dx*this.dx+this.dy*this.dy);return cr.do_cmp(c,a,b)};a.prototype.IsOnFloor=function(){if(0!==this.dy)return!1;var a=null,b=null,c,d;c=this.inst.x;d=this.inst.y;this.inst.x+=this.downx;this.inst.y+=this.downy;this.inst.set_bbox_changed();a=this.runtime.testOverlapSolid(this.inst);!a&&0===this.fallthrough&&(b=this.runtime.testOverlapJumpThru(this.inst,!0));this.inst.x=c;this.inst.y=d;this.inst.set_bbox_changed();if(a)return!this.runtime.testOverlap(this.inst,
a);if(b&&b.length){d=a=0;for(c=b.length;a<c;a++)b[d]=b[a],this.runtime.testOverlap(this.inst,b[a])||d++;if(1<=d)return!0}return!1};a.prototype.IsByWall=function(a){var b=!1,c=this.inst.x,d=this.inst.y;this.inst.x-=3*this.downx;this.inst.y-=3*this.downy;this.inst.set_bbox_changed();if(this.runtime.testOverlapSolid(this.inst))return this.inst.x=c,this.inst.y=d,this.inst.set_bbox_changed(),!1;0===a?(this.inst.x-=2*this.rightx,this.inst.y-=2*this.righty):(this.inst.x+=2*this.rightx,this.inst.y+=2*this.righty);
this.inst.set_bbox_changed();b=this.runtime.testOverlapSolid(this.inst);this.inst.x=c;this.inst.y=d;this.inst.set_bbox_changed();return b};a.prototype.IsJumping=function(){return 0>this.dy};a.prototype.IsFalling=function(){return 0<this.dy};a.prototype.OnJump=function(){return!0};a.prototype.OnFall=function(){return!0};a.prototype.OnStop=function(){return!0};a.prototype.OnMove=function(){return!0};a.prototype.OnLand=function(){return!0};d.cnds=new a;b.prototype.SetIgnoreInput=function(a){this.ignoreInput=
a};b.prototype.SetMaxSpeed=function(a){this.maxspeed=a;0>this.maxspeed&&(this.maxspeed=0)};b.prototype.SetAcceleration=function(a){this.acc=a;0>this.acc&&(this.acc=0)};b.prototype.SetDeceleration=function(a){this.dec=a;0>this.dec&&(this.dec=0)};b.prototype.SetJumpStrength=function(a){this.jumpStrength=a;0>this.jumpStrength&&(this.jumpStrength=0)};b.prototype.SetGravity=function(a){this.g1!==a&&(this.g=a,this.updateGravity(),this.runtime.testOverlapSolid(this.inst)&&(this.runtime.pushOutSolid(this.inst,
this.downx,this.downy,10),this.inst.x+=2*this.downx,this.inst.y+=2*this.downy,this.inst.set_bbox_changed()),this.lastFloorObject=null)};b.prototype.SetMaxFallSpeed=function(a){this.maxFall=a;0>this.maxFall&&(this.maxFall=0)};b.prototype.SimulateControl=function(a){switch(a){case 0:this.simleft=!0;break;case 1:this.simright=!0;break;case 2:this.simjump=!0}};b.prototype.SetVectorX=function(a){this.dx=a};b.prototype.SetVectorY=function(a){this.dy=a};b.prototype.SetGravityAngle=function(a){a=cr.to_radians(a);
a=cr.clamp_angle(a);this.ga!==a&&(this.ga=a,this.updateGravity(),this.lastFloorObject=null)};b.prototype.SetEnabled=function(a){this.enabled=1===a};b.prototype.FallThrough=function(){var a=this.inst.x,b=this.inst.y;this.inst.x+=this.downx;this.inst.y+=this.downy;this.inst.set_bbox_changed();var c=this.runtime.testOverlapJumpThru(this.inst,!1);this.inst.x=a;this.inst.y=b;this.inst.set_bbox_changed();c&&(this.fallthrough=3,this.lastFloorObject=null)};d.acts=new b;c.prototype.Speed=function(a){a.set_float(Math.sqrt(this.dx*
this.dx+this.dy*this.dy))};c.prototype.MaxSpeed=function(a){a.set_float(this.maxspeed)};c.prototype.Acceleration=function(a){a.set_float(this.acc)};c.prototype.Deceleration=function(a){a.set_float(this.dec)};c.prototype.JumpStrength=function(a){a.set_float(this.jumpStrength)};c.prototype.Gravity=function(a){a.set_float(this.g)};c.prototype.GravityAngle=function(a){a.set_float(cr.to_degrees(this.ga))};c.prototype.MaxFallSpeed=function(a){a.set_float(this.maxFall)};c.prototype.MovingAngle=function(a){a.set_float(cr.to_degrees(Math.atan2(this.dy,
this.dx)))};c.prototype.VectorX=function(a){a.set_float(this.dx)};c.prototype.VectorY=function(a){a.set_float(this.dy)};d.exps=new c})();cr.behaviors.Rotate=function(a){this.runtime=a};
(function(){function a(){}function b(){}var c=cr.behaviors.Rotate.prototype;c.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};c.Type.prototype.onCreate=function(){};c.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var d=c.Instance.prototype;d.onCreate=function(){this.speed=cr.to_radians(this.properties[0]);this.acc=cr.to_radians(this.properties[1])};d.saveToJSON=function(){return{speed:this.speed,acc:this.acc}};d.loadFromJSON=
function(a){this.speed=a.speed;this.acc=a.acc};d.tick=function(){var a=this.runtime.getDt(this.inst);0!==a&&(0!==this.acc&&(this.speed+=this.acc*a),0!==this.speed&&(this.inst.angle=cr.clamp_angle(this.inst.angle+this.speed*a),this.inst.set_bbox_changed()))};c.cnds=new function(){};a.prototype.SetSpeed=function(a){this.speed=cr.to_radians(a)};a.prototype.SetAcceleration=function(a){this.acc=cr.to_radians(a)};c.acts=new a;b.prototype.Speed=function(a){a.set_float(cr.to_degrees(this.speed))};b.prototype.Acceleration=
function(a){a.set_float(cr.to_degrees(this.acc))};c.exps=new b})();cr.behaviors.Sin=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){}var d=cr.behaviors.Sin.prototype;d.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};d.Type.prototype.onCreate=function(){};d.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime;this.i=0};var e=d.Instance.prototype,f=2*Math.PI,g=Math.PI/2,h=3*Math.PI/2;e.onCreate=function(){this.active=1===this.properties[0];this.movement=this.properties[1];this.wave=this.properties[2];this.period=
this.properties[3];this.period+=Math.random()*this.properties[4];0===this.period?this.i=0:(this.i=this.properties[5]/this.period*f,this.i+=Math.random()*this.properties[6]/this.period*f);this.mag=this.properties[7];this.mag+=Math.random()*this.properties[8];this.ratio=this.initialValue2=this.initialValue=0;this.init()};e.saveToJSON=function(){return{i:this.i,a:this.active,mv:this.movement,w:this.wave,p:this.period,mag:this.mag,iv:this.initialValue,iv2:this.initialValue2,r:this.ratio,lkv:this.lastKnownValue,
lkv2:this.lastKnownValue2}};e.loadFromJSON=function(a){this.i=a.i;this.active=a.a;this.movement=a.mv;this.wave=a.w;this.period=a.p;this.mag=a.mag;this.initialValue=a.iv;this.initialValue2=a.iv2||0;this.ratio=a.r;this.lastKnownValue=a.lkv;this.lastKnownValue2=a.lkv2||0};e.init=function(){switch(this.movement){case 0:this.initialValue=this.inst.x;break;case 1:this.initialValue=this.inst.y;break;case 2:this.initialValue=this.inst.width;this.ratio=this.inst.height/this.inst.width;break;case 3:this.initialValue=
this.inst.width;break;case 4:this.initialValue=this.inst.height;break;case 5:this.initialValue=this.inst.angle;this.mag=cr.to_radians(this.mag);break;case 6:this.initialValue=this.inst.opacity;break;case 7:this.initialValue=0;break;case 8:this.initialValue=this.inst.x,this.initialValue2=this.inst.y}this.lastKnownValue=this.initialValue;this.lastKnownValue2=this.initialValue2};e.waveFunc=function(a){a%=f;switch(this.wave){case 0:return Math.sin(a);case 1:return a<=g?a/g:a<=h?1-2*(a-g)/Math.PI:(a-h)/
g-1;case 2:return 2*a/f-1;case 3:return-2*a/f+1;case 4:return a<Math.PI?-1:1}return 0};e.tick=function(){var a=this.runtime.getDt(this.inst);if(this.active&&0!==a){0===this.period?this.i=0:(this.i+=a/this.period*f,this.i%=f);switch(this.movement){case 0:this.inst.x!==this.lastKnownValue&&(this.initialValue+=this.inst.x-this.lastKnownValue);this.inst.x=this.initialValue+this.waveFunc(this.i)*this.mag;this.lastKnownValue=this.inst.x;break;case 1:this.inst.y!==this.lastKnownValue&&(this.initialValue+=
this.inst.y-this.lastKnownValue);this.inst.y=this.initialValue+this.waveFunc(this.i)*this.mag;this.lastKnownValue=this.inst.y;break;case 2:this.inst.width=this.initialValue+this.waveFunc(this.i)*this.mag;this.inst.height=this.inst.width*this.ratio;break;case 3:this.inst.width=this.initialValue+this.waveFunc(this.i)*this.mag;break;case 4:this.inst.height=this.initialValue+this.waveFunc(this.i)*this.mag;break;case 5:this.inst.angle!==this.lastKnownValue&&(this.initialValue=cr.clamp_angle(this.initialValue+
(this.inst.angle-this.lastKnownValue)));this.inst.angle=cr.clamp_angle(this.initialValue+this.waveFunc(this.i)*this.mag);this.lastKnownValue=this.inst.angle;break;case 6:this.inst.opacity=this.initialValue+this.waveFunc(this.i)*this.mag/100;0>this.inst.opacity?this.inst.opacity=0:1<this.inst.opacity&&(this.inst.opacity=1);break;case 8:this.inst.x!==this.lastKnownValue&&(this.initialValue+=this.inst.x-this.lastKnownValue),this.inst.y!==this.lastKnownValue2&&(this.initialValue2+=this.inst.y-this.lastKnownValue2),
this.inst.x=this.initialValue+Math.cos(this.inst.angle)*this.waveFunc(this.i)*this.mag,this.inst.y=this.initialValue2+Math.sin(this.inst.angle)*this.waveFunc(this.i)*this.mag,this.lastKnownValue=this.inst.x,this.lastKnownValue2=this.inst.y}this.inst.set_bbox_changed()}};e.onSpriteFrameChanged=function(a,b){switch(this.movement){case 2:this.initialValue*=b.width/a.width;this.ratio=b.height/b.width;break;case 3:this.initialValue*=b.width/a.width;break;case 4:this.initialValue*=b.height/a.height}};a.prototype.IsActive=
function(){return this.active};a.prototype.CompareMovement=function(a){return this.movement===a};a.prototype.ComparePeriod=function(a,b){return cr.do_cmp(this.period,a,b)};a.prototype.CompareMagnitude=function(a,b){return 5===this.movement?cr.do_cmp(this.mag,a,cr.to_radians(b)):cr.do_cmp(this.mag,a,b)};a.prototype.CompareWave=function(a){return this.wave===a};d.cnds=new a;b.prototype.SetActive=function(a){this.active=1===a};b.prototype.SetPeriod=function(a){this.period=a};b.prototype.SetMagnitude=
function(a){this.mag=a;5===this.movement&&(this.mag=cr.to_radians(this.mag))};b.prototype.SetMovement=function(a){5===this.movement&&(this.mag=cr.to_degrees(this.mag));this.movement=a;this.init()};b.prototype.SetWave=function(a){this.wave=a};d.acts=new b;c.prototype.CyclePosition=function(a){a.set_float(this.i/f)};c.prototype.Period=function(a){a.set_float(this.period)};c.prototype.Magnitude=function(a){5===this.movement?a.set_float(cr.to_degrees(this.mag)):a.set_float(this.mag)};c.prototype.Value=
function(a){a.set_float(this.waveFunc(this.i)*this.mag)};d.exps=new c})();cr.behaviors.destroy=function(a){this.runtime=a};
(function(){var a=cr.behaviors.destroy.prototype;a.Type=function(a,c){this.behavior=a;this.objtype=c;this.runtime=a.runtime};a.Type.prototype.onCreate=function(){};a.Instance=function(a,c){this.type=a;this.behavior=a.behavior;this.inst=c;this.runtime=a.runtime};a=a.Instance.prototype;a.onCreate=function(){};a.tick=function(){this.inst.update_bbox();var a=this.inst.bbox,c=this.inst.layer.layout;(0>a.right||0>a.bottom||a.left>c.width||a.top>c.height)&&this.runtime.DestroyInstance(this.inst)}})();
cr.behaviors.scrollto=function(a){this.runtime=a;this.shakeMode=this.shakeEnd=this.shakeStart=this.shakeMag=0};
(function(){function a(){}var b=cr.behaviors.scrollto.prototype;b.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};b.Type.prototype.onCreate=function(){};b.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var c=b.Instance.prototype;c.onCreate=function(){};c.saveToJSON=function(){return{smg:this.behavior.shakeMag,ss:this.behavior.shakeStart,se:this.behavior.shakeEnd,smd:this.behavior.shakeMode}};c.loadFromJSON=function(a){this.behavior.shakeMag=
a.smg;this.behavior.shakeStart=a.ss;this.behavior.shakeEnd=a.se;this.behavior.shakeMode=a.smd};c.tick=function(){};c.tick2=function(){var a=this.behavior.my_instances.values(),b=0,c=0,g,h;g=0;for(h=a.length;g<h;g++)b+=a[g].x,c+=a[g].y;g=this.inst.layer.layout;var l=this.runtime.kahanTime.sum,k=h=0;l>=this.behavior.shakeStart&&l<this.behavior.shakeEnd&&(h=this.behavior.shakeMag*Math.min(this.runtime.timescale,1),0===this.behavior.shakeMode&&(h*=1-(l-this.behavior.shakeStart)/(this.behavior.shakeEnd-
this.behavior.shakeStart)),l=2*Math.random()*Math.PI,k=Math.random()*h,h=Math.cos(l)*k,k*=Math.sin(l));g.scrollToX(b/a.length+h);g.scrollToY(c/a.length+k)};a.prototype.Shake=function(a,b,c){this.behavior.shakeMag=a;this.behavior.shakeStart=this.runtime.kahanTime.sum;this.behavior.shakeEnd=this.behavior.shakeStart+b;this.behavior.shakeMode=c};b.acts=new a})();cr.behaviors.solid=function(a){this.runtime=a};
(function(){function a(){}function b(){}var c=cr.behaviors.solid.prototype;c.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};c.Type.prototype.onCreate=function(){};c.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var d=c.Instance.prototype;d.onCreate=function(){this.inst.extra.solidEnabled=0!==this.properties[0]};d.tick=function(){};a.prototype.IsEnabled=function(){return this.inst.extra.solidEnabled};c.cnds=new a;b.prototype.SetEnabled=
function(a){this.inst.extra.solidEnabled=!!a};c.acts=new b})();
cr.getProjectModel=function(){return[null,"Click to play",[[cr.plugins_.Particles,!1,!0,!0,!1,!0,!0,!0,!0,!0],[cr.plugins_.Sprite,!1,!0,!0,!0,!0,!0,!0,!0,!1],[cr.plugins_.Text,!1,!0,!0,!0,!0,!0,!0,!0,!1],[cr.plugins_.TiledBg,!1,!0,!0,!0,!0,!0,!0,!0,!0],[cr.plugins_.Touch,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.WebStorage,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Button,!1,!0,!0,!0,!1,!1,!1,!1,!1],[cr.plugins_.Arr,!1,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Audio,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.CJSAds,
!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Browser,!0,!1,!1,!1,!1,!1,!1,!1,!1]],[["t0",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0xd6ed150a4249f,[]],["t1",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0xc5a7313f20495,[]],["t2",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0x59af49fb9aa0d,[]],["t3",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,9799484768173632,[]],["t4",cr.plugins_.Text,!1,[],1,0,null,null,[["Anchor",cr.behaviors.Anchor,0xda4de6f5e65b]],!1,!1,0x82cebdc3cf0c0,[]],["t5",cr.plugins_.Text,
!1,[],0,0,null,null,[],!1,!1,95925585672401,[]],["t6",cr.plugins_.Text,!1,[],1,0,null,null,[["Anchor",cr.behaviors.Anchor,0xef5f7aad1b64b]],!1,!1,8735518839043631,[]],["t7",cr.plugins_.Sprite,!1,[],1,0,null,[["opponent",10,!0,1,0,!1,0x486f511c8b7be,[["enemy1-sheet0.png",10580,0,0,90,85,1,0.5,0.505882,[],[-0.291667,-0.278609,0,-0.451337,0.15,-0.124064,0.358333,-0.00588238,0.183333,0.148663,0,0.403209,-0.358333,0.339573],0]]]],[["Pathfinding",cr.behaviors.Pathfinding,5940522986768165]],!1,!1,6880381384705025,
[]],["t8",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!0,1,0,!1,0xd42dfa56f114,[["enemy1b-sheet0.png",10251,0,0,90,65,1,0.5,0.507692,[],[-0.378049,-0.329121,-0.00406501,-0.233882,0.378049,-0.329121,0.272358,0.158975,-0.00406501,0.37326,-0.337398,0.254213,-0.402439,-0.00769234],0]]]],[["Physics",cr.behaviors.Physics,9095812219284104],["Flash",cr.behaviors.Flash,8627171799345703]],!1,!1,4707779943115344,[]],["t9",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,0x6b7a802fcd872,[["enemy2-sheet0.png",
10753,0,0,90,85,1,0.5,0.505882,[],[-0.291667,-0.278609,0,-0.442246,0.15,-0.124064,0.35,-0.00588238,0.175,0.139573,0,0.421391,-0.35,0.330482,-0.333333,-0.00588238],0]]]],[["Pathfinding",cr.behaviors.Pathfinding,7109287280411083]],!1,!1,4659579578507464,[]],["t10",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,837784941544189,[["enemy2b-sheet0.png",9504,0,0,90,65,1,0.5,0.507692,[],[-0.369919,-0.321645,-0.00406501,-0.228622,0.361789,-0.310018,0.272358,0.166727,-0.00406501,0.364401,-0.329268,
0.248122,-0.402439,-0.00769234],0]]]],[["Physics",cr.behaviors.Physics,0xda8b003a959e2],["Flash",cr.behaviors.Flash,8183824584188442]],!1,!1,0xe5896d3a1a840,[]],["t11",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,9355644090519636,[["enemy3-sheet0.png",10985,0,0,90,85,1,0.5,0.505882,[],[-0.291667,-0.278609,0,-0.460428,0.15,-0.124064,0.366667,-0.00588238,0.183333,0.148663,0,0.4123,-0.366667,0.348663,-0.333333,-0.00588238],0]]]],[["Pathfinding",cr.behaviors.Pathfinding,0xbd3e99dd19389]],
!1,!1,7048696778604569,[]],["t12",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,9097588863805382,[["enemy3b-sheet0.png",9972,0,0,90,65,1,0.5,0.507692,[],[-0.378049,-0.329121,-0.00406501,-0.233882,0.378049,-0.329121,0.272358,0.158975,-0.00406501,0.37326,-0.337398,0.254213,-0.402439,-0.00769234],0]]]],[["Physics",cr.behaviors.Physics,6219080593246609],["Flash",cr.behaviors.Flash,9586328277045940]],!1,!1,0x5a54b23973315,[]],["t13",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,
348450160882509,[["enemy4-sheet0.png",10319,0,0,90,85,1,0.5,0.505882,[],[-0.291667,-0.278609,0,-0.460428,0.15,-0.124064,0.358333,-0.00588238,0.183333,0.148663,0,0.403209,-0.358333,0.339573],0]]]],[["Pathfinding",cr.behaviors.Pathfinding,0x68545227cccc0]],!1,!1,5083444961867177,[]],["t14",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,0xf0e907f70370,[["enemy4b-sheet0.png",9792,0,0,90,65,1,0.5,0.507692,[],[-0.378049,-0.329121,-0.00406501,-0.233882,0.369919,-0.317216,0.272358,0.158975,-0.00406501,
0.37326,-0.337398,0.254213,-0.402439,-0.00769234],0]]]],[["Physics",cr.behaviors.Physics,0xd586be06136b],["Flash",cr.behaviors.Flash,0xad7043ef3666e]],!1,!1,0x9696d9a7b974f,[]],["t15",cr.plugins_.WebStorage,!1,[],0,0,null,null,[],!1,!1,5452984529401175,[],[]],["t16",cr.plugins_.Touch,!1,[],0,0,null,null,[],!1,!1,0x9bcf53650dac6,[],[1]],["t17",cr.plugins_.Browser,!1,[],0,0,null,null,[],!1,!1,0x7bd6bbc1bb746,[],[]],["t18",cr.plugins_.Audio,!1,[],0,0,null,null,[],!1,!1,0x90b4fd7382c1d,[],[0,1,1,600,
600,1E4,1,5E3,1]],["t19",cr.plugins_.CJSAds,!1,[],0,0,null,null,[],!1,!1,0x3a819f5bdf174,[],[1,0,0]],["t20",cr.plugins_.Sprite,!1,[0x5b8cf77998459],2,0,null,[["Based",0,!1,1,0,!1,8737978610492001,[["sprite-sheet0.png",16932,0,0,100,110,0,0.45,0.00909091,[["Imagepoint 1",0.19,0.818182]],[-0.24,0.181818,0.05,9.31323E-10,0.29,0.227273,0.5,0.490909,0.33,0.790909,0,0.890909,-0.31,0.754545,-0.39,0.490909],0],["sprite-sheet1.png",16530,0,0,100,110,0,0.45,0,[],[-0.24,0.190909,0.05,0.00909091,0.29,0.236364,
0.5,0.5,0.33,0.8,0.05,0.981818,-0.28,0.845455,-0.39,0.5],0]]]],[["Physics",cr.behaviors.Physics,6478908795844597],["ScrollTo",cr.behaviors.scrollto,7251618584751555]],!1,!1,7983111448969151,[]],["t21",cr.plugins_.Sprite,!1,[],1,0,null,[["tri",5,!1,1,0,!1,6298879286185419,[["sprite8-sheet0.png",17837,0,0,125,93,1,0.504,0.989247,[],[-0.496,-0.612903,-0.2,-0.956989,0.272,-0.870967,0.467999,-0.55914],0]]],["dva",5,!1,1,0,!1,37756960538752,[["sprite8-sheet1.png",13475,0,0,96,93,1,0.520833,0.967742,[],
[-0.343749,-0.913979,0.114584,-0.903226,0.416667,-0.333334,-0.479166,-0.569892],0]]],["odin",5,!1,1,0,!1,396535489189843,[["sprite8-sheet2.png",8653,0,0,71,75,1,0.521127,0.973333,[],[-0.0281687,-0.946667,0.43662,-0.48,-0.0281687,0.0133336,-0.492958,-0.48],0]]]],[["Pin",cr.behaviors.Pin,964111871336449]],!1,!1,4766223455274164,[]],["t22",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,4900383236325392,[["pole-sheet0.png",156,0,0,256,256,1,0,0.488281,[],[],1]]]],[],!1,!1,6383976343780506,
[]],["t23",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",0,!1,1,0,!1,0x8d9e6dc9da61d,[["sprite33-sheet0.png",14513,1,1,90,33,0,0.5,0.515152,[["Imagepoint 1",0.5,-0.151515],["Imagepoint 2",0.5,-0.363636],["Imagepoint 3",0.5,-1.54545],["Imagepoint 4",0.6,-1.12121],["Imagepoint 5",0.455556,-0.727273],["Imagepoint 6",0.477778,-0.787879]],[-0.5,-0.515152,0.5,-0.515152,0.185039,-0.0190275,-0.0125,0.189218,-0.212598,-0.0190275],0],["sprite33-sheet0.png",14513,1,35,90,33,0,0.5,0.515152,[["Imagepoint 1",0.5,
-0.151515],["Imagepoint 2",0.5,-0.363636],["Imagepoint 3",0.5,-1.54545],["Imagepoint 4",0.6,-1.12121],["Imagepoint 5",0.455556,-0.727273],["Imagepoint 6",0.477778,-0.787879]],[-0.5,-0.515152,0.5,-0.515152,0.454887,-0.0273465,0.364662,0.0458245,-0.364662,0.0458245,-0.447368,-0.0273465],0],["sprite33-sheet0.png",14513,1,69,90,33,0,0.5,0.515152,[["Imagepoint 1",0.5,-0.151515],["Imagepoint 2",0.5,-0.363636],["Imagepoint 3",0.5,-1.54545],["Imagepoint 4",0.6,-1.12121],["Imagepoint 5",0.455556,-0.727273],
["Imagepoint 6",0.477778,-0.787879]],[-0.5,-0.515152,0.5,-0.515152,0.478947,-0.273773,0,0.157263,-0.342105,-0.0151515],0],["sprite33-sheet1.png",4421,0,0,90,33,1,0.5,0.515152,[["Imagepoint 1",0.5,-0.151515],["Imagepoint 2",0.5,-0.363636],["Imagepoint 3",0.5,-1.54545],["Imagepoint 4",0.6,-1.12121],["Imagepoint 5",0.455556,-0.727273],["Imagepoint 6",0.477778,-0.787879]],[-0.463158,-0.394462,0,-0.446186,0.457895,-0.377221,0.478947,-0.0151515,0.421053,0.226228,-0.421053,0.226228,-0.489474,-0.0151515],
0]]]],[["Physics",cr.behaviors.Physics,8613828543813326],["Solid",cr.behaviors.solid,0xfd11e38db4d4b]],!1,!1,8684083955520733,[]],["t24",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground.png",4029,1],null,[],!1,!1,420314993375063,[]],["t25",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground2.png",8118,0],null,[],!1,!1,7225769410227324,[]],["t26",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground3.png",91,1],null,[],!1,!1,0x7d9390b30b1bb,[]],["t27",cr.plugins_.TiledBg,!1,[],1,0,["wave.png",8809,0],null,[["Sine3",
cr.behaviors.Sin,5393685804332292]],!1,!1,0xd156143b5b181,[]],["t28",cr.plugins_.TiledBg,!1,[],1,0,["tiledbackground5.png",109,1],null,[["Sine",cr.behaviors.Sin,7052289860098646]],!1,!1,9999359793124664,[]],["t29",cr.plugins_.TiledBg,!1,[],1,0,["tiledbackground6.png",5039,1],null,[["Sine",cr.behaviors.Sin,0x93d4d721c4d23]],!1,!1,0xdae2f99440cd4,[]],["t30",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground7.png",895650,0],null,[],!1,!1,9622222556207228,[]],["t31",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
5,!1,1,0,!1,9774914718013772,[["sprite5-sheet0.png",35267,0,0,145,160,1,0.503448,0.5,[],[-0.337931,-0.35,-0.00689626,-0.4625,0.289655,-0.3125,0.489655,0,0.351724,0.36875,-0.00689626,0.49375,-0.310345,0.325,-0.4,0],0]]]],[],!1,!1,7822087093424266,[]],["t32",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xa570a9e8e14f7,[["sprite6-sheet0.png",371,0,0,32,32,1,0,0.5,[],[],1]]]],[["Anchor",cr.behaviors.Anchor,7905127219666341]],!1,!1,5681971954996828,[]],["t33",cr.plugins_.Particles,!1,[],0,
0,["particles.png",7355,0],null,[],!1,!1,0xc4c12ab7f7e29,[]],["t34",cr.plugins_.Particles,!1,[],0,0,["particles2.png",14015,0],null,[],!1,!1,0x7a28ef69daa30,[]],["t35",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,583630359959441,[["zona-sheet0.png",158,0,0,16,16,1,0.5,0.5,[],[],0]]]],[["Sine",cr.behaviors.Sin,0x7ddad804010c5]],!1,!1,0x8cfbd0b7277f4,[]],["t36",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x728effc51364d,[["sprite13-sheet0.png",9851,0,0,172,117,1,0.5,0.495726,
[],[-0.418605,0.00854751,-0.302326,-0.205128,0,-0.470086,0.215116,-0.0769235,0.482558,0.00854751,0.366279,0.307692,0,0.376069,-0.238372,0.119658],0]]]],[["Bullet",cr.behaviors.Bullet,0x3bd27980c6987]],!1,!1,4726260299347764,[]],["t37",cr.plugins_.Sprite,!1,[6614304799304452],0,0,null,[["Money",5,!0,1,0,!1,0xde8e133cc5833,[["money-sheet0.png",13895,1,1,50,50,1,0.5,0.5,[],[-0.32,-0.32,0,-0.46,0.32,-0.32,0.46,0,0.32,0.32,0,0.46,-0.32,0.32,-0.46,0],0],["money-sheet0.png",13895,52,1,50,50,1,0.5,0.5,[],
[-0.34,-0.34,0,-0.48,0.32,-0.32,0.42,0,0.32,0.32,0,0.48,-0.34,0.34,-0.48,0],0],["money-sheet0.png",13895,1,52,50,50,1,0.5,0.5,[],[-0.14,-0.14,0,-0.48,0.14,-0.14,0.14,0.14,0,0.48,-0.14,0.14],0],["money-sheet0.png",13895,52,52,50,50,1,0.5,0.5,[],[-0.3,-0.3,0,-0.48,0.32,-0.32,0.48,0,0.34,0.34,0,0.5,-0.3,0.3,-0.4,0],0],["money-sheet1.png",3169,0,0,50,50,1,0.5,0.5,[],[-0.32,-0.32,0,-0.46,0.32,-0.32,0.46,0,0.32,0.32,0,0.46,-0.32,0.32,-0.46,0],0]]]],[],!1,!1,6207480267219106,[]],["t38",cr.plugins_.Sprite,
!1,[0xb38b2328e435d],1,0,null,[["Default",7,!0,1,0,!1,8286719369318634,[["sprite43-sheet0.png",6229,0,0,120,100,1,0.5,0.5,[],[-0.066667,0.02,0,-0.23,0.358333,-0.33,0.266667,0,0.183333,0.12,0,0.17,-0.408333,0.39,-0.058333,0],0],["sprite43-sheet1.png",6157,0,0,120,100,1,0.5,0.5,[],[-0.066667,0.02,0,-0.23,0.358333,-0.33,0.258333,0,0.175,0.11,0,0.17,-0.408333,0.39,-0.058333,0],0],["sprite43-sheet2.png",5956,0,0,120,100,1,0.5,0.5,[],[-0.066667,0.02,0,-0.23,0.333333,-0.3,0.266667,0,0.175,0.11,0,0.18,-0.391667,
0.37,-0.066667,0],0]]]],[["Platform",cr.behaviors.Platform,4803861594746904]],!1,!1,7191455444154332,[]],["t39",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8740002270914801,[["trigerleftdevil-sheet0.png",169,0,0,256,256,1,0.5,0.5,[],[],3]]]],[],!1,!1,9700076726606008,[]],["t40",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8052517787862265,[["trigerrightdevil-sheet0.png",169,0,0,256,256,1,0.5,0.5,[],[],3]]]],[],!1,!1,5631861832731567,[]],["t41",cr.plugins_.Sprite,!1,[],1,
0,null,[["Default",5,!1,1,0,!1,0x7ef2b63e6477c,[["trigerleftdevil-sheet0.png",169,0,0,256,256,1,-0.015625,0.480469,[],[1.01563,-0.480469,1.01563,0.519531,0.015625,0.519531,0.015625,-0.480469],3]]]],[["Pin",cr.behaviors.Pin,562147572145862]],!1,!1,0xa8429c3e2a94e,[]],["t42",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,5697333415586603,[["trigerleftdevil-sheet0.png",169,0,0,256,256,1,1.02344,0.492188,[],[],3]]]],[["Pin",cr.behaviors.Pin,670444193734214]],!1,!1,0xb87218c6da247,[]],["t43",
cr.plugins_.Sprite,!1,[7929863946317271],2,0,null,[["Default",10,!0,1,0,!1,9951742473179680,[["sprite44-sheet0.png",9530,0,0,100,100,1,0.5,0.5,[],[],0],["sprite44-sheet1.png",9392,0,0,100,100,1,0.5,0.5,[],[0.5,-0.5,0.5,0.5,-0.5,0.5,-0.5,-0.5],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,0xfe57d220abf76],["Bullet",cr.behaviors.Bullet,491200539319976]],!1,!1,7640195052397519,[]],["t44",cr.plugins_.Sprite,!1,[],0,0,null,[["Kaktus",5,!1,1,0,!1,0xfd7994e7a0d60,[["sprite45-sheet0.png",30512,1,1,
90,100,1,0.5,0.53,[],[0.116071,-0.011203,0,0.048947,-0.125,-0.00368398,0.366071,-0.033759,0.107143,0.139173,0,0.447444,-0.473214,0.447444,-0.321429,-0.033759],0]]],["KaktusActive",5,!1,1,0,!1,0x6898bb3bf961b,[["sprite45-sheet0.png",30512,92,1,90,100,1,0.5,0.5,[["Imagepoint 1",0.166667,0.12]],[0.116071,0.018797,0,0.078947,-0.125,0.026316,0.366071,-0.003759,0.107143,0.169173,0,0.477444,-0.473214,0.477444,-0.321429,-0.003759],0],["sprite45-sheet0.png",30512,1,102,90,100,1,0.488889,0.52,[["Imagepoint 1",
0.188889,0.1]],[0.0021821,-0.106466,0.0111111,-0.301955,0.243254,-0.023759,0.0736111,0.111579,0.0111111,0.457444,-0.471032,0.464962,-0.363889,-0.023759],0],["sprite45-sheet0.png",30512,92,102,90,100,5,0.5,0.5,[["Imagepoint 1",-0.0444444,0.01],["Imagepoint 2",0.0222222,-0.14]],[-0.473214,-0.477444,0,-0.169173,0.017857,-0.093985,0.00892901,-0.003759,-0.017857,0.06391,0,0.477444,-0.491071,0.492481,-0.428571,-0.003759],0]]]],[],!1,!1,7236802420045206,[]],["t45",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",
5,!1,1,0,!1,427505792160182,[["shyp2-sheet0.png",393,0,0,27,13,1,0.481481,0.461538,[],[0.222223,-0.0769235,0.0370375,0.153847,-0.407407,0.384616,-0.481481,0.0769235,-0.407407,-0.307692,0.0370375,-0.384615,0.481481,-0.384615,0.148149,0.0769235],0]]]],[["Bullet",cr.behaviors.Bullet,7506353068067827],["DestroyOutsideLayout",cr.behaviors.destroy,0x938c54caa186e]],!1,!1,0x94dc847d7191f,[]],["t46",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,7295979503653228,[["shyp2-sheet0.png",393,0,0,27,
13,1,0.481481,0.461538,[],[0.222223,-0.0769235,0.0370375,0.153847,-0.407407,0.384616,-0.481481,0.0769235,-0.407407,-0.307692,0.0370375,-0.384615,0.481481,-0.384615,0.148149,0.0769235],0]]]],[["Bullet",cr.behaviors.Bullet,0x7cb9612eeeb6d],["DestroyOutsideLayout",cr.behaviors.destroy,0xd839a5cc03614]],!1,!1,0xf597b1e30175,[]],["t47",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,8689102293338516,[["sprite46-sheet0.png",11869,0,0,100,100,1,0.5,0.5,[["Imagepoint 1",0.06,0.29]],[0.272487,0.274869,
0.00264502,0.494764,-0.309524,0.311518,-0.283069,-0.00261801,-0.224868,-0.227749,0.00264502,-0.301047,0.362434,-0.363874],0]]]],[["Pathfinding",cr.behaviors.Pathfinding,9107041566799416]],!1,!1,7448904862200407,[]],["t48",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!0,1,0,!1,0x9b0f27d82633a,[["sprite47-sheet0.png",1789,0,0,40,20,1,0.5,0.5,[],[-0.00943401,-0.403226,0.386792,-0.306452,0.462264,-0.016129,0.40566,0.33871,-0.00943401,0.435484,-0.311321,0.177419,-0.424528,-0.016129],0]]]],[["DestroyOutsideLayout",
cr.behaviors.destroy,0xc3c22e0a49ed6],["Bullet",cr.behaviors.Bullet,0xa278e1cc8ba20]],!1,!1,6434522116670197,[]],["t49",cr.plugins_.Sprite,!1,[],0,0,null,[["Boo",5,!1,1,0,!1,8277935333016557,[["sprite48-sheet0.png",48350,1,1,90,90,1,0.5,0.5,[],[-0.252137,-0.256303,-0.00427401,-0.390756,0.260684,-0.264706,0.311966,-0.00420201,0.448718,0.44958,-0.00427401,0.483193,-0.32906,0.331933,-0.252137,-0.00420201],0]]],["BooActive",5,!1,1,0,!1,0xa3d515771ca9e,[["sprite48-sheet0.png",48350,92,1,90,90,1,0.5,0.5,
[],[-0.183761,-0.189076,-0.00427401,-0.315126,0.260684,-0.264706,0.277778,-0.00420201,0.440171,0.441176,-0.00427401,0.491597,-0.320513,0.323529,-0.269231,-0.00420201],0],["sprite48-sheet0.png",48350,1,92,90,90,1,0.5,0.5,[],[-0.226496,-0.231092,-0.00427401,-0.357143,0.303419,-0.306723,0.337607,-0.00420201,0.448718,0.44958,-0.00427401,0.491597,-0.303419,0.306723,-0.294872,-0.00420201],0],["sprite48-sheet0.png",48350,92,92,90,90,1,0.5,0.5,[],[-0.00427401,-0.390756,0.32906,-0.331933,0.320513,-0.00420201,
0.440171,0.441176,-0.00427401,0.491597,-0.311966,0.315126,-0.380342,-0.00420201],0],["sprite48-sheet1.png",9432,0,0,90,90,1,0.5,0.5,[],[-0.132479,-0.138655,-0.00427401,-0.231092,0.132479,-0.138655,0.260684,-0.00420201,0.440171,0.441176,-0.00427401,0.483193,-0.303419,0.306723],0]]]],[],!1,!1,0xdb7f1a2eef305,[]],["t50",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5445375725713657,[["sprite9-sheet0.png",428,0,0,256,256,1,0.5,0.5,[],[],0]]]],[],!1,!1,0xc6ae76ec3879f,[]],["t51",cr.plugins_.Sprite,
!1,[],2,0,null,[["Default",5,!1,1,0,!1,0xc5778da713fb2,[["sprite7-sheet0.png",9986,0,0,104,56,1,0.5,0.5,[],[-0.442308,-0.392857,0,-0.464286,0.442308,-0.392857,0.403846,0,0.326923,0.178571,0,0.25,-0.278846,0.089286,-0.413462,0],0]]]],[["Physics",cr.behaviors.Physics,0x5389e78a77d1e],["Solid",cr.behaviors.solid,8500276874454926]],!1,!1,7618983472412917,[]],["t52",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xe9ceef706fb3c,[["sprite12-sheet0.png",18136,0,0,273,57,1,0.501832,0.508772,[],
[-0.465202,-0.333333,-0.00366354,-0.491228,0.479853,-0.421053,0.498168,-0.0175439,0.483516,0.421053,-0.00366354,0.473684,-0.465202,0.315789,-0.501832,-0.0175439],0]]]],[["Anchor",cr.behaviors.Anchor,0x723ad6109be2]],!1,!1,0xa90ce588a8c85,[]],["t53",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,9428556215484612,[["sprite29-sheet0.png",644,0,0,216,43,1,0.5,0.511628,[],[-0.486111,-0.44186,0,-0.511628,0.486111,-0.44186,0.5,-0.0232559,0.486111,0.418605,0,0.488372,-0.486111,0.418605,-0.5,-0.0232559],
0]]]],[["Anchor",cr.behaviors.Anchor,0xc3fb211f7d62f]],!1,!1,0xce52ea97b8f5f,[]],["t54",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,8147727064429666,[["sprite32-sheet0.png",675,0,0,43,51,1,0.511628,0.509804,[],[-0.44186,-0.45098,-0.0232559,-0.509804,0.372093,-0.411765,0.488372,-0.019608,0.395349,0.411765,-0.0232559,0.294118,-0.325581,-0.019608],0]]]],[["Anchor",cr.behaviors.Anchor,0x48483d229f132]],!1,!1,6024242735891091,[]],["t55",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,
1,0,!1,4590788357568142,[["money-sheet1.png",3169,0,0,50,50,1,0.5,0.5,[],[-0.32,-0.32,0,-0.46,0.32,-0.32,0.46,0,0.32,0.32,0,0.46,-0.32,0.32,-0.46,0],0]]]],[],!1,!1,0x5b43d9b227823,[]],["t56",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x96ea5a7bd374b,[["power-sheet0.png",3283,0,0,37,37,1,0.513514,0.513514,[],[-0.351351,-0.351351,-0.0270275,-0.513514,0.324324,-0.351351,0.486486,-0.0270275,0.324324,0.324324,-0.0270275,0.486486,-0.351351,0.324324,-0.513514,-0.0270275],0]]]],[],!1,!1,0x3d6165e820381,
[]],["t57",cr.plugins_.Sprite,!1,[0xca7dea269b80d],0,0,null,[["Default",5,!1,1,0,!1,312293211061599,[["moneymini-sheet0.png",820,0,0,20,20,1,0.5,0.5,[],[-0.3,-0.3,0,-0.45,0.3,-0.3,0.45,0,0.3,0.3,0,0.45,-0.3,0.3,-0.45,0],0]]]],[],!1,!1,7131178667890135,[]],["t58",cr.plugins_.Button,!1,[],0,0,null,null,[],!1,!1,0xcba3fec3a8596,[]],["t59",cr.plugins_.Button,!1,[],0,0,null,null,[],!1,!1,5085050712202608,[]],["t60",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",16,!1,1,0,!1,8011722899305558,[["sprite36-sheet0.png",
3063,0,0,100,100,1,0.5,0.5,[],[-0.15,-0.15,0,-0.18,0.15,-0.15,0.24,0,0.25,0.25,0,0.33,-0.25,0.25,-0.26,0],0],["sprite36-sheet1.png",4112,0,0,100,100,1,0.5,0.5,[],[-0.18,-0.18,0,-0.28,0.25,-0.25,0.34,0,0.28,0.28,0,0.39,-0.27,0.27,-0.33,0],0],["sprite36-sheet2.png",4783,0,0,100,100,1,0.5,0.5,[],[-0.28,-0.28,0,-0.42,0.24,-0.24,0.49,0,0.34,0.34,0,0.44,-0.32,0.32,-0.38,0],0]]]],[["Rotate",cr.behaviors.Rotate,4587002654321112]],!1,!1,4714252902354859,[]],["t61",cr.plugins_.Sprite,!1,[],0,0,null,[["Rpass",
5,!1,1,0,!1,348572770404253,[["sprite37-sheet0.png",35629,1,1,100,100,1,-0.09,-0.09,[["Imagepoint 1",0.41,0.77]],[0.362727,0.365,0.585868,0.331667,0.693306,0.49,0.709835,0.59,0.825537,0.823333,0.585868,1.09,0.288347,0.89,0.09,0.59],0]]],["Ractiv",5,!1,1,0,!1,0xfbd79df876a17,[["sprite37-sheet0.png",35629,102,1,100,100,1,-0.09,-0.09,[["Imagepoint 1",0.41,0.75]],[0.362727,0.365,0.585868,0.331667,0.693306,0.49,0.709835,0.59,0.825537,0.823333,0.585868,1.09,0.288347,0.89,0.09,0.59],0],["sprite37-sheet0.png",
35629,1,102,100,100,1,-0.09,-0.09,[["Imagepoint 1",0.42,0.77]],[0.362727,0.365,0.585868,0.331667,0.668512,0.515,0.982562,0.59,0.825537,0.823333,0.585868,1.09,0.288347,0.89,0.362727,0.59],0],["sprite37-sheet0.png",35629,102,102,100,100,5,-0.09,-0.09,[["Imagepoint 1",0.45,0.79]],[0.205702,0.206667,0.585868,0.173333,0.693306,0.49,0.709835,0.59,0.792479,0.79,0.585868,1.09,0.288347,0.89,0.379256,0.59],0]]]],[],!1,!1,0xce3cbd5b4f933,[]],["t62",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,8740371506640679,
[["rock-sheet0.png",3403,0,0,42,50,1,0.5,0.5,[],[-0.190476,-0.24,0,-0.44,0.380952,-0.4,0.47619,0,0.309524,0.34,0,0.48,-0.357143,0.38,-0.452381,0],0]]]],[["Bullet",cr.behaviors.Bullet,7889595565618847],["DestroyOutsideLayout",cr.behaviors.destroy,7824750421043702]],!1,!1,0xb30bc4df1c758,[]],["t63",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,494393263022259,[["shypboo-sheet0.png",39682,1,1,232,241,1,0.5,0.502075,[],[0.030172,-0.33195,0.349138,-0.00414971,0,0.336099,-0.366379,-0.0248967],
0],["shypboo-sheet0.png",39682,234,1,232,241,1,0.5,0.502075,[],[0.025862,-0.419087,0.452586,-0.00414971,0,0.427386,-0.435345,0.0497923],0],["shypboo-sheet0.png",39682,1,243,232,241,1,0.5,0.502075,[],[0.00431103,-0.448133,0.452586,-0.00414971,0,0.46473,-0.452586,-0.00414971],0],["shypboo-sheet0.png",39682,234,243,232,241,1,0.5,0.502075,[],[0,-0.452282,0.452586,-0.00414971,0,0.427386,-0.452586,-0.00414971],0]]]],[["Bullet",cr.behaviors.Bullet,0x83d74b7fb487e]],!1,!1,9416206053119484,[]],["t64",cr.plugins_.Sprite,
!1,[0xe59e4e5090566],3,0,null,[["Ghost",5,!1,1,0,!1,73532002164539,[["sprite49-sheet0.png",10067,0,0,94,103,1,0.5,0.504854,[],[0.095745,-0.00970837,0.138298,0.165049,0,0.320389,-0.244681,0.262136,-0.393617,-0.00970837,-0.361702,-0.37864,0,-0.446602,0.297872,-0.320388],0]]],["GhostActive",5,!1,1,0,!1,0xa66989ed377e,[["sprite49-sheet1.png",10447,0,0,94,103,1,0.5,0.504854,[],[0.425532,-0.00970837,0.223404,0.242719,0,0.252428,-0.223404,0.242719,-0.393617,-0.00970837,-0.340426,-0.359223,0,-0.456311,0.117021,
-0.155339],0]]]],[["Pathfinding",cr.behaviors.Pathfinding,9337734894289636],["Sine",cr.behaviors.Sin,0xe123e3d846b36],["Sine2",cr.behaviors.Sin,0xd6d8a6f337378]],!1,!1,5861108256700558,[]],["t65",cr.plugins_.Sprite,!1,[],0,0,null,[["Hypno",5,!1,1,0,!1,7272054251169412,[["sprite50-sheet0.png",2959,0,0,100,100,1,0.5,0.5,[],[-0.24,-0.24,0,-0.49,0.27,-0.27,0.25,0,0.27,0.27,0,0.49,-0.13,0.13,-0.12,0],0]]],["HypnoActive",5,!1,1,0,!1,7031300884578401,[["sprite50-sheet1.png",2959,0,0,100,100,1,0.5,0.5,[],
[-0.24,-0.24,0,-0.49,0.27,-0.27,0.25,0,0.27,0.27,0,0.49,-0.13,0.13,-0.12,0],0],["sprite50-sheet2.png",3117,0,0,100,100,1,0.5,0.5,[],[-0.3,-0.3,0,-0.45,0.22,-0.22,0.22,0,0.24,0.24,0,0.49,-0.14,0.14,-0.13,0],0]]]],[],!1,!1,9071115629116020,[]],["t66",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,5132261950946456,[["sprite51-sheet0.png",5164,0,0,60,55,1,0.5,0.509091,[],[-0.266667,-0.254546,0,-0.509091,0.266667,-0.254546,0.383333,-0.0181819,0.416667,0.4,0,0.472727,-0.45,0.436364,-0.383333,
-0.0181819],0]]]],[["Physics",cr.behaviors.Physics,0x44eb88951624f],["Bullet",cr.behaviors.Bullet,9666710494167036]],!1,!1,0xc41119e490ec7,[]],["t67",cr.plugins_.Sprite,!1,[],1,0,null,[["Haha",5,!1,1,0,!1,8548608194816549,[["sprite52-sheet0.png",31749,1,1,90,90,1,0.5,0.5,[],[-0.13,-0.13,0,-0.44,0.3,-0.3,0.38,0,0.31,0.31,0,0.46,-0.27,0.27,-0.27,0],0]]],["HahaActive",5,!1,1,0,!1,9100331424016872,[["sprite52-sheet0.png",31749,92,1,90,90,1,0.5,0.5,[],[-0.27,-0.27,0,-0.32,0.24,-0.24,0.35,0,0.29,0.29,0,
0.44,-0.27,0.27,-0.36,0],0],["sprite52-sheet0.png",31749,1,92,90,90,1,0.5,0.5,[],[-0.21,-0.21,0,-0.26,0.19,-0.19,0.33,0,0.32,0.32,0,0.44,-0.32,0.32,-0.41,0],0],["sprite52-sheet0.png",31749,92,92,90,90,1,0.5,0.5,[],[-0.19,-0.19,0,-0.25,0.2,-0.2,0.36,0,0.32,0.32,0,0.48,-0.31,0.31,-0.34,0],0]]]],[["Platform",cr.behaviors.Platform,0x53581427c8928]],!1,!1,736578893746179,[]],["t68",cr.plugins_.Sprite,!1,[],0,0,null,[["Smoke",5,!1,1,0,!1,9096966130590516,[["sprite53-sheet0.png",29263,1,1,90,90,1,0.5,0.5,
[],[-0.2,-0.2,0,-0.47,0.37,-0.37,0.39,0,0.39,0.39,0,0.48,-0.16,0.16,-0.49,0],0]]],["SmokeActive",5,!1,1,0,!1,5480758112010495,[["sprite53-sheet0.png",29263,92,1,90,90,1,0.5,0.5,[],[-0.2,-0.2,0,-0.47,0.37,-0.37,0.39,0,0.39,0.39,0,0.48,-0.16,0.16,-0.49,0],0],["sprite53-sheet0.png",29263,1,92,90,90,1,0.5,0.5,[],[-0.21,-0.21,0,-0.47,0.37,-0.37,0.36,0,0.38,0.38,0,0.48,-0.17,0.17,-0.41,0],0],["sprite53-sheet0.png",29263,92,92,90,90,1,0.5,0.5,[],[-0.24,-0.24,0,-0.47,0.37,-0.37,0.39,0.39,0,0.48,-0.16,0.16,
-0.39,0],0],["sprite53-sheet1.png",30793,1,1,90,90,1,0.5,0.5,[],[-0.29,-0.29,0,-0.49,0.37,-0.37,0.39,0.39,0,0.48,-0.18,0.18,-0.08,0],0],["sprite53-sheet1.png",30793,92,1,90,90,3,0.5,0.5,[],[-0.3,-0.3,0,-0.49,0.37,-0.37,0.39,0,0.39,0.39,0,0.48,-0.2,0.2,-0.42,0],0],["sprite53-sheet1.png",30793,1,92,90,90,1,0.5,0.5,[],[-0.29,-0.29,0,-0.49,0.37,-0.37,0.39,0.39,0,0.48,-0.18,0.18,-0.08,0],0]]]],[],!1,!1,0x93918cfff04b6,[]],["t69",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,6701469529712617,
[["trigerleftdevil-sheet0.png",169,0,0,256,256,1,0.5,0.5,[],[],3]]]],[["Pin",cr.behaviors.Pin,6931275636970879]],!1,!1,0x897db6ecad7ec,[]],["t70",cr.plugins_.Sprite,!1,[],3,0,null,[["Default",5,!0,1,0,!1,0xbfa69223dfd0b,[["smoke4-sheet0.png",11471,0,0,107,102,1,0.504673,0.5,[],[-0.280374,-0.264706,-0.00934589,-0.343137,0.28972,-0.284314,0.411215,0,0.196262,0.186275,-0.00934589,0.303922,-0.242991,0.22549,-0.383178,0],0]]]],[["Sine",cr.behaviors.Sin,5230592688355225],["Sine2",cr.behaviors.Sin,9778582323056542],
["Pathfinding",cr.behaviors.Pathfinding,0x8ea14afc32375]],!1,!1,0xa6dd88872196,[]],["t71",cr.plugins_.Sprite,!1,[],3,0,null,[["Default",5,!1,1,0,!1,9503981831100604,[["smoke4-sheet0.png",11471,0,0,107,102,1,0.504673,0.5,[],[-0.280374,-0.264706,-0.00934589,-0.343137,0.28972,-0.284314,0.411215,0,0.196262,0.186275,-0.00934589,0.303922,-0.242991,0.22549,-0.383178,0],0]]]],[["Sine",cr.behaviors.Sin,0x4a0f49dbadfd5],["Sine2",cr.behaviors.Sin,5495523246589596],["Pathfinding",cr.behaviors.Pathfinding,6508629567879658]],
!1,!1,9876633097077786,[]],["t72",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,899981400257982,[["sprite54-sheet0.png",9108,0,0,120,100,1,0.5,0.5,[],[-0.258333,-0.21,0,-0.4,0.225,-0.17,0.208333,0,0.35,0.32,0,0.47,-0.4,0.38,-0.241667,0],0],["sprite54-sheet1.png",9305,0,0,120,100,1,0.5,0.5,[],[-0.258333,-0.21,0,-0.4,0.208333,-0.15,0.175,0,0.358333,0.33,0,0.47,-0.375,0.35,-0.25,0],0]]]],[["Pathfinding",cr.behaviors.Pathfinding,7673852344885913]],!1,!1,763349527628371,[]],["t73",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",5,!0,1,0,!1,6190633269182962,[["alienradius-sheet0.png",3007,1,1,100,100,1,0.5,0.5,[],[-0.2,-0.2,0,-0.29,0.2,-0.2,0.29,0,0.2,0.2,0,0.29,-0.2,0.2,-0.29,0],0],["alienradius-sheet0.png",3007,102,1,100,100,1,0.5,0.5,[],[-0.2,-0.2,0,-0.29,0.2,-0.2,0.29,0,0.2,0.2,0,0.29,-0.2,0.2,-0.29,0],0],["alienradius-sheet0.png",3007,1,102,100,100,1,0.5,0.5,[],[],0],["alienradius-sheet0.png",3007,102,102,100,100,1,0.5,0.5,[],[],0],["alienradius-sheet1.png",2634,1,1,100,100,1,0.5,0.5,[],[],
0],["alienradius-sheet1.png",2634,102,1,100,100,1,0.5,0.5,[],[-0.0050,-0.27,0.28,0.015,-0.015,0.31,-0.29,0.00999999],0]]]],[],!1,!1,7043982641123959,[]],["t74",cr.plugins_.Sprite,!1,[],1,0,null,[["Robot",5,!0,1,0,!1,0xe0ce21cbef854,[["sprite55-sheet0.png",11163,0,0,75,100,1,0.506667,0.5,[["Imagepoint 1",0.106667,0.38]],[-0.126667,-0.196,-0.00666666,-0.476,0.303333,-0.348,0.363333,-0.00400001,0.113333,0.196,-0.00666666,0.244,-0.186667,0.244,-0.146667,-0.00400001],0],["sprite55-sheet1.png",11184,0,
0,75,100,1,0.506667,0.5,[["Imagepoint 1",0.12,0.38]],[-0.126667,-0.196,-0.00666666,-0.476,0.303333,-0.348,0.363333,-0.00400001,0.113333,0.196,-0.00666666,0.252,-0.186667,0.244,-0.146667,-0.00400001],0]]]],[["Sine",cr.behaviors.Sin,0x8a7421a13fcec]],!1,!1,0x469f48e62679e,[]],["t75",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,7731428872371195,[["sprite56-sheet0.png",20820,1,42,250,40,1,0.892,0.5,[],[0.046503,-0.122951,0.049176,0.139344,-0.057775,-0.00819701],0],["sprite56-sheet0.png",
20820,252,42,250,40,1,0.892,0.5,[],[0.046503,-0.122951,0.054524,-0.00819701,0.046503,0.122951,-0.10323,-0.00819701],0],["sprite56-sheet0.png",20820,1,83,250,40,1,0.896,0.5,[],[0.042503,-0.122951,0.045176,0.139344,-0.061775,-0.00819701],0],["sprite56-sheet0.png",20820,252,83,250,40,1,0.892,0.5,[],[0.046503,-0.122951,0.054524,-0.00819701,0.046503,0.122951,-0.178096,-0.00819701],0],["sprite56-sheet0.png",20820,1,124,250,40,1,0.892,0.5,[],[0.046503,-0.122951,0.049176,0.139344,-0.057775,-0.00819701],0],
["sprite56-sheet0.png",20820,1,1,500,40,1,0.964,0.5,[],[-0.9415,-0.204918,-0.464,-0.07377,0.01475,-0.221311,0.02475,-0.00819701,0.01475,0.221311,-0.464,0.106557,-0.944,0.237705,-0.9565,-0.00819701],0]]]],[["Pin",cr.behaviors.Pin,0xecba2a4e7a686]],!1,!1,0xaec921adf4989,[]],["t76",cr.plugins_.Sprite,!1,[],0,0,null,[["Slizen",5,!1,1,0,!1,7712257368223786,[["sprite57-sheet0.png",39623,1,1,75,75,1,0.506667,0.506667,[["Imagepoint 1",-0.04,-0.0666667]],[-0.266667,-0.266667,-0.00666666,-0.476667,0.213333,
-0.226667,0.223333,-0.00666666,0.353333,0.353333,-0.00666666,0.473333,-0.436667,0.423333,-0.446667,-0.00666666],0]]],["SlizenActive",5,!1,1,0,!1,0xfb44cebcf979d,[["sprite57-sheet0.png",39623,77,1,75,75,1,0.506667,0.506667,[["Imagepoint 1",-0.08,-0.0666667]],[-0.266667,-0.266667,-0.00666666,-0.476667,0.213333,-0.226667,0.223333,-0.00666666,0.353333,0.353333,-0.00666666,0.473333,-0.436667,0.423333,-0.446667,-0.00666666],0],["sprite57-sheet0.png",39623,153,1,75,75,1,0.493333,0.506667,[["Imagepoint 1",
-0.0133333,-0.0133333]],[-0.393333,-0.406667,0.00666666,-0.376667,0.226667,-0.226667,0.266667,-0.00666666,0.396667,0.383333,0.00666666,0.473333,-0.463333,0.463333,-0.413333,-0.00666666],0],["sprite57-sheet0.png",39623,1,77,75,75,1,0.506667,0.546667,[["Imagepoint 1",-0.08,-0.04]],[-0.392632,-0.422857,-0.00666666,-0.518095,0.256491,-0.289524,0.282807,-0.0514287,0.414386,0.367619,-0.00666666,0.443809,-0.234737,0.158095,-0.436491,-0.0514287],0],["sprite57-sheet0.png",39623,77,77,75,75,1,0.506667,0.506667,
[["Imagepoint 1",-0.16,-0.173333]],[-0.266667,-0.266667,-0.00666666,-0.396667,0.213333,-0.226667,0.243333,-0.00666666,0.373333,0.373333,-0.00666666,0.453333,-0.466667,0.453333,-0.436667,-0.00666666],0]]]],[],!1,!1,7435679795178088,[]],["t77",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,6581588077969102,[["sprite58-sheet0.png",12314,0,0,110,98,1,0.5,0.5,[],[-0.381818,-0.367347,0,-0.489796,0.345455,-0.326531,0.490909,0,0.381818,0.367347,0,0.489796,-0.336364,0.316327,-0.5,0],0]]]],[["Bullet",
cr.behaviors.Bullet,6675322382329345]],!1,!1,0xab69c175468a9,[]],["t78",cr.plugins_.TiledBg,!1,[],1,0,["tiledbackground10.png",848,1],null,[["Sine",cr.behaviors.Sin,0x6cddf4dcdc79e]],!1,!1,8309963438197639,[]],["t79",cr.plugins_.TiledBg,!1,[],0,0,["earth2.png",106,3],null,[],!1,!1,7776350063643525,[]],["t80",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,0x9de36e25f4e2,[["sprite2-sheet0.png",37727,0,0,334,143,1,0.5,0.503497,[],[-0.392216,-0.251749,0,-0.111889,0.383234,-0.23077,0.473054,
-0.00699252,0.458084,0.398601,0,0.433566,-0.404192,0.272727],0]]]],[["Sine",cr.behaviors.Sin,5490355045450157],["Sine2",cr.behaviors.Sin,0x8247e31f85769]],!1,!1,7431245606040404,[]],["t81",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,4669414876623559,[["sprite3-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,8942463766778027,[]],["t82",cr.plugins_.TiledBg,!1,[9204504007671788],0,0,["enemyspawner.png",1570,1],null,[],!1,!1,0x66d3ceb87c91e,[]],["t83",cr.plugins_.Sprite,!1,[],
0,0,null,[["Default",5,!1,1,0,!1,0xf3adcc681ccc9,[["sprite4-sheet0.png",9231,0,0,124,44,1,0.491935,0.454545,[],[-0.362523,-0.0795455,0.00610352,-0.420455,0.300222,0.147728,0.0923785,0.0454545,0.449241,0.375,0.00610352,0.46591,-0.417426,0.329546,-0.358602,0.0454545],0]]]],[],!1,!1,654980345162704,[]],["t84",cr.plugins_.TiledBg,!1,[],1,0,["tiledbackground8.png",156,1],null,[["Pin",cr.behaviors.Pin,9124605375255176]],!1,!1,818104386271852,[]],["t85",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",0,!1,
1,0,!1,4725447386782862,[["sprite33-sheet0.png",14513,1,1,90,33,0,0.5,0.515152,[["Imagepoint 1",0.488889,-0.333333],["Imagepoint 2",0.555556,-1.36364],["Imagepoint 3",-0.0666667,-2.57576],["Imagepoint 4",0.488889,-0.69697],["Imagepoint 5",0.411111,-1.24242],["Imagepoint 6",0.488889,-0.757576]],[-0.5,-0.515152,0.5,-0.515152,0.185039,-0.0190275,-0.020833,0.189218,-0.212598,-0.0190275],0],["sprite33-sheet0.png",14513,1,35,90,33,0,0.5,0.515152,[["Imagepoint 1",0.488889,-0.333333],["Imagepoint 2",0.555556,
-1.36364],["Imagepoint 3",-0.0666667,-2.57576],["Imagepoint 4",0.488889,-0.69697],["Imagepoint 5",0.411111,-1.24242],["Imagepoint 6",0.488889,-0.757576]],[0.469925,-0.512287,0.364662,0.0458245,-0.460495,-0.0678115,-0.480702,-0.515152],0],["sprite34-sheet0.png",9509,1,1,90,33,1,0.5,0.515152,[["Imagepoint 1",0.488889,-0.333333],["Imagepoint 2",0.555556,-1.36364],["Imagepoint 3",-0.0666667,-2.57576],["Imagepoint 4",0.488889,-0.69697],["Imagepoint 5",0.411111,-1.24242],["Imagepoint 6",0.488889,-0.757576]],
[-0.5,-0.515152,0,-0.480669,0.5,-0.515152,0.011111,0.187042],0],["sprite34-sheet0.png",9509,1,35,90,33,1,0.5,0.515152,[["Imagepoint 1",0.488889,-0.333333],["Imagepoint 2",0.555556,-1.36364],["Imagepoint 3",-0.0666667,-2.57576],["Imagepoint 4",0.488889,-0.69697],["Imagepoint 5",0.411111,-1.24242],["Imagepoint 6",0.488889,-0.757576]],[-0.463158,-0.394462,0,-0.446186,0.457895,-0.377221,0.478947,-0.0151515,0.421053,0.226228,-0.421053,0.226228,-0.489474,-0.0151515],0]]]],[["Physics",cr.behaviors.Physics,
0x4cb2878ed5475],["Solid",cr.behaviors.solid,0x5df81605e1f5a]],!1,!1,8207110964560079,[]],["t86",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,776192909341782,[["sprite10-sheet0.png",9620,0,0,110,50,1,0.454545,0.36,[],[-0.292695,0.04,0.0425645,-0.302857,0.337362,0.154286,0.320021,0.14,0.493432,0.511429,0.0425645,0.597143,-0.396742,0.497143,-0.350499,0.14],0]]]],[],!1,!1,464646402887278,[]],["t87",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,4726616003702703,[["sprite11-sheet0.png",
12280,0,0,120,68,1,0.475,0.397059,[],[-0.266667,-0.0294118,0.025,-0.279412,0.366667,-0.117647,0.458333,0.102941,0.375,0.338235,0.025,0.455882,-0.366667,0.411765],0]]]],[],!1,!1,9732787350016808,[]],["t88",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8634944310061205,[["sprite14-sheet0.png",29645,0,0,170,150,1,0.441176,0.493333,[],[-0.21105,-0.231428,0.0567315,-0.450476,0.311962,-0.212381,0.332883,0.00666666,0.20736,0.106667,0.0567315,0.449524,-0.0478715,0.0590476,-0.336573,0.00666666],
0]]]],[],!1,!1,0xd46769c41b907,[]],["t89",cr.plugins_.Sprite,!1,[0x5bfb4cc4f59e9],0,0,null,[["Default",5,!1,1,0,!1,6774056603923012,[["moneycount-sheet0.png",194,0,0,16,16,1,0.5,0.5,[],[],0]]]],[],!1,!1,4761244670987447,[]],["t90",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground9.png",8394,1],null,[],!1,!1,5195442367818238,[]],["t91",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8575690096433131,[["m1-sheet0.png",9295,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,
0,0.3375,0.3375,0,0.3875,-0.3375,0.3375,-0.4125,0],0]]]],[],!1,!1,6768480015985056,[]],["t92",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xf8fd6d72d61d1,[["m2-sheet0.png",9572,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.3375,0.3375,0,0.3875,-0.3375,0.3375,-0.4125,0],0],["m2-sheet1.png",9385,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.35,0.35,0,0.3875,-0.3375,0.3375,-0.4125,0],0]]]],[],!1,!1,8957620712629821,[]],["t93",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",5,!1,1,0,!1,5520772816912564,[["m3-sheet0.png",9712,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.3375,0.3375,0,0.3875,-0.3375,0.3375,-0.4125,0],0],["m2-sheet1.png",9385,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.35,0.35,0,0.3875,-0.3375,0.3375,-0.4125,0],0]]]],[],!1,!1,7217477528415597,[]],["t94",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x500aab857b0a5,[["m4-sheet0.png",9360,0,0,80,80,1,0.5,0.5,
[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.3375,0.3375,0,0.3875,-0.3375,0.3375,-0.4125,0],0],["m2-sheet1.png",9385,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.35,0.35,0,0.3875,-0.3375,0.3375,-0.4125,0],0]]]],[],!1,!1,0xf821d0d9f0280,[]],["t95",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,4709196682660543,[["m5-sheet0.png",9529,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.3375,0.3375,0,0.3875,-0.3375,0.3375,-0.4125,
0],0],["m2-sheet1.png",9385,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.35,0.35,0,0.3875,-0.3375,0.3375,-0.4125,0],0]]]],[],!1,!1,793306015882227,[]],["t96",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6766302127355292,[["m6-sheet0.png",9663,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.3375,0.3375,0,0.3875,-0.3375,0.3375,-0.4125,0],0],["m2-sheet1.png",9385,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,
0,0.35,0.35,0,0.3875,-0.3375,0.3375,-0.4125,0],0]]]],[],!1,!1,0x7bcc5311169e1,[]],["t97",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x6c417fca2dd65,[["m7-sheet0.png",9491,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.3375,0.3375,0,0.3875,-0.3375,0.3375,-0.4125,0],0],["m2-sheet1.png",9385,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.35,0.35,0,0.3875,-0.3375,0.3375,-0.4125,0],0]]]],[],!1,!1,9618329032593056,[]],["t98",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x6504b87f46c2c,[["m8-sheet0.png",9663,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.3375,0.3375,0,0.3875,-0.3375,0.3375,-0.4125,0],0],["m2-sheet1.png",9385,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.35,0.35,0,0.3875,-0.3375,0.3375,-0.4125,0],0]]]],[],!1,!1,9276313627754024,[]],["t99",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,956521625174977,[["m9-sheet0.png",9615,0,0,80,80,1,0.5,0.5,
[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.3375,0.3375,0,0.3875,-0.3375,0.3375,-0.4125,0],0],["m2-sheet1.png",9385,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.35,0.35,0,0.3875,-0.3375,0.3375,-0.4125,0],0]]]],[],!1,!1,0x45663abfd1311,[]],["t100",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7372549166986616,[["m10-sheet0.png",9856,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.3375,0.3375,0,0.3875,-0.3375,0.3375,-0.4125,
0],0],["m2-sheet1.png",9385,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.35,0.35,0,0.3875,-0.3375,0.3375,-0.4125,0],0]]]],[],!1,!1,0xf72b194eceaa,[]],["t101",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xac65cbc1854e1,[["m11-sheet0.png",9269,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.3375,0.3375,0,0.3875,-0.3375,0.3375,-0.4125,0],0],["m2-sheet1.png",9385,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,
0,0.35,0.35,0,0.3875,-0.3375,0.3375,-0.4125,0],0]]]],[],!1,!1,632345076393869,[]],["t102",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,4634128913223689,[["m12-sheet0.png",9929,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.3375,0.3375,0,0.3875,-0.3375,0.3375,-0.4125,0],0],["m2-sheet1.png",9385,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.35,0.35,0,0.3875,-0.3375,0.3375,-0.4125,0],0]]]],[],!1,!1,698620408948124,[]],["t103",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",5,!1,1,0,!1,30591679575463,[["m13-sheet0.png",10082,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.3375,0.3375,0,0.3875,-0.3375,0.3375,-0.4125,0],0],["m2-sheet1.png",9385,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.35,0.35,0,0.3875,-0.3375,0.3375,-0.4125,0],0]]]],[],!1,!1,0xbfbb3ad50ea17,[]],["t104",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7116360662787408,[["m14-sheet0.png",9846,0,0,80,80,1,0.5,0.5,
[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.3375,0.3375,0,0.3875,-0.3375,0.3375,-0.4125,0],0],["m2-sheet1.png",9385,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.35,0.35,0,0.3875,-0.3375,0.3375,-0.4125,0],0]]]],[],!1,!1,4945476992439767,[]],["t105",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9102203240225356,[["m15-sheet0.png",9841,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.3375,0.3375,0,0.3875,-0.3375,0.3375,-0.4125,
0],0],["m2-sheet1.png",9385,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.35,0.35,0,0.3875,-0.3375,0.3375,-0.4125,0],0]]]],[],!1,!1,5502604165369599,[]],["t106",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xee1efe38d077c,[["m16-sheet0.png",9971,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.3375,0.3375,0,0.3875,-0.3375,0.3375,-0.4125,0],0],["m2-sheet1.png",9385,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,
0,0.35,0.35,0,0.3875,-0.3375,0.3375,-0.4125,0],0]]]],[],!1,!1,7769840540900148,[]],["t107",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x6caec48e5c614,[["m17-sheet0.png",9948,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.3375,0.3375,0,0.3875,-0.3375,0.3375,-0.4125,0],0],["m2-sheet1.png",9385,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.35,0.35,0,0.3875,-0.3375,0.3375,-0.4125,0],0]]]],[],!1,!1,5483805861995482,[]],["t108",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xdb985eb80ba04,[["m18-sheet0.png",9939,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.3375,0.3375,0,0.3875,-0.3375,0.3375,-0.4125,0],0],["m2-sheet1.png",9385,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.35,0.35,0,0.3875,-0.3375,0.3375,-0.4125,0],0]]]],[],!1,!1,7762943222257324,[]],["t109",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x6b0b2b5c0a04d,[["m19-sheet0.png",9878,0,0,80,80,1,0.5,0.5,
[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.3375,0.3375,0,0.3875,-0.3375,0.3375,-0.4125,0],0],["m2-sheet1.png",9385,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.35,0.35,0,0.3875,-0.3375,0.3375,-0.4125,0],0]]]],[],!1,!1,4902837719911875,[]],["t110",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7268864608649334,[["m20-sheet0.png",9855,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.3375,0.3375,0,0.3875,-0.3375,0.3375,-0.4125,
0],0],["m2-sheet1.png",9385,0,0,80,80,1,0.5,0.5,[],[-0.3875,-0.3875,0,-0.45,0.3875,-0.3875,0.4125,0,0.35,0.35,0,0.3875,-0.3375,0.3375,-0.4125,0],0]]]],[],!1,!1,9127724096998808,[]],["t111",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,4911890635084598,[["yellow-sheet0.png",638,0,0,50,50,1,0.5,0.5,[],[-0.391089,-0.408333,-0.00494999,-0.466667,0.410891,-0.425,-0.133663,0,0.450495,0.458333,-0.430693,0.441667,-0.430693,0],0]]]],[],!1,!1,8197959923953973,[]],["t112",cr.plugins_.TiledBg,!1,
[],1,0,["tiledbackground4.png",76747,0],null,[["Physics",cr.behaviors.Physics,4820424214972344]],!1,!1,5230645977590134,[]],["t113",cr.plugins_.Arr,!1,[],0,0,null,null,[],!0,!1,5640343806789887,[]],["t114",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xb727d5540219,[["sprite15-sheet0.png",5700,0,0,61,61,1,0.508197,0.508197,[],[],0]]]],[["Anchor",cr.behaviors.Anchor,9193118899990066]],!1,!1,6327700801533158,[]],["t115",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,8602114619158619,
[["sprite16-sheet0.png",1079,0,0,112,72,1,0.5,0.5,[],[-0.473214,-0.458333,0,-0.5,0.473214,-0.458333,0.5,0,0.473214,0.458333,0,0.486111,-0.473214,0.458333,-0.5,0],0]]]],[["Anchor",cr.behaviors.Anchor,7907960424189719]],!1,!1,4922701791505957,[]],["t116",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x88a752441d3f,[["sprite16-sheet0.png",1079,0,0,112,72,1,0.5,0.5,[],[-0.473214,-0.458333,0,-0.5,0.473214,-0.458333,0.5,0,0.473214,0.458333,0,0.486111,-0.473214,0.458333,-0.5,0],0]]]],[["Anchor",
cr.behaviors.Anchor,0xda5d5422dc02f]],!1,!1,5445640971365203,[]],["t117",cr.plugins_.Sprite,!1,[],2,0,null,[["U0",5,!1,1,0,!1,6125795036753241,[["sprite18-sheet0.png",61196,1,1,80,170,1,0.5,0.5,[["Imagepoint 1",0.55,1.00588],["Imagepoint 2",0.5,0.00588235],["Imagepoint 3",0.5,0.129412]],[0,-0.494709,0.2325,-0.217647,0.5,0.42412,-0.5,0.42412,-0.2575,-0.205882],0]]],["U1",5,!0,1,0,!1,0x54ad23a32b6bf,[["sprite18-sheet0.png",61196,82,1,80,170,1,0.5,0.5,[["Imagepoint 1",0.4875,1],["Imagepoint 2",0.4875,
0.0176471],["Imagepoint 3",0.5,0.147059]],[-0.0875,-0.44765,0.08125,-0.482353,0.2625,-0.2,0.5,0.388236,-0.5,0.442359,-0.3125,-0.196763],0]]],["U2",15,!0,1,0,!1,9866347510279008,[["sprite18-sheet0.png",61196,163,1,80,170,1,0.5,0.5,[["Imagepoint 1",0.525,0.988235],["Imagepoint 2",0.475,0.0176471],["Imagepoint 3",0.5,0.129412]],[0,-0.5,0.2375,-0.167647,0.5,0.447059,-0.5,0.447059,-0.3,-0.167647],0]]],["U3",5,!1,1,0,!1,0xf57a95b3635c8,[["sprite18-sheet1.png",45903,1,1,80,170,1,0.5,0.5,[["Imagepoint 1",
0.5,0.923529],["Imagepoint 2",0.4875,0.0588235],["Imagepoint 3",0.5,0.129412],["Imagepoint 4",0.5,0.0588235]],[0.5,0.411765,-0.5,0.411765,-0.25,-0.32353,0,-0.488235,0.25,-0.325],0]]],["U4",5,!1,1,0,!1,7908193764505242,[["sprite18-sheet1.png",45903,82,1,80,170,1,0.5,0.5,[["Imagepoint 1",0.5,0.988235],["Imagepoint 2",0.5,0],["Imagepoint 3",0.5,0.129412],["Imagepoint 4",0.5,0.5]],[0,-0.489706,0.2875,-0.229412,0.5,0.382353,-0.5,0.382353,-0.2875,-0.229412],0]]]],[["Physics",cr.behaviors.Physics,9862551006283E3],
["ScrollTo",cr.behaviors.scrollto,0xe1dd88b3b2796]],!1,!1,0xa0089e45fbe40,[]],["t118",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7577555623257293,[["sprite19-sheet0.png",3128,0,0,37,37,1,0.513514,0.513514,[],[-0.351351,-0.351351,-0.0270275,-0.513514,0.324324,-0.351351,0.486486,-0.0270275,0.324324,0.324324,-0.0270275,0.486486,-0.351351,0.324324,-0.513514,-0.0270275],0]]]],[],!1,!1,5491207714412807,[]],["t119",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x46460a960f42b,
[["rocketpolydestroy-sheet0.png",385,0,0,40,40,1,0.5,0.5,[],[0.00312501,-0.5,0.242188,-0.303125,0.428906,0.017187,0.5,0.5,-0.5,0.5,-0.442187,0.03125,-0.272656,-0.284375],0]]]],[["Pin",cr.behaviors.Pin,7919313068427867]],!1,!1,0xcd20aea069700,[]],["t120",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7577319432396003,[["sprite20-sheet0.png",2934,0,0,37,37,1,0.513514,0.513514,[],[-0.351351,-0.351351,-0.0270275,-0.513514,0.324324,-0.351351,0.486486,-0.0270275,0.324324,0.324324,-0.0270275,
0.486486,-0.351351,0.324324,-0.513514,-0.0270275],0]]]],[],!1,!1,0x533b43e4c3545,[]],["t121",cr.plugins_.Text,!1,[],1,0,null,null,[["Anchor",cr.behaviors.Anchor,5429510476989798]],!1,!1,6726797753358149,[]],["t122",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x77a7c7b6e0726,[["sprite21-sheet0.png",4203,0,0,67,35,1,0.492537,0.342857,[],[-3.27826E-7,-0.285714,0.432836,0.514286,-0.402985,0.485714],0]]]],[],!1,!1,6785755136366299,[]],["t123",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
5,!1,1,0,!1,0xd3b25f4a3f253,[["sprite22-sheet0.png",5864,0,0,72,51,1,0.486111,-0.352941,[],[0.0138889,0.392157,0.430556,1.23529,-0.416667,1.2549],0]]]],[],!1,!1,8435681538558087,[]],["t124",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8201081608432567,[["sprite23-sheet0.png",8951,0,0,74,74,1,0.472973,0.77027,[],[0.216216,-0.77027,0.527027,0.22973,-0.472973,0.22973],0]]]],[],!1,!1,6982655118609544,[]],["t125",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xb4ced95125616,[["sprite24-sheet0.png",
8454,0,0,50,115,1,-0.1,0.791304,[],[0.595238,-0.778373,0.995238,0.161282,0.233333,0.148351],0]]]],[],!1,!1,0xf19553927330b,[]],["t126",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7033096032986947,[["sprite25-sheet0.png",6045,0,0,50,115,1,-0.14,0.704348,[],[0.64,-0.680679,0.991351,0.230563,0.288649,0.230563],0]]]],[],!1,!1,0x3e5ef983fe784,[]],["t127",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6667888847282669,[["sprite26-sheet0.png",3570,0,0,52,57,1,0.519231,0.614035,[],
[],0]]]],[],!1,!1,8768398898886975,[]],["t128",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x7ccde22bd30b3,[["sprite27-sheet0.png",4435,0,0,55,41,1,0.509091,-0.902439,[],[-0.509091,0.902439,0.490909,1.90244,-0.509091,1.90244],0]]]],[],!1,!1,9685774634510914,[]],["t129",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x45dfc64d7ad42,[["sprite28-sheet0.png",2899,0,0,48,30,1,0.5,0,[],[0.5,0,0.5,1,-0.5,1],0]]]],[],!1,!1,8152023723966765,[]],["t130",cr.plugins_.Sprite,!1,[],0,0,
null,[["Default",5,!1,1,0,!1,8930891339252344,[["sprite30-sheet0.png",123857,0,0,700,400,1,0.5,0.5,[],[],1]]]],[],!1,!1,7956399193989331,[]],["t131",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground11.png",33001,1],null,[],!1,!1,6095559195512878,[]],["t132",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6936295722352811,[["sprite31-sheet0.png",25827,0,0,127,127,1,0.503937,0.503937,[],[-0.354331,-0.354331,-0.00787401,-0.503937,0.346457,-0.354331,0.496063,-0.00787401,0.346457,0.346457,-0.00787401,
0.496063,-0.354331,0.346457,-0.503937,-0.00787401],0]]]],[],!1,!1,512809479609554,[]],["t133",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,4683740806925137,[["sprite35-sheet0.png",21979,0,0,113,113,1,0.504425,0.504425,[],[-0.353983,-0.353983,-0.00884974,-0.504425,0.345133,-0.353983,0.495575,-0.00884974,0.345133,0.345133,-0.00884974,0.495575,-0.353983,0.345133,-0.504425,-0.00884974],0]]]],[],!1,!1,9753886866844528,[]],["t134",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5931584677294944,
[["sprite38-sheet0.png",16641,0,0,115,114,1,0.504348,0.5,[],[-0.347826,-0.342105,-0.00869581,-0.45614,0.313043,-0.315789,0.460869,0,0.347826,0.350877,-0.00869581,0.473684,-0.365218,0.359649,-0.486957,0],0]]]],[],!1,!1,0x6ae7b42d0d7c5,[]],["t135",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x3c30d84bcffff,[["sprite39-sheet0.png",8815,0,0,99,91,1,0.50505,0.505495,[],[-0.313131,-0.296704,-0.0101015,-0.494506,0.323233,-0.318682,0.464647,-0.0109895,0.353536,0.340659,-0.0101015,0.483516,-0.363636,
0.340659,-0.494949,-0.0109895],0]]]],[],!1,!1,6027972277094222,[]],["t136",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7481738693776217,[["power-sheet0.png",3283,0,0,37,37,1,0.513514,0.513514,[],[-0.351351,-0.351351,-0.0270275,-0.513514,0.324324,-0.351351,0.486486,-0.0270275,0.324324,0.324324,-0.0270275,0.486486,-0.351351,0.324324,-0.513514,-0.0270275],0]]]],[],!1,!1,0x994b1829fb125,[]],["t137",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6473961108211957,[["sprite40-sheet0.png",
259144,0,0,600,1200,1,0.5,0.5,[],[],1]]]],[],!1,!1,0x9b069e82d598e,[]],["t138",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xaf413a3e7c2bd,[["sprite41-sheet0.png",45013,0,0,1077,453,1,0.500464,0.501104,[],[-0.469824,-0.428256,0.475395,-0.443709,0.494893,-0.00220776,0.3974,0.25607,-0.398328,0.25607,-0.500464,-0.00220776],0]]]],[["Sine",cr.behaviors.Sin,9634509451399508]],!1,!1,5585767500035948,[]],["t139",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x80603ee8a1a54,[["sprite42-sheet0.png",
43254,0,0,1077,453,1,0.500464,0.501104,[],[-0.469824,-0.428256,0.475395,-0.443709,0.494893,-0.00220776,0.3974,0.25607,-0.398328,0.25607,-0.500464,-0.00220776],0]]]],[["Sine",cr.behaviors.Sin,0xbb410e3b5a051]],!1,!1,0x742aaec438e3a,[]],["t140",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,8235701663110177,[["sprite59-sheet0.png",59981,0,0,220,229,1,0.5,0.502183,[],[-0.213636,-0.227074,0,-0.349345,0.309091,-0.318777,0.481818,-0.00436637,0.281818,0.28821,0,0.331878,-0.327273,0.331878,-0.313636,
-0.00436637],0]]]],[["Sine",cr.behaviors.Sin,4588923131966701],["Sine2",cr.behaviors.Sin,0xb24097625a67c]],!1,!1,9590140959118078,[]],["t141",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,8881704051405481,[["sprite60-sheet0.png",9463,0,0,95,84,1,0.505263,0.5,[],[-0.252631,-0.214286,-0.0105262,-0.321429,0.389474,-0.380952,0.452632,0,0.2,0.166667,-0.0105262,0.333333,-0.421053,0.404762,-0.484211,0],0]]]],[["Sine",cr.behaviors.Sin,0xe66ab6045b055],["Sine2",cr.behaviors.Sin,0x75a63072374dd]],
!1,!1,9899761346325056,[]],["t142",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,6461095807927103,[["sprite61-sheet0.png",9276,0,0,95,77,1,0.505263,0.506494,[],[-0.389474,-0.363636,-0.0105262,-0.48052,0.326316,-0.298702,0.463158,-0.0129875,0.305263,0.25974,-0.0105262,0.337663,-0.221052,0.142857,-0.431579,-0.0129875],0]]]],[["Sine",cr.behaviors.Sin,5515243421352928],["Sine2",cr.behaviors.Sin,0x949d17a3e049b]],!1,!1,0x955106aa6381b,[]],["t143",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
5,!1,1,0,!1,8267606121578853,[["sprite62-sheet0.png",155,0,0,250,250,1,0.5,0.5,[],[],1]]]],[],!1,!1,9100103197641564,[]],["t144",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,5268309554068911,[["bullet-sheet0.png",3931,0,0,50,50,1,0.52,0.52,[],[-0.36,-0.36,-0.02,-0.52,0.32,-0.36,0.48,-0.02,0.32,0.32,-0.02,0.48,-0.36,0.32,-0.52,-0.02],0]]]],[["Physics",cr.behaviors.Physics,0xb9459c83ea598]],!1,!1,4859361263774831,[]],["t145",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xbe8f5eb402c4f,
[["sprite63-sheet0.png",4785,0,0,150,44,1,0.186667,0.5,[],[],0]]]],[],!1,!1,0x76b6d9686554a,[]],["t146",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8452449038333383,[["sprite64-sheet0.png",232457,0,0,600,1200,1,0.5,0.5,[],[],1]]]],[],!1,!1,8743901558224993,[]],["t147",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,4593042212320671,[["sprite65-sheet0.png",29522,0,0,142,142,1,0.5,0.5,[],[],0]]]],[],!1,!1,0x3e3379224104a,[]],["t148",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
5,!1,1,0,!1,6129390346994618,[["sprite66-sheet0.png",28493,0,0,142,142,1,0.5,0.5,[],[],0]]]],[],!1,!1,7946796194561794,[]],["t149",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9212544027378072,[["sprite67-sheet0.png",30344,0,0,142,142,1,0.5,0.5,[],[],0]]]],[],!1,!1,8210688288394088,[]],["t150",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xcf4670fdb6138,[["sprite68-sheet0.png",29168,0,0,142,142,1,0.5,0.5,[],[],0]]]],[],!1,!1,0xfa708f2a13cf8,[]],["t151",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xdeb90fd6340ae,[["sprite69-sheet0.png",31771,0,0,134,138,1,0.5,0.5,[],[],0]]]],[],!1,!1,0xfd293f8a41922,[]],["t152",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8028499664688863,[["sprite70-sheet0.png",20784,0,0,129,146,1,0.503876,0.5,[],[0.496124,-0.5,0.496124,0.5,-0.503876,0.5,-0.503876,-0.5],0],["sprite70-sheet1.png",12940,0,0,129,146,1,0.503876,0.5,[],[0.496124,-0.5,0.496124,0.5,-0.503876,0.5,-0.503876,-0.5],0]]]],[],!1,!1,6170504046611925,
[]],["t153",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8009498140001276,[["sprite71-sheet0.png",32650,1,1,125,144,1,0.504,0.5,[],[0.496,-0.5,0.496,0.5,-0.504,0.5,-0.504,-0.5],0],["sprite71-sheet0.png",32650,127,1,125,144,1,0.504,0.5,[],[0.496,-0.5,0.496,0.5,-0.504,0.5,-0.504,-0.5],0]]]],[],!1,!1,5588481089007249,[]],["t154",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x4aeb2f82ee33b,[["sprite72-sheet0.png",32569,1,1,113,134,1,0.504425,0.5,[],[0.495575,-0.5,0.495575,0.5,
-0.504425,0.5,-0.504425,-0.5],0],["sprite72-sheet0.png",32569,115,1,113,134,1,0.504425,0.5,[],[0.495575,-0.5,0.495575,0.492537,-0.504425,0.5,-0.504425,-0.5],0]]]],[],!1,!1,0xb74791d2904c2,[]],["t155",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7126918133505881,[["sprite73-sheet0.png",15915,0,0,102,123,1,0.5,0.504065,[],[],0],["sprite73-sheet1.png",10781,0,0,102,123,1,0.5,0.504065,[],[],0]]]],[],!1,!1,7233108406011125,[]],["t156",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,
!1,7810015031295025,[["sprite74-sheet0.png",25438,0,0,284,142,1,0.5,0.5,[],[],0]]]],[],!1,!1,7003638520834806,[]],["t157",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6934985673934526,[["sprite75-sheet0.png",30191,0,0,284,142,1,0.5,0.5,[],[],0]]]],[],!1,!1,9024983780147824,[]],["t158",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x9c64664ac95b1,[["ru1-sheet0.png",21873,1,1,143,60,1,0.503497,0.5,[],[],0],["ru1-sheet0.png",21873,1,62,143,60,1,0.503497,0.5,[],[],0],["ru1-sheet0.png",
21873,1,123,143,60,1,0.503497,0.5,[],[],0]]]],[],!1,!1,7901641758490812,[]],["t159",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,4761536767923607,[["ru1-sheet0.png",21873,1,1,143,60,1,0.503497,0.5,[],[],0]]]],[],!1,!1,0xf668d5f871eb9,[]],["t160",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xfa9c867ea6e76,[["ru1-sheet0.png",21873,1,1,143,60,1,0.503497,0.5,[],[],0],["ru1-sheet0.png",21873,1,62,143,60,1,0.503497,0.5,[],[-0.454546,-0.383333,-0.00699252,-0.45,0.447552,-0.383333,
0.461538,0,0.433566,0.35,-0.00699252,0.4,-0.440559,0.35,-0.468532,0],0],["ru1-sheet0.png",21873,1,123,143,60,1,0.503497,0.5,[],[],0]]]],[],!1,!1,0xa16636f269ebc,[]],["t161",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8245907853390871,[["ru1-sheet0.png",21873,1,1,143,60,1,0.503497,0.5,[],[],0],["ru1-sheet0.png",21873,1,62,143,60,1,0.503497,0.5,[],[-0.454546,-0.383333,-0.00699252,-0.45,0.447552,-0.383333,0.461538,0,0.433566,0.35,-0.00699252,0.4,-0.440559,0.35,-0.468532,0],0],["ru1-sheet0.png",
21873,1,123,143,60,1,0.503497,0.5,[],[],0]]]],[],!1,!1,0xf27776298139a,[]],["t162",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xa614089ebdd17,[["ru1-sheet0.png",21873,1,1,143,60,1,0.503497,0.5,[],[],0],["ru1-sheet0.png",21873,1,62,143,60,1,0.503497,0.5,[],[-0.454546,-0.383333,-0.00699252,-0.45,0.447552,-0.383333,0.461538,0,0.433566,0.35,-0.00699252,0.4,-0.440559,0.35,-0.468532,0],0],["ru1-sheet0.png",21873,1,123,143,60,1,0.503497,0.5,[],[],0]]]],[],!1,!1,524457784818592,[]],["t163",
cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xa49dc47f4d4ae,[["sprite81-sheet0.png",13356,0,0,96,93,1,0.5,0.505376,[],[],0],["sprite81-sheet1.png",8056,0,0,96,93,1,0.5,0.505376,[],[-0.5,-0.505376,0.5,-0.505376,0.479167,0.494624,-0.5,0.494624],0]]]],[],!1,!1,9452055167049684,[]],["t164",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7945052495821282,[["sprite82-sheet0.png",17587,0,0,125,93,1,0.504,0.505376,[],[-0.504,-0.505376,0.496,-0.505376,0.496,0.483871,-0.504,0.494624],
0],["sprite82-sheet1.png",10126,0,0,125,93,1,0.504,0.505376,[],[],0]]]],[],!1,!1,0xe170c8c3ce189,[]],["t165",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5298091310977637,[["sprite83-sheet0.png",28044,1,1,130,112,1,0.5,0.5,[],[0.5,-0.5,0.5,0.5,-0.5,0.5,-0.5,-0.5],0],["sprite83-sheet0.png",28044,1,114,130,112,1,0.5,0.5,[],[0.5,-0.5,0.5,0.5,-0.5,0.5,-0.5,-0.5],0]]]],[],!1,!1,9296213597412532,[]],["t166",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7818613568997715,[["sprite84-sheet0.png",
23072,0,0,151,138,1,0.503311,0.5,[],[0.496689,-0.5,0.496689,0.5,-0.503311,0.5,-0.503311,-0.5],0],["sprite84-sheet1.png",13411,0,0,151,138,1,0.503311,0.5,[],[],0]]]],[],!1,!1,0xf04b58074b0cc,[]],["t167",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8523921358836565,[["sprite85-sheet0.png",11430,0,0,78,78,1,0.5,0.5,[],[],0]]]],[],!1,!1,9364340838567092,[]],["t168",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8977339945380957,[["sprite86-sheet0.png",9283,0,0,82,82,1,0.5,0.5,
[],[-0.5,-0.5,0.5,-0.5,0.5,0.487805,-0.5,0.5],0],["sprite86-sheet1.png",6442,0,0,82,82,1,0.5,0.5,[],[-0.341463,-0.341463,0,-0.487805,0.341463,-0.341463,0.487805,0,0.341463,0.341463,0,0.487805,-0.341463,0.341463,-0.487805,0],0]]]],[],!1,!1,0xd85176378355c,[]],["t169",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xf9a9285192cc3,[["sprite87-sheet0.png",6521,0,0,82,82,1,0.5,0.5,[],[],0],["sprite87-sheet1.png",4765,0,0,82,82,1,0.5,0.5,[],[-0.341463,-0.341463,0,-0.487805,0.341463,-0.341463,
0.487805,0,0.341463,0.341463,0,0.487805,-0.341463,0.341463,-0.487805,0],0]]]],[],!1,!1,0xd1db757f0de1d,[]],["t170",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,4675161871907049,[["sprite88-sheet0.png",7660,0,0,82,82,1,0.5,0.5,[],[],0]]]],[],!1,!1,7716633186606062,[]],["t171",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6298687267130375,[["sprite3-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,5749042196091688,[]],["t172",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
5,!1,1,0,!1,0xf68d143dfe577,[["ru1-sheet0.png",21873,1,1,143,60,1,0.503497,0.5,[],[],0],["ru1-sheet0.png",21873,1,62,143,60,1,0.503497,0.5,[],[-0.454546,-0.383333,-0.00699252,-0.45,0.447552,-0.383333,0.461538,0,0.433566,0.35,-0.00699252,0.4,-0.440559,0.35,-0.468532,0],0],["ru1-sheet0.png",21873,1,123,143,60,1,0.503497,0.5,[],[-0.454546,-0.383333,-0.00699252,-0.45,0.447552,-0.383333,0.461538,0,0.433566,0.35,-0.00699252,0.4,-0.440559,0.35,-0.468532,0],0]]]],[],!1,!1,0xa89fcc8b3d0bc,[]],["t173",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xf29be342bd0bc,[["ru1-sheet0.png",21873,1,1,143,60,1,0.503497,0.5,[],[],0],["ru1-sheet0.png",21873,1,62,143,60,1,0.503497,0.5,[],[-0.454546,-0.383333,-0.00699252,-0.45,0.447552,-0.383333,0.461538,0,0.433566,0.35,-0.00699252,0.4,-0.440559,0.35,-0.468532,0],0],["ru1-sheet0.png",21873,1,123,143,60,1,0.503497,0.5,[],[-0.454546,-0.383333,-0.00699252,-0.45,0.447552,-0.383333,0.461538,0,0.433566,0.35,-0.00699252,0.4,-0.440559,0.35,-0.468532,0],0]]]],[],!1,!1,0x398b66852e37c,
[]],["t174",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x5b83c301999b2,[["ru1-sheet0.png",21873,1,1,143,60,1,0.503497,0.5,[],[],0],["ru1-sheet0.png",21873,1,62,143,60,1,0.503497,0.5,[],[-0.454546,-0.383333,-0.00699252,-0.45,0.447552,-0.383333,0.461538,0,0.433566,0.35,-0.00699252,0.4,-0.440559,0.35,-0.468532,0],0],["ru1-sheet0.png",21873,1,123,143,60,1,0.503497,0.5,[],[-0.454546,-0.383333,-0.00699252,-0.45,0.447552,-0.383333,0.461538,0,0.433566,0.35,-0.00699252,0.4,-0.440559,0.35,-0.468532,
0],0]]]],[],!1,!1,0x97f4fdefb13cc,[]],["t175",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,4560314958427988,[["ru1-sheet0.png",21873,1,1,143,60,1,0.503497,0.5,[],[],0],["ru1-sheet0.png",21873,1,62,143,60,1,0.503497,0.5,[],[-0.454546,-0.383333,-0.00699252,-0.45,0.447552,-0.383333,0.461538,0,0.433566,0.35,-0.00699252,0.4,-0.440559,0.35,-0.468532,0],0],["ru1-sheet0.png",21873,1,123,143,60,1,0.503497,0.5,[],[-0.454546,-0.383333,-0.00699252,-0.45,0.447552,-0.383333,0.461538,0,0.433566,0.35,
-0.00699252,0.4,-0.440559,0.35,-0.468532,0],0]]]],[],!1,!1,7224091808667491,[]],["t176",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9888589744770858,[["ru1-sheet0.png",21873,1,1,143,60,1,0.503497,0.5,[],[],0],["ru1-sheet0.png",21873,1,62,143,60,1,0.503497,0.5,[],[-0.454546,-0.383333,-0.00699252,-0.45,0.447552,-0.383333,0.461538,0,0.433566,0.35,-0.00699252,0.4,-0.440559,0.35,-0.468532,0],0],["ru1-sheet0.png",21873,1,123,143,60,1,0.503497,0.5,[],[-0.454546,-0.383333,-0.00699252,-0.45,
0.447552,-0.383333,0.461538,0,0.433566,0.35,-0.00699252,0.4,-0.440559,0.35,-0.468532,0],0]]]],[],!1,!1,0xa59121398db2d,[]],["t177",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6947537862844784,[["ru1-sheet0.png",21873,1,1,143,60,1,0.503497,0.5,[],[],0],["ru1-sheet0.png",21873,1,62,143,60,1,0.503497,0.5,[],[-0.454546,-0.383333,-0.00699252,-0.45,0.447552,-0.383333,0.461538,0,0.433566,0.35,-0.00699252,0.4,-0.440559,0.35,-0.468532,0],0],["ru1-sheet0.png",21873,1,123,143,60,1,0.503497,0.5,
[],[-0.454546,-0.383333,-0.00699252,-0.45,0.447552,-0.383333,0.461538,0,0.433566,0.35,-0.00699252,0.4,-0.440559,0.35,-0.468532,0],0]]]],[],!1,!1,7407285405585509,[]],["t178",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xe450f9c768caf,[["ru1-sheet0.png",21873,1,1,143,60,1,0.503497,0.5,[],[],0]]]],[],!1,!1,0xe1d36b33dc396,[]],["t179",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x63b81adda65c6,[["ru1-sheet0.png",21873,1,1,143,60,1,0.503497,0.5,[],[],0]]]],[],!1,!1,0x408a369269d92,
[]],["t180",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,6791177844323015,[]],["t181",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5233838066796642,[["sprite76-sheet0.png",5539,0,0,68,62,1,0.5,0.5,[],[],0]]]],[],!1,!1,5740948669801175,[]],["t182",cr.plugins_.TiledBg,!1,[],1,0,["belaya.png",532,0],null,[["Anchor",cr.behaviors.Anchor,0x93993b0b6bfaf]],!1,!1,8191753053216608,[]],["t183",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,628733454676986,[["loader-sheet0.png",1821,
0,0,61,61,1,0.508197,0.508197,[],[-0.344263,-0.344263,-0.0163937,-0.459016,0.360655,-0.377049,-0.409836,-0.0163937,0.327869,0.327869,-0.0163937,-0.377049,-0.344263,0.327869,-0.47541,-0.0163937],0]]]],[["Rotate",cr.behaviors.Rotate,8456437918452228]],!1,!1,8189358903281188,[]],["t184",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xbd9947552bee0,[["money-sheet1.png",3169,0,0,50,50,1,0.5,0.5,[],[],0]]]],[],!1,!1,6001181123877468,[]],["t185",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
5,!1,1,0,!1,0x6433b1ae3c67e,[["sprite80-sheet0.png",9986,0,0,250,250,1,0.5,0.5,[],[],0]]]],[],!1,!1,0x3c8d9fe1f78f9,[]],["t186",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground12.png",1142,0],null,[],!1,!1,9514206578111024,[]],["t187",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9349668711360468,[["sprite92-sheet0.png",3676,0,0,66,73,1,0.5,0.506849,[],[],0]]]],[],!1,!1,0xc22b992285a2d,[]],["t188",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8967418196875588,[["sprite93-sheet0.png",
4713,0,0,260,41,1,0.5,0.512195,[],[],0]]]],[],!1,!1,7735583795855236,[]],["t189",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9415340354133086,[["sprite94-sheet0.png",10723,0,0,327,78,1,0.501529,0.5,[],[],0]]]],[],!1,!1,6141709362636913,[]],["t190",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,553623784545438,[["sprite95-sheet0.png",5199,0,0,184,96,1,0.5,0.5,[],[],0]]]],[],!1,!1,0xaac863afc5174,[]],["t191",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x7cbadb6217cc9,
[["sprite96-sheet0.png",3978,0,0,215,40,1,0.502326,0.5,[],[],0]]]],[],!1,!1,8933500617498656,[]],["t192",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xb9874ee0d04c9,[["sprite97-sheet0.png",9550,0,0,327,78,1,0.501529,0.5,[],[],0]]]],[],!1,!1,8618256057635459,[]],["t193",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x9a4076f6acb4c,[["sprite98-sheet0.png",4236,0,0,206,41,1,0.5,0.512195,[],[],0]]]],[],!1,!1,0xf7cf4baf6c47b,[]],["t194",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
5,!1,1,0,!1,0xb616ef1672cef,[["sprite99-sheet0.png",11437,0,0,327,78,1,0.501529,0.5,[],[],0]]]],[],!1,!1,9716533276543478,[]],["t195",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8156105701732073,[["sprite100-sheet0.png",17676,0,0,373,124,1,0.501341,0.5,[],[],0]]]],[],!1,!1,7513994728530444,[]],["t196",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x8f02ad22b3eb0,[["sprite101-sheet0.png",13495,0,0,277,113,1,0.501805,0.504425,[],[],0]]]],[],!1,!1,5283155823606439,[]],["t197",
cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6315688729628038,[["sprite102-sheet0.png",7976,0,0,196,113,1,0.5,0.504425,[],[],0]]]],[],!1,!1,9374393415342148,[]],["t198",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7589243955065042,[["ades-sheet0.png",11217,0,0,155,132,1,0.503226,0.5,[],[-0.503226,-0.5,-0.0193548,-0.5,0.496774,-0.5,0.496774,0.060606,0.496774,0.5,0.0193552,0.5,-0.503226,0.5,-0.503226,0.022727],0]]]],[],!1,!1,0x9765e173e7f27,[]],["t199",cr.plugins_.Text,!1,
[],0,0,null,null,[],!1,!1,9341452276895218,[]],["t200",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,6109436396026922,[]],["t201",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,673124247683223,[]],["t202",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,8063692824615709,[]],["t203",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0xdfbf5b148508f,[]],["t204",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,5587673654279292,[]],["t205",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,8324485400124009,[]],["t206",
cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,8776431074181812,[]],["t207",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0x9196bae794c64,[]],["t208",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8355987663274454,[["sprite3-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,0xcbee5a4763e9a,[]],["t209",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0xccf93abb49c21,[]],["t210",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,6909242754733891,[]],["t211",cr.plugins_.Text,!1,[],0,0,null,
null,[],!1,!1,0xd5541f888e8cf,[]],["t212",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,349554710484105,[]],["t213",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0xb6be3799fb8e,[]],["t214",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,9348890500610914,[]],["t215",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0xc1c2d38aebf59,[]],["t216",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x7e40ea4820d2,[["sprite104-sheet0.png",5115,0,0,83,60,1,0.506024,0.5,[],[-0.506024,-0.5,0.493976,-0.5,0.493976,
0.483333,-0.506024,0.5],0]]]],[],!1,!1,0xa474e5d550656,[]],["t217",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8679484998341342,[["sprite105-sheet0.png",5950,0,0,125,60,1,0.504,0.5,[],[-0.504,-0.5,0.496,-0.5,0.488,0.5,-0.504,0.5],0]]]],[],!1,!1,7423685909024797,[]],["t218",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x9fce84658ab3c,[["sprite106-sheet0.png",6523,0,0,130,60,1,0.5,0.5,[],[],0]]]],[],!1,!1,8906496616524927,[]],["t219",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
5,!1,1,0,!1,0x6acfbcacf5865,[["sprite107-sheet0.png",7469,0,0,128,60,1,0.5,0.5,[],[],0]]]],[],!1,!1,0xe6fd4ed89a71e,[]],["t220",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7859770108244099,[["sprite108-sheet0.png",4983,0,0,84,60,1,0.5,0.5,[],[],0]]]],[],!1,!1,7653359314037728,[]],["t221",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6579889493406041,[["sprite109-sheet0.png",5195,0,0,83,60,1,0.506024,0.5,[],[],0]]]],[],!1,!1,9541638989368448,[]],["t222",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",5,!1,1,0,!1,4725072636828697,[["sprite110-sheet0.png",5838,0,0,125,60,1,0.504,0.5,[],[],0]]]],[],!1,!1,4978119844046518,[]],["t223",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8974334575475362,[["sprite111-sheet0.png",6777,0,0,129,60,1,0.503876,0.5,[],[],0]]]],[],!1,!1,908978857882763,[]],["t224",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7381069775984192,[["sprite79-sheet0.png",10349,0,0,157,117,1,0.503185,0.504274,[],[],0]]]],[],!1,!1,7823043383734806,
[]],["t225",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xa5b7596bd4264,[["sprite90-sheet0.png",11591,0,0,161,117,1,0.503106,0.504274,[],[],0]]]],[],!1,!1,0x9ce89cc2e52d7,[]],["t226",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8060792302333559,[["sprite91-sheet0.png",11838,0,0,159,117,1,0.503145,0.504274,[],[],0]]]],[],!1,!1,4608315108430368,[]],["t227",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6925545302935128,[["sprite112-sheet0.png",10805,0,0,211,115,
1,0.50237,0.504348,[],[],0]]]],[],!1,!1,0xa52172dfb773b,[]],["t228",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x618afa3e3447c,[["sprite113-sheet0.png",16280,0,0,128,128,1,0.5,0.5,[],[],0]]]],[],!1,!1,9852165782087242,[]],["t229",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7867760490293523,[["sprite114-sheet0.png",16470,0,0,128,128,1,0.5,0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.492188,-0.5,0.5],0]]]],[],!1,!1,4921667553372388,[]],["t230",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
5,!1,1,0,!1,664048189075777,[["sprite115-sheet0.png",16484,0,0,128,128,1,0.5,0.5,[],[],0]]]],[],!1,!1,0x5baf2b3fab477,[]],["t231",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xf5cb56396475f,[["sprite116-sheet0.png",16449,0,0,128,128,1,0.5,0.5,[],[],0]]]],[],!1,!1,304670560031129,[]],["t232",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,0x65e8ac444f26d,[["sprite117-sheet0.png",30823,0,0,193,156,0,0.502591,0.5,[],[-0.502591,-0.365385,0.497409,-0.371795,0.497409,0.378205,-0.502591,
0.384615],0]]]],[],!1,!1,5133868072033608,[]],["t233",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,0xdb6aaa53c7f10,[["sprite117-sheet0.png",30823,0,0,193,156,0,0.502591,0.5,[],[-0.502591,-0.365385,0.497409,-0.371795,0.497409,0.378205,-0.502591,0.384615],0]]]],[],!1,!1,383799535035487,[]],["t234",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,0xc4bc3acb6cdd4,[["sprite117-sheet0.png",30823,0,0,193,156,0,0.502591,0.5,[],[-0.502591,-0.365385,0.497409,-0.371795,0.497409,0.378205,
-0.502591,0.384615],0]]]],[],!1,!1,9755747190267508,[]],["t235",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,0x9d79578886e4e,[["sprite117-sheet0.png",30823,0,0,193,156,0,0.502591,0.5,[],[-0.502591,-0.378205,0.497409,-0.384615,0.497409,0.391026,-0.502591,0.397436],0]]]],[],!1,!1,4876337459204248,[]],["t236",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xc9943577e13dd,[["sprite121-sheet0.png",22567,0,0,304,142,1,0.5,0.5,[],[-0.5,-0.5,0.5,-0.5,0.493421,0.492958,-0.5,0.5],0]]]],
[],!1,!1,7610204823390789,[]],["t237",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9282541054761806,[["sprite122-sheet0.png",21718,0,0,304,142,1,0.5,0.5,[],[0.5,-0.5,0.5,0.5,-0.5,0.5,-0.5,-0.5],0]]]],[],!1,!1,0xf0d20102d4f16,[]],["t238",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xbe19c173144aa,[["bullet-sheet0.png",3931,0,0,50,50,1,0.5,0.5,[],[-0.34,-0.34,0,-0.5,0.34,-0.34,0.5,0,0.34,0.34,0,0.5,-0.34,0.34,-0.5,0],0]]]],[["Anchor",cr.behaviors.Anchor,5760272942147938]],
!1,!1,0x8348e1386649,[]],["t239",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xeb89a8dc3dc0e,[["sprite3-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,970282875559549,[]],["t240",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x8252fccbd57f3,[["sprite125-sheet0.png",3056,0,0,50,50,1,0.5,0.5,[],[],0]]]],[],!1,!1,5542098742062739,[]],["t241",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,5689357647657674,[["bullet-sheet0.png",3931,0,0,50,50,1,0.5,0.5,
[],[-0.34,-0.34,0,-0.5,0.34,-0.34,0.5,0,0.34,0.34,0,0.5,-0.34,0.34,-0.5,0],0]]]],[["Anchor",cr.behaviors.Anchor,0x83beb04682753]],!1,!1,5037013817245375,[]],["t242",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8897875336270105,[["sprite123-sheet0.png",4645,0,0,133,133,1,0.503759,0.503759,[],[-0.360902,-0.360902,-0.00751838,-0.503759,0.353384,-0.360902,0.496241,-0.00751838,0.353384,0.353384,-0.00751838,0.496241,-0.360902,0.353384,-0.503759,-0.00751838],0]]]],[],!1,!1,6849628743618751,
[]],["t243",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xc70bb356c7a3e,[["bullet-sheet0.png",3931,0,0,50,50,1,0.5,0.5,[],[-0.34,-0.34,0,-0.5,0.34,-0.34,0.5,0,0.34,0.34,0,0.5,-0.34,0.34,-0.5,0],0]]]],[["Anchor",cr.behaviors.Anchor,4565854997155129]],!1,!1,5911752093587122,[]],["t244",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xc0c60945747a5,[["bullet-sheet0.png",3931,0,0,50,50,1,0.5,0.5,[],[-0.34,-0.34,0,-0.5,0.34,-0.34,0.5,0,0.34,0.34,0,0.5,-0.34,0.34,-0.5,0],0]]]],
[["Anchor",cr.behaviors.Anchor,0xf256cf574ed24]],!1,!1,9925031211085600,[]],["t245",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,5970690999806414,[["bullet-sheet0.png",3931,0,0,50,50,1,0.5,0.5,[],[-0.34,-0.34,0,-0.5,0.34,-0.34,0.5,0,0.34,0.34,0,0.5,-0.34,0.34,-0.5,0],0]]]],[["Anchor",cr.behaviors.Anchor,0x3973957653be6]],!1,!1,0xdaf3b553b6283,[]],["t246",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x786aefb987490,[["bullet-sheet0.png",3931,0,0,50,50,1,0.5,0.5,[],[-0.34,
-0.34,0,-0.5,0.34,-0.34,0.5,0,0.34,0.34,0,0.5,-0.34,0.34,-0.5,0],0]]]],[["Anchor",cr.behaviors.Anchor,0x58c3af59b021b]],!1,!1,4534641365686982,[]],["t247",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x791f0cc44caf5,[["bullet-sheet0.png",3931,0,0,50,50,1,0.5,0.5,[],[-0.34,-0.34,0,-0.5,0.34,-0.34,0.5,0,0.34,0.34,0,0.5,-0.34,0.34,-0.5,0],0]]]],[["Anchor",cr.behaviors.Anchor,910000161918916]],!1,!1,0xdb3e3e3ea08a7,[]],["t248",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,5866408748574,
[["bullet-sheet0.png",3931,0,0,50,50,1,0.5,0.5,[],[-0.34,-0.34,0,-0.5,0.34,-0.34,0.5,0,0.34,0.34,0,0.5,-0.34,0.34,-0.5,0],0]]]],[["Anchor",cr.behaviors.Anchor,0x875aa09c4a343]],!1,!1,0xfdd31dc64394b,[]],["t249",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,6957727157146514,[["bullet-sheet0.png",3931,0,0,50,50,1,0.5,0.5,[],[-0.34,-0.34,0,-0.5,0.34,-0.34,0.5,0,0.34,0.34,0,0.5,-0.34,0.34,-0.5,0],0]]]],[["Anchor",cr.behaviors.Anchor,7136657024132829]],!1,!1,621869617426816,[]],["t250",cr.plugins_.Sprite,
!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x8c129d8a363a8,[["bullet-sheet0.png",3931,0,0,50,50,1,0.5,0.5,[],[-0.34,-0.34,0,-0.5,0.34,-0.34,0.5,0,0.34,0.34,0,0.5,-0.34,0.34,-0.5,0],0]]]],[["Anchor",cr.behaviors.Anchor,8153530942145118]],!1,!1,0xa5c79948516d2,[]],["t251",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x6065a9c2f259d,[["bullet-sheet0.png",3931,0,0,50,50,1,0.5,0.5,[],[-0.34,-0.34,0,-0.5,0.34,-0.34,0.5,0,0.34,0.34,0,0.5,-0.34,0.34,-0.5,0],0]]]],[["Anchor",cr.behaviors.Anchor,6599655197082761]],
!1,!1,0x6a964b921ae60,[]],["t252",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6161108018901691,[["window-sheet0.png",119959,0,0,414,504,1,0.5,0.5,[],[-0.439613,-0.450397,0.437198,-0.448413,0.44686,0.456349,0,0.486111,-0.458937,0.46627,-0.429952,0],0]]]],[],!1,!1,7719369090712288,[]],["t253",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9224714471427554,[["sprite126-sheet0.png",3054,0,0,183,71,1,0.502732,0.507042,[],[-0.448087,-0.366197,-0.00546423,-0.492958,0.453552,-0.394366,
0.497268,-0.0140842,0.442623,0.352113,-0.00546423,0.492958,-0.459016,0.380282,-0.502732,-0.0140842],0]]]],[],!1,!1,0x5eec0d18899f6,[]],["t254",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9822382557544296,[["sprite127-sheet0.png",3712,0,0,183,72,1,0.502732,0.5,[],[-0.442623,-0.347222,-0.00546423,-0.472222,0.453552,-0.388889,0.497268,0,0.442623,0.361111,-0.00546423,0.5,-0.459016,0.388889,-0.502732,0],0]]]],[],!1,!1,6046842516274862,[]],["t255",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
5,!1,1,0,!1,0xa293df571d93c,[["sprite128-sheet0.png",12598,0,0,304,142,1,0.5,0.5,[],[-0.5,-0.5,-0.5,0.5,0.5,0.5,0.5,-0.5],0]]]],[],!1,!1,0xef150ff6ad5df,[]]],[],[["M1",1280,1024,!1,null,795858416795787,[["Layer 0",0,5498734010448903,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[215,320,0,98.8139,93.3242,0,0,1,0.5,0.505882,0,0,[]],7,9,[],[[30,0,0,200,1E3,2E3,135,0,1,1]],[0,"Default",0,1]],[[354,328,0,102.745,74.4237,0,0,1,0.5,0.507692,0,0,[]],8,10,[],[[0,0,1,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]]],[]]],
[],[]],["M2",1280,1024,!1,null,6106589351562872,[["Layer 0",0,0x6445d7217ad13,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[205,316,0,97.2057,91.8053,0,0,1,0.5,0.505882,0,0,[]],9,11,[],[[30,0,0,200,1E3,2E3,135,0,1,1]],[0,"Default",0,1]],[[347,328,0,102.745,74.2046,0,0,1,0.5,0.507692,0,0,[]],10,12,[],[[0,0,1,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]]],[]]],[],[]],["M3",1280,1024,!1,null,9651034111683752,[["Layer 0",0,7574787638989608,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[197,361,0,95.9189,90.59,0,0,1,0.5,
0.505882,0,0,[]],13,13,[],[[30,0,0,200,1E3,2E3,135,0,1,1]],[0,"Default",0,1]],[[341,373,0,102.745,74.4237,0,0,1,0.5,0.507692,0,0,[]],14,14,[],[[0,0,1,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]]],[]]],[],[]],["M4",1280,1024,!1,null,6336304598327576,[["Layer 0",0,0xd1d0d9e5cccf1,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[218,357,0,96.6289,91.2606,0,0,1,0.5,0.505882,0,0,[]],11,15,[],[[30,0,0,200,1E3,2E3,135,0,1,1]],[0,"Default",0,1]],[[354,363,0,102.745,74.4237,0,0,1,0.5,0.507692,0,0,[]],12,16,[],[[0,0,
1,1,0.5,0.2,0,0.01,0,1],[]],[0,"Default",0,1]]],[]]],[],[]],["M5",1280,1024,!1,null,600343038462103,[["Layer 0",0,7178908016925677,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[194,332,0,122.345,116.271,0,0,1,-0.09,-0.09,0,0,[]],61,17,[],[],[0,"Default",0,1]],[[384,401,0,42,50,0,0,1,0.5,0.5,0,0,[]],62,18,[],[[400,0,0,0,1,1],[]],[0,"Default",0,1]]],[]]],[],[]],["M6",1280,1024,!1,null,674658541183806,[["Layer 0",0,640150719917576,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[152.5,335,0,91.1242,91.1242,0,0.109623,
1,0.506667,0.506667,0,0,[]],76,19,[],[],[0,"Default",0,1]],[[285.5,321,0,110,98,0,0,1,0.5,0.5,0,0,[]],77,20,[],[[350,0,150,0,1,1]],[0,"Default",0,1]]],[]]],[],[]],["M7",1280,1024,!1,null,9928940698492316,[["Layer 0",0,8848092164843559,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[745,164,0,107.924,119.915,0,0,1,5.43333,-1.03,0,0,[]],44,21,[],[],[0,"Default",0,1]],[[328,372,0,30.2985,14.5882,0,0,1,0.481481,0.461538,0,0,[]],45,22,[],[[400,0,0,0,1,1],[]],[0,"Default",0,1]],[[357,369,0,30.5035,14.6869,0,0,1,
0.481481,0.461538,0,0,[]],46,23,[],[[400,0,0,0,1,1],[]],[0,"Default",0,1]]],[]]],[],[]],["M8",1280,1024,!1,null,8339856670622003,[["Layer 0",0,9736532912770268,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[166,359,0,96.1021,96.1021,0,0,1,0.5,0.5,0,0,[]],49,24,[],[],[0,"Default",0,1]],[[336,346,0,365.846,344.286,0,0,1,0.5,0.502075,0,0,[]],63,25,[],[[0,0,0,0,1,1]],[0,"Default",0,1]]],[]]],[],[]],["M9",1280,1024,!1,null,0xbdf6d9cf60f88,[["Layer 0",0,0x4f7f1bb7895a5,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[219.135,
340.135,0,99.8198,99.8198,0,0,1,0.5,0.5,0,0,[]],47,26,[],[[30,0,0,200,1E3,2E3,135,0,1,1]],[0,"Default",0,1]],[[402,319,0,40,20,0,0,1,0.5,0.5,0,0,[]],48,27,[],[[],[-250,0,0,0,1,1]],[0,"Default",0,1]]],[]]],[],[]],["M10",1280,1024,!1,null,9986903856113404,[["Layer 0",0,6443861022811755,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[329,353,0,90,90,0,0,1,0.5,0.5,0,0,[]],67,28,[],[[230,1500,1500,650,700,1E3,1,1]],[0,"Default",0,1]]],[]]],[],[]],["M11",1280,1024,!1,null,9966924796409696,[["Layer 0",0,0xfcc6996fffd97,
!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[233,328,0,110.838,147.784,0,0,1,0.506667,0.5,0,0,[]],74,29,[],[[1,1,0,18,0,0,0,250,0]],[0,"Default",0,1]],[[390,346,0,250,40,0,0,1,0.892,0.5,0,0,[]],75,30,[],[[]],[0,"Default",0,1]]],[]]],[],[]],["M12",1280,1024,!1,null,0x9bdcee7d8a3be,[["Layer 0",0,0xcb38d6a8c717a,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[216,358,0,119.499,119.499,0,0,1,0.5,0.5,0,0,[]],65,31,[],[],[0,"Default",0,1]],[[366,369,0,60,55,0,0,1,0.5,0.509091,0,0,[]],66,32,[],[[0,0,0,1,0.5,0.2,0,0.01,0,
1],[0,0,0,0,1,1]],[0,"Default",0,1]]],[]]],[],[]],["M13",1280,1024,!1,null,6224834626533987,[["Layer 0",0,0x84d2f9795a4f8,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[136,419,0,91.8,91.8,0,0,1,0.5,0.5,0,0,[]],68,33,[],[],[0,"Default",0,1]],[[758,426,0,742.045,707.37,0,0,1,0.504673,0.5,0,0,[]],70,34,[],[[1,0,0,4,0,0,0,25,0],[1,1,0,2,0,0,0,28,0],[30,0,0,200,1E3,2E3,135,0,1,1]],[0,"Default",0,1]],[[742,402,0,331.115,313.123,0,0,1,0.504673,0.5,0,0,[]],71,35,[],[[1,0,0,3,0,0,0,20,0],[1,1,0,5,0,0,0,10,0],[30,
0,0,200,1E3,2E3,135,0,1,1]],[0,"Default",0,1]],[[-143,416,0,256,256,0,0,1,0.5,0.5,0,0,[]],69,241,[],[[]],[0,"Default",0,1]]],[]]],[],[]],["M14",1280,1024,!1,null,5619342666702737,[["Layer 0",0,0xeac6722dbc42b,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[314,401,0,146.085,121.737,0,0,1,0.5,0.5,0,0,[]],72,36,[],[[30,0,0,200,1E3,2E3,135,0,1,1]],[0,"Default",0,1]],[[308,390,0,523.474,523.474,0,0,0.6,0.5,0.5,0,0,[]],73,37,[],[],[0,"Default",0,1]]],[]]],[],[]],["M15",1280,1024,!1,null,5483887571048609,[["Layer 0",
0,0xaf019f940f219,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[323,381,0,94,103,0,0,1,0.5,0.504854,0,0,[]],64,38,[['"Normal"']],[[30,0,0,140,1E3,2E3,135,0,1,1],[1,0,0,2,0,0,0,18,0],[1,1,0,3,0,0,0,25,0]],[0,"Default",0,1]]],[]]],[],[]],["M16",1280,1024,!1,null,0xd0bf3298b823,[["Layer 0",0,8318074253395089,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[321,376,0,100,100,0,0,1,0.5,0.5,0,0,[]],43,40,[["Mleft"]],[[],[220,0,0,0,0,1]],[0,"Default",0,1]]],[]]],[],[]],["M17",1280,1024,!1,null,7469795252338648,[["Layer 0",
0,7018501809270882,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[313,386,0,172,117,0,0,1,0.5,0.495726,0,0,[]],36,41,[],[[400,0,210,0,1,1]],[0,"Default",0,1]]],[]]],[],[]],["Level1",1280,4E3,!1,"Level1",0x61e073b0edf14,[["BG",0,4552117370756381,!0,[44,159,205],!1,1,1,1,!1,1,0,0,[],[]],["BG(sky)",1,6002944045883258,!0,[255,255,255],!0,0.05,0.08,1,!1,1,0,0,[],[]],["BG(mountian)",2,6172804168877914,!0,[255,255,255],!0,0.05,0.06,1,!1,1,0,0,[],[]],["Map",3,6829141150178752,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-270,
15195,0,250,250,0,0,1,0.5,0.5,0,0,[]],81,56,[],[],[0,"Default",0,1]]],[]],["Earth",4,792656659645519,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[589,2756,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,57,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[799,768,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,58,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[635,1327,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,59,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[446,2287,
0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,60,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[527,1713,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,61,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[699,2021,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,62,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[752,2484,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,63,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[992,2011,0,127.741,46.8384,0,0,1,0.5,
0.515152,0,0,[]],85,64,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[658.173,375.208,0,3729,81,0,0,1,0.5,0.5,0,0,[]],111,108,[],[],[1,"Default",0,1]],[[624,1881,0,122.345,116.271,0,0,1,-0.09,-0.09,0,0,[]],61,911,[],[],[0,"Default",0,1]],[[1388,2380,0,42,50,0,0,1,0.5,0.5,0,0,[]],62,912,[],[[400,0,0,0,1,1],[]],[0,"Default",0,1]],[[756,1909,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,914,[["dva"]],[],[0,"Default",0,1]],[[756,1951,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,915,[["dva"]],[],[0,"Default",0,1]],
[[796,1909,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,916,[["dva"]],[],[0,"Default",0,1]],[[796,1952,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,923,[["dva"]],[],[0,"Default",0,1]],[[838,1909,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,926,[["dva"]],[],[0,"Default",0,1]],[[838,1952,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,927,[["dva"]],[],[0,"Default",0,1]],[[777,1931,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,928,[["dva"]],[],[0,"Default",0,1]],[[777,1974,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,940,[["dva"]],[],[0,"Default",0,1]],[[818,1932,0,20,20,0,
0,1,0.5,0.5,0,0,[]],57,941,[["dva"]],[],[0,"Default",0,1]],[[817,1974,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,980,[["dva"]],[],[0,"Default",0,1]],[[859,1932,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,981,[["dva"]],[],[0,"Default",0,1]],[[859,1974,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,982,[["dva"]],[],[0,"Default",0,1]],[[879,1910,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,984,[["dva"]],[],[0,"Default",0,1]],[[878,1952,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,986,[["dva"]],[],[0,"Default",0,1]],[[919,1910,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,
987,[["dva"]],[],[0,"Default",0,1]],[[919,1953,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,988,[["dva"]],[],[0,"Default",0,1]],[[961,1910,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,989,[["dva"]],[],[0,"Default",0,1]],[[961,1953,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,990,[["dva"]],[],[0,"Default",0,1]],[[900,1932,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,991,[["dva"]],[],[0,"Default",0,1]],[[899,1975,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,993,[["dva"]],[],[0,"Default",0,1]],[[940,1933,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1E3,[["dva"]],[],[0,"Default",
0,1]],[[940,1975,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1003,[["dva"]],[],[0,"Default",0,1]],[[982,1933,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1004,[["dva"]],[],[0,"Default",0,1]],[[982,1975,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1005,[["dva"]],[],[0,"Default",0,1]],[[1004,1911,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1017,[["dva"]],[],[0,"Default",0,1]],[[1004,1953,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1018,[["dva"]],[],[0,"Default",0,1]],[[1045,1911,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1057,[["dva"]],[],[0,"Default",0,1]],[[1044,
1954,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1058,[["dva"]],[],[0,"Default",0,1]],[[1086,1911,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1060,[["dva"]],[],[0,"Default",0,1]],[[1086,1954,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1061,[["dva"]],[],[0,"Default",0,1]],[[1025,1933,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1062,[["dva"]],[],[0,"Default",0,1]],[[1025,1975,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1063,[["dva"]],[],[0,"Default",0,1]],[[1066,1933,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1064,[["dva"]],[],[0,"Default",0,1]],[[1066,1976,0,20,
20,0,0,1,0.5,0.5,0,0,[]],57,1066,[["dva"]],[],[0,"Default",0,1]],[[1107,1933,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1068,[["dva"]],[],[0,"Default",0,1]],[[1107,1976,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1069,[["dva"]],[],[0,"Default",0,1]],[[556,2513,0,59,205,0,0,0.4,0,0,0,0,[]],186,1070,[],[],[0,0]],[[653,2390,0,59,132,0,0.821373,0.4,0,0,0,0,[]],186,1077,[],[],[0,0]],[[742,2394,0,59,63,0,1.57556,0.4,0,0,0,0,[]],186,1080,[],[],[0,0]],[[518.424,2240.67,0,59,259,0,-1.04022,0.4,0,0,0,0,[]],186,1082,[],[],[0,0]],
[[387,2028,0,59,205,0,0,0.4,0,0,0,0,[]],186,1095,[],[],[0,0]],[[598,1909,0,59,198,0,1.15875,0.4,0,0,0,0,[]],186,1134,[],[],[0,0]],[[652,1736,0,59,151,0,0,0.4,0,0,0,0,[]],186,1137,[],[],[0,0]],[[571.598,1654.57,0,59,129,0,-0.807617,0.4,0,0,0,0,[]],186,1139,[],[],[0,0]],[[490,1500,0,59,136,0,0,0.4,0,0,0,0,[]],186,1142,[],[],[0,0]],[[489,1345,0,59,75,0,0,0.4,0,0,0,0,[]],186,1143,[],[],[0,0]],[[569,1218,0,59,132,0,0.821373,0.4,0,0,0,0,[]],186,1154,[],[],[0,0]],[[598,782,0,59,452,0,0,0.4,0,0,0,0,[]],186,
1158,[],[],[0,0]],[[695,668,0,59,132,0,0.821373,0.4,0,0,0,0,[]],186,1159,[],[],[0,0]],[[594,2867,0,66,73,0,0,1,0.5,0.506849,0,0,[]],187,1172,[],[],[0,"Default",0,1]],[[338,2719,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1214,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[222,2673,0,66,73,0,0,1,0.5,0.506849,0,0,[]],187,1215,[],[],[0,"Default",0,1]],[[182,2795,0,330.459,84.8357,0,0,1,0,0,0,0,[]],212,1212,[],[],["The mouse runs away from your finger.",0,"23pt Arial Rounded MT Bold",
"rgb(255,255,255)",0,0,0,0,0]],[[180,2750,0,284.139,80.0996,0,-0.0108985,1,0,0,0,0,[]],202,1312,[],[],["Touch the screen.",0,"23pt Arial Rounded MT Bold","rgb(255,255,255)",0,0,0,0,0]],[[667,2708,0,190.548,83.877,0,-0.114314,1,0,0,0,0,[]],203,1216,[],[],["Follow the arrows",0,"23pt Arial Rounded MT Bold","rgb(255,255,255)",0,0,0,0,0]],[[477,2045,0,304.938,61.1953,0,1.68044E-4,1,0,0,0,0,[]],204,1218,[],[],["Touch mouse",0,"23pt Arial Rounded MT Bold","rgb(255,255,255)",0,0,0,0,0]],[[478,2089,0,297.373,
113.195,0,0.0112369,1,0,0,0,0,[]],205,1219,[],[],["And getting the ball in the opponent",0,"23pt Arial Rounded MT Bold","rgb(255,255,255)",0,0,0,0,0]],[[736,1759,0,316.282,84.83,0,-0.0169632,1,0,0,0,0,[]],206,1220,[],[],["Every 30 coins you get one extra ballon",0,"23pt Arial Rounded MT Bold","rgb(255,255,255)",0,0,0,0,0]],[[736,1840,0,273.737,57.4178,0,0,1,0,0,0,0,[]],207,1222,[],[],["Collect coins",0,"23pt Arial Rounded MT Bold","rgb(255,255,255)",0,0,0,0,0]],[[568,1394,0,365.443,131.158,0,0.134075,
1,0,0,0,0,[]],209,1223,[],[],["This icon will replenish the energy of the rocket and add energy to spare",0,"23pt Arial Rounded MT Bold","rgb(255,255,255)",0,0,0,0,0]],[[688,928,0,278.465,154.784,0,-0.0795793,1,0,0,0,0,[]],210,1224,[],[],["Touch the icon of additional energy to fly more ...",0,"23pt Arial Rounded MT Bold","rgb(255,255,255)",0,0,0,0,0]],[[889,595,0,182.04,129.263,0,0.00953651,1,0,0,0,0,[]],211,1231,[],[],["Move up to get to the next level",0,"23pt Arial Rounded MT Bold","rgb(255,255,255)",
0,0,0,0,0]],[[327,2229,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,831,[],[],[0,"Default",0,1]],[[439,2228,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,833,[],[],[0,"Default",0,1]],[[383,2228,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,892,[],[],[0,"Default",0,1]],[[356,2179,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,903,[],[],[0,"Default",0,1]],[[414,2179,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1364,[],[],[0,"Default",0,1]],[[385,2130,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,738,[],[],[0,"Default",0,1]]],[]],["Power",5,0x668c67393f02b,!0,[255,255,
255],!0,1,1,1,!1,1,0,0,[[[526,1455,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],56,67,[],[],[0,"Default",0,1]]],[]],["Mouse",6,0x82120e9f0b91d,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[324,2575,0,64.0195,53.1053,0,0,1,0.504,0.989247,0,0,[]],21,68,[],[[]],[0,"Default",0,1]],[[323,2586,0,82.0271,93.3333,0,0,1,0.45,0.00909091,0,0,[]],20,69,[[150]],[[0,0,1,0.25,0.5,0.2,1.5,0.01,0,1],[]],[0,"Default",0,1]],[[324,2584,0,8.82941,-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,70,[],[],[0,"Default",0,1]],[[1568,3133,
0,128,128,0,1.57081,1,0,0.5,0,0,[]],34,138,[],[],[15,30,0,170,22,100,5,0,0,0,2,0,-350,0,2,800,0,0,0.7]],[[1468,3135,0,135,200,0,1.5708,1,0,0.5,0,0,[]],33,139,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,0,0,0.3]]],[]],["Decortop",7,0x72e03d5c09cd2,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[588,2728,0,124,44,0,0,1,0.491935,0.454545,0,0,[]],83,72,[],[],[0,"Default",0,1]]],[]],["Water",8,531371877955178,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-138,2934,0,1518.77,128,0,0,1,0,0,0,0,[]],27,73,[],[[1,0,0,
4,0,0,0,50,0]],[0,0]],[[2,3058,0,1379,435,0,0,1,0,0,0,0,[]],84,75,[],[[]],[0,0]]],[]],["UI",9,803488295162426,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[1396,4647,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,76,[["odin"]],[],[0,"Default",0,1]],[[1398,4610,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,77,[["dva"]],[],[0,"Default",0,1]],[[1392,4538,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,78,[["dva"]],[],[1,"Default",0,1]],[[1395,4575,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,79,[["raz"]],[],[1,"Default",0,1]],[[1416,4434,0,100,100,0,0,1,0.5,0.5,
0,0,[]],60,80,[],[[20,0]],[0,"Default",0,1]],[[1742,2833,0,50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,81,[[1]],[],[0,"Default",0,1]],[[314,-148,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,83,[["EnemyBoo"]],[],[1,0]],[[-437.139,-181.715,0,64,64,0,0,1,0,0,0,0,[]],82,90,[["Sp1"]],[],[1,0]],[[172.861,52.2845,0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,91,[],[[]],[0,"Default",0,1]],[[446.861,27.2845,0,-42,51,0,0,1,0.511628,0.509804,0,0,[]],54,92,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,
0,1,0.511628,0.509804,0,0,[]],54,93,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[296.861,32.2845,0,273,57,0,0,1,0.501832,0.508772,0,0,[]],52,94,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[215.861,31.2845,0,172.501,32,0,0,1,0,0.5,0,0,[]],32,96,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[316.861,32.2845,0,216,43,0,0,1,0.5,0.511628,0,0,[]],53,97,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-48,-309,0,72,24,0,0,1,0,0,0,0,[]],58,99,[],[],[0,"SAVE","",1,1,1,"",0]],[[-50,-264,0,72,24,0,0,1,0,0,0,0,[]],59,100,[],[],[0,"CLEAR","",
1,1,1,"",0]],[[122.861,-100.715,0,64,64,0,0,1,0,0,0,0,[]],82,102,[["EarthA"]],[],[1,0]],[[9.86078,-103.715,0,64,64,0,0,1,0,0,0,0,[]],82,103,[["Power"]],[],[1,0]],[[225.861,-101.715,0,64,64,0,0,1,0,0,0,0,[]],82,104,[["Decor1"]],[],[1,0]],[[227.861,-174.715,0,64,64,0,0,1,0,0,0,0,[]],82,105,[["Decor2"]],[],[1,0]],[[227.861,-250.715,0,64,64,0,0,1,0,0,0,0,[]],82,109,[["Decor3"]],[],[1,0]],[[229.861,-324.715,0,64,64,0,0,1,0,0,0,0,[]],82,134,[["Decor4"]],[],[1,0]],[[314,-64,0,26.9258,26.9258,0,0,1,0,0,0,
0,[]],82,135,[["EnemyRoach"]],[],[1,0]],[[423.861,-102.715,0,64,64,0,0,1,0,0,0,0,[]],82,136,[["Money1"]],[],[1,0]],[[424.861,-186.715,0,64,64,0,0,1,0,0,0,0,[]],82,137,[["Money2"]],[],[1,0]],[[-27,-81,0,107,15910,0,0,1,0,0,0,0,[]],112,85,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[1190,-103,0,107,15910,0,0,1,0,0,0,0,[]],112,86,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[67,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],115,113,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[533,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],116,149,[],
[[1,0,0,0,1]],[0,"Default",0,1]],[[146,66,0,33.9411,33.9411,0,0,1,0.5,0.5,0,0,[]],55,98,[],[],[0,"Default",0,1]],[[-7.76617,7.11015,0,146.959,88,0,0,1,0,0,0,0,[]],4,87,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(255,255,51)",1,1,0,0,0]],[[455.144,65.6482,0,32.027,32.027,0,0,1,0.513514,0.513514,0,0,[]],56,150,[],[],[0,"Default",0,1]],[[460.145,6.16529,0,146.959,88,0,0,1,0,0,0,0,[]],6,151,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(204,255,255)",1,1,0,0,0]],[[53,799,
0,67.6461,67.6461,0,0,1,0.508197,0.508197,0,0,[]],114,157,[],[[0,1,0,0,1]],[0,"Default",0,1]],[[95,767,0,488,88,0,0,1,0,0,0,0,[]],121,173,[],[[0,1,0,0,1]],["Left:",0,"36pt Arial Rounded MT Bold","rgb(255,255,255)",0,1,0,0,0]]],[]],["ball",10,767098744391853,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[559,834,0,50,50,0,0,1,0.5,0.5,0,0,[]],238,682,[],[[1,1,0,0,1]],[1,"Default",0,1]]],[]]],[[null,113,88,[],[],[100,1,1]]],[]],["Lewel2",1280,15360,!1,"Lewel2",0x5d813f3a2d15f,[["BG",0,9202690551685684,!0,[44,
159,205],!1,1,1,1,!1,1,0,0,[],[]],["BG(sky)",1,0x4fe33e4155e49,!0,[255,255,255],!0,0.05,0.08,1,!1,1,0,0,[],[]],["BG(mountian)",2,0xd91e8d5d967f1,!0,[255,255,255],!0,0.05,0.06,1,!1,1,0,0,[[[-20,1149,0,1371,258,0,0,1,0,0,0,0,[]],25,82,[],[],[0,0]],[[-20,1401,0,1367,476,0,0,1,0,0,0,0,[]],90,89,[],[],[0,0]]],[]],["Map",3,0xfe9b59bc42c3a,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-290,3265,0,250,250,0,0,1,0.5,0.5,0,0,[]],81,112,[],[],[0,"Default",0,1]]],[]],["Earth",4,0xf667381d5d4c9,!0,[255,255,255],!0,1,
1,1,!1,1,0,0,[[[495,3322,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,114,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[250,3104,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,115,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[641,2911,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,116,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[254,2737,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,117,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[524,2483,
0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,118,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[940,3199,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,119,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[937,2913,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,120,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[941,2638,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,121,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[257,3066,0,120,68,0,0,1,0.475,
0.397059,0,0,[]],87,122,[],[],[0,"Default",0,1]],[[962,2823,0,170,150,0,0,1,0.441176,0.493333,0,0,[]],88,123,[],[],[0,"Default",0,1]],[[597,248,0,3729,81,0,0,1,0.5,0.5,0,0,[]],111,203,[],[],[1,"Default",0,1]],[[266,2555,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,757,[],[],[0,"Default",0,1]],[[829,3033,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,761,[],[],[0,"Default",0,1]]],[]],["Power",5,424359951655351,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[410,2862,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],56,126,[],[],[0,"Default",
0,1]]],[]],["Mouse",6,0x75e7fc4c077f1,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[494,3162,0,64.0195,53.1053,0,0,1,0.504,0.989247,0,0,[]],21,127,[],[[]],[0,"Default",0,1]],[[493,3173,0,82.0271,93.3333,0,0,1,0.45,0.00909091,0,0,[]],20,128,[[150]],[[0,0,1,0.25,0.5,0.2,1.5,0.01,0,1],[]],[0,"Default",0,1]],[[494,3171,0,8.82941,-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,129,[],[],[0,"Default",0,1]],[[1522,2722,0,128,128,0,1.57081,1,0,0.5,0,0,[]],34,130,[],[],[15,30,0,170,22,100,5,0,0,0,2,0,-350,0,2,800,0,0,
0.7]],[[1422,2724,0,135,200,0,1.5708,1,0,0.5,0,0,[]],33,131,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,0,0,0.3]],[[1472,3202,0,80,170,0,0,1,0.5,0.5,0,0,[]],117,132,[],[[0,0,0,0.25,0.5,0.2,0.1,0.01,0,1],[]],[0,"Default",0,1]],[[579,3116,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],118,133,[],[],[0,"Default",0,1]],[[1471,3140,0,59.8836,50.1381,0,0,1,0.5,0.5,0,0,[]],119,141,[],[[]],[1,"Default",0,1]],[[-91,3294,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],120,142,[],[],[0,"Default",0,1]]],[]],["Decortop",
7,9890860414008008,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[940,3155,0,110,50,0,0,1,0.454545,0.36,0,0,[]],86,143,[],[],[0,"Default",0,1]],[[498,3283,0,124,44,0,0,1,0.491935,0.454545,0,0,[]],83,144,[],[],[0,"Default",0,1]]],[]],["Water",8,9381420468657868,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-71,3308,0,1382,128,0,0,1,0,0,0,0,[]],27,145,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[-68,3432,0,1379,435,0,0,1,0,0,0,0,[]],84,146,[],[[]],[0,0]]],[]],["UI",9,9576870972541106,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[1344,
3273,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,147,[["odin"]],[],[0,"Default",0,1]],[[1346,3236,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,148,[["dva"]],[],[0,"Default",0,1]],[[1340,3164,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,156,[["dva"]],[],[1,"Default",0,1]],[[1343,3201,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,158,[["raz"]],[],[1,"Default",0,1]],[[1364,3060,0,100,100,0,0,1,0.5,0.5,0,0,[]],60,159,[],[[20,0]],[0,"Default",0,1]],[[1396,2570,0,50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,160,[[1]],[],[0,"Default",0,1]],[[172.861,52.2845,
0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,163,[],[[]],[0,"Default",0,1]],[[446.861,27.2845,0,-42,51,0,0,1,0.511628,0.509804,0,0,[]],54,164,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,0,1,0.511628,0.509804,0,0,[]],54,165,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[296.861,32.2845,0,273,57,0,0,1,0.501832,0.508772,0,0,[]],52,166,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[215.861,31.2845,0,172.501,32,0,0,1,0,0.5,0,0,[]],32,167,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[316.861,32.2845,0,216,43,
0,0,1,0.5,0.511628,0,0,[]],53,168,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-27,-81,0,107,15910,0,0,1,0,0,0,0,[]],112,182,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[1190,-103,0,107,15910,0,0,1,0,0,0,0,[]],112,183,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[67,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],115,184,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[533,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],116,185,[],[[1,0,0,0,1]],[0,"Default",0,1]],[[146,66,0,33.9411,33.9411,0,0,1,0.5,0.5,0,0,[]],55,186,[],[],[0,"Default",0,1]],[[-7.76617,
7.11015,0,146.959,88,0,0,1,0,0,0,0,[]],4,187,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(255,255,51)",1,1,0,0,0]],[[455.144,65.6482,0,32.027,32.027,0,0,1,0.513514,0.513514,0,0,[]],56,188,[],[],[0,"Default",0,1]],[[460.145,6.16529,0,146.959,88,0,0,1,0,0,0,0,[]],6,189,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(204,255,255)",1,1,0,0,0]],[[53,799,0,67.6461,67.6461,0,0,1,0.508197,0.508197,0,0,[]],114,190,[],[[0,1,0,0,1]],[0,"Default",0,1]],[[95,767,0,488,88,0,0,1,0,0,
0,0,[]],121,191,[],[[0,1,0,0,1]],["Left:",0,"36pt Arial Rounded MT Bold","rgb(255,255,255)",0,1,0,0,0]],[[309,-197,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,175,[["EnemyHaha"]],[],[1,0]],[[311,-278,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,177,[["EnemyGhost"]],[],[1,0]],[[120,-110,0,64,64,0,0,1,0,0,0,0,[]],82,194,[["EarthA"]],[],[1,0]],[[7,-113,0,64,64,0,0,1,0,0,0,0,[]],82,195,[["Power"]],[],[1,0]],[[223,-111,0,64,64,0,0,1,0,0,0,0,[]],82,196,[["Decor1"]],[],[1,0]],[[225,-184,0,64,64,0,0,1,0,0,0,0,[]],82,
197,[["Decor2"]],[],[1,0]],[[225,-260,0,64,64,0,0,1,0,0,0,0,[]],82,198,[["Decor3"]],[],[1,0]],[[227,-334,0,64,64,0,0,1,0,0,0,0,[]],82,199,[["Decor4"]],[],[1,0]],[[421,-112,0,64,64,0,0,1,0,0,0,0,[]],82,201,[["Money1"]],[],[1,0]],[[422,-196,0,64,64,0,0,1,0,0,0,0,[]],82,202,[["Money2"]],[],[1,0]]],[]],["ball",10,5249272114540603,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[559,834,0,50,50,0,0,1,0.5,0.5,0,0,[]],238,1519,[],[[1,1,0,0,1]],[1,"Default",0,1]]],[]]],[],[]],["Lewel3",1280,15360,!1,"Lewel3",0x64a20ed820266,
[["BG",0,5760473366611408,!0,[44,159,205],!1,1,1,1,!1,1,0,0,[],[]],["BG(sky)",1,8314252739394764,!0,[255,255,255],!0,0.05,0.08,1,!1,1,0,0,[],[]],["BG(mountian)",2,8733987192330823,!0,[255,255,255],!0,0.05,0.06,1,!1,1,0,0,[[[-20,1149,0,1371,258,0,0,1,0,0,0,0,[]],25,54,[],[],[0,0]],[[-20,1401,0,1367,476,0,0,1,0,0,0,0,[]],90,111,[],[],[0,0]]],[]],["Map",3,9600719260476604,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-279,4384,0,250,250,0,0,1,0.5,0.5,0,0,[]],81,207,[],[],[0,"Default",0,1]]],[]],["Earth",4,0xd6b4374017858,
!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[506,4441,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,208,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[261,4223,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,209,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[652,4030,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,210,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[265,3856,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,211,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",
0,1]],[[535,3602,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,212,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[951,4318,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,213,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[948,4032,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,214,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[952,3757,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,215,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[268,4185,0,120,
68,0,0,1,0.475,0.397059,0,0,[]],87,216,[],[],[0,"Default",0,1]],[[973,3942,0,170,150,0,0,1,0.441176,0.493333,0,0,[]],88,217,[],[],[0,"Default",0,1]],[[597,248,0,3729,81,0,0,1,0.5,0.5,0,0,[]],111,220,[],[],[1,"Default",0,1]],[[277,4344,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,815,[],[],[0,"Default",0,1]],[[524,3807,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,834,[],[],[0,"Default",0,1]]],[]],["Power",5,8185916862575361,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[421,3981,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],56,221,[],
[],[0,"Default",0,1]]],[]],["Mouse",6,8119956401461468,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[505,4281,0,64.0195,53.1053,0,0,1,0.504,0.989247,0,0,[]],21,222,[],[[]],[0,"Default",0,1]],[[504,4292,0,82.0271,93.3333,0,0,1,0.45,0.00909091,0,0,[]],20,223,[[150]],[[0,0,1,0.25,0.5,0.2,1.5,0.01,0,1],[]],[0,"Default",0,1]],[[505,4290,0,8.82941,-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,224,[],[],[0,"Default",0,1]],[[1533,3841,0,128,128,0,1.57081,1,0,0.5,0,0,[]],34,225,[],[],[15,30,0,170,22,100,5,0,0,0,2,0,
-350,0,2,800,0,0,0.7]],[[1433,3843,0,135,200,0,1.5708,1,0,0.5,0,0,[]],33,226,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,0,0,0.3]],[[1483,4321,0,80,170,0,0,1,0.5,0.5,0,0,[]],117,227,[],[[0,0,0,0.25,0.5,0.2,0.1,0.01,0,1],[]],[0,"Default",0,1]],[[974,4208,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],118,228,[],[],[0,"Default",0,1]],[[1481,4258,0,59.8836,50.1381,0,0,1,0.5,0.5,0,0,[]],119,229,[],[[]],[1,"Default",0,1]],[[-116,4370,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],120,230,[],[],[0,"Default",0,
1]]],[]],["Decortop",7,572433279871398,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[951,4274,0,110,50,0,0,1,0.454545,0.36,0,0,[]],86,231,[],[],[0,"Default",0,1]],[[509,4402,0,124,44,0,0,1,0.491935,0.454545,0,0,[]],83,232,[],[],[0,"Default",0,1]]],[]],["Water",8,465399329770968,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-60,4427,0,1382,128,0,0,1,0,0,0,0,[]],27,233,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[-57,4551,0,1379,435,0,0,1,0,0,0,0,[]],84,234,[],[[]],[0,0]]],[]],["UI",9,353122097124102,!0,[255,255,255],!0,0,0,
1,!1,1,0,0,[[[1355,4392,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,235,[["odin"]],[],[0,"Default",0,1]],[[1357,4355,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,236,[["dva"]],[],[0,"Default",0,1]],[[1351,4283,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,237,[["dva"]],[],[1,"Default",0,1]],[[1354,4320,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,238,[["raz"]],[],[1,"Default",0,1]],[[1375,4179,0,100,100,0,0,1,0.5,0.5,0,0,[]],60,239,[],[[20,0]],[0,"Default",0,1]],[[1407,3689,0,50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,240,[[1]],[],[0,"Default",0,
1]],[[172.861,52.2845,0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,242,[],[[]],[0,"Default",0,1]],[[446.861,27.2845,0,-42,51,0,0,1,0.511628,0.509804,0,0,[]],54,243,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,0,1,0.511628,0.509804,0,0,[]],54,244,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[296.861,32.2845,0,273,57,0,0,1,0.501832,0.508772,0,0,[]],52,245,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[215.861,31.2845,0,172.501,32,0,0,1,0,0.5,0,0,[]],32,246,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[316.861,
32.2845,0,216,43,0,0,1,0.5,0.511628,0,0,[]],53,247,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-27,-81,0,107,15910,0,0,1,0,0,0,0,[]],112,249,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[1190,-103,0,107,15910,0,0,1,0,0,0,0,[]],112,250,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[67,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],115,251,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[533,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],116,252,[],[[1,0,0,0,1]],[0,"Default",0,1]],[[146,66,0,33.9411,33.9411,0,0,1,0.5,0.5,0,0,[]],55,253,[],[],[0,"Default",
0,1]],[[-7.76617,7.11015,0,146.959,88,0,0,1,0,0,0,0,[]],4,254,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(255,255,51)",1,1,0,0,0]],[[455.144,65.6482,0,32.027,32.027,0,0,1,0.513514,0.513514,0,0,[]],56,255,[],[],[0,"Default",0,1]],[[460.145,6.16529,0,146.959,88,0,0,1,0,0,0,0,[]],6,256,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(204,255,255)",1,1,0,0,0]],[[53,799,0,67.6461,67.6461,0,0,1,0.508197,0.508197,0,0,[]],114,257,[],[[0,1,0,0,1]],[0,"Default",0,1]],[[95,767,0,
488,88,0,0,1,0,0,0,0,[]],121,258,[],[[0,1,0,0,1]],["Left:",0,"36pt Arial Rounded MT Bold","rgb(255,255,255)",0,1,0,0,0]],[[-440,-281,0,64,64,0,0,1,0,0,0,0,[]],82,271,[["Sp2"]],[],[1,0]],[[120,-110,0,64,64,0,0,1,0,0,0,0,[]],82,273,[["EarthA"]],[],[1,0]],[[7,-113,0,64,64,0,0,1,0,0,0,0,[]],82,274,[["Power"]],[],[1,0]],[[223,-111,0,64,64,0,0,1,0,0,0,0,[]],82,275,[["Decor1"]],[],[1,0]],[[225,-184,0,64,64,0,0,1,0,0,0,0,[]],82,276,[["Decor2"]],[],[1,0]],[[225,-260,0,64,64,0,0,1,0,0,0,0,[]],82,277,[["Decor3"]],
[],[1,0]],[[227,-334,0,64,64,0,0,1,0,0,0,0,[]],82,278,[["Decor4"]],[],[1,0]],[[421,-112,0,64,64,0,0,1,0,0,0,0,[]],82,280,[["Money1"]],[],[1,0]],[[422,-196,0,64,64,0,0,1,0,0,0,0,[]],82,281,[["Money2"]],[],[1,0]],[[312,-113,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,264,[["EnemyBoo"]],[],[1,0]]],[]],["ball",10,9461522813692872,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[559,834,0,50,50,0,0,1,0.5,0.5,0,0,[]],238,1526,[],[[1,1,0,0,1]],[1,"Default",0,1]]],[]]],[],[]],["Lewel4",1280,15360,!1,"Lewel4",665208441383701,
[["BG",0,5136509610389382,!0,[44,159,205],!1,1,1,1,!1,1,0,0,[],[]],["BG(sky)",1,0xbb24112b7da80,!0,[255,255,255],!0,0.05,0.08,1,!1,1,0,0,[],[]],["BG(mountian)",2,320910334375295,!0,[255,255,255],!0,0.05,0.06,1,!1,1,0,0,[[[-20,1149,0,1371,258,0,0,1,0,0,0,0,[]],25,124,[],[],[0,0]],[[-20,1401,0,1367,476,0,0,1,0,0,0,0,[]],90,125,[],[],[0,0]],[[311,-76,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,341,[["EnemySlizen"]],[],[1,0]]],[]],["Map",3,7872274761206027,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-270,6095,0,
250,250,0,0,1,0.5,0.5,0,0,[]],81,285,[],[],[0,"Default",0,1]]],[]],["Earth",4,6065264355734214,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[515,6152,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,286,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[270,5934,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,287,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[661,5741,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,288,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[274,5567,
0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,289,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[544,5313,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,290,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[960,6029,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,291,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[957,5743,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,292,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[961,5468,0,127.741,46.8384,0,0,
1,0.5,0.515152,0,0,[]],85,293,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[277,5896,0,120,68,0,0,1,0.475,0.397059,0,0,[]],87,294,[],[],[0,"Default",0,1]],[[982,5653,0,170,150,0,0,1,0.441176,0.493333,0,0,[]],88,295,[],[],[0,"Default",0,1]],[[597,248,0,3729,81,0,0,1,0.5,0.5,0,0,[]],111,298,[],[],[1,"Default",0,1]],[[854,5950,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,835,[],[],[0,"Default",0,1]],[[552,5572,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,969,[],[],[0,"Default",0,1]]],[]],["Power",5,571286258293199,
!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[430,5692,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],56,299,[],[],[0,"Default",0,1]]],[]],["Mouse",6,282193516369966,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[514,5992,0,64.0195,53.1053,0,0,1,0.504,0.989247,0,0,[]],21,300,[],[[]],[0,"Default",0,1]],[[513,6003,0,82.0271,93.3333,0,0,1,0.45,0.00909091,0,0,[]],20,301,[[150]],[[0,0,1,0.25,0.5,0.2,1.5,0.01,0,1],[]],[0,"Default",0,1]],[[514,6001,0,8.82941,-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,302,[],[],[0,"Default",0,
1]],[[1542,5552,0,128,128,0,1.57081,1,0,0.5,0,0,[]],34,303,[],[],[15,30,0,170,22,100,5,0,0,0,2,0,-350,0,2,800,0,0,0.7]],[[1442,5554,0,135,200,0,1.5708,1,0,0.5,0,0,[]],33,304,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,0,0,0.3]],[[1492,6032,0,80,170,0,0,1,0.5,0.5,0,0,[]],117,305,[],[[0,0,0,0.25,0.5,0.2,0.1,0.01,0,1],[]],[0,"Default",0,1]],[[276,5847,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],118,306,[],[],[0,"Default",0,1]],[[1491,5969,0,59.8836,50.1381,0,0,1,0.5,0.5,0,0,[]],119,307,[],[[]],[1,
"Default",0,1]],[[-90,6113,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],120,308,[],[],[0,"Default",0,1]]],[]],["Decortop",7,5269961667879115,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[960,5985,0,110,50,0,0,1,0.454545,0.36,0,0,[]],86,309,[],[],[0,"Default",0,1]],[[518,6113,0,124,44,0,0,1,0.491935,0.454545,0,0,[]],83,310,[],[],[0,"Default",0,1]]],[]],["Water",8,886429910638925,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-51,6138,0,1382,128,0,0,1,0,0,0,0,[]],27,311,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[-48,6262,0,1379,
435,0,0,1,0,0,0,0,[]],84,312,[],[[]],[0,0]]],[]],["UI",9,4544852615823686,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[1364,6103,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,313,[["odin"]],[],[0,"Default",0,1]],[[1366,6066,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,314,[["dva"]],[],[0,"Default",0,1]],[[1360,5994,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,315,[["dva"]],[],[1,"Default",0,1]],[[1363,6031,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,316,[["raz"]],[],[1,"Default",0,1]],[[1384,5890,0,100,100,0,0,1,0.5,0.5,0,0,[]],60,317,[],[[20,0]],[0,
"Default",0,1]],[[1416,5400,0,50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,318,[[1]],[],[0,"Default",0,1]],[[172.861,52.2845,0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,319,[],[[]],[0,"Default",0,1]],[[446.861,27.2845,0,-42,51,0,0,1,0.511628,0.509804,0,0,[]],54,320,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,0,1,0.511628,0.509804,0,0,[]],54,321,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[296.861,32.2845,0,273,57,0,0,1,0.501832,0.508772,0,0,[]],52,322,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[215.861,
31.2845,0,172.501,32,0,0,1,0,0.5,0,0,[]],32,323,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[316.861,32.2845,0,216,43,0,0,1,0.5,0.511628,0,0,[]],53,324,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-27,-81,0,107,15910,0,0,1,0,0,0,0,[]],112,326,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[1190,-103,0,107,15910,0,0,1,0,0,0,0,[]],112,327,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[67,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],115,328,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[533,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],116,329,[],[[1,0,
0,0,1]],[0,"Default",0,1]],[[146,66,0,33.9411,33.9411,0,0,1,0.5,0.5,0,0,[]],55,330,[],[],[0,"Default",0,1]],[[-7.76617,7.11015,0,146.959,88,0,0,1,0,0,0,0,[]],4,331,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(255,255,51)",1,1,0,0,0]],[[455.144,65.6482,0,32.027,32.027,0,0,1,0.513514,0.513514,0,0,[]],56,332,[],[],[0,"Default",0,1]],[[460.145,6.16529,0,146.959,88,0,0,1,0,0,0,0,[]],6,333,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(204,255,255)",1,1,0,0,0]],[[53,799,0,
67.6461,67.6461,0,0,1,0.508197,0.508197,0,0,[]],114,334,[],[[0,1,0,0,1]],[0,"Default",0,1]],[[95,767,0,488,88,0,0,1,0,0,0,0,[]],121,335,[],[[0,1,0,0,1]],["Left:",0,"36pt Arial Rounded MT Bold","rgb(255,255,255)",0,1,0,0,0]],[[309,-197,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,343,[["EnemyHaha"]],[],[1,0]],[[120,-110,0,64,64,0,0,1,0,0,0,0,[]],82,350,[["EarthA"]],[],[1,0]],[[7,-113,0,64,64,0,0,1,0,0,0,0,[]],82,351,[["Power"]],[],[1,0]],[[223,-111,0,64,64,0,0,1,0,0,0,0,[]],82,352,[["Decor1"]],[],[1,0]],
[[225,-184,0,64,64,0,0,1,0,0,0,0,[]],82,353,[["Decor2"]],[],[1,0]],[[225,-260,0,64,64,0,0,1,0,0,0,0,[]],82,354,[["Decor3"]],[],[1,0]],[[227,-334,0,64,64,0,0,1,0,0,0,0,[]],82,355,[["Decor4"]],[],[1,0]],[[421,-112,0,64,64,0,0,1,0,0,0,0,[]],82,357,[["Money1"]],[],[1,0]],[[422,-196,0,64,64,0,0,1,0,0,0,0,[]],82,358,[["Money2"]],[],[1,0]]],[]],["ball",10,0xf92359cd885d9,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[559,834,0,50,50,0,0,1,0.5,0.5,0,0,[]],238,1529,[],[[1,1,0,0,1]],[1,"Default",0,1]]],[]]],[],[]],
["Lewel5",1280,15360,!1,"Lewel5",6208648794286475,[["BG",0,9373173875825154,!0,[44,159,205],!1,1,1,1,!1,1,0,0,[],[]],["BG(sky)",1,6589575799987159,!0,[255,255,255],!0,0.05,0.08,1,!1,1,0,0,[],[]],["BG(mountian)",2,0x8f929db807dbc,!0,[255,255,255],!0,0.05,0.06,1,!1,1,0,0,[[[-20,1149,0,1371,258,0,0,1,0,0,0,0,[]],25,84,[],[],[0,0]],[[-20,1401,0,1367,476,0,0,1,0,0,0,0,[]],90,179,[],[],[0,0]]],[]],["Map",3,6806834712816243,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-280,9835,0,250,250,0,0,1,0.5,0.5,0,0,[]],
81,362,[],[],[0,"Default",0,1]]],[]],["Earth",4,6501897791183918,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[505,9892,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,363,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[260,9674,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,364,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[651,9481,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,365,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[264,9307,0,127.739,46.8378,0,0,1,0.5,0.515152,
0,0,[]],23,366,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[534,9053,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,367,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[950,9769,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,368,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[947,9483,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,369,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[951,9208,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,370,[],[[1,
0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[267,9636,0,120,68,0,0,1,0.475,0.397059,0,0,[]],87,371,[],[],[0,"Default",0,1]],[[972,9393,0,170,150,0,0,1,0.441176,0.493333,0,0,[]],88,372,[],[],[0,"Default",0,1]],[[597,248,0,3729,81,0,0,1,0.5,0.5,0,0,[]],111,375,[],[],[1,"Default",0,1]],[[244,9567,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1365,[],[],[0,"Default",0,1]],[[995,9641,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1372,[],[],[0,"Default",0,1]]],[]],["Power",5,0xac288e51fd249,!0,[255,255,255],!0,1,1,1,!1,
1,0,0,[[[420,9432,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],56,376,[],[],[0,"Default",0,1]]],[]],["Mouse",6,9898989383835456,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[504,9732,0,64.0195,53.1053,0,0,1,0.504,0.989247,0,0,[]],21,377,[],[[]],[0,"Default",0,1]],[[503,9743,0,82.0271,93.3333,0,0,1,0.45,0.00909091,0,0,[]],20,378,[[150]],[[0,0,1,0.25,0.5,0.2,1.5,0.01,0,1],[]],[0,"Default",0,1]],[[504,9741,0,8.82941,-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,379,[],[],[0,"Default",0,1]],[[1532,9292,0,128,128,0,
1.57081,1,0,0.5,0,0,[]],34,380,[],[],[15,30,0,170,22,100,5,0,0,0,2,0,-350,0,2,800,0,0,0.7]],[[1432,9294,0,135,200,0,1.5708,1,0,0.5,0,0,[]],33,381,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,0,0,0.3]],[[1482,9772,0,80,170,0,0,1,0.5,0.5,0,0,[]],117,382,[],[[0,0,0,0.25,0.5,0.2,0.1,0.01,0,1],[]],[0,"Default",0,1]],[[800,9599,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],118,383,[],[],[0,"Default",0,1]],[[1481,9710,0,59.8836,50.1381,0,0,1,0.5,0.5,0,0,[]],119,384,[],[[]],[1,"Default",0,1]],[[-89,9827,0,
37,37,0,0,1,0.513514,0.513514,0,0,[]],120,385,[],[],[0,"Default",0,1]]],[]],["Decortop",7,0x59d39ef01b76b,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[950,9725,0,110,50,0,0,1,0.454545,0.36,0,0,[]],86,386,[],[],[0,"Default",0,1]],[[508,9853,0,124,44,0,0,1,0.491935,0.454545,0,0,[]],83,387,[],[],[0,"Default",0,1]]],[]],["Water",8,0x89f127ea3aa6c,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-61,9878,0,1382,128,0,0,1,0,0,0,0,[]],27,388,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[-58,10002,0,1379,435,0,0,1,0,0,0,0,[]],84,389,
[],[[]],[0,0]]],[]],["UI",9,6177130953351292,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[1354,9843,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,390,[["odin"]],[],[0,"Default",0,1]],[[1356,9806,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,391,[["dva"]],[],[0,"Default",0,1]],[[1350,9734,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,392,[["dva"]],[],[1,"Default",0,1]],[[1353,9771,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,393,[["raz"]],[],[1,"Default",0,1]],[[1374,9630,0,100,100,0,0,1,0.5,0.5,0,0,[]],60,394,[],[[20,0]],[0,"Default",0,1]],[[1406,9140,0,
50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,395,[[1]],[],[0,"Default",0,1]],[[172.861,52.2845,0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,396,[],[[]],[0,"Default",0,1]],[[446.861,27.2845,0,-42,51,0,0,1,0.511628,0.509804,0,0,[]],54,397,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,0,1,0.511628,0.509804,0,0,[]],54,398,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[296.861,32.2845,0,273,57,0,0,1,0.501832,0.508772,0,0,[]],52,399,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[215.861,31.2845,0,172.501,32,
0,0,1,0,0.5,0,0,[]],32,400,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[316.861,32.2845,0,216,43,0,0,1,0.5,0.511628,0,0,[]],53,401,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-27,-81,0,107,15910,0,0,1,0,0,0,0,[]],112,403,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[1190,-103,0,107,15910,0,0,1,0,0,0,0,[]],112,404,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[67,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],115,405,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[533,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],116,406,[],[[1,0,0,0,1]],[0,"Default",
0,1]],[[146,66,0,33.9411,33.9411,0,0,1,0.5,0.5,0,0,[]],55,407,[],[],[0,"Default",0,1]],[[-7.76617,7.11015,0,146.959,88,0,0,1,0,0,0,0,[]],4,408,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(255,255,51)",1,1,0,0,0]],[[455.144,65.6482,0,32.027,32.027,0,0,1,0.513514,0.513514,0,0,[]],56,409,[],[],[0,"Default",0,1]],[[460.145,6.16529,0,146.959,88,0,0,1,0,0,0,0,[]],6,410,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(204,255,255)",1,1,0,0,0]],[[53,799,0,67.6461,67.6461,0,0,1,
0.508197,0.508197,0,0,[]],114,411,[],[[0,1,0,0,1]],[0,"Default",0,1]],[[95,767,0,488,88,0,0,1,0,0,0,0,[]],121,412,[],[[0,1,0,0,1]],["Left:",0,"36pt Arial Rounded MT Bold","rgb(255,255,255)",0,1,0,0,0]],[[350,-73,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,413,[["EnemySlizen"]],[],[1,0]],[[-440,-374,0,64,64,0,0,1,0,0,0,0,[]],82,424,[["Sp3"]],[],[1,0]],[[120,-110,0,64,64,0,0,1,0,0,0,0,[]],82,427,[["EarthA"]],[],[1,0]],[[7,-113,0,64,64,0,0,1,0,0,0,0,[]],82,428,[["Power"]],[],[1,0]],[[223,-111,0,64,64,0,0,
1,0,0,0,0,[]],82,429,[["Decor1"]],[],[1,0]],[[225,-184,0,64,64,0,0,1,0,0,0,0,[]],82,430,[["Decor2"]],[],[1,0]],[[225,-260,0,64,64,0,0,1,0,0,0,0,[]],82,431,[["Decor3"]],[],[1,0]],[[227,-334,0,64,64,0,0,1,0,0,0,0,[]],82,432,[["Decor4"]],[],[1,0]],[[421,-112,0,64,64,0,0,1,0,0,0,0,[]],82,434,[["Money1"]],[],[1,0]],[[422,-196,0,64,64,0,0,1,0,0,0,0,[]],82,435,[["Money2"]],[],[1,0]]],[]],["ball",10,5418682394854706,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[559,834,0,50,50,0,0,1,0.5,0.5,0,0,[]],238,1588,[],[[1,
1,0,0,1]],[1,"Default",0,1]]],[]]],[],[]],["Lewel6",1280,15360,!1,"Lewel6",4918447082903934,[["BG",0,9075673178184168,!0,[44,159,205],!1,1,1,1,!1,1,0,0,[[[307,-149,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,492,[["EnemySmoke"]],[],[1,0]]],[]],["BG(sky)",1,5107493652935721,!0,[255,255,255],!0,0.05,0.08,1,!1,1,0,0,[[[-1198,1228,0,3670,254,0,0,1,0,0,0,0,[]],29,178,[],[[1,0,3,70,0,0,0,1024,0]],[0,0]]],[]],["BG(mountian)",2,841623589649259,!0,[255,255,255],!0,0.05,0.06,1,!1,1,0,0,[],[]],["Map",3,7120182381768194,
!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-240,10995,0,250,250,0,0,1,0.5,0.5,0,0,[]],81,436,[],[],[0,"Default",0,1]]],[]],["Earth",4,0x7650c0670e8c,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[545,11052,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,437,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[300,10834,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,438,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[691,10641,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,439,[],[[1,0,0,1,0.5,
0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[304,10467,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,440,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[574,10213,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,441,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[990,10929,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,442,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[987,10643,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,443,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],
[0,"Default",0,1]],[[991,10368,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,444,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[307,10796,0,120,68,0,0,1,0.475,0.397059,0,0,[]],87,445,[],[],[0,"Default",0,1]],[[1012,10553,0,170,150,0,0,1,0.441176,0.493333,0,0,[]],88,446,[],[],[0,"Default",0,1]],[[597,248,0,3729,81,0,0,1,0.5,0.5,0,0,[]],111,449,[],[],[1,"Default",0,1]],[[303,10729,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1375,[],[],[0,"Default",0,1]],[[991,10808,0,50,50,0,0,1,0.5,0.5,0,0,[]],
240,1376,[],[],[0,"Default",0,1]]],[]],["Power",5,9305412890895126,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[460,10592,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],56,450,[],[],[0,"Default",0,1]]],[]],["Mouse",6,7749013519706154,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[544,10892,0,64.0195,53.1053,0,0,1,0.504,0.989247,0,0,[]],21,451,[],[[]],[0,"Default",0,1]],[[543,10903,0,82.0271,93.3333,0,0,1,0.45,0.00909091,0,0,[]],20,452,[[150]],[[0,0,1,0.25,0.5,0.2,1.5,0.01,0,1],[]],[0,"Default",0,1]],[[544,10901,0,8.82941,
-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,453,[],[],[0,"Default",0,1]],[[1572,10452,0,128,128,0,1.57081,1,0,0.5,0,0,[]],34,454,[],[],[15,30,0,170,22,100,5,0,0,0,2,0,-350,0,2,800,0,0,0.7]],[[1472,10454,0,135,200,0,1.5708,1,0,0.5,0,0,[]],33,455,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,0,0,0.3]],[[1522,10932,0,80,170,0,0,1,0.5,0.5,0,0,[]],117,456,[],[[0,0,0,0.25,0.5,0.2,0.1,0.01,0,1],[]],[0,"Default",0,1]],[[626,9926,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],118,457,[],[],[0,"Default",0,1]],
[[1521,10870,0,59.8836,50.1381,0,0,1,0.5,0.5,0,0,[]],119,458,[],[[]],[1,"Default",0,1]],[[-97,10988,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],120,459,[],[],[0,"Default",0,1]]],[]],["Decortop",7,7691987158418123,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[990,10885,0,110,50,0,0,1,0.454545,0.36,0,0,[]],86,460,[],[],[0,"Default",0,1]],[[548,11013,0,124,44,0,0,1,0.491935,0.454545,0,0,[]],83,461,[],[],[0,"Default",0,1]]],[]],["Water",8,9368024681071200,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-21,11038,0,1382,128,
0,0,1,0,0,0,0,[]],27,462,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[-18,11162,0,1379,435,0,0,1,0,0,0,0,[]],84,463,[],[[]],[0,0]]],[]],["UI",9,0xd2b0183e62da8,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[1394,11003,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,464,[["odin"]],[],[0,"Default",0,1]],[[1396,10966,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,465,[["dva"]],[],[0,"Default",0,1]],[[1390,10894,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,466,[["dva"]],[],[1,"Default",0,1]],[[1393,10931,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,467,[["raz"]],[],[1,"Default",
0,1]],[[1414,10790,0,100,100,0,0,1,0.5,0.5,0,0,[]],60,468,[],[[20,0]],[0,"Default",0,1]],[[1446,10300,0,50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,469,[[1]],[],[0,"Default",0,1]],[[172.861,52.2845,0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,470,[],[[]],[0,"Default",0,1]],[[446.861,27.2845,0,-42,51,0,0,1,0.511628,0.509804,0,0,[]],54,471,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,0,1,0.511628,0.509804,0,0,[]],54,472,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[296.861,32.2845,0,273,57,0,
0,1,0.501832,0.508772,0,0,[]],52,473,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[215.861,31.2845,0,172.501,32,0,0,1,0,0.5,0,0,[]],32,474,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[316.861,32.2845,0,216,43,0,0,1,0.5,0.511628,0,0,[]],53,475,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-27,-81,0,107,15910,0,0,1,0,0,0,0,[]],112,477,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[1190,-103,0,107,15910,0,0,1,0,0,0,0,[]],112,478,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[67,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],115,479,[],[[0,0,0,
0,1]],[0,"Default",0,1]],[[533,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],116,480,[],[[1,0,0,0,1]],[0,"Default",0,1]],[[146,66,0,33.9411,33.9411,0,0,1,0.5,0.5,0,0,[]],55,481,[],[],[0,"Default",0,1]],[[-7.76617,7.11015,0,146.959,88,0,0,1,0,0,0,0,[]],4,482,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(255,255,51)",1,1,0,0,0]],[[455.144,65.6482,0,32.027,32.027,0,0,1,0.513514,0.513514,0,0,[]],56,483,[],[],[0,"Default",0,1]],[[460.145,6.16529,0,146.959,88,0,0,1,0,0,0,0,[]],6,484,[],[[0,0,0,0,1]],
["Text",0,"32pt Arial Rounded MT Bold","rgb(204,255,255)",1,1,0,0,0]],[[53,799,0,67.6461,67.6461,0,0,1,0.508197,0.508197,0,0,[]],114,485,[],[[0,1,0,0,1]],[0,"Default",0,1]],[[95,767,0,488,88,0,0,1,0,0,0,0,[]],121,486,[],[[0,1,0,0,1]],["Left:",0,"36pt Arial Rounded MT Bold","rgb(255,255,255)",0,1,0,0,0]],[[350,-73,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,487,[["EnemySlizen"]],[],[1,0]],[[-440,-374,0,64,64,0,0,1,0,0,0,0,[]],82,498,[["Sp3"]],[],[1,0]],[[120,-110,0,64,64,0,0,1,0,0,0,0,[]],82,501,[["EarthA"]],
[],[1,0]],[[7,-113,0,64,64,0,0,1,0,0,0,0,[]],82,502,[["Power"]],[],[1,0]],[[223,-111,0,64,64,0,0,1,0,0,0,0,[]],82,503,[["Decor1A"]],[],[1,0]],[[225,-184,0,64,64,0,0,1,0,0,0,0,[]],82,504,[["Decor2A"]],[],[1,0]],[[225,-260,0,64,64,0,0,1,0,0,0,0,[]],82,505,[["Decor3A"]],[],[1,0]],[[227,-334,0,64,64,0,0,1,0,0,0,0,[]],82,506,[["Decor4A"]],[],[1,0]],[[421,-112,0,64,64,0,0,1,0,0,0,0,[]],82,508,[["Money1"]],[],[1,0]],[[422,-196,0,64,64,0,0,1,0,0,0,0,[]],82,509,[["Money2"]],[],[1,0]]],[]],["ball",10,294160325411724,
!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[559,834,0,50,50,0,0,1,0.5,0.5,0,0,[]],238,1584,[],[[1,1,0,0,1]],[1,"Default",0,1]]],[]]],[],[]],["Lewel7",1280,15360,!1,"Lewel7",7437867887075906,[["BG",0,0xb34b2956233a,!0,[44,159,205],!1,1,1,1,!1,1,0,0,[[[346,-80,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,523,[["EnemyHypno"]],[],[1,0]]],[]],["BG(sky)",1,6452834672366905,!0,[255,255,255],!0,0.05,0.08,1,!1,1,0,0,[[[-1198,1228,0,3670,254,0,0,1,0,0,0,0,[]],29,161,[],[[1,0,3,70,0,0,0,1024,0]],[0,0]]],[]],["BG(mountian)",
2,0x89353e47326a3,!0,[255,255,255],!0,0.05,0.06,1,!1,1,0,0,[],[]],["Map",3,0xd2afd68ec72e9,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-260,13775,0,250,250,0,0,1,0.5,0.5,0,0,[]],81,170,[],[],[0,"Default",0,1]]],[]],["Earth",4,6029260305708283,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[525,13832,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,171,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[280,13614,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,172,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",
0,1]],[[671,13421,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,174,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[284,13247,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,176,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[554,12993,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,192,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[970,13709,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,200,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[967,13423,
0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,259,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[971,13148,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,260,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[287,13576,0,120,68,0,0,1,0.475,0.397059,0,0,[]],87,261,[],[],[0,"Default",0,1]],[[992,13333,0,170,150,0,0,1,0.441176,0.493333,0,0,[]],88,262,[],[],[0,"Default",0,1]],[[597,248,0,3729,81,0,0,1,0.5,0.5,0,0,[]],111,266,[],[],[1,"Default",0,1]],[[427,13588,0,50,50,0,0,1,0.5,
0.5,0,0,[]],240,1439,[],[],[0,"Default",0,1]],[[426,13477,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1441,[],[],[0,"Default",0,1]]],[]],["Power",5,6011091836325501,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[440,13372,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],56,267,[],[],[0,"Default",0,1]]],[]],["Mouse",6,0xddca5124281bf,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[524,13672,0,64.0195,53.1053,0,0,1,0.504,0.989247,0,0,[]],21,268,[],[[]],[0,"Default",0,1]],[[523,13683,0,82.0271,93.3333,0,0,1,0.45,0.00909091,0,0,[]],20,269,
[[150]],[[0,0,1,0.25,0.5,0.2,1.5,0.01,0,1],[]],[0,"Default",0,1]],[[524,13681,0,8.82941,-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,270,[],[],[0,"Default",0,1]],[[1552,13232,0,128,128,0,1.57081,1,0,0.5,0,0,[]],34,272,[],[],[15,30,0,170,22,100,5,0,0,0,2,0,-350,0,2,800,0,0,0.7]],[[1452,13234,0,135,200,0,1.5708,1,0,0.5,0,0,[]],33,336,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,0,0,0.3]],[[1502,13712,0,80,170,0,0,1,0.5,0.5,0,0,[]],117,337,[],[[0,0,0,0.25,0.5,0.2,0.1,0.01,0,1],[]],[0,"Default",0,
1]],[[650,12827,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],118,338,[],[],[0,"Default",0,1]],[[1501,13649,0,59.8836,50.1381,0,0,1,0.5,0.5,0,0,[]],119,339,[],[[]],[1,"Default",0,1]],[[-82,13785,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],120,340,[],[],[0,"Default",0,1]]],[]],["Decortop",7,4976127817610521,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[970,13665,0,110,50,0,0,1,0.454545,0.36,0,0,[]],86,342,[],[],[0,"Default",0,1]],[[528,13793,0,124,44,0,0,1,0.491935,0.454545,0,0,[]],83,344,[],[],[0,"Default",0,1]]],
[]],["Water",8,6923181029661695,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-41,13818,0,1382,128,0,0,1,0,0,0,0,[]],27,345,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[-38,13942,0,1379,435,0,0,1,0,0,0,0,[]],84,346,[],[[]],[0,0]]],[]],["UI",9,6629737512816335,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[1374,13783,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,347,[["odin"]],[],[0,"Default",0,1]],[[1376,13746,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,348,[["dva"]],[],[0,"Default",0,1]],[[1370,13674,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,356,[["dva"]],
[],[1,"Default",0,1]],[[1373,13711,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,414,[["raz"]],[],[1,"Default",0,1]],[[1394,13570,0,100,100,0,0,1,0.5,0.5,0,0,[]],60,415,[],[[20,0]],[0,"Default",0,1]],[[1426,13080,0,50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,416,[[1]],[],[0,"Default",0,1]],[[172.861,52.2845,0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,417,[],[[]],[0,"Default",0,1]],[[446.861,27.2845,0,-42,51,0,0,1,0.511628,0.509804,0,0,[]],54,418,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,0,1,
0.511628,0.509804,0,0,[]],54,420,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[296.861,32.2845,0,273,57,0,0,1,0.501832,0.508772,0,0,[]],52,421,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[215.861,31.2845,0,172.501,32,0,0,1,0,0.5,0,0,[]],32,422,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[316.861,32.2845,0,216,43,0,0,1,0.5,0.511628,0,0,[]],53,423,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-27,-81,0,107,15910,0,0,1,0,0,0,0,[]],112,426,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[1190,-103,0,107,15910,0,0,1,0,0,0,0,[]],112,433,
[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[67,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],115,510,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[533,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],116,511,[],[[1,0,0,0,1]],[0,"Default",0,1]],[[146,66,0,33.9411,33.9411,0,0,1,0.5,0.5,0,0,[]],55,512,[],[],[0,"Default",0,1]],[[-7.76617,7.11015,0,146.959,88,0,0,1,0,0,0,0,[]],4,513,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(255,255,51)",1,1,0,0,0]],[[455.144,65.6482,0,32.027,32.027,0,0,1,0.513514,0.513514,0,0,[]],56,514,
[],[],[0,"Default",0,1]],[[460.145,6.16529,0,146.959,88,0,0,1,0,0,0,0,[]],6,515,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(204,255,255)",1,1,0,0,0]],[[53,799,0,67.6461,67.6461,0,0,1,0.508197,0.508197,0,0,[]],114,516,[],[[0,1,0,0,1]],[0,"Default",0,1]],[[95,767,0,488,88,0,0,1,0,0,0,0,[]],121,517,[],[[0,1,0,0,1]],["Left:",0,"36pt Arial Rounded MT Bold","rgb(255,255,255)",0,1,0,0,0]],[[310,-240,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,526,[["EnemySmoke"]],[],[1,0]],[[-440,-281,0,64,64,
0,0,1,0,0,0,0,[]],82,530,[["Sp2"]],[],[1,0]],[[120,-110,0,64,64,0,0,1,0,0,0,0,[]],82,532,[["EarthA"]],[],[1,0]],[[7,-113,0,64,64,0,0,1,0,0,0,0,[]],82,533,[["Power"]],[],[1,0]],[[223,-111,0,64,64,0,0,1,0,0,0,0,[]],82,534,[["Decor1A"]],[],[1,0]],[[225,-184,0,64,64,0,0,1,0,0,0,0,[]],82,535,[["Decor2A"]],[],[1,0]],[[225,-260,0,64,64,0,0,1,0,0,0,0,[]],82,536,[["Decor3A"]],[],[1,0]],[[227,-334,0,64,64,0,0,1,0,0,0,0,[]],82,537,[["Decor4A"]],[],[1,0]],[[421,-112,0,64,64,0,0,1,0,0,0,0,[]],82,539,[["Money1"]],
[],[1,0]],[[422,-196,0,64,64,0,0,1,0,0,0,0,[]],82,540,[["Money2"]],[],[1,0]]],[]],["ball",10,9425786290059788,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[559,834,0,50,50,0,0,1,0.5,0.5,0,0,[]],238,1530,[],[[1,1,0,0,1]],[1,"Default",0,1]]],[]]],[],[]],["Lewel8",1280,15360,!1,"Lewel8",0xfa420457a2212,[["BG",0,7700515617491962,!0,[44,159,205],!1,1,1,1,!1,1,0,0,[[[310,-153,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1094,[["EnemyGhost"]],[],[1,0]]],[]],["BG(sky)",1,4513355543065726,!0,[255,255,255],!0,0.05,0.08,
1,!1,1,0,0,[[[-1198,1228,0,3670,254,0,0,1,0,0,0,0,[]],29,541,[],[[1,0,3,70,0,0,0,1024,0]],[0,0]]],[]],["BG(mountian)",2,0xea718b684247,!0,[255,255,255],!0,0.05,0.06,1,!1,1,0,0,[],[]],["Map",3,6599230619069517,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-270,15195,0,250,250,0,0,1,0.5,0.5,0,0,[]],81,544,[],[],[0,"Default",0,1]]],[]],["Earth",4,0xe19c5b4e98c34,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[515,15252,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,545,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",
0,1]],[[270,15034,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,546,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[661,14841,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,547,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[274,14667,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,548,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[544,14413,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,549,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[960,15129,
0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,550,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[957,14843,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,551,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[961,14568,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,552,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[277,14996,0,120,68,0,0,1,0.475,0.397059,0,0,[]],87,553,[],[],[0,"Default",0,1]],[[982,14753,0,170,150,0,0,1,0.441176,0.493333,0,0,[]],88,554,[],[],[0,
"Default",0,1]],[[597,248,0,3729,81,0,0,1,0.5,0.5,0,0,[]],111,557,[],[],[1,"Default",0,1]],[[408,15006,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1436,[],[],[0,"Default",0,1]],[[682,15110,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1438,[],[],[0,"Default",0,1]]],[]],["Power",5,0xaad0b3574df2a,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[430,14792,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],56,558,[],[],[0,"Default",0,1]]],[]],["Mouse",6,4816126418488224,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[514,15092,0,64.0195,53.1053,0,0,1,0.504,
0.989247,0,0,[]],21,559,[],[[]],[0,"Default",0,1]],[[513,15103,0,82.0271,93.3333,0,0,1,0.45,0.00909091,0,0,[]],20,560,[[150]],[[0,0,1,0.25,0.5,0.2,1.5,0.01,0,1],[]],[0,"Default",0,1]],[[514,15101,0,8.82941,-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,561,[],[],[0,"Default",0,1]],[[1542,14652,0,128,128,0,1.57081,1,0,0.5,0,0,[]],34,562,[],[],[15,30,0,170,22,100,5,0,0,0,2,0,-350,0,2,800,0,0,0.7]],[[1442,14654,0,135,200,0,1.5708,1,0,0.5,0,0,[]],33,563,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,
0,0,0.3]],[[1492,15132,0,80,170,0,0,1,0.5,0.5,0,0,[]],117,564,[],[[0,0,0,0.25,0.5,0.2,0.1,0.01,0,1],[]],[0,"Default",0,1]],[[124,14846,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],118,565,[],[],[0,"Default",0,1]],[[1490.96,15069.6,0,59.8836,50.1381,0,0,1,0.5,0.5,0,0,[]],119,566,[],[[]],[1,"Default",0,1]],[[-86,15209,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],120,567,[],[],[0,"Default",0,1]]],[]],["Decortop",7,9881253664225262,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[960,15085,0,110,50,0,0,1,0.454545,0.36,0,
0,[]],86,568,[],[],[0,"Default",0,1]],[[518,15213,0,124,44,0,0,1,0.491935,0.454545,0,0,[]],83,569,[],[],[0,"Default",0,1]]],[]],["Water",8,0x9c70bddc897ca,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-51,15238,0,1382,128,0,0,1,0,0,0,0,[]],27,570,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[-48,15362,0,1379,435,0,0,1,0,0,0,0,[]],84,571,[],[[]],[0,0]]],[]],["UI",9,0x7eea8ec35296d,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[1364,15203,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,572,[["odin"]],[],[0,"Default",0,1]],[[1366,15166,0,20,
20,0,0,1,0.5,0.5,0,0,[]],57,573,[["dva"]],[],[0,"Default",0,1]],[[1360,15094,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,574,[["dva"]],[],[1,"Default",0,1]],[[1363,15131,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,575,[["raz"]],[],[1,"Default",0,1]],[[1384,14990,0,100,100,0,0,1,0.5,0.5,0,0,[]],60,576,[],[[20,0]],[0,"Default",0,1]],[[1416,14500,0,50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,577,[[1]],[],[0,"Default",0,1]],[[172.861,52.2845,0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,578,[],[[]],[0,"Default",0,1]],[[446.861,
27.2845,0,-42,51,0,0,1,0.511628,0.509804,0,0,[]],54,579,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,0,1,0.511628,0.509804,0,0,[]],54,580,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[296.861,32.2845,0,273,57,0,0,1,0.501832,0.508772,0,0,[]],52,581,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[215.861,31.2845,0,172.501,32,0,0,1,0,0.5,0,0,[]],32,582,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[316.861,32.2845,0,216,43,0,0,1,0.5,0.511628,0,0,[]],53,583,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-27,-81,0,107,
15910,0,0,1,0,0,0,0,[]],112,585,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[1190,-103,0,107,15910,0,0,1,0,0,0,0,[]],112,586,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[67,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],115,587,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[533,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],116,588,[],[[1,0,0,0,1]],[0,"Default",0,1]],[[146,66,0,33.9411,33.9411,0,0,1,0.5,0.5,0,0,[]],55,589,[],[],[0,"Default",0,1]],[[-7.76617,7.11015,0,146.959,88,0,0,1,0,0,0,0,[]],4,590,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold",
"rgb(255,255,51)",1,1,0,0,0]],[[455.144,65.6482,0,32.027,32.027,0,0,1,0.513514,0.513514,0,0,[]],56,591,[],[],[0,"Default",0,1]],[[460.145,6.16529,0,146.959,88,0,0,1,0,0,0,0,[]],6,592,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(204,255,255)",1,1,0,0,0]],[[53,799,0,67.6461,67.6461,0,0,1,0.508197,0.508197,0,0,[]],114,593,[],[[0,1,0,0,1]],[0,"Default",0,1]],[[95,767,0,488,88,0,0,1,0,0,0,0,[]],121,594,[],[[0,1,0,0,1]],["Left:",0,"36pt Arial Rounded MT Bold","rgb(255,255,255)",0,1,0,0,
0]],[[310,-240,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,603,[["EnemySmoke"]],[],[1,0]],[[-440,-374,0,64,64,0,0,1,0,0,0,0,[]],82,606,[["Sp3"]],[],[1,0]],[[120,-110,0,64,64,0,0,1,0,0,0,0,[]],82,609,[["EarthA"]],[],[1,0]],[[7,-113,0,64,64,0,0,1,0,0,0,0,[]],82,610,[["Power"]],[],[1,0]],[[223,-111,0,64,64,0,0,1,0,0,0,0,[]],82,611,[["Decor1A"]],[],[1,0]],[[225,-184,0,64,64,0,0,1,0,0,0,0,[]],82,612,[["Decor2A"]],[],[1,0]],[[225,-260,0,64,64,0,0,1,0,0,0,0,[]],82,613,[["Decor3A"]],[],[1,0]],[[227,-334,0,64,
64,0,0,1,0,0,0,0,[]],82,614,[["Decor4A"]],[],[1,0]],[[421,-112,0,64,64,0,0,1,0,0,0,0,[]],82,616,[["Money1"]],[],[1,0]],[[422,-196,0,64,64,0,0,1,0,0,0,0,[]],82,617,[["Money2"]],[],[1,0]]],[]],["ball",10,5942424221179366,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[559,834,0,50,50,0,0,1,0.5,0.5,0,0,[]],238,1583,[],[[1,1,0,0,1]],[1,"Default",0,1]]],[]]],[],[]],["Lewel9",1280,15360,!1,"Lewel9",0x79f2ded98055e,[["BG",0,9037462008788402,!0,[44,159,205],!1,1,1,1,!1,1,0,0,[],[]],["BG(sky)",1,4625820887317656,!0,
[255,255,255],!0,0.05,0.08,1,!1,1,0,0,[[[-1216,1226,0,3680,250,0,0,1,0,0,0,0,[]],78,169,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[355,-105,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,673,[["EnemyHypno"]],[],[1,0]]],[]],["BG(mountian)",2,0x806cf2621df72,!0,[255,255,255],!0,0.05,0.06,1,!1,1,0,0,[],[]],["Map",3,9595210569626504,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-270,15195,0,250,250,0,0,1,0.5,0.5,0,0,[]],81,621,[],[],[0,"Default",0,1]]],[]],["Earth",4,7152008165574465,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[515,
15252,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,622,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[270,15034,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,623,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[661,14841,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,624,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[274,14667,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,625,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[544,14413,0,127.739,46.8378,
0,0,1,0.5,0.515152,0,0,[]],23,626,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[960,15129,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,627,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[957,14843,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,628,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[961,14568,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,629,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[277,14996,0,120,68,0,0,1,0.475,0.397059,0,0,[]],
87,630,[],[],[0,"Default",0,1]],[[982,14753,0,170,150,0,0,1,0.441176,0.493333,0,0,[]],88,631,[],[],[0,"Default",0,1]],[[597,248,0,3729,81,0,0,1,0.5,0.5,0,0,[]],111,634,[],[],[1,"Default",0,1]],[[435,15014,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1433,[],[],[0,"Default",0,1]],[[752,15118,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1435,[],[],[0,"Default",0,1]]],[]],["Power",5,9373890070752696,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[430,14792,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],56,635,[],[],[0,"Default",0,1]]],[]],
["Mouse",6,7488910046050573,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[514,15092,0,64.0195,53.1053,0,0,1,0.504,0.989247,0,0,[]],21,636,[],[[]],[0,"Default",0,1]],[[513,15103,0,82.0271,93.3333,0,0,1,0.45,0.00909091,0,0,[]],20,637,[[150]],[[0,0,1,0.25,0.5,0.2,1.5,0.01,0,1],[]],[0,"Default",0,1]],[[514,15101,0,8.82941,-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,638,[],[],[0,"Default",0,1]],[[1542,14652,0,128,128,0,1.57081,1,0,0.5,0,0,[]],34,639,[],[],[15,30,0,170,22,100,5,0,0,0,2,0,-350,0,2,800,0,0,0.7]],
[[1442,14654,0,135,200,0,1.5708,1,0,0.5,0,0,[]],33,640,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,0,0,0.3]],[[1492,15132,0,80,170,0,0,1,0.5,0.5,0,0,[]],117,641,[],[[0,0,0,0.25,0.5,0.2,0.1,0.01,0,1],[]],[0,"Default",0,1]],[[1133,15125,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],118,642,[],[],[0,"Default",0,1]],[[1490.96,15069.6,0,59.8836,50.1381,0,0,1,0.5,0.5,0,0,[]],119,643,[],[[]],[1,"Default",0,1]],[[-112,15206,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],120,644,[],[],[0,"Default",0,1]]],[]],["Decortop",
7,4992361699732694,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[960,15085,0,110,50,0,0,1,0.454545,0.36,0,0,[]],86,645,[],[],[0,"Default",0,1]],[[518,15213,0,124,44,0,0,1,0.491935,0.454545,0,0,[]],83,646,[],[],[0,"Default",0,1]]],[]],["Water",8,0x5e07b3c56d524,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-51,15238,0,1382,128,0,0,1,0,0,0,0,[]],27,647,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[-48,15362,0,1379,435,0,0,1,0,0,0,0,[]],84,648,[],[[]],[0,0]]],[]],["UI",9,5574707760542416,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[1364,
15203,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,649,[["odin"]],[],[0,"Default",0,1]],[[1366,15166,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,650,[["dva"]],[],[0,"Default",0,1]],[[1360,15094,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,651,[["dva"]],[],[1,"Default",0,1]],[[1363,15131,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,652,[["raz"]],[],[1,"Default",0,1]],[[1384,14990,0,100,100,0,0,1,0.5,0.5,0,0,[]],60,653,[],[[20,0]],[0,"Default",0,1]],[[1416,14500,0,50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,654,[[1]],[],[0,"Default",0,1]],[[172.861,
52.2845,0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,655,[],[[]],[0,"Default",0,1]],[[446.861,27.2845,0,-42,51,0,0,1,0.511628,0.509804,0,0,[]],54,656,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,0,1,0.511628,0.509804,0,0,[]],54,657,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[296.861,32.2845,0,273,57,0,0,1,0.501832,0.508772,0,0,[]],52,658,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[215.861,31.2845,0,172.501,32,0,0,1,0,0.5,0,0,[]],32,659,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[316.861,32.2845,0,
216,43,0,0,1,0.5,0.511628,0,0,[]],53,660,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-27,-81,0,107,15910,0,0,1,0,0,0,0,[]],112,662,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[1190,-103,0,107,15910,0,0,1,0,0,0,0,[]],112,663,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[67,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],115,664,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[533,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],116,665,[],[[1,0,0,0,1]],[0,"Default",0,1]],[[146,66,0,33.9411,33.9411,0,0,1,0.5,0.5,0,0,[]],55,666,[],[],[0,"Default",0,
1]],[[-7.76617,7.11015,0,146.959,88,0,0,1,0,0,0,0,[]],4,667,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(255,255,51)",1,1,0,0,0]],[[455.144,65.6482,0,32.027,32.027,0,0,1,0.513514,0.513514,0,0,[]],56,668,[],[],[0,"Default",0,1]],[[460.145,6.16529,0,146.959,88,0,0,1,0,0,0,0,[]],6,669,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(204,255,255)",1,1,0,0,0]],[[53,799,0,67.6461,67.6461,0,0,1,0.508197,0.508197,0,0,[]],114,670,[],[[0,1,0,0,1]],[0,"Default",0,1]],[[95,767,0,488,
88,0,0,1,0,0,0,0,[]],121,671,[],[[0,1,0,0,1]],["Left:",0,"36pt Arial Rounded MT Bold","rgb(255,255,255)",0,1,0,0,0]],[[311,-157,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,678,[["EnemyBoo"]],[],[1,0]],[[-440,-191,0,64,64,0,0,1,0,0,0,0,[]],82,685,[["Sp1"]],[],[1,0]],[[120,-110,0,64,64,0,0,1,0,0,0,0,[]],82,686,[["EarthA"]],[],[1,0]],[[7,-113,0,64,64,0,0,1,0,0,0,0,[]],82,687,[["Power"]],[],[1,0]],[[223,-111,0,64,64,0,0,1,0,0,0,0,[]],82,688,[["Decor1A"]],[],[1,0]],[[225,-184,0,64,64,0,0,1,0,0,0,0,[]],82,689,
[["Decor2A"]],[],[1,0]],[[225,-260,0,64,64,0,0,1,0,0,0,0,[]],82,690,[["Decor3A"]],[],[1,0]],[[227,-334,0,64,64,0,0,1,0,0,0,0,[]],82,691,[["Decor4A"]],[],[1,0]],[[421,-112,0,64,64,0,0,1,0,0,0,0,[]],82,693,[["Money1"]],[],[1,0]],[[422,-196,0,64,64,0,0,1,0,0,0,0,[]],82,694,[["Money2"]],[],[1,0]]],[]],["ball",10,9311480563324548,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[559,834,0,50,50,0,0,1,0.5,0.5,0,0,[]],238,1572,[],[[1,1,0,0,1]],[1,"Default",0,1]]],[]]],[],[]],["Lewel10",1280,15360,!1,"Lewel10",9716322917335668,
[["BG",0,6235721376868238,!0,[44,159,205],!1,1,1,1,!1,1,0,0,[],[]],["BG(sky)",1,4508594282629291,!0,[255,255,255],!0,0.05,0.08,1,!1,1,0,0,[[[-1217,1234,0,3680,250,0,0,1,0,0,0,0,[]],78,162,[],[[1,0,0,4,0,0,0,50,0]],[0,0]]],[]],["BG(mountian)",2,4766301709006145,!0,[255,255,255],!0,0.05,0.06,1,!1,1,0,0,[],[]],["Map",3,0xc6ca028ee99db,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-270,15195,0,250,250,0,0,1,0.5,0.5,0,0,[]],81,698,[],[],[0,"Default",0,1]]],[]],["Earth",4,5299310719525396,!0,[255,255,255],!0,1,
1,1,!1,1,0,0,[[[515,15252,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,699,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[270,15034,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,700,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[661,14841,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,701,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[274,14667,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,702,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[544,
14413,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,703,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[960,15129,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,704,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[957,14843,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,705,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[961,14568,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,706,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[277,14996,0,120,68,0,
0,1,0.475,0.397059,0,0,[]],87,707,[],[],[0,"Default",0,1]],[[982,14753,0,170,150,0,0,1,0.441176,0.493333,0,0,[]],88,708,[],[],[0,"Default",0,1]],[[597,248,0,3729,81,0,0,1,0.5,0.5,0,0,[]],111,711,[],[],[1,"Default",0,1]],[[623,15109,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1431,[],[],[0,"Default",0,1]],[[834,15109,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1432,[],[],[0,"Default",0,1]]],[]],["Power",5,0x3a8ec820b5f94,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[430,14792,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],56,712,[],
[],[0,"Default",0,1]]],[]],["Mouse",6,9182444061983428,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[514,15092,0,64.0195,53.1053,0,0,1,0.504,0.989247,0,0,[]],21,713,[],[[]],[0,"Default",0,1]],[[513,15103,0,82.0271,93.3333,0,0,1,0.45,0.00909091,0,0,[]],20,714,[[150]],[[0,0,1,0.25,0.5,0.2,1.5,0.01,0,1],[]],[0,"Default",0,1]],[[514,15101,0,8.82941,-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,715,[],[],[0,"Default",0,1]],[[1542,14652,0,128,128,0,1.57081,1,0,0.5,0,0,[]],34,716,[],[],[15,30,0,170,22,100,5,0,0,0,
2,0,-350,0,2,800,0,0,0.7]],[[1442,14654,0,135,200,0,1.5708,1,0,0.5,0,0,[]],33,717,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,0,0,0.3]],[[1492,15132,0,80,170,0,0,1,0.5,0.5,0,0,[]],117,718,[],[[0,0,0,0.25,0.5,0.2,0.1,0.01,0,1],[]],[0,"Default",0,1]],[[807,14118,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],118,719,[],[],[0,"Default",0,1]],[[1490.96,15069.6,0,59.8836,50.1381,0,0,1,0.5,0.5,0,0,[]],119,720,[],[[]],[1,"Default",0,1]],[[-115,15199,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],120,721,[],[],[0,
"Default",0,1]]],[]],["Decortop",7,0x556babb27b763,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[960,15085,0,110,50,0,0,1,0.454545,0.36,0,0,[]],86,722,[],[],[0,"Default",0,1]],[[518,15213,0,124,44,0,0,1,0.491935,0.454545,0,0,[]],83,723,[],[],[0,"Default",0,1]]],[]],["Water",8,5015826439665246,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-51,15238,0,1382,128,0,0,1,0,0,0,0,[]],27,724,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[-48,15362,0,1379,435,0,0,1,0,0,0,0,[]],84,725,[],[[]],[0,0]]],[]],["UI",9,6580859865864079,!0,[255,
255,255],!0,0,0,1,!1,1,0,0,[[[1364,15203,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,726,[["odin"]],[],[0,"Default",0,1]],[[1366,15166,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,727,[["dva"]],[],[0,"Default",0,1]],[[1360,15094,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,728,[["dva"]],[],[1,"Default",0,1]],[[1363,15131,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,729,[["raz"]],[],[1,"Default",0,1]],[[1384,14990,0,100,100,0,0,1,0.5,0.5,0,0,[]],60,730,[],[[20,0]],[0,"Default",0,1]],[[1416,14500,0,50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,731,[[1]],
[],[0,"Default",0,1]],[[172.861,52.2845,0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,732,[],[[]],[0,"Default",0,1]],[[446.861,27.2845,0,-42,51,0,0,1,0.511628,0.509804,0,0,[]],54,733,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,0,1,0.511628,0.509804,0,0,[]],54,734,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[296.861,32.2845,0,273,57,0,0,1,0.501832,0.508772,0,0,[]],52,735,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[215.861,31.2845,0,172.501,32,0,0,1,0,0.5,0,0,[]],32,736,[],[[0,0,0,0,1]],[0,"Default",
0,1]],[[316.861,32.2845,0,216,43,0,0,1,0.5,0.511628,0,0,[]],53,737,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-27,-81,0,107,15910,0,0,1,0,0,0,0,[]],112,739,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[1190,-103,0,107,15910,0,0,1,0,0,0,0,[]],112,740,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[67,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],115,741,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[533,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],116,742,[],[[1,0,0,0,1]],[0,"Default",0,1]],[[146,66,0,33.9411,33.9411,0,0,1,0.5,0.5,0,0,[]],55,
743,[],[],[0,"Default",0,1]],[[-7.76617,7.11015,0,146.959,88,0,0,1,0,0,0,0,[]],4,744,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(255,255,51)",1,1,0,0,0]],[[455.144,65.6482,0,32.027,32.027,0,0,1,0.513514,0.513514,0,0,[]],56,745,[],[],[0,"Default",0,1]],[[460.145,6.16529,0,146.959,88,0,0,1,0,0,0,0,[]],6,746,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(204,255,255)",1,1,0,0,0]],[[53,799,0,67.6461,67.6461,0,0,1,0.508197,0.508197,0,0,[]],114,747,[],[[0,1,0,0,1]],[0,"Default",
0,1]],[[95,767,0,488,88,0,0,1,0,0,0,0,[]],121,748,[],[[0,1,0,0,1]],["Left:",0,"36pt Arial Rounded MT Bold","rgb(255,255,255)",0,1,0,0,0]],[[350,-113,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,750,[["EnemyDragon"]],[],[1,0]],[[309,-197,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,756,[["EnemyHaha"]],[],[1,0]],[[-440,-191,0,64,64,0,0,1,0,0,0,0,[]],82,762,[["Sp1"]],[],[1,0]],[[120,-110,0,64,64,0,0,1,0,0,0,0,[]],82,763,[["EarthA"]],[],[1,0]],[[7,-113,0,64,64,0,0,1,0,0,0,0,[]],82,764,[["Power"]],[],[1,0]],[[223,
-111,0,64,64,0,0,1,0,0,0,0,[]],82,765,[["Decor1A"]],[],[1,0]],[[225,-184,0,64,64,0,0,1,0,0,0,0,[]],82,766,[["Decor2A"]],[],[1,0]],[[225,-260,0,64,64,0,0,1,0,0,0,0,[]],82,767,[["Decor3A"]],[],[1,0]],[[227,-334,0,64,64,0,0,1,0,0,0,0,[]],82,768,[["Decor4A"]],[],[1,0]],[[421,-112,0,64,64,0,0,1,0,0,0,0,[]],82,770,[["Money1"]],[],[1,0]],[[422,-196,0,64,64,0,0,1,0,0,0,0,[]],82,771,[["Money2"]],[],[1,0]]],[]],["ball",10,0xef6428421476a,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[559,834,0,50,50,0,0,1,0.5,0.5,0,
0,[]],238,1544,[],[[1,1,0,0,1]],[1,"Default",0,1]]],[]]],[],[]],["Lewel11",1280,15360,!1,"Lewel11",7026218526381921,[["BG",0,0xec48a144db613,!0,[8,69,143],!1,1,1,1,!1,1,0,0,[],[]],["BG(sky)",1,0xdc96003a54ab6,!0,[255,255,255],!0,0.05,0.08,1,!1,1,0,0,[[[293,1228,0,700,400,0,0,1,0.5,0.5,0,0,[]],130,193,[],[],[0,"Default",0,1]]],[]],["BG(mountian)",2,9848254537156176,!0,[255,255,255],!0,0.05,0.06,1,!1,1,0,0,[],[]],["Map",3,7363662081335278,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-270,15195,0,250,250,0,
0,1,0.5,0.5,0,0,[]],81,775,[],[],[0,"Default",0,1]]],[]],["Earth",4,5281334240666173,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[515,15252,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,776,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[270,15034,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,777,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[661,14841,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,778,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[274,14667,0,127.739,
46.8378,0,0,1,0.5,0.515152,0,0,[]],23,779,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[544,14413,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,780,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[960,15129,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,781,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[957,14843,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,782,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[961,14568,0,127.741,46.8384,0,0,1,0.5,
0.515152,0,0,[]],85,783,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[277,14996,0,120,68,0,0,1,0.475,0.397059,0,0,[]],87,784,[],[],[0,"Default",0,1]],[[982,14753,0,170,150,0,0,1,0.441176,0.493333,0,0,[]],88,785,[],[],[0,"Default",0,1]],[[597,248,0,3729,81,0,0,1,0.5,0.5,0,0,[]],111,788,[],[],[1,"Default",0,1]],[[649,14755,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1429,[],[],[0,"Default",0,1]],[[527,14697,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1430,[],[],[0,"Default",0,1]]],[]],["Power",5,0x3f8d945ac227c,
!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[430,14792,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],56,789,[],[],[0,"Default",0,1]]],[]],["Mouse",6,6021469190052609,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[514,15092,0,64.0195,53.1053,0,0,1,0.504,0.989247,0,0,[]],21,790,[],[[]],[0,"Default",0,1]],[[513,15103,0,82.0271,93.3333,0,0,1,0.45,0.00909091,0,0,[]],20,791,[[150]],[[0,0,1,0.25,0.5,0.2,1.5,0.01,0,1],[]],[0,"Default",0,1]],[[514,15101,0,8.82941,-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,792,[],[],[0,"Default",
0,1]],[[1542,14652,0,128,128,0,1.57081,1,0,0.5,0,0,[]],34,793,[],[],[15,30,0,170,22,100,5,0,0,0,2,0,-350,0,2,800,0,0,0.7]],[[1442,14654,0,135,200,0,1.5708,1,0,0.5,0,0,[]],33,794,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,0,0,0.3]],[[1492,15132,0,80,170,0,0,1,0.5,0.5,0,0,[]],117,795,[],[[0,0,0,0.25,0.5,0.2,0.1,0.01,0,1],[]],[0,"Default",0,1]],[[513,14972,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],118,796,[],[],[0,"Default",0,1]],[[1490.96,15069.6,0,59.8836,50.1381,0,0,1,0.5,0.5,0,0,[]],119,797,
[],[[]],[1,"Default",0,1]],[[-89,15223,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],120,798,[],[],[0,"Default",0,1]]],[]],["Decortop",7,0x3f9754dc12eb6,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[960,15085,0,110,50,0,0,1,0.454545,0.36,0,0,[]],86,799,[],[],[0,"Default",0,1]],[[518,15213,0,124,44,0,0,1,0.491935,0.454545,0,0,[]],83,800,[],[],[0,"Default",0,1]]],[]],["Water",8,0xcdc1717c7068c,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-51,15238,0,1382,128,0,0,1,0,0,0,0,[]],27,801,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[-48,
15362,0,1379,435,0,0,1,0,0,0,0,[]],84,802,[],[[]],[0,0]]],[]],["UI",9,9607516726944932,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[1364,15203,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,803,[["odin"]],[],[0,"Default",0,1]],[[1366,15166,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,804,[["dva"]],[],[0,"Default",0,1]],[[1360,15094,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,805,[["dva"]],[],[1,"Default",0,1]],[[1363,15131,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,806,[["raz"]],[],[1,"Default",0,1]],[[1384,14990,0,100,100,0,0,1,0.5,0.5,0,0,[]],60,807,
[],[[20,0]],[0,"Default",0,1]],[[1416,14500,0,50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,808,[[1]],[],[0,"Default",0,1]],[[172.861,52.2845,0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,809,[],[[]],[0,"Default",0,1]],[[446.861,27.2845,0,-42,51,0,0,1,0.511628,0.509804,0,0,[]],54,810,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,0,1,0.511628,0.509804,0,0,[]],54,811,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[296.861,32.2845,0,273,57,0,0,1,0.501832,0.508772,0,0,[]],52,812,[],[[0,0,0,0,1]],[0,"Default",
0,1]],[[215.861,31.2845,0,172.501,32,0,0,1,0,0.5,0,0,[]],32,813,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[316.861,32.2845,0,216,43,0,0,1,0.5,0.511628,0,0,[]],53,814,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-27,-81,0,107,15910,0,0,1,0,0,0,0,[]],112,816,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[1190,-103,0,107,15910,0,0,1,0,0,0,0,[]],112,817,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[67,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],115,818,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[533,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],116,
819,[],[[1,0,0,0,1]],[0,"Default",0,1]],[[146,66,0,33.9411,33.9411,0,0,1,0.5,0.5,0,0,[]],55,820,[],[],[0,"Default",0,1]],[[-7.76617,7.11015,0,146.959,88,0,0,1,0,0,0,0,[]],4,821,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(255,255,51)",1,1,0,0,0]],[[455.144,65.6482,0,32.027,32.027,0,0,1,0.513514,0.513514,0,0,[]],56,822,[],[],[0,"Default",0,1]],[[460.145,6.16529,0,146.959,88,0,0,1,0,0,0,0,[]],6,823,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(204,255,255)",1,1,0,0,0]],
[[53,799,0,67.6461,67.6461,0,0,1,0.508197,0.508197,0,0,[]],114,824,[],[[0,1,0,0,1]],[0,"Default",0,1]],[[95,767,0,488,88,0,0,1,0,0,0,0,[]],121,825,[],[[0,1,0,0,1]],["Left:",0,"36pt Arial Rounded MT Bold","rgb(255,255,255)",0,1,0,0,0]],[[350,-158,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,828,[["EnemyRobot"]],[],[1,0]],[[-440,-374,0,64,64,0,0,1,0,0,0,0,[]],82,837,[["Sp3"]],[],[1,0]],[[120,-110,0,64,64,0,0,1,0,0,0,0,[]],82,840,[["EarthA"]],[],[1,0]],[[7,-113,0,64,64,0,0,1,0,0,0,0,[]],82,841,[["Power"]],
[],[1,0]],[[223,-111,0,64,64,0,0,1,0,0,0,0,[]],82,842,[["Decor1B"]],[],[1,0]],[[225,-184,0,64,64,0,0,1,0,0,0,0,[]],82,843,[["Decor2B"]],[],[1,0]],[[225,-260,0,64,64,0,0,1,0,0,0,0,[]],82,844,[["Decor3B"]],[],[1,0]],[[227,-334,0,64,64,0,0,1,0,0,0,0,[]],82,845,[["Decor4B"]],[],[1,0]],[[311,-73,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,846,[["EnemyRoach"]],[],[1,0]],[[421,-112,0,64,64,0,0,1,0,0,0,0,[]],82,847,[["Money1"]],[],[1,0]],[[422,-196,0,64,64,0,0,1,0,0,0,0,[]],82,848,[["Money2"]],[],[1,0]]],[]],
["ball",10,0x7e060915331c6,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[559,834,0,50,50,0,0,1,0.5,0.5,0,0,[]],238,1543,[],[[1,1,0,0,1]],[1,"Default",0,1]]],[]]],[],[]],["Lewel12",1280,15360,!1,"Lewel12",805953878508688,[["BG",0,0xcdf093c5780bd,!0,[5,67,140],!1,1,1,1,!1,1,0,0,[],[]],["BG(sky)",1,6619345541594158,!0,[255,255,255],!0,0.05,0.08,1,!1,1,0,0,[[[293,1228,0,700,400,0,0,1,0.5,0.5,0,0,[]],130,282,[],[],[0,"Default",0,1]]],[]],["BG(mountian)",2,8807732792585993,!0,[255,255,255],!0,0.05,0.06,1,!1,1,
0,0,[],[]],["Map",3,802419981156988,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-270,15195,0,250,250,0,0,1,0.5,0.5,0,0,[]],81,852,[],[],[0,"Default",0,1]]],[]],["Earth",4,5887120846756909,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[515,15252,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,853,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[270,15034,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,854,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[661,14841,0,127.739,46.8378,0,0,1,0.5,0.515152,
0,0,[]],23,855,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[274,14667,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,856,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[544,14413,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,857,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[960,15129,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,858,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[957,14843,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,859,[],
[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[961,14568,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,860,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[277,14996,0,120,68,0,0,1,0.475,0.397059,0,0,[]],87,861,[],[],[0,"Default",0,1]],[[982,14753,0,170,150,0,0,1,0.441176,0.493333,0,0,[]],88,862,[],[],[0,"Default",0,1]],[[597,248,0,3729,81,0,0,1,0.5,0.5,0,0,[]],111,865,[],[],[1,"Default",0,1]],[[616,14672,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1390,[],[],[0,"Default",0,1]],[[620,15014,
0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1418,[],[],[0,"Default",0,1]]],[]],["Power",5,6478837643857961,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[430,14792,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],56,866,[],[],[0,"Default",0,1]]],[]],["Mouse",6,6945598352186564,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[514,15092,0,64.0195,53.1053,0,0,1,0.504,0.989247,0,0,[]],21,867,[],[[]],[0,"Default",0,1]],[[513,15103,0,82.0271,93.3333,0,0,1,0.45,0.00909091,0,0,[]],20,868,[[150]],[[0,0,1,0.25,0.5,0.2,1.5,0.01,0,1],[]],[0,"Default",
0,1]],[[514,15101,0,8.82941,-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,869,[],[],[0,"Default",0,1]],[[1542,14652,0,128,128,0,1.57081,1,0,0.5,0,0,[]],34,870,[],[],[15,30,0,170,22,100,5,0,0,0,2,0,-350,0,2,800,0,0,0.7]],[[1442,14654,0,135,200,0,1.5708,1,0,0.5,0,0,[]],33,871,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,0,0,0.3]],[[1492,15132,0,80,170,0,0,1,0.5,0.5,0,0,[]],117,872,[],[[0,0,0,0.25,0.5,0.2,0.1,0.01,0,1],[]],[0,"Default",0,1]],[[955,14788,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],118,
873,[],[],[0,"Default",0,1]],[[1490.96,15069.6,0,59.8836,50.1381,0,0,1,0.5,0.5,0,0,[]],119,874,[],[[]],[1,"Default",0,1]],[[-137,15155,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],120,875,[],[],[0,"Default",0,1]]],[]],["Decortop",7,6501803870861386,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[960,15085,0,110,50,0,0,1,0.454545,0.36,0,0,[]],86,876,[],[],[0,"Default",0,1]],[[518,15213,0,124,44,0,0,1,0.491935,0.454545,0,0,[]],83,877,[],[],[0,"Default",0,1]]],[]],["Water",8,5494827173628905,!0,[255,255,255],!0,1,
1,1,!1,1,0,0,[[[-51,15238,0,1382,128,0,0,1,0,0,0,0,[]],27,878,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[-48,15362,0,1379,435,0,0,1,0,0,0,0,[]],84,879,[],[[]],[0,0]]],[]],["UI",9,7236101333005388,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[1364,15203,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,880,[["odin"]],[],[0,"Default",0,1]],[[1366,15166,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,881,[["dva"]],[],[0,"Default",0,1]],[[1360,15094,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,882,[["dva"]],[],[1,"Default",0,1]],[[1363,15131,0,16,16,0,0,1,0.5,
0.5,0,0,[]],89,883,[["raz"]],[],[1,"Default",0,1]],[[1384,14990,0,100,100,0,0,1,0.5,0.5,0,0,[]],60,884,[],[[20,0]],[0,"Default",0,1]],[[1416,14500,0,50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,885,[[1]],[],[0,"Default",0,1]],[[172.861,52.2845,0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,886,[],[[]],[0,"Default",0,1]],[[446.861,27.2845,0,-42,51,0,0,1,0.511628,0.509804,0,0,[]],54,887,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,0,1,0.511628,0.509804,0,0,[]],54,888,[],[[0,0,0,0,1]],[0,
"Default",0,1]],[[296.861,32.2845,0,273,57,0,0,1,0.501832,0.508772,0,0,[]],52,889,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[215.861,31.2845,0,172.501,32,0,0,1,0,0.5,0,0,[]],32,890,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[316.861,32.2845,0,216,43,0,0,1,0.5,0.511628,0,0,[]],53,891,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-27,-81,0,107,15910,0,0,1,0,0,0,0,[]],112,893,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[1190,-103,0,107,15910,0,0,1,0,0,0,0,[]],112,894,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[67,46,0,112,
72,0,0,1,0.5,0.5,0,0,[]],115,895,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[533,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],116,896,[],[[1,0,0,0,1]],[0,"Default",0,1]],[[146,66,0,33.9411,33.9411,0,0,1,0.5,0.5,0,0,[]],55,897,[],[],[0,"Default",0,1]],[[-7.76617,7.11015,0,146.959,88,0,0,1,0,0,0,0,[]],4,898,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(255,255,51)",1,1,0,0,0]],[[455.144,65.6482,0,32.027,32.027,0,0,1,0.513514,0.513514,0,0,[]],56,899,[],[],[0,"Default",0,1]],[[460.145,6.16529,0,146.959,
88,0,0,1,0,0,0,0,[]],6,900,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(204,255,255)",1,1,0,0,0]],[[53,799,0,67.6461,67.6461,0,0,1,0.508197,0.508197,0,0,[]],114,901,[],[[0,1,0,0,1]],[0,"Default",0,1]],[[95,767,0,488,88,0,0,1,0,0,0,0,[]],121,902,[],[[0,1,0,0,1]],["Left:",0,"36pt Arial Rounded MT Bold","rgb(255,255,255)",0,1,0,0,0]],[[350,-196,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,906,[["EnemyHypno"]],[],[1,0]],[[311,-157,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,909,[["EnemyBoo"]],[],
[1,0]],[[-440,-460,0,64,64,0,0,1,0,0,0,0,[]],82,913,[["Sp4"]],[],[1,0]],[[120,-110,0,64,64,0,0,1,0,0,0,0,[]],82,917,[["EarthA"]],[],[1,0]],[[7,-113,0,64,64,0,0,1,0,0,0,0,[]],82,918,[["Power"]],[],[1,0]],[[223,-111,0,64,64,0,0,1,0,0,0,0,[]],82,919,[["Decor1B"]],[],[1,0]],[[225,-184,0,64,64,0,0,1,0,0,0,0,[]],82,920,[["Decor2B"]],[],[1,0]],[[225,-260,0,64,64,0,0,1,0,0,0,0,[]],82,921,[["Decor3B"]],[],[1,0]],[[227,-334,0,64,64,0,0,1,0,0,0,0,[]],82,922,[["Decor4B"]],[],[1,0]],[[421,-112,0,64,64,0,0,1,0,
0,0,0,[]],82,924,[["Money1"]],[],[1,0]],[[422,-196,0,64,64,0,0,1,0,0,0,0,[]],82,925,[["Money2"]],[],[1,0]]],[]],["ball",10,0x8067d2b69fb07,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[559,834,0,50,50,0,0,1,0.5,0.5,0,0,[]],238,1531,[],[[1,1,0,0,1]],[1,"Default",0,1]]],[]]],[],[]],["Lewel13",1280,15360,!1,"Lewel13",5280039599105337,[["BG",0,4597807637363145,!0,[7,70,143],!1,1,1,1,!1,1,0,0,[],[]],["BG(sky)",1,9595846235170274,!0,[255,255,255],!0,0.05,0.08,1,!1,1,0,0,[[[293,1228,0,700,400,0,0,1,0.5,0.5,0,0,
[]],130,206,[],[],[0,"Default",0,1]]],[]],["BG(mountian)",2,6689793252738099,!0,[255,255,255],!0,0.05,0.06,1,!1,1,0,0,[],[]],["Map",3,933771711085681,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-270,15195,0,250,250,0,0,1,0.5,0.5,0,0,[]],81,929,[],[],[0,"Default",0,1]]],[]],["Earth",4,7323848248419186,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[515,15252,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,930,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[270,15034,0,127.739,46.8378,0,0,1,0.5,0.515152,
0,0,[]],23,931,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[661,14841,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,932,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[274,14667,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,933,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[544,14413,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,934,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[960,15129,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,935,[],
[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[957,14843,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,936,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[961,14568,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,937,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[277,14996,0,120,68,0,0,1,0.475,0.397059,0,0,[]],87,938,[],[],[0,"Default",0,1]],[[982,14753,0,170,150,0,0,1,0.441176,0.493333,0,0,[]],88,939,[],[],[0,"Default",0,1]],[[597,248,0,3729,81,0,0,1,0.5,0.5,0,0,
[]],111,942,[],[],[1,"Default",0,1]],[[700,14946,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1377,[],[],[0,"Default",0,1]],[[423,14648,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1389,[],[],[0,"Default",0,1]]],[]],["Power",5,5078190076245914,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[430,14792,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],56,943,[],[],[0,"Default",0,1]]],[]],["Mouse",6,5014170665224678,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[514,15092,0,64.0195,53.1053,0,0,1,0.504,0.989247,0,0,[]],21,944,[],[[]],[0,"Default",0,1]],
[[513,15103,0,82.0271,93.3333,0,0,1,0.45,0.00909091,0,0,[]],20,945,[[150]],[[0,0,1,0.25,0.5,0.2,1.5,0.01,0,1],[]],[0,"Default",0,1]],[[514,15101,0,8.82941,-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,946,[],[],[0,"Default",0,1]],[[1542,14652,0,128,128,0,1.57081,1,0,0.5,0,0,[]],34,947,[],[],[15,30,0,170,22,100,5,0,0,0,2,0,-350,0,2,800,0,0,0.7]],[[1442,14654,0,135,200,0,1.5708,1,0,0.5,0,0,[]],33,948,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,0,0,0.3]],[[1492,15132,0,80,170,0,0,1,0.5,0.5,0,0,[]],
117,949,[],[[0,0,0,0.25,0.5,0.2,0.1,0.01,0,1],[]],[0,"Default",0,1]],[[630,14286,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],118,950,[],[],[0,"Default",0,1]],[[1490.96,15069.6,0,59.8836,50.1381,0,0,1,0.5,0.5,0,0,[]],119,951,[],[[]],[1,"Default",0,1]],[[-110,15206,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],120,952,[],[],[0,"Default",0,1]]],[]],["Decortop",7,0xd6a8308c359bf,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[960,15085,0,110,50,0,0,1,0.454545,0.36,0,0,[]],86,953,[],[],[0,"Default",0,1]],[[518,15213,0,124,
44,0,0,1,0.491935,0.454545,0,0,[]],83,954,[],[],[0,"Default",0,1]]],[]],["Water",8,8132619433957018,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-51,15238,0,1382,128,0,0,1,0,0,0,0,[]],27,955,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[-48,15362,0,1379,435,0,0,1,0,0,0,0,[]],84,956,[],[[]],[0,0]]],[]],["UI",9,6253278279055768,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[1364,15203,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,957,[["odin"]],[],[0,"Default",0,1]],[[1366,15166,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,958,[["dva"]],[],[0,"Default",
0,1]],[[1360,15094,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,959,[["dva"]],[],[1,"Default",0,1]],[[1363,15131,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,960,[["raz"]],[],[1,"Default",0,1]],[[1384,14990,0,100,100,0,0,1,0.5,0.5,0,0,[]],60,961,[],[[20,0]],[0,"Default",0,1]],[[1416,14500,0,50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,962,[[1]],[],[0,"Default",0,1]],[[172.861,52.2845,0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,963,[],[[]],[0,"Default",0,1]],[[446.861,27.2845,0,-42,51,0,0,1,0.511628,0.509804,0,0,[]],54,964,[],
[[0,0,0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,0,1,0.511628,0.509804,0,0,[]],54,965,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[296.861,32.2845,0,273,57,0,0,1,0.501832,0.508772,0,0,[]],52,966,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[215.861,31.2845,0,172.501,32,0,0,1,0,0.5,0,0,[]],32,967,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[316.861,32.2845,0,216,43,0,0,1,0.5,0.511628,0,0,[]],53,968,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-27,-81,0,107,15910,0,0,1,0,0,0,0,[]],112,970,[],[[1,0,0,1,0.5,0.2,0,0.01,
0,1]],[1,0]],[[1190,-103,0,107,15910,0,0,1,0,0,0,0,[]],112,971,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[67,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],115,972,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[533,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],116,973,[],[[1,0,0,0,1]],[0,"Default",0,1]],[[146,66,0,33.9411,33.9411,0,0,1,0.5,0.5,0,0,[]],55,974,[],[],[0,"Default",0,1]],[[-7.76617,7.11015,0,146.959,88,0,0,1,0,0,0,0,[]],4,975,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(255,255,51)",1,1,0,0,0]],[[455.144,
65.6482,0,32.027,32.027,0,0,1,0.513514,0.513514,0,0,[]],56,976,[],[],[0,"Default",0,1]],[[460.145,6.16529,0,146.959,88,0,0,1,0,0,0,0,[]],6,977,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(204,255,255)",1,1,0,0,0]],[[53,799,0,67.6461,67.6461,0,0,1,0.508197,0.508197,0,0,[]],114,978,[],[[0,1,0,0,1]],[0,"Default",0,1]],[[95,767,0,488,88,0,0,1,0,0,0,0,[]],121,979,[],[[0,1,0,0,1]],["Left:",0,"36pt Arial Rounded MT Bold","rgb(255,255,255)",0,1,0,0,0]],[[350,-196,0,26.9258,26.9258,0,0,1,0,
0,0,0,[]],82,983,[["EnemyHypno"]],[],[1,0]],[[311,-115,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,985,[["EnemyKaktus"]],[],[1,0]],[[-440,-281,0,64,64,0,0,1,0,0,0,0,[]],82,992,[["Sp2"]],[],[1,0]],[[120,-110,0,64,64,0,0,1,0,0,0,0,[]],82,994,[["EarthA"]],[],[1,0]],[[7,-113,0,64,64,0,0,1,0,0,0,0,[]],82,995,[["Power"]],[],[1,0]],[[223,-111,0,64,64,0,0,1,0,0,0,0,[]],82,996,[["Decor1B"]],[],[1,0]],[[225,-184,0,64,64,0,0,1,0,0,0,0,[]],82,997,[["Decor2B"]],[],[1,0]],[[225,-260,0,64,64,0,0,1,0,0,0,0,[]],82,998,
[["Decor3B"]],[],[1,0]],[[227,-334,0,64,64,0,0,1,0,0,0,0,[]],82,999,[["Decor4B"]],[],[1,0]],[[421,-112,0,64,64,0,0,1,0,0,0,0,[]],82,1001,[["Money1"]],[],[1,0]],[[422,-196,0,64,64,0,0,1,0,0,0,0,[]],82,1002,[["Money2"]],[],[1,0]]],[]],["ball",10,8138283326784652,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[559,834,0,50,50,0,0,1,0.5,0.5,0,0,[]],238,1608,[],[[1,1,0,0,1]],[1,"Default",0,1]]],[]]],[],[]],["Lewel14",1280,15360,!1,"Lewel14",0xb73461c65e3c1,[["BG",0,9124932650024060,!0,[5,69,141],!1,1,1,1,!1,1,0,
0,[[[308,-232,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,602,[["EnemyKaktus"]],[],[1,0]]],[]],["BG(sky)",1,7367448934317546,!0,[255,255,255],!0,0.05,0.08,1,!1,1,0,0,[[[293,1228,0,700,400,0,0,1,0.5,0.5,0,0,[]],130,205,[],[],[0,"Default",0,1]]],[]],["BG(mountian)",2,5807810016126758,!0,[255,255,255],!0,0.05,0.06,1,!1,1,0,0,[],[]],["Map",3,8570625641947517,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-270,15195,0,250,250,0,0,1,0.5,0.5,0,0,[]],81,1006,[],[],[0,"Default",0,1]]],[]],["Earth",4,0x79a460aa116f5,!0,
[255,255,255],!0,1,1,1,!1,1,0,0,[[[515,15252,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1007,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[270,15034,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1008,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[661,14841,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1009,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[274,14667,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1010,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],
[0,"Default",0,1]],[[544,14413,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1011,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[960,15129,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1012,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[957,14843,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1013,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[961,14568,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1014,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",
0,1]],[[277,14996,0,120,68,0,0,1,0.475,0.397059,0,0,[]],87,1015,[],[],[0,"Default",0,1]],[[982,14753,0,170,150,0,0,1,0.441176,0.493333,0,0,[]],88,1016,[],[],[0,"Default",0,1]],[[597,248,0,3729,81,0,0,1,0.5,0.5,0,0,[]],111,1019,[],[],[1,"Default",0,1]],[[638,15140,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1511,[],[],[0,"Default",0,1]],[[809,14706,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1512,[],[],[0,"Default",0,1]]],[]],["Power",5,0x982460068f48d,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[430,14792,0,37,37,0,0,1,0.513514,
0.513514,0,0,[]],56,1020,[],[],[0,"Default",0,1]]],[]],["Mouse",6,0xc7d533aab05f,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[514,15092,0,64.0195,53.1053,0,0,1,0.504,0.989247,0,0,[]],21,1021,[],[[]],[0,"Default",0,1]],[[513,15103,0,82.0271,93.3333,0,0,1,0.45,0.00909091,0,0,[]],20,1022,[[150]],[[0,0,1,0.25,0.5,0.2,1.5,0.01,0,1],[]],[0,"Default",0,1]],[[514,15101,0,8.82941,-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,1023,[],[],[0,"Default",0,1]],[[1542,14652,0,128,128,0,1.57081,1,0,0.5,0,0,[]],34,1024,[],
[],[15,30,0,170,22,100,5,0,0,0,2,0,-350,0,2,800,0,0,0.7]],[[1442,14654,0,135,200,0,1.5708,1,0,0.5,0,0,[]],33,1025,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,0,0,0.3]],[[1492,15132,0,80,170,0,0,1,0.5,0.5,0,0,[]],117,1026,[],[[0,0,0,0.25,0.5,0.2,0.1,0.01,0,1],[]],[0,"Default",0,1]],[[657,14520,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],118,1027,[],[],[0,"Default",0,1]],[[1490.96,15069.6,0,59.8836,50.1381,0,0,1,0.5,0.5,0,0,[]],119,1028,[],[[]],[1,"Default",0,1]],[[-98,15214,0,37,37,0,0,1,0.513514,
0.513514,0,0,[]],120,1029,[],[],[0,"Default",0,1]]],[]],["Decortop",7,4665002790691152,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[960,15085,0,110,50,0,0,1,0.454545,0.36,0,0,[]],86,1030,[],[],[0,"Default",0,1]],[[518,15213,0,124,44,0,0,1,0.491935,0.454545,0,0,[]],83,1031,[],[],[0,"Default",0,1]]],[]],["Water",8,8156345451007179,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-51,15238,0,1382,128,0,0,1,0,0,0,0,[]],27,1032,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[-48,15362,0,1379,435,0,0,1,0,0,0,0,[]],84,1033,[],[[]],[0,
0]]],[]],["UI",9,8376043903802407,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[1364,15203,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1034,[["odin"]],[],[0,"Default",0,1]],[[1366,15166,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1035,[["dva"]],[],[0,"Default",0,1]],[[1360,15094,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,1036,[["dva"]],[],[1,"Default",0,1]],[[1363,15131,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,1037,[["raz"]],[],[1,"Default",0,1]],[[1384,14990,0,100,100,0,0,1,0.5,0.5,0,0,[]],60,1038,[],[[20,0]],[0,"Default",0,1]],[[1416,14500,0,
50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,1039,[[1]],[],[0,"Default",0,1]],[[172.861,52.2845,0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,1040,[],[[]],[0,"Default",0,1]],[[446.861,27.2845,0,-42,51,0,0,1,0.511628,0.509804,0,0,[]],54,1041,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,0,1,0.511628,0.509804,0,0,[]],54,1042,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[296.861,32.2845,0,273,57,0,0,1,0.501832,0.508772,0,0,[]],52,1043,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[215.861,31.2845,0,172.501,
32,0,0,1,0,0.5,0,0,[]],32,1044,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[316.861,32.2845,0,216,43,0,0,1,0.5,0.511628,0,0,[]],53,1045,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-27,-81,0,107,15910,0,0,1,0,0,0,0,[]],112,1047,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[1190,-103,0,107,15910,0,0,1,0,0,0,0,[]],112,1048,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[67,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],115,1049,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[533,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],116,1050,[],[[1,0,0,0,1]],[0,"Default",
0,1]],[[146,66,0,33.9411,33.9411,0,0,1,0.5,0.5,0,0,[]],55,1051,[],[],[0,"Default",0,1]],[[-7.76617,7.11015,0,146.959,88,0,0,1,0,0,0,0,[]],4,1052,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(255,255,51)",1,1,0,0,0]],[[455.144,65.6482,0,32.027,32.027,0,0,1,0.513514,0.513514,0,0,[]],56,1053,[],[],[0,"Default",0,1]],[[460.145,6.16529,0,146.959,88,0,0,1,0,0,0,0,[]],6,1054,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(204,255,255)",1,1,0,0,0]],[[53,799,0,67.6461,67.6461,0,
0,1,0.508197,0.508197,0,0,[]],114,1055,[],[[0,1,0,0,1]],[0,"Default",0,1]],[[95,767,0,488,88,0,0,1,0,0,0,0,[]],121,1056,[],[[0,1,0,0,1]],["Left:",0,"36pt Arial Rounded MT Bold","rgb(255,255,255)",0,1,0,0,0]],[[350,-158,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1059,[["EnemyRobot"]],[],[1,0]],[[-440,-460,0,64,64,0,0,1,0,0,0,0,[]],82,1067,[["Sp4"]],[],[1,0]],[[120,-110,0,64,64,0,0,1,0,0,0,0,[]],82,1071,[["EarthA"]],[],[1,0]],[[7,-113,0,64,64,0,0,1,0,0,0,0,[]],82,1072,[["Power"]],[],[1,0]],[[223,-111,0,
64,64,0,0,1,0,0,0,0,[]],82,1073,[["Decor1B"]],[],[1,0]],[[225,-184,0,64,64,0,0,1,0,0,0,0,[]],82,1074,[["Decor2B"]],[],[1,0]],[[225,-260,0,64,64,0,0,1,0,0,0,0,[]],82,1075,[["Decor3B"]],[],[1,0]],[[227,-334,0,64,64,0,0,1,0,0,0,0,[]],82,1076,[["Decor4B"]],[],[1,0]],[[421,-112,0,64,64,0,0,1,0,0,0,0,[]],82,1078,[["Money1"]],[],[1,0]],[[422,-196,0,64,64,0,0,1,0,0,0,0,[]],82,1079,[["Money2"]],[],[1,0]]],[]],["ball",10,5719423148568588,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[559,834,0,50,50,0,0,1,0.5,0.5,0,
0,[]],238,1607,[],[[1,1,0,0,1]],[1,"Default",0,1]]],[]]],[],[]],["Lewel15",1280,15360,!1,"Lewel15",5861705168579785,[["BG",0,6411447794942117,!0,[5,69,141],!1,1,1,1,!1,1,0,0,[[[344,-150,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1065,[["EnemyHypno"]],[],[1,0]]],[]],["BG(sky)",1,8916573070957418,!0,[255,255,255],!0,0.05,0.08,1,!1,1,0,0,[[[293,1228,0,700,400,0,0,1,0.5,0.5,0,0,[]],130,204,[],[],[0,"Default",0,1]]],[]],["BG(mountian)",2,8220990782801533,!0,[255,255,255],!0,0.05,0.06,1,!1,1,0,0,[],[]],["Map",
3,0xe6a36779bfe0d,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-270,15195,0,250,250,0,0,1,0.5,0.5,0,0,[]],81,1083,[],[],[0,"Default",0,1]]],[]],["Earth",4,6668889644686247,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[515,15252,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1084,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[270,15034,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1085,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[661,14841,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],
23,1086,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[274,14667,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1087,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[544,14413,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1088,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[960,15129,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1089,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[957,14843,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1090,[],[[1,
0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[961,14568,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1091,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[277,14996,0,120,68,0,0,1,0.475,0.397059,0,0,[]],87,1092,[],[],[0,"Default",0,1]],[[982,14753,0,170,150,0,0,1,0.441176,0.493333,0,0,[]],88,1093,[],[],[0,"Default",0,1]],[[597,248,0,3729,81,0,0,1,0.5,0.5,0,0,[]],111,1096,[],[],[1,"Default",0,1]],[[771,14960,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1508,[],[],[0,"Default",0,1]],[[521,14784,
0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1509,[],[],[0,"Default",0,1]]],[]],["Power",5,0x8568c0146d64b,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[430,14792,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],56,1097,[],[],[0,"Default",0,1]]],[]],["Mouse",6,0x4f7ef02089ee3,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[514,15092,0,64.0195,53.1053,0,0,1,0.504,0.989247,0,0,[]],21,1098,[],[[]],[0,"Default",0,1]],[[513,15103,0,82.0271,93.3333,0,0,1,0.45,0.00909091,0,0,[]],20,1099,[[150]],[[0,0,1,0.25,0.5,0.2,1.5,0.01,0,1],[]],[0,"Default",
0,1]],[[514,15101,0,8.82941,-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,1100,[],[],[0,"Default",0,1]],[[1542,14652,0,128,128,0,1.57081,1,0,0.5,0,0,[]],34,1101,[],[],[15,30,0,170,22,100,5,0,0,0,2,0,-350,0,2,800,0,0,0.7]],[[1442,14654,0,135,200,0,1.5708,1,0,0.5,0,0,[]],33,1102,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,0,0,0.3]],[[1492,15132,0,80,170,0,0,1,0.5,0.5,0,0,[]],117,1103,[],[[0,0,0,0.25,0.5,0.2,0.1,0.01,0,1],[]],[0,"Default",0,1]],[[812,14748,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],
118,1104,[],[],[0,"Default",0,1]],[[1490.96,15069.6,0,59.8836,50.1381,0,0,1,0.5,0.5,0,0,[]],119,1105,[],[[]],[1,"Default",0,1]],[[-93,15209,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],120,1106,[],[],[0,"Default",0,1]]],[]],["Decortop",7,620233528321802,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[960,15085,0,110,50,0,0,1,0.454545,0.36,0,0,[]],86,1107,[],[],[0,"Default",0,1]],[[518,15213,0,124,44,0,0,1,0.491935,0.454545,0,0,[]],83,1108,[],[],[0,"Default",0,1]]],[]],["Water",8,786787898131406,!0,[255,255,255],
!0,1,1,1,!1,1,0,0,[[[-51,15238,0,1382,128,0,0,1,0,0,0,0,[]],27,1109,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[-48,15362,0,1379,435,0,0,1,0,0,0,0,[]],84,1110,[],[[]],[0,0]]],[]],["UI",9,0xe7d52e3e82c97,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[1364,15203,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1111,[["odin"]],[],[0,"Default",0,1]],[[1366,15166,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1112,[["dva"]],[],[0,"Default",0,1]],[[1360,15094,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,1113,[["dva"]],[],[1,"Default",0,1]],[[1363,15131,0,16,16,
0,0,1,0.5,0.5,0,0,[]],89,1114,[["raz"]],[],[1,"Default",0,1]],[[1384,14990,0,100,100,0,0,1,0.5,0.5,0,0,[]],60,1115,[],[[20,0]],[0,"Default",0,1]],[[1416,14500,0,50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,1116,[[1]],[],[0,"Default",0,1]],[[172.861,52.2845,0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,1117,[],[[]],[0,"Default",0,1]],[[446.861,27.2845,0,-42,51,0,0,1,0.511628,0.509804,0,0,[]],54,1118,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,0,1,0.511628,0.509804,0,0,[]],54,1119,[],[[0,
0,0,0,1]],[0,"Default",0,1]],[[296.861,32.2845,0,273,57,0,0,1,0.501832,0.508772,0,0,[]],52,1120,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[215.861,31.2845,0,172.501,32,0,0,1,0,0.5,0,0,[]],32,1121,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[316.861,32.2845,0,216,43,0,0,1,0.5,0.511628,0,0,[]],53,1122,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-27,-81,0,107,15910,0,0,1,0,0,0,0,[]],112,1124,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[1190,-103,0,107,15910,0,0,1,0,0,0,0,[]],112,1125,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,
0]],[[67,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],115,1126,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[533,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],116,1127,[],[[1,0,0,0,1]],[0,"Default",0,1]],[[146,66,0,33.9411,33.9411,0,0,1,0.5,0.5,0,0,[]],55,1128,[],[],[0,"Default",0,1]],[[-7.76617,7.11015,0,146.959,88,0,0,1,0,0,0,0,[]],4,1129,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(255,255,51)",1,1,0,0,0]],[[455.144,65.6482,0,32.027,32.027,0,0,1,0.513514,0.513514,0,0,[]],56,1130,[],[],[0,"Default",0,1]],[[460.145,
6.16529,0,146.959,88,0,0,1,0,0,0,0,[]],6,1131,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(204,255,255)",1,1,0,0,0]],[[53,799,0,67.6461,67.6461,0,0,1,0.508197,0.508197,0,0,[]],114,1132,[],[[0,1,0,0,1]],[0,"Default",0,1]],[[95,767,0,488,88,0,0,1,0,0,0,0,[]],121,1133,[],[[0,1,0,0,1]],["Left:",0,"36pt Arial Rounded MT Bold","rgb(255,255,255)",0,1,0,0,0]],[[351,-238,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1138,[["EnemyAlien"]],[],[1,0]],[[309,-197,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,
1141,[["EnemyHaha"]],[],[1,0]],[[-440,-460,0,64,64,0,0,1,0,0,0,0,[]],82,1144,[["Sp4"]],[],[1,0]],[[-440,-374,0,64,64,0,0,1,0,0,0,0,[]],82,1145,[["Sp3"]],[],[1,0]],[[-440,-281,0,64,64,0,0,1,0,0,0,0,[]],82,1146,[["Sp2"]],[],[1,0]],[[-440,-191,0,64,64,0,0,1,0,0,0,0,[]],82,1147,[["Sp1"]],[],[1,0]],[[120,-110,0,64,64,0,0,1,0,0,0,0,[]],82,1148,[["EarthA"]],[],[1,0]],[[7,-113,0,64,64,0,0,1,0,0,0,0,[]],82,1149,[["Power"]],[],[1,0]],[[223,-111,0,64,64,0,0,1,0,0,0,0,[]],82,1150,[["Decor1B"]],[],[1,0]],[[225,
-184,0,64,64,0,0,1,0,0,0,0,[]],82,1151,[["Decor2B"]],[],[1,0]],[[225,-260,0,64,64,0,0,1,0,0,0,0,[]],82,1152,[["Decor3B"]],[],[1,0]],[[227,-334,0,64,64,0,0,1,0,0,0,0,[]],82,1153,[["Decor4B"]],[],[1,0]],[[421,-112,0,64,64,0,0,1,0,0,0,0,[]],82,1155,[["Money1"]],[],[1,0]],[[422,-196,0,64,64,0,0,1,0,0,0,0,[]],82,1156,[["Money2"]],[],[1,0]]],[]],["ball",10,0xa6cfdff9a825d,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[559,834,0,50,50,0,0,1,0.5,0.5,0,0,[]],238,1589,[],[[1,1,0,0,1]],[1,"Default",0,1]]],[]]],[],[]],
["Lewel16",1280,15360,!1,"Lewel16",8448411895293122,[["BG",0,0xf71afaef1ee4b,!0,[44,159,205],!1,1,1,1,!1,1,0,0,[],[]],["BG(mountian)",1,7821658475546912,!0,[255,255,255],!0,0.05,0.06,1,!1,1,0,0,[[[1,2,0,976,1923,0,0,1,0,0,0,0,[]],131,283,[],[],[0,0]]],[]],["BG(sky)",2,722038109068135,!0,[255,255,255],!0,0.05,0.12,1,!1,1,0,0,[[[404,1252,0,127,127,0,0,1,0.503937,0.503937,0,0,[]],132,284,[],[],[0,"Default",0,1]],[[504,1850,0,113,113,0,0,1,0.504425,0.504425,0,0,[]],133,359,[],[],[0,"Default",0,1]],[[175,
1512,0,115,114,0,0,1,0.504348,0.5,0,0,[]],134,360,[],[],[0,"Default",0,1]],[[176,1086,0,99,91,0,0,1,0.50505,0.505495,0,0,[]],135,361,[],[],[0,"Default",0,1]],[[304,-193,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1135,[["EnemyKaktus"]],[],[1,0]]],[]],["Map",3,0x99ca280cf560b,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-270,15195,0,250,250,0,0,1,0.5,0.5,0,0,[]],81,1160,[],[],[0,"Default",0,1]]],[]],["Earth",4,0xbb26e1305ec6b,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[515,15252,0,127.739,46.8378,0,0,1,0.5,0.515152,
0,0,[]],23,1161,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[270,15034,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1162,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[661,14841,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1163,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[274,14667,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1164,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[544,14413,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1165,
[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[960,15129,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1166,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[957,14843,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1167,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[961,14568,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1168,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[277,14996,0,120,68,0,0,1,0.475,0.397059,0,0,[]],87,1169,[],[],[0,"Default",0,
1]],[[982,14753,0,170,150,0,0,1,0.441176,0.493333,0,0,[]],88,1170,[],[],[0,"Default",0,1]],[[597,248,0,3729,81,0,0,1,0.5,0.5,0,0,[]],111,1173,[],[],[1,"Default",0,1]],[[752,15133,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1506,[],[],[0,"Default",0,1]],[[502,14957,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1507,[],[],[0,"Default",0,1]]],[]],["Power",5,6506658967593441,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[430,14792,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],56,1174,[],[],[0,"Default",0,1]]],[]],["Mouse",6,0xb12105e0e651d,
!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[514,15092,0,64.0195,53.1053,0,0,1,0.504,0.989247,0,0,[]],21,1175,[],[[]],[0,"Default",0,1]],[[513,15103,0,82.0271,93.3333,0,0,1,0.45,0.00909091,0,0,[]],20,1176,[[150]],[[0,0,1,0.25,0.5,0.2,1.5,0.01,0,1],[]],[0,"Default",0,1]],[[514,15101,0,8.82941,-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,1177,[],[],[0,"Default",0,1]],[[1542,14652,0,128,128,0,1.57081,1,0,0.5,0,0,[]],34,1178,[],[],[15,30,0,170,22,100,5,0,0,0,2,0,-350,0,2,800,0,0,0.7]],[[1442,14654,0,135,200,
0,1.5708,1,0,0.5,0,0,[]],33,1179,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,0,0,0.3]],[[1492,15132,0,80,170,0,0,1,0.5,0.5,0,0,[]],117,1180,[],[[0,0,0,0.25,0.5,0.2,0.1,0.01,0,1],[]],[0,"Default",0,1]],[[264,14583,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],118,1181,[],[],[0,"Default",0,1]],[[1490.96,15069.6,0,59.8836,50.1381,0,0,1,0.5,0.5,0,0,[]],119,1182,[],[[]],[1,"Default",0,1]],[[-91,15208,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],120,1183,[],[],[0,"Default",0,1]]],[]],["Decortop",7,775816968117318,
!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[960,15085,0,110,50,0,0,1,0.454545,0.36,0,0,[]],86,1184,[],[],[0,"Default",0,1]],[[518,15213,0,124,44,0,0,1,0.491935,0.454545,0,0,[]],83,1185,[],[],[0,"Default",0,1]]],[]],["Water",8,0x80f7b9cdcd75b,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-51,15238,0,1382,128,0,0,1,0,0,0,0,[]],27,1186,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[-48,15362,0,1379,435,0,0,1,0,0,0,0,[]],84,1187,[],[[]],[0,0]]],[]],["UI",9,9192636278315332,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[1364,15203,0,20,
20,0,0,1,0.5,0.5,0,0,[]],57,1188,[["odin"]],[],[0,"Default",0,1]],[[1366,15166,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1189,[["dva"]],[],[0,"Default",0,1]],[[1360,15094,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,1190,[["dva"]],[],[1,"Default",0,1]],[[1363,15131,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,1191,[["raz"]],[],[1,"Default",0,1]],[[1384,14990,0,100,100,0,0,1,0.5,0.5,0,0,[]],60,1192,[],[[20,0]],[0,"Default",0,1]],[[1416,14500,0,50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,1193,[[1]],[],[0,"Default",0,1]],[[172.861,52.2845,
0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,1194,[],[[]],[0,"Default",0,1]],[[446.861,27.2845,0,-42,51,0,0,1,0.511628,0.509804,0,0,[]],54,1195,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,0,1,0.511628,0.509804,0,0,[]],54,1196,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[296.861,32.2845,0,273,57,0,0,1,0.501832,0.508772,0,0,[]],52,1197,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[215.861,31.2845,0,172.501,32,0,0,1,0,0.5,0,0,[]],32,1198,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[316.861,32.2845,0,216,
43,0,0,1,0.5,0.511628,0,0,[]],53,1199,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-27,-81,0,107,15910,0,0,1,0,0,0,0,[]],112,1201,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[1190,-103,0,107,15910,0,0,1,0,0,0,0,[]],112,1202,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[67,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],115,1203,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[533,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],116,1204,[],[[1,0,0,0,1]],[0,"Default",0,1]],[[146,66,0,33.9411,33.9411,0,0,1,0.5,0.5,0,0,[]],55,1205,[],[],[0,"Default",
0,1]],[[-7.76617,7.11015,0,146.959,88,0,0,1,0,0,0,0,[]],4,1206,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(255,255,51)",1,1,0,0,0]],[[455.144,65.6482,0,32.027,32.027,0,0,1,0.513514,0.513514,0,0,[]],56,1207,[],[],[0,"Default",0,1]],[[460.145,6.16529,0,146.959,88,0,0,1,0,0,0,0,[]],6,1208,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(204,255,255)",1,1,0,0,0]],[[53,799,0,67.6461,67.6461,0,0,1,0.508197,0.508197,0,0,[]],114,1209,[],[[0,1,0,0,1]],[0,"Default",0,1]],[[95,767,
0,488,88,0,0,1,0,0,0,0,[]],121,1210,[],[[0,1,0,0,1]],["Left:",0,"36pt Arial Rounded MT Bold","rgb(255,255,255)",0,1,0,0,0]],[[350,-158,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1213,[["EnemyRobot"]],[],[1,0]],[[-440,-460,0,64,64,0,0,1,0,0,0,0,[]],82,1221,[["Sp4"]],[],[1,0]],[[120,-110,0,64,64,0,0,1,0,0,0,0,[]],82,1225,[["EarthA"]],[],[1,0]],[[7,-113,0,64,64,0,0,1,0,0,0,0,[]],82,1226,[["Power"]],[],[1,0]],[[223,-111,0,64,64,0,0,1,0,0,0,0,[]],82,1227,[["Decor1C"]],[],[1,0]],[[225,-184,0,64,64,0,0,1,0,
0,0,0,[]],82,1228,[["Decor2C"]],[],[1,0]],[[225,-260,0,64,64,0,0,1,0,0,0,0,[]],82,1229,[["Decor3C"]],[],[1,0]],[[227,-334,0,64,64,0,0,1,0,0,0,0,[]],82,1230,[["Decor4C"]],[],[1,0]],[[421,-112,0,64,64,0,0,1,0,0,0,0,[]],82,1232,[["Money1"]],[],[1,0]],[[422,-196,0,64,64,0,0,1,0,0,0,0,[]],82,1233,[["Money2"]],[],[1,0]]],[]],["ball",10,0xb156c6139e89b,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[559,834,0,50,50,0,0,1,0.5,0.5,0,0,[]],238,1590,[],[[1,1,0,0,1]],[1,"Default",0,1]]],[]]],[],[]],["Lewel17",1280,15360,
!1,"Lewel17",0x43a203925902b,[["BG",0,4936249968785335,!0,[44,159,205],!1,1,1,1,!1,1,0,0,[],[]],["BG(mountian)",1,7671440023054041,!0,[255,255,255],!0,0.05,0.06,1,!1,1,0,0,[[[0,0,0,976,1923,0,0,1,0,0,0,0,[]],131,497,[],[],[0,0]]],[]],["BG(sky)",2,322680542477346,!0,[255,255,255],!0,0.05,0.08,1,!1,1,0,0,[[[398,1261,0,127,127,0,0,1,0.503937,0.503937,0,0,[]],132,518,[],[],[0,"Default",0,1]],[[498,1859,0,113,113,0,0,1,0.504425,0.504425,0,0,[]],133,519,[],[],[0,"Default",0,1]],[[169,1521,0,115,114,0,0,
1,0.504348,0.5,0,0,[]],134,520,[],[],[0,"Default",0,1]],[[170,1095,0,99,91,0,0,1,0.50505,0.505495,0,0,[]],135,521,[],[],[0,"Default",0,1]]],[]],["Map",3,0x80f548b63adc7,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-270,15195,0,250,250,0,0,1,0.5,0.5,0,0,[]],81,1237,[],[],[0,"Default",0,1]]],[]],["Earth",4,0xbf0dee444d3ff,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[515,15252,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1238,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[270,15034,0,127.739,46.8378,
0,0,1,0.5,0.515152,0,0,[]],23,1239,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[661,14841,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1240,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[274,14667,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1241,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[544,14413,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1242,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[960,15129,0,127.741,46.8384,0,0,1,0.5,0.515152,
0,0,[]],85,1243,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[957,14843,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1244,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[961,14568,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1309,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[277,14996,0,120,68,0,0,1,0.475,0.397059,0,0,[]],87,1310,[],[],[0,"Default",0,1]],[[982,14753,0,170,150,0,0,1,0.441176,0.493333,0,0,[]],88,1311,[],[],[0,"Default",0,1]],[[597,248,0,3729,
81,0,0,1,0.5,0.5,0,0,[]],111,1314,[],[],[1,"Default",0,1]],[[561,15002,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1442,[],[],[0,"Default",0,1]],[[417,15007,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1449,[],[],[0,"Default",0,1]]],[]],["Power",5,8251082248924601,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[430,14792,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],56,1315,[],[],[0,"Default",0,1]]],[]],["Mouse",6,9427223500549512,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[514,15092,0,64.0195,53.1053,0,0,1,0.504,0.989247,0,0,[]],21,1316,
[],[[]],[0,"Default",0,1]],[[513,15103,0,82.0271,93.3333,0,0,1,0.45,0.00909091,0,0,[]],20,1317,[[150]],[[0,0,1,0.25,0.5,0.2,1.5,0.01,0,1],[]],[0,"Default",0,1]],[[514,15101,0,8.82941,-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,1318,[],[],[0,"Default",0,1]],[[1542,14652,0,128,128,0,1.57081,1,0,0.5,0,0,[]],34,1319,[],[],[15,30,0,170,22,100,5,0,0,0,2,0,-350,0,2,800,0,0,0.7]],[[1442,14654,0,135,200,0,1.5708,1,0,0.5,0,0,[]],33,1320,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,0,0,0.3]],[[1492,15132,
0,80,170,0,0,1,0.5,0.5,0,0,[]],117,1321,[],[[0,0,0,0.25,0.5,0.2,0.1,0.01,0,1],[]],[0,"Default",0,1]],[[564,14789,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],118,1322,[],[],[0,"Default",0,1]],[[1490.96,15069.6,0,59.8836,50.1381,0,0,1,0.5,0.5,0,0,[]],119,1323,[],[[]],[1,"Default",0,1]],[[-97,15237,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],120,1324,[],[],[0,"Default",0,1]]],[]],["Decortop",7,737108552676175,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[960,15085,0,110,50,0,0,1,0.454545,0.36,0,0,[]],86,1325,[],[],
[0,"Default",0,1]],[[518,15213,0,124,44,0,0,1,0.491935,0.454545,0,0,[]],83,1326,[],[],[0,"Default",0,1]]],[]],["Water",8,4759899238900905,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-51,15238,0,1382,128,0,0,1,0,0,0,0,[]],27,1327,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[-48,15362,0,1379,435,0,0,1,0,0,0,0,[]],84,1328,[],[[]],[0,0]]],[]],["UI",9,0x991d2b5a239a5,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[1364,15203,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1329,[["odin"]],[],[0,"Default",0,1]],[[1366,15166,0,20,20,0,0,1,0.5,0.5,
0,0,[]],57,1330,[["dva"]],[],[0,"Default",0,1]],[[1360,15094,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,1331,[["dva"]],[],[1,"Default",0,1]],[[1363,15131,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,1332,[["raz"]],[],[1,"Default",0,1]],[[1384,14990,0,100,100,0,0,1,0.5,0.5,0,0,[]],60,1333,[],[[20,0]],[0,"Default",0,1]],[[1416,14500,0,50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,1334,[[1]],[],[0,"Default",0,1]],[[172.861,52.2845,0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,1335,[],[[]],[0,"Default",0,1]],[[446.861,27.2845,0,-42,
51,0,0,1,0.511628,0.509804,0,0,[]],54,1336,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,0,1,0.511628,0.509804,0,0,[]],54,1337,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[296.861,32.2845,0,273,57,0,0,1,0.501832,0.508772,0,0,[]],52,1338,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[215.861,31.2845,0,172.501,32,0,0,1,0,0.5,0,0,[]],32,1339,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[316.861,32.2845,0,216,43,0,0,1,0.5,0.511628,0,0,[]],53,1340,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-27,-81,0,107,15910,0,
0,1,0,0,0,0,[]],112,1342,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[1190,-103,0,107,15910,0,0,1,0,0,0,0,[]],112,1343,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[67,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],115,1344,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[533,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],116,1345,[],[[1,0,0,0,1]],[0,"Default",0,1]],[[146,66,0,33.9411,33.9411,0,0,1,0.5,0.5,0,0,[]],55,1346,[],[],[0,"Default",0,1]],[[-7.76617,7.11015,0,146.959,88,0,0,1,0,0,0,0,[]],4,1347,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold",
"rgb(255,255,51)",1,1,0,0,0]],[[455.144,65.6482,0,32.027,32.027,0,0,1,0.513514,0.513514,0,0,[]],56,1348,[],[],[0,"Default",0,1]],[[460.145,6.16529,0,146.959,88,0,0,1,0,0,0,0,[]],6,1349,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(204,255,255)",1,1,0,0,0]],[[53,799,0,67.6461,67.6461,0,0,1,0.508197,0.508197,0,0,[]],114,1350,[],[[0,1,0,0,1]],[0,"Default",0,1]],[[95,767,0,488,88,0,0,1,0,0,0,0,[]],121,1351,[],[[0,1,0,0,1]],["Left:",0,"36pt Arial Rounded MT Bold","rgb(255,255,255)",0,1,
0,0,0]],[[351,-238,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1356,[["EnemyAlien"]],[],[1,0]],[[311,-115,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1357,[["EnemyKaktus"]],[],[1,0]],[[-440,-460,0,64,64,0,0,1,0,0,0,0,[]],82,1362,[["Sp4"]],[],[1,0]],[[120,-110,0,64,64,0,0,1,0,0,0,0,[]],82,1366,[["EarthA"]],[],[1,0]],[[7,-113,0,64,64,0,0,1,0,0,0,0,[]],82,1367,[["Power"]],[],[1,0]],[[223,-111,0,64,64,0,0,1,0,0,0,0,[]],82,1368,[["Decor1C"]],[],[1,0]],[[225,-184,0,64,64,0,0,1,0,0,0,0,[]],82,1369,[["Decor2C"]],[],
[1,0]],[[225,-260,0,64,64,0,0,1,0,0,0,0,[]],82,1370,[["Decor3C"]],[],[1,0]],[[227,-334,0,64,64,0,0,1,0,0,0,0,[]],82,1371,[["Decor4C"]],[],[1,0]],[[421,-112,0,64,64,0,0,1,0,0,0,0,[]],82,1373,[["Money1"]],[],[1,0]],[[422,-196,0,64,64,0,0,1,0,0,0,0,[]],82,1374,[["Money2"]],[],[1,0]]],[]],["ball",10,0xa11768b9f1d1f,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[559,834,0,50,50,0,0,1,0.5,0.5,0,0,[]],238,1591,[],[[1,1,0,0,1]],[1,"Default",0,1]]],[]]],[],[]],["Lewel18",1280,15360,!1,"Lewel18",6843921758147919,[["BG",
0,7480030032533219,!0,[44,159,205],!1,1,1,1,!1,1,0,0,[],[]],["BG(mountian)",1,5794765852148709,!0,[255,255,255],!0,0.05,0.06,1,!1,1,0,0,[[[0,0,0,976,1923,0,0,1,0,0,0,0,[]],131,499,[],[],[0,0]]],[]],["BG(sky)",2,6283445066530049,!0,[255,255,255],!0,0.05,0.08,1,!1,1,0,0,[[[414,1261,0,127,127,0,0,1,0.503937,0.503937,0,0,[]],132,522,[],[],[0,"Default",0,1]],[[514,1859,0,113,113,0,0,1,0.504425,0.504425,0,0,[]],133,524,[],[],[0,"Default",0,1]],[[185,1521,0,115,114,0,0,1,0.504348,0.5,0,0,[]],134,525,[],
[],[0,"Default",0,1]],[[186,1095,0,99,91,0,0,1,0.50505,0.505495,0,0,[]],135,527,[],[],[0,"Default",0,1]]],[]],["Map",3,0x9784c9691ccf5,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-270,15195,0,250,250,0,0,1,0.5,0.5,0,0,[]],81,1378,[],[],[0,"Default",0,1]]],[]],["Earth",4,8723242274024157,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[515,15252,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1379,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[270,15034,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1380,
[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[661,14841,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1381,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[274,14667,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1382,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[544,14413,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1383,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[960,15129,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1384,[],[[1,0,0,1,
0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[957,14843,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1385,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[961,14568,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1386,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[277,14996,0,120,68,0,0,1,0.475,0.397059,0,0,[]],87,1387,[],[],[0,"Default",0,1]],[[982,14753,0,170,150,0,0,1,0.441176,0.493333,0,0,[]],88,1388,[],[],[0,"Default",0,1]],[[597,248,0,3729,81,0,0,1,0.5,0.5,0,0,[]],111,
1391,[],[],[1,"Default",0,1]],[[653,15095,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1452,[],[],[0,"Default",0,1]],[[650,14983,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1453,[],[],[0,"Default",0,1]]],[]],["Power",5,0x49fde9f432b57,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[430,14792,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],56,1392,[],[],[0,"Default",0,1]]],[]],["Mouse",6,0xe5852c7e68e2b,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[514,15092,0,64.0195,53.1053,0,0,1,0.504,0.989247,0,0,[]],21,1393,[],[[]],[0,"Default",0,1]],[[513,
15103,0,82.0271,93.3333,0,0,1,0.45,0.00909091,0,0,[]],20,1394,[[150]],[[0,0,1,0.25,0.5,0.2,1.5,0.01,0,1],[]],[0,"Default",0,1]],[[514,15101,0,8.82941,-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,1395,[],[],[0,"Default",0,1]],[[1542,14652,0,128,128,0,1.57081,1,0,0.5,0,0,[]],34,1396,[],[],[15,30,0,170,22,100,5,0,0,0,2,0,-350,0,2,800,0,0,0.7]],[[1442,14654,0,135,200,0,1.5708,1,0,0.5,0,0,[]],33,1397,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,0,0,0.3]],[[1492,15132,0,80,170,0,0,1,0.5,0.5,0,0,[]],
117,1398,[],[[0,0,0,0.25,0.5,0.2,0.1,0.01,0,1],[]],[0,"Default",0,1]],[[794,14954,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],118,1399,[],[],[0,"Default",0,1]],[[1490.96,15069.6,0,59.8836,50.1381,0,0,1,0.5,0.5,0,0,[]],119,1400,[],[[]],[1,"Default",0,1]],[[-94,15219,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],120,1401,[],[],[0,"Default",0,1]]],[]],["Decortop",7,8287365573695288,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[960,15085,0,110,50,0,0,1,0.454545,0.36,0,0,[]],86,1402,[],[],[0,"Default",0,1]],[[518,15213,
0,124,44,0,0,1,0.491935,0.454545,0,0,[]],83,1403,[],[],[0,"Default",0,1]]],[]],["Water",8,8925727990071013,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-51,15238,0,1382,128,0,0,1,0,0,0,0,[]],27,1404,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[-48,15362,0,1379,435,0,0,1,0,0,0,0,[]],84,1405,[],[[]],[0,0]]],[]],["UI",9,4659963156931769,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[1364,15203,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1406,[["odin"]],[],[0,"Default",0,1]],[[1366,15166,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1407,[["dva"]],[],
[0,"Default",0,1]],[[1360,15094,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,1408,[["dva"]],[],[1,"Default",0,1]],[[1363,15131,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,1409,[["raz"]],[],[1,"Default",0,1]],[[1384,14990,0,100,100,0,0,1,0.5,0.5,0,0,[]],60,1410,[],[[20,0]],[0,"Default",0,1]],[[1416,14500,0,50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,1411,[[1]],[],[0,"Default",0,1]],[[172.861,52.2845,0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,1412,[],[[]],[0,"Default",0,1]],[[446.861,27.2845,0,-42,51,0,0,1,0.511628,0.509804,
0,0,[]],54,1413,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,0,1,0.511628,0.509804,0,0,[]],54,1414,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[296.861,32.2845,0,273,57,0,0,1,0.501832,0.508772,0,0,[]],52,1415,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[215.861,31.2845,0,172.501,32,0,0,1,0,0.5,0,0,[]],32,1416,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[316.861,32.2845,0,216,43,0,0,1,0.5,0.511628,0,0,[]],53,1417,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-27,-81,0,107,15910,0,0,1,0,0,0,0,[]],112,1419,[],
[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[1190,-103,0,107,15910,0,0,1,0,0,0,0,[]],112,1420,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[67,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],115,1421,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[533,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],116,1422,[],[[1,0,0,0,1]],[0,"Default",0,1]],[[146,66,0,33.9411,33.9411,0,0,1,0.5,0.5,0,0,[]],55,1423,[],[],[0,"Default",0,1]],[[-7.76617,7.11015,0,146.959,88,0,0,1,0,0,0,0,[]],4,1424,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(255,255,51)",
1,1,0,0,0]],[[455.144,65.6482,0,32.027,32.027,0,0,1,0.513514,0.513514,0,0,[]],56,1425,[],[],[0,"Default",0,1]],[[460.145,6.16529,0,146.959,88,0,0,1,0,0,0,0,[]],6,1426,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(204,255,255)",1,1,0,0,0]],[[53,799,0,67.6461,67.6461,0,0,1,0.508197,0.508197,0,0,[]],114,1427,[],[[0,1,0,0,1]],[0,"Default",0,1]],[[95,767,0,488,88,0,0,1,0,0,0,0,[]],121,1428,[],[[0,1,0,0,1]],["Left:",0,"36pt Arial Rounded MT Bold","rgb(255,255,255)",0,1,0,0,0]],[[311,-115,
0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1434,[["EnemyKaktus"]],[],[1,0]],[[310,-240,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1437,[["EnemySmoke"]],[],[1,0]],[[-440,-374,0,64,64,0,0,1,0,0,0,0,[]],82,1440,[["Sp3"]],[],[1,0]],[[120,-110,0,64,64,0,0,1,0,0,0,0,[]],82,1443,[["EarthA"]],[],[1,0]],[[7,-113,0,64,64,0,0,1,0,0,0,0,[]],82,1444,[["Power"]],[],[1,0]],[[223,-111,0,64,64,0,0,1,0,0,0,0,[]],82,1445,[["Decor1C"]],[],[1,0]],[[225,-184,0,64,64,0,0,1,0,0,0,0,[]],82,1446,[["Decor2C"]],[],[1,0]],[[225,-260,
0,64,64,0,0,1,0,0,0,0,[]],82,1447,[["Decor3C"]],[],[1,0]],[[227,-334,0,64,64,0,0,1,0,0,0,0,[]],82,1448,[["Decor4C"]],[],[1,0]],[[421,-112,0,64,64,0,0,1,0,0,0,0,[]],82,1450,[["Money1"]],[],[1,0]],[[422,-196,0,64,64,0,0,1,0,0,0,0,[]],82,1451,[["Money2"]],[],[1,0]]],[]],["ball",10,0x783595b8014b4,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[559,834,0,50,50,0,0,1,0.5,0.5,0,0,[]],238,1592,[],[[1,1,0,0,1]],[1,"Default",0,1]]],[]]],[],[]],["Lewel19",1280,15360,!1,"Lewel19",0x4077e10ba3488,[["BG",0,0x83df459861a10,
!0,[44,159,205],!1,1,1,1,!1,1,0,0,[],[]],["BG(mountian)",1,9338149484840616,!0,[255,255,255],!0,0.05,0.06,1,!1,1,0,0,[[[0,0,0,976,1923,0,0,1,0,0,0,0,[]],131,500,[],[],[0,0]]],[]],["BG(sky)",2,0x90a81ce1939ef,!0,[255,255,255],!0,0.05,0.08,1,!1,1,0,0,[[[402,1260,0,127,127,0,0,1,0.503937,0.503937,0,0,[]],132,528,[],[],[0,"Default",0,1]],[[502,1858,0,113,113,0,0,1,0.504425,0.504425,0,0,[]],133,529,[],[],[0,"Default",0,1]],[[173,1520,0,115,114,0,0,1,0.504348,0.5,0,0,[]],134,531,[],[],[0,"Default",0,1]],
[[174,1094,0,99,91,0,0,1,0.50505,0.505495,0,0,[]],135,538,[],[],[0,"Default",0,1]]],[]],["Map",3,6299206231114264,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-270,15195,0,250,250,0,0,1,0.5,0.5,0,0,[]],81,1455,[],[],[0,"Default",0,1]]],[]],["Earth",4,7092499122101014,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[515,15252,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1456,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[270,15034,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1457,[],[[1,0,0,1,0.5,
0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[661,14841,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1458,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[274,14667,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1459,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[544,14413,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1460,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[960,15129,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1461,[],[[1,0,0,1,0.5,0.2,0,0.01,0,
1],[1]],[0,"Default",0,1]],[[957,14843,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1462,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[961,14568,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1463,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[277,14996,0,120,68,0,0,1,0.475,0.397059,0,0,[]],87,1464,[],[],[0,"Default",0,1]],[[982,14753,0,170,150,0,0,1,0.441176,0.493333,0,0,[]],88,1465,[],[],[0,"Default",0,1]],[[597,248,0,3729,81,0,0,1,0.5,0.5,0,0,[]],111,1468,[],[],[1,
"Default",0,1]],[[520,14981,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1454,[],[],[0,"Default",0,1]],[[755,15068,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1466,[],[],[0,"Default",0,1]]],[]],["Power",5,8038473298313236,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[430,14792,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],56,1469,[],[],[0,"Default",0,1]]],[]],["Mouse",6,0x7639dcefad199,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[514,15092,0,64.0195,53.1053,0,0,1,0.504,0.989247,0,0,[]],21,1470,[],[[]],[0,"Default",0,1]],[[513,15103,0,82.0271,
93.3333,0,0,1,0.45,0.00909091,0,0,[]],20,1471,[[150]],[[0,0,1,0.25,0.5,0.2,1.5,0.01,0,1],[]],[0,"Default",0,1]],[[514,15101,0,8.82941,-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,1472,[],[],[0,"Default",0,1]],[[1542,14652,0,128,128,0,1.57081,1,0,0.5,0,0,[]],34,1473,[],[],[15,30,0,170,22,100,5,0,0,0,2,0,-350,0,2,800,0,0,0.7]],[[1442,14654,0,135,200,0,1.5708,1,0,0.5,0,0,[]],33,1474,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,0,0,0.3]],[[1492,15132,0,80,170,0,0,1,0.5,0.5,0,0,[]],117,1475,[],[[0,
0,0,0.25,0.5,0.2,0.1,0.01,0,1],[]],[0,"Default",0,1]],[[754,15122,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],118,1476,[],[],[0,"Default",0,1]],[[1490.96,15069.6,0,59.8836,50.1381,0,0,1,0.5,0.5,0,0,[]],119,1477,[],[[]],[1,"Default",0,1]],[[-95,15208,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],120,1478,[],[],[0,"Default",0,1]]],[]],["Decortop",7,6981318952982967,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[960,15085,0,110,50,0,0,1,0.454545,0.36,0,0,[]],86,1479,[],[],[0,"Default",0,1]],[[518,15213,0,124,44,0,0,1,
0.491935,0.454545,0,0,[]],83,1480,[],[],[0,"Default",0,1]]],[]],["Water",8,0x58ae9516aff2c,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-51,15238,0,1382,128,0,0,1,0,0,0,0,[]],27,1481,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[-48,15362,0,1379,435,0,0,1,0,0,0,0,[]],84,1482,[],[[]],[0,0]]],[]],["UI",9,6236625479833023,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[1364,15203,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1483,[["odin"]],[],[0,"Default",0,1]],[[1366,15166,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1484,[["dva"]],[],[0,"Default",0,
1]],[[1360,15094,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,1485,[["dva"]],[],[1,"Default",0,1]],[[1363,15131,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,1486,[["raz"]],[],[1,"Default",0,1]],[[1384,14990,0,100,100,0,0,1,0.5,0.5,0,0,[]],60,1487,[],[[20,0]],[0,"Default",0,1]],[[1416,14500,0,50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,1488,[[1]],[],[0,"Default",0,1]],[[172.861,52.2845,0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,1489,[],[[]],[0,"Default",0,1]],[[446.861,27.2845,0,-42,51,0,0,1,0.511628,0.509804,0,0,[]],54,1490,
[],[[0,0,0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,0,1,0.511628,0.509804,0,0,[]],54,1491,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[296.861,32.2845,0,273,57,0,0,1,0.501832,0.508772,0,0,[]],52,1492,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[215.861,31.2845,0,172.501,32,0,0,1,0,0.5,0,0,[]],32,1493,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[316.861,32.2845,0,216,43,0,0,1,0.5,0.511628,0,0,[]],53,1494,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-27,-81,0,107,15910,0,0,1,0,0,0,0,[]],112,1496,[],[[1,0,0,1,0.5,0.2,
0,0.01,0,1]],[1,0]],[[1190,-103,0,107,15910,0,0,1,0,0,0,0,[]],112,1497,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[67,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],115,1498,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[533,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],116,1499,[],[[1,0,0,0,1]],[0,"Default",0,1]],[[146,66,0,33.9411,33.9411,0,0,1,0.5,0.5,0,0,[]],55,1500,[],[],[0,"Default",0,1]],[[-7.76617,7.11015,0,146.959,88,0,0,1,0,0,0,0,[]],4,1501,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(255,255,51)",1,1,0,0,
0]],[[455.144,65.6482,0,32.027,32.027,0,0,1,0.513514,0.513514,0,0,[]],56,1502,[],[],[0,"Default",0,1]],[[460.145,6.16529,0,146.959,88,0,0,1,0,0,0,0,[]],6,1503,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(204,255,255)",1,1,0,0,0]],[[53,799,0,67.6461,67.6461,0,0,1,0.508197,0.508197,0,0,[]],114,1504,[],[[0,1,0,0,1]],[0,"Default",0,1]],[[95,767,0,488,88,0,0,1,0,0,0,0,[]],121,1505,[],[[0,1,0,0,1]],["Left:",0,"36pt Arial Rounded MT Bold","rgb(255,255,255)",0,1,0,0,0]],[[351,-238,0,26.9258,
26.9258,0,0,1,0,0,0,0,[]],82,1510,[["EnemyAlien"]],[],[1,0]],[[310,-240,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1514,[["EnemySmoke"]],[],[1,0]],[[-440,-460,0,64,64,0,0,1,0,0,0,0,[]],82,1516,[["Sp4"]],[],[1,0]],[[120,-110,0,64,64,0,0,1,0,0,0,0,[]],82,1520,[["EarthA"]],[],[1,0]],[[7,-113,0,64,64,0,0,1,0,0,0,0,[]],82,1521,[["Power"]],[],[1,0]],[[223,-111,0,64,64,0,0,1,0,0,0,0,[]],82,1522,[["Decor1C"]],[],[1,0]],[[225,-184,0,64,64,0,0,1,0,0,0,0,[]],82,1523,[["Decor2C"]],[],[1,0]],[[225,-260,0,64,64,0,
0,1,0,0,0,0,[]],82,1524,[["Decor3C"]],[],[1,0]],[[227,-334,0,64,64,0,0,1,0,0,0,0,[]],82,1525,[["Decor4C"]],[],[1,0]],[[421,-112,0,64,64,0,0,1,0,0,0,0,[]],82,1527,[["Money1"]],[],[1,0]],[[422,-196,0,64,64,0,0,1,0,0,0,0,[]],82,1528,[["Money2"]],[],[1,0]]],[]],["ball",10,0x6b14a60de53ae,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[559,834,0,50,50,0,0,1,0.5,0.5,0,0,[]],238,1603,[],[[1,1,0,0,1]],[1,"Default",0,1]]],[]]],[],[]],["Lewel20",1280,15360,!1,"Lewel20",9076458527963236,[["BG",0,7751969237925821,!0,[44,
159,205],!1,1,1,1,!1,1,0,0,[],[]],["BG(mountian)",1,0x42978fcb1b6ef,!0,[255,255,255],!0,0.05,0.06,1,!1,1,0,0,[[[0,0,0,976,1923,0,0,1,0,0,0,0,[]],131,507,[],[],[0,0]]],[]],["BG(sky)",2,531434578184617,!0,[255,255,255],!0,0.05,0.08,1,!1,1,0,0,[[[390,1255,0,127,127,0,0,1,0.503937,0.503937,0,0,[]],132,542,[],[],[0,"Default",0,1]],[[490,1853,0,113,113,0,0,1,0.504425,0.504425,0,0,[]],133,543,[],[],[0,"Default",0,1]],[[161,1515,0,115,114,0,0,1,0.504348,0.5,0,0,[]],134,595,[],[],[0,"Default",0,1]],[[162,
1089,0,99,91,0,0,1,0.50505,0.505495,0,0,[]],135,596,[],[],[0,"Default",0,1]]],[]],["Map",3,5222373936579432,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-270,15195,0,250,250,0,0,1,0.5,0.5,0,0,[]],81,1532,[],[],[0,"Default",0,1]]],[]],["Earth",4,809742419620768,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[515,15252,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1533,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[270,15034,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1534,[],[[1,0,0,1,0.5,0.2,0,0.01,
0,1],[1]],[0,"Default",0,1]],[[661,14841,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1535,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[274,14667,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1536,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[544,14413,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1537,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[960,15129,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1538,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,
"Default",0,1]],[[957,14843,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1539,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[961,14568,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1540,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[277,14996,0,120,68,0,0,1,0.475,0.397059,0,0,[]],87,1541,[],[],[0,"Default",0,1]],[[982,14753,0,170,150,0,0,1,0.441176,0.493333,0,0,[]],88,1542,[],[],[0,"Default",0,1]],[[597,248,0,3729,81,0,0,1,0.5,0.5,0,0,[]],111,1545,[],[],[1,"Default",0,
1]],[[681,15183,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1467,[],[],[0,"Default",0,1]],[[431,15007,0,50,50,0,0,1,0.5,0.5,0,0,[]],240,1495,[],[],[0,"Default",0,1]]],[]],["Power",5,9130854215345244,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[430,14792,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],56,1546,[],[],[0,"Default",0,1]]],[]],["Mouse",6,6381624430762369,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[514,15092,0,64.0195,53.1053,0,0,1,0.504,0.989247,0,0,[]],21,1547,[],[[]],[0,"Default",0,1]],[[513,15103,0,82.0271,93.3333,
0,0,1,0.45,0.00909091,0,0,[]],20,1548,[[150]],[[0,0,1,0.25,0.5,0.2,1.5,0.01,0,1],[]],[0,"Default",0,1]],[[514,15101,0,8.82941,-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,1549,[],[],[0,"Default",0,1]],[[1542,14652,0,128,128,0,1.57081,1,0,0.5,0,0,[]],34,1550,[],[],[15,30,0,170,22,100,5,0,0,0,2,0,-350,0,2,800,0,0,0.7]],[[1442,14654,0,135,200,0,1.5708,1,0,0.5,0,0,[]],33,1551,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,0,0,0.3]],[[1492,15132,0,80,170,0,0,1,0.5,0.5,0,0,[]],117,1552,[],[[0,0,0,0.25,
0.5,0.2,0.1,0.01,0,1],[]],[0,"Default",0,1]],[[777,14329,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],118,1553,[],[],[0,"Default",0,1]],[[1490.96,15069.6,0,59.8836,50.1381,0,0,1,0.5,0.5,0,0,[]],119,1554,[],[[]],[1,"Default",0,1]],[[-85,15217,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],120,1555,[],[],[0,"Default",0,1]]],[]],["Decortop",7,7609012664585864,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[960,15085,0,110,50,0,0,1,0.454545,0.36,0,0,[]],86,1556,[],[],[0,"Default",0,1]],[[518,15213,0,124,44,0,0,1,0.491935,
0.454545,0,0,[]],83,1557,[],[],[0,"Default",0,1]]],[]],["Water",8,7614428220655153,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-51,15238,0,1382,128,0,0,1,0,0,0,0,[]],27,1558,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[-48,15362,0,1379,435,0,0,1,0,0,0,0,[]],84,1559,[],[[]],[0,0]]],[]],["UI",9,7635312540033995,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[1364,15203,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1560,[["odin"]],[],[0,"Default",0,1]],[[1366,15166,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1561,[["dva"]],[],[0,"Default",0,1]],[[1360,
15094,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,1562,[["dva"]],[],[1,"Default",0,1]],[[1363,15131,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,1563,[["raz"]],[],[1,"Default",0,1]],[[1384,14990,0,100,100,0,0,1,0.5,0.5,0,0,[]],60,1564,[],[[20,0]],[0,"Default",0,1]],[[1416,14500,0,50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,1565,[[1]],[],[0,"Default",0,1]],[[172.861,52.2845,0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,1566,[],[[]],[0,"Default",0,1]],[[446.861,27.2845,0,-42,51,0,0,1,0.511628,0.509804,0,0,[]],54,1567,[],[[0,0,
0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,0,1,0.511628,0.509804,0,0,[]],54,1568,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[296.861,32.2845,0,273,57,0,0,1,0.501832,0.508772,0,0,[]],52,1569,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[215.861,31.2845,0,172.501,32,0,0,1,0,0.5,0,0,[]],32,1570,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[316.861,32.2845,0,216,43,0,0,1,0.5,0.511628,0,0,[]],53,1571,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-27,-81,0,107,15910,0,0,1,0,0,0,0,[]],112,1573,[],[[1,0,0,1,0.5,0.2,0,0.01,
0,1]],[1,0]],[[1190,-103,0,107,15910,0,0,1,0,0,0,0,[]],112,1574,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,0]],[[67,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],115,1575,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[533,46,0,112,72,0,0,1,0.5,0.5,0,0,[]],116,1576,[],[[1,0,0,0,1]],[0,"Default",0,1]],[[146,66,0,33.9411,33.9411,0,0,1,0.5,0.5,0,0,[]],55,1577,[],[],[0,"Default",0,1]],[[-7.76617,7.11015,0,146.959,88,0,0,1,0,0,0,0,[]],4,1578,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(255,255,51)",1,1,0,0,0]],[[455.144,
65.6482,0,32.027,32.027,0,0,1,0.513514,0.513514,0,0,[]],56,1579,[],[],[0,"Default",0,1]],[[460.145,6.16529,0,146.959,88,0,0,1,0,0,0,0,[]],6,1580,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(204,255,255)",1,1,0,0,0]],[[53,799,0,67.6461,67.6461,0,0,1,0.508197,0.508197,0,0,[]],114,1581,[],[[0,1,0,0,1]],[0,"Default",0,1]],[[95,767,0,488,88,0,0,1,0,0,0,0,[]],121,1582,[],[[0,1,0,0,1]],["Left:",0,"36pt Arial Rounded MT Bold","rgb(255,255,255)",0,1,0,0,0]],[[350,-158,0,26.9258,26.9258,0,0,
1,0,0,0,0,[]],82,1585,[["EnemyRobot"]],[],[1,0]],[[350,-196,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1586,[["EnemyHypno"]],[],[1,0]],[[351,-238,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1587,[["EnemyAlien"]],[],[1,0]],[[-440,-460,0,64,64,0,0,1,0,0,0,0,[]],82,1593,[["Sp4"]],[],[1,0]],[[-440,-374,0,64,64,0,0,1,0,0,0,0,[]],82,1594,[["Sp3"]],[],[1,0]],[[-440,-281,0,64,64,0,0,1,0,0,0,0,[]],82,1595,[["Sp2"]],[],[1,0]],[[-440,-191,0,64,64,0,0,1,0,0,0,0,[]],82,1596,[["Sp1"]],[],[1,0]],[[120,-110,0,64,64,0,0,1,
0,0,0,0,[]],82,1597,[["EarthA"]],[],[1,0]],[[7,-113,0,64,64,0,0,1,0,0,0,0,[]],82,1598,[["Power"]],[],[1,0]],[[223,-111,0,64,64,0,0,1,0,0,0,0,[]],82,1599,[["Decor1C"]],[],[1,0]],[[225,-184,0,64,64,0,0,1,0,0,0,0,[]],82,1600,[["Decor2C"]],[],[1,0]],[[225,-260,0,64,64,0,0,1,0,0,0,0,[]],82,1601,[["Decor3C"]],[],[1,0]],[[227,-334,0,64,64,0,0,1,0,0,0,0,[]],82,1602,[["Decor4C"]],[],[1,0]],[[421,-112,0,64,64,0,0,1,0,0,0,0,[]],82,1604,[["Money1"]],[],[1,0]],[[422,-196,0,64,64,0,0,1,0,0,0,0,[]],82,1605,[["Money2"]],
[],[1,0]]],[]],["ball",10,693697466448688,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[559,834,0,50,50,0,0,1,0.5,0.5,0,0,[]],238,1606,[],[[1,1,1,1,1]],[1,"Default",0,1]]],[]]],[],[]],["ZZZZ",1280,15360,!1,"Chooselevel",0xb5739310b8f5b,[["BG",0,5935686632465194,!0,[44,159,205],!1,1,1,1,!1,1,0,0,[[[-80,14870,0,67,35,0,0,1,0.492537,0.342857,0,0,[]],122,488,[],[],[0,"Default",0,1]],[[-175,14872,0,72,51,0,0,1,0.486111,-0.352941,0,0,[]],123,489,[],[],[0,"Default",0,1]],[[-270,14860,0,74,74,0,0,1,0.472973,0.77027,
0,0,[]],124,490,[],[],[0,"Default",0,1]],[[-391,14784,0,50,115,0,0,1,-0.1,0.791304,0,0,[]],125,491,[],[],[0,"Default",0,1]],[[-386,15044,0,50,115,0,0,1,-0.14,0.704348,0,0,[]],126,493,[],[],[0,"Default",0,1]],[[-270,15106,0,52,57,0,0,1,0.519231,0.614035,0,0,[]],127,494,[],[],[0,"Default",0,1]],[[-175,15049,0,55,41,0,0,1,0.509091,-0.902439,0,0,[]],128,495,[],[],[0,"Default",0,1]],[[-107,15025,0,48,30,0,0,1,0.5,0,0,0,[]],129,496,[],[],[0,"Default",0,1]],[[1448,13887,0,37,37,0,0,1,0.513514,0.513514,0,
0,[]],136,219,[],[],[0,"Default",0,1]],[[1365,14210,0,50,50,0,0,1,0.52,0.52,0,0,[]],144,447,[],[[0,0,0,2,0.5,0.2,0.2,0.06,0,1]],[0,"Default",0,1]],[[1334,14449,0,150,44,0,0,1,0.186667,0.5,0,0,[]],145,448,[],[],[0,"Default",0,1]],[[-51,13899,0,90,100,0,0,1,0.5,0.53,0,0,[]],44,555,[],[],[0,"Default",0,1]],[[1520,14175,0,68,62,0,0,1,0.5,0.5,0,0,[]],181,849,[],[],[0,"Default",0,1]]],[]],["BG(sky)",1,5554991409113769,!0,[255,255,255],!0,0.05,0.08,1,!1,1,0,0,[[[-1198,1228,0,3670,254,0,0,1,0,0,0,0,[]],29,
1245,[],[[1,0,3,70,0,0,0,1024,0]],[0,0]]],[]],["BG(mountian)",2,0xea8956e74b966,!0,[255,255,255],!0,0.05,0.06,1,!1,1,0,0,[[[-20,1369,0,1371,258,0,0,1,0,0,0,0,[]],25,1246,[],[],[0,0]],[[-20,1621,0,1367,476,0,0,1,0,0,0,0,[]],90,1247,[],[],[0,0]]],[]],["Map",3,0xa72fe870bd1e0,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-237,15394,0,250,250,0,0,1,0.5,0.5,0,0,[]],81,1248,[],[],[0,"Default",0,1]]],[]],["Earth",4,5909018385781503,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[515,15252,0,127.739,46.8378,0,0,1,0.5,0.515152,
0,0,[]],23,1249,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[270,15034,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1250,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[661,14841,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1251,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[274,14667,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1252,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[544,14413,0,127.739,46.8378,0,0,1,0.5,0.515152,0,0,[]],23,1253,
[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[960,15129,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1254,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[957,14843,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1255,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[961,14568,0,127.741,46.8384,0,0,1,0.5,0.515152,0,0,[]],85,1256,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[277,14996,0,120,68,0,0,1,0.475,0.397059,0,0,[]],87,1257,[],[],[0,"Default",0,
1]],[[982,14753,0,170,150,0,0,1,0.441176,0.493333,0,0,[]],88,1258,[],[],[0,"Default",0,1]],[[817,14262,0,171,203,0,0,1,0.5,0.5,0,0,[]],111,1259,[],[],[0,"Default",0,1]],[[353,-64,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1260,[["EnemySlizen"]],[],[1,0]],[[353,-104,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1261,[["EnemyDragon"]],[],[1,0]],[[353,-149,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1262,[["EnemyRobot"]],[],[1,0]],[[353,-187,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1263,[["EnemyHypno"]],[],[1,0]],[[354,
-229,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1264,[["EnemyAlien"]],[],[1,0]]],[]],["Power",5,9948867483263394,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[430,14792,0,37,37,0,0,1,0.513514,0.513514,0,0,[]],56,1265,[],[],[0,"Default",0,1]]],[]],["Mouse",6,5651132112733458,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[514,15092,0,64.0195,53.1053,0,0,1,0.504,0.989247,0,0,[]],21,1266,[],[[]],[0,"Default",0,1]],[[513,15103,0,82.0271,93.3333,0,0,1,0.45,0.00909091,0,0,[]],20,1267,[[150]],[[0,0,1,0.25,0.5,0.2,0.1,0.01,0,
1],[]],[0,"Default",0,1]],[[514,15101,0,8.82941,-1.73537,0,-1.57673,1,0,0.488281,0,0,[]],22,1268,[],[],[0,"Default",0,1]],[[1542,14652,0,128,128,0,1.57081,1,0,0.5,0,0,[]],34,1269,[],[],[15,30,0,170,22,100,5,0,0,0,2,0,-350,0,2,800,0,0,0.7]],[[1442,14654,0,135,200,0,1.5708,1,0,0.5,0,0,[]],33,1270,[],[],[15,20,0,70,10,100,50,0,0,0,10,0,70,0,0,800,0,0,0.3]]],[]],["Decortop",7,6896249014296848,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[960,15085,0,110,50,0,0,1,0.454545,0.36,0,0,[]],86,1271,[],[],[0,"Default",
0,1]],[[518,15213,0,124,44,0,0,1,0.491935,0.454545,0,0,[]],83,1272,[],[],[0,"Default",0,1]]],[]],["Water",8,5903076745932666,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-51,15238,0,1382,128,0,0,1,0,0,0,0,[]],27,1273,[],[[1,0,0,4,0,0,0,50,0]],[0,0]],[[-48,15362,0,1379,435,0,0,1,0,0,0,0,[]],84,1274,[],[[]],[0,0]]],[]],["UI",9,6096429531273691,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[1364,15203,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,1275,[["odin"]],[],[0,"Default",0,1]],[[1366,15166,0,20,20,0,0,1,0.5,0.5,0,0,[]],57,
1276,[["dva"]],[],[0,"Default",0,1]],[[1360,15094,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,1277,[["dva"]],[],[1,"Default",0,1]],[[1363,15131,0,16,16,0,0,1,0.5,0.5,0,0,[]],89,1278,[["raz"]],[],[1,"Default",0,1]],[[1384,14990,0,100,100,0,0,1,0.5,0.5,0,0,[]],60,1279,[],[[20,0]],[0,"Default",0,1]],[[1397,14905,0,50,50,0,-0.0113687,1,0.5,0.5,0,0,[]],37,1280,[[1]],[],[0,"Default",0,1]],[[314,-106,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1281,[["EnemyKaktus"]],[],[1,0]],[[314,-148,0,26.9258,26.9258,0,0,1,0,0,0,0,
[]],82,1282,[["EnemyBoo"]],[],[1,0]],[[312,-188,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1283,[["EnemyHaha"]],[],[1,0]],[[313,-231,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1284,[["EnemySmoke"]],[],[1,0]],[[314,-269,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1285,[["EnemyGhost"]],[],[1,0]],[[-437.139,-450.715,0,64,64,0,0,1,0,0,0,0,[]],82,1286,[["Sp4"]],[],[1,0]],[[-437.139,-364.715,0,64,64,0,0,1,0,0,0,0,[]],82,1287,[["Sp3"]],[],[1,0]],[[-437.139,-271.715,0,64,64,0,0,1,0,0,0,0,[]],82,1288,[["Sp2"]],[],[1,0]],
[[-437.139,-181.715,0,64,64,0,0,1,0,0,0,0,[]],82,1289,[["Sp1"]],[],[1,0]],[[172.861,52.2845,0,70,69,0,0,1,-0.015625,0.480469,0,0,[]],41,1290,[],[[]],[0,"Default",0,1]],[[446.861,27.2845,0,-42,51,0,0,1,0.511628,0.509804,0,0,[]],54,1291,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[151.861,27.2845,0,43,51,0,0,1,0.511628,0.509804,0,0,[]],54,1292,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[296.861,32.2845,0,273,57,0,0,1,0.501832,0.508772,0,0,[]],52,1293,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[215.861,31.2845,0,172.501,
32,0,0,1,0,0.5,0,0,[]],32,1294,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[316.861,32.2845,0,216,43,0,0,1,0.5,0.511628,0,0,[]],53,1295,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[183.861,87.2845,0,35.9861,35.9861,0,0,1,0.5,0.5,0,0,[]],55,1296,[],[],[0,"Default",0,1]],[[485.861,17.2845,0,72,24,0,0,1,0,0,0,0,[]],58,1297,[],[],[0,"SAVE","",1,1,1,"",0]],[[42.8608,17.2845,0,72,24,0,0,1,0,0,0,0,[]],59,1298,[],[],[0,"CLEAR","",1,1,1,"",0]],[[122.861,-100.715,0,64,64,0,0,1,0,0,0,0,[]],82,1299,[["EarthA"]],[],[1,0]],
[[9.86078,-103.715,0,64,64,0,0,1,0,0,0,0,[]],82,1300,[["Power"]],[],[1,0]],[[225.861,-101.715,0,64,64,0,0,1,0,0,0,0,[]],82,1301,[["Decor1"]],[],[1,0]],[[227.861,-174.715,0,64,64,0,0,1,0,0,0,0,[]],82,1302,[["Decor2"]],[],[1,0]],[[227.861,-250.715,0,64,64,0,0,1,0,0,0,0,[]],82,1303,[["Decor3"]],[],[1,0]],[[229.861,-324.715,0,64,64,0,0,1,0,0,0,0,[]],82,1304,[["Decor4"]],[],[1,0]],[[314,-64,0,26.9258,26.9258,0,0,1,0,0,0,0,[]],82,1305,[["EnemyRoach"]],[],[1,0]],[[423.861,-102.715,0,64,64,0,0,1,0,0,0,0,
[]],82,1306,[["Money1"]],[],[1,0]],[[424.861,-186.715,0,64,64,0,0,1,0,0,0,0,[]],82,1307,[["Money2"]],[],[1,0]],[[339,122,0,217,44,0,0,1,0,0,0,0,[]],2,1308,[],[],["Text",0,"18pt Arial","rgb(0,0,0)",0,0,0,0,0]],[[-173,24,0,1091,1476,0,0,1,0,0,0,0,[]],182,752,[],[[0,0,0,0,1]],[0,0]],[[300,425,0,61,61,0,0,1,0.508197,0.508197,0,0,[]],183,755,[],[[800,0]],[0,"Default",0,1]],[[1508,15223,0,155,132,0,0,1,0.503226,0.5,0,0,[]],198,1236,[],[],[0,"Default",0,1]],[[308,329,0,414,504,0,0,1,0.5,0.5,0,0,[]],252,
1513,[],[],[0,"Default",0,1]],[[209,609,0,183,71,0,0,1,0.502732,0.507042,0,0,[]],253,1515,[],[],[0,"Default",0,1]],[[404,607,0,183,72,0,0,1,0.502732,0.5,0,0,[]],254,1517,[],[],[0,"Default",0,1]],[[234,300,0,146.959,88,0,0,1,0,0,0,0,[]],4,1518,[],[[0,0,0,0,1]],["0000",0,"32pt Arial Rounded MT Bold","rgb(255,255,51)",1,1,0,0,0]],[[1808,14908,0,50,50,0,0,1,0.5,0.5,0,0,[]],241,773,[],[[1,1,0,0,1]],[0,"Default",0,1]],[[1808,14827,0,50,50,0,0,1,0.5,0.5,0,0,[]],243,1046,[],[[1,1,0,0,1]],[0,"Default",0,1]],
[[1810,14745,0,50,50,0,0,1,0.5,0.5,0,0,[]],244,1123,[],[[1,1,0,0,1]],[0,"Default",0,1]],[[1810,14669,0,50,50,0,0,1,0.5,0.5,0,0,[]],245,1200,[],[[1,1,0,0,1]],[0,"Default",0,1]],[[1808,14594,0,50,50,0,0,1,0.5,0.5,0,0,[]],246,1341,[],[[1,1,0,0,1]],[0,"Default",0,1]],[[1808,14513,0,50,50,0,0,1,0.5,0.5,0,0,[]],247,1358,[],[[1,1,0,0,1]],[0,"Default",0,1]],[[1808,14447,0,50,50,0,0,1,0.5,0.5,0,0,[]],248,1359,[],[[1,1,0,0,1]],[0,"Default",0,1]],[[1808,14372,0,50,50,0,0,1,0.5,0.5,0,0,[]],249,1360,[],[[1,1,
0,0,1]],[0,"Default",0,1]],[[1808,14312,0,50,50,0,0,1,0.5,0.5,0,0,[]],250,1361,[],[[1,1,0,0,1]],[0,"Default",0,1]],[[1806,14242,0,50,50,0,0,1,0.5,0.5,0,0,[]],251,1363,[],[[1,1,0,0,1]],[0,"Default",0,1]]],[]]],[],[]],["UpG1",1280,1024,!1,"UpG1",0x7a8d1f2f516d3,[["Layer 0",0,8321772701403759,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[300.5,599,0,605,1200,0,0,1,0.5,0.5,0,0,[]],146,597,[],[],[0,"Default",0,1]]],[]],["Layer 1",1,5403363916005528,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[98,252,0,134,138,0,0,1,
0.5,0.5,0,0,[]],151,615,[],[],[0,"Default",0,1]],[[399,254,0,134,138,0,0,1,0.5,0.5,0,0,[]],151,618,[],[],[0,"Default",0,1]],[[103,442,0,134,138,0,0,1,0.5,0.5,0,0,[]],151,619,[],[],[0,"Default",0,1]],[[407,444,0,134,138,0,0,1,0.5,0.5,0,0,[]],151,620,[],[],[0,"Default",0,1]],[[96,251,0,129,146,0,0,1,0.503876,0.5,0,0,[]],152,632,[],[],[0,"Default",1,1]],[[390,256,0,125,144,0,0,1,0.504,0.5,0,0,[]],153,633,[],[],[0,"Default",1,1]],[[92,447,0,113,134,0,0,1,0.504425,0.5,0,0,[]],154,672,[],[],[0,"Default",
1,1]],[[388,444,0,102,123,0,0,1,0.5,0.504065,0,0,[]],155,674,[],[],[0,"Default",1,1]],[[159,675,0,284,142,0,0,1,0.5,0.5,0,0,[]],156,675,[],[],[0,"Default",0,1]],[[445,675,0,284,142,0,0,1,0.5,0.5,0,0,[]],157,676,[],[],[0,"Default",0,1]],[[207,292,0,143,60,0,0,1,0.503497,0.5,0,0,[]],158,677,[],[],[0,"Default",2,1]],[[503,292,0,143,60,0,0,1,0.503497,0.5,0,0,[]],160,679,[],[],[0,"Default",2,1]],[[208,480,0,143,60,0,0,1,0.503497,0.5,0,0,[]],161,680,[],[],[0,"Default",2,1]],[[504,474,0,143,60,0,0,1,0.503497,
0.5,0,0,[]],162,681,[],[],[0,"Default",2,1]],[[56,72,0,50,50,0,0,1,0.5,0.5,0,0,[]],184,838,[],[],[0,"Default",0,1]]],[]],["Layer 2",2,4580767788604185,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[203.818,229.384,0,83,60,0,0,1,0.506024,0.5,0,0,[]],216,53,[],[],[0,"Default",0,1]],[[505.125,225.251,0,125,60,0,0,1,0.504,0.5,0,0,[]],217,55,[],[],[0,"Default",0,1]],[[208.264,418.143,0,130,60,0,0,1,0.5,0.5,0,0,[]],218,65,[],[],[0,"Default",0,1]],[[504.298,411.531,0,128,60,0,0,1,0.5,0.5,0,0,[]],219,66,[],[],[0,
"Default",0,1]],[[92,27,0,514,193,0,0.0309058,1,0,0,0,0,[]],3,608,[],[],["Text",0,"74pt Arial Rounded MT Bold","rgb(0,153,204)",0,0,0,0,0]],[[88,27,0,512,182,0,-0.0131759,1,0,0,0,0,[]],3,661,[],[],["Text",0,"72pt Arial Rounded MT Bold","rgb(255,255,255)",0,0,0,0,0]]],[]]],[],[]],["UpG2",1280,1024,!1,"UpG2",0xcae88ec40e786,[["Layer 0",0,5838289869315331,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[300.5,599,0,603,1200,0,0,1,0.5,0.5,0,0,[]],146,598,[],[],[0,"Default",0,1]]],[]],["Layer 1",1,0xbd315489d6ac6,
!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[98,252,0,134,138,0,0,1,0.5,0.5,0,0,[]],151,683,[],[],[0,"Default",0,1]],[[399,254,0,134,138,0,0,1,0.5,0.5,0,0,[]],151,684,[],[],[0,"Default",0,1]],[[103,442,0,134,138,0,0,1,0.5,0.5,0,0,[]],151,692,[],[],[0,"Default",0,1]],[[407,444,0,134,138,0,0,1,0.5,0.5,0,0,[]],151,695,[],[],[0,"Default",0,1]],[[159,675,0,284,142,0,0,1,0.5,0.5,0,0,[]],156,749,[],[],[0,"Default",0,1]],[[445,675,0,284,142,0,0,1,0.5,0.5,0,0,[]],157,751,[],[],[0,"Default",0,1]],[[98,253,0,96,93,
0,0,1,0.5,0.505376,0,0,[]],163,696,[],[],[0,"Default",1,1]],[[398,256,0,125,93,0,0,1,0.504,0.505376,0,0,[]],164,697,[],[],[0,"Default",1,1]],[[106,441,0,130,112,0,0,1,0.5,0.5,0,0,[]],165,709,[],[],[0,"Default",1,1]],[[408,442,0,151,138,0,0,1,0.503311,0.5,0,0,[]],166,710,[],[],[0,"Default",1,1]],[[206,287,0,143,60,0,0,1,0.503497,0.5,0,0,[]],172,826,[],[],[0,"Default",2,1]],[[510,288,0,143,60,0,0,1,0.503497,0.5,0,0,[]],173,774,[],[],[0,"Default",2,1]],[[205,477,0,143,60,0,0,1,0.503497,0.5,0,0,[]],174,
827,[],[],[0,"Default",2,1]],[[506,480,0,143,60,0,0,1,0.503497,0.5,0,0,[]],175,829,[],[],[0,"Default",2,1]],[[58,74,0,50,50,0,0,1,0.5,0.5,0,0,[]],184,839,[],[],[0,"Default",0,1]]],[]],["Layer 2",2,0xfb0e4c9aac0b9,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[203,221,0,84,60,0,0,1,0.5,0.5,0,0,[]],220,71,[],[],[0,"Default",0,1]],[[511,222,0,83,60,0,0,1,0.506024,0.5,0,0,[]],221,152,[],[],[0,"Default",0,1]],[[203,409,0,84,60,0,0,1,0.5,0.5,0,0,[]],220,153,[],[],[0,"Default",0,1]],[[511,410,0,83,60,0,0,1,0.506024,
0.5,0,0,[]],221,154,[],[],[0,"Default",0,1]],[[93,29,0,514,193,0,0.0309058,1,0,0,0,0,[]],3,476,[],[],["Text",0,"74pt Arial Rounded MT Bold","rgb(0,153,204)",0,0,0,0,0]],[[89,29,0,512,182,0,-0.0131759,1,0,0,0,0,[]],3,584,[],[],["Text",0,"72pt Arial Rounded MT Bold","rgb(255,255,255)",0,0,0,0,0]]],[]]],[],[]],["UpG3",1280,1024,!1,"UpG3",0x43f5e0257718a,[["Layer 0",0,0x93e8610bc2c24,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[300,599,0,604,1200,0,0,1,0.5,0.5,0,0,[]],146,599,[],[],[0,"Default",0,1]],[[57,75,
0,50,50,0,0,1,0.5,0.5,0,0,[]],184,863,[],[],[0,"Default",0,1]]],[]],["Layer 1",1,7433041589006311,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[93,333,0,134,138,0,0,1,0.5,0.5,0,0,[]],151,758,[],[],[0,"Default",0,1]],[[394,335,0,134,138,0,0,1,0.5,0.5,0,0,[]],151,759,[],[],[0,"Default",0,1]],[[159,675,0,284,142,0,0,1,0.5,0.5,0,0,[]],156,786,[],[],[0,"Default",0,1]],[[445,675,0,284,142,0,0,1,0.5,0.5,0,0,[]],157,787,[],[],[0,"Default",0,1]],[[391,335,0,82,82,0,0,1,0.5,0.5,0,0,[]],168,753,[],[],[0,"Default",1,
1]],[[91,338,0,82,82,0,0,1,0.5,0.5,0,0,[]],169,754,[],[],[0,"Default",1,1]],[[207,373,0,143,60,0,0,1,0.503497,0.5,0,0,[]],176,832,[],[],[0,"Default",2,1]],[[504,371,0,143,60,0,0,1,0.503497,0.5,0,0,[]],177,830,[],[],[0,"Default",2,1]]],[]],["Layer 2",2,7213097732515477,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[208,310,0,125,60,0,0,1,0.504,0.5,0,0,[]],222,155,[],[],[0,"Default",0,1]],[[506,309,0,129,60,0,0,1,0.503876,0.5,0,0,[]],223,1081,[],[],[0,"Default",0,1]],[[92,29,0,514,193,0,0.0309058,1,0,0,0,0,
[]],3,402,[],[],["Text",0,"74pt Arial Rounded MT Bold","rgb(0,153,204)",0,0,0,0,0]],[[88,29,0,512,182,0,-0.0131759,1,0,0,0,0,[]],3,425,[],[],["Text",0,"72pt Arial Rounded MT Bold","rgb(255,255,255)",0,0,0,0,0]]],[]]],[],[]],["UpG4",1280,1024,!1,"UpG4",6482827850384248,[["Layer 0",0,9899417058280116,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[300.5,599,0,603,1200,0,0,1,0.5,0.5,0,0,[]],146,600,[],[],[0,"Default",0,1]]],[]],["Layer 1",1,4648010272634021,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[159,675,0,284,
142,0,0,1,0.5,0.5,0,0,[]],156,850,[],[],[0,"Default",0,1]],[[445,675,0,284,142,0,0,1,0.5,0.5,0,0,[]],157,851,[],[],[0,"Default",0,1]],[[61,75,0,50,50,0,0,1,0.5,0.5,0,0,[]],184,864,[],[],[0,"Default",0,1]],[[93,29,0,514,193,0,0.0309058,1,0,0,0,0,[]],3,248,[],[],["Text",0,"74pt Arial Rounded MT Bold","rgb(0,153,204)",0,0,0,0,0]],[[89,29,0,512,182,0,-0.0131759,1,0,0,0,0,[]],3,325,[],[],["Text",0,"72pt Arial Rounded MT Bold","rgb(255,255,255)",0,0,0,0,0]],[[298,376,0,304,142,0,0,1,0.5,0.5,0,0,[]],255,
1609,[],[],[0,"Default",0,1]]],[]]],[],[]],["GetMoney",1280,1024,!1,"GetMoney",8681801818135579,[["Layer 0",0,0xc50dbf6061e5,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[300.5,599,0,605,1200,0,0,1,0.5,0.5,0,0,[]],146,769,[],[],[0,"Default",0,1]]],[]],["Layer 1",1,0x8a45e59fe89b4,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[159,735,0,284,142,0,0,1,0.5,0.5,0,0,[]],156,772,[],[],[0,"Default",0,1]],[[48,74,0,50,50,0,0,1,0.5,0.5,0,0,[]],184,904,[],[],[0,"Default",0,1]]],[]],["Layer 2",2,0xc8985bd1a1d2f,!0,[255,255,
255],!0,1,1,1,!1,1,0,0,[[[502,-46,0,114.018,114.018,0,0,1,0.5,0.5,0,0,[]],185,907,[],[],[0,"Default",0,1]],[[-8,-101,0,146.959,88,0,0,1,0,0,0,0,[]],4,1136,[],[[0,0,0,0,1]],["Text",0,"32pt Arial Rounded MT Bold","rgb(255,255,51)",1,1,0,0,0]],[[136,200,0,121.692,90.6878,0,0,1,0.503185,0.504274,0,0,[]],224,905,[],[],[0,"Default",0,1]],[[139,325,0,125.692,90.6878,0,0,1,0.503106,0.504274,0,0,[]],225,908,[],[],[0,"Default",0,1]],[[136,460,0,123.692,90.6878,0,0,1,0.503145,0.504274,0,0,[]],226,910,[],[],
[0,"Default",0,1]],[[119,591,0,163.026,82.2938,0,0,1,0.50237,0.504348,0,0,[]],227,1140,[],[],[0,"Default",0,1]],[[265,203,0,103.88,103.88,0,0,1,0.5,0.5,0,0,[]],228,1157,[],[],[0,"Default",0,1]],[[263,335,0,103.88,103.88,0,0,1,0.5,0.5,0,0,[]],229,1171,[],[],[0,"Default",0,1]],[[263,461,0,103.88,103.88,0,0,1,0.5,0.5,0,0,[]],230,1211,[],[],[0,"Default",0,1]],[[262,588,0,103.88,103.88,0,0,1,0.5,0.5,0,0,[]],231,1217,[],[],[0,"Default",0,1]],[[1141,104,0,193,156,0,0,1,0.502591,0.5,0,0,[]],232,1234,[],[],
[0,"Default",0,1]],[[1142,228,0,193,156,0,0,1,0.502591,0.5,0,0,[]],233,1235,[],[],[0,"Default",0,1]],[[1143,363,0,193,156,0,0,1,0.502591,0.5,0,0,[]],234,1313,[],[],[0,"Default",0,1]],[[1142,490,0,193,156,0,0,1,0.502591,0.5,0,0,[]],235,1352,[],[],[0,"Default",0,1]],[[815,-107,0,304,142,0,0,1,0.5,0.5,0,0,[]],236,1354,[],[],[0,"Default",0,1]],[[1130,-112,0,304,142,0,0,1,0.5,0.5,0,0,[]],237,1355,[],[],[0,"Default",0,1]]],[]],["Layer 3",3,4858432852947967,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[86,29,0,
514,193,0,0.0309058,1,0,0,0,0,[]],3,140,[],[],["Text",0,"74pt Arial Rounded MT Bold","rgb(0,153,204)",0,0,0,0,0]],[[82,29,0,512,182,0,-0.0131759,1,0,0,0,0,[]],3,181,[],[],["Text",0,"72pt Arial Rounded MT Bold","rgb(255,255,255)",0,0,0,0,0]]],[]]],[],[]],["Click to play",1280,1024,!1,"Click to play",0x4f84b5f8db233,[["Layer 0",0,0x671be5126e7b5,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[301,598,0,604,1200,0,0,1,0.5,0.5,0,0,[]],137,218,[],[],[0,"Default",0,1]]],[]],["Layer 2",1,7910301457261477,!0,[255,
255,255],!0,1,1,1,!1,1,0,0,[[[477,426,0,1077,453,0,0,0.65,0.500464,0.501104,0,0,[]],138,263,[],[[1,0,0,40,0,0,0,50,0]],[0,"Default",0,1]]],[]],["Layer 3",2,4618503873303115,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[448,522,0,-1077,453,0,0,0.4,0.500464,0.501104,0,0,[]],139,265,[],[[1,0,0,20,0,0,0,50,0]],[0,"Default",0,1]]],[]],["Layer 4",3,641681748340501,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[441,582,0,220,229,0,0,1,0.5,0.502183,0,0,[]],140,296,[],[[1,1,0,8,0,0,0,9,0],[1,0,0,16,0,0,0,6,0]],[0,"Default",
0,1]],[[101,258,0,95,84,0,0,1,0.505263,0.5,0,0,[]],141,297,[],[[1,1,0,4,0,0,0,5,0],[1,0,0,6,0,0,0,12,0]],[0,"Default",0,1]],[[510,102,0,-95,84,0,0.367707,1,0.505263,0.5,0,0,[]],141,373,[],[[1,1,0,8,0,0,0,12,0],[1,0,0,8,0,0,0,7,0]],[0,"Default",0,1]],[[245,106,0,95,77,0,0,1,0.505263,0.506494,0,0,[]],142,374,[],[[1,0,0,12,0,0,0,6,0],[1,0,0,10,0,0,0,3,0]],[0,"Default",0,1]]],[]],["Layer 1",4,4594048605742802,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[284,392,0,388.038,166.136,0,0,1,0.5,0.503497,0,0,[]],80,
110,[],[[1,0,0,9,0,0,0,22,0],[1,1,0,18,0,0,0,22,0]],[0,"Default",0,1]]],[]]],[],[]],["Chooselevel",1280,1024,!1,"Chooselevel",0xf171ccacf7b9d,[["Layer 1",0,0xac1b1fd0f8313,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[300,598,0,604,1200,0,0,1,0.5,0.5,0,0,[]],146,556,[],[],[0,"Default",0,1]]],[]],["Layer 0",1,0x892970006ae39,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[87,26,0,514,193,0,0.0309058,1,0,0,0,0,[]],3,5,[],[],["Text",0,"74pt Arial Rounded MT Bold","rgb(0,153,204)",0,0,0,0,0]],[[68.4901,199.49,0,100.98,
100.98,0,0,1,0.5,0.5,0,0,[]],91,6,[],[],[0,"Default",0,1]],[[183.49,198.49,0,100.98,100.98,0,0,1,0.5,0.5,0,0,[]],92,7,[],[],[0,"Default",1,1]],[[298.49,198.49,0,100.98,100.98,0,0,1,0.5,0.5,0,0,[]],93,8,[],[],[0,"Default",1,1]],[[413.49,198.49,0,100.98,100.98,0,0,1,0.5,0.5,0,0,[]],94,39,[],[],[0,"Default",1,1]],[[528.49,198.49,0,100.98,100.98,0,0,1,0.5,0.5,0,0,[]],95,42,[],[],[0,"Default",1,1]],[[70.4901,310.49,0,100.98,100.98,0,0,1,0.5,0.5,0,0,[]],96,43,[],[],[0,"Default",1,1]],[[184.49,309.49,0,
100.98,100.98,0,0,1,0.5,0.5,0,0,[]],97,44,[],[],[0,"Default",1,1]],[[299.49,309.49,0,100.98,100.98,0,0,1,0.5,0.5,0,0,[]],98,45,[],[],[0,"Default",1,1]],[[414.49,309.49,0,100.98,100.98,0,0,1,0.5,0.5,0,0,[]],99,46,[],[],[0,"Default",1,1]],[[528.49,308.49,0,100.98,100.98,0,0,1,0.5,0.5,0,0,[]],100,47,[],[],[0,"Default",1,1]],[[69.4901,418.49,0,100.98,100.98,0,0,1,0.5,0.5,0,0,[]],101,48,[],[],[0,"Default",1,1]],[[184.49,418.49,0,100.98,100.98,0,0,1,0.5,0.5,0,0,[]],102,49,[],[],[0,"Default",1,1]],[[299.49,
419.49,0,100.98,100.98,0,0,1,0.5,0.5,0,0,[]],103,50,[],[],[0,"Default",1,1]],[[414.49,419.49,0,100.98,100.98,0,0,1,0.5,0.5,0,0,[]],104,51,[],[],[0,"Default",1,1]],[[529.49,419.49,0,100.98,100.98,0,0,1,0.5,0.5,0,0,[]],105,52,[],[],[0,"Default",1,1]],[[72.4901,527.49,0,100.98,100.98,0,0,1,0.5,0.5,0,0,[]],106,74,[],[],[0,"Default",1,1]],[[187.49,527.49,0,100.98,100.98,0,0,1,0.5,0.5,0,0,[]],107,95,[],[],[0,"Default",1,1]],[[302.49,527.49,0,100.98,100.98,0,0,1,0.5,0.5,0,0,[]],108,101,[],[],[0,"Default",
1,1]],[[416.49,526.49,0,100.98,100.98,0,0,1,0.5,0.5,0,0,[]],109,106,[],[],[0,"Default",1,1]],[[531.49,526.49,0,100.98,100.98,0,0,1,0.5,0.5,0,0,[]],110,107,[],[],[0,"Default",1,1]],[[91,675,0,142,142,0,0,1,0.5,0.5,0,0,[]],147,601,[],[],[0,"Default",0,1]],[[234,675,0,142,142,0,0,1,0.5,0.5,0,0,[]],148,604,[],[],[0,"Default",0,1]],[[375,675,0,142,142,0,0,1,0.5,0.5,0,0,[]],149,605,[],[],[0,"Default",0,1]],[[517,675,0,142,142,0,0,1,0.5,0.5,0,0,[]],150,607,[],[],[0,"Default",0,1]],[[83,26,0,512,182,0,-0.0131759,
1,0,0,0,0,[]],3,760,[],[],["Text",0,"72pt Arial Rounded MT Bold","rgb(255,255,255)",0,0,0,0,0]],[[53,76,0,50,50,0,0,1,0.5,0.5,0,0,[]],184,836,[],[],[0,"Default",0,1]]],[]],["Layer 2",2,6974392445016586,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[472.591,77.7046,0,222.818,111.409,0,0,1,0.5,0.5,0,0,[]],157,1353,[],[],[0,"Default",0,1]]],[]]],[],[]]],[["Level1",[[2,"Generalcode"],[0,[!0,"Webstorage"],!1,0xc1b6343d7f7c,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xc1b6343d7f7c,[[1,[2,
"Webstorage"]]]]],[],[[0,null,!1,344,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,345,[[11,"win"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,346,[[11,"currentlevel"],[7,[0,2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,5394295847334433,[[6,"Lewel2"]]]]],[0,null,!1,348,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,349,[[11,"win"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,350,[[11,"chooser"],
[8,3],[7,[23,"currentlevel"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,351,[[11,"chooser"],[7,[0,2]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,352,[[1,[2,"play"]],[7,[23,"chooser"]]]]]]]],[0,[!0,"Money"],!1,8899554437942895,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8899554437942895,[[1,[2,"Money"]]]]],[],[[0,null,!1,0x9d3748fe9b276,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x4d4da99e52628]],[[-1,cr.system_object.prototype.acts.SetVar,
null,9919372954845772,[[11,"Money"],[7,[0,0]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,7453318299949775,[[7,[2,""]]]]]],[0,null,!1,9067598984039456,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,7995120901386789,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb708feeafcb8d],[-1,cr.system_object.prototype.acts.AddVar,null,9633852739674422,[[11,"Money"],[7,[0,50]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,8044627755867312,[[7,[23,"Money"]]]],[3,
cr.plugins_.Text.prototype.acts.SetText,null,0x9f04eb531afb5,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,6376292970975232,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0xe4f20dd97499b,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xab004f876fe88],[-1,cr.system_object.prototype.acts.AddVar,null,9769968136610648,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x51cd00cfe3d2b,[[7,
[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,506601144933982,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,0xc336f0462227f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9078904733932652,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb9e97f6c3cdf3,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],
[-1,cr.system_object.prototype.acts.SetVar,null,773432614272547,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6204531942815,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8674524364853558,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,5565781599485464,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4715179444273662,[[4,
117]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,5690543372316481,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,423075614780558,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,5807773930054757,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,0xd70b8047c39ed,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]]]],[0,[!0,"MoneyDestroy"],!1,0x9dfe0974acb9f,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x9dfe0974acb9f,[[1,[2,"MoneyDestroy"]]]]],[],[[0,null,!1,403,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,404]],[[113,cr.plugins_.Arr.prototype.acts.JSONLoad,null,405,[[1,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"savedd"]]]]]]],[[0,null,!1,
406,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,407,[[4,37]]],[113,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,408,[[0,[21,37,!1,null,0]],[8,0],[7,[0,1]]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,409]]]]],[0,null,!1,410,[[59,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,411]],[[113,cr.plugins_.Arr.prototype.acts.Clear,null,412],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,413,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,
!0,null]]]]]],[0,null,!1,414,[[58,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,415]],[[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,416,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,417,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,418,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,419]]],[0,null,!1,420,[[37,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,421]],[[113,cr.plugins_.Arr.prototype.acts.SetX,
null,422,[[0,[21,37,!1,null,0]],[7,[0,1]]]]]]]],[0,null,!1,0xcbe2b5bf3f1a4,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,5772306095643808]],[[121,cr.plugins_.Text.prototype.acts.SetFontColor,null,9731668387012372,[[0,[19,cr.system_object.prototype.exps.rgb,[[0,0],[0,0],[0,0]]]]]]]],[0,null,!1,9749331953087364,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,716035408524501]],[[180,cr.plugins_.Text.prototype.acts.SetText,null,0x76a31125c84d,[[7,[23,"BTV"]]]]]],[0,
[!0,"on Off"],!1,7459017113887346,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7459017113887346,[[1,[2,"on Off"]]]]],[],[[0,null,!1,8131957233141259,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xe3825e0508db8]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,4543294856137606,[[1,[2,"Batman"]],[3,0]]]]]]],[0,[!0,"Powerdestroyspawn"],!1,546451396203841,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,546451396203841,[[1,[2,"Powerdestroyspawn"]]]]],
[],[[0,null,!1,4640060418562817,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8373852904063289,[[11,"Accleration"],[8,3],[7,[0,0]]]]],[],[[0,null,!1,6172233692847193,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6446644070157934,[[11,"Power2"],[8,3],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,5275637006309051,[[4,136],[5,[0,5]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,27,cr.plugins_.TiledBg.prototype.exps.Y,!1,null],
[0,10]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5499656325318384,[[11,"Power2"],[7,[0,1]]]]]]]],[0,null,!1,8558474863181181,[[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9186763779450396,[[4,136]]]],[[136,cr.plugins_.Sprite.prototype.acts.Destroy,null,5546102331850545],[-1,cr.system_object.prototype.acts.SetVar,null,0xe204cf61cdf25,[[11,"Accleration"],[7,[0,200]]]],[20,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0xc35da2cabc9cc,[[10,0],[7,[0,200]]]]]],[0,
null,!1,0xb1f815446fb65,[[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6699530590375594,[[4,56]]]],[[56,cr.plugins_.Sprite.prototype.acts.Destroy,null,6960700158738026],[-1,cr.system_object.prototype.acts.SetVar,null,9185264851920144,[[11,"Accleration"],[7,[0,200]]]],[20,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0xe764801e55aed,[[10,0],[7,[0,200]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,8112516351553661,[[4,56],[5,[0,5]],[0,[19,cr.system_object.prototype.exps.random,
[[0,200],[0,900]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[19,cr.system_object.prototype.exps.random,[[0,1E3],[0,1650]]]]]]]]],[0,null,!1,4976368052501348,[[56,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,7969720455485037,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[56,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,992708168763238]],[[56,cr.plugins_.Sprite.prototype.acts.Destroy,null,6243671651831575],[-1,cr.system_object.prototype.acts.CreateObject,
null,6055260893608252,[[4,56],[5,[0,5]],[0,[19,cr.system_object.prototype.exps.random,[[0,200],[0,900]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[19,cr.system_object.prototype.exps.random,[[0,1E3],[0,1650]]]]]]]]]]],[0,[!0,"Balldestroyspawn"],!1,542768191426303,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,542768191426303,[[1,[2,"Balldestroyspawn"]]]]],[],[[0,null,!1,8820559911990008,[[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xe08d5970d3e8f,
[[4,240]]]],[[240,cr.plugins_.Sprite.prototype.acts.Destroy,null,7239608020707663],[-1,cr.system_object.prototype.acts.CreateObject,null,8453688870470851,[[4,240],[5,[0,5]],[0,[19,cr.system_object.prototype.exps.random,[[0,200],[0,900]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[19,cr.system_object.prototype.exps.random,[[0,1E3],[0,1650]]]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,7443405374590559,[[11,"Ballss"],[7,[0,1]]]]]],[0,null,!1,4976368052501348,[[240,cr.plugins_.Sprite.prototype.cnds.CompareY,
null,0,!1,!1,!1,7969720455485037,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[240,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,992708168763238]],[[240,cr.plugins_.Sprite.prototype.acts.Destroy,null,6243671651831575],[-1,cr.system_object.prototype.acts.CreateObject,null,6055260893608252,[[4,240],[5,[0,5]],[0,[19,cr.system_object.prototype.exps.random,[[0,200],[0,900]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[19,cr.system_object.prototype.exps.random,
[[0,1E3],[0,1650]]]]]]]]]]],[0,null,!1,0x96064ba4e755d,[[19,cr.plugins_.CJSAds.prototype.cnds.IsShowingBanner,null,0,!1,!1,!1,952026604392354]],[[19,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,6461902716403545]]]]],["Lewel2",[[2,"Generalcode"],[2,"Levelslogic"],[0,[!0,"Webstorage"],!1,0x7f0a0e3d5ce12,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x7f0a0e3d5ce12,[[1,[2,"Webstorage"]]]]],[],[[0,null,!1,344,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,345,
[[11,"win"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,346,[[11,"currentlevel"],[7,[0,3]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,934980420930001,[[6,"Lewel3"]]]]],[0,null,!1,348,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,349,[[11,"win"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,350,[[11,"chooser"],[8,3],[7,[23,"currentlevel"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,351,[[11,"chooser"],
[7,[0,3]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,352,[[1,[2,"play"]],[7,[23,"chooser"]]]]]]]],[0,[!0,"Money"],!1,6481826849383943,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6481826849383943,[[1,[2,"Money"]]]]],[],[[0,null,!1,0x9d3748fe9b276,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x4d4da99e52628]],[[-1,cr.system_object.prototype.acts.SetVar,null,9919372954845772,[[11,"Money"],[7,[0,0]]]],[4,cr.plugins_.Text.prototype.acts.SetText,
null,7453318299949775,[[7,[2,""]]]]]],[0,null,!1,9067598984039456,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,7995120901386789,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb708feeafcb8d],[-1,cr.system_object.prototype.acts.AddVar,null,9633852739674422,[[11,"Money"],[7,[0,50]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,8044627755867312,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x9f04eb531afb5,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,
!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,6376292970975232,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0xe4f20dd97499b,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xab004f876fe88],[-1,cr.system_object.prototype.acts.AddVar,null,9769968136610648,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x51cd00cfe3d2b,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,506601144933982,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,
!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,0xc336f0462227f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9078904733932652,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb9e97f6c3cdf3,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,773432614272547,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,6204531942815,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8674524364853558,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,8239164600876954,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,21117746069371,[[4,117]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,5440117921695812,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,
!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x7b6b6089cc518,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,5751269522203218,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0x87c88e7f281a5,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]]]],[0,[!0,"MoneyDestroy"],!1,8268922070086406,[[-1,cr.system_object.prototype.cnds.IsGroupActive,
null,0,!1,!1,!1,8268922070086406,[[1,[2,"MoneyDestroy"]]]]],[],[[0,null,!1,403,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,404]],[[113,cr.plugins_.Arr.prototype.acts.JSONLoad,null,405,[[1,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"savedd"]]]]]]],[[0,null,!1,406,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,407,[[4,37]]],[113,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,408,[[0,[21,37,!1,null,0]],[8,0],[7,[0,1]]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,
null,409]]]]],[0,null,!1,410,[[59,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,411]],[[113,cr.plugins_.Arr.prototype.acts.Clear,null,412],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,413,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,414,[[58,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,415]],[[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,416,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,
!0,null]]]]]],[0,null,!1,417,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,418,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,419]]],[0,null,!1,420,[[37,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,421]],[[113,cr.plugins_.Arr.prototype.acts.SetX,null,422,[[0,[21,37,!1,null,0]],[7,[0,1]]]]]]]],[0,null,!1,8078190083291815,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x6e8076b4e319d]],[[121,cr.plugins_.Text.prototype.acts.SetFontColor,
null,0x66c499f9cec79,[[0,[19,cr.system_object.prototype.exps.rgb,[[0,0],[0,0],[0,0]]]]]]]],[0,null,!1,7447969130574942,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x57add33f671ae,[[0,[1,0.5]]]]],[[19,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,0x470a19f6ef893]]]]],["Lewel3",[[2,"Generalcode"],[2,"Levelslogic"],[0,[!0,"Webstorage"],!1,9833550503382002,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,9833550503382002,[[1,[2,"Webstorage"]]]]],[],[[0,null,!1,344,
[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,345,[[11,"win"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,346,[[11,"currentlevel"],[7,[0,4]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,8686030408468277,[[6,"Lewel4"]]]]],[0,null,!1,348,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,349,[[11,"win"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,350,[[11,"chooser"],[8,3],[7,[23,"currentlevel"]]]]],
[[-1,cr.system_object.prototype.acts.SetVar,null,351,[[11,"chooser"],[7,[0,4]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,352,[[1,[2,"play"]],[7,[23,"chooser"]]]]]]]],[0,[!0,"Money"],!1,0x9916eb1fb769e,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x9916eb1fb769e,[[1,[2,"Money"]]]]],[],[[0,null,!1,0x9d3748fe9b276,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x4d4da99e52628]],[[-1,cr.system_object.prototype.acts.SetVar,null,9919372954845772,
[[11,"Money"],[7,[0,0]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,7453318299949775,[[7,[2,""]]]]]],[0,null,!1,9067598984039456,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,7995120901386789,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb708feeafcb8d],[-1,cr.system_object.prototype.acts.AddVar,null,9633852739674422,[[11,"Money"],[7,[0,50]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,8044627755867312,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,
null,0x9f04eb531afb5,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,6376292970975232,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0xe4f20dd97499b,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xab004f876fe88],[-1,cr.system_object.prototype.acts.AddVar,null,9769968136610648,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x51cd00cfe3d2b,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,
null,506601144933982,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,0xc336f0462227f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9078904733932652,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb9e97f6c3cdf3,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,773432614272547,
[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6204531942815,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8674524364853558,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,0x55abad8dc8b74,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9487583606719184,[[4,117]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,5690875720265155,
[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,4736652047799485,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8025043600126326,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,7249454008549164,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,
!0,null]]]]]]]],[0,[!0,"MoneyDestroy"],!1,7547602594014934,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7547602594014934,[[1,[2,"MoneyDestroy"]]]]],[],[[0,null,!1,403,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,404]],[[113,cr.plugins_.Arr.prototype.acts.JSONLoad,null,405,[[1,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"savedd"]]]]]]],[[0,null,!1,406,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,407,[[4,37]]],[113,
cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,408,[[0,[21,37,!1,null,0]],[8,0],[7,[0,1]]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,409]]]]],[0,null,!1,410,[[59,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,411]],[[113,cr.plugins_.Arr.prototype.acts.Clear,null,412],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,413,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,414,[[58,cr.plugins_.Button.prototype.cnds.OnClicked,
null,1,!1,!1,!1,415]],[[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,416,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,417,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,418,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,419]]],[0,null,!1,420,[[37,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,421]],[[113,cr.plugins_.Arr.prototype.acts.SetX,null,422,[[0,[21,37,!1,null,0]],[7,[0,1]]]]]]]],
[0,null,!1,9207169489580006,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,5538395574356358]],[[121,cr.plugins_.Text.prototype.acts.SetFontColor,null,5922310584291875,[[0,[19,cr.system_object.prototype.exps.rgb,[[0,0],[0,0],[0,0]]]]]]]],[0,null,!1,9083595781979814,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x4948a35fa2d6c,[[0,[1,0.5]]]]],[[19,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,8589237353058611]]]]],["Lewel4",[[2,"Generalcode"],[2,"Levelslogic"],[0,
[!0,"Webstorage"],!1,0xc40cb6139dd22,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xc40cb6139dd22,[[1,[2,"Webstorage"]]]]],[],[[0,null,!1,344,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,345,[[11,"win"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,346,[[11,"currentlevel"],[7,[0,5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,8333206904221479,[[6,"Lewel5"]]]]],[0,null,!1,348,[[-1,cr.system_object.prototype.cnds.CompareVar,null,
0,!1,!1,!1,349,[[11,"win"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,350,[[11,"chooser"],[8,3],[7,[23,"currentlevel"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,351,[[11,"chooser"],[7,[0,5]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,352,[[1,[2,"play"]],[7,[23,"chooser"]]]]]]]],[0,[!0,"Money"],!1,8185640963429066,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8185640963429066,[[1,[2,"Money"]]]]],[],[[0,null,!1,0x9d3748fe9b276,
[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x4d4da99e52628]],[[-1,cr.system_object.prototype.acts.SetVar,null,9919372954845772,[[11,"Money"],[7,[0,0]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,7453318299949775,[[7,[2,""]]]]]],[0,null,!1,9067598984039456,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,7995120901386789,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb708feeafcb8d],[-1,cr.system_object.prototype.acts.AddVar,null,9633852739674422,
[[11,"Money"],[7,[0,50]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,8044627755867312,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x9f04eb531afb5,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,6376292970975232,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0xe4f20dd97499b,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xab004f876fe88],[-1,cr.system_object.prototype.acts.AddVar,null,
9769968136610648,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x51cd00cfe3d2b,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,506601144933982,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,0xc336f0462227f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9078904733932652,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb9e97f6c3cdf3,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],
[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,773432614272547,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6204531942815,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8674524364853558,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,0xa2481cb48fd90,[[111,
cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xd9c9823571636,[[4,117]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xffdea8df1e8ee,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9447690506446928,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0xb4570d4742cd1,
[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8117124857784691,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]]]],[0,[!0,"MoneyDestroy"],!1,0x85d10968a4ff7,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x85d10968a4ff7,[[1,[2,"MoneyDestroy"]]]]],[],[[0,null,!1,403,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,404]],[[113,cr.plugins_.Arr.prototype.acts.JSONLoad,null,405,[[1,[20,
15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"savedd"]]]]]]],[[0,null,!1,406,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,407,[[4,37]]],[113,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,408,[[0,[21,37,!1,null,0]],[8,0],[7,[0,1]]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,409]]]]],[0,null,!1,410,[[59,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,411]],[[113,cr.plugins_.Arr.prototype.acts.Clear,null,412],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,413,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,414,[[58,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,415]],[[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,416,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,417,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,418,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,419]]],[0,null,!1,420,[[37,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
null,1,!1,!1,!1,421]],[[113,cr.plugins_.Arr.prototype.acts.SetX,null,422,[[0,[21,37,!1,null,0]],[7,[0,1]]]]]]]],[0,null,!1,0xc8049de0fcea6,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x910da4317e7a3]],[[121,cr.plugins_.Text.prototype.acts.SetFontColor,null,6965206484535947,[[0,[19,cr.system_object.prototype.exps.rgb,[[0,0],[0,0],[0,0]]]]]]]],[0,null,!1,0xf15dced1057e9,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xb2caa0c803313,[[0,[1,0.5]]]]],[[19,cr.plugins_.CJSAds.prototype.acts.HideBanner,
null,0xf1f75c545c669]]]]],["Lewel5",[[2,"Generalcode"],[2,"Levelslogic"],[0,[!0,"Webstorage"],!1,0x5ee532fd78337,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x5ee532fd78337,[[1,[2,"Webstorage"]]]]],[],[[0,null,!1,344,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,345,[[11,"win"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,346,[[11,"currentlevel"],[7,[0,6]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,9428265649515062,[[6,"Lewel6"]]]]],
[0,null,!1,348,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,349,[[11,"win"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,350,[[11,"chooser"],[8,3],[7,[23,"currentlevel"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,351,[[11,"chooser"],[7,[0,6]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,352,[[1,[2,"play"]],[7,[23,"chooser"]]]]]]]],[0,[!0,"Money"],!1,0xa862f3210526e,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,
0,!1,!1,!1,0xa862f3210526e,[[1,[2,"Money"]]]]],[],[[0,null,!1,0x9d3748fe9b276,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x4d4da99e52628]],[[-1,cr.system_object.prototype.acts.SetVar,null,9919372954845772,[[11,"Money"],[7,[0,0]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,7453318299949775,[[7,[2,""]]]]]],[0,null,!1,9067598984039456,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,7995120901386789,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,
null,0xb708feeafcb8d],[-1,cr.system_object.prototype.acts.AddVar,null,9633852739674422,[[11,"Money"],[7,[0,50]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,8044627755867312,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x9f04eb531afb5,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,6376292970975232,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0xe4f20dd97499b,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,
null,0xab004f876fe88],[-1,cr.system_object.prototype.acts.AddVar,null,9769968136610648,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x51cd00cfe3d2b,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,506601144933982,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,0xc336f0462227f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9078904733932652,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetVar,
null,0xb9e97f6c3cdf3,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,773432614272547,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6204531942815,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8674524364853558,[[1,[2,"savedd"]],[7,[20,113,
cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,5991146372396927,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5224805844772184,[[4,117]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,9128996716346512,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9533262499044748,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],
[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,7569882770352635,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0x4d9f120347cc3,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]]]],[0,[!0,"MoneyDestroy"],!1,8696115866510531,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8696115866510531,[[1,[2,"MoneyDestroy"]]]]],[],[[0,null,!1,403,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,
!1,!1,404]],[[113,cr.plugins_.Arr.prototype.acts.JSONLoad,null,405,[[1,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"savedd"]]]]]]],[[0,null,!1,406,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,407,[[4,37]]],[113,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,408,[[0,[21,37,!1,null,0]],[8,0],[7,[0,1]]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,409]]]]],[0,null,!1,410,[[59,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,411]],[[113,
cr.plugins_.Arr.prototype.acts.Clear,null,412],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,413,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,414,[[58,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,415]],[[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,416,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,417,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,
!1,418,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,419]]],[0,null,!1,420,[[37,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,421]],[[113,cr.plugins_.Arr.prototype.acts.SetX,null,422,[[0,[21,37,!1,null,0]],[7,[0,1]]]]]]]],[0,null,!1,6406056372295233,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xa18bf67328e74]],[[121,cr.plugins_.Text.prototype.acts.SetFontColor,null,6462280643021306,[[0,[19,cr.system_object.prototype.exps.rgb,[[0,0],[0,0],[0,
0]]]]]]]],[0,null,!1,0x699c5b46768e6,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xe8a175eda3c14,[[0,[1,0.5]]]]],[[19,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,0xa60c0bee16e1]]]]],["Lewel6",[[2,"Generalcode"],[2,"Levelslogic"],[0,[!0,"Webstorage"],!1,0x6d8d85d25aba5,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x6d8d85d25aba5,[[1,[2,"Webstorage"]]]]],[],[[0,null,!1,344,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,345,[[11,"win"],[8,0],
[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,346,[[11,"currentlevel"],[7,[0,7]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x7e772a93ab6fb,[[6,"Lewel7"]]]]],[0,null,!1,348,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,349,[[11,"win"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,350,[[11,"chooser"],[8,3],[7,[23,"currentlevel"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,351,[[11,"chooser"],[7,[0,7]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,352,[[1,[2,"play"]],[7,[23,"chooser"]]]]]]]],[0,[!0,"Money"],!1,8707146486953445,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8707146486953445,[[1,[2,"Money"]]]]],[],[[0,null,!1,0x9d3748fe9b276,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x4d4da99e52628]],[[-1,cr.system_object.prototype.acts.SetVar,null,9919372954845772,[[11,"Money"],[7,[0,0]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,7453318299949775,[[7,[2,""]]]]]],[0,null,!1,9067598984039456,
[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,7995120901386789,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb708feeafcb8d],[-1,cr.system_object.prototype.acts.AddVar,null,9633852739674422,[[11,"Money"],[7,[0,50]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,8044627755867312,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x9f04eb531afb5,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,
!1,6376292970975232,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0xe4f20dd97499b,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xab004f876fe88],[-1,cr.system_object.prototype.acts.AddVar,null,9769968136610648,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x51cd00cfe3d2b,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,506601144933982,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],
[0,null,!1,0xc336f0462227f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9078904733932652,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb9e97f6c3cdf3,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,773432614272547,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,6204531942815,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8674524364853558,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,0x76450a9a67ca2,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xaa5ec512787f5,[[4,117]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xd3949624bd0ea,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,
!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,4847645264844507,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,9009498606143256,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,9041287732259212,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]]]],[0,[!0,"MoneyDestroy"],!1,5452877523282517,[[-1,cr.system_object.prototype.cnds.IsGroupActive,
null,0,!1,!1,!1,5452877523282517,[[1,[2,"MoneyDestroy"]]]]],[],[[0,null,!1,403,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,404]],[[113,cr.plugins_.Arr.prototype.acts.JSONLoad,null,405,[[1,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"savedd"]]]]]]],[[0,null,!1,406,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,407,[[4,37]]],[113,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,408,[[0,[21,37,!1,null,0]],[8,0],[7,[0,1]]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,
null,409]]]]],[0,null,!1,410,[[59,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,411]],[[113,cr.plugins_.Arr.prototype.acts.Clear,null,412],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,413,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,414,[[58,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,415]],[[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,416,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,
!0,null]]]]]],[0,null,!1,417,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,418,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,419]]],[0,null,!1,420,[[37,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,421]],[[113,cr.plugins_.Arr.prototype.acts.SetX,null,422,[[0,[21,37,!1,null,0]],[7,[0,1]]]]]]]],[0,null,!1,6450916976867674,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,88400895443086]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,0xdc3bf320d25fb,[[0,[0,1]]]],[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xc7580a816c795,[[0,[0,1]]]]]],[0,null,!1,6694063266799989,[[23,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,8176869700026642]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,7275799202992734,[[0,[0,1]]]]]],[0,null,!1,9954175948479660,[[85,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,92137449965309]],[[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,8806221762612986,
[[0,[0,1]]]]]],[0,null,!1,0xc6044ff5ca7e8,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,7386839801392712,[[0,[1,0.5]]]]],[[19,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,0xa3a8b95d10c43]]]]],["Lewel7",[[2,"Generalcode"],[2,"Levelslogic"],[0,[!0,"Webstorage"],!1,0xb25d068caf97a,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xb25d068caf97a,[[1,[2,"Webstorage"]]]]],[],[[0,null,!1,344,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,345,[[11,"win"],
[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,346,[[11,"currentlevel"],[7,[0,8]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,5116460439847095,[[6,"Lewel8"]]]]],[0,null,!1,348,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,349,[[11,"win"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,350,[[11,"chooser"],[8,3],[7,[23,"currentlevel"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,351,[[11,"chooser"],[7,[0,8]]]],
[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,352,[[1,[2,"play"]],[7,[23,"chooser"]]]]]]]],[0,[!0,"Money"],!1,0x889705a5e4151,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x889705a5e4151,[[1,[2,"Money"]]]]],[],[[0,null,!1,0x9d3748fe9b276,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x4d4da99e52628]],[[-1,cr.system_object.prototype.acts.SetVar,null,9919372954845772,[[11,"Money"],[7,[0,0]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,7453318299949775,
[[7,[2,""]]]]]],[0,null,!1,9067598984039456,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,7995120901386789,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb708feeafcb8d],[-1,cr.system_object.prototype.acts.AddVar,null,9633852739674422,[[11,"Money"],[7,[0,50]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,8044627755867312,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x9f04eb531afb5,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,
!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,6376292970975232,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0xe4f20dd97499b,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xab004f876fe88],[-1,cr.system_object.prototype.acts.AddVar,null,9769968136610648,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x51cd00cfe3d2b,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,506601144933982,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,
!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,0xc336f0462227f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9078904733932652,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb9e97f6c3cdf3,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,773432614272547,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,6204531942815,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8674524364853558,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,0x5a8756fbc790f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8285413549372065,[[4,117]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xa0b0b47e7f55,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,
!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xff004ec2614c6,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6644766124729981,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8904191855199134,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]]]],[0,[!0,"MoneyDestroy"],!1,0xf5e78cf79113,[[-1,cr.system_object.prototype.cnds.IsGroupActive,
null,0,!1,!1,!1,0xf5e78cf79113,[[1,[2,"MoneyDestroy"]]]]],[],[[0,null,!1,403,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,404]],[[113,cr.plugins_.Arr.prototype.acts.JSONLoad,null,405,[[1,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"savedd"]]]]]]],[[0,null,!1,406,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,407,[[4,37]]],[113,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,408,[[0,[21,37,!1,null,0]],[8,0],[7,[0,1]]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,
null,409]]]]],[0,null,!1,410,[[59,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,411]],[[113,cr.plugins_.Arr.prototype.acts.Clear,null,412],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,413,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,414,[[58,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,415]],[[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,416,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,
!0,null]]]]]],[0,null,!1,417,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,418,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,419]]],[0,null,!1,420,[[37,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,421]],[[113,cr.plugins_.Arr.prototype.acts.SetX,null,422,[[0,[21,37,!1,null,0]],[7,[0,1]]]]]],[0,null,!1,0xc09bb87950807,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,7069757578068033]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,6851361771156539,[[0,[0,1]]]],[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5130851677514466,[[0,[0,1]]]]]],[0,null,!1,0x856ee04323ccf,[[23,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,6534116246149704]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,4523626997821159,[[0,[0,1]]]]]],[0,null,!1,5651273689864583,[[85,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,872510681793088]],[[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,7316106145156255,
[[0,[0,1]]]]]]]],[0,null,!1,6213003696767889,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x87c89417b2ceb]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xd1607b749aca3,[[0,[0,1]]]],[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,9900191532976744,[[0,[0,1]]]]]],[0,null,!1,9064343152867948,[[23,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x4068aba48b844]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,9895062781963932,[[0,[0,1]]]]]],
[0,null,!1,9103089115786494,[[85,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,0xe02fadef59cc]],[[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x4b13032b48227,[[0,[0,1]]]]]],[0,null,!1,4576882702547419,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xa6f4453aa3090,[[0,[1,0.5]]]]],[[19,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,8365041791554206]]]]],["Lewel8",[[2,"Generalcode"],[2,"Levelslogic"],[0,[!0,"Webstorage"],!1,5318587520752782,[[-1,cr.system_object.prototype.cnds.IsGroupActive,
null,0,!1,!1,!1,5318587520752782,[[1,[2,"Webstorage"]]]]],[],[[0,null,!1,344,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,345,[[11,"win"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,346,[[11,"currentlevel"],[7,[0,9]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x3e16ca62dd1b2,[[6,"Lewel9"]]]]],[0,null,!1,348,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,349,[[11,"win"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,350,[[11,"chooser"],[8,3],[7,[23,"currentlevel"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,351,[[11,"chooser"],[7,[0,9]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,352,[[1,[2,"play"]],[7,[23,"chooser"]]]]]]]],[0,[!0,"Money"],!1,65669519046608,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,65669519046608,[[1,[2,"Money"]]]]],[],[[0,null,!1,0x9d3748fe9b276,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x4d4da99e52628]],
[[-1,cr.system_object.prototype.acts.SetVar,null,9919372954845772,[[11,"Money"],[7,[0,0]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,7453318299949775,[[7,[2,""]]]]]],[0,null,!1,9067598984039456,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,7995120901386789,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb708feeafcb8d],[-1,cr.system_object.prototype.acts.AddVar,null,9633852739674422,[[11,"Money"],[7,[0,50]]]],[4,cr.plugins_.Text.prototype.acts.SetText,
null,8044627755867312,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x9f04eb531afb5,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,6376292970975232,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0xe4f20dd97499b,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xab004f876fe88],[-1,cr.system_object.prototype.acts.AddVar,null,9769968136610648,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,
null,0x51cd00cfe3d2b,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,506601144933982,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,0xc336f0462227f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9078904733932652,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb9e97f6c3cdf3,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,
!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,773432614272547,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6204531942815,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8674524364853558,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,0xcaa921a1dfece,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,
!1,!0,9313336693143300,[[4,117]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,7073118630952138,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x3cc7c175a35d4,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0x602da4eb35ab0,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,4973860149915339,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]]]],[0,[!0,"MoneyDestroy"],!1,8153420516619682,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8153420516619682,[[1,[2,"MoneyDestroy"]]]]],[],[[0,null,!1,403,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,404]],[[113,cr.plugins_.Arr.prototype.acts.JSONLoad,null,405,[[1,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"savedd"]]]]]]],[[0,null,
!1,406,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,407,[[4,37]]],[113,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,408,[[0,[21,37,!1,null,0]],[8,0],[7,[0,1]]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,409]]]]],[0,null,!1,410,[[59,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,411]],[[113,cr.plugins_.Arr.prototype.acts.Clear,null,412],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,413,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,
!0,null]]]]]],[0,null,!1,414,[[58,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,415]],[[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,416,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,417,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,418,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,419]]],[0,null,!1,420,[[37,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,421]],[[113,cr.plugins_.Arr.prototype.acts.SetX,
null,422,[[0,[21,37,!1,null,0]],[7,[0,1]]]]]]]],[0,null,!1,917150220786348,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,883643424253421]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,689513524712795,[[0,[0,1]]]],[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,751294070490623,[[0,[0,1]]]]]],[0,null,!1,6852716495940203,[[23,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,7723111019706894]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,
0x966825962d0b0,[[0,[0,1]]]]]],[0,null,!1,5612512854887254,[[85,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,8433454805709644]],[[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,878955342197202,[[0,[0,1]]]]]],[0,null,!1,0x9031bb4828c9f,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,4692767661917761,[[0,[1,0.5]]]]],[[19,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,7933978331805609]]]]],["Lewel9",[[2,"Generalcode"],[2,"Levelslogic"],[0,[!0,"Webstorage"],!1,4851344541164336,
[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,4851344541164336,[[1,[2,"Webstorage"]]]]],[],[[0,null,!1,344,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,345,[[11,"win"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,346,[[11,"currentlevel"],[7,[0,10]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,6830327290083416,[[6,"Lewel10"]]]]],[0,null,!1,348,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,349,[[11,"win"],[8,0],
[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,350,[[11,"chooser"],[8,3],[7,[23,"currentlevel"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,351,[[11,"chooser"],[7,[0,10]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,352,[[1,[2,"play"]],[7,[23,"chooser"]]]]]]]],[0,[!0,"Money"],!1,0xe0a214aba94fe,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xe0a214aba94fe,[[1,[2,"Money"]]]]],[],[[0,null,!1,0x9d3748fe9b276,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,0x4d4da99e52628]],[[-1,cr.system_object.prototype.acts.SetVar,null,9919372954845772,[[11,"Money"],[7,[0,0]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,7453318299949775,[[7,[2,""]]]]]],[0,null,!1,9067598984039456,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,7995120901386789,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb708feeafcb8d],[-1,cr.system_object.prototype.acts.AddVar,null,9633852739674422,[[11,"Money"],[7,[0,50]]]],[4,cr.plugins_.Text.prototype.acts.SetText,
null,8044627755867312,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x9f04eb531afb5,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,6376292970975232,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0xe4f20dd97499b,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xab004f876fe88],[-1,cr.system_object.prototype.acts.AddVar,null,9769968136610648,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,
null,0x51cd00cfe3d2b,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,506601144933982,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,0xc336f0462227f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9078904733932652,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb9e97f6c3cdf3,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,
!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,773432614272547,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6204531942815,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8674524364853558,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,6646542169350536,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,
!1,!0,6223323366428934,[[4,117]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,9484237954575786,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,4553774923854137,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,5923167387583898,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,0x849b922339440,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]]]],[0,[!0,"MoneyDestroy"],!1,7742431001203352,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7742431001203352,[[1,[2,"MoneyDestroy"]]]]],[],[[0,null,!1,403,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,404]],[[113,cr.plugins_.Arr.prototype.acts.JSONLoad,null,405,[[1,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"savedd"]]]]]]],[[0,null,
!1,406,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,407,[[4,37]]],[113,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,408,[[0,[21,37,!1,null,0]],[8,0],[7,[0,1]]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,409]]]]],[0,null,!1,410,[[59,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,411]],[[113,cr.plugins_.Arr.prototype.acts.Clear,null,412],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,413,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,
!0,null]]]]]],[0,null,!1,414,[[58,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,415]],[[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,416,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,417,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,418,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,419]]],[0,null,!1,420,[[37,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,421]],[[113,cr.plugins_.Arr.prototype.acts.SetX,
null,422,[[0,[21,37,!1,null,0]],[7,[0,1]]]]]],[0,null,!1,0x474032f51911b,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,513905460303054]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xf61467ff7d3c7,[[0,[0,1]]]],[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,9067831337944398,[[0,[0,1]]]]]],[0,null,!1,9959163273083898,[[23,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,6667941484054468]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,
0x6cd1a4da3ea93,[[0,[0,1]]]]]],[0,null,!1,0xc6e4247c21ac2,[[85,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x9f5531a2865c5]],[[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5310553312759419,[[0,[0,1]]]]]]]],[0,null,!1,0x5dfeafe6b3fcf,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,9853016086386520]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,9543203004734434,[[0,[0,1]]]],[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,7701143869027866,
[[0,[0,1]]]]]],[0,null,!1,6016783456713618,[[23,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,9531193829620712]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x9dd1878ea7c68,[[0,[0,1]]]]]],[0,null,!1,0xaa0220238d3f9,[[85,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,8605704777603003]],[[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xd07f73733ab4f,[[0,[0,1]]]]]],[0,null,!1,0xffac64f33202c,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xb654f61d1f980,
[[0,[1,0.5]]]]],[[19,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,930079056004926]]]]],["Lewel10",[[2,"Generalcode"],[2,"Levelslogic"],[0,[!0,"Webstorage"],!1,6588679858048574,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6588679858048574,[[1,[2,"Webstorage"]]]]],[],[[0,null,!1,344,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,345,[[11,"win"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,346,[[11,"currentlevel"],[7,[0,11]]]]]],[0,null,
!1,348,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,349,[[11,"win"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,350,[[11,"chooser"],[8,3],[7,[23,"currentlevel"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,351,[[11,"chooser"],[7,[0,11]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,352,[[1,[2,"play"]],[7,[23,"chooser"]]]]]]]],[0,[!0,"Money"],!1,6061024662730941,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,
!1,!1,6061024662730941,[[1,[2,"Money"]]]]],[],[[0,null,!1,0x9d3748fe9b276,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x4d4da99e52628]],[[-1,cr.system_object.prototype.acts.SetVar,null,9919372954845772,[[11,"Money"],[7,[0,0]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,7453318299949775,[[7,[2,""]]]]]],[0,null,!1,9067598984039456,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,7995120901386789,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,
null,0xb708feeafcb8d],[-1,cr.system_object.prototype.acts.AddVar,null,9633852739674422,[[11,"Money"],[7,[0,50]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,8044627755867312,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x9f04eb531afb5,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,6376292970975232,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,0xe4f20dd97499b,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,
null,0xab004f876fe88],[-1,cr.system_object.prototype.acts.AddVar,null,9769968136610648,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x51cd00cfe3d2b,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,506601144933982,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,0xc336f0462227f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9078904733932652,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetVar,
null,0xb9e97f6c3cdf3,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,773432614272547,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6204531942815,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8674524364853558,[[1,[2,"savedd"]],[7,[20,113,
cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,0xbe1c8853233b3,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x9c8299eadd15d,[[4,117]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb5983cece00ff,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xb6418a3d2e5d2,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],
[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,739049560162042,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0xaca54f64c5f9e,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]]]],[0,[!0,"MoneyDestroy"],!1,9246722466976164,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,9246722466976164,[[1,[2,"MoneyDestroy"]]]]],[],[[0,null,!1,403,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,
!1,!1,404]],[[113,cr.plugins_.Arr.prototype.acts.JSONLoad,null,405,[[1,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"savedd"]]]]]]],[[0,null,!1,406,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,407,[[4,37]]],[113,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,408,[[0,[21,37,!1,null,0]],[8,0],[7,[0,1]]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,409]]]]],[0,null,!1,410,[[59,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,411]],[[113,
cr.plugins_.Arr.prototype.acts.Clear,null,412],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,413,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,414,[[58,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,415]],[[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,416,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,417,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,
!1,418,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,419]]],[0,null,!1,420,[[37,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,421]],[[113,cr.plugins_.Arr.prototype.acts.SetX,null,422,[[0,[21,37,!1,null,0]],[7,[0,1]]]]]]]],[0,null,!1,0x5ed6dda40f287,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,7030291522087843]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,8354521959026664,[[0,[0,1]]]],[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,4510023670582696,[[0,[0,1]]]]]],[0,null,!1,6638575096930064,[[23,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,5291117347778768]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,7344464481972617,[[0,[0,1]]]]]],[0,null,!1,5313203106351971,[[85,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x440ff2dddc989]],[[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x6db960ff8bc78,[[0,[0,1]]]]]],[0,null,!1,5823165231936492,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,0xe5a8b8f98e9e2,[[0,[1,0.5]]]]],[[19,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,0xda8580c56875f]]]]],["Lewel11",[[2,"Generalcode"],[2,"Levelslogic"],[0,[!0,"Webstorage"],!1,6275826590022039,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6275826590022039,[[1,[2,"Webstorage"]]]]],[],[[0,null,!1,344,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,345,[[11,"win"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,346,[[11,"currentlevel"],
[7,[0,12]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,0xffbe3874d703f,[[6,"Lewel12"]]]]],[0,null,!1,348,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,349,[[11,"win"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,350,[[11,"chooser"],[8,3],[7,[23,"currentlevel"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,351,[[11,"chooser"],[7,[0,12]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,352,[[1,[2,"play"]],[7,[23,"chooser"]]]]]]]],
[0,[!0,"Money"],!1,6272515035379349,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6272515035379349,[[1,[2,"Money"]]]]],[],[[0,null,!1,0x9d3748fe9b276,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x4d4da99e52628]],[[-1,cr.system_object.prototype.acts.SetVar,null,9919372954845772,[[11,"Money"],[7,[0,0]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,7453318299949775,[[7,[2,""]]]]]],[0,null,!1,9067598984039456,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,7995120901386789,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb708feeafcb8d],[-1,cr.system_object.prototype.acts.AddVar,null,9633852739674422,[[11,"Money"],[7,[0,50]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,8044627755867312,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x9f04eb531afb5,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,6376292970975232,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,0xe4f20dd97499b,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xab004f876fe88],[-1,cr.system_object.prototype.acts.AddVar,null,9769968136610648,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x51cd00cfe3d2b,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,506601144933982,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,0xc336f0462227f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,9078904733932652,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb9e97f6c3cdf3,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,773432614272547,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6204531942815,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,8674524364853558,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,9353244599866872,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xf50625a0a1be4,[[4,117]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,6858387657672539,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9129704645591564,
[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,9262656433723964,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,9971693576311226,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]]]],[0,[!0,"MoneyDestroy"],!1,8726705563638153,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8726705563638153,[[1,[2,"MoneyDestroy"]]]]],[],[[0,null,!1,403,[[-1,
cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,404]],[[113,cr.plugins_.Arr.prototype.acts.JSONLoad,null,405,[[1,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"savedd"]]]]]]],[[0,null,!1,406,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,407,[[4,37]]],[113,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,408,[[0,[21,37,!1,null,0]],[8,0],[7,[0,1]]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,409]]]]],[0,null,!1,410,[[59,cr.plugins_.Button.prototype.cnds.OnClicked,
null,1,!1,!1,!1,411]],[[113,cr.plugins_.Arr.prototype.acts.Clear,null,412],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,413,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,414,[[58,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,415]],[[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,416,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,417,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,418,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,419]]],[0,null,!1,420,[[37,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,421]],[[113,cr.plugins_.Arr.prototype.acts.SetX,null,422,[[0,[21,37,!1,null,0]],[7,[0,1]]]]]]]],[0,null,!1,4646020242660644,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,7346644799724931]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xd8ae1186e4fb5,[[0,[0,2]]]],[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,946191948229642,[[0,[0,2]]]]]],[0,null,!1,5520488210111587,[[23,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x9fa4cd4aefcbc]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5416118914130647,[[0,[0,2]]]]]],[0,null,!1,0xeaa6df553b9e3,[[85,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,5071403555576117]],[[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,6924691451178095,[[0,[0,2]]]]]],[0,null,!1,0xa626154402e54,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,5978171572226008,[[0,[1,0.5]]]]],[[19,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,5040303406067406]]]]],["Lewel12",[[2,"Generalcode"],[2,"Levelslogic"],[0,[!0,"Webstorage"],!1,0x81249a403fc6f,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x81249a403fc6f,[[1,[2,"Webstorage"]]]]],[],[[0,null,!1,344,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,345,[[11,"win"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,346,[[11,"currentlevel"],
[7,[0,13]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,0xc6f75a7e1696b,[[6,"Lewel13"]]]]],[0,null,!1,348,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,349,[[11,"win"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,350,[[11,"chooser"],[8,3],[7,[23,"currentlevel"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,351,[[11,"chooser"],[7,[0,13]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,352,[[1,[2,"play"]],[7,[23,"chooser"]]]]]]]],
[0,[!0,"Money"],!1,9295968454217576,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,9295968454217576,[[1,[2,"Money"]]]]],[],[[0,null,!1,0x9d3748fe9b276,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x4d4da99e52628]],[[-1,cr.system_object.prototype.acts.SetVar,null,9919372954845772,[[11,"Money"],[7,[0,0]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,7453318299949775,[[7,[2,""]]]]]],[0,null,!1,9067598984039456,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,7995120901386789,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb708feeafcb8d],[-1,cr.system_object.prototype.acts.AddVar,null,9633852739674422,[[11,"Money"],[7,[0,50]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,8044627755867312,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x9f04eb531afb5,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,6376292970975232,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,0xe4f20dd97499b,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xab004f876fe88],[-1,cr.system_object.prototype.acts.AddVar,null,9769968136610648,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x51cd00cfe3d2b,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,506601144933982,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,0xc336f0462227f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,9078904733932652,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb9e97f6c3cdf3,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,773432614272547,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6204531942815,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,8674524364853558,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,5430163152089958,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xf80382b0fcb94,[[4,117]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xaaea241e935df,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8719283337987914,
[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0x6d0dadfcb7fcd,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0x893863cca4b48,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]]]],[0,[!0,"MoneyDestroy"],!1,9583312402052294,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,9583312402052294,[[1,[2,"MoneyDestroy"]]]]],[],[[0,null,!1,403,[[-1,
cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,404]],[[113,cr.plugins_.Arr.prototype.acts.JSONLoad,null,405,[[1,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"savedd"]]]]]]],[[0,null,!1,406,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,407,[[4,37]]],[113,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,408,[[0,[21,37,!1,null,0]],[8,0],[7,[0,1]]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,409]]]]],[0,null,!1,410,[[59,cr.plugins_.Button.prototype.cnds.OnClicked,
null,1,!1,!1,!1,411]],[[113,cr.plugins_.Arr.prototype.acts.Clear,null,412],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,413,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,414,[[58,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,415]],[[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,416,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,417,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,418,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,419]]],[0,null,!1,420,[[37,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,421]],[[113,cr.plugins_.Arr.prototype.acts.SetX,null,422,[[0,[21,37,!1,null,0]],[7,[0,1]]]]]]]],[0,null,!1,0x820298f86380d,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xe15af1e28d0a5]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,932128185252526,[[0,[0,2]]]],[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,0x416fc223ee4e9,[[0,[0,2]]]]]],[0,null,!1,0x69a62916db3f5,[[23,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,5465214356768122]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,7573038194852767,[[0,[0,2]]]]]],[0,null,!1,0x50255f1ad0500,[[85,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,284289429519218]],[[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,6340555853924916,[[0,[0,2]]]]]],[0,null,!1,5843746570187858,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,0xd3b8b39817e8,[[0,[1,0.5]]]]],[[19,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,747365770671298]]]]],["Lewel13",[[2,"Generalcode"],[2,"Levelslogic"],[0,[!0,"Webstorage"],!1,0xd5091f8b59c36,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xd5091f8b59c36,[[1,[2,"Webstorage"]]]]],[],[[0,null,!1,344,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,345,[[11,"win"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,346,[[11,"currentlevel"],
[7,[0,14]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,7622941931992131,[[6,"Lewel14"]]]]],[0,null,!1,348,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,349,[[11,"win"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,350,[[11,"chooser"],[8,3],[7,[23,"currentlevel"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,351,[[11,"chooser"],[7,[0,14]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,352,[[1,[2,"play"]],[7,[23,"chooser"]]]]]]]],
[0,[!0,"Money"],!1,6268566792782183,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6268566792782183,[[1,[2,"Money"]]]]],[],[[0,null,!1,0x9d3748fe9b276,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x4d4da99e52628]],[[-1,cr.system_object.prototype.acts.SetVar,null,9919372954845772,[[11,"Money"],[7,[0,0]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,7453318299949775,[[7,[2,""]]]]]],[0,null,!1,9067598984039456,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,7995120901386789,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb708feeafcb8d],[-1,cr.system_object.prototype.acts.AddVar,null,9633852739674422,[[11,"Money"],[7,[0,50]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,8044627755867312,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x9f04eb531afb5,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,6376292970975232,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,0xe4f20dd97499b,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xab004f876fe88],[-1,cr.system_object.prototype.acts.AddVar,null,9769968136610648,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x51cd00cfe3d2b,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,506601144933982,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,0xc336f0462227f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,9078904733932652,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb9e97f6c3cdf3,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,773432614272547,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6204531942815,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,8674524364853558,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,7290191353035901,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xd4ad30053fb6e,[[4,117]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,9440980341862622,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5773513338659586,
[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,7612818663881732,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0xba8ea17dfbd75,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]]]],[0,[!0,"MoneyDestroy"],!1,0x70cafb2e847c1,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x70cafb2e847c1,[[1,[2,"MoneyDestroy"]]]]],[],[[0,null,!1,403,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,404]],[[113,cr.plugins_.Arr.prototype.acts.JSONLoad,null,405,[[1,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"savedd"]]]]]]],[[0,null,!1,406,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,407,[[4,37]]],[113,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,408,[[0,[21,37,!1,null,0]],[8,0],[7,[0,1]]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,409]]]]],[0,null,!1,410,[[59,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,
!1,411]],[[113,cr.plugins_.Arr.prototype.acts.Clear,null,412],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,413,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,414,[[58,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,415]],[[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,416,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,417,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,418,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,419]]],[0,null,!1,420,[[37,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,421]],[[113,cr.plugins_.Arr.prototype.acts.SetX,null,422,[[0,[21,37,!1,null,0]],[7,[0,1]]]]]]]],[0,null,!1,0x86e9d5a8f1cb3,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x7473030e4e4de]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,8333676381066854,[[0,[0,2]]]],[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,702150573153433,[[0,[0,2]]]]]],[0,null,!1,0xbd8789480dc75,[[23,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,761824166376496]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,8834402990364212,[[0,[0,2]]]]]],[0,null,!1,7057810402263255,[[85,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,0xcb8059a4ac84e]],[[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,9956597545806716,[[0,[0,2]]]]]],[0,null,!1,0xaed3681101fb4,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,0xc1619e762360,[[0,[1,0.5]]]]],[[19,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,355830492784044]]]]],["Lewel14",[[2,"Generalcode"],[2,"Levelslogic"],[0,[!0,"Webstorage"],!1,0xb339d2b5e744b,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xb339d2b5e744b,[[1,[2,"Webstorage"]]]]],[],[[0,null,!1,344,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,345,[[11,"win"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,346,[[11,"currentlevel"],
[7,[0,15]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,6463023118573087,[[6,"Lewel15"]]]]],[0,null,!1,348,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,349,[[11,"win"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,350,[[11,"chooser"],[8,3],[7,[23,"currentlevel"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,351,[[11,"chooser"],[7,[0,15]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,352,[[1,[2,"play"]],[7,[23,"chooser"]]]]]]]],
[0,[!0,"Money"],!1,8989061018597658,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8989061018597658,[[1,[2,"Money"]]]]],[],[[0,null,!1,0x9d3748fe9b276,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x4d4da99e52628]],[[-1,cr.system_object.prototype.acts.SetVar,null,9919372954845772,[[11,"Money"],[7,[0,0]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,7453318299949775,[[7,[2,""]]]]]],[0,null,!1,9067598984039456,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,7995120901386789,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb708feeafcb8d],[-1,cr.system_object.prototype.acts.AddVar,null,9633852739674422,[[11,"Money"],[7,[0,50]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,8044627755867312,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x9f04eb531afb5,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,6376292970975232,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,0xe4f20dd97499b,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xab004f876fe88],[-1,cr.system_object.prototype.acts.AddVar,null,9769968136610648,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x51cd00cfe3d2b,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,506601144933982,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,0xc336f0462227f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,9078904733932652,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb9e97f6c3cdf3,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,773432614272547,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6204531942815,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,8674524364853558,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,8102182315594013,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xe13f021079919,[[4,117]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0x926d3dd6db655,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xe5fef83e19134,
[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,5765968379546346,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0xa0a699367a14e,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]]]],[0,[!0,"MoneyDestroy"],!1,0xd065580aef3e5,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xd065580aef3e5,[[1,[2,"MoneyDestroy"]]]]],[],[[0,null,!1,403,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,404]],[[113,cr.plugins_.Arr.prototype.acts.JSONLoad,null,405,[[1,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"savedd"]]]]]]],[[0,null,!1,406,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,407,[[4,37]]],[113,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,408,[[0,[21,37,!1,null,0]],[8,0],[7,[0,1]]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,409]]]]],[0,null,!1,410,[[59,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,
!1,411]],[[113,cr.plugins_.Arr.prototype.acts.Clear,null,412],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,413,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,414,[[58,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,415]],[[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,416,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,417,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,418,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,419]]],[0,null,!1,420,[[37,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,421]],[[113,cr.plugins_.Arr.prototype.acts.SetX,null,422,[[0,[21,37,!1,null,0]],[7,[0,1]]]]]]]],[0,null,!1,0x463342473365e,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,6172855260017757]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,6480449651385037,[[0,[0,2]]]],[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,7051834252177267,[[0,[0,2]]]]]],[0,null,!1,4854851311522569,[[23,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,672969220925657]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xd7221e619b142,[[0,[0,2]]]]]],[0,null,!1,9381184346744556,[[85,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,8191863489474073]],[[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,7711923454849727,[[0,[0,2]]]]]],[0,null,!1,5258999892785808,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,994317320282067,[[0,[1,0.5]]]]],[[19,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,0x6c63656fc508]]]]],["Lewel15",[[2,"Generalcode"],[2,"Levelslogic"],[0,[!0,"Webstorage"],!1,0xa2dbdd1636aad,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xa2dbdd1636aad,[[1,[2,"Webstorage"]]]]],[],[[0,null,!1,344,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,345,[[11,"win"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,346,[[11,"currentlevel"],
[7,[0,16]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,5500799342335188,[[6,"Lewel16"]]]]],[0,null,!1,348,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,349,[[11,"win"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,350,[[11,"chooser"],[8,3],[7,[23,"currentlevel"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,351,[[11,"chooser"],[7,[0,16]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,352,[[1,[2,"play"]],[7,[23,"chooser"]]]]]]]],
[0,[!0,"Money"],!1,6647655633700535,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6647655633700535,[[1,[2,"Money"]]]]],[],[[0,null,!1,0x9d3748fe9b276,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x4d4da99e52628]],[[-1,cr.system_object.prototype.acts.SetVar,null,9919372954845772,[[11,"Money"],[7,[0,0]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,7453318299949775,[[7,[2,""]]]]]],[0,null,!1,9067598984039456,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,7995120901386789,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb708feeafcb8d],[-1,cr.system_object.prototype.acts.AddVar,null,9633852739674422,[[11,"Money"],[7,[0,50]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,8044627755867312,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x9f04eb531afb5,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,6376292970975232,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,0xe4f20dd97499b,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xab004f876fe88],[-1,cr.system_object.prototype.acts.AddVar,null,9769968136610648,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x51cd00cfe3d2b,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,506601144933982,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,0xc336f0462227f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,9078904733932652,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb9e97f6c3cdf3,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,773432614272547,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6204531942815,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,8674524364853558,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,7472814123430072,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8449136624158879,[[4,117]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,5857133958797651,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8591259472251135,
[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6546521160068396,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0xa95b9e7bbf0fc,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]]]],[0,[!0,"MoneyDestroy"],!1,0x64b9a6d943a0d,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x64b9a6d943a0d,[[1,[2,"MoneyDestroy"]]]]],[],[[0,null,!1,403,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,404]],[[113,cr.plugins_.Arr.prototype.acts.JSONLoad,null,405,[[1,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"savedd"]]]]]]],[[0,null,!1,406,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,407,[[4,37]]],[113,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,408,[[0,[21,37,!1,null,0]],[8,0],[7,[0,1]]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,409]]]]],[0,null,!1,410,[[59,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,
!1,411]],[[113,cr.plugins_.Arr.prototype.acts.Clear,null,412],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,413,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,414,[[58,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,415]],[[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,416,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,417,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,418,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,419]]],[0,null,!1,420,[[37,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,421]],[[113,cr.plugins_.Arr.prototype.acts.SetX,null,422,[[0,[21,37,!1,null,0]],[7,[0,1]]]]]]]],[0,null,!1,9487905418275592,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,6783433208060049]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x4473505ef746b,[[0,[0,2]]]],[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,7993725753673253,[[0,[0,2]]]]]],[0,null,!1,9904532322646802,[[23,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,6374638473413628]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,4640562107365291,[[0,[0,2]]]]]],[0,null,!1,6046411459728254,[[85,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,4683817068751182]],[[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x766963f97ef3b,[[0,[0,2]]]]]],[0,null,!1,9193062306743892,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,5166810650307339,[[0,[1,0.5]]]]],[[19,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,4545090207123045]]]]],["Lewel16",[[2,"Generalcode"],[2,"Levelslogic"],[0,[!0,"Webstorage"],!1,7653098980046136,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7653098980046136,[[1,[2,"Webstorage"]]]]],[],[[0,null,!1,344,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,345,[[11,"win"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,346,[[11,"currentlevel"],
[7,[0,17]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,8424178577210131,[[6,"Lewel17"]]]]],[0,null,!1,348,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,349,[[11,"win"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,350,[[11,"chooser"],[8,3],[7,[23,"currentlevel"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,351,[[11,"chooser"],[7,[0,17]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,352,[[1,[2,"play"]],[7,[23,"chooser"]]]]]]]],
[0,[!0,"Money"],!1,0xaf09e94e5eb69,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xaf09e94e5eb69,[[1,[2,"Money"]]]]],[],[[0,null,!1,0x9d3748fe9b276,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x4d4da99e52628]],[[-1,cr.system_object.prototype.acts.SetVar,null,9919372954845772,[[11,"Money"],[7,[0,0]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,7453318299949775,[[7,[2,""]]]]]],[0,null,!1,9067598984039456,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,7995120901386789,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb708feeafcb8d],[-1,cr.system_object.prototype.acts.AddVar,null,9633852739674422,[[11,"Money"],[7,[0,50]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,8044627755867312,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x9f04eb531afb5,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,6376292970975232,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,0xe4f20dd97499b,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xab004f876fe88],[-1,cr.system_object.prototype.acts.AddVar,null,9769968136610648,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x51cd00cfe3d2b,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,506601144933982,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,0xc336f0462227f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,9078904733932652,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb9e97f6c3cdf3,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,773432614272547,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6204531942815,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,8674524364853558,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,17938911856381,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x974b74e79c0e3,[[4,117]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,7377837080681762,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xb8122101fda55,
[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,5189394745644649,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0x61c82d55228de,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]]]],[0,[!0,"MoneyDestroy"],!1,5651761841149021,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,5651761841149021,[[1,[2,"MoneyDestroy"]]]]],[],[[0,null,!1,403,[[-1,
cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,404]],[[113,cr.plugins_.Arr.prototype.acts.JSONLoad,null,405,[[1,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"savedd"]]]]]]],[[0,null,!1,406,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,407,[[4,37]]],[113,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,408,[[0,[21,37,!1,null,0]],[8,0],[7,[0,1]]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,409]]]]],[0,null,!1,410,[[59,cr.plugins_.Button.prototype.cnds.OnClicked,
null,1,!1,!1,!1,411]],[[113,cr.plugins_.Arr.prototype.acts.Clear,null,412],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,413,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,414,[[58,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,415]],[[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,416,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,417,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,418,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,419]]],[0,null,!1,420,[[37,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,421]],[[113,cr.plugins_.Arr.prototype.acts.SetX,null,422,[[0,[21,37,!1,null,0]],[7,[0,1]]]]]]]],[0,null,!1,9957187154461198,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,9745185770749124]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,9669829767065668,[[0,[0,3]]]],[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,9895569133788048,[[0,[0,3]]]]]],[0,null,!1,5487154095938323,[[23,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,9805694785399060]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,21580208836782,[[0,[0,3]]]]]],[0,null,!1,9763484167936444,[[85,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,0xa2f0feb43b4a7]],[[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xf293958961a37,[[0,[0,3]]]]]],[0,null,!1,0xd39f89bc96c2,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,0xef02b632afc5d,[[0,[1,0.5]]]]],[[19,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,0xf53cff96fc17c]]]]],["Lewel17",[[2,"Generalcode"],[2,"Levelslogic"],[0,[!0,"Webstorage"],!1,0xbd10715175751,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xbd10715175751,[[1,[2,"Webstorage"]]]]],[],[[0,null,!1,344,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,345,[[11,"win"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,346,[[11,"currentlevel"],
[7,[0,18]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x8f7ddc8b2953f,[[6,"Lewel18"]]]]],[0,null,!1,348,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,349,[[11,"win"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,350,[[11,"chooser"],[8,3],[7,[23,"currentlevel"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,351,[[11,"chooser"],[7,[0,18]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,352,[[1,[2,"play"]],[7,[23,"chooser"]]]]]]]],
[0,[!0,"Money"],!1,0xc23ac05211a3c,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xc23ac05211a3c,[[1,[2,"Money"]]]]],[],[[0,null,!1,0x9d3748fe9b276,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x4d4da99e52628]],[[-1,cr.system_object.prototype.acts.SetVar,null,9919372954845772,[[11,"Money"],[7,[0,0]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,7453318299949775,[[7,[2,""]]]]]],[0,null,!1,9067598984039456,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,7995120901386789,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb708feeafcb8d],[-1,cr.system_object.prototype.acts.AddVar,null,9633852739674422,[[11,"Money"],[7,[0,50]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,8044627755867312,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x9f04eb531afb5,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,6376292970975232,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,0xe4f20dd97499b,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xab004f876fe88],[-1,cr.system_object.prototype.acts.AddVar,null,9769968136610648,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x51cd00cfe3d2b,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,506601144933982,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,0xc336f0462227f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,9078904733932652,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb9e97f6c3cdf3,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,773432614272547,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6204531942815,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,8674524364853558,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,837274875915989,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xa28621d93af58,[[4,117]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,6752754945891308,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xbc34c1f0c6e2b,
[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,7317480576370574,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,4588526174404351,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]]]],[0,[!0,"MoneyDestroy"],!1,8275852275698246,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8275852275698246,[[1,[2,"MoneyDestroy"]]]]],[],[[0,null,!1,403,[[-1,
cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,404]],[[113,cr.plugins_.Arr.prototype.acts.JSONLoad,null,405,[[1,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"savedd"]]]]]]],[[0,null,!1,406,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,407,[[4,37]]],[113,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,408,[[0,[21,37,!1,null,0]],[8,0],[7,[0,1]]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,409]]]]],[0,null,!1,410,[[59,cr.plugins_.Button.prototype.cnds.OnClicked,
null,1,!1,!1,!1,411]],[[113,cr.plugins_.Arr.prototype.acts.Clear,null,412],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,413,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,414,[[58,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,415]],[[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,416,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,417,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,418,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,419]]],[0,null,!1,420,[[37,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,421]],[[113,cr.plugins_.Arr.prototype.acts.SetX,null,422,[[0,[21,37,!1,null,0]],[7,[0,1]]]]]]]],[0,null,!1,0x4abacc5677657,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,4537592805690536]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x9bb56f8f53f24,[[0,[0,3]]]],[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,0x42506844d6db1,[[0,[0,3]]]]]],[0,null,!1,5396358975815486,[[23,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,7930260922917552]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5059403423484499,[[0,[0,3]]]]]],[0,null,!1,9453550563150556,[[85,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,8212859290976381]],[[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,8145281750983062,[[0,[0,3]]]]]],[0,null,!1,0x6f87c3609deab,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,8134125489262643,[[0,[1,0.5]]]]],[[19,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,7418106314130912]]]]],["Lewel18",[[2,"Generalcode"],[2,"Levelslogic"],[0,[!0,"Webstorage"],!1,8888544398283845,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8888544398283845,[[1,[2,"Webstorage"]]]]],[],[[0,null,!1,344,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,345,[[11,"win"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,346,[[11,"currentlevel"],
[7,[0,19]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x711cb01ff89bb,[[6,"Lewel19"]]]]],[0,null,!1,348,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,349,[[11,"win"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,350,[[11,"chooser"],[8,3],[7,[23,"currentlevel"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,351,[[11,"chooser"],[7,[0,19]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,352,[[1,[2,"play"]],[7,[23,"chooser"]]]]]]]],
[0,[!0,"Money"],!1,9723578918837414,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,9723578918837414,[[1,[2,"Money"]]]]],[],[[0,null,!1,0x9d3748fe9b276,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x4d4da99e52628]],[[-1,cr.system_object.prototype.acts.SetVar,null,9919372954845772,[[11,"Money"],[7,[0,0]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,7453318299949775,[[7,[2,""]]]]]],[0,null,!1,9067598984039456,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,7995120901386789,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb708feeafcb8d],[-1,cr.system_object.prototype.acts.AddVar,null,9633852739674422,[[11,"Money"],[7,[0,50]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,8044627755867312,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x9f04eb531afb5,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,6376292970975232,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,0xe4f20dd97499b,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xab004f876fe88],[-1,cr.system_object.prototype.acts.AddVar,null,9769968136610648,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x51cd00cfe3d2b,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,506601144933982,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,0xc336f0462227f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,9078904733932652,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb9e97f6c3cdf3,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,773432614272547,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6204531942815,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,8674524364853558,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,7247652925375242,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8137813188675851,[[4,117]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,9485557380117578,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x8d9b92e110f1e,
[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,310281241261404,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,9207587543922608,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]]]],[0,[!0,"MoneyDestroy"],!1,4994834492545333,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,4994834492545333,[[1,[2,"MoneyDestroy"]]]]],[],[[0,null,!1,403,[[-1,
cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,404]],[[113,cr.plugins_.Arr.prototype.acts.JSONLoad,null,405,[[1,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"savedd"]]]]]]],[[0,null,!1,406,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,407,[[4,37]]],[113,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,408,[[0,[21,37,!1,null,0]],[8,0],[7,[0,1]]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,409]]]]],[0,null,!1,410,[[59,cr.plugins_.Button.prototype.cnds.OnClicked,
null,1,!1,!1,!1,411]],[[113,cr.plugins_.Arr.prototype.acts.Clear,null,412],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,413,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,414,[[58,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,415]],[[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,416,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,417,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,418,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,419]]],[0,null,!1,420,[[37,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,421]],[[113,cr.plugins_.Arr.prototype.acts.SetX,null,422,[[0,[21,37,!1,null,0]],[7,[0,1]]]]]]]],[0,null,!1,7024835285522579,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xb817b6f67fe9b]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xbffcd4ee2d23a,[[0,[0,3]]]],[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,9787454705917224,[[0,[0,3]]]]]],[0,null,!1,4584257011752767,[[23,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,6764204005675108]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,20718078439602,[[0,[0,3]]]]]],[0,null,!1,5403405908270231,[[85,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,0xcca71c890311f]],[[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,969673767963012,[[0,[0,3]]]]]],[0,null,!1,0xc1371f532a625,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,6791146224802452,[[0,[1,0.5]]]]],[[19,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,5372111374547672]]]]],["Lewel19",[[2,"Generalcode"],[2,"Levelslogic"],[0,[!0,"Webstorage"],!1,7594242215350904,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7594242215350904,[[1,[2,"Webstorage"]]]]],[],[[0,null,!1,344,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,345,[[11,"win"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,346,[[11,"currentlevel"],
[7,[0,20]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,0xb25477877fdb9,[[6,"Lewel20"]]]]],[0,null,!1,348,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,349,[[11,"win"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,350,[[11,"chooser"],[8,3],[7,[23,"currentlevel"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,351,[[11,"chooser"],[7,[0,20]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,352,[[1,[2,"play"]],[7,[23,"chooser"]]]]]]]],
[0,[!0,"Money"],!1,7540410285030038,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7540410285030038,[[1,[2,"Money"]]]]],[],[[0,null,!1,0x9d3748fe9b276,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x4d4da99e52628]],[[-1,cr.system_object.prototype.acts.SetVar,null,9919372954845772,[[11,"Money"],[7,[0,0]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,7453318299949775,[[7,[2,""]]]]]],[0,null,!1,9067598984039456,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,7995120901386789,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb708feeafcb8d],[-1,cr.system_object.prototype.acts.AddVar,null,9633852739674422,[[11,"Money"],[7,[0,50]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,8044627755867312,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x9f04eb531afb5,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,6376292970975232,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,0xe4f20dd97499b,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xab004f876fe88],[-1,cr.system_object.prototype.acts.AddVar,null,9769968136610648,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x51cd00cfe3d2b,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,506601144933982,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,0xc336f0462227f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,9078904733932652,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb9e97f6c3cdf3,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,773432614272547,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6204531942815,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,8674524364853558,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,0xc3505728c21c3,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xd13dbab77b191,[[4,117]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,779588943839781,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9148886877504562,
[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8607735254038202,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,9545719689313452,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]]]],[0,[!0,"MoneyDestroy"],!1,670268260604343,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,670268260604343,[[1,[2,"MoneyDestroy"]]]]],[],[[0,null,!1,403,[[-1,
cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,404]],[[113,cr.plugins_.Arr.prototype.acts.JSONLoad,null,405,[[1,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"savedd"]]]]]]],[[0,null,!1,406,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,407,[[4,37]]],[113,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,408,[[0,[21,37,!1,null,0]],[8,0],[7,[0,1]]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,409]]]]],[0,null,!1,410,[[59,cr.plugins_.Button.prototype.cnds.OnClicked,
null,1,!1,!1,!1,411]],[[113,cr.plugins_.Arr.prototype.acts.Clear,null,412],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,413,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,414,[[58,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,415]],[[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,416,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,417,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,418,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,419]]],[0,null,!1,420,[[37,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,421]],[[113,cr.plugins_.Arr.prototype.acts.SetX,null,422,[[0,[21,37,!1,null,0]],[7,[0,1]]]]]]]],[0,null,!1,4764064964425018,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,686459855971499]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,9232605809804448,[[0,[0,3]]]],[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,0xa961282ddc4f1,[[0,[0,3]]]]]],[0,null,!1,0xfbf815206d3dd,[[23,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,5807925823924302]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,4881132466083336,[[0,[0,3]]]]]],[0,null,!1,0x449c3faafda7e,[[85,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x97eb2249711eb]],[[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,8095959964512049,[[0,[0,3]]]]]],[0,null,!1,0x75f7837c48910,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,0xb6c2283a1bb8e,[[0,[1,0.5]]]]],[[19,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,6394461063460018]]]]],["Lewel20",[[0,[!0,"Webstorage"],!1,8446566331598196,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8446566331598196,[[1,[2,"Webstorage"]]]]],[],[[0,null,!1,344,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,345,[[11,"win"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,346,[[11,"currentlevel"],[7,[0,3]]]],[-1,cr.system_object.prototype.acts.GoToLayout,
null,934980420930001,[[6,"Lewel3"]]]]],[0,null,!1,348,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,349,[[11,"win"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,350,[[11,"chooser"],[8,3],[7,[23,"currentlevel"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,351,[[11,"chooser"],[7,[0,3]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,352,[[1,[2,"play"]],[7,[23,"chooser"]]]]]]]],[2,"Generalcode"],[2,"Levelslogic"],[0,[!0,"Money"],
!1,0xa0258cb899ca2,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xa0258cb899ca2,[[1,[2,"Money"]]]]],[],[[0,null,!1,0x9d3748fe9b276,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x4d4da99e52628]],[[-1,cr.system_object.prototype.acts.SetVar,null,9919372954845772,[[11,"Money"],[7,[0,0]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,7453318299949775,[[7,[2,""]]]]]],[0,null,!1,9067598984039456,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,
!1,!1,7995120901386789,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb708feeafcb8d],[-1,cr.system_object.prototype.acts.AddVar,null,9633852739674422,[[11,"Money"],[7,[0,50]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,8044627755867312,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x9f04eb531afb5,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,6376292970975232,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,0xe4f20dd97499b,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xab004f876fe88],[-1,cr.system_object.prototype.acts.AddVar,null,9769968136610648,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x51cd00cfe3d2b,[[7,[23,"Money"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,506601144933982,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,0xc336f0462227f,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,9078904733932652,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb9e97f6c3cdf3,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,773432614272547,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6204531942815,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,8674524364853558,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,5267230263027676,[[111,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7460090383837113,[[4,117]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,5099294229399625,[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9183188181451874,
[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,588059594309602,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,94663361647066,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]]]],[0,[!0,"MoneyDestroy"],!1,0xdbf5799a2a0dd,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xdbf5799a2a0dd,[[1,[2,"MoneyDestroy"]]]]],[],[[0,null,!1,403,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,404]],[[113,cr.plugins_.Arr.prototype.acts.JSONLoad,null,405,[[1,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"savedd"]]]]]]],[[0,null,!1,406,[[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,407,[[4,37]]],[113,cr.plugins_.Arr.prototype.cnds.CompareX,null,0,!1,!1,!1,408,[[0,[21,37,!1,null,0]],[8,0],[7,[0,1]]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,409]]]]],[0,null,!1,410,[[59,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,
!1,411]],[[113,cr.plugins_.Arr.prototype.acts.Clear,null,412],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,413,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,414,[[58,cr.plugins_.Button.prototype.cnds.OnClicked,null,1,!1,!1,!1,415]],[[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,416,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,!0,null]]]]]],[0,null,!1,417,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,418,[[4,37]]]],[[37,cr.plugins_.Sprite.prototype.acts.Destroy,null,419]]],[0,null,!1,420,[[37,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,421]],[[113,cr.plugins_.Arr.prototype.acts.SetX,null,422,[[0,[21,37,!1,null,0]],[7,[0,1]]]]]]]],[0,null,!1,5344660439703788,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xcd6a06a4950e0]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,6075887447900578,[[0,[0,3]]]],[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,4547497171037702,[[0,[0,3]]]]]],[0,null,!1,7709273162277485,[[23,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,6387139839963107]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,4555030209566861,[[0,[0,3]]]]]],[0,null,!1,5223221953268742,[[85,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,7946473879368738]],[[85,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5254123853753133,[[0,[0,3]]]]]],[0,null,!1,0x6c8dfe5af5beb,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,8237504687735506,[[0,[1,0.5]]]]],[[19,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,334560965730228]]]]],["Levelslogic",[[2,"Generalcode"],[1,"Power2",0,0,!1,!1,8073532895221411],[1,"Smoke",0,0,!1,!1,4816942496110683],[1,"Alien",0,0,!1,!1,0x7491ddccb7385],[1,"Roach",0,0,!1,!1,7457877350371156],[1,"Slizen",0,0,!1,!1,8701956999633841],[1,"Kaktus",0,0,!1,!1,8100979992966045],[1,"Batman",0,0,!1,!1,4911219019609259],[1,"Dragon",0,0,!1,!1,8364638653216553],[1,"Boo",0,0,!1,!1,0xf49ea3a423168],
[1,"Ghost",0,0,!1,!1,0xfef1e02e0b4da],[1,"Hypno",0,0,!1,!1,0xdd8730328951b],[1,"Haha",0,0,!1,!1,895155706263744],[1,"Robot",0,0,!1,!1,0x714fad0d004fb],[1,"Special1Countdown",0,0,!1,!1,0x6a43040ac9856],[1,"Special2Countdown",0,0,!1,!1,8032721305896166],[1,"Special3Countdown",0,0,!1,!1,7248860714389862],[1,"Special4Countdown",0,0,!1,!1,9062721958757804],[1,"MoneyCountdown",0,0,!1,!1,8334521658998165],[1,"MoneyCountdown2",0,0,!1,!1,8076383677884297],[0,[!0,"WatherMouse"],!1,0xb2c9b717f5a07,[[-1,cr.system_object.prototype.cnds.IsGroupActive,
null,0,!1,!1,!1,0xb2c9b717f5a07,[[1,[2,"WatherMouse"]]]]],[],[[0,null,!1,9420154322456220,[[27,cr.plugins_.TiledBg.prototype.cnds.CompareY,null,0,!1,!1,!1,7232088068588432,[[8,5],[0,[4,[20,21,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,700]]]]]],[[27,cr.plugins_.TiledBg.prototype.acts.SetPos,null,0xff1e3077a47cf,[[0,[0,-97]],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,650]]]]],[84,cr.plugins_.TiledBg.prototype.acts.SetPos,null,9556478125653432,[[0,[0,-97]],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,
!1,null],[0,770]]]]]]]]],[0,[!0,"WatherRocket"],!1,7304515009597267,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7304515009597267,[[1,[2,"WatherRocket"]]]]],[],[[0,null,!1,9420154322456220,[[27,cr.plugins_.TiledBg.prototype.cnds.CompareY,null,0,!1,!1,!1,7232088068588432,[[8,5],[0,[4,[20,117,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,700]]]]]],[[27,cr.plugins_.TiledBg.prototype.acts.SetPos,null,0xff1e3077a47cf,[[0,[0,-97]],[0,[4,[20,117,cr.plugins_.Sprite.prototype.exps.Y,
!1,null],[0,650]]]]],[84,cr.plugins_.TiledBg.prototype.acts.SetPos,null,9556478125653432,[[0,[0,-97]],[0,[4,[20,117,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,770]]]]]]]]],[0,[!0,"NoRocket"],!1,862231362857544,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,862231362857544,[[1,[2,"NoRocket"]]]]],[],[[0,null,!1,6223563000754062,[[23,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,6340770512936664,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,
400]]]]],[23,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,7136479325669541]],[[23,cr.plugins_.Sprite.prototype.acts.Destroy,null,9493800993571788],[-1,cr.system_object.prototype.acts.CreateObject,null,6239659652111969,[[4,23],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,[[0,200],[0,512]]]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,1250]]]]]]],[0,null,!1,5452889280749037,[[85,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,9682707167021268,[[8,
5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[85,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0x70236fd3d5223]],[[85,cr.plugins_.Sprite.prototype.acts.Destroy,null,5626807704286889],[-1,cr.system_object.prototype.acts.CreateObject,null,0xe008aad458041,[[4,85],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,[[0,530],[0,900]]]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,1250]]]]]]],[0,null,!1,0x669952ec154bc,[[118,cr.plugins_.Sprite.prototype.cnds.CompareY,
null,0,!1,!1,!1,528345855336579,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,800]]]]],[118,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,8660802646773731]],[[118,cr.plugins_.Sprite.prototype.acts.Destroy,null,5429247610828036],[-1,cr.system_object.prototype.acts.CreateObject,null,9449393848733332,[[4,118],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,[[0,20],[0,400]]]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,1250]]]]]]],[0,null,
!1,8566213645264256,[[120,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,0xb51e7cf2be67c,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,800]]]]],[120,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,9370633766924420],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7226769879331483,[[11,"CTV"],[8,5],[7,[0,0]]]]],[[120,cr.plugins_.Sprite.prototype.acts.Destroy,null,5946522747075884],[-1,cr.system_object.prototype.acts.CreateObject,null,0x827c0e74d9899,
[[4,120],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,[[0,630],[0,1024]]]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,1250]]]]]]],[0,[!0,"Power"],!1,4871412891851861,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,4871412891851861,[[1,[2,"Power"]]]]],[],[[0,null,!1,4640060418562817,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8373852904063289,[[11,"Accleration"],[8,3],[7,[0,0]]]]],[],[[0,null,!1,6172233692847193,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,6446644070157934,[[11,"Power2"],[8,3],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,5275637006309051,[[4,136],[5,[0,5]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,27,cr.plugins_.TiledBg.prototype.exps.Y,!1,null],[0,10]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5499656325318384,[[11,"Power2"],[7,[0,1]]]]]]]],[0,null,!1,8558474863181181,[[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9186763779450396,[[4,136]]]],
[[136,cr.plugins_.Sprite.prototype.acts.Destroy,null,5546102331850545],[-1,cr.system_object.prototype.acts.SetVar,null,0xe204cf61cdf25,[[11,"Accleration"],[7,[0,200]]]],[20,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0xc35da2cabc9cc,[[10,0],[7,[0,200]]]]]],[0,null,!1,0xb1f815446fb65,[[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6699530590375594,[[4,56]]]],[[56,cr.plugins_.Sprite.prototype.acts.Destroy,null,6960700158738026],[-1,cr.system_object.prototype.acts.SetVar,
null,9185264851920144,[[11,"Accleration"],[7,[0,200]]]],[20,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0xe764801e55aed,[[10,0],[7,[0,200]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,8112516351553661,[[4,56],[5,[0,5]],[0,[19,cr.system_object.prototype.exps.random,[[0,200],[0,900]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[19,cr.system_object.prototype.exps.random,[[0,1E3],[0,1650]]]]]]]]],[0,null,!1,4976368052501348,[[56,cr.plugins_.Sprite.prototype.cnds.CompareY,
null,0,!1,!1,!1,7969720455485037,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[56,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,992708168763238]],[[56,cr.plugins_.Sprite.prototype.acts.Destroy,null,6243671651831575],[-1,cr.system_object.prototype.acts.CreateObject,null,6055260893608252,[[4,56],[5,[0,5]],[0,[19,cr.system_object.prototype.exps.random,[[0,200],[0,900]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[19,cr.system_object.prototype.exps.random,
[[0,1E3],[0,1650]]]]]]]]]]],[0,[!0,"mouseballs"],!1,0x4966e8148aa55,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x4966e8148aa55,[[1,[2,"mouseballs"]]]]],[],[[0,null,!1,9320309252848588,[[240,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,6883646999865588,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[240,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0x509ac35be546f]],[[240,cr.plugins_.Sprite.prototype.acts.Destroy,null,
8942149879300527],[-1,cr.system_object.prototype.acts.CreateObject,null,7686328985942499,[[4,240],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,[[0,200],[0,900]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[19,cr.system_object.prototype.exps.random,[[0,600],[0,900]]]]]]]]],[0,null,!1,5542258522564687,[[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5328064906339094,[[4,240]]]],[[240,cr.plugins_.Sprite.prototype.acts.Destroy,null,6114166503758213],[-1,cr.system_object.prototype.acts.CreateObject,
null,4937032452297166,[[4,240],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,[[0,200],[0,900]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[19,cr.system_object.prototype.exps.random,[[0,600],[0,900]]]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,7363525741965882,[[11,"Ballss"],[7,[0,1]]]]]]]]]],[0,[!0,"NoMouse"],!1,5903691153387207,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,5903691153387207,[[1,[2,"NoMouse"]]]]],[],[[0,null,!1,6531812813700461,
[[23,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,5066206720463905,[[8,5],[0,[4,[20,117,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,800]]]]],[23,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,8608723361579645]],[[23,cr.plugins_.Sprite.prototype.acts.Destroy,null,340340660031303],[-1,cr.system_object.prototype.acts.CreateObject,null,0xa8223d3dadeee,[[4,23],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,[[0,20],[0,400]]]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,
!1,null],[0,1250]]]]]]],[0,null,!1,0x3ae7518e3cc05,[[85,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,0x9d8b980bac42b,[[8,5],[0,[4,[20,117,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,800]]]]],[85,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0xc4a4a8423abb9]],[[85,cr.plugins_.Sprite.prototype.acts.Destroy,null,9191223766508180],[-1,cr.system_object.prototype.acts.CreateObject,null,5903073954414083,[[4,85],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,[[0,
630],[0,1024]]]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,1250]]]]]]],[0,null,!1,6851240624841168,[[118,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,9088187948878528,[[8,5],[0,[4,[20,117,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,800]]]]],[118,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0xe6b88fdb4c4e6]],[[118,cr.plugins_.Sprite.prototype.acts.Destroy,null,5639184172227011],[-1,cr.system_object.prototype.acts.CreateObject,null,6250827856037947,
[[4,118],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,[[0,20],[0,400]]]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,1250]]]]]]],[0,null,!1,0xfb8c0dbb7de2d,[[120,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,9380858392907716,[[8,5],[0,[4,[20,117,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,800]]]]],[120,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0xf6ff17cbec50d],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,855184594959834,
[[11,"CTV"],[8,5],[7,[0,0]]]]],[[120,cr.plugins_.Sprite.prototype.acts.Destroy,null,669639353215512],[-1,cr.system_object.prototype.acts.CreateObject,null,0x8fe6308e7d3f2,[[4,120],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,[[0,630],[0,1024]]]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,1250]]]]]]],[0,[!0,"Power2"],!1,7053953524834967,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7053953524834967,[[1,[2,"Power2"]]]]],[],[[0,null,!1,4976368052501348,
[[56,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,7969720455485037,[[8,5],[0,[4,[20,117,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[56,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,992708168763238]],[[56,cr.plugins_.Sprite.prototype.acts.Destroy,null,6243671651831575],[-1,cr.system_object.prototype.acts.CreateObject,null,6055260893608252,[[4,56],[5,[0,5]],[0,[19,cr.system_object.prototype.exps.random,[[0,200],[0,900]]]],[0,[5,[20,117,cr.plugins_.Sprite.prototype.exps.Y,
!1,null],[19,cr.system_object.prototype.exps.random,[[0,1E3],[0,1650]]]]]]]]]]],[0,[!0,"mouseballs2"],!1,0xf9e0f4380d5d3,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xf9e0f4380d5d3,[[1,[2,"mouseballs2"]]]]],[],[[0,null,!1,9320309252848588,[[240,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,6883646999865588,[[8,5],[0,[4,[20,117,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[240,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0x509ac35be546f]],
[[240,cr.plugins_.Sprite.prototype.acts.Destroy,null,8942149879300527],[-1,cr.system_object.prototype.acts.CreateObject,null,7686328985942499,[[4,240],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,[[0,200],[0,900]]]],[0,[5,[20,117,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[19,cr.system_object.prototype.exps.random,[[0,600],[0,900]]]]]]]]]]]]],[0,[!0,"DecorTop"],!1,0xf57116f2380,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xf57116f2380,[[1,[2,"DecorTop"]]]]],[],
[[0,null,!1,7080387500271819,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,967416762417366,[[0,[19,cr.system_object.prototype.exps.random,[[0,4],[0,12]]]]]],[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,8233126831983181,[[4,82]]]],[],[[0,null,!1,4865376476046444,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,0x4f96764d95d6c,[[10,0],[8,0],[7,[2,"Decor1"]]]],[23,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,8909792637989395],[23,
cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,6216058593941843,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,4802474210679732,[[4,83],[5,[0,7]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[83,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,9144167512744400,[[4,23],[7,[0,1]]]],[83,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,6759546986997136]]],[0,null,!1,0x8bb385a6a5208,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,
null,0,!1,!1,!1,0x9b0050686cbf9,[[10,0],[8,0],[7,[2,"Decor1A"]]]],[23,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,8824712964409226],[23,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,0x9244b64bcb7d9,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,7127709874629037,[[4,124],[5,[0,7]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[124,cr.plugins_.Sprite.prototype.acts.SetPosToObject,
null,6752924856599438,[[4,23],[7,[0,1]]]],[124,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,6676342839580563]]],[0,null,!1,6988447301051229,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,0x80eeaf3bffd6f,[[10,0],[8,0],[7,[2,"Decor1C"]]]],[23,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,4968842340306417],[23,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,0xfc2c21aed976b,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,
0x436b4d0cb120a,[[4,127],[5,[0,7]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[127,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x4c7d4e88eee54,[[4,23],[7,[0,1]]]],[127,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,0x99e892911f333]]],[0,null,!1,4792239094709415,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,6390199468624636,[[10,0],[8,0],[7,[2,"Decor2"]]]],[85,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!0,!1,6724142964486361],[85,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,9671030287928192,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x9d095d015a53e,[[4,86],[5,[0,7]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[86,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,8689193290382629,[[4,85],[7,[0,1]]]],[86,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,9414922963564514]]],
[0,null,!1,5601176219074976,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,0x84e8f9db9951c,[[10,0],[8,0],[7,[2,"Decor2A"]]]],[85,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,7994034544274902],[85,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,0xd11e1309da083,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x7d7a72b4e01e3,[[4,125],[5,[0,7]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,
!1,null]]]],[125,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,7366406168682368,[[4,85],[7,[0,1]]]],[125,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,0x4656636a332d0]]],[0,null,!1,548888938301855,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8875618072717403,[[10,0],[8,0],[7,[2,"Decor2C"]]]],[85,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0xf33de45f7fe8],[85,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,9896539855251436,[[3,
0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x4a5efd869dc89,[[4,126],[5,[0,7]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[126,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xd8c23893c80f3,[[4,85],[7,[0,1]]]],[126,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,283885805747044]]]]]]],[0,[!0,"DecorTop2"],!1,6152623442041644,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6152623442041644,
[[1,[2,"DecorTop2"]]]]],[],[[0,null,!1,7080387500271819,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,967416762417366,[[0,[19,cr.system_object.prototype.exps.random,[[0,3],[0,9]]]]]],[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,8233126831983181,[[4,82]]]],[],[[0,null,!1,0x89022d4abfac5,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,9272807003682172,[[10,0],[8,0],[7,[2,"Decor3"]]]],[23,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,
!1,0x5d4f66dc06b3e],[23,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,7393126916204701,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,5114642121571314,[[4,87],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[87,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x640ea5cf3f66,[[4,23],[7,[0,2]]]],[87,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,7103603491850727]]],[0,null,!1,0x7342129a463f9,
[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,418096847718831,[[10,0],[8,0],[7,[2,"Decor3A"]]]],[23,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,6743123025735213],[23,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,8003563644596221,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,7521678651039117,[[4,122],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,
null]]]],[122,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xa766ca4f2e179,[[4,23],[7,[0,2]]]],[122,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,6991301502870562]]],[0,null,!1,6830988185682161,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,0x78bba29ae8df,[[10,0],[8,0],[7,[2,"Decor3C"]]]],[23,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,9387856659185960],[23,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,498577855963131,[[3,
0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,5086207710497704,[[4,129],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[129,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5643739608037492,[[4,23],[7,[0,2]]]],[129,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,7363950945055755]]],[0,null,!1,8552442489585023,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,4612829262000216,
[[10,0],[8,0],[7,[2,"Decor4"]]]],[85,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,6934896861247819],[85,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,9263347595530248,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,6841835921798877,[[4,88],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[88,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x6cdf820d15c7d,[[4,85],[7,
[0,2]]]],[88,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,5212519406712817]]],[0,null,!1,6545750490784913,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,5543050740092305,[[10,0],[8,0],[7,[2,"Decor4A"]]]],[85,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0x7f20c59d12730],[85,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,0x94775f39b3ded,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,8789923915668537,[[4,123],[5,[0,4]],
[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[123,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5381872772004796,[[4,85],[7,[0,2]]]],[123,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,4565882964938881]]],[0,null,!1,8658911631902195,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,5076855496208606,[[10,0],[8,0],[7,[2,"Decor4C"]]]],[85,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,
!1,9091575401137172],[85,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,6113357566765019,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xceb60d297a776,[[4,128],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[128,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xb719d468cc08,[[4,85],[7,[0,2]]]],[128,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,4658372739428004]]]]]]],[0,[!0,
"Money1"],!1,4653532950087292,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,4653532950087292,[[1,[2,"Money1"]]]]],[],[[0,null,!1,0x5cc6a87155caf,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,5709202099103404,[[0,[19,cr.system_object.prototype.exps.random,[[0,3],[0,9]]]]]],[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,6362865007478069,[[4,82]]]],[],[[0,null,!1,762594102174583,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,
8306766100689782,[[10,0],[8,0],[7,[2,"Money1"]]]],[23,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,8959010915747908],[23,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,5153841705919135,[[3,0]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,826980762597656,[[11,"MoneyCountdown"],[8,3],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xce61f9c00d538,[[4,89],[5,[0,4]],[0,[20,23,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,
23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,120]]]]],[89,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,97374233261419,[[10,0],[7,[2,"raz"]]]],[57,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,4922298187625527,[[10,0],[7,[2,"odin"]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xebea2a2a5f8,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,
null,5761589789194341,[[0,[20,23,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,80]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,99067779443903,[[11,"MoneyCountdown"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,427942709356028,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,9474824555358536,
[[0,[4,[20,23,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,30]]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,50]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,976719910291516,[[11,"MoneyCountdown"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xd0c74c748a38d,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xe53db835f1c65,
[[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,30]]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,50]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,4940936288205476,[[11,"MoneyCountdown"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,5894673299135275,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,4781373124008482,
[[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,30]]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,110]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,6207878431381062,[[11,"MoneyCountdown"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,6772314168432989,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,7261813824007325,
[[0,[4,[20,23,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,30]]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,110]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,6566465121902689,[[11,"MoneyCountdown"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,9159326861635424,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xea83feb83bbe7,
[[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,60]]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,80]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,0xe3432bd7d716f,[[11,"MoneyCountdown"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,9658602800232048,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,8777492504950588,
[[0,[4,[20,23,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,60]]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,80]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,5628439791755668,[[11,"MoneyCountdown"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,76413706889868,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,0x3fbd457a978cb,
[[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,90]]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,110]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,0x9aa6a159133e6,[[11,"MoneyCountdown"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,550803577809674,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,7236836171561932,
[[0,[4,[20,23,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,90]]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,110]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,473801742953424,[[11,"MoneyCountdown"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,5092334357661145,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,7398273778967022,
[[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,90]]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,50]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,5696415876729581,[[11,"MoneyCountdown"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xf17a849474e4c,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,8201760375228822,
[[0,[4,[20,23,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,90]]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,50]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,5357801916658899,[[11,"MoneyCountdown"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,4802902824652777,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,9567517453225862,
[[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,120]]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,80]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,7864121052680517,[[11,"MoneyCountdown"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,4641938165654292,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,6965808782061198,
[[0,[4,[20,23,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,120]]],[0,[5,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,80]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,4673559264262275,[[11,"MoneyCountdown"],[7,[0,1]]]],[57,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,0x65836481839d]]]]]]],[0,[!0,"Money2"],!1,0xdbc4096783a18,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xdbc4096783a18,[[1,[2,"Money2"]]]]],[],[[0,null,!1,0x5cc6a87155caf,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,5709202099103404,[[0,[19,cr.system_object.prototype.exps.random,[[0,3],[0,9]]]]]],[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,6362865007478069,[[4,82]]]],[],[[0,null,!1,762594102174583,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8306766100689782,[[10,0],[8,0],[7,[2,"Money2"]]]],[85,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,8959010915747908],[85,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,5153841705919135,
[[3,0]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,826980762597656,[[11,"MoneyCountdown2"],[8,3],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x7d2b7f1cdc7ac,[[4,89],[5,[0,4]],[0,[20,85,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,85,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,120]]]]],[89,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x86bd73651952d,[[10,0],[7,[2,"dva"]]]],[57,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,
0x66d0de6527042,[[10,0],[7,[2,"dva"]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xebea2a2a5f8,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,5761589789194341,[[0,[20,85,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,85,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,80]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,99067779443903,[[11,
"MoneyCountdown2"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,427942709356028,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,9474824555358536,[[0,[4,[20,85,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,30]]],[0,[5,[20,85,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,50]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,976719910291516,
[[11,"MoneyCountdown2"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xd0c74c748a38d,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xe53db835f1c65,[[0,[5,[20,85,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,30]]],[0,[5,[20,85,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,50]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,4940936288205476,
[[11,"MoneyCountdown2"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,5894673299135275,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,4781373124008482,[[0,[5,[20,85,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,30]]],[0,[5,[20,85,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,110]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,6207878431381062,
[[11,"MoneyCountdown2"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,6772314168432989,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,7261813824007325,[[0,[4,[20,85,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,30]]],[0,[5,[20,85,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,110]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,6566465121902689,
[[11,"MoneyCountdown2"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,9159326861635424,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xea83feb83bbe7,[[0,[5,[20,85,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,60]]],[0,[5,[20,85,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,80]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,0xe3432bd7d716f,
[[11,"MoneyCountdown2"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,9658602800232048,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,8777492504950588,[[0,[4,[20,85,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,60]]],[0,[5,[20,85,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,80]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,5628439791755668,
[[11,"MoneyCountdown2"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,76413706889868,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,0x3fbd457a978cb,[[0,[5,[20,85,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,90]]],[0,[5,[20,85,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,110]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,0x9aa6a159133e6,
[[11,"MoneyCountdown2"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,550803577809674,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,7236836171561932,[[0,[4,[20,85,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,90]]],[0,[5,[20,85,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,110]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,473801742953424,
[[11,"MoneyCountdown2"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,5092334357661145,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,7398273778967022,[[0,[5,[20,85,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,90]]],[0,[5,[20,85,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,50]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,5696415876729581,
[[11,"MoneyCountdown2"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xf17a849474e4c,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,8201760375228822,[[0,[4,[20,85,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,90]]],[0,[5,[20,85,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,50]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,5357801916658899,
[[11,"MoneyCountdown2"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,4802902824652777,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,9567517453225862,[[0,[5,[20,85,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,120]]],[0,[5,[20,85,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,80]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,7864121052680517,
[[11,"MoneyCountdown2"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,4641938165654292,[[4,57],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[57,cr.plugins_.Sprite.prototype.acts.SetPos,null,6965808782061198,[[0,[4,[20,85,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,120]]],[0,[5,[20,85,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,80]]]]],[-1,cr.system_object.prototype.acts.AddVar,null,4673559264262275,
[[11,"MoneyCountdown2"],[7,[0,1]]]],[57,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,0x65836481839d]]]]]]],[0,[!0,"SpawnEnemys"],!1,6168974939670394,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6168974939670394,[[1,[2,"SpawnEnemys"]]]]],[],[[0,[!0,"Enemy1Spawn"],!1,6363718854834639,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6363718854834639,[[1,[2,"Enemy1Spawn"]]]]],[],[[0,null,!1,918540461221642,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,
!1,!1,53911726720098,[[0,[19,cr.system_object.prototype.exps.random,[[0,8],[0,10]]]]]],[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,8254573177132982,[[4,82]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9974790194628572,[[11,"Special1Countdown"],[8,3],[7,[0,0]]]]],[],[[0,null,!1,0xe155f44b081d8,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8419059321753981,[[10,0],[8,0],[7,[2,"Sp1"]]]],[23,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!0,!1,0xa277702f19f62],[23,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,0x89398d1d7f609,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x6baa5c8f8f45,[[4,7],[5,[0,6]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[7,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5674638636757654,[[4,23],[7,[0,3]]]],[-1,cr.system_object.prototype.acts.AddVar,null,868819699317756,[[11,"Special1Countdown"],
[7,[0,1]]]],[7,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,92689600151678]]]]]]],[0,[!0,"Enemy2Spawn"],!1,7118798193900059,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7118798193900059,[[1,[2,"Enemy2Spawn"]]]]],[],[[0,null,!1,918540461221642,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,53911726720098,[[0,[19,cr.system_object.prototype.exps.random,[[0,8],[0,10]]]]]],[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,8254573177132982,[[4,82]]],[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,9974790194628572,[[11,"Special2Countdown"],[8,3],[7,[0,0]]]]],[],[[0,null,!1,0xe155f44b081d8,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8419059321753981,[[10,0],[8,0],[7,[2,"Sp2"]]]],[23,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0xa277702f19f62],[23,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,0x89398d1d7f609,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x6baa5c8f8f45,[[4,9],[5,[0,6]],[0,[20,
82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[9,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5674638636757654,[[4,23],[7,[0,3]]]],[-1,cr.system_object.prototype.acts.AddVar,null,868819699317756,[[11,"Special2Countdown"],[7,[0,1]]]],[9,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,92689600151678]]]]]]],[0,[!0,"Enemy3Spawn"],!1,9956274500804520,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,9956274500804520,
[[1,[2,"Enemy3Spawn"]]]]],[],[[0,null,!1,918540461221642,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,53911726720098,[[0,[19,cr.system_object.prototype.exps.random,[[0,8],[0,10]]]]]],[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,8254573177132982,[[4,82]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9974790194628572,[[11,"Special3Countdown"],[8,3],[7,[0,0]]]]],[],[[0,null,!1,0xe155f44b081d8,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,
0,!1,!1,!1,8419059321753981,[[10,0],[8,0],[7,[2,"Sp3"]]]],[23,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0xa277702f19f62],[23,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,0x89398d1d7f609,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x6baa5c8f8f45,[[4,11],[5,[0,6]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[11,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5674638636757654,
[[4,23],[7,[0,3]]]],[-1,cr.system_object.prototype.acts.AddVar,null,868819699317756,[[11,"Special3Countdown"],[7,[0,1]]]],[11,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,92689600151678]]]]]]],[0,[!0,"Enemy4Spawn"],!1,7439795089896491,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7439795089896491,[[1,[2,"Enemy4Spawn"]]]]],[],[[0,null,!1,918540461221642,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,53911726720098,[[0,[19,cr.system_object.prototype.exps.random,
[[0,8],[0,10]]]]]],[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,8254573177132982,[[4,82]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9974790194628572,[[11,"Special4Countdown"],[8,3],[7,[0,0]]]]],[],[[0,null,!1,0xe155f44b081d8,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8419059321753981,[[10,0],[8,0],[7,[2,"Sp4"]]]],[23,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0xa277702f19f62],[23,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,
null,0,!1,!1,!0,0x89398d1d7f609,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x6baa5c8f8f45,[[4,13],[5,[0,6]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[13,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5674638636757654,[[4,23],[7,[0,3]]]],[-1,cr.system_object.prototype.acts.AddVar,null,868819699317756,[[11,"Special4Countdown"],[7,[0,1]]]],[13,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,92689600151678]]]]]]],
[0,[!0,"RoachSpawn"],!1,5304105162021308,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,5304105162021308,[[1,[2,"RoachSpawn"]]]]],[],[[0,null,!1,918540461221642,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,53911726720098,[[0,[19,cr.system_object.prototype.exps.random,[[0,3],[0,5]]]]]],[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,8254573177132982,[[4,82]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9974790194628572,[[11,"Roach"],
[8,3],[7,[0,0]]]]],[],[[0,null,!1,0xe155f44b081d8,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8419059321753981,[[10,0],[8,0],[7,[2,"EnemyRoach"]]]],[85,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0xa277702f19f62],[85,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,0x89398d1d7f609,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x6baa5c8f8f45,[[4,61],[5,[0,6]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,
[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[61,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5674638636757654,[[4,85],[7,[0,3]]]],[-1,cr.system_object.prototype.acts.AddVar,null,868819699317756,[[11,"Roach"],[7,[0,1]]]],[61,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,92689600151678]]]]]]],[0,[!0,"SlizenSpawn"],!1,470018082910547,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,470018082910547,[[1,[2,"SlizenSpawn"]]]]],[],[[0,null,!1,918540461221642,[[-1,
cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,53911726720098,[[0,[19,cr.system_object.prototype.exps.random,[[0,7],[0,9]]]]]],[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,8254573177132982,[[4,82]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9974790194628572,[[11,"Slizen"],[8,3],[7,[0,0]]]]],[],[[0,null,!1,0xe155f44b081d8,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8419059321753981,[[10,0],[8,0],[7,[2,"EnemySlizen"]]]],[85,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!0,!1,0xa277702f19f62],[85,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,0x89398d1d7f609,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x6baa5c8f8f45,[[4,76],[5,[0,6]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[76,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5674638636757654,[[4,85],[7,[0,4]]]],[-1,cr.system_object.prototype.acts.AddVar,null,868819699317756,[[11,"Slizen"],
[7,[0,1]]]],[76,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,92689600151678]]]]]]],[0,[!0,"KaktusSpawn"],!1,0x76eb9b416565b,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x76eb9b416565b,[[1,[2,"KaktusSpawn"]]]]],[],[[0,null,!1,918540461221642,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,53911726720098,[[0,[19,cr.system_object.prototype.exps.random,[[0,6],[0,7]]]]]],[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,8254573177132982,[[4,82]]],[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,9974790194628572,[[11,"Kaktus"],[8,3],[7,[0,0]]]]],[],[[0,null,!1,0xe155f44b081d8,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8419059321753981,[[10,0],[8,0],[7,[2,"EnemyKaktus"]]]],[23,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0xa277702f19f62],[23,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,0x89398d1d7f609,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x6baa5c8f8f45,[[4,44],[5,[0,6]],[0,[20,82,
cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[44,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5674638636757654,[[4,23],[7,[0,4]]]],[-1,cr.system_object.prototype.acts.AddVar,null,868819699317756,[[11,"Kaktus"],[7,[0,1]]]],[44,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,92689600151678]]]]]]],[0,[!0,"BooSpawn"],!1,7309518534036934,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7309518534036934,[[1,[2,"BooSpawn"]]]]],
[],[[0,null,!1,918540461221642,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,53911726720098,[[0,[19,cr.system_object.prototype.exps.random,[[0,3],[0,7]]]]]],[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,8254573177132982,[[4,82]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9974790194628572,[[11,"Boo"],[8,3],[7,[0,0]]]]],[],[[0,null,!1,0xe155f44b081d8,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8419059321753981,[[10,0],[8,
0],[7,[2,"EnemyBoo"]]]],[23,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0xa277702f19f62],[23,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,0x89398d1d7f609,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x6baa5c8f8f45,[[4,49],[5,[0,6]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[49,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5674638636757654,[[4,23],[7,[0,6]]]],[-1,
cr.system_object.prototype.acts.AddVar,null,868819699317756,[[11,"Boo"],[7,[0,1]]]],[49,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,92689600151678]]]]]]],[0,[!0,"DragonSpawn"],!1,0x4219137ed46bf,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x4219137ed46bf,[[1,[2,"DragonSpawn"]]]]],[],[[0,null,!1,918540461221642,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,53911726720098,[[0,[19,cr.system_object.prototype.exps.random,[[0,4],[0,12]]]]]],[-1,cr.system_object.prototype.cnds.ForEach,
null,0,!0,!1,!1,8254573177132982,[[4,82]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9974790194628572,[[11,"Dragon"],[8,3],[7,[0,0]]]]],[],[[0,null,!1,0xe155f44b081d8,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8419059321753981,[[10,0],[8,0],[7,[2,"EnemyDragon"]]]],[85,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0xa277702f19f62],[85,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,0x89398d1d7f609,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,
null,0x6baa5c8f8f45,[[4,47],[5,[0,6]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[47,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5674638636757654,[[4,85],[7,[0,5]]]],[-1,cr.system_object.prototype.acts.AddVar,null,868819699317756,[[11,"Dragon"],[7,[0,1]]]],[47,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,92689600151678]]]]]]],[0,[!0,"HahaSpawn"],!1,0xc1fc53839cce6,[[-1,cr.system_object.prototype.cnds.IsGroupActive,
null,0,!1,!1,!1,0xc1fc53839cce6,[[1,[2,"HahaSpawn"]]]]],[],[[0,null,!1,918540461221642,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,53911726720098,[[0,[19,cr.system_object.prototype.exps.random,[[0,4],[0,12]]]]]],[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,8254573177132982,[[4,82]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9974790194628572,[[11,"Haha"],[8,3],[7,[0,0]]]]],[],[[0,null,!1,0xe155f44b081d8,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,
null,0,!1,!1,!1,8419059321753981,[[10,0],[8,0],[7,[2,"EnemyHaha"]]]],[85,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0xa277702f19f62],[85,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,0x89398d1d7f609,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x6baa5c8f8f45,[[4,67],[5,[0,4]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[67,cr.plugins_.Sprite.prototype.acts.SetPosToObject,
null,5674638636757654,[[4,85],[7,[0,5]]]],[-1,cr.system_object.prototype.acts.AddVar,null,868819699317756,[[11,"Haha"],[7,[0,1]]]],[67,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,92689600151678]]]]]]],[0,[!0,"RobotSpawn"],!1,0xd2c69db650c01,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xd2c69db650c01,[[1,[2,"RobotSpawn"]]]]],[],[[0,null,!1,918540461221642,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,53911726720098,[[0,[19,cr.system_object.prototype.exps.random,
[[0,4],[0,12]]]]]],[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,8254573177132982,[[4,82]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9974790194628572,[[11,"Robot"],[8,3],[7,[0,0]]]]],[],[[0,null,!1,0xe155f44b081d8,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8419059321753981,[[10,0],[8,0],[7,[2,"EnemyRobot"]]]],[85,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0xa277702f19f62],[85,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,
null,0,!1,!1,!0,0x89398d1d7f609,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x6baa5c8f8f45,[[4,74],[5,[0,6]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[74,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5674638636757654,[[4,85],[7,[0,4]]]],[-1,cr.system_object.prototype.acts.AddVar,null,868819699317756,[[11,"Robot"],[7,[0,1]]]],[74,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,92689600151678]]]]]]],
[0,[!0,"HypnoSpawn"],!1,0xa37fe81f232ff,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xa37fe81f232ff,[[1,[2,"HypnoSpawn"]]]]],[],[[0,null,!1,918540461221642,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,53911726720098,[[0,[19,cr.system_object.prototype.exps.random,[[0,4],[0,12]]]]]],[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,8254573177132982,[[4,82]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9974790194628572,[[11,"Hypno"],[8,
3],[7,[0,0]]]]],[],[[0,null,!1,0xe155f44b081d8,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8419059321753981,[[10,0],[8,0],[7,[2,"EnemyHypno"]]]],[85,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0xa277702f19f62],[85,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,0x89398d1d7f609,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x6baa5c8f8f45,[[4,65],[5,[0,6]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,
82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[65,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5674638636757654,[[4,85],[7,[0,5]]]],[-1,cr.system_object.prototype.acts.AddVar,null,868819699317756,[[11,"Hypno"],[7,[0,1]]]],[65,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,92689600151678]]]]]]],[0,[!0,"SmokeSpawn"],!1,6697838237604594,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6697838237604594,[[1,[2,"SmokeSpawn"]]]]],[],[[0,null,!1,918540461221642,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,53911726720098,[[0,[19,cr.system_object.prototype.exps.random,[[0,4],[0,12]]]]]],[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,8254573177132982,[[4,82]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9974790194628572,[[11,"Smoke"],[8,3],[7,[0,0]]]]],[],[[0,null,!1,0xe155f44b081d8,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8419059321753981,[[10,0],[8,0],[7,[2,"EnemySmoke"]]]],[23,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!0,!1,0xa277702f19f62],[23,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,0x89398d1d7f609,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x6baa5c8f8f45,[[4,68],[5,[0,6]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[68,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5674638636757654,[[4,23],[7,[0,5]]]],[-1,cr.system_object.prototype.acts.AddVar,null,868819699317756,[[11,"Smoke"],
[7,[0,1]]]],[68,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,92689600151678],[-1,cr.system_object.prototype.acts.CreateObject,null,6016494267484467,[[4,69],[5,[0,4]],[0,[20,68,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,68,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]]]]]],[0,[!0,"AlienSpawn"],!1,0xee874e6fbf683,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xee874e6fbf683,[[1,[2,"AlienSpawn"]]]]],[],[[0,null,!1,918540461221642,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,53911726720098,[[0,[19,cr.system_object.prototype.exps.random,[[0,4],[0,12]]]]]],[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,8254573177132982,[[4,82]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9974790194628572,[[11,"Alien"],[8,3],[7,[0,0]]]]],[],[[0,null,!1,0xe155f44b081d8,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8419059321753981,[[10,0],[8,0],[7,[2,"EnemyAlien"]]]],[23,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!0,!1,0xa277702f19f62],[23,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,0x89398d1d7f609,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x6baa5c8f8f45,[[4,72],[5,[0,6]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[72,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5674638636757654,[[4,23],[7,[0,5]]]],[-1,cr.system_object.prototype.acts.AddVar,null,868819699317756,[[11,"Alien"],
[7,[0,1]]]],[72,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,92689600151678],[-1,cr.system_object.prototype.acts.CreateObject,null,6082434660450516,[[4,73],[5,[0,4]],[0,[20,72,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,72,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]]]]]],[0,[!0,"GhostSpawn"],!1,0xc2465a13b3c57,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xc2465a13b3c57,[[1,[2,"GhostSpawn"]]]]],[],[[0,null,!1,918540461221642,[[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,53911726720098,[[0,[19,cr.system_object.prototype.exps.random,[[0,4],[0,12]]]]]],[-1,cr.system_object.prototype.cnds.ForEach,null,0,!0,!1,!1,8254573177132982,[[4,82]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9974790194628572,[[11,"Ghost"],[8,3],[7,[0,0]]]]],[],[[0,null,!1,0xe155f44b081d8,[[82,cr.plugins_.TiledBg.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,8419059321753981,[[10,0],[8,0],[7,[2,"EnemyGhost"]]]],[23,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!0,!1,0xa277702f19f62],[23,cr.plugins_.Sprite.prototype.cnds.PickTopBottom,null,0,!1,!1,!0,0x89398d1d7f609,[[3,0]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x6baa5c8f8f45,[[4,64],[5,[0,6]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.X,!1,null]],[0,[20,82,cr.plugins_.TiledBg.prototype.exps.Y,!1,null]]]],[64,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5674638636757654,[[4,23],[7,[0,5]]]],[-1,cr.system_object.prototype.acts.AddVar,null,868819699317756,[[11,"Ghost"],
[7,[0,1]]]],[64,cr.plugins_.Sprite.prototype.acts.MoveToTop,null,92689600151678]]]]]]]]],[0,[!0,"Delet all"],!1,4531537275093182,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,4531537275093182,[[1,[2,"Delet all"]]]]],[],[[0,[!0,"Enemy1Del"],!1,7468750493100034,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7468750493100034,[[1,[2,"Enemy1Del"]]]]],[],[[0,null,!1,0x4496f91bb17c2,[[7,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,7448131367106039,[[8,
5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[7,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,9781992125540444]],[[7,cr.plugins_.Sprite.prototype.acts.Destroy,null,4782153197898436],[-1,cr.system_object.prototype.acts.SetVar,null,5899473224556644,[[11,"Special1Countdown"],[7,[0,0]]]]]],[0,null,!1,0xb5712d1f1f4f,[[8,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,5785870624875262,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],
[0,400]]]]],[8,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0x56c6a3742a7be]],[[8,cr.plugins_.Sprite.prototype.acts.Destroy,null,9172406114969744],[-1,cr.system_object.prototype.acts.SetVar,null,451556188686399,[[11,"Special1Countdown"],[7,[0,0]]]]]]]],[0,[!0,"Enemy2Del"],!1,0xc5d45067c24bf,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xc5d45067c24bf,[[1,[2,"Enemy2Del"]]]]],[],[[0,null,!1,0x4496f91bb17c2,[[9,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,
!1,!1,7448131367106039,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[9,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,9781992125540444]],[[9,cr.plugins_.Sprite.prototype.acts.Destroy,null,4782153197898436],[-1,cr.system_object.prototype.acts.SetVar,null,5899473224556644,[[11,"Special2Countdown"],[7,[0,0]]]]]],[0,null,!1,0xb5712d1f1f4f,[[10,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,5785870624875262,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,
!1,null],[0,400]]]]],[10,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0x56c6a3742a7be]],[[10,cr.plugins_.Sprite.prototype.acts.Destroy,null,9172406114969744],[-1,cr.system_object.prototype.acts.SetVar,null,451556188686399,[[11,"Special2Countdown"],[7,[0,0]]]]]]]],[0,[!0,"Enemy3Del"],!1,575037785771093,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,575037785771093,[[1,[2,"Enemy3Del"]]]]],[],[[0,null,!1,0x4496f91bb17c2,[[11,cr.plugins_.Sprite.prototype.cnds.CompareY,
null,0,!1,!1,!1,7448131367106039,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[11,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,9781992125540444]],[[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,4782153197898436],[-1,cr.system_object.prototype.acts.SetVar,null,5899473224556644,[[11,"Special3Countdown"],[7,[0,0]]]]]],[0,null,!1,0xb5712d1f1f4f,[[12,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,5785870624875262,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,
!1,null],[0,400]]]]],[12,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0x56c6a3742a7be]],[[12,cr.plugins_.Sprite.prototype.acts.Destroy,null,9172406114969744],[-1,cr.system_object.prototype.acts.SetVar,null,451556188686399,[[11,"Special3Countdown"],[7,[0,0]]]]]]]],[0,[!0,"Enemy4Del"],!1,8572657093567043,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8572657093567043,[[1,[2,"Enemy4Del"]]]]],[],[[0,null,!1,0x4496f91bb17c2,[[13,cr.plugins_.Sprite.prototype.cnds.CompareY,
null,0,!1,!1,!1,7448131367106039,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[13,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,9781992125540444]],[[13,cr.plugins_.Sprite.prototype.acts.Destroy,null,4782153197898436],[-1,cr.system_object.prototype.acts.SetVar,null,5899473224556644,[[11,"Special4Countdown"],[7,[0,0]]]]]],[0,null,!1,0xb5712d1f1f4f,[[14,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,5785870624875262,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,
!1,null],[0,400]]]]],[14,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0x56c6a3742a7be]],[[14,cr.plugins_.Sprite.prototype.acts.Destroy,null,9172406114969744],[-1,cr.system_object.prototype.acts.SetVar,null,451556188686399,[[11,"Special4Countdown"],[7,[0,0]]]]]]]],[0,[!0,"RoachDel"],!1,8868259887305121,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8868259887305121,[[1,[2,"RoachDel"]]]]],[],[[0,null,!1,0x4496f91bb17c2,[[61,cr.plugins_.Sprite.prototype.cnds.CompareY,
null,0,!1,!1,!1,7448131367106039,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[61,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,9781992125540444]],[[61,cr.plugins_.Sprite.prototype.acts.Destroy,null,4782153197898436],[-1,cr.system_object.prototype.acts.SetVar,null,5899473224556644,[[11,"Roach"],[7,[0,0]]]]]],[0,null,!1,0xb5712d1f1f4f,[[62,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,5785870624875262,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,
!1,null],[0,400]]]]],[62,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0x56c6a3742a7be]],[[62,cr.plugins_.Sprite.prototype.acts.Destroy,null,9172406114969744]]]]],[0,[!0,"SlizenDel"],!1,4762594270738961,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,4762594270738961,[[1,[2,"SlizenDel"]]]]],[],[[0,null,!1,0x4496f91bb17c2,[[76,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,7448131367106039,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],
[0,400]]]]],[76,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,9781992125540444]],[[76,cr.plugins_.Sprite.prototype.acts.Destroy,null,4782153197898436],[-1,cr.system_object.prototype.acts.SetVar,null,5899473224556644,[[11,"Slizen"],[7,[0,0]]]]]],[0,null,!1,0xb5712d1f1f4f,[[77,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,5785870624875262,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[77,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,
!0,!1,0x56c6a3742a7be]],[[77,cr.plugins_.Sprite.prototype.acts.Destroy,null,9172406114969744]]]]],[0,[!0,"KaktusDel"],!1,4862267364300339,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,4862267364300339,[[1,[2,"KaktusDel"]]]]],[],[[0,null,!1,0x4496f91bb17c2,[[44,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,7448131367106039,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[44,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,9781992125540444]],
[[44,cr.plugins_.Sprite.prototype.acts.Destroy,null,4782153197898436],[-1,cr.system_object.prototype.acts.SetVar,null,5899473224556644,[[11,"Kaktus"],[7,[0,0]]]]]],[0,null,!1,0xb5712d1f1f4f,[[46,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,5785870624875262,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[46,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0x56c6a3742a7be]],[[46,cr.plugins_.Sprite.prototype.acts.Destroy,null,9172406114969744]]],
[0,null,!1,7157957918697568,[[45,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,0x8ab30df85db39,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[45,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0x87977332bd951]],[[45,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x61d069c0ef610]]]]],[0,[!0,"BooDel"],!1,0x91c6ef61c9cfb,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x91c6ef61c9cfb,[[1,[2,"BooDel"]]]]],[],[[0,null,!1,0x4496f91bb17c2,
[[49,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,7448131367106039,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[49,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,9781992125540444]],[[49,cr.plugins_.Sprite.prototype.acts.Destroy,null,4782153197898436],[-1,cr.system_object.prototype.acts.SetVar,null,5899473224556644,[[11,"Boo"],[7,[0,0]]]]]],[0,null,!1,0xb5712d1f1f4f,[[63,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,5785870624875262,
[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[63,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0x56c6a3742a7be]],[[63,cr.plugins_.Sprite.prototype.acts.Destroy,null,9172406114969744]]]]],[0,[!0,"DragonDel"],!1,0x743837c125c39,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x743837c125c39,[[1,[2,"DragonDel"]]]]],[],[[0,null,!1,0x4496f91bb17c2,[[47,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,7448131367106039,[[8,5],[0,
[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[47,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,9781992125540444]],[[47,cr.plugins_.Sprite.prototype.acts.Destroy,null,4782153197898436],[-1,cr.system_object.prototype.acts.SetVar,null,5899473224556644,[[11,"Dragon"],[7,[0,0]]]]]],[0,null,!1,0xb5712d1f1f4f,[[63,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,5785870624875262,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[63,
cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0x56c6a3742a7be]],[[63,cr.plugins_.Sprite.prototype.acts.Destroy,null,9172406114969744]]]]],[0,[!0,"HahaDel"],!1,9101415842598778,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,9101415842598778,[[1,[2,"HahaDel"]]]]],[],[[0,null,!1,0x4496f91bb17c2,[[67,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,7448131367106039,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[67,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!0,!1,9781992125540444]],[[67,cr.plugins_.Sprite.prototype.acts.Destroy,null,4782153197898436],[-1,cr.system_object.prototype.acts.SetVar,null,5899473224556644,[[11,"Haha"],[7,[0,0]]]]]]]],[0,[!0,"RobotDel"],!1,0xc28e1cb67f812,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xc28e1cb67f812,[[1,[2,"RobotDel"]]]]],[],[[0,null,!1,0x4496f91bb17c2,[[74,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,7448131367106039,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,
!1,null],[0,400]]]]],[74,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,9781992125540444]],[[74,cr.plugins_.Sprite.prototype.acts.Destroy,null,4782153197898436],[-1,cr.system_object.prototype.acts.SetVar,null,5899473224556644,[[11,"Robot"],[7,[0,0]]]]]],[0,null,!1,0xb5712d1f1f4f,[[75,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,5785870624875262,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[75,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!0,!1,0x56c6a3742a7be]],[[75,cr.plugins_.Sprite.prototype.acts.Destroy,null,9172406114969744]]]]],[0,[!0,"HypnoDel"],!1,5979220677811872,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,5979220677811872,[[1,[2,"HypnoDel"]]]]],[],[[0,null,!1,0x4496f91bb17c2,[[65,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,7448131367106039,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[65,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,
!0,!1,9781992125540444]],[[65,cr.plugins_.Sprite.prototype.acts.Destroy,null,4782153197898436],[-1,cr.system_object.prototype.acts.SetVar,null,5899473224556644,[[11,"Hypno"],[7,[0,0]]]]]],[0,null,!1,5905768518711013,[[66,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,8330409061143925,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[66,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,4963044067752409]],[[66,cr.plugins_.Sprite.prototype.acts.Destroy,
null,0xae8ca066d7f]]]]],[0,[!0,"SmokeDel"],!1,9935285650555104,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,9935285650555104,[[1,[2,"SmokeDel"]]]]],[],[[0,null,!1,0x4496f91bb17c2,[[68,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,7448131367106039,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[68,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,9781992125540444]],[[68,cr.plugins_.Sprite.prototype.acts.Destroy,null,4782153197898436],
[-1,cr.system_object.prototype.acts.SetVar,null,5899473224556644,[[11,"Smoke"],[7,[0,0]]]]]],[0,null,!1,5905768518711013,[[70,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,8330409061143925,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[70,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,4963044067752409]],[[70,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xae8ca066d7f]]],[0,null,!1,6572253458389065,[[71,cr.plugins_.Sprite.prototype.cnds.CompareY,
null,0,!1,!1,!1,0x4c41b6c14349c,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[71,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0x87ecf1fefb809]],[[71,cr.plugins_.Sprite.prototype.acts.Destroy,null,9668466937635816]]]]],[0,[!0,"GhostDel"],!1,9799333999086856,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,9799333999086856,[[1,[2,"GhostDel"]]]]],[],[[0,null,!1,0x4496f91bb17c2,[[64,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,
!1,!1,7448131367106039,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[64,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,9781992125540444]],[[64,cr.plugins_.Sprite.prototype.acts.Destroy,null,4782153197898436],[-1,cr.system_object.prototype.acts.SetVar,null,5899473224556644,[[11,"Ghost"],[7,[0,0]]]]]]]],[0,[!0,"AlienDel"],!1,8656894379994764,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8656894379994764,[[1,[2,"AlienDel"]]]]],[],[[0,
null,!1,0x4496f91bb17c2,[[72,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,7448131367106039,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[72,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,9781992125540444]],[[72,cr.plugins_.Sprite.prototype.acts.Destroy,null,4782153197898436],[-1,cr.system_object.prototype.acts.SetVar,null,5899473224556644,[[11,"Alien"],[7,[0,0]]]]]],[0,null,!1,5905768518711013,[[73,cr.plugins_.Sprite.prototype.cnds.CompareY,
null,0,!1,!1,!1,8330409061143925,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[73,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,4963044067752409]],[[73,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xae8ca066d7f]]]]],[0,null,!1,8824981023362899,[[83,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,0xe446af11dcd6c,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[83,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,
0,!1,!0,!1,0x3ec6fedb69c6a]],[[83,cr.plugins_.Sprite.prototype.acts.Destroy,null,7147107604461834]]],[0,null,!1,0x9f87b92c18398,[[86,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,6275679428015962,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[86,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,0xa94cba59dfee2]],[[86,cr.plugins_.Sprite.prototype.acts.Destroy,null,5248957635530906]]],[0,null,!1,5121268073462168,[[87,cr.plugins_.Sprite.prototype.cnds.CompareY,
null,0,!1,!1,!1,8259961622373893,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[87,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,6249499957058195]],[[87,cr.plugins_.Sprite.prototype.acts.Destroy,null,9726842300266756]]],[0,null,!1,6996614458223029,[[88,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,0x4dc7cc986cd75,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[88,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,
0,!1,!0,!1,0xb09d5ddb6e628]],[[88,cr.plugins_.Sprite.prototype.acts.Destroy,null,8100300279429326]]],[0,null,!1,0x72861a997058e,[[57,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,5015026302121289,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[57,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,5787677124567824]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,6258278023576967]]],[0,null,!1,6601127934650684,[[57,cr.plugins_.Sprite.prototype.cnds.CompareY,
null,0,!1,!1,!1,8683410389136645,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[57,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!0,!1,5290067402577855]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xf9894353ef3d]]],[0,null,!1,5365138647081446,[[89,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,6350647043343779,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[89,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
null,0,!1,!1,!1,4541758494339657,[[10,0],[8,0],[7,[2,"raz"]]]]],[[89,cr.plugins_.Sprite.prototype.acts.Destroy,null,4996228854769911],[-1,cr.system_object.prototype.acts.SetVar,null,0xcf7fd6e5aebf6,[[11,"MoneyCountdown"],[7,[0,0]]]]]],[0,null,!1,5122052170909919,[[89,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,8584176068668386,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[89,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,5352202081598384,
[[10,0],[8,0],[7,[2,"dva"]]]]],[[89,cr.plugins_.Sprite.prototype.acts.Destroy,null,8336591916376548],[-1,cr.system_object.prototype.acts.SetVar,null,6395503664543236,[[11,"MoneyCountdown2"],[7,[0,0]]]]]]]],[0,null,!1,8219909209034756,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,9573716779091936]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,5189501927365355],[89,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc763437122845],[86,cr.plugins_.Sprite.prototype.acts.Destroy,
null,9554230962617668],[87,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x6becf6e81968b],[88,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x94c4801ec2ad9],[83,cr.plugins_.Sprite.prototype.acts.Destroy,null,4669828680169965]]]]],["Generalcode",[[1,"Ballss",0,0,!1,!1,5123204895174198],[1,"BulletValue",0,0,!1,!1,0xfc7277fba1edc],[1,"Catapult",0,0,!1,!1,4631145046363979],[1,"EnergyValue",0,0,!1,!1,471893984120763],[1,"chooser",0,1,!1,!1,8244590125763229],[1,"currentlevel",0,1,!1,!1,6736228810148965],
[1,"win",0,0,!1,!1,320716225111095],[1,"Lifes",0,1,!1,!1,0xf202f795ac531],[1,"Countdown",0,0,!1,!1,8088511866304602],[1,"Accleration",0,200,!1,!1,0x6742f48bee8ff],[1,"Money",0,0,!1,!1,8514366386206111],[1,"Moneybuffer",0,0,!1,!1,0x5307a509dde27],[0,null,!1,7706150916812718,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,7567274260547212]],[[-1,cr.system_object.prototype.acts.Wait,null,6813516749122481,[[0,[1,0.1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,4701492366686739,
[[11,"Ballss"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xd08ad8b7fdc12,[[0,[1,0.1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x672fa82d4b4df,[[11,"Ballss"],[7,[0,2]]]],[-1,cr.system_object.prototype.acts.Wait,null,7639188955050446,[[0,[1,0.1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,7664252130680023,[[11,"Ballss"],[7,[0,3]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x52d7fb6986a7f,[[0,[1,0.1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xe36e61b829b73,
[[11,"Ballss"],[7,[0,4]]]]]],[0,null,!1,7895599536922156,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x55edb68f38275]],[[2,cr.plugins_.Text.prototype.acts.SetText,null,971361352152448,[[7,[19,cr.system_object.prototype.exps.fps]]]]]],[0,null,!1,6542766770443448,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xd98b1ddb3f7fa,[[0,[1,0.2]]]]],[[121,cr.plugins_.Text.prototype.acts.SetText,null,0x996888b4b9e97,[[7,[10,[19,cr.system_object.prototype.exps["int"],[[19,cr.system_object.prototype.exps.viewporttop,
[[0,6]]]]],[2,"  m. left"]]]]]]],[0,[!0,"BallsCatapult"],!1,0x623543e98df75,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x623543e98df75,[[1,[2,"BallsCatapult"]]]]],[],[[0,null,!1,8912349524687672,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6286003702964865,[[11,"Ballss"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.TriggerOnce,null,0,!1,!1,!1,5637855234283711]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xed8e440dedb5b,[[4,241],[5,[0,
10]],[0,[20,238,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,238,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,60]]]]]]],[0,null,!1,8957704877635785,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xc5278c15c80e8,[[11,"Ballss"],[8,0],[7,[0,2]]]],[-1,cr.system_object.prototype.cnds.TriggerOnce,null,0,!1,!1,!1,659975703605911]],[[-1,cr.system_object.prototype.acts.CreateObject,null,9848979761825632,[[4,243],[5,[0,10]],[0,[20,238,cr.plugins_.Sprite.prototype.exps.X,!1,null]],
[0,[5,[20,238,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,120]]]]]]],[0,null,!1,7056880899290399,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,886239565013014,[[11,"Ballss"],[8,0],[7,[0,3]]]],[-1,cr.system_object.prototype.cnds.TriggerOnce,null,0,!1,!1,!1,6630888686474012]],[[-1,cr.system_object.prototype.acts.CreateObject,null,7364297601853129,[[4,244],[5,[0,10]],[0,[20,238,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,238,cr.plugins_.Sprite.prototype.exps.Y,!1,null],
[0,180]]]]]]],[0,null,!1,7293641111452968,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8550283133240844,[[11,"Ballss"],[8,0],[7,[0,4]]]],[-1,cr.system_object.prototype.cnds.TriggerOnce,null,0,!1,!1,!1,5049538682379029]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x9b7b05dcc8dc0,[[4,245],[5,[0,10]],[0,[20,238,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,238,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,240]]]]]]],[0,null,!1,9327797698425948,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,8609637485297537,[[11,"Ballss"],[8,0],[7,[0,5]]]],[-1,cr.system_object.prototype.cnds.TriggerOnce,null,0,!1,!1,!1,5046647960528543]],[[-1,cr.system_object.prototype.acts.CreateObject,null,9919633325473676,[[4,246],[5,[0,10]],[0,[20,238,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,238,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,300]]]]]]],[0,null,!1,5884195672010842,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9954613349364016,[[11,"Ballss"],[8,0],
[7,[0,6]]]],[-1,cr.system_object.prototype.cnds.TriggerOnce,null,0,!1,!1,!1,0x7f14c78b72b88]],[[-1,cr.system_object.prototype.acts.CreateObject,null,7185907360933747,[[4,247],[5,[0,10]],[0,[20,238,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,238,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,360]]]]]]],[0,null,!1,6042839117399706,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5741064167898416,[[11,"Ballss"],[8,0],[7,[0,7]]]],[-1,cr.system_object.prototype.cnds.TriggerOnce,
null,0,!1,!1,!1,5679357695381705]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xfecd2c47820df,[[4,248],[5,[0,10]],[0,[20,238,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,238,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,420]]]]]]],[0,null,!1,0xf483c25c95ec8,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xe6d4bc481422c,[[11,"Ballss"],[8,0],[7,[0,8]]]],[-1,cr.system_object.prototype.cnds.TriggerOnce,null,0,!1,!1,!1,4907565652688478]],[[-1,cr.system_object.prototype.acts.CreateObject,
null,6751030341886357,[[4,249],[5,[0,10]],[0,[20,238,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,238,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,480]]]]]]],[0,null,!1,5295863926235343,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,819938285768273,[[11,"Ballss"],[8,0],[7,[0,9]]]],[-1,cr.system_object.prototype.cnds.TriggerOnce,null,0,!1,!1,!1,0xd36946b68f6a3]],[[-1,cr.system_object.prototype.acts.CreateObject,null,7054538875331061,[[4,250],[5,[0,10]],[0,[20,238,cr.plugins_.Sprite.prototype.exps.X,
!1,null]],[0,[5,[20,238,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,540]]]]]]],[0,null,!1,0x7b9da2bcfc762,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x506b35883849f,[[11,"Ballss"],[8,0],[7,[0,10]]]],[-1,cr.system_object.prototype.cnds.TriggerOnce,null,0,!1,!1,!1,0xcb304e80d5797]],[[-1,cr.system_object.prototype.acts.CreateObject,null,9250890947166418,[[4,251],[5,[0,10]],[0,[20,238,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,238,cr.plugins_.Sprite.prototype.exps.Y,
!1,null],[0,600]]]]]]],[0,null,!1,7188408937043878,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,4818796796684042,[[11,"Ballss"],[8,3],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,5801789062796618,[[1,[2,"Catapult"]],[3,0]]]]],[0,null,!1,8924591784447006,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,4907259261317385,[[11,"Ballss"],[8,4],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,6893795152320628,[[1,[2,"Catapult"]],
[3,1]]]]]]],[0,[!0,"Catapult"],!1,9293948888015492,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,9293948888015492,[[1,[2,"Catapult"]]]]],[],[[0,null,!1,0x9a91fd402f051,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,7309573846436891,[[4,20]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8538538101761766,[[11,"BulletValue"],[8,3],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7734270145759539,[[11,"Catapult"],
[8,3],[7,[0,0]]]]],[[144,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xf472cb541225d],[-1,cr.system_object.prototype.acts.CreateObject,null,0x96d139fcee487,[[4,144],[5,[0,6]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,7193619897036523,[[4,145],[5,[0,6]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xf8d24d2472c5a,[[11,"BulletValue"],[7,[0,1]]]],[-1,
cr.system_object.prototype.acts.SetGroupActive,null,0x65a33581e23c7,[[1,[2,"acell"]],[3,0]]],[20,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",0x4d556861f975f,[[3,0]]]]],[0,null,!1,4576534154336011,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,4758332387924312,[[11,"BulletValue"],[8,0],[7,[0,1]]]]],[[144,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xbaa07572dc90d,[[4,20],[7,[0,0]]]],[145,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,6697092418898207,
[[4,20],[7,[0,0]]]]],[[0,null,!1,0xc16372f7593cd,[[16,cr.plugins_.Touch.prototype.cnds.IsInTouch,null,0,!1,!1,!1,0xdbd90f4b0695]],[[144,cr.plugins_.Sprite.prototype.acts.SetAngle,null,9203178280654564,[[0,[19,cr.system_object.prototype.exps.angle,[[20,16,cr.plugins_.Touch.prototype.exps.X,!1,null],[20,16,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[145,cr.plugins_.Sprite.prototype.acts.SetAngle,
null,8959541432737965,[[0,[19,cr.system_object.prototype.exps.angle,[[20,16,cr.plugins_.Touch.prototype.exps.X,!1,null],[20,16,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[144,cr.plugins_.Sprite.prototype.acts.MoveAtAngle,null,585950928888972,[[0,[4,[20,144,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,180]]],[0,[6,[19,cr.system_object.prototype.exps.min,[[7,[19,cr.system_object.prototype.exps.distance,
[[20,16,cr.plugins_.Touch.prototype.exps.X,!1,null],[20,16,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[0,3]],[0,45]]],[1,1.5]]]]],[145,cr.plugins_.Sprite.prototype.acts.MoveAtAngle,null,5554308387957117,[[0,[4,[20,145,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,180]]],[0,[19,cr.system_object.prototype.exps.min,[[7,[3,[19,cr.system_object.prototype.exps.distance,[[20,16,cr.plugins_.Touch.prototype.exps.X,
!1,null],[20,16,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[0,6]],[0,45]]]]]]]],[0,null,!1,780657530498492,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,4848850005126735],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x9212773915da3,[[11,"Ballss"],[8,5],[7,[0,10]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,5972724643374611,[[11,"Ballss"],[7,[0,9]]]],
[251,cr.plugins_.Sprite.prototype.acts.Destroy,null,5616344612223439],[-1,cr.system_object.prototype.acts.SetVar,null,0xf0b10826dcd82,[[11,"Catapult"],[7,[0,1]]]],[145,cr.plugins_.Sprite.prototype.acts.Destroy,null,8429793269135656],[144,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",0x3de6fcf9e0a51,[[0,[7,[19,cr.system_object.prototype.exps.distance,[[20,144,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,144,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,
!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[1,3.8]]],[0,[20,144,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5385303257551759,[[11,"BulletValue"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,6506366673654602,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,9856649646882688,[[1,[2,"acell"]],[3,1]]],[20,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",4520485329811481,[[3,
1]]],[-1,cr.system_object.prototype.acts.Wait,null,6342097236158599,[[0,[0,2]]]],[144,cr.plugins_.Sprite.prototype.acts.Destroy,null,9550279454231596],[-1,cr.system_object.prototype.acts.SetVar,null,0x7b48c36ddcef4,[[11,"Catapult"],[7,[0,0]]]],[144,cr.plugins_.Sprite.prototype.acts.Spawn,null,347275049166007,[[4,60],[5,[0,6]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x879a16ee3b83f,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc9c66de505254]]],[0,null,!1,0x9520cb81f326c,
[[16,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,9898951568233464],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8147431382209457,[[11,"Ballss"],[8,0],[7,[0,9]]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,732426310484427,[[11,"Ballss"],[7,[0,1]]]],[250,cr.plugins_.Sprite.prototype.acts.Destroy,null,5580300022008863],[-1,cr.system_object.prototype.acts.SetVar,null,0x6bf817ac86cc3,[[11,"Catapult"],[7,[0,1]]]],[145,cr.plugins_.Sprite.prototype.acts.Destroy,null,
8700918347484424],[144,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",5532031924189133,[[0,[7,[19,cr.system_object.prototype.exps.distance,[[20,144,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,144,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[1,3.8]]],[0,[20,144,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,
0xa4be98701f49,[[11,"BulletValue"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,6155613995303672,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x7d9d046daddd9,[[1,[2,"acell"]],[3,1]]],[20,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",0x7534ef87152a1,[[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,0xfb42e1d2a723a,[[0,[0,2]]]],[144,cr.plugins_.Sprite.prototype.acts.Destroy,null,7985391645760182],[-1,cr.system_object.prototype.acts.SetVar,null,
6751092699721388,[[11,"Catapult"],[7,[0,0]]]],[144,cr.plugins_.Sprite.prototype.acts.Spawn,null,6955349784767693,[[4,60],[5,[0,6]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xaefcb2fc44450,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,5422148379089504]]],[0,null,!1,8867608275031819,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,0x52cfee9f5cdab],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5913312903211912,[[11,"Ballss"],[8,0],
[7,[0,8]]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,0x85fac7d52b9d6,[[11,"Ballss"],[7,[0,1]]]],[249,cr.plugins_.Sprite.prototype.acts.Destroy,null,9782465986960202],[-1,cr.system_object.prototype.acts.SetVar,null,5985183894740308,[[11,"Catapult"],[7,[0,1]]]],[145,cr.plugins_.Sprite.prototype.acts.Destroy,null,665883417184262],[144,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",7837053304289892,[[0,[7,[19,cr.system_object.prototype.exps.distance,[[20,144,cr.plugins_.Sprite.prototype.exps.X,
!1,null],[20,144,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[1,3.8]]],[0,[20,144,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9135508982636444,[[11,"BulletValue"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,81377029558515,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,8618656115374485,[[1,
[2,"acell"]],[3,1]]],[20,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",4800236448431304,[[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,6449167287636507,[[0,[0,2]]]],[144,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x784c1a03fbfe8],[-1,cr.system_object.prototype.acts.SetVar,null,6591316323846917,[[11,"Catapult"],[7,[0,0]]]],[144,cr.plugins_.Sprite.prototype.acts.Spawn,null,5270257731823131,[[4,60],[5,[0,6]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,5671691110894786,
[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,707946213271677]]],[0,null,!1,7683215844295981,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,5999273528491385],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9912607046353460,[[11,"Ballss"],[8,0],[7,[0,7]]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,500662614415883,[[11,"Ballss"],[7,[0,1]]]],[248,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x98b0ad31838c5],[-1,cr.system_object.prototype.acts.SetVar,
null,6293791876185379,[[11,"Catapult"],[7,[0,1]]]],[145,cr.plugins_.Sprite.prototype.acts.Destroy,null,5020036449729845],[144,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",4960217527287395,[[0,[7,[19,cr.system_object.prototype.exps.distance,[[20,144,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,144,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[1,3.8]]],[0,[20,144,cr.plugins_.Sprite.prototype.exps.Angle,
!1,null]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x97bce2f0cbada,[[11,"BulletValue"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xa452e62f01a1,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,5368844313438303,[[1,[2,"acell"]],[3,1]]],[20,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",432797782594594,[[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,6420165184311771,[[0,[0,2]]]],[144,cr.plugins_.Sprite.prototype.acts.Destroy,
null,9572052916892348],[-1,cr.system_object.prototype.acts.SetVar,null,9746089756595714,[[11,"Catapult"],[7,[0,0]]]],[144,cr.plugins_.Sprite.prototype.acts.Spawn,null,674407224657617,[[4,60],[5,[0,6]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,84323271834957,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,7663196488648759]]],[0,null,!1,0x6d6be2d495fea,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,0x849e55d7fe054],[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,7713648012915004,[[11,"Ballss"],[8,0],[7,[0,6]]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,0x84a18cae355cf,[[11,"Ballss"],[7,[0,1]]]],[247,cr.plugins_.Sprite.prototype.acts.Destroy,null,6580366983784025],[-1,cr.system_object.prototype.acts.SetVar,null,9718659955344020,[[11,"Catapult"],[7,[0,1]]]],[145,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xd13ebd4190ce7],[144,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",5742670246577551,[[0,[7,[19,cr.system_object.prototype.exps.distance,
[[20,144,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,144,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[1,3.8]]],[0,[20,144,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8184874714424458,[[11,"BulletValue"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x5a746daf2b59a,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.SetGroupActive,
null,8256151216722692,[[1,[2,"acell"]],[3,1]]],[20,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",4629796377554746,[[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,4597715662310459,[[0,[0,2]]]],[144,cr.plugins_.Sprite.prototype.acts.Destroy,null,7321837181923542],[-1,cr.system_object.prototype.acts.SetVar,null,9092806618309E3,[[11,"Catapult"],[7,[0,0]]]],[144,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xc223a4067f63c,[[4,60],[5,[0,6]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,
null,5403304582965885,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,8562602372311235]]],[0,null,!1,6874721013800994,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,9872004452277044],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,4806728275286403,[[11,"Ballss"],[8,0],[7,[0,5]]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,0xf191c759e50c6,[[11,"Ballss"],[7,[0,1]]]],[246,cr.plugins_.Sprite.prototype.acts.Destroy,null,5102061219499449],[-1,cr.system_object.prototype.acts.SetVar,
null,5541334043568423,[[11,"Catapult"],[7,[0,1]]]],[145,cr.plugins_.Sprite.prototype.acts.Destroy,null,9202271508047360],[144,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",0xfda0b2258fade,[[0,[7,[19,cr.system_object.prototype.exps.distance,[[20,144,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,144,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[1,3.8]]],[0,[20,144,cr.plugins_.Sprite.prototype.exps.Angle,
!1,null]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6578095766330072,[[11,"BulletValue"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xf3904c92296a,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,7522231789387516,[[1,[2,"acell"]],[3,1]]],[20,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",5658475632813896,[[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,0x8cc6cc2391646,[[0,[0,2]]]],[144,cr.plugins_.Sprite.prototype.acts.Destroy,
null,8227024933298695],[-1,cr.system_object.prototype.acts.SetVar,null,0xc297c0692c835,[[11,"Catapult"],[7,[0,0]]]],[144,cr.plugins_.Sprite.prototype.acts.Spawn,null,6409643323599144,[[4,60],[5,[0,6]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,9987370770891948,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,6566830405607664]]],[0,null,!1,4756298423204731,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,6887410991654201],[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,0x79be1a9e083b6,[[11,"Ballss"],[8,0],[7,[0,4]]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,0xc8950dd71283,[[11,"Ballss"],[7,[0,1]]]],[245,cr.plugins_.Sprite.prototype.acts.Destroy,null,7838008338021977],[-1,cr.system_object.prototype.acts.SetVar,null,0x8ac516994f505,[[11,"Catapult"],[7,[0,1]]]],[145,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x937bdcfd8bcbd],[144,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",655520590922439,[[0,[7,[19,cr.system_object.prototype.exps.distance,
[[20,144,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,144,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[1,3.8]]],[0,[20,144,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x4bc430ea0e145,[[11,"BulletValue"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xa11c8bdd9b3b0,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.SetGroupActive,
null,326777833693369,[[1,[2,"acell"]],[3,1]]],[20,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",5549729342269285,[[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,8658518244882735,[[0,[0,2]]]],[144,cr.plugins_.Sprite.prototype.acts.Destroy,null,7437756617830053],[-1,cr.system_object.prototype.acts.SetVar,null,8105381937256684,[[11,"Catapult"],[7,[0,0]]]],[144,cr.plugins_.Sprite.prototype.acts.Spawn,null,9493631623123800,[[4,60],[5,[0,6]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,
null,4924060903772979,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x68b25240b895c]]],[0,null,!1,4932527447584806,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,5218159722007462],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9956821158402508,[[11,"Ballss"],[8,0],[7,[0,3]]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,5638321380322284,[[11,"Ballss"],[7,[0,1]]]],[244,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb439d544fa447],[-1,cr.system_object.prototype.acts.SetVar,
null,7860057454726493,[[11,"Catapult"],[7,[0,1]]]],[145,cr.plugins_.Sprite.prototype.acts.Destroy,null,8195997312429837],[144,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",5170347729309418,[[0,[7,[19,cr.system_object.prototype.exps.distance,[[20,144,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,144,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[1,3.8]]],[0,[20,144,cr.plugins_.Sprite.prototype.exps.Angle,
!1,null]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5296921303251587,[[11,"BulletValue"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,7574128723925026,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,5576023656626271,[[1,[2,"acell"]],[3,1]]],[20,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",454171191095566,[[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,0xc8a8f510802f7,[[0,[0,2]]]],[144,cr.plugins_.Sprite.prototype.acts.Destroy,
null,0x6b7eb72adcb77],[-1,cr.system_object.prototype.acts.SetVar,null,0xcd712a82d451e,[[11,"Catapult"],[7,[0,0]]]],[144,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xe34484bccf836,[[4,60],[5,[0,6]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,6446622921858632,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,8973170862505858]]],[0,null,!1,7437596909347786,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,710593990372374],[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,8168579086976205,[[11,"Ballss"],[8,0],[7,[0,2]]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,4839815018138279,[[11,"Ballss"],[7,[0,1]]]],[243,cr.plugins_.Sprite.prototype.acts.Destroy,null,9375672254135972],[-1,cr.system_object.prototype.acts.SetVar,null,695317878281757,[[11,"Catapult"],[7,[0,1]]]],[145,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x9980b7115f279],[144,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",0x747eca2033d92,[[0,[7,[19,cr.system_object.prototype.exps.distance,
[[20,144,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,144,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[1,3.8]]],[0,[20,144,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5613330559741182,[[11,"BulletValue"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,602143629064265,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.SetGroupActive,
null,9001055633632208,[[1,[2,"acell"]],[3,1]]],[20,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",540640095646058,[[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,0x6925c71768d6,[[0,[0,2]]]],[144,cr.plugins_.Sprite.prototype.acts.Destroy,null,6711053035602432],[-1,cr.system_object.prototype.acts.SetVar,null,0xc6a6a417711a5,[[11,"Catapult"],[7,[0,0]]]],[144,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x6c965f3cdcefd,[[4,60],[5,[0,6]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,
null,5589437935385923,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x7051213257d15]]],[0,null,!1,8304067313380087,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,8592067920440549],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7255991685308009,[[11,"Ballss"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,0x7120b325f4fb9,[[11,"Ballss"],[7,[0,1]]]],[241,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x40102d49bc9fc],[-1,cr.system_object.prototype.acts.SetVar,
null,6188799226354155,[[11,"Catapult"],[7,[0,1]]]],[145,cr.plugins_.Sprite.prototype.acts.Destroy,null,970108562565994],[144,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",9181867838501396,[[0,[7,[19,cr.system_object.prototype.exps.distance,[[20,144,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,144,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[1,3.8]]],[0,[20,144,cr.plugins_.Sprite.prototype.exps.Angle,
!1,null]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xd0fe9ced378fe,[[11,"BulletValue"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,8031183916073658,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x8fe5f68026c85,[[1,[2,"acell"]],[3,1]]],[20,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",0xc472982bebe58,[[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,7003740839547385,[[0,[0,2]]]],[144,cr.plugins_.Sprite.prototype.acts.Destroy,
null,0x6d9469de4dc1b],[-1,cr.system_object.prototype.acts.SetVar,null,0xae6970c726380,[[11,"Catapult"],[7,[0,0]]]],[144,cr.plugins_.Sprite.prototype.acts.Spawn,null,7812375539633102,[[4,60],[5,[0,6]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,5027414887416866,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,8343859686841733]]]]]]],[0,[!0,"MoneyLifes"],!1,0xbe27d412015c7,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xbe27d412015c7,[[1,[2,"MoneyLifes"]]]]],
[],[[0,null,!1,9709297886639032,[[57,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8289696806716621,[[4,20]]],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0xa167be43d0527,[[7,[23,"Money"]],[8,0],[7,[0,29]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,664031816661277,[[11,"Lifes"],[7,[0,3]]]]]],[0,null,!1,7138698875592885,[[57,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xfdb34cb4a85d5,[[4,20]]],[-1,cr.system_object.prototype.cnds.Compare,null,
0,!1,!1,!1,0xfea633df784c7,[[7,[23,"Money"]],[8,0],[7,[0,59]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0x6fe29d0ef216b,[[11,"Lifes"],[7,[0,3]]]]]],[0,null,!1,0x5ffc59fb9eba0,[[57,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4990047234285057,[[4,20]]],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0xd8ad99b4b9a7,[[7,[23,"Money"]],[8,0],[7,[0,89]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,8689764249739565,[[11,"Lifes"],[7,[0,3]]]]]],[0,null,!1,7834753068518573,
[[57,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xde69c60347d19,[[4,20]]],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0xd3448bd28b8e9,[[7,[23,"Money"]],[8,0],[7,[0,119]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,7074602203447021,[[11,"Lifes"],[7,[0,3]]]]]],[0,null,!1,0xd7bbef522b7d0,[[57,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,716874648257314,[[4,20]]],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,6895599438965388,[[7,
[23,"Money"]],[8,0],[7,[0,149]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xa91b8273b8899,[[11,"Lifes"],[7,[0,3]]]]]],[0,null,!1,0xeda8938ff9953,[[57,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7798690489233721,[[4,20]]],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,8217712297703646,[[7,[23,"Money"]],[8,0],[7,[0,179]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,4598002379753272,[[11,"Lifes"],[7,[0,3]]]]]],[0,null,!1,0xdce2536ea8018,[[57,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,0x60d2c6a90e20f,[[4,20]]],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,9888424500513418,[[7,[23,"Money"]],[8,0],[7,[0,209]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,7301182696938242,[[11,"Lifes"],[7,[0,3]]]]]],[0,null,!1,4531135216740187,[[57,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6932067948928224,[[4,20]]],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,7270647595555339,[[7,[23,"Money"]],[8,0],[7,[0,239]]]]],[[-1,cr.system_object.prototype.acts.SetVar,
null,0xbf10fa1f6d470,[[11,"Lifes"],[7,[0,3]]]]]],[0,null,!1,7118459682001092,[[57,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x969cbe7dab61,[[4,20]]],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0xa8a17d9b29170,[[7,[23,"Money"]],[8,0],[7,[0,279]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,6065216624972093,[[11,"Lifes"],[7,[0,3]]]]]],[0,null,!1,429094082399319,[[57,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8294563513627101,[[4,20]]],[-1,
cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0xb77250276d53,[[7,[23,"Money"]],[8,0],[7,[0,309]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0x84b1647aec03c,[[11,"Lifes"],[7,[0,3]]]]]]]],[0,[!0,"RocketChange"],!1,5647267094043074,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,5647267094043074,[[1,[2,"RocketChange"]]]]],[],[[0,null,!1,4798677314595649,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,570997373371979,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.cnds.Compare,
null,0,!1,!1,!1,0x3df3d7e9cc9e5,[[7,[4,[9,[22,117,"Physics",cr.behaviors.Physics.prototype.exps.VelocityX,!1,null],[0,2]],[9,[22,117,"Physics",cr.behaviors.Physics.prototype.exps.VelocityY,!1,null],[0,2]]]],[8,5],[7,[0,35E3]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,0xdfda1e5888e64,[[11,"Money"],[7,[0,1]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x56d373a4d02c1,[[7,[23,"Money"]]]]]],[0,null,!1,6862015024270174,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,
7810727135543826]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,8584149294951897,[[1,[2,"NoMouse"]],[3,0]]],[117,cr.plugins_.Sprite.prototype.acts.Destroy,null,8355467622759873],[-1,cr.system_object.prototype.acts.SetGroupActive,null,9402934106806556,[[1,[2,"WatherRocket"]],[3,0]]]]],[0,null,!1,0x7eb7771505447,[[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x3ac88227178c5,[[4,118]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6435824804252931,[[11,
"RV"],[8,3],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xcfae6ae42f4ff,[[1,[2,"NoRocket"]],[3,0]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x7e65f31639673,[[1,[2,"NoMouse"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xec27e0914cc61,[[1,[2,"WatherRocket"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x9cc628dee364d,[[1,[2,"WatherMouse"]],[3,0]]],[-1,cr.system_object.prototype.acts.CreateObject,null,7070730194861326,
[[4,117],[5,[0,6]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[20,cr.plugins_.Sprite.prototype.acts.Destroy,null,7118200438397],[21,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xac41050173dff],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x8107f7c88c4e6,[[1,[2,"acell"]],[3,0]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,4916569512520038,[[1,[2,"SpawnEnemys"]],[3,0]]],[33,cr.plugins_.Particles.prototype.acts.SetSpraying,
null,7421447618680377,[[3,1]]],[34,cr.plugins_.Particles.prototype.acts.SetSpraying,null,6309318742949746,[[3,1]]],[120,cr.plugins_.Sprite.prototype.acts.Destroy,null,53650064540036],[-1,cr.system_object.prototype.acts.CreateObject,null,6336433184255678,[[4,120],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,[[0,100],[0,1200]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,1500]]]]],[118,cr.plugins_.Sprite.prototype.acts.Destroy,null,7520707410216158],[-1,cr.system_object.prototype.acts.CreateObject,
null,942757634011376,[[4,118],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,[[0,100],[0,1200]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,1500]]]]],[-1,cr.system_object.prototype.acts.Wait,null,5769374392077553,[[0,[0,3]]]],[117,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x96ac5a70759b2,[[4,119],[5,[0,6]],[7,[0,3]]]],[119,cr.behaviors.Pin.prototype.acts.Pin,"Pin",6415861531804414,[[4,117],[3,0]]]]],[0,null,!1,687133087659903,[[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,291464723577222,[[4,118]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9479828983841232,[[11,"RV"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x9d105aa8c6de5,[[1,[2,"NoRocket"]],[3,0]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xe4dd2fb368c21,[[1,[2,"NoMouse"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x9c8ac559f0107,[[1,[2,"WatherRocket"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,
null,0x94c533bcec9eb,[[1,[2,"WatherMouse"]],[3,0]]],[-1,cr.system_object.prototype.acts.CreateObject,null,5382535779366362,[[4,117],[5,[0,6]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[117,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xf1790b392b2a4,[[1,[2,"U1"]],[3,1]]],[20,cr.plugins_.Sprite.prototype.acts.Destroy,null,7778272053446735],[21,cr.plugins_.Sprite.prototype.acts.Destroy,null,4792309366554294],[-1,cr.system_object.prototype.acts.SetGroupActive,
null,8090857593981019,[[1,[2,"acell"]],[3,0]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,5857078631717108,[[1,[2,"SpawnEnemys"]],[3,0]]],[33,cr.plugins_.Particles.prototype.acts.SetSpraying,null,3775568423421,[[3,1]]],[34,cr.plugins_.Particles.prototype.acts.SetSpraying,null,0xad8d319e45333,[[3,1]]],[120,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x893b50b1c1802],[-1,cr.system_object.prototype.acts.CreateObject,null,5345015713930394,[[4,120],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,
[[0,100],[0,1200]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,1500]]]]],[118,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xe70a62bd949c3],[-1,cr.system_object.prototype.acts.CreateObject,null,0xb5a384db36d4c,[[4,118],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,[[0,100],[0,1200]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,1500]]]]],[-1,cr.system_object.prototype.acts.Wait,null,351135146829186,[[0,[0,3]]]],[117,cr.plugins_.Sprite.prototype.acts.Spawn,
null,5430023214707204,[[4,119],[5,[0,6]],[7,[0,3]]]],[119,cr.behaviors.Pin.prototype.acts.Pin,"Pin",0xf8d43061c734f,[[4,117],[3,0]]]]],[0,null,!1,0xa7204dde7aae5,[[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x4892465a06488,[[4,118]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,4657034170459668,[[11,"RV"],[8,0],[7,[0,2]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xc3a0e87bba6f9,[[1,[2,"NoRocket"]],[3,0]]],[-1,cr.system_object.prototype.acts.SetGroupActive,
null,7021107892635389,[[1,[2,"NoMouse"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xe5f7547873121,[[1,[2,"WatherRocket"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,7927918007756468,[[1,[2,"WatherMouse"]],[3,0]]],[-1,cr.system_object.prototype.acts.CreateObject,null,9138943127059014,[[4,117],[5,[0,6]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[117,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,0x512dd6bb19d76,[[1,[2,"U2"]],[3,1]]],[20,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x50f06b78a3b33],[21,cr.plugins_.Sprite.prototype.acts.Destroy,null,6222240740518408],[-1,cr.system_object.prototype.acts.SetGroupActive,null,7110989943540048,[[1,[2,"acell"]],[3,0]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,4839718352504903,[[1,[2,"SpawnEnemys"]],[3,0]]],[33,cr.plugins_.Particles.prototype.acts.SetSpraying,null,0x3e39114524bd7,[[3,1]]],[34,cr.plugins_.Particles.prototype.acts.SetSpraying,
null,0xd667f8c239408,[[3,1]]],[120,cr.plugins_.Sprite.prototype.acts.Destroy,null,9507290541229532],[-1,cr.system_object.prototype.acts.CreateObject,null,7184810901830325,[[4,120],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,[[0,100],[0,1200]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,1500]]]]],[118,cr.plugins_.Sprite.prototype.acts.Destroy,null,5306484062606326],[-1,cr.system_object.prototype.acts.CreateObject,null,4711343138391266,[[4,118],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,
[[0,100],[0,1200]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,1500]]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xad718d0e692b1,[[0,[0,3]]]],[117,cr.plugins_.Sprite.prototype.acts.Spawn,null,7220423026932752,[[4,119],[5,[0,6]],[7,[0,3]]]],[119,cr.behaviors.Pin.prototype.acts.Pin,"Pin",460782574610552,[[4,117],[3,0]]]]],[0,null,!1,0x7ce77f1a8036b,[[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,293965218995078,[[4,118]]],[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,9628275517628012,[[11,"RV"],[8,0],[7,[0,3]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,5475906616958876,[[1,[2,"NoRocket"]],[3,0]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x8149a53d8afdb,[[1,[2,"NoMouse"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,78423315154966,[[1,[2,"WatherRocket"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,8788876196226518,[[1,[2,"WatherMouse"]],[3,0]]],[-1,cr.system_object.prototype.acts.CreateObject,
null,9305139950450122,[[4,117],[5,[0,6]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[117,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xf92b696b084c4,[[1,[2,"U3"]],[3,1]]],[20,cr.plugins_.Sprite.prototype.acts.Destroy,null,8240707269227503],[21,cr.plugins_.Sprite.prototype.acts.Destroy,null,9498526321466300],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xbd0ff8a30e3f1,[[1,[2,"acell"]],[3,0]]],[-1,cr.system_object.prototype.acts.SetGroupActive,
null,0x8f5fc9bfc85ca,[[1,[2,"SpawnEnemys"]],[3,0]]],[33,cr.plugins_.Particles.prototype.acts.SetSpraying,null,8581634639444735,[[3,1]]],[34,cr.plugins_.Particles.prototype.acts.SetSpraying,null,0xfed7931795407,[[3,1]]],[120,cr.plugins_.Sprite.prototype.acts.Destroy,null,8862105366343616],[-1,cr.system_object.prototype.acts.CreateObject,null,6127545575958765,[[4,120],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,[[0,100],[0,1200]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],
[0,1500]]]]],[118,cr.plugins_.Sprite.prototype.acts.Destroy,null,4689389108033883],[-1,cr.system_object.prototype.acts.CreateObject,null,0x8ab25bbdde8a6,[[4,118],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,[[0,100],[0,1200]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,1500]]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xc1e127e9c0138,[[0,[0,3]]]],[117,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x6c6e713c0c2c9,[[4,119],[5,[0,6]],[7,[0,3]]]],[119,cr.behaviors.Pin.prototype.acts.Pin,
"Pin",7760477190930171,[[4,117],[3,0]]]]],[0,null,!1,5940464133204134,[[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5056187127966625,[[4,118]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8698523437995458,[[11,"RV"],[8,0],[7,[0,4]]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x78b333741dc32,[[1,[2,"NoRocket"]],[3,0]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,7284720586909761,[[1,[2,"NoMouse"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,
null,0x54fa6145d34d5,[[1,[2,"WatherRocket"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x4cc173afefda5,[[1,[2,"WatherMouse"]],[3,0]]],[-1,cr.system_object.prototype.acts.CreateObject,null,814920808498177,[[4,117],[5,[0,6]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[117,cr.plugins_.Sprite.prototype.acts.SetAnim,null,9697073932201204,[[1,[2,"U4"]],[3,1]]],[20,cr.plugins_.Sprite.prototype.acts.Destroy,null,
0x929bbe92d4827],[21,cr.plugins_.Sprite.prototype.acts.Destroy,null,4658257619082506],[-1,cr.system_object.prototype.acts.SetGroupActive,null,8810902858274526,[[1,[2,"acell"]],[3,0]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xcc0e88e0b2956,[[1,[2,"SpawnEnemys"]],[3,0]]],[33,cr.plugins_.Particles.prototype.acts.SetSpraying,null,4782835004780699,[[3,1]]],[34,cr.plugins_.Particles.prototype.acts.SetSpraying,null,0xaa21b57eeeaf3,[[3,1]]],[120,cr.plugins_.Sprite.prototype.acts.Destroy,
null,0x76cf82a20355],[-1,cr.system_object.prototype.acts.CreateObject,null,6196236948929136,[[4,120],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,[[0,100],[0,1200]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,1500]]]]],[118,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x406918736f91a],[-1,cr.system_object.prototype.acts.CreateObject,null,9679547313231924,[[4,118],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,[[0,100],[0,1200]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,
!1,null],[0,1500]]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x748c8d9032893,[[0,[0,3]]]],[117,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x4e59801b82123,[[4,119],[5,[0,6]],[7,[0,3]]]],[119,cr.behaviors.Pin.prototype.acts.Pin,"Pin",8727830354359632,[[4,117],[3,0]]]]],[0,null,!1,0xc248d084c207f,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x7daceeceafe8]],[[117,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",0xcda71f1a1e4,[[0,[1,6.5]],[0,[5,[20,117,cr.plugins_.Sprite.prototype.exps.Angle,
!1,null],[0,90]]],[7,[0,1]]]]]],[0,null,!1,5322276333062139,[[16,cr.plugins_.Touch.prototype.cnds.IsInTouch,null,0,!1,!1,!1,5690543814157125],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8822556307624618,[[11,"RV"],[8,3],[7,[0,3]]]]],[[117,cr.behaviors.Physics.prototype.acts.ApplyForceToward,"Physics",0xcffcd3edf02e9,[[0,[0,2]],[0,[20,16,cr.plugins_.Touch.prototype.exps.X,!1,null]],[0,[20,117,cr.plugins_.Sprite.prototype.exps.Y,!1,null]],[7,[0,2]]]]]],[0,null,!1,9604984666583300,
[[16,cr.plugins_.Touch.prototype.cnds.IsInTouch,null,0,!1,!1,!1,4992753254507595],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xcef2273c0a499,[[11,"RV"],[8,0],[7,[0,4]]]]],[[117,cr.behaviors.Physics.prototype.acts.ApplyForceToward,"Physics",7480867195252522,[[0,[0,2]],[0,[20,16,cr.plugins_.Touch.prototype.exps.X,!1,null]],[0,[20,117,cr.plugins_.Sprite.prototype.exps.Y,!1,null]],[7,[0,2]]]],[117,cr.behaviors.Physics.prototype.acts.ApplyForceToward,"Physics",7292042571164218,[[0,
[0,4]],[0,[20,16,cr.plugins_.Touch.prototype.exps.X,!1,null]],[0,[20,117,cr.plugins_.Sprite.prototype.exps.Y,!1,null]],[7,[0,4]]]]]],[0,null,!1,7790420719126279,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,20486500804172]],[[33,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,0xcef79a0b94da5,[[4,117],[7,[0,1]]]]]],[0,null,!1,0xacf8d810274a8,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,8934947823487995]],[[34,cr.plugins_.Particles.prototype.acts.SetPosToObject,
null,9760614465407724,[[4,117],[7,[0,1]]]]]],[0,null,!1,6957045867948533,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,9122169894006228,[[7,[20,117,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[8,5],[7,[0,90]]]],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,8752548648982101,[[7,[20,117,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[8,3],[7,[0,270]]]]],[[117,cr.plugins_.Sprite.prototype.acts.SetAngle,null,0xaf9ad08614d29,[[0,[0,0]]]],[117,cr.plugins_.Sprite.prototype.acts.Destroy,
null,0xbcf13fe75cc0a],[119,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb120c1b8e3c53],[-1,cr.system_object.prototype.acts.SetGroupActive,null,5190938834125816,[[1,[2,"NoRocket"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xf22a2f356c20b,[[1,[2,"NoMouse"]],[3,0]]],[33,cr.plugins_.Particles.prototype.acts.SetSpraying,null,926495360363281,[[3,0]]],[34,cr.plugins_.Particles.prototype.acts.SetSpraying,null,53366597169493,[[3,0]]],[117,cr.plugins_.Sprite.prototype.acts.Spawn,
null,573160209511852,[[4,20],[5,[0,6]],[7,[0,0]]]],[117,cr.plugins_.Sprite.prototype.acts.Spawn,null,7712485426184176,[[4,21],[5,[0,6]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xae6372ca4633c,[[1,[2,"acell"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xb9333c99b7e39,[[1,[2,"WatherRocket"]],[3,0]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,552470378337176,[[1,[2,"WatherMouse"]],[3,1]]],[21,cr.plugins_.Sprite.prototype.acts.SetPos,null,
8762450151195947,[[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,10]]]]],[21,cr.behaviors.Pin.prototype.acts.Pin,"Pin",0x97a6ef23b907a,[[4,20],[3,0]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xc60f8769c3463,[[1,[2,"SpawnEnemys"]],[3,1]]]]],[0,null,!0,0x488a393a1e2be,[[119,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5795936038894533,[[4,23]]],[119,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,
0,!1,!1,!0,6359461698998767,[[4,85]]],[119,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xba4b3d859dd4b,[[4,112]]]],[[117,cr.plugins_.Sprite.prototype.acts.SetAngle,null,501248357506743,[[0,[0,0]]]],[117,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc759fcfc9283],[119,cr.plugins_.Sprite.prototype.acts.Destroy,null,5850825702590975],[-1,cr.system_object.prototype.acts.SetGroupActive,null,9176369858091834,[[1,[2,"NoRocket"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,
null,0x49462676ff3ed,[[1,[2,"NoMouse"]],[3,0]]],[33,cr.plugins_.Particles.prototype.acts.SetSpraying,null,5263621744022488,[[3,0]]],[34,cr.plugins_.Particles.prototype.acts.SetSpraying,null,0xec160f95fc1da,[[3,0]]],[117,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x62d14e895fdd9,[[4,20],[5,[0,6]],[7,[0,0]]]],[117,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xf4adae28a3885,[[4,21],[5,[0,6]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,5163490226089857,[[1,[2,"acell"]],[3,1]]],
[-1,cr.system_object.prototype.acts.SetGroupActive,null,7135179323098062,[[1,[2,"WatherRocket"]],[3,0]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xe9338c37aa0d4,[[1,[2,"WatherMouse"]],[3,1]]],[21,cr.plugins_.Sprite.prototype.acts.SetPos,null,0x6280d6657007e,[[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,10]]]]],[21,cr.behaviors.Pin.prototype.acts.Pin,"Pin",9740088314386012,[[4,20],[3,0]]],[-1,cr.system_object.prototype.acts.SetGroupActive,
null,5775059293428413,[[1,[2,"SpawnEnemys"]],[3,1]]]]],[0,null,!1,7731525147775122,[[117,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5699645703020886,[[4,84]]]],[[117,cr.plugins_.Sprite.prototype.acts.Destroy,null,88528350962056],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xe748926e17c8c,[[1,[2,"acell"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,4876158184327078,[[1,[2,"WatherRocket"]],[3,0]]],[22,cr.plugins_.Sprite.prototype.acts.Destroy,null,
0xf6081cdccdc3e],[-1,cr.system_object.prototype.acts.Wait,null,0x575679ac724dd,[[0,[0,2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,7090890359143836,[[6,"Click to play"]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xe315d28856b8b,[[1,[2,"SpawnEnemys"]],[3,1]]]]]]],[0,[!0,"GravityChange"],!1,0x864536a52181d,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x864536a52181d,[[1,[2,"GravityChange"]]]]],[],[[0,null,!1,0x7eb7771505447,[[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,0x3ac88227178c5,[[4,120]]]],[[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x8fd974b0570aa,[[1,[2,"GravityChange"]],[3,1]]],[20,cr.behaviors.Physics.prototype.acts.SetWorldGravity,"Physics",4988690990613603,[[0,[0,-10]]]],[120,cr.plugins_.Sprite.prototype.acts.Destroy,null,9752973613610712],[118,cr.plugins_.Sprite.prototype.acts.Destroy,null,4668763795663494],[-1,cr.system_object.prototype.acts.CreateObject,null,9194940215181412,[[4,120],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,
[[0,100],[0,1200]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,1500]]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x40698c7fbffc8,[[4,118],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.random,[[0,100],[0,1200]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,1500]]]]]]],[0,null,!0,7068916479490703,[[21,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9495013244669116,[[4,23]]],[21,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,
!1,!0,0xa5e40a914c676,[[4,85]]],[21,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x9edb4660045b9,[[4,112]]]],[[20,cr.behaviors.Physics.prototype.acts.SetWorldGravity,"Physics",6010302808974561,[[0,[1,7.5]]]]]],[0,null,!0,6983496023562832,[[21,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8026131950223795,[[4,7]]],[21,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5408799805143826,[[4,9]]],[21,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,
!0,9865663243685234,[[4,11]]],[21,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xbc8eead944c2,[[4,13]]],[21,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,349732072391436,[[4,62]]],[21,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6760104308800366,[[4,46]]],[21,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4746284243646437,[[4,45]]],[21,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5590652609730234,[[4,63]]],[21,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,0x57cc453df79ec,[[4,43]]],[21,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x829d93786dbb2,[[4,48]]],[21,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,706963494076222,[[4,47]]],[21,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xe2f496db018cf,[[4,64]]],[21,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x4027df555b598,[[4,66]]],[21,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x99584a97f2a13,[[4,67]]],
[21,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xf7b2f2a00ad0b,[[4,75]]],[21,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6398805361930852,[[4,77]]],[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8899795013388447,[[4,62]]],[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x848f74040ce96,[[4,46]]],[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xaff6c6dc1efbe,[[4,45]]],[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,9979867200957360,[[4,63]]],[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,286906718380718,[[4,36]]],[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5692738326038513,[[4,43]]],[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xfea15267d1507,[[4,48]]],[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5467862099272018,[[4,66]]],[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7757041121169913,[[4,67]]],
[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x8e6fc28fde709,[[4,75]]],[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5618267557117528,[[4,77]]]],[[20,cr.behaviors.Physics.prototype.acts.SetWorldGravity,"Physics",6098538696293262,[[0,[1,7.5]]]]]]]],[0,[!0,"EnergyValue"],!1,6743680673677483,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6743680673677483,[[1,[2,"EnergyValue"]]]]],[],[[0,null,!1,6249303295023471,[[56,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
null,0,!1,!1,!1,7139369702460541,[[4,20]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,6220010917155329,[[11,"EnergyValue"],[7,[0,1]]]],[6,cr.plugins_.Text.prototype.acts.SetText,null,0xe0fcadb729a24,[[7,[23,"EnergyValue"]]]]]],[0,null,!1,544645664268937,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xa59022d917802]],[[6,cr.plugins_.Text.prototype.acts.SetText,null,28270100074573,[[7,[2,""]]]]]],[0,null,!1,7102838393938811,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
null,0,!1,!1,!1,0xffdd7980533ee,[[4,116]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5743050887703065,[[11,"EnergyValue"],[8,5],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,79592333184938,[[11,"Accleration"],[7,[0,200]]]],[20,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,0x4519f7da09a0d,[[10,0],[7,[0,200]]]],[-1,cr.system_object.prototype.acts.SubVar,null,4554312805152966,[[11,"EnergyValue"],[7,[0,1]]]],[6,cr.plugins_.Text.prototype.acts.SetText,null,
8484508193697355,[[7,[23,"EnergyValue"]]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,5738428198550864,[[1,[2,"EnergyValue"]],[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,4752309561368691,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0xb299780abf7e8,[[1,[2,"EnergyValue"]],[3,1]]]]]]],[0,[!0,"Reset"],!1,4504253452373745,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,4504253452373745,[[1,[2,"Reset"]]]]],[],[[0,null,!1,0x6ff9447713631,
[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xc454323b312ae,[[4,114]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xb3fbdc51244c1,[[4,182],[5,[0,10]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x7181db980a3f5,[[4,183],[5,[0,10]],[0,[0,300]],[0,[0,470]]]],[117,cr.plugins_.Sprite.prototype.acts.Destroy,null,9968302249801076],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x461eca2960aab,[[1,[2,"acell"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,
null,5276677192182722,[[1,[2,"WatherRocket"]],[3,0]]],[22,cr.plugins_.Sprite.prototype.acts.Destroy,null,901542285526094],[-1,cr.system_object.prototype.acts.Wait,null,9572058116591512,[[0,[0,2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x7cbda0849b630,[[6,"Click to play"]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,4591806106135334,[[1,[2,"SpawnEnemys"]],[3,1]]]]]]],[0,[!0,"Player wins"],!1,9731469328125066,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,
!1,9731469328125066,[[1,[2,"Player wins"]]]]],[],[[0,null,!1,164,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,165]],[[-1,cr.system_object.prototype.acts.SetVar,null,166,[[11,"win"],[7,[0,0]]]]]],[0,null,!0,167,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,168,[[4,111]]],[117,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,9715546745820968,[[4,111]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,169,[[11,"win"],[7,[0,1]]]]]]]],[0,[!0,
"Physics"],!1,0x4681bb3647314,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x4681bb3647314,[[1,[2,"Physics"]]]]],[],[[0,null,!1,171,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,172]],[[20,cr.behaviors.Physics.prototype.acts.SetSteppingMode,"Physics",173,[[3,1]]],[20,cr.behaviors.Physics.prototype.acts.SetIterations,"Physics",174,[[0,[0,6]],[0,[0,1]]]],[20,cr.behaviors.Physics.prototype.acts.SetWorldGravity,"Physics",176,[[0,[1,7.5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,
null,177,[[0,[1,0.7]]]],[21,cr.behaviors.Pin.prototype.acts.Pin,"Pin",4798719423206506,[[4,20],[3,0]]]]]]],[0,[!0,"Countdown and set Globals"],!1,0x63f746a68f14b,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x63f746a68f14b,[[1,[2,"Countdown and set Globals"]]]]],[],[[0,null,!1,182,[[16,cr.plugins_.Touch.prototype.cnds.IsInTouch,null,0,!1,!1,!1,183]],[[-1,cr.system_object.prototype.acts.SetVar,null,184,[[11,"Countdown"],[7,[0,2]]]]]],[0,null,!1,0xd193dbee4be00,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlappingOffset,
null,0,!1,!1,!1,42470998141968,[[4,23],[0,[0,0]],[0,[0,20]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,7692067371215854,[[11,"Countdown"],[7,[0,0]]]]]],[0,null,!1,4929339994697482,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlappingOffset,null,0,!1,!1,!1,0xa0e315b66c275,[[4,85],[0,[0,0]],[0,[0,20]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,5831022214911885,[[11,"Countdown"],[7,[0,0]]]]]],[0,null,!1,185,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,186,[[11,"Countdown"],
[8,4],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,187]],[[-1,cr.system_object.prototype.acts.SetVar,null,189,[[11,"Countdown"],[7,[19,cr.system_object.prototype.exps.max,[[0,0],[5,[23,"Countdown"],[19,cr.system_object.prototype.exps.dt]]]]]]]]],[0,null,!1,190,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,191]],[[-1,cr.system_object.prototype.acts.ResetGlobals,null,192],[-1,cr.system_object.prototype.acts.SetVar,null,0x9b14c1435f27c,[[11,"RV"],[7,
[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"Rsave"]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5537544538726043,[[11,"BV"],[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"Bsave"]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xf529d80a54901,[[11,"Lifes"],[7,[23,"BV"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x573806dbef87f,[[11,"BTV"],[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"BTVsave"]]]]]],[-1,
cr.system_object.prototype.acts.SetVar,null,0x97c43d396aa98,[[11,"EnergyValue"],[7,[23,"BTV"]]]],[6,cr.plugins_.Text.prototype.acts.SetText,null,0x9f1395575f311,[[7,[23,"EnergyValue"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9342428234871716,[[11,"AV"],[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"Asave"]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5128510217925154,[[11,"ATV"],[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"Tsave"]]]]]],
[-1,cr.system_object.prototype.acts.SetVar,null,193,[[11,"Countdown"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,25425021101042,[[11,"CTV"],[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"CTVsave"]]]]]]]]]],[0,[!0,"acell"],!1,0xd6096ea130fdd,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xd6096ea130fdd,[[1,[2,"acell"]]]]],[],[[0,null,!1,195,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,196]],[[33,cr.plugins_.Particles.prototype.acts.SetSpraying,
null,197,[[3,0]]]]],[0,null,!1,198,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,199]],[[33,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,200,[[4,20],[7,[0,1]]]]]],[0,null,!1,201,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,202]],[[34,cr.plugins_.Particles.prototype.acts.SetSpraying,null,203,[[3,0]]]]],[0,null,!1,204,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,205]],[[34,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,206,
[[4,20],[7,[0,1]]]]]],[0,null,!1,207,[[16,cr.plugins_.Touch.prototype.cnds.IsInTouch,null,0,!1,!1,!1,208],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,209,[[11,"Accleration"],[8,5],[7,[0,0]]]]],[[20,cr.behaviors.Physics.prototype.acts.ApplyForceToward,"Physics",210,[[0,[1,-4.9]],[0,[20,16,cr.plugins_.Touch.prototype.exps.X,!1,null]],[0,[20,16,cr.plugins_.Touch.prototype.exps.Y,!1,null]],[7,[0,0]]]],[32,cr.plugins_.Sprite.prototype.acts.SetWidth,null,213,[[0,[21,20,!1,null,0]]]],
[33,cr.plugins_.Particles.prototype.acts.SetSpraying,null,214,[[3,1]]],[34,cr.plugins_.Particles.prototype.acts.SetSpraying,null,215,[[3,1]]]],[[0,null,!1,0x6152f08ca3ea9,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlappingOffset,null,0,!1,!1,!1,7927944282117567,[[4,23],[0,[0,0]],[0,[0,20]]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,5078249050918208,[[11,"Accleration"],[7,[6,[19,cr.system_object.prototype.exps.dt],[0,1]]]]],[20,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,5059374300566862,
[[10,0],[7,[6,[19,cr.system_object.prototype.exps.dt],[0,1]]]]]]],[0,null,!1,0xc5367e12b1e03,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlappingOffset,null,0,!1,!0,!1,0x696c8ea04098a,[[4,23],[0,[0,0]],[0,[0,20]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7606600704557698,[[11,"AV"],[8,3],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,0xa6fabe026f5ad,[[11,"Accleration"],[7,[6,[19,cr.system_object.prototype.exps.dt],[0,17]]]]],[20,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
null,0xbd060b85a751e,[[10,0],[7,[6,[19,cr.system_object.prototype.exps.dt],[0,17]]]]]]],[0,null,!1,5655567616112742,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlappingOffset,null,0,!1,!0,!1,467624217591915,[[4,23],[0,[0,0]],[0,[0,20]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x96d949f046630,[[11,"AV"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,6346244394906517,[[11,"Accleration"],[7,[6,[19,cr.system_object.prototype.exps.dt],[0,13]]]]],[20,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
null,8981051550424728,[[10,0],[7,[6,[19,cr.system_object.prototype.exps.dt],[0,13]]]]]]],[0,null,!1,0xe7f6f3c38889d,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlappingOffset,null,0,!1,!0,!1,0xa49e346ef8ef0,[[4,23],[0,[0,0]],[0,[0,20]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5814994516732305,[[11,"AV"],[8,0],[7,[0,2]]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,7519806520473987,[[11,"Accleration"],[7,[6,[19,cr.system_object.prototype.exps.dt],[0,10]]]]],[20,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
null,715146385244777,[[10,0],[7,[6,[19,cr.system_object.prototype.exps.dt],[0,10]]]]]]],[0,null,!1,511830095184587,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlappingOffset,null,0,!1,!1,!1,7727854138984065,[[4,85],[0,[0,0]],[0,[0,20]]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,7532296109235428,[[11,"Accleration"],[7,[6,[19,cr.system_object.prototype.exps.dt],[0,1]]]]],[20,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,0x86c2e8b19c11,[[10,0],[7,[6,[19,cr.system_object.prototype.exps.dt],
[0,1]]]]]]],[0,null,!1,0x49c856e1ab7a1,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlappingOffset,null,0,!1,!0,!1,8537645741556751,[[4,85],[0,[0,0]],[0,[0,20]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,4978963853612447,[[11,"AV"],[8,3],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,5490869915075122,[[11,"Accleration"],[7,[6,[19,cr.system_object.prototype.exps.dt],[0,17]]]]],[20,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,null,7480528118814084,[[10,0],[7,
[6,[19,cr.system_object.prototype.exps.dt],[0,17]]]]]]],[0,null,!1,7527487449351562,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlappingOffset,null,0,!1,!0,!1,5696446948964212,[[4,85],[0,[0,0]],[0,[0,20]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,537033112347446,[[11,"AV"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,7687717195454839,[[11,"Accleration"],[7,[6,[19,cr.system_object.prototype.exps.dt],[0,13]]]]],[20,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
null,0x8367b2a0254cf,[[10,0],[7,[6,[19,cr.system_object.prototype.exps.dt],[0,13]]]]]]],[0,null,!1,0x40ed400ac93bd,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlappingOffset,null,0,!1,!0,!1,0x61b0357e2fa2,[[4,85],[0,[0,0]],[0,[0,20]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6509390857804827,[[11,"AV"],[8,0],[7,[0,2]]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,9471601586479112,[[11,"Accleration"],[7,[6,[19,cr.system_object.prototype.exps.dt],[0,10]]]]],[20,cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
null,7413239268141242,[[10,0],[7,[6,[19,cr.system_object.prototype.exps.dt],[0,10]]]]]]]]],[0,null,!1,216,[[-1,cr.system_object.prototype.cnds.Else,null,0,!1,!1,!1,217]],[[33,cr.plugins_.Particles.prototype.acts.SetSpraying,null,218,[[3,0]]],[34,cr.plugins_.Particles.prototype.acts.SetSpraying,null,219,[[3,0]]]]],[0,null,!1,227,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,228,[[11,"Countdown"],[8,3],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,229,[[11,"Accleration"],
[7,[6,[19,cr.system_object.prototype.exps.dt],[0,5]]]]],[20,cr.plugins_.Sprite.prototype.acts.AddInstanceVar,null,230,[[10,0],[7,[6,[19,cr.system_object.prototype.exps.dt],[0,5]]]]],[32,cr.plugins_.Sprite.prototype.acts.SetWidth,null,231,[[0,[21,20,!1,null,0]]]]]],[0,null,!1,5540549949957768,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xa3d0a4cdd1c4b,[[11,"Countdown"],[8,3],[7,[0,1]]]],[20,cr.plugins_.Sprite.prototype.cnds.IsOverlappingOffset,null,0,!1,!1,!1,5534236563979717,[[4,
23],[0,[0,0]],[0,[0,20]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,0xaf44f9a6af245,[[11,"Accleration"],[7,[6,[19,cr.system_object.prototype.exps.dt],[0,80]]]]],[20,cr.plugins_.Sprite.prototype.acts.AddInstanceVar,null,0xba88aa5c92bb9,[[10,0],[7,[6,[19,cr.system_object.prototype.exps.dt],[0,80]]]]],[32,cr.plugins_.Sprite.prototype.acts.SetWidth,null,0x8b2c1d64a9167,[[0,[21,20,!1,null,0]]]]]],[0,null,!1,0x6b9a4bcaa471e,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9948367406081312,
[[11,"Countdown"],[8,3],[7,[0,1]]]],[20,cr.plugins_.Sprite.prototype.cnds.IsOverlappingOffset,null,0,!1,!1,!1,6037940624358055,[[4,85],[0,[0,0]],[0,[0,20]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,0xc6f3972c81343,[[11,"Accleration"],[7,[6,[19,cr.system_object.prototype.exps.dt],[0,80]]]]],[20,cr.plugins_.Sprite.prototype.acts.AddInstanceVar,null,5666295450557734,[[10,0],[7,[6,[19,cr.system_object.prototype.exps.dt],[0,80]]]]],[32,cr.plugins_.Sprite.prototype.acts.SetWidth,null,9297165779322152,
[[0,[21,20,!1,null,0]]]]]],[0,null,!1,232,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,233,[[11,"Accleration"],[8,5],[7,[0,201]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,234,[[11,"Accleration"],[7,[0,200]]]],[20,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,235,[[10,0],[7,[0,200]]]]]]]],[0,[!0,"Animations"],!1,8998950799008162,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8998950799008162,[[1,[2,"Animations"]]]]],[],[[0,null,!1,247,[[-1,cr.system_object.prototype.cnds.EveryTick,
null,0,!1,!1,!1,248]],[[22,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,249,[[4,21],[7,[0,0]]]],[22,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,250,[[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[22,cr.plugins_.Sprite.prototype.acts.SetWidth,null,251,[[0,[19,cr.system_object.prototype.exps.distance,[[20,21,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,21,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,
cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]]]],[0,null,!1,258,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,259,[[7,[20,16,cr.plugins_.Touch.prototype.exps.X,!1,null]],[8,2],[7,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]],[16,cr.plugins_.Touch.prototype.cnds.IsInTouch,null,0,!1,!1,!1,260]],[[20,cr.plugins_.Sprite.prototype.acts.SetMirrored,null,261,[[3,1]]],[21,cr.plugins_.Sprite.prototype.acts.SetMirrored,null,262,
[[3,1]]]]],[0,null,!1,263,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,264,[[7,[20,16,cr.plugins_.Touch.prototype.exps.X,!1,null]],[8,5],[7,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[20,cr.plugins_.Sprite.prototype.acts.SetMirrored,null,265,[[3,0]]],[21,cr.plugins_.Sprite.prototype.acts.SetMirrored,null,266,[[3,0]]]]],[0,null,!1,267,[[22,cr.plugins_.Sprite.prototype.cnds.CompareWidth,null,0,!1,!1,!1,268,[[8,5],[0,[0,100]]]]],[[22,cr.plugins_.Sprite.prototype.acts.Destroy,
null,269]]],[0,null,!1,270,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,271]],[[37,cr.plugins_.Sprite.prototype.acts.SetAnim,null,272,[[1,[2,"Money"]],[3,1]]]]]]],[0,[!0,"Globaldestroy"],!1,984515088173031,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,984515088173031,[[1,[2,"Globaldestroy"]]]]],[],[[0,null,!1,0x881ec2574e54f,[[23,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xf0c57801c35d0,[[4,21]]]],[[-1,cr.system_object.prototype.acts.Wait,
null,0xffc3094137c85,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.acts.SubVar,null,9882390955283360,[[11,"Lifes"],[7,[0,1]]]],[20,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",0xcd61a03a608e8,[[0,[0,1]],[0,[0,90]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,6737987769631154,[[1,[2,"acell"]],[3,0]]],[33,cr.plugins_.Particles.prototype.acts.SetSpraying,null,7051693512982819,[[3,0]]],[34,cr.plugins_.Particles.prototype.acts.SetSpraying,null,969505372042308,
[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,4854920511493597,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,4646510795107868,[[1,[2,"acell"]],[3,1]]]]],[0,null,!1,6731590034759578,[[85,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7780609557010072,[[4,21]]]],[[-1,cr.system_object.prototype.acts.Wait,null,7599115790196475,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.acts.SubVar,null,5372398833234428,[[11,"Lifes"],[7,[0,1]]]],[20,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,
"Physics",0xb3ac2d114c046,[[0,[0,1]],[0,[0,90]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,6204346496988688,[[1,[2,"acell"]],[3,0]]],[33,cr.plugins_.Particles.prototype.acts.SetSpraying,null,0xc66c42cfb8f7e,[[3,0]]],[34,cr.plugins_.Particles.prototype.acts.SetSpraying,null,97319605385624,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,0x996eb85b3d81f,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,823133566821365,[[1,[2,"acell"]],[3,1]]]]],[0,
null,!1,274,[[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,275,[[4,84]]]],[[21,cr.plugins_.Sprite.prototype.acts.SetOpacity,null,0xe18406eb30a3,[[0,[0,0]]]],[20,cr.plugins_.Sprite.prototype.acts.Destroy,null,277],[22,cr.plugins_.Sprite.prototype.acts.Destroy,null,278],[-1,cr.system_object.prototype.acts.Wait,null,279,[[0,[0,2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,280,[[6,"Click to play"]]]]],[0,null,!1,281,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,
!1,!1,282,[[7,[23,"Lifes"]],[8,0],[7,[0,3]]]]],[[21,cr.plugins_.Sprite.prototype.acts.SetAnim,null,283,[[1,[2,"tri"]],[3,1]]]]],[0,null,!1,9743690021232736,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,8828217510480927,[[7,[23,"Lifes"]],[8,0],[7,[0,2]]]]],[[21,cr.plugins_.Sprite.prototype.acts.SetAnim,null,8812970138895251,[[1,[2,"dva"]],[3,1]]]]],[0,null,!1,284,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,285,[[11,"Lifes"],[8,0],[7,[0,1]]]]],[[21,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,286,[[1,[2,"odin"]],[3,1]]]]],[0,null,!1,287,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,288,[[7,[23,"Lifes"]],[8,3],[7,[0,0]]]]],[[20,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,9439250625382102,[[0,[0,1]]]],[21,cr.plugins_.Sprite.prototype.acts.Destroy,null,6421010918677183],[21,cr.plugins_.Sprite.prototype.acts.Spawn,null,7917779044655863,[[4,60],[5,[0,4]],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,8225446890927386,[[0,[1,1.2]]]],[20,cr.plugins_.Sprite.prototype.acts.Destroy,
null,5889199066570616],[20,cr.plugins_.Sprite.prototype.acts.Spawn,null,44103672703858,[[4,60],[5,[0,4]],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,4929424520639709,[[0,[1,0.6]]]],[117,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc05918244835],[117,cr.plugins_.Sprite.prototype.acts.Spawn,null,8119065261289139,[[4,60],[5,[0,4]],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,778545103323554,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x6d665e5b1c25a],
[-1,cr.system_object.prototype.acts.SetGroupActive,null,8278721915617595,[[1,[2,"acell"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,4604588895294108,[[1,[2,"WatherRocket"]],[3,0]]],[22,cr.plugins_.Sprite.prototype.acts.Destroy,null,9389637938954920],[-1,cr.system_object.prototype.acts.Wait,null,0x94006ada30894,[[0,[0,2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,9430481932692096,[[6,"Click to play"]]],[-1,cr.system_object.prototype.acts.SetGroupActive,null,0x9baaf0c9b6b0c,
[[1,[2,"SpawnEnemys"]],[3,1]]]]]]],[0,[!0,"Smoke"],!1,8462426616200162,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8462426616200162,[[1,[2,"Smoke"]]]]],[],[[0,null,!1,1137,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,1138]],[[70,cr.plugins_.Sprite.prototype.acts.Destroy,null,1166],[71,cr.plugins_.Sprite.prototype.acts.Destroy,null,1167]]],[0,null,!1,1134,[[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,1135,[[4,69]]]],[[69,cr.plugins_.Sprite.prototype.acts.Destroy,
null,1148],[68,cr.plugins_.Sprite.prototype.acts.SetAnim,null,1190,[[1,[2,"SmokeActive"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,1191,[[0,[0,1]]]],[68,cr.plugins_.Sprite.prototype.acts.Spawn,null,1176,[[4,70],[5,[0,7]],[7,[0,0]]]],[68,cr.plugins_.Sprite.prototype.acts.Spawn,null,1181,[[4,71],[5,[0,7]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x97595e66d1367,[[0,[0,8]]]],[70,cr.plugins_.Sprite.prototype.acts.Destroy,null,8615291554015192],[71,cr.plugins_.Sprite.prototype.acts.Destroy,
null,5026690426248171]]],[0,null,!1,1149,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,1150,[[0,[1,0.5]]]]],[[70,cr.behaviors.Pathfinding.prototype.acts.FindPath,"Pathfinding",1170,[[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[71,cr.behaviors.Pathfinding.prototype.acts.FindPath,"Pathfinding",1171,[[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[0,
null,!1,1172,[[70,cr.behaviors.Pathfinding.prototype.cnds.OnPathFound,"Pathfinding",1,!1,!1,!1,1173]],[[70,cr.behaviors.Pathfinding.prototype.acts.StartMoving,"Pathfinding",1174],[70,cr.behaviors.Pathfinding.prototype.acts.SetMaxSpeed,"Pathfinding",1175,[[0,[0,300]]]]]],[0,null,!1,1177,[[71,cr.behaviors.Pathfinding.prototype.cnds.OnPathFound,"Pathfinding",1,!1,!1,!1,1178]],[[71,cr.behaviors.Pathfinding.prototype.acts.StartMoving,"Pathfinding",1179],[71,cr.behaviors.Pathfinding.prototype.acts.SetMaxSpeed,
"Pathfinding",1180,[[0,[0,270]]]]]],[0,null,!0,1182,[[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,1183,[[4,68]]],[144,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xd369b5ebb8d26,[[4,68]]]],[[70,cr.plugins_.Sprite.prototype.acts.Destroy,null,1188],[71,cr.plugins_.Sprite.prototype.acts.Destroy,null,1189],[68,cr.plugins_.Sprite.prototype.acts.Destroy,null,1184],[68,cr.plugins_.Sprite.prototype.acts.Spawn,null,1185,[[4,60],[5,[0,4]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,
null,1186,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,1187],[-1,cr.system_object.prototype.acts.SetVar,null,0x5489a4b7a0fa1,[[11,"Smoke"],[7,[0,0]]]]]]]],[0,[!0,"Alien"],!1,0x69c1c60be7b76,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x69c1c60be7b76,[[1,[2,"Alien"]]]]],[],[[0,null,!1,1195,[[72,cr.plugins_.Sprite.prototype.cnds.CompareX,null,0,!1,!1,!1,1196,[[8,2],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[72,cr.plugins_.Sprite.prototype.acts.SetMirrored,
null,1197,[[3,1]]]]],[0,null,!1,1198,[[72,cr.plugins_.Sprite.prototype.cnds.CompareX,null,0,!1,!1,!1,1199,[[8,5],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[72,cr.plugins_.Sprite.prototype.acts.SetMirrored,null,1200,[[3,0]]]]],[0,null,!1,1201,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,1202,[[0,[1,0.5]]]]],[[72,cr.behaviors.Pathfinding.prototype.acts.FindPath,"Pathfinding",1204,[[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,
!1,null],[0,150]]]]]]],[0,null,!1,1206,[[72,cr.behaviors.Pathfinding.prototype.cnds.OnPathFound,"Pathfinding",1,!1,!1,!1,1207],[72,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,1209]],[[72,cr.behaviors.Pathfinding.prototype.acts.StartMoving,"Pathfinding",1210],[72,cr.behaviors.Pathfinding.prototype.acts.SetMaxSpeed,"Pathfinding",1205,[[0,[0,130]]]]]],[0,null,!1,1217,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,1218,[[4,73]]]],[[20,cr.behaviors.Physics.prototype.acts.ApplyForceToward,
"Physics",1219,[[0,[1,1.8]],[0,[20,72,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,72,cr.plugins_.Sprite.prototype.exps.Y,!1,null]],[7,[0,0]]]],[72,cr.behaviors.Pathfinding.prototype.acts.SetEnabled,"Pathfinding",1223,[[3,1]]]]],[0,null,!1,0x3e44603c5f7f1,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,4892305811149986,[[0,[0,3]]]]],[[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,346443680987165,[[4,72],[7,[0,0]]]]]]]],[0,[!0,"Roach"],!1,8013289425260288,[[-1,cr.system_object.prototype.cnds.IsGroupActive,
null,0,!1,!1,!1,8013289425260288,[[1,[2,"Roach"]]]]],[],[[0,null,!1,436,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,52281835340427,[[7,[19,cr.system_object.prototype.exps.distance,[[20,61,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,61,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[8,2],[7,[0,500]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,450,[[0,[0,2]]]]],
[[61,cr.plugins_.Sprite.prototype.acts.SetAnim,null,438,[[1,[2,"Ractiv"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,455,[[0,[1,0.45]]]],[61,cr.plugins_.Sprite.prototype.acts.Spawn,null,451,[[4,62],[5,[0,4]],[7,[0,0]]]],[62,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",452,[[0,[0,-120]]]],[62,cr.behaviors.Bullet.prototype.acts.SetGravity,"Bullet",453,[[0,[0,200]]]],[62,cr.behaviors.Bullet.prototype.acts.SetSpeed,"Bullet",454,[[0,[0,270]]]]]],[0,null,!1,456,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,457,[[4,20]]]],[[62,cr.behaviors.Bullet.prototype.acts.Bounce,"Bullet",458,[[4,20]]],[20,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",464,[[0,[0,3]],[0,[0,135]],[7,[0,0]]]]]],[0,null,!1,460,[[62,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,461,[[4,21]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,462,[[11,"Lifes"],[7,[0,1]]]],[62,cr.behaviors.Bullet.prototype.acts.Bounce,"Bullet",463,[[4,21]]]]],[0,null,!1,439,[[61,cr.plugins_.Sprite.prototype.cnds.CompareX,
null,0,!1,!1,!1,440,[[8,5],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,500]]]]]],[[61,cr.plugins_.Sprite.prototype.acts.SetAnim,null,441,[[1,[2,"Rpass"]],[3,1]]]]],[0,null,!0,465,[[61,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,466,[[4,20]]],[61,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4645070240104735,[[4,144]]]],[[61,cr.plugins_.Sprite.prototype.acts.Destroy,null,467],[-1,cr.system_object.prototype.acts.SetVar,null,9357019412211964,[[11,"Roach"],
[7,[0,0]]]],[61,cr.plugins_.Sprite.prototype.acts.Spawn,null,468,[[4,60],[5,[0,4]],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,469,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,470]]]]],[0,[!0,"Slizen"],!1,637829854813961,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,637829854813961,[[1,[2,"Slizen"]]]]],[],[[0,null,!1,1280,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,1281,[[7,[19,cr.system_object.prototype.exps.distance,[[20,76,
cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,76,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[8,2],[7,[0,600]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,1293,[[0,[19,cr.system_object.prototype.exps.random,[[0,2],[1,3.5]]]]]]],[[76,cr.plugins_.Sprite.prototype.acts.SetAnim,null,1288,[[1,[2,"SlizenActive"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,1298,[[0,[1,
0.55]]]],[76,cr.plugins_.Sprite.prototype.acts.Spawn,null,1296,[[4,77],[5,[0,4]],[7,[0,1]]]],[77,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,1304,[[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[-1,cr.system_object.prototype.acts.Wait,null,1299,[[0,[1,1.7]]]],[77,cr.plugins_.Sprite.prototype.acts.Destroy,null,1300]]],[0,null,!1,1285,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,1286,[[7,[19,cr.system_object.prototype.exps.distance,
[[20,76,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,76,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[8,5],[7,[0,420]]]]],[[76,cr.plugins_.Sprite.prototype.acts.SetAnim,null,1289,[[1,[2,"Slizen"]],[3,1]]]]],[0,null,!1,1306,[[20,cr.plugins_.Sprite.prototype.cnds.IsOverlapping,null,0,!1,!1,!1,1307,[[4,77]]]],[[20,cr.behaviors.Physics.prototype.acts.ApplyForceToward,"Physics",1308,[[0,[0,9]],
[0,[20,77,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,77,cr.plugins_.Sprite.prototype.exps.Y,!1,null]],[7,[0,0]]]]]],[0,null,!0,7426407953139406,[[76,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8534420045914854,[[4,20]]],[76,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7711345150017822,[[4,144]]]],[[76,cr.plugins_.Sprite.prototype.acts.Destroy,null,4626937760923615],[-1,cr.system_object.prototype.acts.SetVar,null,0x3d0aa48d515e2,[[11,"Slizen"],[7,[0,0]]]],
[76,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xbfa1c71c672ea,[[4,60],[5,[0,4]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x9aa30db92236a,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xae03731389dff]]]]],[0,[!0,"Kaktus"],!1,6294302445954607,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6294302445954607,[[1,[2,"Kaktus"]]]]],[],[[0,null,!1,611,[[44,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,612,[[8,5],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,
!1,null],[0,250]]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,613,[[0,[0,5]]]]],[[44,cr.plugins_.Sprite.prototype.acts.SetAnim,null,615,[[1,[2,"KaktusActive"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,625,[[0,[1,0.45]]]],[44,cr.plugins_.Sprite.prototype.acts.Spawn,null,619,[[4,45],[5,[0,4]],[7,[0,1]]]],[44,cr.plugins_.Sprite.prototype.acts.Spawn,null,626,[[4,46],[5,[0,4]],[7,[0,2]]]],[45,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,620,[[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,
!1,null]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[46,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,631,[[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,100]]]]]]],[0,null,!1,659,[[44,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,660,[[8,2],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,250]]]]]],[[44,cr.plugins_.Sprite.prototype.acts.SetAnim,null,661,[[1,[2,"Kaktus"]],[3,1]]]]],
[0,null,!1,632,[[44,cr.plugins_.Sprite.prototype.cnds.CompareX,null,0,!1,!1,!1,633,[[8,3],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[44,cr.plugins_.Sprite.prototype.acts.SetMirrored,null,634,[[3,0]]]]],[0,null,!1,635,[[44,cr.plugins_.Sprite.prototype.cnds.CompareX,null,0,!1,!1,!1,636,[[8,4],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[44,cr.plugins_.Sprite.prototype.acts.SetMirrored,null,637,[[3,1]]]]],[0,null,!1,638,[[46,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,639,[[4,21]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,645,[[11,"Lifes"],[7,[0,1]]]],[46,cr.plugins_.Sprite.prototype.acts.Destroy,null,641],[46,cr.plugins_.Sprite.prototype.acts.Spawn,null,642,[[4,60],[5,[0,4]],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,643,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,644]]],[0,null,!1,646,[[45,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,647,[[4,21]]]],[[-1,cr.system_object.prototype.acts.SubVar,
null,648,[[11,"Lifes"],[7,[0,1]]]],[45,cr.plugins_.Sprite.prototype.acts.Destroy,null,649],[45,cr.plugins_.Sprite.prototype.acts.Spawn,null,650,[[4,60],[5,[0,4]],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,651,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,652]]],[0,null,!0,653,[[44,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,654,[[4,20]]],[44,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5239120778619418,[[4,144]]]],[[44,cr.plugins_.Sprite.prototype.acts.Destroy,
null,655],[-1,cr.system_object.prototype.acts.SetVar,null,5108206804952187,[[11,"Kaktus"],[7,[0,0]]]],[44,cr.plugins_.Sprite.prototype.acts.Spawn,null,656,[[4,60],[5,[0,4]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,657,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,658]]]]],[0,[!0,"Batman"],!1,8443159025558665,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8443159025558665,[[1,[2,"Batman"]]]]],[],[[0,null,!1,573,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,574]],[[43,cr.plugins_.Sprite.prototype.acts.Destroy,null,575]]],[0,null,!1,576,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,577,[[0,[19,cr.system_object.prototype.exps.random,[[0,4],[0,8]]]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,578,[[4,43],[5,[0,4]],[0,[19,cr.system_object.prototype.exps.choose,[[4,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,305]],[5,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[0,305]]]]],[0,[19,cr.system_object.prototype.exps.random,
[[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,200]],[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,250]]]]]]],[-1,cr.system_object.prototype.acts.Wait,null,588,[[0,[0,4]]]],[43,cr.plugins_.Sprite.prototype.acts.Destroy,null,589],[43,cr.plugins_.Sprite.prototype.acts.Spawn,null,590,[[4,60],[5,[0,4]],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,602,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,591],[43,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,
null,6743315699624933,[[0,[20,21,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[4,[20,21,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,100]]]]]]],[0,null,!1,517502983335388,[[43,cr.plugins_.Sprite.prototype.cnds.CompareX,null,0,!1,!1,!1,4701198265700727,[[8,5],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[43,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",5001890738717478,[[0,[0,180]]]]]],[0,null,!1,592,[[43,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,
!1,!0,593,[[4,21]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,594,[[11,"Lifes"],[7,[0,1]]]],[43,cr.plugins_.Sprite.prototype.acts.Destroy,null,595],[43,cr.plugins_.Sprite.prototype.acts.Spawn,null,596,[[4,60],[5,[0,4]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,604,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,605]]],[0,null,!1,597,[[43,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,598,[[4,20]]]],[[20,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,
"Physics",599,[[0,[1,2.5]],[0,[0,90]],[7,[0,0]]]],[43,cr.plugins_.Sprite.prototype.acts.Destroy,null,600],[43,cr.plugins_.Sprite.prototype.acts.Spawn,null,601,[[4,60],[5,[0,4]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,607,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,606]]],[0,null,!1,5553266413439906,[[43,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5565964321090926,[[4,144]]]],[[43,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x9ece9b9cd65a3],
[43,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x8bfd77343d085,[[4,60],[5,[0,4]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,9923078379484912,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,9983417318111996]]],[0,null,!1,9570411642026248,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,7167417764043144,[[4,43]]]],[[43,cr.plugins_.Sprite.prototype.acts.Destroy,null,6887454046938114],[43,cr.plugins_.Sprite.prototype.acts.Spawn,null,7590362386350949,
[[4,60],[5,[0,4]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,5297042316093769,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,8964206618295637]]]]],[0,[!0,"Dragon"],!1,0xadc068d1b6af7,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xadc068d1b6af7,[[1,[2,"Dragon"]]]]],[],[[0,null,!1,717,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,718]],[]],[0,null,!1,719,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,720,[[0,[1,
0.5]]]]],[[47,cr.behaviors.Pathfinding.prototype.acts.FindPath,"Pathfinding",721,[[0,[7,[4,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[19,cr.system_object.prototype.exps.layoutwidth]],[0,2]]],[0,[20,21,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[0,null,!1,722,[[47,cr.behaviors.Pathfinding.prototype.cnds.OnPathFound,"Pathfinding",1,!1,!1,!1,723]],[[47,cr.behaviors.Pathfinding.prototype.acts.StartMoving,"Pathfinding",725],[47,cr.behaviors.Pathfinding.prototype.acts.SetMaxSpeed,"Pathfinding",
726,[[0,[0,200]]]]]],[0,null,!1,727,[[47,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,728,[[4,21]]]],[[-1,cr.system_object.prototype.acts.Wait,null,730,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.acts.SubVar,null,731,[[11,"Lifes"],[7,[0,1]]]],[47,cr.plugins_.Sprite.prototype.acts.Destroy,null,746],[47,cr.plugins_.Sprite.prototype.acts.Spawn,null,747,[[4,60],[5,[0,4]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,748,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,
null,749]]],[0,null,!0,737,[[47,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,738,[[4,20]]],[47,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xaf8f1d75e4aef,[[4,144]]]],[[47,cr.plugins_.Sprite.prototype.acts.Destroy,null,739],[-1,cr.system_object.prototype.acts.SetVar,null,8789191288690908,[[11,"Dragon"],[7,[0,0]]]],[47,cr.plugins_.Sprite.prototype.acts.Spawn,null,740,[[4,60],[5,[0,4]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,741,[[0,[1,0.6]]]],[60,
cr.plugins_.Sprite.prototype.acts.Destroy,null,742]]],[0,null,!1,752,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,753,[[0,[0,2]]]]],[[47,cr.plugins_.Sprite.prototype.acts.Spawn,null,754,[[4,48],[5,[0,4]],[7,[0,1]]]]]],[0,null,!1,757,[[48,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,758,[[4,21]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,760,[[11,"Lifes"],[7,[0,1]]]],[48,cr.plugins_.Sprite.prototype.acts.Destroy,null,759],[48,cr.plugins_.Sprite.prototype.acts.Spawn,
null,761,[[4,60],[5,[0,4]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,762,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,763]]],[0,null,!1,764,[[48,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,765,[[4,20]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,766,[[11,"Lifes"],[7,[0,1]]]],[48,cr.plugins_.Sprite.prototype.acts.Destroy,null,767],[48,cr.plugins_.Sprite.prototype.acts.Spawn,null,768,[[4,60],[5,[0,2]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,
null,769,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,770]]]]],[0,[!0,"Devil"],!1,7795314252088096,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7795314252088096,[[1,[2,"Devil"]]]]],[],[[0,null,!1,485,[[38,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,486,[[10,0],[8,0],[7,[2,"right"]]]]],[[38,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",499,[[3,1]]],[38,cr.plugins_.Sprite.prototype.acts.SetMirrored,null,500,[[3,1]]],
[42,cr.plugins_.Sprite.prototype.acts.SetMirrored,null,549,[[3,1]]],[41,cr.plugins_.Sprite.prototype.acts.SetMirrored,null,551,[[3,1]]]]],[0,null,!1,501,[[38,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,502,[[10,0],[8,0],[7,[2,"left"]]]]],[[38,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",503,[[3,0]]],[38,cr.plugins_.Sprite.prototype.acts.SetMirrored,null,504,[[3,0]]],[41,cr.plugins_.Sprite.prototype.acts.SetMirrored,null,547,[[3,0]]],[42,cr.plugins_.Sprite.prototype.acts.SetMirrored,
null,550,[[3,0]]]]],[0,null,!1,505,[[38,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,506,[[4,39]]]],[[38,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,510,[[10,0],[7,[2,"left"]]]]]],[0,null,!1,518,[[38,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,519,[[4,40]]]],[[38,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,520,[[10,0],[7,[2,"right"]]]]]],[0,null,!1,527,[[38,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,528]],[[41,cr.behaviors.Pin.prototype.acts.Pin,
"Pin",529,[[4,38],[3,0]]],[42,cr.behaviors.Pin.prototype.acts.Pin,"Pin",548,[[4,38],[3,0]]]]],[0,null,!1,552,[[41,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,553,[[4,20]]]],[[20,cr.plugins_.Sprite.prototype.acts.Spawn,null,555,[[4,31],[5,[0,3]],[7,[0,0]]]],[20,cr.plugins_.Sprite.prototype.acts.Destroy,null,556],[22,cr.plugins_.Sprite.prototype.acts.Destroy,null,557],[-1,cr.system_object.prototype.acts.Wait,null,558,[[0,[0,2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,
559,[[6,"Click to play"]]]]],[0,null,!1,560,[[42,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,561,[[4,20]]]],[[41,cr.plugins_.Sprite.prototype.acts.Destroy,null,562],[42,cr.plugins_.Sprite.prototype.acts.Destroy,null,563],[39,cr.plugins_.Sprite.prototype.acts.Destroy,null,564],[40,cr.plugins_.Sprite.prototype.acts.Destroy,null,565],[38,cr.plugins_.Sprite.prototype.acts.Destroy,null,566],[38,cr.plugins_.Sprite.prototype.acts.Spawn,null,567,[[4,60],[5,[0,2]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,
null,568,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,569]]]]],[0,[!0,"Fish"],!1,8083423126543581,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8083423126543581,[[1,[2,"Fish"]]]]],[],[[0,null,!1,385,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,386]],[[36,cr.plugins_.Sprite.prototype.acts.Destroy,null,387]]],[0,null,!1,388,[[36,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,389,[[4,20]]]],[[21,cr.plugins_.Sprite.prototype.acts.SetOpacity,
null,6814984262093867,[[0,[0,0]]]],[20,cr.plugins_.Sprite.prototype.acts.Destroy,null,390],[-1,cr.system_object.prototype.acts.Wait,null,391,[[0,[0,2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,392,[[6,"Click to play"]]]]],[0,null,!1,393,[[36,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,394,[[4,7]]]],[[7,cr.plugins_.Sprite.prototype.acts.Destroy,null,395]]],[0,null,!1,396,[[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,397,[[4,27]]]],[[-1,cr.system_object.prototype.acts.Wait,
null,5564725562323533,[[0,[1,0.3]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,398,[[4,36],[5,[0,5]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,360]]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x8336287db1db9,[[0,[1,0.2]]]],[36,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,401,[[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[-1,cr.system_object.prototype.acts.Wait,
null,404,[[0,[0,5]]]],[36,cr.plugins_.Sprite.prototype.acts.Destroy,null,405]]]]],[0,[!0,"Boo"],!1,0x4441569fd378e,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x4441569fd378e,[[1,[2,"Boo"]]]]],[],[[0,null,!1,786,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0x5fbae1ff79e5f,[[7,[19,cr.system_object.prototype.exps.distance,[[20,49,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,49,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,
!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[8,2],[7,[0,300]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,788,[[0,[0,5]]]]],[[49,cr.plugins_.Sprite.prototype.acts.SetAnim,null,789,[[1,[2,"BooActive"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,790,[[0,[1,0.45]]]],[-1,cr.system_object.prototype.acts.Wait,null,851,[[0,[1,0.0010]]]],[49,cr.plugins_.Sprite.prototype.acts.Spawn,null,791,[[4,63],[5,[0,3]],[7,[0,0]]]],[63,cr.plugins_.Sprite.prototype.acts.SetAngle,
null,794,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,907,[[0,[1,0.7]]]],[63,cr.plugins_.Sprite.prototype.acts.Destroy,null,908]]],[0,null,!1,909,[[63,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,910,[[4,20]]]],[[20,cr.plugins_.Sprite.prototype.acts.Destroy,null,913],[20,cr.plugins_.Sprite.prototype.acts.Spawn,null,912,[[4,60],[5,[0,2]],[7,[0,0]]]],[22,cr.plugins_.Sprite.prototype.acts.Destroy,null,914],[-1,cr.system_object.prototype.acts.Wait,null,915,[[0,[0,2]]]],
[-1,cr.system_object.prototype.acts.GoToLayout,null,916,[[6,"Click to play"]]]]],[0,null,!1,8969034078944001,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,6727395509807326,[[7,[19,cr.system_object.prototype.exps.distance,[[20,49,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,49,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[8,5],[7,[0,300]]]]],[[49,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,8493158266753321,[[1,[2,"Boo"]],[3,1]]]]],[0,null,!0,900403803818564,[[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9090598319659868,[[4,49]]],[144,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9203389180148746,[[4,49]]]],[[49,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xf3b772e6810b2],[49,cr.plugins_.Sprite.prototype.acts.Spawn,null,6464241499336687,[[4,60],[5,[0,4]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,5297526929622306,[[0,[1,0.6]]]],
[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,7960598830944388],[-1,cr.system_object.prototype.acts.SetVar,null,0xee0836af393a9,[[11,"Smoke"],[7,[0,0]]]]]]]],[0,[!0,"Ghost"],!1,26024526398516,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,26024526398516,[[1,[2,"Ghost"]]]]],[],[[0,[!0,"change state"],!1,965,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,965,[[1,[2,"change state"]]]]],[],[[0,null,!1,992,[[64,cr.plugins_.Sprite.prototype.cnds.PickDistance,
null,0,!1,!1,!0,993,[[3,0],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]],[],[[0,null,!1,966,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,967,[[7,[19,cr.system_object.prototype.exps.distance,[[20,64,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,64,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[8,2],[7,[0,350]]]],
[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,1004,[[0,[1,1]]]]],[[64,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,968,[[10,0],[7,[2,"Alarm"]]]],[64,cr.behaviors.Pathfinding.prototype.acts.FindPath,"Pathfinding",1005,[[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,50]]]]]]],[0,null,!1,972,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,973,[[7,[19,cr.system_object.prototype.exps.distance,[[20,64,
cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,64,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[8,5],[7,[0,350]]]]],[[64,cr.plugins_.Sprite.prototype.acts.SetInstanceVar,null,974,[[10,0],[7,[2,"Normal"]]]]]]]]]],[0,null,!1,942,[[64,cr.plugins_.Sprite.prototype.cnds.CompareX,null,0,!1,!1,!1,943,[[8,2],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[64,cr.plugins_.Sprite.prototype.acts.SetMirrored,
null,944,[[3,0]]]]],[0,null,!1,945,[[64,cr.plugins_.Sprite.prototype.cnds.CompareX,null,0,!1,!1,!1,946,[[8,5],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[64,cr.plugins_.Sprite.prototype.acts.SetMirrored,null,947,[[3,1]]]]],[0,null,!1,959,[[64,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,960,[[10,0],[8,0],[7,[2,"Normal"]]]]],[[64,cr.plugins_.Sprite.prototype.acts.SetAnim,null,963,[[1,[2,"Ghost"]],[3,1]]],[64,cr.plugins_.Sprite.prototype.acts.SetOpacity,null,
969,[[0,[0,30]]]]]],[0,null,!1,961,[[64,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,962,[[10,0],[8,0],[7,[2,"Alarm"]]]]],[[64,cr.plugins_.Sprite.prototype.acts.SetAnim,null,964,[[1,[2,"GhostActive"]],[3,1]]],[64,cr.plugins_.Sprite.prototype.acts.SetOpacity,null,975,[[0,[0,100]]]]]],[0,null,!1,1006,[[64,cr.behaviors.Pathfinding.prototype.cnds.OnPathFound,"Pathfinding",1,!1,!1,!1,1007],[64,cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,null,0,!1,!1,!1,1010,[[10,0],[8,
0],[7,[2,"Alarm"]]]]],[[64,cr.behaviors.Pathfinding.prototype.acts.StartMoving,"Pathfinding",1008],[64,cr.behaviors.Pathfinding.prototype.acts.SetMaxSpeed,"Pathfinding",1009,[[0,[0,150]]]]]],[0,null,!1,1015,[[64,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,1016,[[4,20]]]],[[20,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",1017,[[0,[0,2]],[0,[0,90]],[7,[0,0]]]]]],[0,null,!1,7698916597287497,[[144,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8981640092489836,
[[4,64]]]],[[64,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x9727bec86d6a3],[64,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xb2595c7b94380,[[4,60],[5,[0,4]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,5993971388702582,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,4732897592409286],[-1,cr.system_object.prototype.acts.SetVar,null,7672844575670848,[[11,"Smoke"],[7,[0,0]]]]]]]],[0,[!0,"Hypno"],!1,9642070135206148,[[-1,cr.system_object.prototype.cnds.IsGroupActive,
null,0,!1,!1,!1,9642070135206148,[[1,[2,"Hypno"]]]]],[],[[0,null,!1,1038,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,1039]],[[66,cr.plugins_.Sprite.prototype.acts.Destroy,null,1040]]],[0,null,!1,1022,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,1023,[[7,[19,cr.system_object.prototype.exps.distance,[[20,65,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,65,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,
cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[8,2],[7,[0,550]]]]],[[65,cr.plugins_.Sprite.prototype.acts.SetAnim,null,1024,[[1,[2,"HypnoActive"]],[3,1]]]]],[0,null,!1,1028,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,1029,[[7,[19,cr.system_object.prototype.exps.distance,[[20,65,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,65,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],
[8,5],[7,[0,550]]]]],[[65,cr.plugins_.Sprite.prototype.acts.SetAnim,null,1030,[[1,[2,"Hypno"]],[3,1]]]]],[0,null,!1,1031,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,1032,[[7,[19,cr.system_object.prototype.exps.distance,[[20,65,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,65,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[8,2],[7,[0,550]]]],[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,1034,[[0,[0,2]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,1033,[[4,66],[5,[0,4]],[0,[4,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[19,cr.system_object.prototype.exps.random,[[0,-200],[0,200]]]]],[0,[5,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,400]]]]],[-1,cr.system_object.prototype.acts.Wait,null,1050,[[0,[0,4]]]],[66,cr.plugins_.Sprite.prototype.acts.Destroy,null,1051],[66,cr.plugins_.Sprite.prototype.acts.Spawn,null,1052,[[4,60],[5,[0,4]],[7,
[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,1048,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,1049]]],[0,null,!0,1042,[[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,1043,[[4,65]]],[144,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6825407424874522,[[4,65]]]],[[65,cr.plugins_.Sprite.prototype.acts.Destroy,null,1044],[-1,cr.system_object.prototype.acts.SetVar,null,0xcae0e6d396af9,[[11,"Hypno"],[7,[0,0]]]],[65,cr.plugins_.Sprite.prototype.acts.Spawn,
null,1045,[[4,60],[5,[0,4]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,1046,[[0,[1,0.6]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5777301253566661,[[11,"Hypno"],[7,[0,0]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,1047]]],[0,null,!1,1053,[[66,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,1054,[[4,21]]]],[[66,cr.plugins_.Sprite.prototype.acts.Destroy,null,1055],[66,cr.plugins_.Sprite.prototype.acts.Spawn,null,1059,[[4,60],[5,[0,4]],[7,[0,0]]]],[-1,
cr.system_object.prototype.acts.SubVar,null,1056,[[11,"Lifes"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,1057,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,1058]]]]],[0,[!0,"Haha"],!1,8587762859284633,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8587762859284633,[[1,[2,"Haha"]]]]],[],[[0,null,!1,1072,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,1073]],[[67,cr.behaviors.Platform.prototype.acts.SetEnabled,"Platform",1074,
[[3,0]]]]],[0,null,!1,1067,[[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,1068,[[7,[19,cr.system_object.prototype.exps.distance,[[20,67,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,67,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[8,2],[7,[0,460]]]]],[[67,cr.plugins_.Sprite.prototype.acts.SetAnim,null,1069,[[1,[2,"HahaActive"]],[3,1]]],[67,cr.behaviors.Platform.prototype.acts.SetEnabled,
"Platform",1075,[[3,1]]],[67,cr.behaviors.Platform.prototype.acts.SimulateControl,"Platform",1077,[[3,0]]]]],[0,null,!1,1082,[[67,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,1083,[[4,20]]]],[[67,cr.plugins_.Sprite.prototype.acts.Destroy,null,1085],[-1,cr.system_object.prototype.acts.SetVar,null,0x69c67556140eb,[[11,"Haha"],[7,[0,0]]]],[67,cr.plugins_.Sprite.prototype.acts.Spawn,null,1086,[[4,60],[5,[0,2]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SubVar,null,1087,[[11,"Lifes"],
[7,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,1088,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,1089]]],[0,null,!1,1090,[[67,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,1091,[[4,21]]]],[[67,cr.plugins_.Sprite.prototype.acts.Destroy,null,1092],[-1,cr.system_object.prototype.acts.SetVar,null,5261701414501842,[[11,"Haha"],[7,[0,0]]]],[67,cr.plugins_.Sprite.prototype.acts.Spawn,null,1093,[[4,60],[5,[0,2]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SubVar,
null,1094,[[11,"Lifes"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,1095,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,1096]]]]],[0,[!0,"Robot"],!1,80312767243062,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,80312767243062,[[1,[2,"Robot"]]]]],[],[[0,null,!1,8407385443950324,[[74,cr.plugins_.Sprite.prototype.cnds.CompareX,null,0,!1,!1,!1,5013772555845783,[[8,3],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[74,cr.plugins_.Sprite.prototype.acts.SetMirrored,
null,0x4e141fa20a449,[[3,0]]]]],[0,null,!1,658294247073521,[[74,cr.plugins_.Sprite.prototype.cnds.CompareX,null,0,!1,!1,!1,0xe50a27306d5db,[[8,4],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[74,cr.plugins_.Sprite.prototype.acts.SetMirrored,null,0x7f01d56d12a6,[[3,1]]]]],[0,null,!1,7722020702221774,[[74,cr.plugins_.Sprite.prototype.cnds.CompareX,null,0,!1,!1,!1,6596395684611994,[[8,3],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetMirrored,
null,0xf570ebcc1dc95,[[3,0]]]]],[0,null,!1,0xc02fcfae71aff,[[74,cr.plugins_.Sprite.prototype.cnds.CompareX,null,0,!1,!1,!1,0x3fc3ba43d938e,[[8,4],[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetMirrored,null,0xb9f03cd3c9fb0,[[3,1]]]]],[0,null,!1,1241,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,1242,[[0,[0,5]]]]],[[74,cr.plugins_.Sprite.prototype.acts.Spawn,null,1245,[[4,75],[5,[0,7]],[7,[0,0]]]],[75,cr.behaviors.Pin.prototype.acts.Pin,
"Pin",1247,[[4,74],[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,1248,[[0,[1,3.5]]]],[75,cr.plugins_.Sprite.prototype.acts.Destroy,null,1249]]],[0,null,!1,1261,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,1262,[[4,20]]]],[[20,cr.plugins_.Sprite.prototype.acts.Destroy,null,1263],[-1,cr.system_object.prototype.acts.Wait,null,1264,[[0,[0,2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,1265,[[6,"Click to play"]]]]],[0,null,!1,1266,[[75,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,1267,[[4,21]]]],[[-1,cr.system_object.prototype.acts.SubVar,null,1268,[[11,"Lifes"],[7,[0,1]]]]]],[0,null,!0,1269,[[20,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,1270,[[4,74]]],[144,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5576509758403693,[[4,74]]]],[[75,cr.plugins_.Sprite.prototype.acts.Destroy,null,1271],[74,cr.plugins_.Sprite.prototype.acts.Destroy,null,1272],[-1,cr.system_object.prototype.acts.SetVar,null,0xa5bd99b47c047,[[11,"Robot"],[7,
[0,0]]]],[74,cr.plugins_.Sprite.prototype.acts.Spawn,null,1273,[[4,60],[5,[0,4]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,1274,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,1275],[-1,cr.system_object.prototype.acts.SetVar,null,9328936102602392,[[11,"Robot"],[7,[0,0]]]]]]]],[0,[!0,"Special"],!1,0xc249ff0cf91c7,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xc249ff0cf91c7,[[1,[2,"Special"]]]]],[],[[0,[!0,"Opponent1"],!1,4784016232869188,[[-1,
cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,4784016232869188,[[1,[2,"Opponent1"]]]]],[],[[0,null,!1,292,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,293]],[]],[0,null,!1,294,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,295,[[0,[1,1]]]]],[[7,cr.behaviors.Pathfinding.prototype.acts.FindPath,"Pathfinding",296,[[0,[20,21,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,21,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,20]]]]]]],[0,null,!1,
297,[[7,cr.behaviors.Pathfinding.prototype.cnds.OnPathFound,"Pathfinding",1,!1,!1,!1,298],[7,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,299]],[[7,cr.behaviors.Pathfinding.prototype.acts.StartMoving,"Pathfinding",300],[7,cr.behaviors.Pathfinding.prototype.acts.SetMaxSpeed,"Pathfinding",301,[[0,[0,100]]]]]],[0,null,!1,302,[[7,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,303,[[4,21]]]],[[7,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,5677983405186767,[[3,0]]],
[-1,cr.system_object.prototype.acts.Wait,null,305,[[0,[1,0.08]]]],[7,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,8736594866855122,[[3,1]]],[-1,cr.system_object.prototype.acts.SubVar,null,306,[[11,"Lifes"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6643684904590885,[[11,"Special1Countdown"],[7,[0,0]]]],[7,cr.plugins_.Sprite.prototype.acts.Destroy,null,9925017628083408],[7,cr.plugins_.Sprite.prototype.acts.Spawn,null,5563864784349981,[[4,60],[5,[0,4]],[7,[0,0]]]]]],[0,null,
!0,312,[[7,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,313,[[4,20]]],[7,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x62e7913a0bbe6,[[4,144]]]],[[7,cr.plugins_.Sprite.prototype.acts.Destroy,null,314],[7,cr.plugins_.Sprite.prototype.acts.Spawn,null,427,[[4,8],[5,[0,4]],[7,[0,0]]]],[8,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,22418558427311,[[3,0]]],[8,cr.behaviors.Flash.prototype.acts.Flash,"Flash",680289174638426,[[0,[1,0.1]],[0,[1,0.1]],[0,[0,1]]]],
[-1,cr.system_object.prototype.acts.Wait,null,0x733798301e427,[[0,[0,1]]]],[8,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,7401091918598039,[[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,428,[[0,[0,6]]]],[8,cr.behaviors.Flash.prototype.acts.Flash,"Flash",0xc9d35ed7eace5,[[0,[1,0.1]],[0,[1,0.1]],[0,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x609b1f12aeb9f,[[0,[1,0.7]]]],[8,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x51828abdd1ce3],[8,cr.plugins_.Sprite.prototype.acts.Spawn,
null,7963808433701163,[[4,7],[5,[0,4]],[7,[0,0]]]]]],[0,[!0,"Op1Knockout"],!1,0x66785640cc1bf,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x66785640cc1bf,[[1,[2,"Op1Knockout"]]]]],[],[[0,null,!0,0xe8add8281507,[[8,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x805eb3e4d4333,[[4,20]]],[8,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x7ace39b11f1b7,[[4,144]]]],[[8,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x5f98218a3a66],[-1,cr.system_object.prototype.acts.SetVar,
null,0x8511b603ed750,[[11,"Special1Countdown"],[7,[0,0]]]],[8,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xda3b515dee4e5,[[4,60],[5,[0,4]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,4662834877802304,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xeeac627ac4d5d]]]]]]],[0,[!0,"Opponent2"],!1,0xe7290cf013978,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xe7290cf013978,[[1,[2,"Opponent2"]]]]],[],[[0,null,!1,5127918579489182,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,443200973224648]],[]],[0,null,!1,8134141914816808,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xbaa43ce874d0f,[[0,[1,1.45]]]]],[[9,cr.behaviors.Pathfinding.prototype.acts.FindPath,"Pathfinding",0xfb8f5999179ee,[[0,[20,21,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,21,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,40]]]]]]],[0,null,!1,0xfc7c939b63a69,[[9,cr.behaviors.Pathfinding.prototype.cnds.OnPathFound,"Pathfinding",1,!1,!1,!1,0x5fc5e79cdcf00],[9,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!1,!1,9554001588442906]],[[9,cr.behaviors.Pathfinding.prototype.acts.StartMoving,"Pathfinding",0xad3ab08016f39],[9,cr.behaviors.Pathfinding.prototype.acts.SetMaxSpeed,"Pathfinding",0x778d3f4cba840,[[0,[0,110]]]]]],[0,null,!1,7576876807808021,[[9,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5031549476867486,[[4,21]]]],[[9,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,5532792187149466,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,6119054649128579,[[0,[1,0.08]]]],
[9,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0x84bbef994218,[[3,1]]],[-1,cr.system_object.prototype.acts.SubVar,null,0x81b5974f1eb6c,[[11,"Lifes"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5861115322774162,[[11,"Special2Countdown"],[7,[0,0]]]],[9,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x3bd95dd5dffb2],[9,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xdca854da4ffc3,[[4,60],[5,[0,4]],[7,[0,0]]]]]],[0,null,!0,7634983436010096,[[9,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,5551096787402984,[[4,20]]],[9,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,522373406293639,[[4,144]]]],[[9,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xaf128044938ee],[9,cr.plugins_.Sprite.prototype.acts.Spawn,null,910013095079704,[[4,10],[5,[0,4]],[7,[0,0]]]],[10,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,2627635592084,[[3,0]]],[10,cr.behaviors.Flash.prototype.acts.Flash,"Flash",5599108097794024,[[0,[1,0.1]],[0,[1,0.1]],[0,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,
null,9462612853542214,[[0,[0,1]]]],[10,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,6117813522618674,[[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,6884035226914747,[[0,[0,4]]]],[10,cr.behaviors.Flash.prototype.acts.Flash,"Flash",8139268564230922,[[0,[1,0.1]],[0,[1,0.1]],[0,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,4782379391712044,[[0,[1,0.7]]]],[10,cr.plugins_.Sprite.prototype.acts.Destroy,null,6968923719464568],[10,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xf675e780bebd0,
[[4,9],[5,[0,4]],[7,[0,0]]]]]],[0,[!0,"Op2Knockout"],!1,0x8290e224b1b16,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x8290e224b1b16,[[1,[2,"Op2Knockout"]]]]],[],[[0,null,!0,0xe8add8281507,[[10,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x805eb3e4d4333,[[4,20]]],[10,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,952778553091252,[[4,144]]]],[[10,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x5f98218a3a66],[-1,cr.system_object.prototype.acts.SetVar,
null,2863987145246,[[11,"Special2Countdown"],[7,[0,0]]]],[10,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xda3b515dee4e5,[[4,60],[5,[0,4]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,4662834877802304,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xeeac627ac4d5d]]]]]]],[0,[!0,"Opponent3"],!1,0x56fa17a7cd699,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x56fa17a7cd699,[[1,[2,"Opponent3"]]]]],[],[[0,null,!1,5127918579489182,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,443200973224648]],[]],[0,null,!1,8134141914816808,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xbaa43ce874d0f,[[0,[1,1.25]]]]],[[11,cr.behaviors.Pathfinding.prototype.acts.FindPath,"Pathfinding",0xfb8f5999179ee,[[0,[20,21,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,21,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,60]]]]]]],[0,null,!1,0xfc7c939b63a69,[[11,cr.behaviors.Pathfinding.prototype.cnds.OnPathFound,"Pathfinding",1,!1,!1,!1,0x5fc5e79cdcf00],[11,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!1,!1,9554001588442906]],[[11,cr.behaviors.Pathfinding.prototype.acts.StartMoving,"Pathfinding",0xad3ab08016f39],[11,cr.behaviors.Pathfinding.prototype.acts.SetMaxSpeed,"Pathfinding",0x778d3f4cba840,[[0,[0,135]]]]]],[0,null,!1,7576876807808021,[[11,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5031549476867486,[[4,21]]]],[[11,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,9570743010998776,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,6119054649128579,[[0,[1,
0.08]]]],[11,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0x836de4f9802bf,[[3,1]]],[-1,cr.system_object.prototype.acts.SubVar,null,0x81b5974f1eb6c,[[11,"Lifes"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xcffcd92efa937,[[11,"Special3Countdown"],[7,[0,0]]]],[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,8860773724075131],[11,cr.plugins_.Sprite.prototype.acts.Spawn,null,6541851248757893,[[4,60],[5,[0,4]],[7,[0,0]]]]]],[0,null,!0,7634983436010096,[[11,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,5551096787402984,[[4,20]]],[11,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6319813438560459,[[4,144]]]],[[11,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xaf128044938ee],[11,cr.plugins_.Sprite.prototype.acts.Spawn,null,910013095079704,[[4,12],[5,[0,4]],[7,[0,0]]]],[12,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,2627635592084,[[3,0]]],[12,cr.behaviors.Flash.prototype.acts.Flash,"Flash",5599108097794024,[[0,[1,0.1]],[0,[1,0.1]],[0,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,
null,9462612853542214,[[0,[0,1]]]],[12,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,6117813522618674,[[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,6884035226914747,[[0,[0,3]]]],[12,cr.behaviors.Flash.prototype.acts.Flash,"Flash",8139268564230922,[[0,[1,0.1]],[0,[1,0.1]],[0,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,4782379391712044,[[0,[1,0.7]]]],[12,cr.plugins_.Sprite.prototype.acts.Destroy,null,6968923719464568],[12,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xf675e780bebd0,
[[4,11],[5,[0,4]],[7,[0,0]]]]]],[0,[!0,"Op3Knockout"],!1,0x8290e224b1b16,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x8290e224b1b16,[[1,[2,"Op3Knockout"]]]]],[],[[0,null,!0,0xe8add8281507,[[12,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x805eb3e4d4333,[[4,20]]],[12,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8743463390794597,[[4,144]]]],[[12,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x5f98218a3a66],[-1,cr.system_object.prototype.acts.SetVar,
null,89293744812379,[[11,"Special3Countdown"],[7,[0,0]]]],[12,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xda3b515dee4e5,[[4,60],[5,[0,4]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,4662834877802304,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xeeac627ac4d5d]]]]]]],[0,[!0,"Opponent4"],!1,7465247910700259,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7465247910700259,[[1,[2,"Opponent4"]]]]],[],[[0,null,!1,5127918579489182,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,443200973224648]],[]],[0,null,!1,8134141914816808,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xbaa43ce874d0f,[[0,[0,1]]]]],[[13,cr.behaviors.Pathfinding.prototype.acts.FindPath,"Pathfinding",0xfb8f5999179ee,[[0,[20,21,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[5,[20,21,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[0,80]]]]]]],[0,null,!1,0xfc7c939b63a69,[[13,cr.behaviors.Pathfinding.prototype.cnds.OnPathFound,"Pathfinding",1,!1,!1,!1,0x5fc5e79cdcf00],[13,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!1,!1,9554001588442906]],[[13,cr.behaviors.Pathfinding.prototype.acts.StartMoving,"Pathfinding",0xad3ab08016f39],[13,cr.behaviors.Pathfinding.prototype.acts.SetMaxSpeed,"Pathfinding",0x778d3f4cba840,[[0,[0,150]]]]]],[0,null,!1,7576876807808021,[[13,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5031549476867486,[[4,21]]]],[[13,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,5138972571211319,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,6119054649128579,[[0,[1,
0.08]]]],[13,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,6702842030511296,[[3,1]]],[-1,cr.system_object.prototype.acts.SubVar,null,0x81b5974f1eb6c,[[11,"Lifes"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5442816654676931,[[11,"Special4Countdown"],[7,[0,0]]]],[13,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xda11484c02e0a],[13,cr.plugins_.Sprite.prototype.acts.Spawn,null,6885703302902566,[[4,60],[5,[0,4]],[7,[0,0]]]]]],[0,null,!0,7634983436010096,[[13,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,5551096787402984,[[4,20]]],[13,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8263956876273948,[[4,144]]]],[[13,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xaf128044938ee],[13,cr.plugins_.Sprite.prototype.acts.Spawn,null,910013095079704,[[4,14],[5,[0,4]],[7,[0,0]]]],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,2627635592084,[[3,0]]],[14,cr.behaviors.Flash.prototype.acts.Flash,"Flash",5599108097794024,[[0,[1,0.1]],[0,[1,0.1]],[0,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,
null,9462612853542214,[[0,[0,1]]]],[14,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,6117813522618674,[[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,6884035226914747,[[0,[1,1.7]]]],[14,cr.behaviors.Flash.prototype.acts.Flash,"Flash",8139268564230922,[[0,[1,0.1]],[0,[1,0.1]],[0,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,4782379391712044,[[0,[1,0.7]]]],[14,cr.plugins_.Sprite.prototype.acts.Destroy,null,6968923719464568],[14,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xf675e780bebd0,
[[4,13],[5,[0,4]],[7,[0,0]]]]]],[0,[!0,"Op4Knockout"],!1,0x8290e224b1b16,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x8290e224b1b16,[[1,[2,"Op4Knockout"]]]]],[],[[0,null,!0,0xe8add8281507,[[14,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x805eb3e4d4333,[[4,20]]],[14,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5961372292480385,[[4,144]]]],[[14,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x5f98218a3a66],[-1,cr.system_object.prototype.acts.SetVar,
null,4879499235404842,[[11,"Special4Countdown"],[7,[0,0]]]],[14,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xda3b515dee4e5,[[4,60],[5,[0,4]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,4662834877802304,[[0,[1,0.6]]]],[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xeeac627ac4d5d]]]]]]]]]]],["Click to play",[[1,"SETGLOBALS",0,0,!1,!1,77242819082337],[0,null,!1,6088893462073478,[[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,null,0,!1,!1,!1,0x6eb75ab6b301,[[1,[2,"SETGLOBALSSave"]],
[8,0],[0,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,6464429380436092,[[11,"SETGLOBALS"],[7,[0,1]]]]]],[0,null,!1,8066853579060027,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x3ab8d5b213fb6,[[4,80]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7518148415509026,[[11,"SETGLOBALS"],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,7926178733707777,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,
null,0x563505f1770e7,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.SetVar,null,295163369715366,[[11,"chooser"],[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"play"]]]]]],[-1,cr.system_object.prototype.acts.Wait,null,6759054591482532,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,7868384896297767,[[6,"Chooselevel"]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xed0743545ca0a,[[11,"RV"],[7,[0,0]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,5430561404088089,[[1,[2,"Rsave"]],[7,[23,"RV"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xe05c8c09113e1,[[11,"BV"],[7,[0,1]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8879614890107621,[[1,[2,"Bsave"]],[7,[23,"BV"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6103604678571912,[[11,"AV"],[7,[0,0]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,4730273494743396,[[1,[2,"Asave"]],[7,[23,"AV"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x436e55c65ae5a,
[[11,"ATV"],[7,[0,0]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8527942524648704,[[1,[2,"ATVsave"]],[7,[23,"ATV"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6242827759448409,[[11,"BTV"],[7,[0,0]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,9903660569926384,[[1,[2,"BTVsave"]],[7,[23,"BTV"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8952618960960965,[[11,"CTV"],[7,[0,0]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6624255448570804,[[1,
[2,"CTVsave"]],[7,[23,"CTV"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6840890323180741,[[11,"DTV"],[7,[0,0]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,4955392422320632,[[1,[2,"DTVsave"]],[7,[23,"DTV"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9315066072552452,[[11,"SETGLOBALS"],[7,[0,1]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0x83fec3fd620ab,[[1,[2,"SETGLOBALSSave"]],[7,[23,"SETGLOBALS"]]]]]],[0,null,!1,0xc4cbf52a58cf3,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,8163089814046187,[[4,80]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x533d70ada3b06,[[11,"SETGLOBALS"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,7520965220272032,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,942080953921762,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6595689252355128,[[11,"chooser"],[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,
!0,null,[[2,"play"]]]]]],[-1,cr.system_object.prototype.acts.Wait,null,5659103963908506,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,0xc899c142d794e,[[6,"Chooselevel"]]]]],[0,null,!1,0x9cdebb83ccec6,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,8529529041719762]],[[180,cr.plugins_.Text.prototype.acts.SetText,null,7110726921888965,[[7,[23,"SETGLOBALS"]]]]]],[0,null,!1,9487264394222732,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,9113215244255036,
[[4,157]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,5082773203192786,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,8508335923418086,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,8249665247650277,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,5839101147279402,[[6,"GetMoney"]]]]],[0,null,!1,9691468823385418,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,
6786562506323585]],[[19,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,0xfb9237e925e52,[[3,1]]]]]]],["Chooselevel",[[0,null,!1,6049518928469023,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,5997014296361523,[[4,91]]],[-1,cr.system_object.prototype.cnds.Compare,null,0,!1,!1,!1,0x8b78b110e4415,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"play"]]]],[8,3],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,5231244881834105,[[11,"chooser"],
[7,[0,1]]]]]],[0,[!0,"Set button"],!1,0xd657a5b5e835c,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xd657a5b5e835c,[[1,[2,"Set button"]]]]],[],[[0,null,!1,6021976847354031,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x7cd0cbc7f3fe5,[[11,"chooser"],[8,5],[7,[0,1]]]]],[[91,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xee8b7b878591b,[[3,1]]]]],[0,null,!1,8264683109372652,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8716072223308682,[[11,
"chooser"],[8,5],[7,[0,2]]]]],[[92,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,9484687317432936,[[0,[0,0]]]],[91,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xff25fb2e7439c]]],[0,null,!1,0xe01d79a68266b,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,995423967225464,[[11,"chooser"],[8,5],[7,[0,3]]]]],[[93,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,7770754575894378,[[0,[0,0]]]]]],[0,null,!1,0x9aaac33f01cac,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,
!1,!1,0xe235aece698f4,[[11,"chooser"],[8,5],[7,[0,4]]]]],[[94,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5418059153559353,[[0,[0,0]]]]]],[0,null,!1,0xd1ea9398a3a1f,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x5c8cb2fe8b2cf,[[11,"chooser"],[8,5],[7,[0,5]]]]],[[95,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x4cc852dcb206d,[[0,[0,0]]]]]],[0,null,!1,0x6a8d9bfb73ea9,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8150441864892985,[[11,"chooser"],[8,
5],[7,[0,6]]]]],[[96,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xe53feaf762b65,[[0,[0,0]]]]]],[0,null,!1,5999010284073429,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xbcfc2312587b3,[[11,"chooser"],[8,5],[7,[0,7]]]]],[[97,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,4615855262002826,[[0,[0,0]]]]]],[0,null,!1,902427741579109,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,4869605470060216,[[11,"chooser"],[8,5],[7,[0,8]]]]],[[98,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,8599744898902226,[[0,[0,0]]]]]],[0,null,!1,6741401821238655,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5460525969728091,[[11,"chooser"],[8,5],[7,[0,9]]]]],[[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,6859886318682235,[[0,[0,0]]]]]],[0,null,!1,5815365580498396,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xefb3184ca956,[[11,"chooser"],[8,5],[7,[0,10]]]]],[[100,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,9069816590558628,[[0,[0,0]]]]]],
[0,null,!1,4937678492126005,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x73422af381bab,[[11,"chooser"],[8,5],[7,[0,11]]]]],[[101,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x8d7cbebb7eb86,[[0,[0,0]]]]]],[0,null,!1,0x3d39f5d66bf02,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,696992020546473,[[11,"chooser"],[8,5],[7,[0,12]]]]],[[102,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,483315655511316,[[0,[0,0]]]]]],[0,null,!1,0x6edae8158d5c3,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,9083593505295842,[[11,"chooser"],[8,5],[7,[0,13]]]]],[[103,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x893eb3c7ec8bc,[[0,[0,0]]]]]],[0,null,!1,6102641740538357,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,887041045840935,[[11,"chooser"],[8,5],[7,[0,14]]]]],[[104,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5453867704968577,[[0,[0,0]]]]]],[0,null,!1,8572647693394611,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7372591872579426,
[[11,"chooser"],[8,5],[7,[0,15]]]]],[[105,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,8887262416567377,[[0,[0,0]]]]]],[0,null,!1,0xe029738523a5f,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7410671039041321,[[11,"chooser"],[8,5],[7,[0,16]]]]],[[106,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x8abd274fc4d53,[[0,[0,0]]]]]],[0,null,!1,4584989663785443,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x8479828fc2308,[[11,"chooser"],[8,5],[7,[0,17]]]]],
[[107,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,8467182698985505,[[0,[0,0]]]]]],[0,null,!1,8665307618443943,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5960290638201144,[[11,"chooser"],[8,5],[7,[0,18]]]]],[[108,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xefc2313e690a3,[[0,[0,0]]]]]],[0,null,!1,0x97b1169a183a3,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6062712704240127,[[11,"chooser"],[8,5],[7,[0,19]]]]],[[109,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,8344918654766798,[[0,[0,0]]]]]],[0,null,!1,8698545803287316,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9918257272033380,[[11,"chooser"],[8,5],[7,[0,20]]]]],[[110,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,7418560176454287,[[0,[0,0]]]]]]]],[0,[!0,"Choose level"],!1,6998179906348978,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6998179906348978,[[1,[2,"Choose level"]]]]],[],[[0,null,!1,8840922158513264,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
null,0,!1,!1,!1,7026352038165338,[[4,91]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xe885ce8c4681e,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x962145d6cec36,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,9139906340550136,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,0xa6934f97a8787,[[6,"Level1"]]]]],[0,null,!1,5831998622044623,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
null,0,!1,!1,!1,4832538994602227,[[4,92]]],[92,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xaa647893c201,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xb6aab640d8f61,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,8847139084215609,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xc3cbd35b48901,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,
0xf5d4058391e8d,[[6,"Lewel2"]]]]],[0,null,!1,6659286667558255,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0xc06563be1d481,[[4,93]]],[93,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,9740848414952196,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xd0ebc9a12c6f4,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x3bcff37ecd5c7,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,
null,8201511993234095,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,5697694448928121,[[6,"Lewel3"]]]]],[0,null,!1,0xe9cce64d6b328,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,6774094116733774,[[4,94]]],[94,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,6607142599846248,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,5059286003833278,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,
null,8960354093659624,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,5704240445850048,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x94821968d6ab4,[[6,"Lewel4"]]]]],[0,null,!1,0xc7c80d9bed8bd,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,8546323537607182,[[4,95]]],[95,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,886885714348244,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,
null,7111611448938,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,9525105960590866,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x926bdea1afc9e,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,68787427476048,[[6,"Lewel5"]]]]],[0,null,!1,7791380689850751,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,6272125146092513,[[4,96]]],[96,cr.plugins_.Sprite.prototype.cnds.CompareFrame,
null,0,!1,!1,!1,0xd1693741efb61,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,7598672288171577,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,6237359762467752,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x8594e92204f59,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x62cc2c4950c52,[[6,"Lewel6"]]]]],[0,null,!1,0xe7963bb0a2935,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
null,0,!1,!1,!1,9087786318357926,[[4,97]]],[97,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,7586312965391325,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x96e8f266770c1,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xeb335f8931edf,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,4604917618490627,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,
0xbc2cdb5821c32,[[6,"Lewel7"]]]]],[0,null,!1,8884955317580319,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,7775225135926678,[[4,98]]],[98,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,5362837243321615,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,401831669850651,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xd86defd006bc3,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,
null,8027675068446766,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x3b19ed624a3fa,[[6,"Lewel8"]]]]],[0,null,!1,0xa9828550e0a1b,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0xc68f4c140e6d6,[[4,99]]],[99,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0x3fe0412f464cd,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,7013911635507438,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,
null,0x3de6053b88ad3,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x73b7899d889b7,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,4704663083478547,[[6,"Lewel9"]]]]],[0,null,!1,0xe5190f6bd8a23,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0x4f7084634859e,[[4,100]]],[100,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,8624951718956262,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,
null,475899029390282,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x6688458137d6f,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,5603867884057054,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x4b3ca0636738d,[[6,"Lewel10"]]]]],[0,null,!1,0x4bc0598dd2504,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,7592347532039841,[[4,101]]],[101,cr.plugins_.Sprite.prototype.cnds.CompareFrame,
null,0,!1,!1,!1,5797453200597944,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x585ea0a3d0879,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,9674425012260112,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xea5c5a8a0ba95,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,0xcdfff3141be68,[[6,"Lewel11"]]]]],[0,null,!1,4730960184754004,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
null,0,!1,!1,!1,5396056082326605,[[4,102]]],[102,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,6745053891366061,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,7056145390817246,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,9748598327706524,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xb61c31de111de,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,
null,6429141150972481,[[6,"Lewel12"]]]]],[0,null,!1,4727377128207573,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,745467685809629,[[4,103]]],[103,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,4762367622024711,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,5705723936681266,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,7982152313098925,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],
[-1,cr.system_object.prototype.acts.Wait,null,0xe585594a31e14,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,863326485915131,[[6,"Lewel13"]]]]],[0,null,!1,0xf7945078b862,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,645274748704116,[[4,104]]],[104,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xae0f8102712ff,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,5571368551502556,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],
[-1,cr.system_object.prototype.acts.CreateObject,null,9716665656568480,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,8439458014195685,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,9084936645065968,[[6,"Lewel14"]]]]],[0,null,!1,5991554667091582,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,6273199175522654,[[4,105]]],[105,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,9623215197161296,[[8,0],
[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,8133237748149505,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,5281318881640164,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,4650450738930004,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,9685437791424752,[[6,"Lewel15"]]]]],[0,null,!1,5197651211982197,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,
!1,!1,499395532513293,[[4,106]]],[106,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xe7736b88392bc,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,9206216944811926,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,9838533474147332,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,625146376114005,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,8926654394155665,
[[6,"Lewel16"]]]]],[0,null,!1,93839082856267,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,6978932881524912,[[4,107]]],[107,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0x4a275a0940b09,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xdb2fe617f4007,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,7439297755312439,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,
null,5083702459949589,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x8735677927606,[[6,"Lewel17"]]]]],[0,null,!1,914741153886898,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,7151619709342988,[[4,108]]],[108,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,9890063959322696,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x8b9fec0aac86b,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,
null,0xecd3164b2162c,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xa5ea8340449c6,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,0xd72313d12e803,[[6,"Lewel18"]]]]],[0,null,!1,6423027256875314,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,5974665806866334,[[4,109]]],[109,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xc8d66ad4424c2,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,
null,9851561887507556,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xf14a154d94848,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,7629028933731304,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,4777270406786685,[[6,"Lewel19"]]]]],[0,null,!1,4763864906696088,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,9099225738118600,[[4,110]]],[110,cr.plugins_.Sprite.prototype.cnds.CompareFrame,
null,0,!1,!1,!1,0x59d3ae137bae5,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x50c5fe275b747,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,9809458978145066,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,7145458920158641,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,4703791957036321,[[6,"Lewel20"]]]]]]],[0,[!0,"Money global"],!1,9844459998915860,[[-1,cr.system_object.prototype.cnds.IsGroupActive,
null,0,!1,!1,!1,9844459998915860,[[1,[2,"Money global"]]]]],[],[[0,null,!1,394,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,395]],[[3,cr.plugins_.Text.prototype.acts.SetText,null,396,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]]]],[0,[!0,"NaviUpgrades"],!1,5776790183600313,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,5776790183600313,[[1,[2,"NaviUpgrades"]]]]],[],[[0,null,!1,0x7ef84f83730f4,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
null,0,!1,!1,!1,0xd9e785ae2c6e4,[[4,147]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,4920938618815066,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,6783953235095212,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,6711021186363917,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,9963145994453324,[[6,"UpG1"]]]]],[0,null,!1,0x9015fd7bb6326,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
null,0,!1,!1,!1,9356208984276432,[[4,148]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xd15e8a700b1d8,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x6859b1eef92a2,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xc096323d542e7,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,9243305257176604,[[6,"UpG2"]]]]],[0,null,!1,325647329980538,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
null,0,!1,!1,!1,0x874472e2a183,[[4,149]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x74b1bcff959aa,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xa3960fe0667be,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x41ee479fd29bb,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,571425049186982,[[6,"UpG3"]]]]],[0,null,!1,0xf1a9edff5c233,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
null,0,!1,!1,!1,0x6d0b3ec305a10,[[4,150]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xb630261112af0,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xa88fd87ac14ef,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x8860d4b077378,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,6846348993845117,[[6,"UpG4"]]]]]]],[0,null,!1,0xf40e8d757c7b,[[-1,cr.system_object.prototype.cnds.EveryTick,
null,0,!1,!1,!1,0xf181a4897a4c2]],[[180,cr.plugins_.Text.prototype.acts.SetText,null,0x4b69638d8e98f,[[7,[23,"BTV"]]]]]],[0,null,!1,7342707790548134,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,8960954437994856]],[[19,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,0x8a32a37745057,[[3,1]]]]],[0,null,!1,0x9696de3b982fc,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0x6c83eab5f971c,[[4,157]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,7711411163852254,
[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,8012297575250752,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x95a3d5bc9d224,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,8221392205143289,[[6,"GetMoney"]]]]]]],["UpG1",[[1,"MoneyBuy",0,0,!1,!1,0x623e8fe38888f],[1,"RV",0,0,!1,!1,0xc84ed83299714],[0,[!0,"Money global"],!1,0x53aa2e0913522,[[-1,cr.system_object.prototype.cnds.IsGroupActive,
null,0,!1,!1,!1,0x53aa2e0913522,[[1,[2,"Money global"]]]]],[],[[0,null,!1,394,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,395]],[[3,cr.plugins_.Text.prototype.acts.SetText,null,396,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x889b18c5ed11f,[[11,"MoneyBuy"],[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]]]],[0,[!0,"NaviUpgrades"],!1,0x400c82a4fe5b5,
[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x400c82a4fe5b5,[[1,[2,"NaviUpgrades"]]]]],[],[[0,null,!1,0x7ef84f83730f4,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0xd9e785ae2c6e4,[[4,156]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x799eae978c300,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x4764e5770e183,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,
null,8105129614055718,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,9963145994453324,[[6,"Chooselevel"]]]]],[0,null,!1,0x9015fd7bb6326,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,9356208984276432,[[4,157]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,9541408044249088,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xd7263c0a7557a,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,
null,8673580213587304,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,9243305257176604,[[6,"GetMoney"]]]]]]],[0,[!0,"Set Button Money"],!1,944199038599147,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,944199038599147,[[1,[2,"Set Button Money"]]]]],[],[[0,null,!1,0xbb00a157c89c1,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9577203032620028,[[11,"MoneyBuy"],[8,5],[7,[0,60]]]],[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,null,0,
!1,!0,!1,711374700069094,[[1,[2,"Rsave"]],[8,0],[0,[0,1]]]]],[[158,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,6147696924289483,[[0,[0,0]]]],[152,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5345729188035424,[[0,[0,0]]]]]],[0,null,!1,0x49346020569a0,[[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,null,0,!1,!1,!1,5415711878095295,[[1,[2,"Rsave"]],[8,0],[0,[0,1]]]]],[[158,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x4a9e612e14f85,[[0,[0,1]]]],[152,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,9286710568130092,[[0,[0,0]]]]]],[0,null,!1,9305610373354816,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5585302651890692,[[11,"MoneyBuy"],[8,5],[7,[0,150]]]],[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,null,0,!1,!0,!1,0xc82e907800a0c,[[1,[2,"Rsave"]],[8,0],[0,[0,2]]]]],[[160,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5389326653521332,[[0,[0,0]]]],[153,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x95d36215e73e6,[[0,[0,0]]]]]],[0,null,!1,9315926867027832,
[[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,null,0,!1,!1,!1,781202532607983,[[1,[2,"Rsave"]],[8,0],[0,[0,2]]]]],[[160,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,9848621965816152,[[0,[0,1]]]],[153,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5500091389257017,[[0,[0,0]]]]]],[0,null,!1,9151234336814856,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9844218870703284,[[11,"MoneyBuy"],[8,5],[7,[0,400]]]],[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
null,0,!1,!0,!1,660081714820331,[[1,[2,"Rsave"]],[8,0],[0,[0,3]]]]],[[161,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,6140577330142855,[[0,[0,0]]]],[154,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x624a90003e9bf,[[0,[0,0]]]]]],[0,null,!1,6607669206639553,[[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,null,0,!1,!1,!1,9839995768380584,[[1,[2,"Rsave"]],[8,0],[0,[0,3]]]]],[[161,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,4523601565738342,[[0,[0,1]]]],[154,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,7344810004321281,[[0,[0,0]]]]]],[0,null,!1,0x4f4fdb425fb77,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7071810945364903,[[11,"MoneyBuy"],[8,5],[7,[0,800]]]],[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,null,0,!1,!0,!1,7595354002100161,[[1,[2,"Rsave"]],[8,0],[0,[0,4]]]]],[[162,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xb5f8a904fe708,[[0,[0,0]]]],[155,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,9959136219169458,[[0,[0,0]]]]]],[0,null,!1,6481944414305325,
[[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,null,0,!1,!1,!1,9960883644896364,[[1,[2,"Rsave"]],[8,0],[0,[0,4]]]]],[[162,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5877783615632391,[[0,[0,1]]]],[155,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,4990930510918503,[[0,[0,0]]]]]]]],[0,[!0,"Upgrades"],!1,5583793528280625,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,5583793528280625,[[1,[2,"Upgrades"]]]]],[],[[0,null,!1,7832568206766433,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,7328524554279083,[[4,158]]],[158,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,6429430018425045,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,5925728388071847,[[11,"RV"],[7,[0,1]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6750356841553136,[[1,[2,"Rsave"]],[7,[23,"RV"]]]],[-1,cr.system_object.prototype.acts.SubVar,null,0xed7f770a7eb91,[[11,"MoneyBuy"],[7,[0,60]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,346445292553019,
[[1,[2,"MSave"]],[7,[23,"MoneyBuy"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,9593981299265100,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,9278094558458994,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x9df7e8f8f4dca,[[4,160]]],[160,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,5432091120051064,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xf36151867fe15,[[11,"RV"],[7,[0,
2]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6010658258143136,[[1,[2,"Rsave"]],[7,[23,"RV"]]]],[-1,cr.system_object.prototype.acts.SubVar,null,0xbd2b45ef23ef5,[[11,"MoneyBuy"],[7,[0,150]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,5387498995921158,[[1,[2,"MSave"]],[7,[23,"MoneyBuy"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,5017656448770546,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,0x9cee185383365,
[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x785f96df70f4a,[[4,161]]],[161,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,8223723980889223,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,8805037317265174,[[11,"RV"],[7,[0,3]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6657698393494005,[[1,[2,"Rsave"]],[7,[23,"RV"]]]],[-1,cr.system_object.prototype.acts.SubVar,null,0xa782b38b795b6,[[11,"MoneyBuy"],[7,[0,400]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,0x78a53ad33e919,[[1,[2,"MSave"]],[7,[23,"MoneyBuy"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,7667518747353605,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,7835068554176628,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xfa41676b64317,[[4,162]]],[162,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,4927144388280688,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,5833947702383785,
[[11,"RV"],[7,[0,4]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0xc5935034693e,[[1,[2,"Rsave"]],[7,[23,"RV"]]]],[-1,cr.system_object.prototype.acts.SubVar,null,0xf9e6f02fde448,[[11,"MoneyBuy"],[7,[0,800]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,338727979452494,[[1,[2,"MSave"]],[7,[23,"MoneyBuy"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0xe4d0ff151efa4,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]]]],[0,null,!1,
7641431633786974,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,6254182012604681]],[[19,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,5541810720549972,[[3,1]]]]]]],["UpG2",[[1,"AV",0,0,!1,!1,6364172291657178],[1,"BV",0,0,!1,!1,0xfd1324730d93],[0,[!0,"Money global"],!1,0xee8b029c180bb,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xee8b029c180bb,[[1,[2,"Money global"]]]]],[],[[0,null,!1,394,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,
!1,395]],[[3,cr.plugins_.Text.prototype.acts.SetText,null,396,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6840657758796485,[[11,"MoneyBuy"],[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]]]],[0,[!0,"NaviUpgrades"],!1,0xac185b71bd90d,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xac185b71bd90d,[[1,[2,"NaviUpgrades"]]]]],[],[[0,null,!1,0x7ef84f83730f4,
[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0xd9e785ae2c6e4,[[4,156]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xca2b3313229c8,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,9349166525228594,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,8184911345326251,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,9963145994453324,[[6,"Chooselevel"]]]]],[0,null,
!1,0x9015fd7bb6326,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,9356208984276432,[[4,157]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,6046461458065462,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,6549457461543693,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,5769127785581556,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,9243305257176604,[[6,"GetMoney"]]]]]]],
[0,[!0,"Set Button Money"],!1,7411097213861363,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7411097213861363,[[1,[2,"Set Button Money"]]]]],[],[[0,null,!1,0xbb00a157c89c1,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9577203032620028,[[11,"MoneyBuy"],[8,5],[7,[0,30]]]],[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,null,0,!1,!0,!1,5925587016360558,[[1,[2,"Bsave"]],[8,0],[0,[0,2]]]]],[[172,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,6147696924289483,
[[0,[0,0]]]],[163,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5345729188035424,[[0,[0,0]]]]]],[0,null,!1,0x49346020569a0,[[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,null,0,!1,!1,!1,5415711878095295,[[1,[2,"Bsave"]],[8,0],[0,[0,2]]]]],[[172,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x4a9e612e14f85,[[0,[0,1]]]],[163,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x86d7a830ec90f,[[0,[0,0]]]]]],[0,null,!1,9305610373354816,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,5585302651890692,[[11,"MoneyBuy"],[8,5],[7,[0,80]]]],[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,null,0,!1,!0,!1,5836002234435731,[[1,[2,"Bsave"]],[8,0],[0,[0,3]]]]],[[173,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5389326653521332,[[0,[0,0]]]],[164,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x95d36215e73e6,[[0,[0,0]]]]]],[0,null,!1,9315926867027832,[[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,null,0,!1,!1,!1,781202532607983,[[1,[2,"Bsave"]],
[8,0],[0,[0,3]]]]],[[173,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,9848621965816152,[[0,[0,1]]]],[164,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xe3479271a7f2c,[[0,[0,0]]]]]],[0,null,!1,9151234336814856,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9844218870703284,[[11,"MoneyBuy"],[8,5],[7,[0,30]]]],[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,null,0,!1,!0,!1,0x66ea38b4e3964,[[1,[2,"Asave"]],[8,0],[0,[0,1]]]]],[[174,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,6140577330142855,[[0,[0,0]]]],[165,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x624a90003e9bf,[[0,[0,0]]]]]],[0,null,!1,6607669206639553,[[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,null,0,!1,!1,!1,9839995768380584,[[1,[2,"Asave"]],[8,0],[0,[0,1]]]]],[[174,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,4523601565738342,[[0,[0,1]]]],[165,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5931804855483412,[[0,[0,0]]]]]],[0,null,!1,0x4f4fdb425fb77,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,7071810945364903,[[11,"MoneyBuy"],[8,5],[7,[0,80]]]],[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,null,0,!1,!0,!1,580175413508666,[[1,[2,"Asave"]],[8,0],[0,[0,2]]]]],[[175,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xb5f8a904fe708,[[0,[0,0]]]],[166,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,9959136219169458,[[0,[0,0]]]]]],[0,null,!1,6481944414305325,[[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,null,0,!1,!1,!1,9960883644896364,[[1,[2,"Asave"]],
[8,0],[0,[0,2]]]]],[[175,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5877783615632391,[[0,[0,1]]]],[166,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x93348969b920e,[[0,[0,0]]]]]]]],[0,[!0,"Upgrades2"],!1,9006972178259502,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,9006972178259502,[[1,[2,"Upgrades2"]]]]],[],[[0,null,!1,0xb5cbed33c339d,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9461744383341836,[[4,172]]],[172,cr.plugins_.Sprite.prototype.cnds.CompareFrame,
null,0,!1,!1,!1,7670485790609909,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,9488609917704434,[[11,"BV"],[7,[0,2]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,4583716007506366,[[1,[2,"Bsave"]],[7,[23,"BV"]]]],[-1,cr.system_object.prototype.acts.SubVar,null,0xac2b94c71af7e,[[11,"MoneyBuy"],[7,[0,30]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,9485212587111268,[[1,[2,"MSave"]],[7,[23,"MoneyBuy"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,
null,0x6abd5d3e4f1da,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,7649536976513136,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xa49eb1e3d832f,[[4,173]]],[173,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,7887995255652618,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,8782887546663285,[[11,"BV"],[7,[0,3]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0xdd9d5714410cd,[[1,
[2,"Bsave"]],[7,[23,"BV"]]]],[-1,cr.system_object.prototype.acts.SubVar,null,8612498613848567,[[11,"MoneyBuy"],[7,[0,80]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,4859306322813485,[[1,[2,"MSave"]],[7,[23,"MoneyBuy"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x9f68b7937b7e0,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,9766960109862398,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7193612477152145,
[[4,174]]],[174,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,9901298458501946,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,4686159889008649,[[11,"AV"],[7,[0,1]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0x5d70eac38fc7f,[[1,[2,"Asave"]],[7,[23,"AV"]]]],[-1,cr.system_object.prototype.acts.SubVar,null,0x48a00b42a2a94,[[11,"MoneyBuy"],[7,[0,30]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6710757994252904,[[1,[2,"MSave"]],[7,
[23,"MoneyBuy"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,7713182114508516,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,4851196776634304,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x628b0de6bab9b,[[4,175]]],[175,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0x6cf3035e36208,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xb627b2dd1f43b,[[11,"AV"],[7,[0,2]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,7491447595869081,[[1,[2,"Asave"]],[7,[23,"AV"]]]],[-1,cr.system_object.prototype.acts.SubVar,null,0x42b07a9823adc,[[11,"MoneyBuy"],[7,[0,80]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6976250890621626,[[1,[2,"MSave"]],[7,[23,"MoneyBuy"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x685fcfb27006e,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]]]],[0,null,!1,0x68c76228f6bab,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,
!1,!1,!1,0x9cf3e8d21c165]],[[19,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,5239746806231905,[[3,1]]]]]]],["UpG3",[[1,"DTV",0,0,!1,!1,5187142283825505],[1,"CTV",0,0,!1,!1,0x83d600f9cc0ae],[1,"BTV",0,0,!1,!1,0xf83f48ac6142],[1,"ATV",0,0,!1,!1,0xf66d0a6abf841],[0,[!0,"Money global"],!1,0xd2d8633de4baf,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0xd2d8633de4baf,[[1,[2,"Money global"]]]]],[],[[0,null,!1,394,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,
395]],[[3,cr.plugins_.Text.prototype.acts.SetText,null,396,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8840101865988568,[[11,"MoneyBuy"],[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]]]],[0,[!0,"NaviUpgrades"],!1,5223180611223407,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,5223180611223407,[[1,[2,"NaviUpgrades"]]]]],[],[[0,null,!1,0x7ef84f83730f4,
[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0xd9e785ae2c6e4,[[4,156]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,5495996648991485,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xf3f90a411d618,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x7ab51c52d73d9,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,9963145994453324,[[6,"Chooselevel"]]]]],[0,null,
!1,0x9015fd7bb6326,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,9356208984276432,[[4,157]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,5392986223577536,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,5043227387687789,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xccb9a93217e37,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,9243305257176604,[[6,"GetMoney"]]]]]]],
[0,[!0,"Set Button Money"],!1,0x893153e492d44,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x893153e492d44,[[1,[2,"Set Button Money"]]]]],[],[[0,null,!1,0xbb00a157c89c1,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9577203032620028,[[11,"MoneyBuy"],[8,5],[7,[0,100]]]],[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,null,0,!1,!0,!1,6621777853945003,[[1,[2,"CTVsave"]],[8,0],[0,[0,1]]]]],[[176,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,6147696924289483,
[[0,[0,0]]]],[169,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5345729188035424,[[0,[0,0]]]]]],[0,null,!1,0x49346020569a0,[[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,null,0,!1,!1,!1,5415711878095295,[[1,[2,"CTVsave"]],[8,0],[0,[0,1]]]]],[[176,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x4a9e612e14f85,[[0,[0,1]]]],[169,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xa7ec252e54a48,[[0,[0,0]]]]]],[0,null,!1,9305610373354816,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,5585302651890692,[[11,"MoneyBuy"],[8,5],[7,[0,200]]]],[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,null,0,!1,!0,!1,0xf85985f419271,[[1,[2,"BTVsave"]],[8,0],[0,[0,2]]]]],[[177,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5389326653521332,[[0,[0,0]]]],[168,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x95d36215e73e6,[[0,[0,0]]]]]],[0,null,!1,9315926867027832,[[15,cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,null,0,!1,!1,!1,781202532607983,[[1,[2,
"BTVsave"]],[8,0],[0,[0,2]]]]],[[177,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,9848621965816152,[[0,[0,1]]]],[168,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,9709840532702600,[[0,[0,0]]]]]]]],[0,[!0,"Upgrades3"],!1,456800419486544,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,456800419486544,[[1,[2,"Upgrades3"]]]]],[],[[0,null,!1,0xb5cbed33c339d,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9461744383341836,[[4,176]]],[176,cr.plugins_.Sprite.prototype.cnds.CompareFrame,
null,0,!1,!1,!1,0xd2fb6db37ff6,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,9488609917704434,[[11,"CTV"],[7,[0,1]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,4583716007506366,[[1,[2,"CTVsave"]],[7,[23,"CTV"]]]],[-1,cr.system_object.prototype.acts.SubVar,null,0xb52c3131c183d,[[11,"MoneyBuy"],[7,[0,100]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6433252868019061,[[1,[2,"MSave"]],[7,[23,"MoneyBuy"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,
null,0x6d89bcbff6ec4,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[0,null,!1,7649536976513136,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xa49eb1e3d832f,[[4,177]]],[177,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,9933211093016992,[[8,0],[0,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,8782887546663285,[[11,"BTV"],[7,[0,2]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0xdd9d5714410cd,
[[1,[2,"BTVsave"]],[7,[23,"BTV"]]]],[-1,cr.system_object.prototype.acts.SubVar,null,495314596345537,[[11,"MoneyBuy"],[7,[0,200]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0x87d832411df74,[[1,[2,"MSave"]],[7,[23,"MoneyBuy"]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x831884be1de71,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]]]],[0,null,!1,0xdf855950831b7,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x677b1c1974031]],
[[180,cr.plugins_.Text.prototype.acts.SetText,null,7189926059201641,[[7,[23,"BTV"]]]]]],[0,null,!1,5166148973635959,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xa5c425f8427f9]],[[19,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,0x40c8a16f8a662,[[3,1]]]]]]],["UpG4",[[0,[!0,"Money global"],!1,0x8f614aab5e89a,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x8f614aab5e89a,[[1,[2,"Money global"]]]]],[],[[0,null,!1,394,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,395]],[[3,cr.plugins_.Text.prototype.acts.SetText,null,396,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]]]],[0,[!0,"NaviUpgrades"],!1,7891334829767412,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,7891334829767412,[[1,[2,"NaviUpgrades"]]]]],[],[[0,null,!1,0x7ef84f83730f4,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0xd9e785ae2c6e4,[[4,156]]]],[[-1,cr.system_object.prototype.acts.Wait,null,6377456637399305,
[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,9963145994453324,[[6,"Chooselevel"]]]]],[0,null,!1,0x9015fd7bb6326,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,9356208984276432,[[4,157]]]],[[-1,cr.system_object.prototype.acts.Wait,null,9327486325199336,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,9243305257176604,[[6,"GetMoney"]]]]]]],[0,null,!1,6751172211991632,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xe5f98da90c05]],
[[19,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,0x4dbb6b7f1d7b8,[[3,1]]]]]]],["GetMoney",[[0,[!0,"NaviUpgrades"],!1,0x3f2008ee7fc25,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,0x3f2008ee7fc25,[[1,[2,"NaviUpgrades"]]]]],[],[[0,null,!1,0x7ef84f83730f4,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0xd9e785ae2c6e4,[[4,156]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x4412d12615847,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,
null,987612544380916,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xb04b33c7ad313,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,9963145994453324,[[6,"Chooselevel"]]]]],[0,null,!1,0x9015fd7bb6326,[[16,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,9356208984276432,[[4,157]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xcf35b3fbdb25f,[[4,182],[5,[0,9]],[0,[0,0]],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,
null,0xbe6f92f23b687,[[4,183],[5,[0,9]],[0,[0,300]],[0,[0,470]]]],[-1,cr.system_object.prototype.acts.Wait,null,4765947883256591,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,9243305257176604,[[6,"GetMoney"]]]]]]],[0,[!0,"Money global"],!1,362857519528284,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,362857519528284,[[1,[2,"Money global"]]]]],[],[[0,null,!1,394,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,395]],[[3,cr.plugins_.Text.prototype.acts.SetText,
null,396,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]]]],[0,[!0,"Purchase"],!1,8109762502964497,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,8109762502964497,[[1,[2,"Purchase"]]]]],[],[[0,null,!0,9278898062187212,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xb342298639aa2,[[4,224]]],[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xc0966bab13287,[[4,228]]]],[[19,cr.plugins_.CJSAds.prototype.acts.fetchProductsFromStore,
null,0x6058b52b9a677,[[1,[2,"golda100"]]]],[232,cr.plugins_.Sprite.prototype.acts.Destroy,null,7386012793436799],[233,cr.plugins_.Sprite.prototype.acts.Destroy,null,8344217799540863],[234,cr.plugins_.Sprite.prototype.acts.Destroy,null,5590854024683806],[235,cr.plugins_.Sprite.prototype.acts.Destroy,null,6052825774901097],[-1,cr.system_object.prototype.acts.CreateObject,null,0x8352912f84f3d,[[4,183],[5,[0,3]],[0,[0,435]],[0,[0,200]]]],[-1,cr.system_object.prototype.acts.Wait,null,9234499129363484,
[[0,[0,3]]]],[183,cr.plugins_.Sprite.prototype.acts.Destroy,null,5093324401619653],[-1,cr.system_object.prototype.acts.CreateObject,null,0x7656c3bd6fae9,[[4,232],[5,[0,2]],[0,[0,435]],[0,[0,200]]]]]],[0,null,!1,0xd150ebc0cb0d6,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xc46ed5a5a31f4,[[4,232]]]],[],[[0,null,!1,9255475106027216,[[19,cr.plugins_.CJSAds.prototype.cnds.IsCocoonJS,null,0,!1,!1,!1,9410727632139218]],[],[[0,null,!1,0x99b75986d8cbd,[[19,cr.plugins_.CJSAds.prototype.cnds.IsStoreAvailable,
null,0,!1,!1,!1,0xe1347dfc2043d]],[[19,cr.plugins_.CJSAds.prototype.acts.Purchase,null,0xea9aae95a449f,[[1,[2,"golda100"]]]]]]]]]],[0,null,!1,571172223369306,[[19,cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete,null,1,!1,!1,!1,0x8fd26e27b9a21,[[1,[2,"golda100"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xf81b54e63ba68,[[11,"Money"],[7,[0,100]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x623850efe33f7,[[7,[23,"Money"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,4822365633448512,
[[11,"Moneybuffer"],[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5802388791517786,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,5402608081000693,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8735785489790272,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,
!0,null]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,5467159313370007,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,7869330084743633,[[4,236],[5,[0,2]],[0,[0,430]],[0,[0,725]]]]]],[0,null,!1,9455810373573468,[[19,cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail,null,1,!1,!1,!1,0xbab8c3264e09b,[[1,[2,"golda100"]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x954a4efd385f4,[[4,237],[5,
[0,2]],[0,[0,430]],[0,[0,725]]]]]]]],[0,[!0,"Purchase2"],!1,9505639642982102,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,9505639642982102,[[1,[2,"Purchase2"]]]]],[],[[0,null,!0,522278371197655,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x740fe42454851,[[4,225]]],[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x9ac1c0606ddb3,[[4,229]]]],[[19,cr.plugins_.CJSAds.prototype.acts.fetchProductsFromStore,null,8236719782599928,[[1,[2,"golda200"]]]],
[232,cr.plugins_.Sprite.prototype.acts.Destroy,null,6374268532840494],[233,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x7f6b5686c6eb3],[234,cr.plugins_.Sprite.prototype.acts.Destroy,null,5620313592863538],[235,cr.plugins_.Sprite.prototype.acts.Destroy,null,6774201491758459],[-1,cr.system_object.prototype.acts.CreateObject,null,4776554326252317,[[4,183],[5,[0,3]],[0,[0,435]],[0,[0,324]]]],[-1,cr.system_object.prototype.acts.Wait,null,655621840148882,[[0,[0,3]]]],[183,cr.plugins_.Sprite.prototype.acts.Destroy,
null,0xe1ad41e0fc1a9],[-1,cr.system_object.prototype.acts.CreateObject,null,0x7df87e36ef222,[[4,233],[5,[0,2]],[0,[0,435]],[0,[0,324]]]]]],[0,null,!1,4843628626022357,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xe1ddcd0e8618e,[[4,233]]]],[],[[0,null,!1,6710732002209952,[[19,cr.plugins_.CJSAds.prototype.cnds.IsCocoonJS,null,0,!1,!1,!1,0xaf07eee4fab23]],[],[[0,null,!1,7078196953460952,[[19,cr.plugins_.CJSAds.prototype.cnds.IsStoreAvailable,null,0,!1,!1,!1,6046702980339119]],
[[19,cr.plugins_.CJSAds.prototype.acts.Purchase,null,613055751504031,[[1,[2,"golda200"]]]]]]]]]],[0,null,!1,7808444076715219,[[19,cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete,null,1,!1,!1,!1,8644833184979282,[[1,[2,"golda200"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xe6e9407645883,[[11,"Money"],[7,[0,200]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,0x589f2c851fd23,[[7,[23,"Money"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,4780244166796876,[[11,"Moneybuffer"],
[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x70b3cf1ba1ff0,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0x9359dfb82a0f9,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,9857091373258928,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,
!0,null]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,7751591170421952,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,8038947035206742,[[4,236],[5,[0,2]],[0,[0,430]],[0,[0,725]]]]]],[0,null,!1,7566830319308498,[[19,cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail,null,1,!1,!1,!1,485357309969016,[[1,[2,"golda200"]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,8211458787837369,[[4,237],[5,
[0,2]],[0,[0,430]],[0,[0,725]]]]]]]],[0,[!0,"Purchase3"],!1,6062259474840774,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6062259474840774,[[1,[2,"Purchase3"]]]]],[],[[0,null,!0,9141185879708704,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7346930259985455,[[4,226]]],[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,4840637774899541,[[4,230]]]],[[19,cr.plugins_.CJSAds.prototype.acts.fetchProductsFromStore,null,0x8a06debb884cb,[[1,[2,"golda500"]]]],
[232,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xe884c02b6a818],[233,cr.plugins_.Sprite.prototype.acts.Destroy,null,7438770349160054],[234,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x7718927127e74],[235,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xa4b9b64f88cda],[-1,cr.system_object.prototype.acts.CreateObject,null,7211963068618649,[[4,183],[5,[0,3]],[0,[0,435]],[0,[0,460]]]],[-1,cr.system_object.prototype.acts.Wait,null,6311614059027903,[[0,[0,3]]]],[183,cr.plugins_.Sprite.prototype.acts.Destroy,
null,5436488641509698],[-1,cr.system_object.prototype.acts.CreateObject,null,6051129921085135,[[4,234],[5,[0,2]],[0,[0,435]],[0,[0,460]]]]]],[0,null,!1,0x784ccf778a00e,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xf118c3a5cc2da,[[4,234]]]],[],[[0,null,!1,7087359080506853,[[19,cr.plugins_.CJSAds.prototype.cnds.IsCocoonJS,null,0,!1,!1,!1,7493517846389871]],[],[[0,null,!1,0x6998cbc18077d,[[19,cr.plugins_.CJSAds.prototype.cnds.IsStoreAvailable,null,0,!1,!1,!1,7008479809087563]],
[[19,cr.plugins_.CJSAds.prototype.acts.Purchase,null,0xb789d743d7b51,[[1,[2,"golda500"]]]]]]]]]],[0,null,!1,5404457425225731,[[19,cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete,null,1,!1,!1,!1,7323794126863926,[[1,[2,"golda500"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,4904134449576425,[[11,"Money"],[7,[0,500]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,6568621348875671,[[7,[23,"Money"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,7556055658825654,[[11,"Moneybuffer"],
[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xe0d65173ef1e5,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6325582522549778,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6555148969231665,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,
!0,null]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0xd8d9eda8b5f63,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,6995342274820467,[[4,236],[5,[0,2]],[0,[0,430]],[0,[0,725]]]]]],[0,null,!1,6763444394021523,[[19,cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail,null,1,!1,!1,!1,41438448413191,[[1,[2,"golda500"]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x465822a05eb50,[[4,237],[5,[0,
2]],[0,[0,430]],[0,[0,725]]]]]]]],[0,[!0,"Purchase4"],!1,6380883129218913,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6380883129218913,[[1,[2,"Purchase4"]]]]],[],[[0,null,!0,4916612122962678,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,624938425613052,[[4,227]]],[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x43e85b3ad39e4,[[4,231]]]],[[19,cr.plugins_.CJSAds.prototype.acts.fetchProductsFromStore,null,603756845172662,[[1,[2,"golda1000"]]]],
[232,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x86372b566ad39],[233,cr.plugins_.Sprite.prototype.acts.Destroy,null,7210608805242922],[234,cr.plugins_.Sprite.prototype.acts.Destroy,null,5140743541933546],[235,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xa1945e9575f31],[-1,cr.system_object.prototype.acts.CreateObject,null,6950970865755333,[[4,183],[5,[0,3]],[0,[0,435]],[0,[0,586]]]],[-1,cr.system_object.prototype.acts.Wait,null,6420280155013807,[[0,[0,3]]]],[183,cr.plugins_.Sprite.prototype.acts.Destroy,
null,0x7a07e61d34986],[-1,cr.system_object.prototype.acts.CreateObject,null,7676761845714356,[[4,235],[5,[0,2]],[0,[0,435]],[0,[0,586]]]]]],[0,null,!1,0xc127ee2292bab,[[16,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6685618249605232,[[4,235]]]],[],[[0,null,!1,0xe212f4258dd02,[[19,cr.plugins_.CJSAds.prototype.cnds.IsCocoonJS,null,0,!1,!1,!1,9518164841029244]],[],[[0,null,!1,6604133531338791,[[19,cr.plugins_.CJSAds.prototype.cnds.IsStoreAvailable,null,0,!1,!1,!1,0x94e1359954ee9]],
[[19,cr.plugins_.CJSAds.prototype.acts.Purchase,null,6068805519278158,[[1,[2,"golda1000"]]]]]]]]]],[0,null,!1,7099498378626283,[[19,cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete,null,1,!1,!1,!1,534216812624788,[[1,[2,"golda1000"]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0x93c267ed07504,[[11,"Money"],[7,[0,1E3]]]],[4,cr.plugins_.Text.prototype.acts.SetText,null,8746370525063223,[[7,[23,"Money"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9110044629843160,[[11,"Moneybuffer"],
[7,[19,cr.system_object.prototype.exps["int"],[[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8659631249678961,[[11,"Money"],[7,[4,[23,"Money"],[23,"Moneybuffer"]]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,7051181547014878,[[1,[2,"MSave"]],[7,[23,"Money"]]]],[15,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8508185001603747,[[1,[2,"savedd"]],[7,[20,113,cr.plugins_.Arr.prototype.exps.AsJSON,
!0,null]]]],[3,cr.plugins_.Text.prototype.acts.SetText,null,0x56e129b853c19,[[7,[20,15,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"MSave"]]]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x8f674b757c257,[[4,236],[5,[0,2]],[0,[0,430]],[0,[0,725]]]]]],[0,null,!1,5169890937195928,[[19,cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail,null,1,!1,!1,!1,5710080467614466,[[1,[2,"golda1000"]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x41c896a17b40b,[[4,237],[5,
[0,2]],[0,[0,430]],[0,[0,725]]]]]]]]]]],"",!1,600,850,4,!0,!0,!1,"1.0",1,!1,2,!0,1610,!1,[]]};

createCocoonJSRuntime();

})();
